/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],c=0,A=re.length;c<A;c++)e[c]=De[re[c]];return e};define(De[61],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(P,k){const y=Object.create(null);for(const p of P){const L=k(p);let T=y[L];T||(T=y[L]=[]),T.push(p)}return y}e.groupBy=c;function A(P,k){const y=[],p=[];for(const L of P)k.has(L)||y.push(L);for(const L of k)P.has(L)||p.push(L);return{removed:y,added:p}}e.diffSets=A;function u(P,k){const y=[],p=[];for(const[L,T]of P)k.has(L)||y.push(T);for(const[L,T]of k)P.has(L)||p.push(T);return{removed:y,added:p}}e.diffMaps=u;class R{constructor(){this.a=new Map}add(k,y){let p=this.a.get(k);p||(p=new Set,this.a.set(k,p)),p.add(y)}delete(k,y){const p=this.a.get(k);!p||(p.delete(y),p.size===0&&this.a.delete(k))}forEach(k,y){const p=this.a.get(k);!p||p.forEach(y)}}e.SetMap=R}),define(De[62],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(P){return(k,y,p)=>{let L=null,T=null;if(typeof p.value=="function"?(L="value",T=p.value):typeof p.get=="function"&&(L="get",T=p.get),!T)throw new Error("not supported");p[L]=P(T,y)}}function A(P,k,y){let p=null,L=null;if(typeof y.value=="function"?(p="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(p="get",L=y.get),!L)throw new Error("not supported");const T=`$memoize$${k}`;y[p]=function(...S){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[T]}}e.memoize=A;function u(P,k,y){return c((p,L)=>{const T=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...I){this[S]||(this[S]=y?y():void 0),clearTimeout(this[T]),k&&(this[S]=k(this[S],...I),I=[this[S]]),this[T]=setTimeout(()=>{p.apply(this,I),this[S]=y?y():void 0},P)}})}e.debounce=u;function R(P,k,y){return c((p,L)=>{const T=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...w){if(this[S]||(this[S]=y?y():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),k&&(this[S]=k(this[S],...w)),this[C])return;const n=this[I]+P;n<=Date.now()?(this[I]=Date.now(),p.apply(this,[this[S]]),this[S]=y?y():void 0):(this[C]=!0,this[T]=setTimeout(()=>{this[C]=!1,this[I]=Date.now(),p.apply(this,[this[S]]),this[S]=y?y():void 0},n-Date.now()))}})}e.throttle=R}),define(De[9],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?D.isErrorNoTelemetry(o)?new D(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=c,e.errorHandler=new c;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function u(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function R(t){p(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function P(t){p(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=P;function k(t){if(t instanceof Error){const{name:o,message:s}=t,a=t.stacktrace||t.stack;return{$isError:!0,name:o,message:s,stack:a,noTelemetry:D.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const y="Canceled";function p(t){return t instanceof L?!0:t instanceof Error&&t.name===y&&t.message===y}e.isCancellationError=p;class L extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=L;function T(){const t=new Error(y);return t.name=t.message,t}e.canceled=T;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function I(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=I;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function w(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=w;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=n;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class f extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class D extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof D)return o;const s=new D;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype);debugger}}e.BugIndicatingError=b}),define(De[17],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(_,le=0){return _[_.length-(1+le)]}e.tail=A;function u(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=u;function R(_,le,de=(te,ce)=>te===ce){if(_===le)return!0;if(!_||!le||_.length!==le.length)return!1;for(let te=0,ce=_.length;te<ce;te++)if(!de(_[te],le[te]))return!1;return!0}e.equals=R;function P(_,le){const de=_.length-1;le<de&&(_[le]=_[de]),_.pop()}e.removeFastWithoutKeepingOrder=P;function k(_,le,de){return y(_.length,te=>de(_[te],le))}e.binarySearch=k;function y(_,le){let de=0,te=_-1;for(;de<=te;){const ce=(de+te)/2|0,oe=le(ce);if(oe<0)de=ce+1;else if(oe>0)te=ce-1;else return ce}return-(de+1)}e.binarySearch2=y;function p(_,le){let de=0,te=_.length;if(te===0)return 0;for(;de<te;){const ce=Math.floor((de+te)/2);le(_[ce])?te=ce:de=ce+1}return de}e.findFirstInSorted=p;function L(_,le,de){if(_=_|0,_>=le.length)throw new TypeError("invalid index");const te=le[Math.floor(le.length*Math.random())],ce=[],oe=[],F=[];for(const z of le){const K=de(z,te);K<0?ce.push(z):K>0?oe.push(z):F.push(z)}return _<ce.length?L(_,ce,de):_<ce.length+F.length?F[0]:L(_-(ce.length+F.length),oe,de)}e.quickSelect=L;function T(_,le){const de=[];let te;for(const ce of _.slice(0).sort(le))!te||le(te[0],ce)!==0?(te=[ce],de.push(te)):te.push(ce);return de}e.groupBy=T;function S(_,le,de){const te=[];function ce(z,K,Z){if(K===0&&Z.length===0)return;const fe=te[te.length-1];fe&&fe.start+fe.deleteCount===z?(fe.deleteCount+=K,fe.toInsert.push(...Z)):te.push({start:z,deleteCount:K,toInsert:Z})}let oe=0,F=0;for(;;){if(oe===_.length){ce(oe,0,le.slice(F));break}if(F===le.length){ce(oe,_.length-oe,[]);break}const z=_[oe],K=le[F],Z=de(z,K);Z===0?(oe+=1,F+=1):Z<0?(ce(oe,1,[]),oe+=1):Z>0&&(ce(oe,0,[K]),F+=1)}return te}e.sortedDiff=S;function I(_,le,de){const te=S(_,le,de),ce=[],oe=[];for(const F of te)ce.push(..._.slice(F.start,F.start+F.deleteCount)),oe.push(...F.toInsert);return{removed:ce,added:oe}}e.delta=I;function C(_,le,de){if(de===0)return[];const te=_.slice(0,de).sort(le);return n(_,le,te,de,_.length),te}e.top=C;function w(_,le,de,te,ce){return de===0?Promise.resolve([]):new Promise((oe,F)=>{(async()=>{const z=_.length,K=_.slice(0,de).sort(le);for(let Z=de,fe=Math.min(de+te,z);Z<z;Z=fe,fe=Math.min(fe+te,z)){if(Z>de&&await new Promise(Ee=>setTimeout(Ee)),ce&&ce.isCancellationRequested)throw new c.CancellationError;n(_,le,K,Z,fe)}return K})().then(oe,F)})}e.topAsync=w;function n(_,le,de,te,ce){for(const oe=de.length;te<ce;te++){const F=_[te];if(le(F,de[oe-1])<0){de.pop();const z=p(de,K=>le(F,K)<0);de.splice(z,0,F)}}}function d(_){return _.filter(le=>!!le)}e.coalesce=d;function f(_){let le=0;for(let de=0;de<_.length;de++)_[de]&&(_[le]=_[de],le+=1);_.length=le}e.coalesceInPlace=f;function v(_,le,de){_.splice(de,0,_.splice(le,1)[0])}e.move=v;function D(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=D;function b(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=b;function t(_,le=de=>de){const de=new Set;return _.filter(te=>{const ce=le(te);return de.has(ce)?!1:(de.add(ce),!0)})}e.distinct=t;function o(_){const le=new Set;return de=>{const te=_(de);return le.has(te)?!1:(le.add(te),!0)}}e.uniqueFilter=o;function s(_,le){const de=a(_,le);if(de!==-1)return _[de]}e.findLast=s;function a(_,le){for(let de=_.length-1;de>=0;de--){const te=_[de];if(le(te))return de}return-1}e.lastIndex=a;function l(_,le){return _.length>0?_[0]:le}e.firstOrDefault=l;function E(_,le){return _.length>0?_[_.length-1]:le}e.lastOrDefault=E;function i(_,le,de=(te,ce)=>te===ce){let te=0;for(let ce=0,oe=Math.min(_.length,le.length);ce<oe&&de(_[ce],le[ce]);ce++)te++;return te}e.commonPrefixLength=i;function r(_){return[].concat(..._)}e.flatten=r;function m(_,le){let de=typeof le=="number"?_:0;typeof le=="number"?de=_:(de=0,le=_);const te=[];if(de<=le)for(let ce=de;ce<le;ce++)te.push(ce);else for(let ce=de;ce>le;ce--)te.push(ce);return te}e.range=m;function g(_,le,de){return _.reduce((te,ce)=>(te[le(ce)]=de?de(ce):ce,te),Object.create(null))}e.index=g;function h(_,le){return _.push(le),()=>O(_,le)}e.insert=h;function O(_,le){const de=_.indexOf(le);if(de>-1)return _.splice(de,1),le}e.remove=O;function $(_,le,de){const te=_.slice(0,le),ce=_.slice(le);return te.concat(de,ce)}e.arrayInsert=$;function x(_,le){let de;if(typeof le=="number"){let te=le;de=()=>{const ce=Math.sin(te++)*179426549;return ce-Math.floor(ce)}}else de=Math.random;for(let te=_.length-1;te>0;te-=1){const ce=Math.floor(de()*(te+1)),oe=_[te];_[te]=_[ce],_[ce]=oe}}e.shuffle=x;function Y(_,le){const de=_.indexOf(le);de>-1&&(_.splice(de,1),_.unshift(le))}e.pushToStart=Y;function G(_,le){const de=_.indexOf(le);de>-1&&(_.splice(de,1),_.push(le))}e.pushToEnd=G;function M(_,le){for(const de of le)_.push(de)}e.pushMany=M;function B(_,le){return Array.isArray(_)?_.map(le):le(_)}e.mapArrayOrNot=B;function U(_){return Array.isArray(_)?_:[_]}e.asArray=U;function j(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=j;function he(_,le){for(const de of _){const te=le(de);if(te!==void 0)return te}}e.mapFind=he;function ie(_,le,de){const te=J(_,le),ce=_.length,oe=de.length;_.length=ce+oe;for(let F=ce-1;F>=te;F--)_[F+oe]=_[F];for(let F=0;F<oe;F++)_[F+te]=de[F]}e.insertInto=ie;function V(_,le,de,te){const ce=J(_,le),oe=_.splice(ce,de);return ie(_,ce,te),oe}e.splice=V;function J(_,le){return le<0?Math.max(le+_.length,0):Math.min(le,_.length)}var ne;(function(_){function le(ce){return ce<0}_.isLessThan=le;function de(ce){return ce>0}_.isGreaterThan=de;function te(ce){return ce===0}_.isNeitherLessOrGreaterThan=te,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function ve(_,le){return(de,te)=>le(_(de),_(te))}e.compareBy=ve;function ue(..._){return(le,de)=>{for(const te of _){const ce=te(le,de);if(!ne.isNeitherLessOrGreaterThan(ce))return ce}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=ue;const ee=(_,le)=>_-le;e.numberComparator=ee;function N(_,le){if(_.length===0)return;let de=_[0];for(let te=1;te<_.length;te++){const ce=_[te];le(ce,de)>0&&(de=ce)}return de}e.findMaxBy=N;function q(_,le){if(_.length===0)return;let de=_[0];for(let te=1;te<_.length;te++){const ce=_[te];le(ce,de)>=0&&(de=ce)}return de}e.findLastMaxBy=q;function ae(_,le){return N(_,(de,te)=>-le(de,te))}e.findMinBy=ae;class me{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let de=this.c;for(;de<this.f.length&&le(this.f[de]);)de++;const te=de===this.c?null:this.f.slice(this.c,de);return this.c=de,te}takeFromEndWhile(le){let de=this.d;for(;de>=0&&le(this.f[de]);)de--;const te=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,te}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const de=this.f.slice(this.c,this.c+le);return this.c+=le,de}}e.ArrayQueue=me;class ke{constructor(le){this.iterate=le}forEach(le){this.iterate(de=>(le(de),!0))}toArray(){const le=[];return this.iterate(de=>(le.push(de),!0)),le}filter(le){return new ke(de=>this.iterate(te=>le(te)?de(te):!0))}map(le){return new ke(de=>this.iterate(te=>de(le(te))))}some(le){let de=!1;return this.iterate(te=>(de=le(te),!de)),de}findFirst(le){let de;return this.iterate(te=>le(te)?(de=te,!1):!0),de}findLast(le){let de;return this.iterate(te=>(le(te)&&(de=te),!0)),de}findLastMaxBy(le){let de,te=!0;return this.iterate(ce=>((te||ne.isGreaterThan(le(ce,de)))&&(te=!1,de=ce),!0)),de}}ke.empty=new ke(_=>{}),e.CallbackIterable=ke}),define(De[51],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(y,p){if(!y)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=A;function u(y,p="Unreachable"){throw new Error(p)}e.assertNever=u;function R(y){if(!y)throw new c.BugIndicatingError("Assertion Failed")}e.assert=R;function P(y){if(!y()){debugger;y(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=P;function k(y,p){let L=0;for(;L<y.length-1;){const T=y[L],S=y[L+1];if(!p(T,S))return!1;L++}return!0}e.checkAdjacentItems=k}),define(De[63],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(A){const u=this;let R=!1,P;return function(){return R||(R=!0,P=A.apply(u,arguments)),P}}e.once=c}),define(De[102],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(u){this.a=u,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(De[64],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(A){function u(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}A.is=u;const R=Object.freeze([]);function P(){return R}A.empty=P;function*k(D){yield D}A.single=k;function y(D){return u(D)?D:k(D)}A.wrap=y;function p(D){return D||R}A.from=p;function L(D){return!D||D[Symbol.iterator]().next().done===!0}A.isEmpty=L;function T(D){return D[Symbol.iterator]().next().value}A.first=T;function S(D,b){for(const t of D)if(b(t))return!0;return!1}A.some=S;function I(D,b){for(const t of D)if(b(t))return t}A.find=I;function*C(D,b){for(const t of D)b(t)&&(yield t)}A.filter=C;function*w(D,b){let t=0;for(const o of D)yield b(o,t++)}A.map=w;function*n(...D){for(const b of D)for(const t of b)yield t}A.concat=n;function d(D,b,t){let o=t;for(const s of D)o=b(o,s);return o}A.reduce=d;function*f(D,b,t=D.length){for(b<0&&(b+=D.length),t<0?t+=D.length:t>D.length&&(t=D.length);b<t;b++)yield D[b]}A.slice=f;function v(D,b=Number.POSITIVE_INFINITY){const t=[];if(b===0)return[t,D];const o=D[Symbol.iterator]();for(let s=0;s<b;s++){const a=o.next();if(a.done)return[t,A.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return o}}]}A.consume=v})(c=e.Iterable||(e.Iterable={}))}),define(De[148],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var u;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(u=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function P(t,o=!1){let s=0;const a=t.length;let l="",E=0,i=16,r=0;function m(G){let M=0,B=0;for(;M<G;){const U=t.charCodeAt(s);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;s++,M++}return M<G&&(B=-1),B}function g(G){s=G,l="",E=0,i=16,r=0}function h(){const G=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return r=3,t.substring(G,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;M=s}else r=3;return t.substring(G,M)}function O(){let G="",M=s;for(;;){if(s>=a){G+=t.substring(M,s),r=2;break}const B=t.charCodeAt(s);if(B===34){G+=t.substring(M,s),s++;break}if(B===92){if(G+=t.substring(M,s),s++,s>=a){r=2;break}switch(t.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:{const j=m(4);j>=0?G+=String.fromCharCode(j):r=4;break}default:r=5}M=s;continue}if(B>=0&&B<=31)if(y(B)){G+=t.substring(M,s),r=2;break}else r=6;s++}return G}function $(){if(l="",r=0,E=s,s>=a)return E=a,i=17;let G=t.charCodeAt(s);if(k(G)){do s++,l+=String.fromCharCode(G),G=t.charCodeAt(s);while(k(G));return i=15}if(y(G))return s++,l+=String.fromCharCode(G),G===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),i=14;switch(G){case 123:return s++,i=1;case 125:return s++,i=2;case 91:return s++,i=3;case 93:return s++,i=4;case 58:return s++,i=6;case 44:return s++,i=5;case 34:return s++,l=O(),i=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!y(t.charCodeAt(s));)s++;return l=t.substring(M,s),i=12}if(t.charCodeAt(s+1)===42){s+=2;const B=a-1;let U=!1;for(;s<B;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,r=1),l=t.substring(M,s),i=13}return l+=String.fromCharCode(G),s++,i=16}case 45:if(l+=String.fromCharCode(G),s++,s===a||!p(t.charCodeAt(s)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=h(),i=11;default:for(;s<a&&x(G);)s++,G=t.charCodeAt(s);if(E!==s){switch(l=t.substring(E,s),l){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return l+=String.fromCharCode(G),s++,i=16}}function x(G){if(k(G)||y(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let G;do G=$();while(G>=12&&G<=15);return G}return{setPosition:g,getPosition:()=>s,scan:o?Y:$,getToken:()=>i,getTokenValue:()=>l,getTokenOffset:()=>E,getTokenLength:()=>s-E,getTokenError:()=>r}}e.createScanner=P;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function T(t,o){const s=[],a=new Object;let l;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function r(m,g,h,O){E.value=m,E.offset=g,E.length=h,E.type=O,E.colonOffset=void 0,l=E}try{v(t,{onObjectBegin:(m,g)=>{if(o<=m)throw a;l=void 0,i=o>m,s.push("")},onObjectProperty:(m,g,h)=>{if(o<g||(r(m,g,h,"property"),s[s.length-1]=m,o<=g+h))throw a},onObjectEnd:(m,g)=>{if(o<=m)throw a;l=void 0,s.pop()},onArrayBegin:(m,g)=>{if(o<=m)throw a;l=void 0,s.push(0)},onArrayEnd:(m,g)=>{if(o<=m)throw a;l=void 0,s.pop()},onLiteralValue:(m,g,h)=>{if(o<g||(r(m,g,h,b(m)),o<=g+h))throw a},onSeparator:(m,g,h)=>{if(o<=g)throw a;if(m===":"&&l&&l.type==="property")l.colonOffset=g,i=!1,l=void 0;else if(m===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(i=!0,s[s.length-1]=""),l=void 0}}})}catch(m){if(m!==a)throw m}return{path:s,previousNode:l,isAtPropertyKey:i,matches:m=>{let g=0;for(let h=0;g<m.length&&h<s.length;h++)if(m[g]===s[h]||m[g]==="*")g++;else if(m[g]!=="**")return!1;return g===m.length}}}e.getLocation=T;function S(t,o=[],s=R.DEFAULT){let a=null,l=[];const E=[];function i(m){Array.isArray(l)?l.push(m):a!==null&&(l[a]=m)}return v(t,{onObjectBegin:()=>{const m={};i(m),E.push(l),l=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{l=E.pop()},onArrayBegin:()=>{const m=[];i(m),E.push(l),l=m,a=null},onArrayEnd:()=>{l=E.pop()},onLiteralValue:i,onError:(m,g,h)=>{o.push({error:m,offset:g,length:h})}},s),l[0]}e.parse=S;function I(t,o=[],s=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(m){a.type==="property"&&(a.length=m-a.offset,a=a.parent)}function E(m){return a.children.push(m),m}v(t,{onObjectBegin:m=>{a=E({type:"object",offset:m,length:-1,parent:a,children:[]})},onObjectProperty:(m,g,h)=>{a=E({type:"property",offset:g,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:m,offset:g,length:h,parent:a})},onObjectEnd:(m,g)=>{a.length=m+g-a.offset,a=a.parent,l(m+g)},onArrayBegin:(m,g)=>{a=E({type:"array",offset:m,length:-1,parent:a,children:[]})},onArrayEnd:(m,g)=>{a.length=m+g-a.offset,a=a.parent,l(m+g)},onLiteralValue:(m,g,h)=>{E({type:b(m),offset:g,length:h,parent:a,value:m}),l(g+h)},onSeparator:(m,g,h)=>{a.type==="property"&&(m===":"?a.colonOffset=g:m===","&&l(g))},onError:(m,g,h)=>{o.push({error:m,offset:g,length:h})}},s);const r=a.children[0];return r&&delete r.parent,r}e.parseTree=I;function C(t,o){if(!t)return;let s=t;for(const a of o)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const E of s.children)if(Array.isArray(E.children)&&E.children[0].value===a){s=E.children[1],l=!0;break}if(!l)return}else{const l=a;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=C;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.getNodePath=w;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const o=Object.create(null);for(const s of t.children){const a=s.children[1];a&&(o[s.children[0].value]=n(a))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=n;function d(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.contains=d;function f(t,o,s=!1){if(d(t,o,s)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=o;l++){const E=f(a[l],o,s);if(E)return E}return t}}e.findNodeAtOffset=f;function v(t,o,s=R.DEFAULT){const a=P(t,!1);function l(ve){return ve?()=>ve(a.getTokenOffset(),a.getTokenLength()):()=>!0}function E(ve){return ve?ue=>ve(ue,a.getTokenOffset(),a.getTokenLength()):()=>!0}const i=l(o.onObjectBegin),r=E(o.onObjectProperty),m=l(o.onObjectEnd),g=l(o.onArrayBegin),h=l(o.onArrayEnd),O=E(o.onLiteralValue),$=E(o.onSeparator),x=l(o.onComment),Y=E(o.onError),G=s&&s.disallowComments,M=s&&s.allowTrailingComma;function B(){for(;;){const ve=a.scan();switch(a.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:G||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ve){case 12:case 13:G?U(10):x();break;case 16:U(1);break;case 15:case 14:break;default:return ve}}}function U(ve,ue=[],ee=[]){if(Y(ve),ue.length+ee.length>0){let N=a.getToken();for(;N!==17;){if(ue.indexOf(N)!==-1){B();break}else if(ee.indexOf(N)!==-1)break;N=B()}}}function j(ve){const ue=a.getTokenValue();return ve?O(ue):r(ue),B(),!0}function he(){switch(a.getToken()){case 11:{let ve=0;try{ve=JSON.parse(a.getTokenValue()),typeof ve!="number"&&(U(2),ve=0)}catch{U(2)}O(ve);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return B(),!0}function ie(){return a.getToken()!==10?(U(3,[],[2,5]),!1):(j(!1),a.getToken()===6?($(":"),B(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){i(),B();let ve=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ve||U(4,[],[]),$(","),B(),a.getToken()===2&&M)break}else ve&&U(6,[],[]);ie()||U(4,[],[2,5]),ve=!0}return m(),a.getToken()!==2?U(7,[2],[]):B(),!0}function J(){g(),B();let ve=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ve||U(4,[],[]),$(","),B(),a.getToken()===4&&M)break}else ve&&U(6,[],[]);ne()||U(4,[],[4,5]),ve=!0}return h(),a.getToken()!==4?U(8,[4],[]):B(),!0}function ne(){switch(a.getToken()){case 3:return J();case 1:return V();case 10:return j(!0);default:return he()}}return B(),a.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(a.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=v;function D(t,o){const s=P(t),a=[];let l,E=0,i;do switch(i=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:E!==i&&a.push(t.substring(E,i)),o!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,o)),E=s.getPosition();break}while(l!==17);return a.join("")}e.stripComments=D;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(De[65],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(u){this.d=u,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(u){this.c=u}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=c}),define(De[6],Ce([1,0,63,64]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let R=null;function P(E){R=E}if(e.setDisposableTracker=P,u){const E="__is_disposable_tracked__";P(new class{trackDisposable(i){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[E]||console.log(r)},3e3)}setParent(i,r){if(i&&i!==f.None)try{i[E]=!0}catch{}}markAsDisposed(i){if(i&&i!==f.None)try{i[E]=!0}catch{}}markAsSingleton(i){}})}function k(E){return R?.trackDisposable(E),E}function y(E){R?.markAsDisposed(E)}function p(E,i){R?.setParent(E,i)}function L(E,i){if(!!R)for(const r of E)R.setParent(r,i)}function T(E){return R?.markAsSingleton(E),E}e.markAsSingleton=T;function S(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.isDisposable=S;function I(E){if(A.Iterable.is(E)){const i=[];for(const r of E)if(r)try{r.dispose()}catch(m){i.push(m)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.dispose=I;function C(E){for(const i of E)S(i)&&i.dispose();return[]}e.disposeIfDisposable=C;function w(...E){const i=n(()=>I(E));return L(E,i),i}e.combinedDisposable=w;function n(E){const i=k({dispose:(0,c.once)(()=>{y(i),E()})});return i}e.toDisposable=n;class d{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{I(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return p(i,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class f{constructor(){this.B=new d,k(this),p(this.B,this)}dispose(){y(this),this.B.dispose()}D(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(i)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class v{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&p(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&p(i,null),i}}e.MutableDisposable=v;class D{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(i){let r=i;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,y(this))},this}}e.SafeDisposable=b;class t{constructor(){this.a=new Map}acquire(i,...r){let m=this.a.get(i);m||(m={counter:0,object:this.b(i,...r)},this.a.set(i,m));const{object:g}=m,h=(0,c.once)(()=>{--m.counter===0&&(this.c(i,m.object),this.a.delete(i))});return m.counter++,{object:g,dispose:h}}}e.ReferenceCollection=t;class o{constructor(i){this.a=i}async acquire(i,...r){const m=this.a.acquire(i,...r);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(g){throw m.dispose(),g}}}e.AsyncReferenceCollection=o;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function a(E){const i=new d;try{E(i)}finally{i.dispose()}}e.disposeOnReturn=a;class l{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{I(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,r,m=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this.a.get(i)?.dispose(),this.a.set(i,r)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(De[66],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(R){this.element=R,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class A{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let R=this.a;for(;R!==c.Undefined;){const P=R.next;R.prev=c.Undefined,R.next=c.Undefined,R=P}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,P){const k=new c(R);if(this.a===c.Undefined)this.a=k,this.b=k;else if(P){const p=this.b;this.b=k,k.prev=p,p.next=k}else{const p=this.a;this.a=k,k.next=p,p.prev=k}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(k))}}shift(){if(this.a!==c.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==c.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==c.Undefined&&R.next!==c.Undefined){const P=R.prev;P.next=R.next,R.next.prev=P}else R.prev===c.Undefined&&R.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):R.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):R.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==c.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(De[28],Ce([1,0]),function(re,e){"use strict";var c,A,u;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(w,n,d){let f=w.get(n);return f===void 0&&(f=d,w.set(n,f)),f}e.getOrSet=R;function P(w){const n=[];return w.forEach((d,f)=>{n.push(`${f} => ${d}`)}),`Map(${w.size}) {${n.join(", ")}}`}e.mapToString=P;function k(w){const n=[];return w.forEach(d=>{n.push(d)}),`Set(${w.size}) {${n.join(", ")}}`}e.setToString=k;class y{constructor(n,d){this.uri=n,this.value=d}}class p{constructor(n,d){this[c]="ResourceMap",n instanceof p?(this.b=new Map(n.b),this.c=d??p.a):(this.b=new Map,this.c=n??p.a)}set(n,d){return this.b.set(this.c(n),new y(n,d)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,d){typeof d<"u"&&(n=n.bind(d));for(const[f,v]of this.b)n(v.value,v.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}p.a=w=>w.toString(),e.ResourceMap=p;class L{constructor(n,d){this[A]="ResourceSet",!n||typeof n=="function"?this.a=new p(n):(this.a=new p(d),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,d){this.a.forEach((f,v)=>n.call(d,v,v,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var T;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class S{constructor(){this[u]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,d=0){const f=this.a.get(n);if(!!f)return d!==0&&this.j(f,d),f.value}set(n,d,f=0){let v=this.a.get(n);if(v)v.value=d,f!==0&&this.j(v,f);else{switch(v={key:n,value:d,next:void 0,previous:void 0},f){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(n,v),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const d=this.a.get(n);if(!!d)return this.a.delete(n),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,d){const f=this.e;let v=this.b;for(;v;){if(d?n.bind(d)(v.value,v.key,this):n(v.value,v.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const n=this,d=this.e;let f=this.b;const v={[Symbol.iterator](){return v},next(){if(n.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const D={value:f.key,done:!1};return f=f.next,D}else return{value:void 0,done:!0}}};return v}values(){const n=this,d=this.e;let f=this.b;const v={[Symbol.iterator](){return v},next(){if(n.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const D={value:f.value,done:!1};return f=f.next,D}else return{value:void 0,done:!0}}};return v}entries(){const n=this,d=this.e;let f=this.b;const v={[Symbol.iterator](){return v},next(){if(n.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const D={value:[f.key,f.value],done:!1};return f=f.next,D}else return{value:void 0,done:!0}}};return v}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>n;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const d=n.next,f=n.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}n.next=void 0,n.previous=void 0,this.e++}j(n,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(n===this.b)return;const f=n.next,v=n.previous;n===this.c?(v.next=void 0,this.c=v):(f.previous=v,v.next=f),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(d===2){if(n===this.c)return;const f=n.next,v=n.previous;n===this.b?(f.previous=void 0,this.b=f):(f.previous=v,v.next=f),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((d,f)=>{n.push([f,d])}),n}fromJSON(n){this.clear();for(const[d,f]of n)this.set(d,f)}}e.LinkedMap=S;class I extends S{constructor(n,d=1){super(),this.k=n,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,d=2){return super.get(n,d)}peek(n){return super.get(n,0)}set(n,d){return super.set(n,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=I;class C{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let d=this.a.get(n)||0;return d===0?!1:(d--,d===0?this.a.delete(n):this.a.set(n,d),!0)}has(n){return this.a.has(n)}}e.CounterSet=C}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[149],Ce([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(_,le){for(var de=0;de<le.length;de++){var te=le[de];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(_,te.key,te)}}function c(_,le,de){return le&&e(_.prototype,le),de&&e(_,de),Object.defineProperty(_,"prototype",{writable:!1}),_}function A(_,le){if(!!_){if(typeof _=="string")return u(_,le);var de=Object.prototype.toString.call(_).slice(8,-1);if(de==="Object"&&_.constructor&&(de=_.constructor.name),de==="Map"||de==="Set")return Array.from(_);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return u(_,le)}}function u(_,le){(le==null||le>_.length)&&(le=_.length);for(var de=0,te=new Array(le);de<le;de++)te[de]=_[de];return te}function R(_,le){var de=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(de)return(de=de.call(_)).next.bind(de);if(Array.isArray(_)||(de=A(_))||le&&_&&typeof _.length=="number"){de&&(_=de);var te=0;return function(){return te>=_.length?{done:!0}:{done:!1,value:_[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=P();function k(_){re.defaults=_}var y=/[&<>"']/,p=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(le){return S[le]};function C(_,le){if(le){if(y.test(_))return _.replace(p,I)}else if(L.test(_))return _.replace(T,I);return _}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(_){return _.replace(w,function(le,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function f(_,le){_=typeof _=="string"?_:_.source,le=le||"";var de={replace:function(ce,oe){return oe=oe.source||oe,oe=oe.replace(d,"$1"),_=_.replace(ce,oe),de},getRegex:function(){return new RegExp(_,le)}};return de}var v=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(_,le,de){if(_){var te;try{te=decodeURIComponent(n(de)).replace(v,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}le&&!D.test(de)&&(de=l(le,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(_,le){t[" "+_]||(o.test(_)?t[" "+_]=_+"/":t[" "+_]=m(_,"/",!0)),_=t[" "+_];var de=_.indexOf(":")===-1;return le.substring(0,2)==="//"?de?le:_.replace(s,"$1")+le:le.charAt(0)==="/"?de?le:_.replace(a,"$1")+le:_+le}var E={exec:function(){}};function i(_){for(var le=1,de,te;le<arguments.length;le++){de=arguments[le];for(te in de)Object.prototype.hasOwnProperty.call(de,te)&&(_[te]=de[te])}return _}function r(_,le){var de=_.replace(/\|/g,function(oe,F,z){for(var K=!1,Z=F;--Z>=0&&z[Z]==="\\";)K=!K;return K?"|":" |"}),te=de.split(/ \|/),ce=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>le)te.splice(le);else for(;te.length<le;)te.push("");for(;ce<te.length;ce++)te[ce]=te[ce].trim().replace(/\\\|/g,"|");return te}function m(_,le,de){var te=_.length;if(te===0)return"";for(var ce=0;ce<te;){var oe=_.charAt(te-ce-1);if(oe===le&&!de)ce++;else if(oe!==le&&de)ce++;else break}return _.slice(0,te-ce)}function g(_,le){if(_.indexOf(le[1])===-1)return-1;for(var de=_.length,te=0,ce=0;ce<de;ce++)if(_[ce]==="\\")ce++;else if(_[ce]===le[0])te++;else if(_[ce]===le[1]&&(te--,te<0))return ce;return-1}function h(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(_,le){if(le<1)return"";for(var de="";le>1;)le&1&&(de+=_),le>>=1,_+=_;return de+_}function $(_,le,de,te){var ce=le.href,oe=le.title?C(le.title):null,F=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){te.state.inLink=!0;var z={type:"link",raw:de,href:ce,title:oe,text:F,tokens:te.inlineTokens(F)};return te.state.inLink=!1,z}return{type:"image",raw:de,href:ce,title:oe,text:C(F)}}function x(_,le){var de=_.match(/^(\s+)(?:```)/);if(de===null)return le;var te=de[1];return le.split(`
`).map(function(ce){var oe=ce.match(/^\s+/);if(oe===null)return ce;var F=oe[0];return F.length>=te.length?ce.slice(te.length):ce}).join(`
`)}var Y=function(){function _(de){this.options=de||re.defaults}var le=_.prototype;return le.space=function(te){var ce=this.rules.block.newline.exec(te);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},le.code=function(te){var ce=this.rules.block.code.exec(te);if(ce){var oe=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:m(oe,`
`)}}},le.fences=function(te){var ce=this.rules.block.fences.exec(te);if(ce){var oe=ce[0],F=x(oe,ce[3]||"");return{type:"code",raw:oe,lang:ce[2]?ce[2].trim():ce[2],text:F}}},le.heading=function(te){var ce=this.rules.block.heading.exec(te);if(ce){var oe=ce[2].trim();if(/#$/.test(oe)){var F=m(oe,"#");(this.options.pedantic||!F||/ $/.test(F))&&(oe=F.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:oe,tokens:this.lexer.inline(oe)}}},le.hr=function(te){var ce=this.rules.block.hr.exec(te);if(ce)return{type:"hr",raw:ce[0]}},le.blockquote=function(te){var ce=this.rules.block.blockquote.exec(te);if(ce){var oe=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},le.list=function(te){var ce=this.rules.block.list.exec(te);if(ce){var oe,F,z,K,Z,fe,Ee,Ae,we,Pe,Ie,$e,xe=ce[1].trim(),tt=xe.length>1,Qe={type:"list",raw:"",ordered:tt,start:tt?+xe.slice(0,-1):"",loose:!1,items:[]};xe=tt?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=tt?xe:"[*+-]");for(var it=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&($e=!1,!(!(ce=it.exec(te))||this.rules.block.hr.test(te)));){if(oe=ce[0],te=te.substring(oe.length),Ae=ce[2].split(`
`,1)[0],we=te.split(`
`,1)[0],this.options.pedantic?(K=2,Ie=Ae.trimLeft()):(K=ce[2].search(/[^ ]/),K=K>4?1:K,Ie=Ae.slice(K),K+=ce[1].length),fe=!1,!Ae&&/^ *$/.test(we)&&(oe+=we+`
`,te=te.substring(we.length+1),$e=!0),!$e)for(var rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),W=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");te&&(Pe=te.split(`
`,1)[0],Ae=Pe,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Ae)||W.test(Ae)||rt.test(Ae)||Be.test(te)));){if(Ae.search(/[^ ]/)>=K||!Ae.trim())Ie+=`
`+Ae.slice(K);else if(!fe)Ie+=`
`+Ae;else break;!fe&&!Ae.trim()&&(fe=!0),oe+=Pe+`
`,te=te.substring(Pe.length+1)}Qe.loose||(Ee?Qe.loose=!0:/\n *\n *$/.test(oe)&&(Ee=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(Ie),F&&(z=F[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:oe,task:!!F,checked:z,loose:!1,text:Ie}),Qe.raw+=oe}Qe.items[Qe.items.length-1].raw=oe.trimRight(),Qe.items[Qe.items.length-1].text=Ie.trimRight(),Qe.raw=Qe.raw.trimRight();var Q=Qe.items.length;for(Z=0;Z<Q;Z++){this.lexer.state.top=!1,Qe.items[Z].tokens=this.lexer.blockTokens(Qe.items[Z].text,[]);var ge=Qe.items[Z].tokens.filter(function(Ne){return Ne.type==="space"}),Le=ge.every(function(Ne){for(var je=Ne.raw.split(""),Ye=0,Xe=R(je),nt;!(nt=Xe()).done;){var ot=nt.value;if(ot===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Qe.loose&&ge.length&&Le&&(Qe.loose=!0,Qe.items[Z].loose=!0)}return Qe}},le.html=function(te){var ce=this.rules.block.html.exec(te);if(ce){var oe={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]);oe.type="paragraph",oe.text=F,oe.tokens=this.lexer.inline(F)}return oe}},le.def=function(te){var ce=this.rules.block.def.exec(te);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var oe=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:ce[0],href:ce[2],title:ce[3]}}},le.table=function(te){var ce=this.rules.block.table.exec(te);if(ce){var oe={type:"table",header:r(ce[1]).map(function(Ee){return{text:Ee}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ce[0];var F=oe.align.length,z,K,Z,fe;for(z=0;z<F;z++)/^ *-+: *$/.test(oe.align[z])?oe.align[z]="right":/^ *:-+: *$/.test(oe.align[z])?oe.align[z]="center":/^ *:-+ *$/.test(oe.align[z])?oe.align[z]="left":oe.align[z]=null;for(F=oe.rows.length,z=0;z<F;z++)oe.rows[z]=r(oe.rows[z],oe.header.length).map(function(Ee){return{text:Ee}});for(F=oe.header.length,K=0;K<F;K++)oe.header[K].tokens=this.lexer.inline(oe.header[K].text);for(F=oe.rows.length,K=0;K<F;K++)for(fe=oe.rows[K],Z=0;Z<fe.length;Z++)fe[Z].tokens=this.lexer.inline(fe[Z].text);return oe}}},le.lheading=function(te){var ce=this.rules.block.lheading.exec(te);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},le.paragraph=function(te){var ce=this.rules.block.paragraph.exec(te);if(ce){var oe=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:oe,tokens:this.lexer.inline(oe)}}},le.text=function(te){var ce=this.rules.block.text.exec(te);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},le.escape=function(te){var ce=this.rules.inline.escape.exec(te);if(ce)return{type:"escape",raw:ce[0],text:C(ce[1])}},le.tag=function(te){var ce=this.rules.inline.tag.exec(te);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):C(ce[0]):ce[0]}},le.link=function(te){var ce=this.rules.inline.link.exec(te);if(ce){var oe=ce[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var F=m(oe.slice(0,-1),"\\");if((oe.length-F.length)%2===0)return}else{var z=g(ce[2],"()");if(z>-1){var K=ce[0].indexOf("!")===0?5:4,Z=K+ce[1].length+z;ce[2]=ce[2].substring(0,z),ce[0]=ce[0].substring(0,Z).trim(),ce[3]=""}}var fe=ce[2],Ee="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(fe);Ae&&(fe=Ae[1],Ee=Ae[3])}else Ee=ce[3]?ce[3].slice(1,-1):"";return fe=fe.trim(),/^</.test(fe)&&(this.options.pedantic&&!/>$/.test(oe)?fe=fe.slice(1):fe=fe.slice(1,-1)),$(ce,{href:fe&&fe.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},le.reflink=function(te,ce){var oe;if((oe=this.rules.inline.reflink.exec(te))||(oe=this.rules.inline.nolink.exec(te))){var F=(oe[2]||oe[1]).replace(/\s+/g," ");if(F=ce[F.toLowerCase()],!F||!F.href){var z=oe[0].charAt(0);return{type:"text",raw:z,text:z}}return $(oe,F,oe[0],this.lexer)}},le.emStrong=function(te,ce,oe){oe===void 0&&(oe="");var F=this.rules.inline.emStrong.lDelim.exec(te);if(!!F&&!(F[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=F[1]||F[2]||"";if(!z||z&&(oe===""||this.rules.inline.punctuation.exec(oe))){var K=F[0].length-1,Z,fe,Ee=K,Ae=0,we=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(we.lastIndex=0,ce=ce.slice(-1*te.length+K);(F=we.exec(ce))!=null;)if(Z=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!Z){if(fe=Z.length,F[3]||F[4]){Ee+=fe;continue}else if((F[5]||F[6])&&K%3&&!((K+fe)%3)){Ae+=fe;continue}if(Ee-=fe,!(Ee>0)){if(fe=Math.min(fe,fe+Ee+Ae),Math.min(K,fe)%2){var Pe=te.slice(1,K+F.index+fe);return{type:"em",raw:te.slice(0,K+F.index+fe+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var Ie=te.slice(2,K+F.index+fe-1);return{type:"strong",raw:te.slice(0,K+F.index+fe+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},le.codespan=function(te){var ce=this.rules.inline.code.exec(te);if(ce){var oe=ce[2].replace(/\n/g," "),F=/[^ ]/.test(oe),z=/^ /.test(oe)&&/ $/.test(oe);return F&&z&&(oe=oe.substring(1,oe.length-1)),oe=C(oe,!0),{type:"codespan",raw:ce[0],text:oe}}},le.br=function(te){var ce=this.rules.inline.br.exec(te);if(ce)return{type:"br",raw:ce[0]}},le.del=function(te){var ce=this.rules.inline.del.exec(te);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},le.autolink=function(te,ce){var oe=this.rules.inline.autolink.exec(te);if(oe){var F,z;return oe[2]==="@"?(F=C(this.options.mangle?ce(oe[1]):oe[1]),z="mailto:"+F):(F=C(oe[1]),z=F),{type:"link",raw:oe[0],text:F,href:z,tokens:[{type:"text",raw:F,text:F}]}}},le.url=function(te,ce){var oe;if(oe=this.rules.inline.url.exec(te)){var F,z;if(oe[2]==="@")F=C(this.options.mangle?ce(oe[0]):oe[0]),z="mailto:"+F;else{var K;do K=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(K!==oe[0]);F=C(oe[0]),oe[1]==="www."?z="http://"+F:z=F}return{type:"link",raw:oe[0],text:F,href:z,tokens:[{type:"text",raw:F,text:F}]}}},le.inlineText=function(te,ce){var oe=this.rules.inline.text.exec(te);if(oe){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):C(oe[0]):oe[0]:F=C(this.options.smartypants?ce(oe[0]):oe[0]),{type:"text",raw:oe[0],text:F}}},_}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=f(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=f(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=f(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=f(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=f(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=f(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=i({},G),G.gfm=i({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=f(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=f(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=i({},G.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:f(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=f(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=f(G._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=f(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=f(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=f(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=f(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=f(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=f(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=f(M.reflink).replace("label",M._label).replace("ref",G._label).getRegex(),M.nolink=f(M.nolink).replace("ref",G._label).getRegex(),M.reflinkSearch=f(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=i({},M),M.pedantic=i({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=i({},M.normal,{escape:f(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=f(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=i({},M.gfm,{br:f(M.br).replace("{2,}","*").getRegex(),text:f(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(_){var le="",de,te,ce=_.length;for(de=0;de<ce;de++)te=_.charCodeAt(de),Math.random()>.5&&(te="x"+te.toString(16)),le+="&#"+te+";";return le}var j=function(){function _(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||re.defaults,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:G.normal,inline:M.normal};this.options.pedantic?(te.block=G.pedantic,te.inline=M.pedantic):this.options.gfm&&(te.block=G.gfm,this.options.breaks?te.inline=M.breaks:te.inline=M.gfm),this.tokenizer.rules=te}_.lex=function(te,ce){var oe=new _(ce);return oe.lex(te)},_.lexInline=function(te,ce){var oe=new _(ce);return oe.inlineTokens(te)};var le=_.prototype;return le.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},le.blockTokens=function(te,ce){var oe=this;ce===void 0&&(ce=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(Ee,Ae,we){return Ae+"    ".repeat(we.length)});for(var F,z,K,Z;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(F=Ee.call({lexer:oe},te,ce))?(te=te.substring(F.raw.length),ce.push(F),!0):!1}))){if(F=this.tokenizer.space(te)){te=te.substring(F.raw.length),F.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(F);continue}if(F=this.tokenizer.code(te)){te=te.substring(F.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(F);continue}if(F=this.tokenizer.fences(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.heading(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.hr(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.blockquote(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.list(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.html(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.def(te)){te=te.substring(F.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+F.raw,z.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.lheading(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(K=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,Ae=te.slice(1),we=void 0;oe.options.extensions.startBlock.forEach(function(Pe){we=Pe.call({lexer:this},Ae),typeof we=="number"&&we>=0&&(Ee=Math.min(Ee,we))}),Ee<1/0&&Ee>=0&&(K=te.substring(0,Ee+1))}(),this.state.top&&(F=this.tokenizer.paragraph(K))){z=ce[ce.length-1],Z&&z.type==="paragraph"?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(F),Z=K.length!==te.length,te=te.substring(F.raw.length);continue}if(F=this.tokenizer.text(te)){te=te.substring(F.raw.length),z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(F);continue}if(te){var fe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return this.state.top=!0,ce},le.inline=function(te,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:te,tokens:ce}),ce},le.inlineTokens=function(te,ce){var oe=this;ce===void 0&&(ce=[]);var F,z,K,Z=te,fe,Ee,Ae;if(this.tokens.links){var we=Object.keys(this.tokens.links);if(we.length>0)for(;(fe=this.tokenizer.rules.inline.reflinkSearch.exec(Z))!=null;)we.includes(fe[0].slice(fe[0].lastIndexOf("[")+1,-1))&&(Z=Z.slice(0,fe.index)+"["+O("a",fe[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(fe=this.tokenizer.rules.inline.blockSkip.exec(Z))!=null;)Z=Z.slice(0,fe.index)+"["+O("a",fe[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(fe=this.tokenizer.rules.inline.escapedEmSt.exec(Z))!=null;)Z=Z.slice(0,fe.index)+"++"+Z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(Ee||(Ae=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(F=Ie.call({lexer:oe},te,ce))?(te=te.substring(F.raw.length),ce.push(F),!0):!1}))){if(F=this.tokenizer.escape(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.tag(te)){te=te.substring(F.raw.length),z=ce[ce.length-1],z&&F.type==="text"&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):ce.push(F);continue}if(F=this.tokenizer.link(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(F.raw.length),z=ce[ce.length-1],z&&F.type==="text"&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):ce.push(F);continue}if(F=this.tokenizer.emStrong(te,Z,Ae)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.codespan(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.br(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.del(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.autolink(te,U)){te=te.substring(F.raw.length),ce.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(te,U))){te=te.substring(F.raw.length),ce.push(F);continue}if(K=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,$e=te.slice(1),xe=void 0;oe.options.extensions.startInline.forEach(function(tt){xe=tt.call({lexer:this},$e),typeof xe=="number"&&xe>=0&&(Ie=Math.min(Ie,xe))}),Ie<1/0&&Ie>=0&&(K=te.substring(0,Ie+1))}(),F=this.tokenizer.inlineText(K,B)){te=te.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(Ae=F.raw.slice(-1)),Ee=!0,z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):ce.push(F);continue}if(te){var Pe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return ce},c(_,null,[{key:"rules",get:function(){return{block:G,inline:M}}}]),_}(),he=function(){function _(de){this.options=de||re.defaults}var le=_.prototype;return le.code=function(te,ce,oe){var F=(ce||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(te,F);z!=null&&z!==te&&(oe=!0,te=z)}return te=te.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+C(F,!0)+'">'+(oe?te:C(te,!0))+`</code></pre>
`:"<pre><code>"+(oe?te:C(te,!0))+`</code></pre>
`},le.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},le.html=function(te){return te},le.heading=function(te,ce,oe,F){if(this.options.headerIds){var z=this.options.headerPrefix+F.slug(oe);return"<h"+ce+' id="'+z+'">'+te+"</h"+ce+`>
`}return"<h"+ce+">"+te+"</h"+ce+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(te,ce,oe){var F=ce?"ol":"ul",z=ce&&oe!==1?' start="'+oe+'"':"";return"<"+F+z+`>
`+te+"</"+F+`>
`},le.listitem=function(te){return"<li>"+te+`</li>
`},le.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(te){return"<p>"+te+`</p>
`},le.table=function(te,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ce+`</table>
`},le.tablerow=function(te){return`<tr>
`+te+`</tr>
`},le.tablecell=function(te,ce){var oe=ce.header?"th":"td",F=ce.align?"<"+oe+' align="'+ce.align+'">':"<"+oe+">";return F+te+("</"+oe+`>
`)},le.strong=function(te){return"<strong>"+te+"</strong>"},le.em=function(te){return"<em>"+te+"</em>"},le.codespan=function(te){return"<code>"+te+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(te){return"<del>"+te+"</del>"},le.link=function(te,ce,oe){if(te=b(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var F='<a href="'+C(te)+'"';return ce&&(F+=' title="'+ce+'"'),F+=">"+oe+"</a>",F},le.image=function(te,ce,oe){if(te=b(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var F='<img src="'+te+'" alt="'+oe+'"';return ce&&(F+=' title="'+ce+'"'),F+=this.options.xhtml?"/>":">",F},le.text=function(te){return te},_}(),ie=function(){function _(){}var le=_.prototype;return le.strong=function(te){return te},le.em=function(te){return te},le.codespan=function(te){return te},le.del=function(te){return te},le.html=function(te){return te},le.text=function(te){return te},le.link=function(te,ce,oe){return""+oe},le.image=function(te,ce,oe){return""+oe},le.br=function(){return""},_}(),V=function(){function _(){this.seen={}}var le=_.prototype;return le.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(te,ce){var oe=te,F=0;if(this.seen.hasOwnProperty(oe)){F=this.seen[te];do F++,oe=te+"-"+F;while(this.seen.hasOwnProperty(oe))}return ce||(this.seen[te]=F,this.seen[oe]=0),oe},le.slug=function(te,ce){ce===void 0&&(ce={});var oe=this.serialize(te);return this.getNextSafeSlug(oe,ce.dryrun)},_}(),J=function(){function _(de){this.options=de||re.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new V}_.parse=function(te,ce){var oe=new _(ce);return oe.parse(te)},_.parseInline=function(te,ce){var oe=new _(ce);return oe.parseInline(te)};var le=_.prototype;return le.parse=function(te,ce){ce===void 0&&(ce=!0);var oe="",F,z,K,Z,fe,Ee,Ae,we,Pe,Ie,$e,xe,tt,Qe,it,rt,Be,et,W,Q=te.length;for(F=0;F<Q;F++){if(Ie=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(W=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){oe+=W||"";continue}switch(Ie.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,n(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(we="",Ae="",Z=Ie.header.length,z=0;z<Z;z++)Ae+=this.renderer.tablecell(this.parseInline(Ie.header[z].tokens),{header:!0,align:Ie.align[z]});for(we+=this.renderer.tablerow(Ae),Pe="",Z=Ie.rows.length,z=0;z<Z;z++){for(Ee=Ie.rows[z],Ae="",fe=Ee.length,K=0;K<fe;K++)Ae+=this.renderer.tablecell(this.parseInline(Ee[K].tokens),{header:!1,align:Ie.align[K]});Pe+=this.renderer.tablerow(Ae)}oe+=this.renderer.table(we,Pe);continue}case"blockquote":{Pe=this.parse(Ie.tokens),oe+=this.renderer.blockquote(Pe);continue}case"list":{for($e=Ie.ordered,xe=Ie.start,tt=Ie.loose,Z=Ie.items.length,Pe="",z=0;z<Z;z++)it=Ie.items[z],rt=it.checked,Be=it.task,Qe="",it.task&&(et=this.renderer.checkbox(rt),tt?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=et+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=et+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:et}):Qe+=et),Qe+=this.parse(it.tokens,tt),Pe+=this.renderer.listitem(Qe,Be,rt);oe+=this.renderer.list(Pe,$e,xe);continue}case"html":{oe+=this.renderer.html(Ie.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(Pe=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;F+1<Q&&te[F+1].type==="text";)Ie=te[++F],Pe+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);oe+=ce?this.renderer.paragraph(Pe):Pe;continue}default:{var ge='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(ge);return}else throw new Error(ge)}}}return oe},le.parseInline=function(te,ce){ce=ce||this.renderer;var oe="",F,z,K,Z=te.length;for(F=0;F<Z;F++){if(z=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(K=this.options.extensions.renderers[z.type].call({parser:this},z),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){oe+=K||"";continue}switch(z.type){case"escape":{oe+=ce.text(z.text);break}case"html":{oe+=ce.html(z.text);break}case"link":{oe+=ce.link(z.href,z.title,this.parseInline(z.tokens,ce));break}case"image":{oe+=ce.image(z.href,z.title,z.text);break}case"strong":{oe+=ce.strong(this.parseInline(z.tokens,ce));break}case"em":{oe+=ce.em(this.parseInline(z.tokens,ce));break}case"codespan":{oe+=ce.codespan(z.text);break}case"br":{oe+=ce.br();break}case"del":{oe+=ce.del(this.parseInline(z.tokens,ce));break}case"text":{oe+=ce.text(z.text);break}default:{var fe='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return oe},_}();function ne(_,le,de){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof le=="function"&&(de=le,le=null),le=i({},ne.defaults,le||{}),h(le),de){var te=le.highlight,ce;try{ce=j.lex(_,le)}catch(Z){return de(Z)}var oe=function(fe){var Ee;if(!fe)try{le.walkTokens&&ne.walkTokens(ce,le.walkTokens),Ee=J.parse(ce,le)}catch(Ae){fe=Ae}return le.highlight=te,fe?de(fe):de(null,Ee)};if(!te||te.length<3||(delete le.highlight,!ce.length))return oe();var F=0;ne.walkTokens(ce,function(Z){Z.type==="code"&&(F++,setTimeout(function(){te(Z.text,Z.lang,function(fe,Ee){if(fe)return oe(fe);Ee!=null&&Ee!==Z.text&&(Z.text=Ee,Z.escaped=!0),F--,F===0&&oe()})},0))}),F===0&&oe();return}function z(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+C(Z.message+"",!0)+"</pre>";throw Z}try{var K=j.lex(_,le);if(le.walkTokens){if(le.async)return Promise.all(ne.walkTokens(K,le.walkTokens)).then(function(){return J.parse(K,le)}).catch(z);ne.walkTokens(K,le.walkTokens)}return J.parse(K,le)}catch(Z){z(Z)}}ne.options=ne.setOptions=function(_){return i(ne.defaults,_),k(ne.defaults),ne},ne.getDefaults=P,ne.defaults=re.defaults,ne.use=function(){for(var _=arguments.length,le=new Array(_),de=0;de<_;de++)le[de]=arguments[de];var te=i.apply(void 0,[{}].concat(le)),ce=ne.defaults.extensions||{renderers:{},childTokens:{}},oe;le.forEach(function(F){if(F.extensions&&(oe=!0,F.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var Z=ce.renderers?ce.renderers[K.name]:null;Z?ce.renderers[K.name]=function(){for(var fe=arguments.length,Ee=new Array(fe),Ae=0;Ae<fe;Ae++)Ee[Ae]=arguments[Ae];var we=K.renderer.apply(this,Ee);return we===!1&&(we=Z.apply(this,Ee)),we}:ce.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[K.level]?ce[K.level].unshift(K.tokenizer):ce[K.level]=[K.tokenizer],K.start&&(K.level==="block"?ce.startBlock?ce.startBlock.push(K.start):ce.startBlock=[K.start]:K.level==="inline"&&(ce.startInline?ce.startInline.push(K.start):ce.startInline=[K.start]))}K.childTokens&&(ce.childTokens[K.name]=K.childTokens)})),F.renderer&&function(){var K=ne.defaults.renderer||new he,Z=function(Ae){var we=K[Ae];K[Ae]=function(){for(var Pe=arguments.length,Ie=new Array(Pe),$e=0;$e<Pe;$e++)Ie[$e]=arguments[$e];var xe=F.renderer[Ae].apply(K,Ie);return xe===!1&&(xe=we.apply(K,Ie)),xe}};for(var fe in F.renderer)Z(fe);te.renderer=K}(),F.tokenizer&&function(){var K=ne.defaults.tokenizer||new Y,Z=function(Ae){var we=K[Ae];K[Ae]=function(){for(var Pe=arguments.length,Ie=new Array(Pe),$e=0;$e<Pe;$e++)Ie[$e]=arguments[$e];var xe=F.tokenizer[Ae].apply(K,Ie);return xe===!1&&(xe=we.apply(K,Ie)),xe}};for(var fe in F.tokenizer)Z(fe);te.tokenizer=K}(),F.walkTokens){var z=ne.defaults.walkTokens;te.walkTokens=function(K){var Z=[];return Z.push(F.walkTokens.call(this,K)),z&&(Z=Z.concat(z.call(this,K))),Z}}oe&&(te.extensions=ce),ne.setOptions(te)})},ne.walkTokens=function(_,le){for(var de=[],te=function(){var z=oe.value;switch(de=de.concat(le.call(ne,z)),z.type){case"table":{for(var K=R(z.header),Z;!(Z=K()).done;){var fe=Z.value;de=de.concat(ne.walkTokens(fe.tokens,le))}for(var Ee=R(z.rows),Ae;!(Ae=Ee()).done;)for(var we=Ae.value,Pe=R(we),Ie;!(Ie=Pe()).done;){var $e=Ie.value;de=de.concat(ne.walkTokens($e.tokens,le))}break}case"list":{de=de.concat(ne.walkTokens(z.items,le));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[z.type]?ne.defaults.extensions.childTokens[z.type].forEach(function(xe){de=de.concat(ne.walkTokens(z[xe],le))}):z.tokens&&(de=de.concat(ne.walkTokens(z.tokens,le)))}},ce=R(_),oe;!(oe=ce()).done;)te();return de},ne.parseInline=function(_,le){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");le=i({},ne.defaults,le||{}),h(le);try{var de=j.lexInline(_,le);return le.walkTokens&&ne.walkTokens(de,le.walkTokens),J.parseInline(de,le)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+C(te.message+"",!0)+"</pre>";throw te}},ne.Parser=J,ne.parser=J.parse,ne.Renderer=he,ne.TextRenderer=ie,ne.Lexer=j,ne.lexer=j.lex,ne.Tokenizer=Y,ne.Slugger=V,ne.parse=ne;var ve=ne.options,ue=ne.setOptions,ee=ne.use,N=ne.walkTokens,q=ne.parseInline,ae=ne,me=J.parse,ke=j.lex;re.Lexer=j,re.Parser=J,re.Renderer=he,re.Slugger=V,re.TextRenderer=ie,re.Tokenizer=Y,re.getDefaults=P,re.lexer=ke,re.marked=ne,re.options=ve,re.parse=ae,re.parseInline=q,re.parser=me,re.setOptions=ue,re.use=ee,re.walkTokens=N,Object.defineProperty(re,"__esModule",{value:!0})}),define(De[88],Ce([1,0,28]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new c.LRUCache(1e4);function u(p){return y(p,"NFC",A)}e.normalizeNFC=u;const R=new c.LRUCache(1e4);function P(p){return y(p,"NFD",R)}e.normalizeNFD=P;const k=/[^\u0000-\u0080]/;function y(p,L,T){if(!p)return p;const S=T.get(p);if(S)return S;let I;return k.test(p)?I=p.normalize(L):I=p,T.set(p,I),I}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(L){return P(L).replace(p,"")}}()}),define(De[103],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(k,y,p){return Math.min(Math.max(k,y),p)}e.clamp=c;function A(k,y){return(y+k%y)%y}e.rot=A;class u{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=u;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class P{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const p=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=P}),function(){function re(u){const R=[];typeof u=="number"&&R.push("code/timeOrigin",u);function P(y){R.push(y,Date.now())}function k(){const y=[];for(let p=0;p<R.length;p+=2)y.push({name:R[p],startTime:R[p+1]});return y}return{mark:P,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const P of performance.getEntriesByType("mark"))R.push({name:P.name,startTime:Math.round(u+P.startTime)});return R}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=c(A))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var A in c)(typeof exports=="object"?exports:re)[A]=c[A]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function c(A){if(e[A])return e[A].exports;var u=e[A]={i:A,l:!1,exports:{}};return re[A].call(u.exports,u,u.exports,c),u.l=!0,u.exports}return c.m=re,c.c=e,c.d=function(A,u,R){c.o(A,u)||Object.defineProperty(A,u,{enumerable:!0,get:R})},c.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},c.t=function(A,u){if(1&u&&(A=c(A)),8&u||4&u&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(c.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&u&&typeof A!="string")for(var P in A)c.d(R,P,function(k){return A[k]}.bind(null,P));return R},c.n=function(A){var u=A&&A.__esModule?function(){return A.default}:function(){return A};return c.d(u,"a",u),u},c.o=function(A,u){return Object.prototype.hasOwnProperty.call(A,u)},c.p="",c(c.s=0)}([function(re,e,c){(function(A){var u;e=re.exports=ee,u=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var we=Array.prototype.slice.call(arguments,0);we.unshift("SEMVER"),console.log.apply(console,we)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],y=e.src=[],p=0,L=p++;y[L]="0|[1-9]\\d*";var T=p++;y[T]="[0-9]+";var S=p++;y[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=p++;y[I]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var C=p++;y[C]="("+y[T]+")\\.("+y[T]+")\\.("+y[T]+")";var w=p++;y[w]="(?:"+y[L]+"|"+y[S]+")";var n=p++;y[n]="(?:"+y[T]+"|"+y[S]+")";var d=p++;y[d]="(?:-("+y[w]+"(?:\\."+y[w]+")*))";var f=p++;y[f]="(?:-?("+y[n]+"(?:\\."+y[n]+")*))";var v=p++;y[v]="[0-9A-Za-z-]+";var D=p++;y[D]="(?:\\+("+y[v]+"(?:\\."+y[v]+")*))";var b=p++,t="v?"+y[I]+y[d]+"?"+y[D]+"?";y[b]="^"+t+"$";var o="[v=\\s]*"+y[C]+y[f]+"?"+y[D]+"?",s=p++;y[s]="^"+o+"$";var a=p++;y[a]="((?:<|>)?=?)";var l=p++;y[l]=y[T]+"|x|X|\\*";var E=p++;y[E]=y[L]+"|x|X|\\*";var i=p++;y[i]="[v=\\s]*("+y[E]+")(?:\\.("+y[E]+")(?:\\.("+y[E]+")(?:"+y[d]+")?"+y[D]+"?)?)?";var r=p++;y[r]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[f]+")?"+y[D]+"?)?)?";var m=p++;y[m]="^"+y[a]+"\\s*"+y[i]+"$";var g=p++;y[g]="^"+y[a]+"\\s*"+y[r]+"$";var h=p++;y[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=p++;y[O]="(?:~>?)";var $=p++;y[$]="(\\s*)"+y[O]+"\\s+",k[$]=new RegExp(y[$],"g");var x=p++;y[x]="^"+y[O]+y[i]+"$";var Y=p++;y[Y]="^"+y[O]+y[r]+"$";var G=p++;y[G]="(?:\\^)";var M=p++;y[M]="(\\s*)"+y[G]+"\\s+",k[M]=new RegExp(y[M],"g");var B=p++;y[B]="^"+y[G]+y[i]+"$";var U=p++;y[U]="^"+y[G]+y[r]+"$";var j=p++;y[j]="^"+y[a]+"\\s*("+o+")$|^$";var he=p++;y[he]="^"+y[a]+"\\s*("+t+")$|^$";var ie=p++;y[ie]="(\\s*)"+y[a]+"\\s*("+o+"|"+y[i]+")",k[ie]=new RegExp(y[ie],"g");var V=p++;y[V]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var J=p++;y[J]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var ne=p++;y[ne]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)u(ve,y[ve]),k[ve]||(k[ve]=new RegExp(y[ve]));function ue(we,Pe){if(we instanceof ee)return we;if(typeof we!="string"||we.length>R||!(Pe?k[s]:k[b]).test(we))return null;try{return new ee(we,Pe)}catch{return null}}function ee(we,Pe){if(we instanceof ee){if(we.loose===Pe)return we;we=we.version}else if(typeof we!="string")throw new TypeError("Invalid Version: "+we);if(we.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ee))return new ee(we,Pe);u("SemVer",we,Pe),this.loose=Pe;var Ie=we.trim().match(Pe?k[s]:k[b]);if(!Ie)throw new TypeError("Invalid Version: "+we);if(this.raw=we,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var xe=+$e;if(xe>=0&&xe<P)return xe}return $e}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=ue,e.valid=function(we,Pe){var Ie=ue(we,Pe);return Ie?Ie.version:null},e.clean=function(we,Pe){var Ie=ue(we.trim().replace(/^[=v]+/,""),Pe);return Ie?Ie.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(we){return u("SemVer.compare",this.version,this.loose,we),we instanceof ee||(we=new ee(we,this.loose)),this.compareMain(we)||this.comparePre(we)},ee.prototype.compareMain=function(we){return we instanceof ee||(we=new ee(we,this.loose)),q(this.major,we.major)||q(this.minor,we.minor)||q(this.patch,we.patch)},ee.prototype.comparePre=function(we){if(we instanceof ee||(we=new ee(we,this.loose)),this.prerelease.length&&!we.prerelease.length)return-1;if(!this.prerelease.length&&we.prerelease.length)return 1;if(!this.prerelease.length&&!we.prerelease.length)return 0;var Pe=0;do{var Ie=this.prerelease[Pe],$e=we.prerelease[Pe];if(u("prerelease compare",Pe,Ie,$e),Ie===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==$e)return q(Ie,$e)}while(++Pe)},ee.prototype.inc=function(we,Pe){switch(we){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+we)}return this.format(),this.raw=this.version,this},e.inc=function(we,Pe,Ie,$e){typeof Ie=="string"&&($e=Ie,Ie=void 0);try{return new ee(we,Ie).inc(Pe,$e).version}catch{return null}},e.diff=function(we,Pe){if(_(we,Pe))return null;var Ie=ue(we),$e=ue(Pe);if(Ie.prerelease.length||$e.prerelease.length){for(var xe in Ie)if((xe==="major"||xe==="minor"||xe==="patch")&&Ie[xe]!==$e[xe])return"pre"+xe;return"prerelease"}for(var xe in Ie)if((xe==="major"||xe==="minor"||xe==="patch")&&Ie[xe]!==$e[xe])return xe},e.compareIdentifiers=q;var N=/^[0-9]+$/;function q(we,Pe){var Ie=N.test(we),$e=N.test(Pe);return Ie&&$e&&(we=+we,Pe=+Pe),Ie&&!$e?-1:$e&&!Ie?1:we<Pe?-1:we>Pe?1:0}function ae(we,Pe,Ie){return new ee(we,Ie).compare(new ee(Pe,Ie))}function me(we,Pe,Ie){return ae(we,Pe,Ie)>0}function ke(we,Pe,Ie){return ae(we,Pe,Ie)<0}function _(we,Pe,Ie){return ae(we,Pe,Ie)===0}function le(we,Pe,Ie){return ae(we,Pe,Ie)!==0}function de(we,Pe,Ie){return ae(we,Pe,Ie)>=0}function te(we,Pe,Ie){return ae(we,Pe,Ie)<=0}function ce(we,Pe,Ie,$e){var xe;switch(Pe){case"===":typeof we=="object"&&(we=we.version),typeof Ie=="object"&&(Ie=Ie.version),xe=we===Ie;break;case"!==":typeof we=="object"&&(we=we.version),typeof Ie=="object"&&(Ie=Ie.version),xe=we!==Ie;break;case"":case"=":case"==":xe=_(we,Ie,$e);break;case"!=":xe=le(we,Ie,$e);break;case">":xe=me(we,Ie,$e);break;case">=":xe=de(we,Ie,$e);break;case"<":xe=ke(we,Ie,$e);break;case"<=":xe=te(we,Ie,$e);break;default:throw new TypeError("Invalid operator: "+Pe)}return xe}function oe(we,Pe){if(we instanceof oe){if(we.loose===Pe)return we;we=we.value}if(!(this instanceof oe))return new oe(we,Pe);u("comparator",we,Pe),this.loose=Pe,this.parse(we),this.semver===F?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(we,Pe){return q(Pe,we)},e.major=function(we,Pe){return new ee(we,Pe).major},e.minor=function(we,Pe){return new ee(we,Pe).minor},e.patch=function(we,Pe){return new ee(we,Pe).patch},e.compare=ae,e.compareLoose=function(we,Pe){return ae(we,Pe,!0)},e.rcompare=function(we,Pe,Ie){return ae(Pe,we,Ie)},e.sort=function(we,Pe){return we.sort(function(Ie,$e){return e.compare(Ie,$e,Pe)})},e.rsort=function(we,Pe){return we.sort(function(Ie,$e){return e.rcompare(Ie,$e,Pe)})},e.gt=me,e.lt=ke,e.eq=_,e.neq=le,e.gte=de,e.lte=te,e.cmp=ce,e.Comparator=oe;var F={};function z(we,Pe){if(we instanceof z)return we.loose===Pe?we:new z(we.raw,Pe);if(we instanceof oe)return new z(we.value,Pe);if(!(this instanceof z))return new z(we,Pe);if(this.loose=Pe,this.raw=we,this.set=we.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+we);this.format()}function K(we){return!we||we.toLowerCase()==="x"||we==="*"}function Z(we,Pe,Ie,$e,xe,tt,Qe,it,rt,Be,et,W,Q){return((Pe=K(Ie)?"":K($e)?">="+Ie+".0.0":K(xe)?">="+Ie+"."+$e+".0":">="+Pe)+" "+(it=K(rt)?"":K(Be)?"<"+(+rt+1)+".0.0":K(et)?"<"+rt+"."+(+Be+1)+".0":W?"<="+rt+"."+Be+"."+et+"-"+W:"<="+it)).trim()}function fe(we,Pe){for(var Ie=0;Ie<we.length;Ie++)if(!we[Ie].test(Pe))return!1;if(Pe.prerelease.length){for(Ie=0;Ie<we.length;Ie++)if(u(we[Ie].semver),we[Ie].semver!==F&&we[Ie].semver.prerelease.length>0){var $e=we[Ie].semver;if($e.major===Pe.major&&$e.minor===Pe.minor&&$e.patch===Pe.patch)return!0}return!1}return!0}function Ee(we,Pe,Ie){try{Pe=new z(Pe,Ie)}catch{return!1}return Pe.test(we)}function Ae(we,Pe,Ie,$e){var xe,tt,Qe,it,rt;switch(we=new ee(we,$e),Pe=new z(Pe,$e),Ie){case">":xe=me,tt=te,Qe=ke,it=">",rt=">=";break;case"<":xe=ke,tt=de,Qe=me,it="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(we,Pe,$e))return!1;for(var Be=0;Be<Pe.set.length;++Be){var et=Pe.set[Be],W=null,Q=null;if(et.forEach(function(ge){ge.semver===F&&(ge=new oe(">=0.0.0")),W=W||ge,Q=Q||ge,xe(ge.semver,W.semver,$e)?W=ge:Qe(ge.semver,Q.semver,$e)&&(Q=ge)}),W.operator===it||W.operator===rt||(!Q.operator||Q.operator===it)&&tt(we,Q.semver)||Q.operator===rt&&Qe(we,Q.semver))return!1}return!0}oe.prototype.parse=function(we){var Pe=this.loose?k[j]:k[he],Ie=we.match(Pe);if(!Ie)throw new TypeError("Invalid comparator: "+we);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new ee(Ie[2],this.loose):this.semver=F},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(we){return u("Comparator.test",we,this.loose),this.semver===F||(typeof we=="string"&&(we=new ee(we,this.loose)),ce(we,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(we,Pe){if(!(we instanceof oe))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new z(we.value,Pe),Ee(this.value,Ie,Pe);if(we.operator==="")return Ie=new z(this.value,Pe),Ee(we.semver,Ie,Pe);var $e=!(this.operator!==">="&&this.operator!==">"||we.operator!==">="&&we.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||we.operator!=="<="&&we.operator!=="<"),tt=this.semver.version===we.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||we.operator!==">="&&we.operator!=="<="),it=ce(this.semver,"<",we.semver,Pe)&&(this.operator===">="||this.operator===">")&&(we.operator==="<="||we.operator==="<"),rt=ce(this.semver,">",we.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(we.operator===">="||we.operator===">");return $e||xe||tt&&Qe||it||rt},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(we){return we.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(we){var Pe=this.loose;we=we.trim(),u("range",we,Pe);var Ie=Pe?k[J]:k[V];we=we.replace(Ie,Z),u("hyphen replace",we),we=we.replace(k[ie],"$1$2$3"),u("comparator trim",we,k[ie]),we=(we=(we=we.replace(k[$],"$1~")).replace(k[M],"$1^")).split(/\s+/).join(" ");var $e=Pe?k[j]:k[he],xe=we.split(" ").map(function(tt){return function(Qe,it){return u("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(et){return function(W,Q){u("caret",W,Q);var ge=Q?k[U]:k[B];return W.replace(ge,function(Le,Ne,je,Ye,Xe){var nt;return u("caret",W,Le,Ne,je,Ye,Xe),K(Ne)?nt="":K(je)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":K(Ye)?nt=Ne==="0"?">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+".0 <"+(+Ne+1)+".0.0":Xe?(u("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),nt=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+je+"."+(+Ye+1):">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+Ye+Xe+" <"+(+Ne+1)+".0.0"):(u("no pr"),nt=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+je+"."+(+Ye+1):">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+Ye+" <"+(+Ne+1)+".0.0"),u("caret return",nt),nt})}(et,Be)}).join(" ")}(Qe,it),u("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(et){return function(W,Q){var ge=Q?k[Y]:k[x];return W.replace(ge,function(Le,Ne,je,Ye,Xe){var nt;return u("tilde",W,Le,Ne,je,Ye,Xe),K(Ne)?nt="":K(je)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":K(Ye)?nt=">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":Xe?(u("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),nt=">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+(+je+1)+".0"):nt=">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+(+je+1)+".0",u("tilde return",nt),nt})}(et,Be)}).join(" ")}(Qe,it),u("tildes",Qe),Qe=function(rt,Be){return u("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(et){return function(W,Q){W=W.trim();var ge=Q?k[g]:k[m];return W.replace(ge,function(Le,Ne,je,Ye,Xe,nt){u("xRange",W,Le,Ne,je,Ye,Xe,nt);var ot=K(je),pt=ot||K(Ye),bt=pt||K(Xe);return Ne==="="&&bt&&(Ne=""),ot?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&bt?(pt&&(Ye=0),bt&&(Xe=0),Ne===">"?(Ne=">=",pt?(je=+je+1,Ye=0,Xe=0):bt&&(Ye=+Ye+1,Xe=0)):Ne==="<="&&(Ne="<",pt?je=+je+1:Ye=+Ye+1),Le=Ne+je+"."+Ye+"."+Xe):pt?Le=">="+je+".0.0 <"+(+je+1)+".0.0":bt&&(Le=">="+je+"."+Ye+".0 <"+je+"."+(+Ye+1)+".0"),u("xRange return",Le),Le})}(et,Be)}).join(" ")}(Qe,it),u("xrange",Qe),Qe=function(rt,Be){return u("replaceStars",rt,Be),rt.trim().replace(k[ne],"")}(Qe,it),u("stars",Qe),Qe}(tt,Pe)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(tt){return!!tt.match($e)})),xe=xe.map(function(tt){return new oe(tt,Pe)})},z.prototype.intersects=function(we,Pe){if(!(we instanceof z))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function($e){return we.set.some(function(xe){return xe.every(function(tt){return $e.intersects(tt,Pe)})})})})},e.toComparators=function(we,Pe){return new z(we,Pe).set.map(function(Ie){return Ie.map(function($e){return $e.value}).join(" ").trim().split(" ")})},z.prototype.test=function(we){if(!we)return!1;typeof we=="string"&&(we=new ee(we,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if(fe(this.set[Pe],we))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(we,Pe,Ie){var $e=null,xe=null;try{var tt=new z(Pe,Ie)}catch{return null}return we.forEach(function(Qe){tt.test(Qe)&&($e&&xe.compare(Qe)!==-1||(xe=new ee($e=Qe,Ie)))}),$e},e.minSatisfying=function(we,Pe,Ie){var $e=null,xe=null;try{var tt=new z(Pe,Ie)}catch{return null}return we.forEach(function(Qe){tt.test(Qe)&&($e&&xe.compare(Qe)!==1||(xe=new ee($e=Qe,Ie)))}),$e},e.validRange=function(we,Pe){try{return new z(we,Pe).range||"*"}catch{return null}},e.ltr=function(we,Pe,Ie){return Ae(we,Pe,"<",Ie)},e.gtr=function(we,Pe,Ie){return Ae(we,Pe,">",Ie)},e.outside=Ae,e.prerelease=function(we,Pe){var Ie=ue(we,Pe);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(we,Pe,Ie){return we=new z(we,Ie),Pe=new z(Pe,Ie),we.intersects(Pe)},e.coerce=function(we){if(we instanceof ee)return we;if(typeof we!="string")return null;var Pe=we.match(k[h]);return Pe==null?null:ue((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,c(1))},function(re,e){var c,A,u=re.exports={};function R(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function k(n){if(c===setTimeout)return setTimeout(n,0);if((c===R||!c)&&setTimeout)return c=setTimeout,setTimeout(n,0);try{return c(n,0)}catch{try{return c.call(null,n,0)}catch{return c.call(this,n,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:R}catch{c=R}try{A=typeof clearTimeout=="function"?clearTimeout:P}catch{A=P}})();var y,p=[],L=!1,T=-1;function S(){L&&y&&(L=!1,y.length?p=y.concat(p):T=-1,p.length&&I())}function I(){if(!L){var n=k(S);L=!0;for(var d=p.length;d;){for(y=p,p=[];++T<d;)y&&y[T].run();T=-1,d=p.length}y=null,L=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===P||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(n)}}function C(n,d){this.fun=n,this.array=d}function w(){}u.nextTick=function(n){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];p.push(new C(n,d)),p.length!==1||L||k(I)},C.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=w,u.addListener=w,u.once=w,u.off=w,u.removeListener=w,u.removeAllListeners=w,u.emit=w,u.prependListener=w,u.prependOnceListener=w,u.listeners=function(n){return[]},u.binding=function(n){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(n){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(De[104],Ce([1,0,9,6]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(D){const b=D;return b?typeof b.read=="function":!1}e.isReadable=u;function R(D){const b=D;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function P(D){const b=D;return b?R(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=P;function k(D,b){return new y(D,b)}e.newWriteableStream=k;class y{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,c.onUnexpectedError)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let o;switch(b){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(D,b){const t=[];let o;for(;(o=D.read())!==null;)t.push(o);return b(t)}e.consumeReadable=p;function L(D,b,t){const o=[];let s;for(;(s=D.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?b(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const a=s;return s=void 0,a}return D.read()}}}e.peekReadable=L;function T(D,b){return new Promise((t,o)=>{const s=[];S(D,{onData:a=>{b&&s.push(a)},onError:a=>{b?o(a):t(void 0)},onEnd:()=>{t(b?b(s):void 0)}})})}e.consumeStream=T;function S(D,b){let t=!1;return D.on("error",o=>{t||b.onError(o)}),D.on("end",()=>{t||b.onEnd()}),D.on("data",o=>{t||b.onData(o)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=S;function I(D,b){return new Promise((t,o)=>{const s=new A.DisposableStore,a=[],l=r=>{if(a.push(r),a.length>b)return s.dispose(),D.pause(),t({stream:D,buffer:a,ended:!1})},E=r=>o(r),i=()=>t({stream:D,buffer:a,ended:!0});s.add((0,A.toDisposable)(()=>D.removeListener("error",E))),D.on("error",E),s.add((0,A.toDisposable)(()=>D.removeListener("end",i))),D.on("end",i),s.add((0,A.toDisposable)(()=>D.removeListener("data",l))),D.on("data",l)})}e.peekStream=I;function C(D,b){const t=k(b);return t.end(D),t}e.toStream=C;function w(){const D=k(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=w;function n(D){let b=!1;return{read:()=>b?null:(b=!0,D)}}e.toReadable=n;function d(D,b,t){const o=k(t);return S(D,{onData:s=>o.write(b.data(s)),onError:s=>o.error(b.error?b.error(s):s),onEnd:()=>o.end()}),o}e.transform=d;function f(D,b,t){let o=!1;return{read:()=>{const s=b.read();return o?s:(o=!0,s!==null?t([D,s]):D)}}}e.prefixedReadable=f;function v(D,b,t){let o=!1;const s=k(t);return S(b,{onData:a=>o?s.write(a):(o=!0,s.write(t([D,a]))),onError:a=>s.error(a),onEnd:()=>{o||(o=!0,s.write(D)),s.end()}}),s}e.prefixedStream=v}),define(De[22],Ce([1,0,104]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let u,R;class P{static alloc(r){return A?new P(Buffer.allocUnsafe(r)):new P(new Uint8Array(r))}static wrap(r){return A&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new P(r)}static fromString(r,m){return!(m?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(r)):(u||(u=new TextEncoder),new P(u.encode(r)))}static fromByteArray(r){const m=P.alloc(r.length);for(let g=0,h=r.length;g<h;g++)m.buffer[g]=r[g];return m}static concat(r,m){if(typeof m>"u"){m=0;for(let O=0,$=r.length;O<$;O++)m+=r[O].byteLength}const g=P.alloc(m);let h=0;for(let O=0,$=r.length;O<$;O++){const x=r[O];g.set(x,h),h+=x.byteLength}return g}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=P.alloc(this.byteLength);return r.set(this),r}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(r,m){return new P(this.buffer.subarray(r,m))}set(r,m){if(r instanceof P)this.buffer.set(r.buffer,m);else if(r instanceof Uint8Array)this.buffer.set(r,m);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),m);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return p(this.buffer,r)}writeUInt32BE(r,m){L(this.buffer,r,m)}readUInt32LE(r){return T(this.buffer,r)}writeUInt32LE(r,m){S(this.buffer,r,m)}readUInt8(r){return I(this.buffer,r)}writeUInt8(r,m){C(this.buffer,r,m)}}e.VSBuffer=P;function k(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}e.readUInt16LE=k;function y(i,r,m){i[m+0]=r&255,r=r>>>8,i[m+1]=r&255}e.writeUInt16LE=y;function p(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}e.readUInt32BE=p;function L(i,r,m){i[m+3]=r,r=r>>>8,i[m+2]=r,r=r>>>8,i[m+1]=r,r=r>>>8,i[m]=r}e.writeUInt32BE=L;function T(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}e.readUInt32LE=T;function S(i,r,m){i[m+0]=r&255,r=r>>>8,i[m+1]=r&255,r=r>>>8,i[m+2]=r&255,r=r>>>8,i[m+3]=r&255}e.writeUInt32LE=S;function I(i,r){return i[r]}e.readUInt8=I;function C(i,r,m){i[m]=r}e.writeUInt8=C;function w(i){return c.consumeReadable(i,r=>P.concat(r))}e.readableToBuffer=w;function n(i){return c.toReadable(i)}e.bufferToReadable=n;function d(i){return c.consumeStream(i,r=>P.concat(r))}e.streamToBuffer=d;async function f(i){return i.ended?P.concat(i.buffer):P.concat([...i.buffer,await d(i.stream)])}e.bufferedStreamToBuffer=f;function v(i){return c.toStream(i,r=>P.concat(r))}e.bufferToStream=v;function D(i){return c.transform(i,{data:r=>typeof r=="string"?P.fromString(r):P.wrap(r)},r=>P.concat(r))}e.streamToBufferReadableStream=D;function b(i){return c.newWriteableStream(r=>P.concat(r),i)}e.newWriteableBufferStream=b;function t(i,r){return c.prefixedReadable(i,r,m=>P.concat(m))}e.prefixedBufferReadable=t;function o(i,r){return c.prefixedStream(i,r,m=>P.concat(m))}e.prefixedBufferStream=o;function s(i){let r=0,m=0,g=0;const h=new Uint8Array(Math.floor(i.length/4*3)),O=x=>{switch(m){case 3:h[g++]=r|x,m=0;break;case 2:h[g++]=r|x>>>2,r=x<<6,m=3;break;case 1:h[g++]=r|x>>>4,r=x<<4,m=2;break;default:r=x<<2,m=1}};for(let x=0;x<i.length;x++){const Y=i.charCodeAt(x);if(Y>=65&&Y<=90)O(Y-65);else if(Y>=97&&Y<=122)O(Y-97+26);else if(Y>=48&&Y<=57)O(Y-48+52);else if(Y===43||Y===45)O(62);else if(Y===47||Y===95)O(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${i[x]}`)}}const $=g;for(;m>0;)O(0);return P.wrap(h).slice(0,$)}e.decodeBase64=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:i},r=!0,m=!1){const g=m?l:a;let h="";const O=i.byteLength%3;let $=0;for(;$<i.byteLength-O;$+=3){const x=i[$+0],Y=i[$+1],G=i[$+2];h+=g[x>>>2],h+=g[(x<<4|Y>>>4)&63],h+=g[(Y<<2|G>>>6)&63],h+=g[G&63]}if(O===1){const x=i[$+0];h+=g[x>>>2],h+=g[x<<4&63],r&&(h+="==")}else if(O===2){const x=i[$+0],Y=i[$+1];h+=g[x>>>2],h+=g[(x<<4|Y>>>4)&63],h+=g[Y<<2&63],r&&(h+="=")}return h}e.encodeBase64=E}),define(De[150],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[10],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(o){return typeof o=="string"}e.isString=c;function A(o){return Array.isArray(o)&&o.every(s=>c(s))}e.isStringArray=A;function u(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=u;function R(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=R;function P(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=P;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function y(o){return o===!0||o===!1}e.isBoolean=y;function p(o){return typeof o>"u"}e.isUndefined=p;function L(o){return!T(o)}e.isDefined=L;function T(o){return p(o)||o===null}e.isUndefinedOrNull=T;function S(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=S;function I(o){if(T(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=I;function C(...o){const s=[];for(let a=0;a<o.length;a++){const l=o[a];if(T(l))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(l)}return s}e.assertAllDefined=C;const w=Object.prototype.hasOwnProperty;function n(o){if(!u(o))return!1;for(const s in o)if(w.call(o,s))return!1;return!0}e.isEmptyObject=n;function d(o){return typeof o=="function"}e.isFunction=d;function f(...o){return o.length>0&&o.every(d)}e.areFunctions=f;function v(o,s){const a=Math.min(o.length,s.length);for(let l=0;l<a;l++)D(o[l],s[l])}e.validateConstraints=v;function D(o,s){if(c(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(d(s)){try{if(o instanceof s)return}catch{}if(!T(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function b(o){return o===null?void 0:o}e.withNullAsUndefined=b;function t(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=t}),define(De[67],Ce([1,0,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function u(k,y){if((0,c.isString)(y)){const p=A[y];if(p===void 0)throw new Error(`${k} references an unknown codicon: ${y}`);y=p}return A[k]=y,{id:k}}function R(){return A}e.getCodiconFontCharacters=R;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([v,D])=>{f[v]=D&&typeof D=="object"?A(D):D}),f}e.deepClone=A;function u(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const v=f.shift();Object.freeze(v);for(const D in v)if(R.call(v,D)){const b=v[D];typeof b=="object"&&!Object.isFrozen(b)&&!(0,c.isTypedArray)(b)&&f.push(b)}}return d}e.deepFreeze=u;const R=Object.prototype.hasOwnProperty;function P(d,f){return k(d,f,new Set)}e.cloneAndChange=P;function k(d,f,v){if((0,c.isUndefinedOrNull)(d))return d;const D=f(d);if(typeof D<"u")return D;if(Array.isArray(d)){const b=[];for(const t of d)b.push(k(t,f,v));return b}if((0,c.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const b={};for(const t in d)R.call(d,t)&&(b[t]=k(d[t],f,v));return v.delete(d),b}return d}function y(d,f,v=!0){return(0,c.isObject)(d)?((0,c.isObject)(f)&&Object.keys(f).forEach(D=>{D in d?v&&((0,c.isObject)(d[D])&&(0,c.isObject)(f[D])?y(d[D],f[D],v):d[D]=f[D]):d[D]=f[D]}),d):f}e.mixin=y;function p(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let v,D;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(v=0;v<d.length;v++)if(!p(d[v],f[v]))return!1}else{const b=[];for(D in d)b.push(D);b.sort();const t=[];for(D in f)t.push(D);if(t.sort(),!p(b,t))return!1;for(v=0;v<b.length;v++)if(!p(d[b[v]],f[b[v]]))return!1}return!0}e.equals=p;function L(d){const f=new Set;return JSON.stringify(d,(v,D)=>{if((0,c.isObject)(D)||Array.isArray(D)){if(f.has(D))return"[Circular]";f.add(D)}return D})}e.safeStringify=L;function T(d,f){const v=Object.create(null);return!d||!f||Object.keys(f).forEach(b=>{const t=d[b],o=f[b];p(t,o)||(v[b]=o)}),v}e.distinct=T;function S(d,f){const v=f.toLowerCase(),D=Object.keys(d).find(b=>b.toLowerCase()===v);return D?d[D]:d[f]}e.getCaseInsensitive=S;function I(d,f){const v=Object.create(null);for(const[D,b]of Object.entries(d))f(D,b)&&(v[D]=b);return v}e.filter=I;function C(d){let f=[],v=Object.getPrototypeOf(d);for(;Object.prototype!==v;)f=f.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return f}e.getAllPropertyNames=C;function w(d){const f=[];for(const v of C(d))typeof d[v]=="function"&&f.push(v);return f}e.getAllMethodNames=w;function n(d,f){const v=b=>function(){const t=Array.prototype.slice.call(arguments,0);return f(b,t)},D={};for(const b of d)D[b]=v(b);return D}e.createProxyObject=n}),define(De[52],Ce([1,0,67]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(P){function k(y){return y&&typeof y=="object"&&typeof y.id=="string"}P.isThemeColor=k})(A=e.ThemeColor||(e.ThemeColor={}));function u(P){return{id:P}}e.themeColorFromId=u;var R;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function y(f){const v=k.exec(f.id);if(!v)return y(c.Codicon.error);const[,D,b]=v,t=["codicon","codicon-"+D];return b&&t.push("codicon-modifier-"+b.substring(1)),t}P.asClassNameArray=y;function p(f){return y(f).join(" ")}P.asClassName=p;function L(f){return"."+y(f).join(".")}P.asCSSSelector=L;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||A.isThemeColor(f.color))}P.isThemeIcon=T;const S=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function I(f){const v=S.exec(f);if(!v)return;const[,D]=v;return{id:D}}P.fromString=I;function C(f){return{id:f}}P.fromId=C;function w(f,v){let D=f.id;const b=D.lastIndexOf("~");return b!==-1&&(D=D.substring(0,b)),v&&(D=`${D}~${v}`),{id:D}}P.modify=w;function n(f){const v=f.id.lastIndexOf("~");if(v!==-1)return f.id.substring(v+1)}P.getModifier=n;function d(f,v){return f.id===v.id&&f.color?.id===v.color?.id}P.isEqual=d})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(De[105],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function u(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=u}),define(De[30],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(u){return c.test(u)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(k){for(let y=0;y<k.length;y++)k[y]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),P=[];for(let k=0;k<256;k++)P.push(k.toString(16).padStart(2,"0"));return function(){u(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,p="";return p+=P[R[y++]],p+=P[R[y++]],p+=P[R[y++]],p+=P[R[y++]],p+="-",p+=P[R[y++]],p+=P[R[y++]],p+="-",p+=P[R[y++]],p+=P[R[y++]],p+="-",p+=P[R[y++]],p+=P[R[y++]],p+="-",p+=P[R[y++]],p+=P[R[y++]],p+=P[R[y++]],p+=P[R[y++]],p+=P[R[y++]],p+=P[R[y++]],p}}()}),define(De[151],Ce([1,0,17,30]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function u(k){return{id:(0,A.generateUuid)(),asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=u;function R(k,y,p){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:k,uri:y,data:p}),value:void 0}}e.createFileDataTransferItem=R;class P{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,p){const L=this.a.get(y);L?L.push(p):this.a.set(this.b(y),[p])}replace(y,p){this.a.set(this.b(y),[p])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,p]of this.a.entries())for(const L of p)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[p,L]of this.entries())y(L,p)}b(y){return y.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:k=>(0,c.distinct)(k.map(y=>y.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(y=>!y.startsWith("#"))})}),define(De[106],Ce([1,0,105]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(k){const y=(0,c.toUint8)(k);this.c=y,this.a=A.d(y),this.b=new Map}static d(k){const y=new Uint8Array(256);return y.fill(k),y}set(k,y){const p=(0,c.toUint8)(y);k>=0&&k<256?this.a[k]=p:this.b.set(k,p)}get(k){return k>=0&&k<256?this.a[k]:this.b.get(k)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var u;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(u||(u={}));class R{constructor(){this.a=new A(0)}add(k){this.a.set(k,1)}has(k){return this.a.get(k)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(De[53],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(u,R){this.lineNumber=u,this.column=R}with(u=this.lineNumber,R=this.column){return u===this.lineNumber&&R===this.column?this:new c(u,R)}delta(u=0,R=0){return this.with(this.lineNumber+u,this.column+R)}equals(u){return c.equals(this,u)}static equals(u,R){return!u&&!R?!0:!!u&&!!R&&u.lineNumber===R.lineNumber&&u.column===R.column}isBefore(u){return c.isBefore(this,u)}static isBefore(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<R.column}isBeforeOrEqual(u){return c.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<=R.column}static compare(u,R){const P=u.lineNumber|0,k=R.lineNumber|0;if(P===k){const y=u.column|0,p=R.column|0;return y-p}return P-k}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new c(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=c}),define(De[32],Ce([1,0,53]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,P,k,y){R>k||R===k&&P>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=R,this.endColumn=P):(this.startLineNumber=R,this.startColumn=P,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<R.startColumn||P.lineNumber===R.endLineNumber&&P.column>R.endColumn)}static strictContainsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<=R.startColumn||P.lineNumber===R.endLineNumber&&P.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<=R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,P){let k,y,p,L;return P.startLineNumber<R.startLineNumber?(k=P.startLineNumber,y=P.startColumn):P.startLineNumber===R.startLineNumber?(k=P.startLineNumber,y=Math.min(P.startColumn,R.startColumn)):(k=R.startLineNumber,y=R.startColumn),P.endLineNumber>R.endLineNumber?(p=P.endLineNumber,L=P.endColumn):P.endLineNumber===R.endLineNumber?(p=P.endLineNumber,L=Math.max(P.endColumn,R.endColumn)):(p=R.endLineNumber,L=R.endColumn),new A(k,y,p,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,P){let k=R.startLineNumber,y=R.startColumn,p=R.endLineNumber,L=R.endColumn;const T=P.startLineNumber,S=P.startColumn,I=P.endLineNumber,C=P.endColumn;return k<T?(k=T,y=S):k===T&&(y=Math.max(y,S)),p>I?(p=I,L=C):p===I&&(L=Math.min(L,C)),k>p||k===p&&y>L?null:new A(k,y,p,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,P){return!R&&!P?!0:!!R&&!!P&&R.startLineNumber===P.startLineNumber&&R.startColumn===P.startColumn&&R.endLineNumber===P.endLineNumber&&R.endColumn===P.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new c.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new c.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,P){return new A(this.startLineNumber,this.startColumn,R,P)}setStartPosition(R,P){return new A(R,P,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,P=R){return new A(R.lineNumber,R.column,P.lineNumber,P.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<R.startColumn)}static areIntersecting(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<=P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,P){if(R&&P){const p=R.startLineNumber|0,L=P.startLineNumber|0;if(p===L){const T=R.startColumn|0,S=P.startColumn|0;if(T===S){const I=R.endLineNumber|0,C=P.endLineNumber|0;if(I===C){const w=R.endColumn|0,n=P.endColumn|0;return w-n}return I-C}return T-S}return p-L}return(R?1:0)-(P?1:0)}static compareRangesUsingEnds(R,P){return R.endLineNumber===P.endLineNumber?R.endColumn===P.endColumn?R.startLineNumber===P.startLineNumber?R.startColumn-P.startColumn:R.startLineNumber-P.startLineNumber:R.endColumn-P.endColumn:R.endLineNumber-P.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(De[152],Ce([1,0,53,32]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(u=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(k,y,p,L){super(k,y,p,L),this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=p,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return R.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,k,y):new R(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,y){return this.getDirection()===0?new R(k,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new R(k.lineNumber,k.column,y.lineNumber,y.column)}static fromRange(k,y){return y===0?new R(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new R(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new R(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let p=0,L=k.length;p<L;p++)if(!this.selectionsEqual(k[p],y[p]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,p,L,T){return T===0?new R(k,y,p,L):new R(p,L,k,y)}}e.Selection=R}),define(De[153],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[154],Ce([1,0,106]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class u extends c.CharacterClassifier{constructor(k){super(0);for(let y=0,p=k.length;y<p;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function R(P){const k={};return y=>(k.hasOwnProperty(y)||(k[y]=P(y)),k[y])}e.getMapForWordSeparators=R(P=>new u(P))}),define(De[107],Ce([1,0,64,6,66]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(T=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)T.indexOf(I)>=0||(S+="\\"+I);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=R();function P(T){let S=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)S=T;else{let I="g";T.ignoreCase&&(I+="i"),T.multiline&&(I+="m"),T.unicode&&(I+="u"),S=new RegExp(T.source,I)}return S.lastIndex=0,S}e.ensureValidWordDefinition=P;const k=new u.LinkedList;k.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(T){const S=k.unshift(T);return(0,A.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=y;function p(T,S,I,C,w){if(w||(w=c.Iterable.first(k)),I.length>w.maxLen){let D=T-w.maxLen/2;return D<0?D=0:C+=D,I=I.substring(D,T+w.maxLen/2),p(T,S,I,C,w)}const n=Date.now(),d=T-1-C;let f=-1,v=null;for(let D=1;!(Date.now()-n>=w.timeBudget);D++){const b=d-w.windowSize*D;S.lastIndex=Math.max(0,b);const t=L(S,I,d,f);if(!t&&v||(v=t,b<=0))break;f=b}if(v){const D={word:v[0],startColumn:C+1+v.index,endColumn:C+1+v.index+v[0].length};return S.lastIndex=0,D}return null}e.getWordAtText=p;function L(T,S,I,C){let w;for(;w=T.exec(S);){const n=w.index||0;if(n<=I&&T.lastIndex>=I)return w;if(C>0&&n>C)return null}return null}}),define(De[155],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class A{constructor(k){if(this.e=null,this.f=!1,this.open=k.open,this.close=k.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(k.notIn))for(let y=0,p=k.notIn.length;y<p;y++)switch(k.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(k,y){if(k.getTokenCount()===0)return!0;const p=k.findTokenIndexAtOffset(y-2),L=k.getStandardTokenType(p);return this.isOK(L)}g(k,y){for(let p=k;p<=y;p++){const L=String.fromCharCode(p);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class u{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=u;function R(P,k,y){P.has(k)?P.get(k).push(y):P.set(k,[y])}}),define(De[156],Ce([1,0,106]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class u{constructor(C,w,n){const d=new Uint8Array(C*w);for(let f=0,v=C*w;f<v;f++)d[f]=n;this.a=d,this.rows=C,this.cols=w}get(C,w){return this.a[C*this.cols+w]}set(C,w,n){this.a[C*this.cols+w]=n}}class R{constructor(C){let w=0,n=0;for(let f=0,v=C.length;f<v;f++){const[D,b,t]=C[f];b>w&&(w=b),D>n&&(n=D),t>n&&(n=t)}w++,n++;const d=new u(n,w,0);for(let f=0,v=C.length;f<v;f++){const[D,b,t]=C[f];d.set(D,b,t)}this.a=d,this.b=w}nextState(C,w){return w<0||w>=this.b?0:this.a.get(C,w)}}e.StateMachine=R;let P=null;function k(){return P===null&&(P=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var y;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let p=null;function L(){if(p===null){p=new c.CharacterClassifier(0);const I=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<I.length;w++)p.set(I.charCodeAt(w),1);const C=".,;:";for(let w=0;w<C.length;w++)p.set(C.charCodeAt(w),2)}return p}class T{static a(C,w,n,d,f){let v=f-1;do{const D=w.charCodeAt(v);if(C.get(D)!==2)break;v--}while(v>d);if(d>0){const D=w.charCodeAt(d-1),b=w.charCodeAt(v);(D===40&&b===41||D===91&&b===93||D===123&&b===125)&&v--}return{range:{startLineNumber:n,startColumn:d+1,endLineNumber:n,endColumn:v+2},url:w.substring(d,v+1)}}static computeLinks(C,w=k()){const n=L(),d=[];for(let f=1,v=C.getLineCount();f<=v;f++){const D=C.getLineContent(f),b=D.length;let t=0,o=0,s=0,a=1,l=!1,E=!1,i=!1,r=!1;for(;t<b;){let m=!1;const g=D.charCodeAt(t);if(a===13){let h;switch(g){case 40:l=!0,h=0;break;case 41:h=l?0:1;break;case 91:i=!0,E=!0,h=0;break;case 93:i=!1,h=E?0:1;break;case 123:r=!0,h=0;break;case 125:h=r?0:1;break;case 39:case 34:case 96:s===g?h=1:s===39||s===34||s===96?h=0:h=1;break;case 42:h=s===42?1:0;break;case 124:h=s===124?1:0;break;case 32:h=i?0:1;break;default:h=n.get(g)}h===1&&(d.push(T.a(n,D,f,o,t)),m=!0)}else if(a===12){let h;g===91?(E=!0,h=0):h=n.get(g),h===1?m=!0:a=13}else a=w.nextState(a,g),a===0&&(m=!0);m&&(a=1,l=!1,E=!1,r=!1,o=t+1,s=g),t++}a===13&&d.push(T.a(n,D,f,o,b))}return d}}e.LinkComputer=T;function S(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:T.computeLinks(I)}e.computeLinks=S}),define(De[108],Ce([1,0,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var u;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(u=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var P;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class p{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),D.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,D.indentSize|0),this.a=!1),this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.a===D.a&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=p;class L{constructor(D,b){this._findMatchBrand=void 0,this.range=D,this.matches=b}}e.FindMatch=L;var T;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(v){return v&&typeof v.read=="function"}e.isITextSnapshot=S;var I;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None",v[v.LeftOfInjectedText=3]="LeftOfInjectedText",v[v.RightOfInjectedText=4]="RightOfInjectedText"})(I=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class w{constructor(D,b,t,o,s,a){this.identifier=D,this.range=b,this.text=t,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=a}}e.ValidAnnotatedEditOperation=w;class n{constructor(D,b,t){this.regex=D,this.wordSeparators=b,this.simpleSearch=t}}e.SearchData=n;class d{constructor(D,b,t){this.reverseEdits=D,this.changes=b,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=d;function f(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}e.shouldSynchronizeModel=f}),define(De[157],Ce([1,0,17,105]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,p){y=(0,A.toUint32)(y);const L=this.a,T=this.b,S=p.length;return S===0?!1:(this.a=new Uint32Array(L.length+S),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+S),this.a.set(p,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}setValue(y,p){return y=(0,A.toUint32)(y),p=(0,A.toUint32)(p),this.a[y]===p?!1:(this.a[y]=p,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,p){y=(0,A.toUint32)(y),p=(0,A.toUint32)(p);const L=this.a,T=this.b;if(y>=L.length)return!1;const S=L.length-y;return p>=S&&(p=S),p===0?!1:(this.a=new Uint32Array(L.length-p),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+p),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,A.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let p=this.c[0]+1;p===0&&(this.b[0]=this.a[0],p++),y>=this.a.length&&(y=this.a.length-1);for(let L=p;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let p=0,L=this.a.length-1,T=0,S=0,I=0;for(;p<=L;)if(T=p+(L-p)/2|0,S=this.b[T],I=S-this.a[T],y<I)L=T-1;else if(y>=S)p=T+1;else break;return new P(T,y-I)}}e.PrefixSumComputer=u;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const p=this.e[y],L=p>0?this.d[p-1]:0;return new P(p,y-L)}removeValues(y,p){this.a.splice(y,p),this.f(y)}insertValues(y,p){this.a=(0,c.arrayInsert)(this.a,y,p),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,p=this.a.length;y<p;y++){const L=this.a[y],T=y>0?this.d[y-1]:0;this.d[y]=T+L;for(let S=0;S<L;S++)this.e[T+S]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,p){this.a[y]!==p&&(this.a[y]=p,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class P{constructor(y,p){this.index=y,this.remainder=p,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=p}}e.PrefixSumIndexOfResult=P}),define(De[158],Ce([14,15]),function(re,e){return re.create("vs/base/common/actions",e)}),define(De[159],Ce([14,15]),function(re,e){return re.create("vs/base/common/date",e)}),define(De[160],Ce([1,0,159]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,u=A*60,R=u*24,P=R*7,k=R*30,y=R*365;function p(T,S,I,C){typeof T!="number"&&(T=T.getTime());const w=Math.round((new Date().getTime()-T)/1e3);if(w<-30)return(0,c.localize)(0,null,p(new Date().getTime()+w*1e3,!1));if(!C&&w<30)return(0,c.localize)(1,null);let n;return w<A?(n=w,S?n===1?I?(0,c.localize)(2,null,n):(0,c.localize)(3,null,n):I?(0,c.localize)(4,null,n):(0,c.localize)(5,null,n):n===1?I?(0,c.localize)(6,null,n):(0,c.localize)(7,null,n):I?(0,c.localize)(8,null,n):(0,c.localize)(9,null,n)):w<u?(n=Math.floor(w/A),S?n===1?I?(0,c.localize)(10,null,n):(0,c.localize)(11,null,n):I?(0,c.localize)(12,null,n):(0,c.localize)(13,null,n):n===1?I?(0,c.localize)(14,null,n):(0,c.localize)(15,null,n):I?(0,c.localize)(16,null,n):(0,c.localize)(17,null,n)):w<R?(n=Math.floor(w/u),S?n===1?I?(0,c.localize)(18,null,n):(0,c.localize)(19,null,n):I?(0,c.localize)(20,null,n):(0,c.localize)(21,null,n):n===1?I?(0,c.localize)(22,null,n):(0,c.localize)(23,null,n):I?(0,c.localize)(24,null,n):(0,c.localize)(25,null,n)):w<P?(n=Math.floor(w/R),S?n===1?(0,c.localize)(26,null,n):(0,c.localize)(27,null,n):n===1?(0,c.localize)(28,null,n):(0,c.localize)(29,null,n)):w<k?(n=Math.floor(w/P),S?n===1?I?(0,c.localize)(30,null,n):(0,c.localize)(31,null,n):I?(0,c.localize)(32,null,n):(0,c.localize)(33,null,n):n===1?I?(0,c.localize)(34,null,n):(0,c.localize)(35,null,n):I?(0,c.localize)(36,null,n):(0,c.localize)(37,null,n)):w<y?(n=Math.floor(w/k),S?n===1?I?(0,c.localize)(38,null,n):(0,c.localize)(39,null,n):I?(0,c.localize)(40,null,n):(0,c.localize)(41,null,n):n===1?I?(0,c.localize)(42,null,n):(0,c.localize)(43,null,n):I?(0,c.localize)(44,null,n):(0,c.localize)(45,null,n)):(n=Math.floor(w/y),S?n===1?I?(0,c.localize)(46,null,n):(0,c.localize)(47,null,n):I?(0,c.localize)(48,null,n):(0,c.localize)(49,null,n):n===1?I?(0,c.localize)(50,null,n):(0,c.localize)(51,null,n):I?(0,c.localize)(52,null,n):(0,c.localize)(53,null,n))}e.fromNow=p;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[161],Ce([14,15]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,17,10,161]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(T,S){return S&&(T.stack||T.stacktrace)?u.localize(0,null,k(T),P(T.stack)||P(T.stacktrace)):k(T)}function P(T){return Array.isArray(T)?T.join(`
`):T}function k(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?u.localize(1,null,T.message):T.message||u.localize(2,null)}function y(T=null,S=!1){if(!T)return u.localize(3,null);if(Array.isArray(T)){const I=c.coalesce(T),C=y(I[0],S);return I.length>1?u.localize(4,null,C,I.length):C}if(A.isString(T))return T;if(T.detail){const I=T.detail;if(I.error)return R(I.error,S);if(I.exception)return R(I.exception,S)}return T.stack?R(T,S):T.message?T.message:u.localize(5,null)}e.toErrorMessage=y;function p(T){const S=T;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=p;function L(T,S){let I;return typeof T=="string"?I=new Error(T):I=T,I.actions=S,I}e.createErrorWithActions=L}),define(De[162],Ce([14,15]),function(re,e){return re.create("vs/base/common/platform",e)}),define(De[11],Ce([1,0,162]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,u=!1,R=!1,P=!1,k=!1,y=!1,p=!1,L=!1,T=!1,S=!1,I,C=e.LANGUAGE_DEFAULT,w,n;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const f=typeof d?.versions?.electron=="string",v=f&&d?.type==="renderer";if(typeof navigator=="object"&&!v)n=navigator.userAgent,A=n.indexOf("Windows")>=0,u=n.indexOf("Macintosh")>=0,L=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=n.indexOf("Linux")>=0,S=n?.indexOf("Mobi")>=0,y=!0,I=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,C=I;else if(typeof d=="object"){A=d.platform==="win32",u=d.platform==="darwin",R=d.platform==="linux",P=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,p=f,T=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const r=JSON.parse(i),m=r.availableLanguages["*"];I=r.locale,C=m||e.LANGUAGE_DEFAULT,w=r._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let t=0;u?t=1:A?t=3:R&&(t=2),e.isWindows=A,e.isMacintosh=u,e.isLinux=R,e.isLinuxSnap=P,e.isNative=k,e.isElectron=p,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=S,e.isCI=T,e.platform=t,e.userAgent=n,e.language=C;var o;(function(i){function r(){return e.language}i.value=r;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=m;function g(){return e.language==="en"}i.isDefault=g})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let g=0,h=i.length;g<h;g++){const O=i[g];if(O.id===m.data.vscodeScheduleAsyncWork){i.splice(g,1),O.callback();return}}});let r=0;return m=>{const g=++r;i.push({id:g,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return i=>setTimeout(i)})();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=u||L?2:A?1:3;let a=!0,l=!1;function E(){if(!l){l=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=E,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const u=c.globals.vscode.process;A={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(De[12],Ce([1,0,36]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,u=97,R=90,P=122,k=46,y=47,p=92,L=58,T=63;class S extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const E=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${E} ${l} of type ${s}`;i+=`. Received type ${typeof a}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function I(t,o){if(t===null||typeof t!="object")throw new S(o,"Object",t)}function C(t,o){if(typeof t!="string")throw new S(o,"string",t)}const w=c.platform==="win32";function n(t){return t===y||t===p}function d(t){return t===y}function f(t){return t>=A&&t<=R||t>=u&&t<=P}function v(t,o,s,a){let l="",E=0,i=-1,r=0,m=0;for(let g=0;g<=t.length;++g){if(g<t.length)m=t.charCodeAt(g);else{if(a(m))break;m=y}if(a(m)){if(!(i===g-1||r===1))if(r===2){if(l.length<2||E!==2||l.charCodeAt(l.length-1)!==k||l.charCodeAt(l.length-2)!==k){if(l.length>2){const h=l.lastIndexOf(s);h===-1?(l="",E=0):(l=l.slice(0,h),E=l.length-1-l.lastIndexOf(s)),i=g,r=0;continue}else if(l.length!==0){l="",E=0,i=g,r=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",E=2)}else l.length>0?l+=`${s}${t.slice(i+1,g)}`:l=t.slice(i+1,g),E=g-i-1;i=g,r=0}else m===k&&r!==-1?++r:r=-1}return l}function D(t,o){I(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${a}`:`${s}${t}${a}`:a}e.win32={resolve(...t){let o="",s="",a=!1;for(let l=t.length-1;l>=-1;l--){let E;if(l>=0){if(E=t[l],C(E,"path"),E.length===0)continue}else o.length===0?E=c.cwd():(E=c.env[`=${o}`]||c.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==o.toLowerCase()&&E.charCodeAt(2)===p)&&(E=`${o}\\`));const i=E.length;let r=0,m="",g=!1;const h=E.charCodeAt(0);if(i===1)n(h)&&(r=1,g=!0);else if(n(h))if(g=!0,n(E.charCodeAt(1))){let O=2,$=O;for(;O<i&&!n(E.charCodeAt(O));)O++;if(O<i&&O!==$){const x=E.slice($,O);for($=O;O<i&&n(E.charCodeAt(O));)O++;if(O<i&&O!==$){for($=O;O<i&&!n(E.charCodeAt(O));)O++;(O===i||O!==$)&&(m=`\\\\${x}\\${E.slice($,O)}`,r=O)}}}else r=1;else f(h)&&E.charCodeAt(1)===L&&(m=E.slice(0,2),r=2,i>2&&n(E.charCodeAt(2))&&(g=!0,r=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(a){if(o.length>0)break}else if(s=`${E.slice(r)}\\${s}`,a=g,g&&o.length>0)break}return s=v(s,!a,"\\",n),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){C(t,"path");const o=t.length;if(o===0)return".";let s=0,a,l=!1;const E=t.charCodeAt(0);if(o===1)return d(E)?"\\":t;if(n(E))if(l=!0,n(t.charCodeAt(1))){let r=2,m=r;for(;r<o&&!n(t.charCodeAt(r));)r++;if(r<o&&r!==m){const g=t.slice(m,r);for(m=r;r<o&&n(t.charCodeAt(r));)r++;if(r<o&&r!==m){for(m=r;r<o&&!n(t.charCodeAt(r));)r++;if(r===o)return`\\\\${g}\\${t.slice(m)}\\`;r!==m&&(a=`\\\\${g}\\${t.slice(m,r)}`,s=r)}}}else s=1;else f(E)&&t.charCodeAt(1)===L&&(a=t.slice(0,2),s=2,o>2&&n(t.charCodeAt(2))&&(l=!0,s=3));let i=s<o?v(t.slice(s),!l,"\\",n):"";return i.length===0&&!l&&(i="."),i.length>0&&n(t.charCodeAt(o-1))&&(i+="\\"),a===void 0?l?`\\${i}`:i:l?`${a}\\${i}`:`${a}${i}`},isAbsolute(t){C(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return n(s)||o>2&&f(s)&&t.charCodeAt(1)===L&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let E=0;E<t.length;++E){const i=t[E];C(i,"path"),i.length>0&&(o===void 0?o=s=i:o+=`\\${i}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&n(s.charCodeAt(0))){++l;const E=s.length;E>1&&n(s.charCodeAt(1))&&(++l,E>2&&(n(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&n(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o)return"";const s=e.win32.resolve(t),a=e.win32.resolve(o);if(s===a||(t=s.toLowerCase(),o=a.toLowerCase(),t===o))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===p;)l++;let E=t.length;for(;E-1>l&&t.charCodeAt(E-1)===p;)E--;const i=E-l;let r=0;for(;r<o.length&&o.charCodeAt(r)===p;)r++;let m=o.length;for(;m-1>r&&o.charCodeAt(m-1)===p;)m--;const g=m-r,h=i<g?i:g;let O=-1,$=0;for(;$<h;$++){const Y=t.charCodeAt(l+$);if(Y!==o.charCodeAt(r+$))break;Y===p&&(O=$)}if($!==h){if(O===-1)return a}else{if(g>h){if(o.charCodeAt(r+$)===p)return a.slice(r+$+1);if($===2)return a.slice(r+$)}i>h&&(t.charCodeAt(l+$)===p?O=$:$===2&&(O=3)),O===-1&&(O=0)}let x="";for($=l+O+1;$<=E;++$)($===E||t.charCodeAt($)===p)&&(x+=x.length===0?"..":"\\..");return r+=O,x.length>0?`${x}${a.slice(r,m)}`:(a.charCodeAt(r)===p&&++r,a.slice(r,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===p){if(o.charCodeAt(1)===p){const s=o.charCodeAt(2);if(s!==T&&s!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===p)return`\\\\?\\${o}`;return t},dirname(t){C(t,"path");const o=t.length;if(o===0)return".";let s=-1,a=0;const l=t.charCodeAt(0);if(o===1)return n(l)?t:".";if(n(l)){if(s=a=1,n(t.charCodeAt(1))){let r=2,m=r;for(;r<o&&!n(t.charCodeAt(r));)r++;if(r<o&&r!==m){for(m=r;r<o&&n(t.charCodeAt(r));)r++;if(r<o&&r!==m){for(m=r;r<o&&!n(t.charCodeAt(r));)r++;if(r===o)return t;r!==m&&(s=a=r+1)}}}}else f(l)&&t.charCodeAt(1)===L&&(s=o>2&&n(t.charCodeAt(2))?3:2,a=s);let E=-1,i=!0;for(let r=o-1;r>=a;--r)if(n(t.charCodeAt(r))){if(!i){E=r;break}}else i=!1;if(E===-1){if(s===-1)return".";E=s}return t.slice(0,E)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let s=0,a=-1,l=!0,E;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,r=-1;for(E=t.length-1;E>=s;--E){const m=t.charCodeAt(E);if(n(m)){if(!l){s=E+1;break}}else r===-1&&(l=!1,r=E+1),i>=0&&(m===o.charCodeAt(i)?--i===-1&&(a=E):(i=-1,a=r))}return s===a?a=r:a===-1&&(a=t.length),t.slice(s,a)}for(E=t.length-1;E>=s;--E)if(n(t.charCodeAt(E))){if(!l){s=E+1;break}}else a===-1&&(l=!1,a=E+1);return a===-1?"":t.slice(s,a)},extname(t){C(t,"path");let o=0,s=-1,a=0,l=-1,E=!0,i=0;t.length>=2&&t.charCodeAt(1)===L&&f(t.charCodeAt(0))&&(o=a=2);for(let r=t.length-1;r>=o;--r){const m=t.charCodeAt(r);if(n(m)){if(!E){a=r+1;break}continue}l===-1&&(E=!1,l=r+1),m===k?s===-1?s=r:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||l===-1||i===0||i===1&&s===l-1&&s===a+1?"":t.slice(s,l)},format:D.bind(null,"\\"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let a=0,l=t.charCodeAt(0);if(s===1)return n(l)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(n(l)){if(a=1,n(t.charCodeAt(1))){let O=2,$=O;for(;O<s&&!n(t.charCodeAt(O));)O++;if(O<s&&O!==$){for($=O;O<s&&n(t.charCodeAt(O));)O++;if(O<s&&O!==$){for($=O;O<s&&!n(t.charCodeAt(O));)O++;O===s?a=O:O!==$&&(a=O+1)}}}}else if(f(l)&&t.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=t,o;if(a=2,n(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;a=3}}a>0&&(o.root=t.slice(0,a));let E=-1,i=a,r=-1,m=!0,g=t.length-1,h=0;for(;g>=a;--g){if(l=t.charCodeAt(g),n(l)){if(!m){i=g+1;break}continue}r===-1&&(m=!1,r=g+1),l===k?E===-1?E=g:h!==1&&(h=1):E!==-1&&(h=-1)}return r!==-1&&(E===-1||h===0||h===1&&E===r-1&&E===i+1?o.base=o.name=t.slice(i,r):(o.name=t.slice(i,E),o.base=t.slice(i,r),o.ext=t.slice(E,r))),i>0&&i!==a?o.dir=t.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(w){const t=/\\/g;return()=>{const o=c.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let a=t.length-1;a>=-1&&!s;a--){const l=a>=0?t[a]:b();C(l,"path"),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===y)}return o=v(o,!s,"/",d),s?`/${o}`:o.length>0?o:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===y,s=t.charCodeAt(t.length-1)===y;return t=v(t,!o,"/",d),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const a=t[s];C(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,a=t.length,l=a-s,E=1,i=o.length-E,r=l<i?l:i;let m=-1,g=0;for(;g<r;g++){const O=t.charCodeAt(s+g);if(O!==o.charCodeAt(E+g))break;O===y&&(m=g)}if(g===r)if(i>r){if(o.charCodeAt(E+g)===y)return o.slice(E+g+1);if(g===0)return o.slice(E+g)}else l>r&&(t.charCodeAt(s+g)===y?m=g:g===0&&(m=0));let h="";for(g=s+m+1;g<=a;++g)(g===a||t.charCodeAt(g)===y)&&(h+=h.length===0?"..":"/..");return`${h}${o.slice(E+m)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===y;let s=-1,a=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===y){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let s=0,a=-1,l=!0,E;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,r=-1;for(E=t.length-1;E>=0;--E){const m=t.charCodeAt(E);if(m===y){if(!l){s=E+1;break}}else r===-1&&(l=!1,r=E+1),i>=0&&(m===o.charCodeAt(i)?--i===-1&&(a=E):(i=-1,a=r))}return s===a?a=r:a===-1&&(a=t.length),t.slice(s,a)}for(E=t.length-1;E>=0;--E)if(t.charCodeAt(E)===y){if(!l){s=E+1;break}}else a===-1&&(l=!1,a=E+1);return a===-1?"":t.slice(s,a)},extname(t){C(t,"path");let o=-1,s=0,a=-1,l=!0,E=0;for(let i=t.length-1;i>=0;--i){const r=t.charCodeAt(i);if(r===y){if(!l){s=i+1;break}continue}a===-1&&(l=!1,a=i+1),r===k?o===-1?o=i:E!==1&&(E=1):o!==-1&&(E=-1)}return o===-1||a===-1||E===0||E===1&&o===a-1&&o===s+1?"":t.slice(o,a)},format:D.bind(null,"/"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===y;let a;s?(o.root="/",a=1):a=0;let l=-1,E=0,i=-1,r=!0,m=t.length-1,g=0;for(;m>=a;--m){const h=t.charCodeAt(m);if(h===y){if(!r){E=m+1;break}continue}i===-1&&(r=!1,i=m+1),h===k?l===-1?l=m:g!==1&&(g=1):l!==-1&&(g=-1)}if(i!==-1){const h=E===0&&s?1:E;l===-1||g===0||g===1&&l===i-1&&l===E+1?o.base=o.name=t.slice(h,i):(o.name=t.slice(h,l),o.base=t.slice(h,i),o.ext=t.slice(l,i))}return E>0?o.dir=t.slice(0,E-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(De[109],Ce([1,0,65,12]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new c.Lazy(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(r,m,g=!1){const h=r||"",O=m||"",$=u.value.collator.compare(h,O);return u.value.collatorIsNumeric&&$===0&&h!==O?h<O?-1:1:$}e.compareFileNames=k;function y(r,m){const g=R.value.collator;return r=r||"",m=m||"",D(g,r,m)}e.compareFileNamesDefault=y;function p(r,m){const g=R.value.collator;return r=r||"",m=m||"",s(r,m)||D(g,r,m)}e.compareFileNamesUpper=p;function L(r,m){const g=R.value.collator;return r=r||"",m=m||"",o(r,m)||D(g,r,m)}e.compareFileNamesLower=L;function T(r,m){return r=r||"",m=m||"",r===m?0:r<m?-1:1}e.compareFileNamesUnicode=T;function S(r,m){const[g,h]=f(r),[O,$]=f(m);let x=u.value.collator.compare(h,$);if(x===0){if(u.value.collatorIsNumeric&&h!==$)return h<$?-1:1;if(x=u.value.collator.compare(g,O),u.value.collatorIsNumeric&&x===0&&g!==O)return g<O?-1:1}return x}e.compareFileExtensions=S;function I(r,m){r=r||"",m=m||"";const g=v(r),h=v(m),O=R.value.collator,$=P.value.collator;return D($,g,h)||D(O,r,m)}e.compareFileExtensionsDefault=I;function C(r,m){r=r||"",m=m||"";const g=v(r),h=v(m),O=R.value.collator,$=P.value.collator;return D($,g,h)||s(r,m)||D(O,r,m)}e.compareFileExtensionsUpper=C;function w(r,m){r=r||"",m=m||"";const g=v(r),h=v(m),O=R.value.collator,$=P.value.collator;return D($,g,h)||o(r,m)||D(O,r,m)}e.compareFileExtensionsLower=w;function n(r,m){r=r||"",m=m||"";const g=v(r).toLowerCase(),h=v(m).toLowerCase();return g!==h?g<h?-1:1:r!==m?r<m?-1:1:0}e.compareFileExtensionsUnicode=n;const d=/^(.*?)(\.([^.]*))?$/;function f(r,m=!1){const g=r?d.exec(r):[];let h=[g&&g[1]||"",g&&g[3]||""];return m&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function v(r){const m=r?d.exec(r):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function D(r,m,g){const h=r.compare(m,g);return h!==0?h:m.length!==g.length?m.length<g.length?-1:1:0}function b(r){const m=r.charAt(0);return m.toLocaleUpperCase()!==m}function t(r){const m=r.charAt(0);return m.toLocaleLowerCase()!==m}function o(r,m){return b(r)&&t(m)?-1:t(r)&&b(m)?1:0}function s(r,m){return t(r)&&b(m)?-1:b(r)&&t(m)?1:0}function a(r,m,g=!1){return g||(r=r&&r.toLowerCase(),m=m&&m.toLowerCase()),r===m?0:r<m?-1:1}function l(r,m,g=!1){const h=r.split(A.sep),O=m.split(A.sep),$=h.length-1,x=O.length-1;let Y,G;for(let M=0;;M++){if(Y=$===M,G=x===M,Y&&G)return k(h[M],O[M],g);if(Y)return-1;if(G)return 1;const B=a(h[M],O[M],g);if(B!==0)return B}}e.comparePaths=l;function E(r,m,g){const h=r.toLowerCase(),O=m.toLowerCase(),$=i(r,m,g);if($)return $;const x=h.endsWith(g),Y=O.endsWith(g);if(x!==Y)return x?-1:1;const G=k(h,O);return G!==0?G:h.localeCompare(O)}e.compareAnything=E;function i(r,m,g){const h=r.toLowerCase(),O=m.toLowerCase(),$=h.startsWith(g),x=O.startsWith(g);if($!==x)return $?-1:1;if($&&x){if(h.length<O.length)return-1;if(h.length>O.length)return 1}return 0}e.compareByPrefix=i}),define(De[89],Ce([1,0,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const T=(0,c.extname)(L),S=A[T.toLowerCase()];return S!==void 0?S:P(L)}e.getMediaOrTextMime=R;function P(L){const T=(0,c.extname)(L);return u[T.toLowerCase()]}e.getMediaMime=P;function k(L){for(const T in u)if(u[T]===L)return T}e.getExtensionForMimeType=k;const y=/^(.+)\/(.+?)(;.+)?$/;function p(L,T){const S=y.exec(L);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:T?void 0:L}e.normalizeMimeType=p}),define(De[110],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var u;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(u=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...y){const p=y.reduce((S,I)=>(S[I]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(S=>!p[S]).forEach(S=>{for(let I=0;I<L.length;I++)if(S.search(L[I])!==-1){delete k[S];break}})}e.sanitizeProcessEnvironment=R;function P(k){!k||(delete k.DEBUG,c.isMacintosh&&delete k.DYLD_LIBRARY_PATH,c.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=P}),define(De[43],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=c.globals.performance&&typeof c.globals.performance.now=="function";class u{static create(P=!0){return new u(P)}constructor(P){this.a=A&&P,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=u}),define(De[3],Ce([1,0,9,63,6,66,43]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,y=!1;var p;(function(E){E.None=()=>u.Disposable.None;function i(ae){if(y){const{onDidAddListener:me}=ae,ke=C.create();let _=0;ae.onDidAddListener=()=>{++_===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),me?.()}}}function r(ae,me){return M(ae,()=>{},0,void 0,!0,void 0,me)}E.defer=r;function m(ae){return(me,ke=null,_)=>{let le=!1,de;return de=ae(te=>{if(!le)return de?de.dispose():le=!0,me.call(ke,te)},null,_),le&&de.dispose(),de}}E.once=m;function g(ae,me,ke){return G((_,le=null,de)=>ae(te=>_.call(le,me(te)),null,de),ke)}E.map=g;function h(ae,me,ke){return G((_,le=null,de)=>ae(te=>{me(te),_.call(le,te)},null,de),ke)}E.forEach=h;function O(ae,me,ke){return G((_,le=null,de)=>ae(te=>me(te)&&_.call(le,te),null,de),ke)}E.filter=O;function $(ae){return ae}E.signal=$;function x(...ae){return(me,ke=null,_)=>(0,u.combinedDisposable)(...ae.map(le=>le(de=>me.call(ke,de),null,_)))}E.any=x;function Y(ae,me,ke,_){let le=ke;return g(ae,de=>(le=me(le,de),le),_)}E.reduce=Y;function G(ae,me){let ke;const _={onWillAddFirstListener(){ke=ae(le.fire,le)},onDidRemoveLastListener(){ke?.dispose()}};me||i(_);const le=new n(_);return me?.add(le),le.event}function M(ae,me,ke=100,_=!1,le=!1,de,te){let ce,oe,F,z=0,K;const Z={leakWarningThreshold:de,onWillAddFirstListener(){ce=ae(Ee=>{z++,oe=me(oe,Ee),_&&!F&&(fe.fire(oe),oe=void 0),K=()=>{const Ae=oe;oe=void 0,F=void 0,(!_||z>1)&&fe.fire(Ae),z=0},typeof ke=="number"?(clearTimeout(F),F=setTimeout(K,ke)):F===void 0&&(F=0,queueMicrotask(K))})},onWillRemoveListener(){le&&z>0&&K?.()},onDidRemoveLastListener(){K=void 0,ce.dispose()}};te||i(Z);const fe=new n(Z);return te?.add(fe),fe.event}E.debounce=M;function B(ae,me=0,ke){return E.debounce(ae,(_,le)=>_?(_.push(le),_):[le],me,void 0,!0,void 0,ke)}E.accumulate=B;function U(ae,me=(_,le)=>_===le,ke){let _=!0,le;return O(ae,de=>{const te=_||!me(de,le);return _=!1,le=de,te},ke)}E.latch=U;function j(ae,me,ke){return[E.filter(ae,me,ke),E.filter(ae,_=>!me(_),ke)]}E.split=j;function he(ae,me=!1,ke=[]){let _=ke.slice(),le=ae(ce=>{_?_.push(ce):te.fire(ce)});const de=()=>{_?.forEach(ce=>te.fire(ce)),_=null},te=new n({onWillAddFirstListener(){le||(le=ae(ce=>te.fire(ce)))},onDidAddFirstListener(){_&&(me?setTimeout(de):de())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return te.event}E.buffer=he;class ie{constructor(me){this.event=me,this.c=new u.DisposableStore}map(me){return new ie(g(this.event,me,this.c))}forEach(me){return new ie(h(this.event,me,this.c))}filter(me){return new ie(O(this.event,me,this.c))}reduce(me,ke){return new ie(Y(this.event,me,ke,this.c))}latch(){return new ie(U(this.event,void 0,this.c))}debounce(me,ke=100,_=!1,le=!1,de){return new ie(M(this.event,me,ke,_,le,de,this.c))}on(me,ke,_){return this.event(me,ke,_)}once(me,ke,_){return m(this.event)(me,ke,_)}dispose(){this.c.dispose()}}function V(ae){return new ie(ae)}E.chain=V;function J(ae,me,ke=_=>_){const _=(...ce)=>te.fire(ke(...ce)),le=()=>ae.on(me,_),de=()=>ae.removeListener(me,_),te=new n({onWillAddFirstListener:le,onDidRemoveLastListener:de});return te.event}E.fromNodeEventEmitter=J;function ne(ae,me,ke=_=>_){const _=(...ce)=>te.fire(ke(...ce)),le=()=>ae.addEventListener(me,_),de=()=>ae.removeEventListener(me,_),te=new n({onWillAddFirstListener:le,onDidRemoveLastListener:de});return te.event}E.fromDOMEventEmitter=ne;function ve(ae){return new Promise(me=>m(ae)(me))}E.toPromise=ve;function ue(ae,me){return me(void 0),ae(ke=>me(ke))}E.runAndSubscribe=ue;function ee(ae,me){let ke=null;function _(de){ke?.dispose(),ke=new u.DisposableStore,me(de,ke)}_(void 0);const le=ae(de=>_(de));return(0,u.toDisposable)(()=>{le.dispose(),ke?.dispose()})}E.runAndSubscribeWithStore=ee;class N{constructor(me,ke){this.obs=me,this.c=0,this.d=!1;const _={onWillAddFirstListener:()=>{me.addObserver(this)},onDidRemoveLastListener:()=>{me.removeObserver(this)}};ke||i(_),this.emitter=new n(_),ke&&ke.add(this.emitter)}beginUpdate(me){this.c++}handleChange(me,ke){this.d=!0}endUpdate(me){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function q(ae,me){return new N(ae,me).emitter.event}E.fromObservable=q})(p=e.Event||(e.Event={}));class L{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${L.c++}`,L.all.add(this)}start(i){this.d=new P.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let T=-1;function S(E){const i=T;return T=E,{dispose(){T=i}}}e.setGlobalLeakWarningThreshold=S;class I{constructor(i,r=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=r,this.d=0}dispose(){this.c?.clear()}check(i,r){const m=this.threshold;if(m<=0||r<m)return;this.c||(this.c=new Map);const g=this.c.get(i.value)||0;if(this.c.set(i.value,g+1),this.d-=1,this.d<=0){this.d=m*.5;let h,O=0;for(const[$,x]of this.c)(!h||O<x)&&(h=$,O=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${O}):`),console.warn(h)}return()=>{const h=this.c.get(i.value)||0;this.c.set(i.value,h-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(i,r,m){this.callback=i,this.callbackThis=r,this.stack=m,this.subscription=new u.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class n{constructor(i){this.j=!1,this.d=i,this.f=T>0||this.d?.leakWarningThreshold?new I(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const i=Array.from(this.q);queueMicrotask(()=>{for(const r of i)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,r,m)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const g=this.q.isEmpty();g&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let h,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=C.create(),h=this.f.check(O,this.q.size+1)),k&&(O=O??C.create());const $=new w(i,r,O),x=this.q.push($);g&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,r);const Y=$.subscription.set(()=>{h?.(),this.j||(this.d?.onWillRemoveListener?.(this),x(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return m instanceof u.DisposableStore?m.add(Y):Array.isArray(m)&&m.push(Y),Y}),this.l}fire(i){if(this.q){this.m||(this.m=new f(this.d?.onListenerError));for(const r of this.q)this.m.push(this,r,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=n;class d{constructor(i=c.onUnexpectedError){this.d=i,this.c=new R.LinkedList}get size(){return this.c.size}push(i,r,m){this.c.push(new v(i,r,m))}clear(i){const r=new R.LinkedList;for(const m of this.c)m.emitter!==i&&r.push(m);this.c=r}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(r){this.d(r)}}}}e.EventDeliveryQueue=d;class f extends d{clear(i){this.c.clear()}}class v{constructor(i,r,m){this.emitter=i,this.listener=r,this.event=m}}class D extends n{async fireAsync(i,r,m){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const g of this.q)this.c.push([g,i]);for(;this.c.size>0&&!r.isCancellationRequested;){const[g,h]=this.c.shift(),O=[],$={...h,token:r,waitUntil:x=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");m&&(x=m(x,g.callback)),O.push(x)}};try{g.invoke($)}catch(x){(0,c.onUnexpectedError)(x);continue}Object.freeze(O),await Promise.allSettled(O).then(x=>{for(const Y of x)Y.status==="rejected"&&(0,c.onUnexpectedError)(Y.reason)})}}}}e.AsyncEmitter=D;class b extends n{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=b;class t extends b{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=t;class o extends n{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(r=>super.fire(r)),this.c=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const r={event:i,listener:null};this.f.push(r),this.d&&this.j(r);const m=()=>{this.d&&this.k(r);const g=this.f.indexOf(r);this.f.splice(g,1)};return(0,u.toDisposable)((0,A.once)(m))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(r=>this.c.fire(r))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class a{constructor(){this.c=[]}wrapEvent(i){return(r,m,g)=>i(h=>{const O=this.c[this.c.length-1];O?O.push(()=>r.call(m,h)):r.call(m,h)},void 0,g)}bufferEvents(i){const r=[];this.c.push(r);const m=i();return this.c.pop(),r.forEach(g=>g()),m}}e.EventBufferer=a;class l{constructor(){this.c=!1,this.d=p.None,this.f=u.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(De[163],Ce([1,0,3,6,158]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(S,I="",C="",w=!0,n){super(),this.j=this.D(new c.Emitter),this.onDidChange=this.j.event,this.w=!0,this.m=S,this.n=I,this.u=C,this.w=w,this.C=n}get id(){return this.m}get label(){return this.n}set label(S){this.F(S)}F(S){this.n!==S&&(this.n=S,this.j.fire({label:S}))}get tooltip(){return this.q||""}set tooltip(S){this.G(S)}G(S){this.q!==S&&(this.q=S,this.j.fire({tooltip:S}))}get class(){return this.u}set class(S){this.H(S)}H(S){this.u!==S&&(this.u=S,this.j.fire({class:S}))}get enabled(){return this.w}set enabled(S){this.I(S)}I(S){this.w!==S&&(this.w=S,this.j.fire({enabled:S}))}get checked(){return this.z}set checked(S){this.J(S)}J(S){this.z!==S&&(this.z=S,this.j.fire({checked:S}))}async run(S,I){this.C&&await this.C(S)}}e.Action=R;class P extends A.Disposable{constructor(){super(...arguments),this.f=this.D(new c.Emitter),this.onWillRun=this.f.event,this.h=this.D(new c.Emitter),this.onDidRun=this.h.event}async run(S,I){if(!S.enabled)return;this.f.fire({action:S});let C;try{await this.k(S,I)}catch(w){C=w}this.h.fire({action:S,error:C})}async k(S,I){await S.run(I)}}e.ActionRunner=P;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...S){let I=[];for(const C of S)C.length&&(I.length?I=[...I,new k,...C]:I=C);return I}async run(){}}k.ID="vs.actions.separator",e.Separator=k;class y{get actions(){return this.a}constructor(S,I,C,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=S,this.label=I,this.class=w,this.a=C}async run(){}}e.SubmenuAction=y;class p extends R{constructor(){super(p.ID,u.localize(0,null),void 0,!1)}}p.ID="vs.actions.empty",e.EmptySubmenuAction=p;function L(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label}}e.toAction=L}),define(De[21],Ce([1,0,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(k,y){const p=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(p)}}});var u;(function(k){function y(p){return p===k.None||p===k.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(u=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=u.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=u.None}}e.CancellationTokenSource=P}),define(De[164],Ce([1,0,21]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new c.CancellationTokenSource,y=this.b(k.token);return this.a={promise:y,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=A;class u{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const y=JSON.stringify(k);return this.b!==y&&(this.b=y,this.a=this.c(k)),this.a}}e.LRUCachedFunction=u;class R{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const y=this.b(k);return this.a.set(k,y),y}}e.CachedFunction=R}),define(De[8],Ce([1,0,164,65]),function(re,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=R;const P=/{(\d+)}/g;function k(W,...Q){return Q.length===0?W:W.replace(P,function(ge,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=Q.length?ge:Q[Ne]})}e.format=k;const y=/{([^}]+)}/g;function p(W,Q){return W.replace(y,(ge,Le)=>Q[Le]??ge)}e.format2=p;function L(W){return W.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=L;function T(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function S(W,Q){let ge=0;const Le=Q.charCodeAt(0);for(let Ne=W.length-1;Ne>=0;Ne--)W.charCodeAt(Ne)===Le&&ge++;return ge}e.count=S;function I(W,Q,ge="\u2026"){return W.length<=Q?W:`${W.substr(0,Q)}${ge}`}e.truncate=I;function C(W,Q=" "){const ge=w(W,Q);return n(ge,Q)}e.trim=C;function w(W,Q){if(!W||!Q)return W;const ge=Q.length;if(ge===0||W.length===0)return W;let Le=0;for(;W.indexOf(Q,Le)===Le;)Le=Le+ge;return W.substring(Le)}e.ltrim=w;function n(W,Q){if(!W||!Q)return W;const ge=Q.length,Le=W.length;if(ge===0||Le===0)return W;let Ne=Le,je=-1;for(;je=W.lastIndexOf(Q,Ne-1),!(je===-1||je+ge!==Ne);){if(je===0)return"";Ne=je}return W.substring(0,Ne)}e.rtrim=n;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(W){return W.replace(/\*/g,"")}e.stripWildcards=f;function v(W,Q,ge={}){if(!W)throw new Error("Cannot create regex from empty string");Q||(W=T(W)),ge.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Le="";return ge.global&&(Le+="g"),ge.matchCase||(Le+="i"),ge.multiline&&(Le+="m"),ge.unicode&&(Le+="u"),new RegExp(W,Le)}e.createRegExp=v;function D(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function b(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function t(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=t;function o(W){return W.split(/\r\n|\r|\n/)}e.splitLines=o;function s(W){for(let Q=0,ge=W.length;Q<ge;Q++){const Le=W.charCodeAt(Q);if(Le!==32&&Le!==9)return Q}return-1}e.firstNonWhitespaceIndex=s;function a(W,Q=0,ge=W.length){for(let Le=Q;Le<ge;Le++){const Ne=W.charCodeAt(Le);if(Ne!==32&&Ne!==9)return W.substring(Q,Le)}return W.substring(Q,ge)}e.getLeadingWhitespace=a;function l(W,Q=W.length-1){for(let ge=Q;ge>=0;ge--){const Le=W.charCodeAt(ge);if(Le!==32&&Le!==9)return ge}return-1}e.lastNonWhitespaceIndex=l;function E(W,Q,ge){const Le=[];let Ne=0;for(const je of W.matchAll(Q)){if(Le.push(W.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Le.push(ge(je[0],...je.slice(1),je.index,W,je.groups))}return Le.push(W.slice(Ne)),Promise.all(Le).then(je=>je.join(""))}e.replaceAsync=E;function i(W,Q){return W<Q?-1:W>Q?1:0}e.compare=i;function r(W,Q,ge=0,Le=W.length,Ne=0,je=Q.length){for(;ge<Le&&Ne<je;ge++,Ne++){const nt=W.charCodeAt(ge),ot=Q.charCodeAt(Ne);if(nt<ot)return-1;if(nt>ot)return 1}const Ye=Le-ge,Xe=je-Ne;return Ye<Xe?-1:Ye>Xe?1:0}e.compareSubstring=r;function m(W,Q){return g(W,Q,0,W.length,0,Q.length)}e.compareIgnoreCase=m;function g(W,Q,ge=0,Le=W.length,Ne=0,je=Q.length){for(;ge<Le&&Ne<je;ge++,Ne++){let nt=W.charCodeAt(ge),ot=Q.charCodeAt(Ne);if(nt===ot)continue;if(nt>=128||ot>=128)return r(W.toLowerCase(),Q.toLowerCase(),ge,Le,Ne,je);O(nt)&&(nt-=32),O(ot)&&(ot-=32);const pt=nt-ot;if(pt!==0)return pt}const Ye=Le-ge,Xe=je-Ne;return Ye<Xe?-1:Ye>Xe?1:0}e.compareSubstringIgnoreCase=g;function h(W){return W>=48&&W<=57}e.isAsciiDigit=h;function O(W){return W>=97&&W<=122}e.isLowerAsciiLetter=O;function $(W){return W>=65&&W<=90}e.isUpperAsciiLetter=$;function x(W,Q){return W.length===Q.length&&g(W,Q)===0}e.equalsIgnoreCase=x;function Y(W,Q){const ge=Q.length;return Q.length>W.length?!1:g(W,Q,0,ge)===0}e.startsWithIgnoreCase=Y;function G(W,Q){const ge=Math.min(W.length,Q.length);let Le;for(Le=0;Le<ge;Le++)if(W.charCodeAt(Le)!==Q.charCodeAt(Le))return Le;return ge}e.commonPrefixLength=G;function M(W,Q){const ge=Math.min(W.length,Q.length);let Le;const Ne=W.length-1,je=Q.length-1;for(Le=0;Le<ge;Le++)if(W.charCodeAt(Ne-Le)!==Q.charCodeAt(je-Le))return Le;return ge}e.commonSuffixLength=M;function B(W){return 55296<=W&&W<=56319}e.isHighSurrogate=B;function U(W){return 56320<=W&&W<=57343}e.isLowSurrogate=U;function j(W,Q){return(W-55296<<10)+(Q-56320)+65536}e.computeCodePoint=j;function he(W,Q,ge){const Le=W.charCodeAt(ge);if(B(Le)&&ge+1<Q){const Ne=W.charCodeAt(ge+1);if(U(Ne))return j(Le,Ne)}return Le}e.getNextCodePoint=he;function ie(W,Q){const ge=W.charCodeAt(Q-1);if(U(ge)&&Q>1){const Le=W.charCodeAt(Q-2);if(B(Le))return j(Le,ge)}return ge}class V{get offset(){return this.e}constructor(Q,ge=0){this.c=Q,this.d=Q.length,this.e=ge}setOffset(Q){this.e=Q}prevCodePoint(){const Q=ie(this.c,this.e);return this.e-=Q>=65536?2:1,Q}nextCodePoint(){const Q=he(this.c,this.d,this.e);return this.e+=Q>=65536?2:1,Q}eol(){return this.e>=this.d}}e.CodePointIterator=V;class J{get offset(){return this.c.offset}constructor(Q,ge=0){this.c=new V(Q,ge)}nextGraphemeLength(){const Q=$e.getInstance(),ge=this.c,Le=ge.offset;let Ne=Q.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const je=ge.offset,Ye=Q.getGraphemeBreakType(ge.nextCodePoint());if(Pe(Ne,Ye)){ge.setOffset(je);break}Ne=Ye}return ge.offset-Le}prevGraphemeLength(){const Q=$e.getInstance(),ge=this.c,Le=ge.offset;let Ne=Q.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const je=ge.offset,Ye=Q.getGraphemeBreakType(ge.prevCodePoint());if(Pe(Ye,Ne)){ge.setOffset(je);break}Ne=Ye}return Le-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ne(W,Q){return new J(W,Q).nextGraphemeLength()}e.nextCharLength=ne;function ve(W,Q){return new J(W,Q).prevGraphemeLength()}e.prevCharLength=ve;function ue(W,Q){Q>0&&U(W.charCodeAt(Q))&&Q--;const ge=Q+ne(W,Q);return[ge-ve(W,ge),ge]}e.getCharContainingOffset=ue;function ee(W){const Q=new J(W);let ge=0;for(;!Q.eol();)ge++,Q.nextGraphemeLength();return ge}e.charCount=ee;let N;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(W){return N||(N=q()),N.test(W)}e.containsRTL=ae;const me=/^[\t\n\r\x20-\x7E]*$/;function ke(W){return me.test(W)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=_;function le(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=le;function de(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=de;function te(W,Q){if(W.length<Q)return W;const ge=/\b/g;let Le=0;for(;ge.test(W)&&!(W.length-ge.lastIndex<Q);)Le=ge.lastIndex,ge.lastIndex+=1;return W.substring(Le).replace(/^\s/,"")}e.lcut=te;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function oe(W){return W&&(W=W.replace(ce,"")),W}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function z(W){return F(W)?W.substr(1):W}e.stripUTF8BOM=z;function K(W,Q){if(!W||!Q||W.length<Q.length)return!1;const ge=Q.length,Le=W.toLowerCase();let Ne=0,je=-1;for(;Ne<ge;){const Ye=Le.indexOf(Q[Ne],je+1);if(Ye<0)return!1;je=Ye,Ne++}return!0}e.fuzzyContains=K;function Z(W,Q=!1){return W?(Q&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Z;function fe(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=fe;function Ee(W,Q=1){if(Q===0)return"";let ge=-1;do ge=W.indexOf(`
`,ge+1),Q--;while(Q>0&&ge>=0);return ge===-1?W:(W[ge-1]==="\r"&&ge--,W.substr(0,ge))}e.getNLines=Ee;function Ae(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Ae;function we(W){return $e.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=we;function Pe(W,Q){return W===0?Q!==5&&Q!==7:W===2&&Q===3?!1:W===4||W===2||W===3||Q===4||Q===2||Q===3?!0:!(W===8&&(Q===8||Q===9||Q===11||Q===12)||(W===11||W===9)&&(Q===9||Q===10)||(W===12||W===10)&&Q===10||Q===5||Q===13||Q===7||W===1||W===13&&Q===14||W===6&&Q===6)}var Ie;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=xe()}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const ge=this.d,Le=ge.length/3;let Ne=1;for(;Ne<=Le;)if(Q<ge[3*Ne])Ne=2*Ne;else if(Q>ge[3*Ne+1])Ne=2*Ne+1;else return ge[3*Ne+2];return 0}}$e.c=null;function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(W,Q){if(W===0)return 0;const ge=Qe(W,Q);if(ge!==void 0)return ge;const Le=new V(Q,W);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=tt;function Qe(W,Q){const ge=new V(Q,W);let Le=ge.prevCodePoint();for(;it(Le)||Le===65039||Le===8419;){if(ge.offset===0)return;Le=ge.prevCodePoint()}if(!de(Le))return;let Ne=ge.offset;return Ne>0&&ge.prevCodePoint()===8205&&(Ne=ge.offset),Ne}function it(W){return 127995<=W&&W<=127999}var rt;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(Q){return Be.d.get(Array.from(Q))}static getLocales(){return Be.e.value}constructor(Q){this.f=Q}isAmbiguous(Q){return this.f.has(Q)}getPrimaryConfusable(Q){return this.f.get(Q)}getConfusableCodePoints(){return new Set(this.f.keys())}}u=Be,Be.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new c.LRUCachedFunction(W=>{function Q(ot){const pt=new Map;for(let bt=0;bt<ot.length;bt+=2)pt.set(ot[bt],ot[bt+1]);return pt}function ge(ot,pt){const bt=new Map(ot);for(const[St,Pt]of pt)bt.set(St,Pt);return bt}function Le(ot,pt){if(!ot)return pt;const bt=new Map;for(const[St,Pt]of ot)pt.has(St)&&bt.set(St,Pt);return bt}const Ne=u.c.value;let je=W.filter(ot=>!ot.startsWith("_")&&ot in Ne);je.length===0&&(je=["_default"]);let Ye;for(const ot of je){const pt=Q(Ne[ot]);Ye=Le(Ye,pt)}const Xe=Q(Ne._common),nt=ge(Xe,Ye);return new Be(nt)}),Be.e=new A.Lazy(()=>Object.keys(Be.c.value).filter(W=>!W.startsWith("_"))),e.AmbiguousCharacters=Be;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Q){return et.e().has(Q)}static get codePoints(){return et.e()}}et.d=void 0,e.InvisibleCharacters=et}),define(De[33],Ce([1,0,12,11,8,10]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(l){return l===47||l===92}e.isPathSeparator=P;function k(l){return l.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=k;function y(l){return l.indexOf("/")===-1&&(l=k(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function p(l,E=c.posix.sep){if(!l)return"";const i=l.length,r=l.charCodeAt(0);if(P(r)){if(P(l.charCodeAt(1))&&!P(l.charCodeAt(2))){let g=3;const h=g;for(;g<i&&!P(l.charCodeAt(g));g++);if(h!==g&&!P(l.charCodeAt(g+1))){for(g+=1;g<i;g++)if(P(l.charCodeAt(g)))return l.slice(0,g+1).replace(/[\\/]/g,E)}}return E}else if(d(r)&&l.charCodeAt(1)===58)return P(l.charCodeAt(2))?l.slice(0,2)+E:l.slice(0,2);let m=l.indexOf("://");if(m!==-1){for(m+=3;m<i;m++)if(P(l.charCodeAt(m)))return l.slice(0,m+1)}return""}e.getRoot=p;function L(l){if(!A.isWindows||!l||l.length<5)return!1;let E=l.charCodeAt(0);if(E!==92||(E=l.charCodeAt(1),E!==92))return!1;let i=2;const r=i;for(;i<l.length&&(E=l.charCodeAt(i),E!==92);i++);return!(r===i||(E=l.charCodeAt(i+1),isNaN(E)||E===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(l,E=A.isWindows){const i=E?T:S;return!(!l||l.length===0||/^\s+$/.test(l)||(i.lastIndex=0,i.test(l))||E&&I.test(l)||l==="."||l===".."||E&&l[l.length-1]==="."||E&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=C;function w(l,E,i){const r=l===E;return!i||r?r:!l||!E?!1:(0,u.equalsIgnoreCase)(l,E)}e.isEqual=w;function n(l,E,i,r=c.sep){if(l===E)return!0;if(!l||!E||E.length>l.length)return!1;if(i){if(!(0,u.startsWithIgnoreCase)(l,E))return!1;if(E.length===l.length)return!0;let g=E.length;return E.charAt(E.length-1)===r&&g--,l.charAt(g)===r}return E.charAt(E.length-1)!==r&&(E+=r),l.indexOf(E)===0}e.isEqualOrParent=n;function d(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=d;function f(l,E){return A.isWindows&&l.endsWith(":")&&(l+=c.sep),(0,c.isAbsolute)(l)||(l=(0,c.join)(E,l)),l=(0,c.normalize)(l),A.isWindows?(l=(0,u.rtrim)(l,c.sep),l.endsWith(":")&&(l+=c.sep)):(l=(0,u.rtrim)(l,c.sep),l||(l=c.sep)),l}e.sanitizeFilePath=f;function v(l){const E=(0,c.normalize)(l);return A.isWindows?l.length>3?!1:D(E)&&(l.length===2||E.charCodeAt(2)===92):E===c.posix.sep}e.isRootOrDriveLetter=v;function D(l,E=A.isWindows){return E?d(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function b(l){return D(l)?l[0]:void 0}e.getDriveLetter=b;function t(l,E,i){return E.length>l.length?-1:l===E?0:(i&&(l=l.toLowerCase(),E=E.toLowerCase()),l.indexOf(E))}e.indexOfPath=t;function o(l){const E=l.split(":");let i,r,m;for(const g of E){const h=Number(g);(0,R.isNumber)(h)?r===void 0?r=h:m===void 0&&(m=h):i=i?[i,g].join(":"):g}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:r!==void 0?r:void 0,column:m!==void 0?m:r!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(l,E,i=8){let r="";for(let g=0;g<i;g++)r+=s.charAt(Math.floor(Math.random()*s.length));let m;return E?m=`${E}-${r}`:m=r,l?(0,c.join)(l,m):m}e.randomPath=a}),define(De[111],Ce([1,0,28,8]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...oe){return function(F,z){for(let K=0,Z=oe.length;K<Z;K++){const fe=oe[K](F,z);if(fe)return fe}return null}}e.or=u,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(oe,F,z){if(!z||z.length<F.length)return null;let K;return oe?K=A.startsWithIgnoreCase(z,F):K=z.indexOf(F)===0,K?F.length>0?[{start:0,end:F.length}]:[]:null}function P(oe,F){const z=F.toLowerCase().indexOf(oe.toLowerCase());return z===-1?null:[{start:z,end:z+oe.length}]}e.matchesContiguousSubString=P;function k(oe,F){return y(oe.toLowerCase(),F.toLowerCase(),0,0)}e.matchesSubString=k;function y(oe,F,z,K){if(z===oe.length)return[];if(K===F.length)return null;if(oe[z]===F[K]){let Z=null;return(Z=y(oe,F,z+1,K+1))?d({start:K,end:K+1},Z):null}return y(oe,F,z,K+1)}function p(oe){return 97<=oe&&oe<=122}function L(oe){return 65<=oe&&oe<=90}e.isUpper=L;function T(oe){return 48<=oe&&oe<=57}function S(oe){return oe===32||oe===9||oe===10||oe===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>I.add(oe.charCodeAt(0)));function C(oe){return S(oe)||I.has(oe)}function w(oe,F){return oe===F||C(oe)&&C(F)}function n(oe){return p(oe)||L(oe)||T(oe)}function d(oe,F){return F.length===0?F=[oe]:oe.end===F[0].start?F[0].start=oe.start:F.unshift(oe),F}function f(oe,F){for(let z=F;z<oe.length;z++){const K=oe.charCodeAt(z);if(L(K)||T(K)||z>0&&!n(oe.charCodeAt(z-1)))return z}return oe.length}function v(oe,F,z,K){if(z===oe.length)return[];if(K===F.length)return null;if(oe[z]!==F[K].toLowerCase())return null;{let Z=null,fe=K+1;for(Z=v(oe,F,z+1,K+1);!Z&&(fe=f(F,fe))<F.length;)Z=v(oe,F,z+1,fe),fe++;return Z===null?null:d({start:K,end:K+1},Z)}}function D(oe){let F=0,z=0,K=0,Z=0,fe=0;for(let Ie=0;Ie<oe.length;Ie++)fe=oe.charCodeAt(Ie),L(fe)&&F++,p(fe)&&z++,n(fe)&&K++,T(fe)&&Z++;const Ee=F/oe.length,Ae=z/oe.length,we=K/oe.length,Pe=Z/oe.length;return{upperPercent:Ee,lowerPercent:Ae,alphaPercent:we,numericPercent:Pe}}function b(oe){const{upperPercent:F,lowerPercent:z}=oe;return z===0&&F>.6}function t(oe){const{upperPercent:F,lowerPercent:z,alphaPercent:K,numericPercent:Z}=oe;return z>.2&&F<.8&&K>.6&&Z<.2}function o(oe){let F=0,z=0,K=0,Z=0;for(let fe=0;fe<oe.length;fe++)K=oe.charCodeAt(fe),L(K)&&F++,p(K)&&z++,S(K)&&Z++;return(F===0||z===0)&&Z===0?oe.length<=30:F<=5}function s(oe,F){if(!F||(F=F.trim(),F.length===0)||!o(oe)||F.length>60)return null;const z=D(F);if(!t(z)){if(!b(z))return null;F=F.toLowerCase()}let K=null,Z=0;for(oe=oe.toLowerCase();Z<F.length&&(K=v(oe,F,0,Z))===null;)Z=f(F,Z+1);return K}e.matchesCamelCase=s;function a(oe,F,z=!1){if(!F||F.length===0)return null;let K=null,Z=0;for(oe=oe.toLowerCase(),F=F.toLowerCase();Z<F.length&&(K=l(oe,F,0,Z,z))===null;)Z=E(F,Z+1);return K}e.matchesWords=a;function l(oe,F,z,K,Z){if(z===oe.length)return[];if(K===F.length)return null;if(w(oe.charCodeAt(z),F.charCodeAt(K))){let fe=null,Ee=K+1;if(fe=l(oe,F,z+1,K+1,Z),!Z)for(;!fe&&(Ee=E(F,Ee))<F.length;)fe=l(oe,F,z+1,Ee,Z),Ee++;return fe?oe.charCodeAt(z)!==F.charCodeAt(K)?fe:d({start:K,end:K+1},fe):null}else return null}function E(oe,F){for(let z=F;z<oe.length;z++)if(C(oe.charCodeAt(z))||z>0&&C(oe.charCodeAt(z-1)))return z;return oe.length}const i=u(e.matchesPrefix,s,P),r=u(e.matchesPrefix,s,k),m=new c.LRUCache(1e4);function g(oe,F,z=!1){if(typeof oe!="string"||typeof F!="string")return null;let K=m.get(oe);K||(K=new RegExp(A.convertSimple2RegExpPattern(oe),"i"),m.set(oe,K));const Z=K.exec(F);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:z?r(oe,F):i(oe,F)}e.matchesFuzzy=g;function h(oe,F){const z=me(oe,oe.toLowerCase(),0,F,F.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?$(z):null}e.matchesFuzzy2=h;function O(oe,F,z,K,Z,fe){const Ee=Math.min(13,oe.length);for(;z<Ee;z++){const Ae=me(oe,F,z,K,Z,fe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,fe]}e.anyScore=O;function $(oe){if(typeof oe>"u")return[];const F=[],z=oe[1];for(let K=oe.length-1;K>1;K--){const Z=oe[K]+z,fe=F[F.length-1];fe&&fe.end===Z?fe.end=Z+1:F.push({start:Z,end:Z+1})}return F}e.createMatches=$;const x=128;function Y(){const oe=[],F=[];for(let z=0;z<=x;z++)F[z]=0;for(let z=0;z<=x;z++)oe.push(F.slice(0));return oe}function G(oe){const F=[];for(let z=0;z<=oe;z++)F[z]=0;return F}const M=G(2*x),B=G(2*x),U=Y(),j=Y(),he=Y(),ie=!1;function V(oe,F,z,K,Z){function fe(Ae,we,Pe=" "){for(;Ae.length<we;)Ae=Pe+Ae;return Ae}let Ee=` |   |${K.split("").map(Ae=>fe(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=z;Ae++)Ae===0?Ee+=" |":Ee+=`${F[Ae-1]}|`,Ee+=oe[Ae].slice(0,Z+1).map(we=>fe(we.toString(),3)).join("|")+`
`;return Ee}function J(oe,F,z,K){oe=oe.substr(F),z=z.substr(K),console.log(V(j,oe,oe.length,z,z.length)),console.log(V(he,oe,oe.length,z,z.length)),console.log(V(U,oe,oe.length,z,z.length))}function ne(oe,F){if(F<0||F>=oe.length)return!1;const z=oe.codePointAt(F);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(z)}}function ve(oe,F){if(F<0||F>=oe.length)return!1;switch(oe.charCodeAt(F)){case 32:case 9:return!0;default:return!1}}function ue(oe,F,z){return F[oe]!==z[oe]}function ee(oe,F,z,K,Z,fe,Ee=!1){for(;F<z&&Z<fe;)oe[F]===K[Z]&&(Ee&&(M[F]=Z),F+=1),Z+=1;return F===z}e.isPatternInWord=ee;var N;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(N||(N={}));var q;(function(oe){oe.Default=[-100,0];function F(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}oe.isDefault=F})(q=e.FuzzyScore||(e.FuzzyScore={}));class ae{constructor(F,z){this.firstMatchCanBeWeak=F,this.boostFullMatch=z}}ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ae;function me(oe,F,z,K,Z,fe,Ee=ae.default){const Ae=oe.length>x?x:oe.length,we=K.length>x?x:K.length;if(z>=Ae||fe>=we||Ae-z>we-fe||!ee(F,z,Ae,Z,fe,we,!0))return;ke(Ae,we,z,fe,F,Z);let Pe=1,Ie=1,$e=z,xe=fe;const tt=[!1];for(Pe=1,$e=z;$e<Ae;Pe++,$e++){const et=M[$e],W=B[$e],Q=$e+1<Ae?B[$e+1]:we;for(Ie=et-fe+1,xe=et;xe<Q;Ie++,xe++){let ge=Number.MIN_SAFE_INTEGER,Le=!1;xe<=W&&(ge=_(oe,F,$e,z,K,Z,xe,we,fe,U[Pe-1][Ie-1]===0,tt));let Ne=0;ge!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=ge+j[Pe-1][Ie-1]);const je=xe>et,Ye=je?j[Pe][Ie-1]+(U[Pe][Ie-1]>0?-5:0):0,Xe=xe>et+1&&U[Pe][Ie-1]>0,nt=Xe?j[Pe][Ie-2]+(U[Pe][Ie-2]>0?-5:0):0;if(Xe&&(!je||nt>=Ye)&&(!Le||nt>=Ne))j[Pe][Ie]=nt,he[Pe][Ie]=3,U[Pe][Ie]=0;else if(je&&(!Le||Ye>=Ne))j[Pe][Ie]=Ye,he[Pe][Ie]=2,U[Pe][Ie]=0;else if(Le)j[Pe][Ie]=Ne,he[Pe][Ie]=1,U[Pe][Ie]=U[Pe-1][Ie-1]+1;else throw new Error("not possible")}}if(ie&&J(oe,z,K,fe),!tt[0]&&!Ee.firstMatchCanBeWeak)return;Pe--,Ie--;const Qe=[j[Pe][Ie],fe];let it=0,rt=0;for(;Pe>=1;){let et=Ie;do{const W=he[Pe][et];if(W===3)et=et-2;else if(W===2)et=et-1;else break}while(et>=1);it>1&&F[z+Pe-1]===Z[fe+Ie-1]&&!ue(et+fe-1,K,Z)&&it+1>U[Pe][et]&&(et=Ie),et===Ie?it++:it=1,rt||(rt=et),Pe--,Ie=et-1,Qe.push(Ie)}we===Ae&&Ee.boostFullMatch&&(Qe[0]+=2);const Be=rt-Ae;return Qe[0]-=Be,Qe}e.fuzzyScore=me;function ke(oe,F,z,K,Z,fe){let Ee=oe-1,Ae=F-1;for(;Ee>=z&&Ae>=K;)Z[Ee]===fe[Ae]&&(B[Ee]=Ae,Ee--),Ae--}function _(oe,F,z,K,Z,fe,Ee,Ae,we,Pe,Ie){if(F[z]!==fe[Ee])return Number.MIN_SAFE_INTEGER;let $e=1,xe=!1;return Ee===z-K?$e=oe[z]===Z[Ee]?7:5:ue(Ee,Z,fe)&&(Ee===0||!ue(Ee-1,Z,fe))?($e=oe[z]===Z[Ee]?7:5,xe=!0):ne(fe,Ee)&&(Ee===0||!ne(fe,Ee-1))?$e=5:(ne(fe,Ee-1)||ve(fe,Ee-1))&&($e=5,xe=!0),$e>1&&z===K&&(Ie[0]=!0),xe||(xe=ue(Ee,Z,fe)||ne(fe,Ee-1)||ve(fe,Ee-1)),z===K?Ee>we&&($e-=xe?3:5):Pe?$e+=xe?2:0:$e+=xe?0:1,Ee+1===Ae&&($e-=xe?3:5),$e}function le(oe,F,z,K,Z,fe,Ee){return te(oe,F,z,K,Z,fe,!0,Ee)}e.fuzzyScoreGracefulAggressive=le;function de(oe,F,z,K,Z,fe,Ee){return te(oe,F,z,K,Z,fe,!1,Ee)}e.fuzzyScoreGraceful=de;function te(oe,F,z,K,Z,fe,Ee,Ae){let we=me(oe,F,z,K,Z,fe,Ae);if(we&&!Ee)return we;if(oe.length>=3){const Pe=Math.min(7,oe.length-1);for(let Ie=z+1;Ie<Pe;Ie++){const $e=ce(oe,Ie);if($e){const xe=me($e,$e.toLowerCase(),z,K,Z,fe,Ae);xe&&(xe[0]-=3,(!we||xe[0]>we[0])&&(we=xe))}}}return we}function ce(oe,F){if(F+1>=oe.length)return;const z=oe[F],K=oe[F+1];if(z!==K)return oe.slice(0,F)+K+z+oe.slice(F+2)}}),define(De[68],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(d){return u(d,0)}e.hash=A;function u(d,f){switch(typeof d){case"object":return d===null?R(349,f):Array.isArray(d)?y(d,f):p(d,f);case"string":return k(d,f);case"boolean":return P(d,f);case"number":return R(d,f);case"undefined":return R(937,f);default:return R(617,f)}}e.doHash=u;function R(d,f){return(f<<5)-f+d|0}e.numberHash=R;function P(d,f){return R(d?433:863,f)}function k(d,f){f=R(149417,f);for(let v=0,D=d.length;v<D;v++)f=R(d.charCodeAt(v),f);return f}e.stringHash=k;function y(d,f){return f=R(104579,f),d.reduce((v,D)=>u(D,v),f)}function p(d,f){return f=R(181387,f),Object.keys(d).sort().reduce((v,D)=>(v=k(D,v),u(d[D],v)),f)}class L{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=u(f,this.g),this.g}}e.Hasher=L;var T;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function S(d,f,v=32){const D=v-f,b=~((1<<D)-1);return(d<<f|(b&d)>>>D)>>>0}function I(d,f=0,v=d.byteLength,D=0){for(let b=0;b<v;b++)d[f+b]=D}function C(d,f,v="0"){for(;d.length<f;)d=v+d;return d}function w(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(v=>v.toString(16).padStart(2,"0")).join(""):C((d>>>0).toString(16),f/4)}e.toHexString=w;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const v=f.length;if(v===0)return;const D=this.p;let b=this.r,t=this.u,o,s;for(t!==0?(o=t,s=-1,t=0):(o=f.charCodeAt(0),s=0);;){let a=o;if(c.isHighSurrogate(o))if(s+1<v){const l=f.charCodeAt(s+1);c.isLowSurrogate(l)?(s++,a=c.computeCodePoint(o,l)):a=65533}else{t=o;break}else c.isLowSurrogate(o)&&(a=65533);if(b=this.w(D,b,a),s++,s<v)o=f.charCodeAt(s);else break}this.r=b,this.u=t}w(f,v,D){return D<128?f[v++]=D:D<2048?(f[v++]=192|(D&1984)>>>6,f[v++]=128|(D&63)>>>0):D<65536?(f[v++]=224|(D&61440)>>>12,f[v++]=128|(D&4032)>>>6,f[v++]=128|(D&63)>>>0):(f[v++]=240|(D&1835008)>>>18,f[v++]=128|(D&258048)>>>12,f[v++]=128|(D&4032)>>>6,f[v++]=128|(D&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=n.g,v=this.q;for(let i=0;i<64;i+=4)f.setUint32(i,v.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)f.setUint32(i,S(f.getUint32(i-12,!1)^f.getUint32(i-32,!1)^f.getUint32(i-56,!1)^f.getUint32(i-64,!1),1),!1);let D=this.h,b=this.l,t=this.m,o=this.n,s=this.o,a,l,E;for(let i=0;i<80;i++)i<20?(a=b&t|~b&o,l=1518500249):i<40?(a=b^t^o,l=1859775393):i<60?(a=b&t|b&o|t&o,l=2400959708):(a=b^t^o,l=3395469782),E=S(D,5)+a+s+l+f.getUint32(i*4,!1)&4294967295,s=o,o=t,t=S(b,30),b=D,D=E;this.h=this.h+D&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}n.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=n}),define(De[112],Ce([1,0,109,111,68,12,11,8]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,p=[y,[]];function L(U,j,he,ie){if(!U||!j)return p;const V=U.length,J=j.length;if(V<J)return p;const ne=U.toLowerCase();return T(j,he,J,U,ne,V,ie)}e.scoreFuzzy=L;function T(U,j,he,ie,V,J,ne){const ve=[],ue=[];for(let ae=0;ae<he;ae++){const me=ae*J,ke=me-J,_=ae>0,le=U[ae],de=j[ae];for(let te=0;te<J;te++){const ce=te>0,oe=me+te,F=oe-1,z=ke+te-1,K=ce?ve[F]:0,Z=_&&ce?ve[z]:0,fe=_&&ce?ue[z]:0;let Ee;!Z&&_?Ee=0:Ee=S(le,de,ie,V,te,fe),Ee&&Z+Ee>=K&&(ne||_||V.startsWith(j,te))?(ue[oe]=fe+1,ve[oe]=Z+Ee):(ue[oe]=y,ve[oe]=K)}}const ee=[];let N=he-1,q=J-1;for(;N>=0&&q>=0;){const ae=N*J+q;ue[ae]===y||(ee.push(q),N--),q--}return[ve[he*J-1],ee.reverse()]}function S(U,j,he,ie,V,J){let ne=0;if(!I(j,ie[V]))return ne;if(ne+=1,J>0&&(ne+=J*5),U===he[V]&&(ne+=1),V===0)ne+=8;else{const ve=C(he.charCodeAt(V-1));ve?ne+=ve:(0,A.isUpper)(he.charCodeAt(V))&&J===0&&(ne+=2)}return ne}function I(U,j){return U===j?!0:U==="/"||U==="\\"?j==="/"||j==="\\":!1}function C(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function n(U,j,he=0,ie=0){const V=j;return V.values&&V.values.length>1?d(U,V.values,he,ie):f(U,j,he,ie)}e.scoreFuzzy2=n;function d(U,j,he,ie){let V=0;const J=[];for(const ne of j){const[ve,ue]=f(U,ne,he,ie);if(typeof ve!="number")return w;V+=ve,J.push(...ue)}return[V,r(J)]}function f(U,j,he,ie){const V=(0,A.fuzzyScore)(j.original,j.originalLowercase,he,U,U.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,A.createMatches)(V)]:w}const v=Object.freeze({score:0}),D=1<<18,b=1<<17,t=1<<16;function o(U,j,he,ie){const V=ie.values?ie.values:[ie];return(0,u.hash)({[ie.normalized]:{values:V.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:j,allowNonContiguousMatches:he}})}function s(U,j,he,ie,V){if(!U||!j.normalized)return v;const J=ie.getItemLabel(U);if(!J)return v;const ne=ie.getItemDescription(U),ve=o(J,ne,he,j),ue=V[ve];if(ue)return ue;const ee=a(J,ne,ie.getItemPath(U),j,he);return V[ve]=ee,ee}e.scoreItemFuzzy=s;function a(U,j,he,ie,V){const J=!he||!ie.containsPathSeparator;return he&&(P.isLinux?ie.pathNormalized===he:(0,k.equalsIgnoreCase)(ie.pathNormalized,he))?{score:D,labelMatch:[{start:0,end:U.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:ie.values&&ie.values.length>1?l(U,j,he,ie.values,J,V):E(U,j,he,ie,J,V)}function l(U,j,he,ie,V,J){let ne=0;const ve=[],ue=[];for(const ee of ie){const{score:N,labelMatch:q,descriptionMatch:ae}=E(U,j,he,ee,V,J);if(N===y)return v;ne+=N,q&&ve.push(...q),ae&&ue.push(...ae)}return{score:ne,labelMatch:r(ve),descriptionMatch:r(ue)}}function E(U,j,he,ie,V,J){if(V||!j){const[ne,ve]=L(U,ie.normalized,ie.normalizedLowercase,J&&!ie.expectContiguousMatch);if(ne){const ue=(0,A.matchesPrefix)(ie.normalized,U);let ee;return ue?(ee=b,ee+=Math.round(ie.normalized.length/U.length*100)):ee=t,{score:ee+ne,labelMatch:ue||i(ve)}}}if(j){let ne=j;he&&(ne=`${j}${R.sep}`);const ve=ne.length,ue=`${ne}${U}`,[ee,N]=L(ue,ie.normalized,ie.normalizedLowercase,J&&!ie.expectContiguousMatch);if(ee){const q=i(N),ae=[],me=[];return q.forEach(ke=>{ke.start<ve&&ke.end>ve?(ae.push({start:0,end:ke.end-ve}),me.push({start:ke.start,end:ve})):ke.start>=ve?ae.push({start:ke.start-ve,end:ke.end-ve}):me.push(ke)}),{score:ee,labelMatch:ae,descriptionMatch:me}}}return v}function i(U){const j=[];if(!U)return j;let he;for(const ie of U)he&&he.end===ie?he.end+=1:(he={start:ie,end:ie+1},j.push(he));return j}function r(U){const j=U.sort((V,J)=>V.start-J.start),he=[];let ie;for(const V of j)!ie||!m(ie,V)?(ie=V,he.push(V)):(ie.start=Math.min(ie.start,V.start),ie.end=Math.max(ie.end,V.end));return he}function m(U,j){return!(U.end<j.start||j.end<U.start)}function g(U,j,he,ie,V,J){const ne=s(U,he,ie,V,J),ve=s(j,he,ie,V,J),ue=ne.score,ee=ve.score;if((ue===D||ee===D)&&ue!==ee)return ue===D?-1:1;if(ue>t||ee>t){if(ue!==ee)return ue>ee?-1:1;if(ue<b&&ee<b){const le=O(ne.labelMatch,ve.labelMatch);if(le!==0)return le}const ke=V.getItemLabel(U)||"",_=V.getItemLabel(j)||"";if(ke.length!==_.length)return ke.length-_.length}if(ue!==ee)return ue>ee?-1:1;const N=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,q=Array.isArray(ve.labelMatch)&&ve.labelMatch.length>0;if(N&&!q)return-1;if(q&&!N)return 1;const ae=h(U,ne,V),me=h(j,ve,V);return ae&&me&&ae!==me?me>ae?-1:1:$(U,j,he,V)}e.compareItemsByFuzzyScore=g;function h(U,j,he){let ie=-1,V=-1;if(j.descriptionMatch&&j.descriptionMatch.length?ie=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(ie=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(V=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=he.getItemDescription(U);J&&(V+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(V=j.descriptionMatch[j.descriptionMatch.length-1].end);return V-ie}function O(U,j){if(!U&&!j||(!U||!U.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!U||!U.length)return 1;const he=U[0].start,V=U[U.length-1].end-he,J=j[0].start,ve=j[j.length-1].end-J;return V===ve?0:ve<V?1:-1}function $(U,j,he,ie){const V=ie.getItemLabel(U)||"",J=ie.getItemLabel(j)||"",ne=ie.getItemDescription(U),ve=ie.getItemDescription(j),ue=V.length+(ne?ne.length:0),ee=J.length+(ve?ve.length:0);if(ue!==ee)return ue-ee;const N=ie.getItemPath(U),q=ie.getItemPath(j);return N&&q&&N.length!==q.length?N.length-q.length:V!==J?(0,c.compareAnything)(V,J,he.normalized):ne&&ve&&ne!==ve?(0,c.compareAnything)(ne,ve,he.normalized):N&&q&&N!==q?(0,c.compareAnything)(N,q,he.normalized):0}function x(U){return U.startsWith('"')&&U.endsWith('"')}const Y=" ";function G(U){typeof U!="string"&&(U="");const j=U.toLowerCase(),{pathNormalized:he,normalized:ie,normalizedLowercase:V}=M(U),J=he.indexOf(R.sep)>=0,ne=x(U);let ve;const ue=U.split(Y);if(ue.length>1)for(const ee of ue){const N=x(ee),{pathNormalized:q,normalized:ae,normalizedLowercase:me}=M(ee);ae&&(ve||(ve=[]),ve.push({original:ee,originalLowercase:ee.toLowerCase(),pathNormalized:q,normalized:ae,normalizedLowercase:me,expectContiguousMatch:N}))}return{original:U,originalLowercase:j,pathNormalized:he,normalized:ie,normalizedLowercase:V,values:ve,containsPathSeparator:J,expectContiguousMatch:ne}}e.prepareQuery=G;function M(U){let j;P.isWindows?j=U.replace(/\//g,R.sep):j=U.replace(/\\/g,R.sep);const he=(0,k.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:he,normalizedLowercase:he.toLowerCase()}}function B(U){return Array.isArray(U)?G(U.map(j=>j.original).join(Y)):G(U.original)}e.pieceToQuery=B}),define(De[165],Ce([1,0,111,8,52]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",P=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${P.source}`,"g");function y(d){return d.replace(k,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=y;const p=new RegExp(`\\\\${P.source}`,"g");function L(d){return d.replace(p,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(d){return d.indexOf(R)===-1?d:d.replace(T,(f,v,D,b)=>D?f:v||b||"")}e.stripIcons=S;function I(d){return d?d.replace(/\$\((.*?)\)/g,(f,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=I;const C=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(d){C.lastIndex=0;let f="";const v=[];let D=0;for(;;){const b=C.lastIndex,t=C.exec(d),o=d.substring(b,t?.index);if(o.length>0){f+=o;for(let s=0;s<o.length;s++)v.push(D)}if(!t)break;D+=t[0].length}return{text:f,iconOffsets:v}}e.parseLabelWithIcons=w;function n(d,f,v=!1){const{text:D,iconOffsets:b}=f;if(!b||b.length===0)return(0,c.matchesFuzzy)(d,D,v);const t=(0,A.ltrim)(D," "),o=D.length-t.length,s=(0,c.matchesFuzzy)(d,t,v);if(s)for(const a of s){const l=b[a.start+o]+o;a.start+=l,a.end+=l}return s}e.matchesFuzzyIconAware=n}),define(De[37],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(A||(A={})),function(u){const R="error",P="warning",k="warn",y="info",p="ignore";function L(S){return S?c.equalsIgnoreCase(R,S)?u.Error:c.equalsIgnoreCase(P,S)||c.equalsIgnoreCase(k,S)?u.Warning:c.equalsIgnoreCase(y,S)?u.Info:u.Ignore:u.Ignore}u.fromValue=L;function T(S){switch(S){case u.Error:return R;case u.Warning:return P;case u.Info:return y;default:return p}}u.toString=T}(A||(A={})),e.default=A}),define(De[69],Ce([1,0,17,8]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this.b="",this.c=0}reset(I){return this.b=I,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(I){const C=I.charCodeAt(0),w=this.b.charCodeAt(this.c);return C-w}value(){return this.b[this.c]}}e.StringIterator=u;class R{constructor(I=!0){this.e=I}reset(I){return this.b=I,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let I=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(I)this.c++;else break;else I=!1;return this}cmp(I){return this.e?(0,A.compareSubstring)(I,this.b,0,I.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class P{constructor(I=!0,C=!0){this.f=I,this.g=C}reset(I){this.d=0,this.e=0,this.b=I,this.c=I.length;for(let C=I.length-1;C>=0;C--,this.c--){const w=this.b.charCodeAt(C);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let I=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(I)this.d++;else break;else I=!1}return this}cmp(I){return this.g?(0,A.compareSubstring)(I,this.b,0,I.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=P;var k;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(k||(k={}));class y{constructor(I,C){this.f=I,this.g=C,this.d=[],this.e=0}reset(I){return this.c=I,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(I)),this.b.reset(I.path),this.b.value()&&this.d.push(3)),this.g(I)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(I){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(I,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(I,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(I);if(this.d[this.e]===4)return(0,A.compare)(I,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(I,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const I=this.right;return this.right=I.left,I.left=this,this.updateHeight(),I.updateHeight(),I}rotateRight(){const I=this.left;return this.left=I.right,I.right=this,this.updateHeight(),I.updateHeight(),I}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(L||(L={}));class T{static forUris(I=()=>!1,C=()=>!1){return new T(new y(I,C))}static forPaths(I=!1){return new T(new P(void 0,!I))}static forStrings(){return new T(new u)}static forConfigKeys(){return new T(new R)}constructor(I){this.b=I}clear(){this.c=void 0}fill(I,C){if(C){const w=C.slice(0);(0,c.shuffle)(w);for(const n of w)this.set(n,I)}else{const w=I.slice(0);(0,c.shuffle)(w);for(const n of w)this.set(n[0],n[1])}}set(I,C){const w=this.b.reset(I);let n;this.c||(this.c=new p,this.c.segment=w.value());const d=[];for(n=this.c;;){const v=w.cmp(n.segment);if(v>0)n.left||(n.left=new p,n.left.segment=w.value()),d.push([-1,n]),n=n.left;else if(v<0)n.right||(n.right=new p,n.right.segment=w.value()),d.push([1,n]),n=n.right;else if(w.hasNext())w.next(),n.mid||(n.mid=new p,n.mid.segment=w.value()),d.push([0,n]),n=n.mid;else break}const f=n.value;n.value=C,n.key=I;for(let v=d.length-1;v>=0;v--){const D=d[v][1];D.updateHeight();const b=D.balanceFactor();if(b<-1||b>1){const t=d[v][0],o=d[v+1][0];if(t===1&&o===1)d[v][1]=D.rotateLeft();else if(t===-1&&o===-1)d[v][1]=D.rotateRight();else if(t===1&&o===-1)D.right=d[v+1][1]=d[v+1][1].rotateRight(),d[v][1]=D.rotateLeft();else if(t===-1&&o===1)D.left=d[v+1][1]=d[v+1][1].rotateLeft(),d[v][1]=D.rotateRight();else throw new Error;if(v>0)switch(d[v-1][0]){case-1:d[v-1][1].left=d[v][1];break;case 1:d[v-1][1].right=d[v][1];break;case 0:d[v-1][1].mid=d[v][1];break}else this.c=d[0][1]}}return f}get(I){return this.d(I)?.value}d(I){const C=this.b.reset(I);let w=this.c;for(;w;){const n=C.cmp(w.segment);if(n>0)w=w.left;else if(n<0)w=w.right;else if(C.hasNext())C.next(),w=w.mid;else break}return w}has(I){const C=this.d(I);return!(C?.value===void 0&&C?.mid===void 0)}delete(I){return this.e(I,!1)}deleteSuperstr(I){return this.e(I,!0)}e(I,C){const w=this.b.reset(I),n=[];let d=this.c;for(;d;){const f=w.cmp(d.segment);if(f>0)n.push([-1,d]),d=d.left;else if(f<0)n.push([1,d]),d=d.right;else if(w.hasNext())w.next(),n.push([0,d]),d=d.mid;else break}if(!!d){if(C?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this.f(d.right);if(f.key){const{key:v,value:D,segment:b}=f;this.e(f.key,!1),d.key=v,d.value=D,d.segment=b}}else{const f=d.left??d.right;if(n.length>0){const[v,D]=n[n.length-1];switch(v){case-1:D.left=f;break;case 0:D.mid=f;break;case 1:D.right=f;break}}else this.c=f}for(let f=n.length-1;f>=0;f--){const v=n[f][1];v.updateHeight();const D=v.balanceFactor();if(D>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),n[f][1]=v.rotateLeft()):D<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),n[f][1]=v.rotateRight()),f>0)switch(n[f-1][0]){case-1:n[f-1][1].left=n[f][1];break;case 1:n[f-1][1].right=n[f][1];break;case 0:n[f-1][1].mid=n[f][1];break}else this.c=n[0][1]}}}f(I){for(;I.left;)I=I.left;return I}findSubstr(I){const C=this.b.reset(I);let w=this.c,n;for(;w;){const d=C.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(C.hasNext())C.next(),n=w.value||n,w=w.mid;else break}return w&&w.value||n}findSuperstr(I){return this.g(I,!1)}g(I,C){const w=this.b.reset(I);let n=this.c;for(;n;){const d=w.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(w.hasNext())w.next(),n=n.mid;else return n.mid?this.h(n.mid):C?n.value:void 0}}hasElementOrSubtree(I){return this.g(I,!0)!==void 0}forEach(I){for(const[C,w]of this)I(w,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(I){const C=[];return this.j(I,C),C[Symbol.iterator]()}j(I,C){!I||(I.left&&this.j(I.left,C),I.value&&C.push([I.key,I.value]),I.mid&&this.j(I.mid,C),I.right&&this.j(I.right,C))}_isBalanced(){const I=C=>{if(!C)return!0;const w=C.balanceFactor();return w<-1||w>1?!1:I(C.left)&&I(C.right)};return I(this.c)}}e.TernarySearchTree=T}),define(De[2],Ce([1,0,12,11]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,R=/^\//,P=/^\/\//;function k(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!u.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,a){return!s&&!a?"file":s}function p(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==T&&(a=T+a):a=T;break}return a}const L="",T="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(a){return a instanceof I?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,E,i,r,m=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=y(a,m),this.authority=l||L,this.path=p(this.scheme,E||L),this.query=i||L,this.fragment=r||L,k(this,m))}get fsPath(){return v(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:E,path:i,query:r,fragment:m}=a;return l===void 0?l=this.scheme:l===null&&(l=L),E===void 0?E=this.authority:E===null&&(E=L),i===void 0?i=this.path:i===null&&(i=L),r===void 0?r=this.query:r===null&&(r=L),m===void 0?m=this.fragment:m===null&&(m=L),l===this.scheme&&E===this.authority&&i===this.path&&r===this.query&&m===this.fragment?this:new w(l,E,i,r,m)}static parse(a,l=!1){const E=S.exec(a);return E?new w(E[2]||L,o(E[4]||L),o(E[5]||L),o(E[7]||L),o(E[9]||L),l):new w(L,L,L,L,L)}static file(a){let l=L;if(A.isWindows&&(a=a.replace(/\\/g,T)),a[0]===T&&a[1]===T){const E=a.indexOf(T,2);E===-1?(l=a.substring(2),a=T):(l=a.substring(2,E),a=a.substring(E)||T)}return new w("file",l,a,L,L)}static from(a){const l=new w(a.scheme,a.authority,a.path,a.query,a.fragment);return k(l,!0),l}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return A.isWindows&&a.scheme==="file"?E=I.file(c.win32.join(v(a,!0),...l)).path:E=c.posix.join(a.path,...l),a.with({path:E})}toString(a=!1){return D(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof I)return a;{const l=new w(a);return l._formatted=a.external,l._fsPath=a._sep===C?a.fsPath:null,l}}else return a}}e.URI=I;const C=A.isWindows?1:void 0;class w extends I{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(a=!1){return a?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=C),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,a,l){let E,i=-1;for(let r=0;r<s.length;r++){const m=s.charCodeAt(r);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||a&&m===47||l&&m===91||l&&m===93||l&&m===58)i!==-1&&(E+=encodeURIComponent(s.substring(i,r)),i=-1),E!==void 0&&(E+=s.charAt(r));else{E===void 0&&(E=s.substr(0,r));const g=n[m];g!==void 0?(i!==-1&&(E+=encodeURIComponent(s.substring(i,r)),i=-1),E+=g):i===-1&&(i=r)}}return i!==-1&&(E+=encodeURIComponent(s.substring(i))),E!==void 0?E:s}function f(s){let a;for(let l=0;l<s.length;l++){const E=s.charCodeAt(l);E===35||E===63?(a===void 0&&(a=s.substr(0,l)),a+=n[E]):a!==void 0&&(a+=s[l])}return a!==void 0?a:s}function v(s,a){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,A.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=v;function D(s,a){const l=a?f:d;let E="",{scheme:i,authority:r,path:m,query:g,fragment:h}=s;if(i&&(E+=i,E+=":"),(r||i==="file")&&(E+=T,E+=T),r){let O=r.indexOf("@");if(O!==-1){const $=r.substr(0,O);r=r.substr(O+1),O=$.lastIndexOf(":"),O===-1?E+=l($,!1,!1):(E+=l($.substr(0,O),!1,!1),E+=":",E+=l($.substr(O+1),!1,!0)),E+="@"}r=r.toLowerCase(),O=r.lastIndexOf(":"),O===-1?E+=l(r,!1,!0):(E+=l(r.substr(0,O),!1,!0),E+=r.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}E+=l(m,!0,!1)}return g&&(E+="?",E+=l(g,!1,!1)),h&&(E+="#",E+=a?h:d(h,!1,!1)),E}function b(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+b(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(t)?s.replace(t,a=>b(a)):s}}),define(De[70],Ce([1,0,22,8,2]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,k)}e.stringify=R;function P(p){let L=JSON.parse(p);return L=y(L),L}e.parse=P;function k(p,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function y(p,L=0){if(!p||L>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return u.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 16:return new Date(p.source)}if(p instanceof c.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let T=0;T<p.length;++T)p[T]=y(p[T],L+1);else for(const T in p)Object.hasOwnProperty.call(p,T)&&(p[T]=y(p[T],L+1))}return p}e.revive=y}),define(De[18],Ce([1,0,9,11,2]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,T,S){this.a[L]=T,this.b[L]=S}setConnectionToken(L,T){this.c[L]=T}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(n){return c.onUnexpectedError(n),L}const T=L.authority;let S=this.a[T];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const I=this.b[T],C=this.c[T];let w=`path=${encodeURIComponent(L.path)}`;return typeof C=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),u.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${S}:${I}`,path:this.f,query:w})}}e.RemoteAuthorities=new P,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(L){const T=this.b(L,re);return this.uriToBrowserUri(T)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${k.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||k.a,query:null,fragment:null}):L}asFileUri(L){const T=this.b(L,re);return this.uriToFileUri(T)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==k.a?L.authority:null,query:null,fragment:null}):L}b(L,T){return u.URI.isUri(L)?L:u.URI.parse(T.toUrl(L))}}k.a="vscode-app",e.FileAccess=new k;var y;(function(p){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(L.get("3"));const T="vscode-coi";function S(C){let w;typeof C=="string"?w=new URL(C).searchParams:C instanceof URL?w=C.searchParams:u.URI.isUri(C)&&(w=new URL(C.toString(!0)).searchParams);const n=w?.get(T);if(!!n)return L.get(n)}p.getHeadersFromQuery=S;function I(C,w,n){if(!globalThis.crossOriginIsolated)return;const d=w&&n?"3":n?"2":"1";C instanceof URLSearchParams?C.set(T,d):C[T]=d}p.addSearchParam=I})(y=e.COI||(e.COI={}))}),define(De[24],Ce([1,0,33,18,12,11,8,2]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(I){return(0,k.uriToFsPath)(I,!0)}e.originalFSPath=y;class p{constructor(C){this.a=C}compare(C,w,n=!1){return C===w?0:(0,P.compare)(this.getComparisonKey(C,n),this.getComparisonKey(w,n))}isEqual(C,w,n=!1){return C===w?!0:!C||!w?!1:this.getComparisonKey(C,n)===this.getComparisonKey(w,n)}getComparisonKey(C,w=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,w,n=!1){if(C.scheme===w.scheme){if(C.scheme===A.Schemas.file)return c.isEqualOrParent(y(C),y(w),this.a(C))&&C.query===w.query&&(n||C.fragment===w.fragment);if((0,e.isEqualAuthority)(C.authority,w.authority))return c.isEqualOrParent(C.path,w.path,this.a(C),"/")&&C.query===w.query&&(n||C.fragment===w.fragment)}return!1}joinPath(C,...w){return k.URI.joinPath(C,...w)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return u.posix.basename(C.path)}extname(C){return u.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let w;return C.scheme===A.Schemas.file?w=k.URI.file(u.dirname(y(C))).path:(w=u.posix.dirname(C.path),C.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),w="/")),C.with({path:w})}normalizePath(C){if(!C.path.length)return C;let w;return C.scheme===A.Schemas.file?w=k.URI.file(u.normalize(y(C))).path:w=u.posix.normalize(C.path),C.with({path:w})}relativePath(C,w){if(C.scheme!==w.scheme||!(0,e.isEqualAuthority)(C.authority,w.authority))return;if(C.scheme===A.Schemas.file){const f=u.relative(y(C),y(w));return R.isWindows?c.toSlashes(f):f}let n=C.path||"/";const d=w.path||"/";if(this.a(C)){let f=0;for(const v=Math.min(n.length,d.length);f<v&&!(n.charCodeAt(f)!==d.charCodeAt(f)&&n.charAt(f).toLowerCase()!==d.charAt(f).toLowerCase());f++);n=d.substr(0,f)+n.substr(f)}return u.posix.relative(n,d)}resolvePath(C,w){if(C.scheme===A.Schemas.file){const n=k.URI.file(u.resolve(y(C),w));return C.with({authority:n.authority,path:n.path})}return w=c.toPosixPath(w),C.with({path:u.posix.resolve(C.path,w)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,w){return C===w||C!==void 0&&w!==void 0&&(0,P.equalsIgnoreCase)(C,w)}hasTrailingPathSeparator(C,w=u.sep){if(C.scheme===A.Schemas.file){const n=y(C);return n.length>c.getRoot(n).length&&n[n.length-1]===w}else{const n=C.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,w=u.sep){return(0,e.hasTrailingPathSeparator)(C,w)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,w=u.sep){let n=!1;if(C.scheme===A.Schemas.file){const d=y(C);n=d!==void 0&&d.length===c.getRoot(d).length&&d[d.length-1]===w}else{w="/";const d=C.path;n=d.length===1&&d.charCodeAt(d.length-1)===47}return!n&&!(0,e.hasTrailingPathSeparator)(C,w)?C.with({path:C.path+"/"}):C}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(I=>I.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,C){const w=[];for(let n=0;n<I.length;n++){const d=C(I[n]);I.some((f,v)=>v===n?!1:(0,e.isEqualOrParent)(d,C(f)))||w.push(I[n])}return w}e.distinctParents=L;var T;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function C(w){const n=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(v=>{const[D,b]=v.split(":");D&&b&&n.set(D,b)});const f=w.path.substring(0,w.path.indexOf(";"));return f&&n.set(I.META_DATA_MIME,f),n}I.parseMetaData=C})(T=e.DataUri||(e.DataUri={}));function S(I,C,w){if(C){let n=I.path;return n&&n[0]!==u.posix.sep&&(n=u.posix.sep+n),I.with({scheme:w,authority:C,path:n})}return I.with({scheme:w})}e.toLocalResource=S}),define(De[19],Ce([1,0,21,9,3,6,24,11,150]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(ee){return!!ee&&typeof ee.then=="function"}e.isThenable=p;function L(ee){const N=new c.CancellationTokenSource,q=ee(N.token),ae=new Promise((me,ke)=>{const _=N.token.onCancellationRequested(()=>{_.dispose(),N.dispose(),ke(new A.CancellationError)});Promise.resolve(q).then(le=>{_.dispose(),N.dispose(),me(le)},le=>{_.dispose(),N.dispose(),ke(le)})});return new class{cancel(){N.cancel()}then(me,ke){return ae.then(me,ke)}catch(me){return this.then(void 0,me)}finally(me){return ae.finally(me)}}}e.createCancelablePromise=L;function T(ee,N,q){return new Promise((ae,me)=>{const ke=N.onCancellationRequested(()=>{ke.dispose(),ae(q)});ee.then(ae,me).finally(()=>ke.dispose())})}e.raceCancellation=T;function S(ee,N){return new Promise((q,ae)=>{const me=N.onCancellationRequested(()=>{me.dispose(),ae(new A.CancellationError)});ee.then(q,ae).finally(()=>me.dispose())})}e.raceCancellationError=S;async function I(ee){let N=-1;const q=ee.map((me,ke)=>me.then(_=>(N=ke,_))),ae=await Promise.race(q);return ee.forEach((me,ke)=>{ke!==N&&me.cancel()}),ae}e.raceCancellablePromises=I;function C(ee,N,q){let ae;const me=setTimeout(()=>{ae?.(void 0),q?.()},N);return Promise.race([ee.finally(()=>clearTimeout(me)),new Promise(ke=>ae=ke)])}e.raceTimeout=C;function w(ee){return new Promise((N,q)=>{const ae=ee();p(ae)?ae.then(N,q):N(ae)})}e.asPromise=w;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const q=()=>{this.b=null;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(q,q).then(ae)})}return new Promise((q,ae)=>{this.b.then(q,ae)})}return this.a=N(),new Promise((q,ae)=>{this.a.then(me=>{this.a=null,q(me)},me=>{this.a=null,ae(me)})})}}e.Throttler=n;class d{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=d;class f{constructor(){this.a=new Map}queue(N,q){const me=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(N)===me&&this.a.delete(N)});return this.a.set(N,me),me}}e.SequencerByKey=f;const v=(ee,N)=>{let q=!0;const ae=setTimeout(()=>{q=!1,N()},ee);return{isTriggered:()=>q,dispose:()=>{clearTimeout(ae),q=!1}}},D=ee=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,ee())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class b{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,q=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((me,ke)=>{this.d=me,this.f=ke}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=q===y.MicrotaskDelay?D(ae):v(q,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=b;class t{constructor(N){this.a=new b(N),this.b=new n}trigger(N,q){return this.a.trigger(()=>this.b.queue(N),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this.a=!1,this.b=new Promise((N,q)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class s extends o{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function a(ee,N){return N?new Promise((q,ae)=>{const me=setTimeout(()=>{ke.dispose(),q()},ee),ke=N.onCancellationRequested(()=>{clearTimeout(me),ke.dispose(),ae(new A.CancellationError)})}):L(q=>a(ee,q))}e.timeout=a;function l(ee,N=0){const q=setTimeout(ee,N);return(0,R.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=l;function E(ee){const N=[];let q=0;const ae=ee.length;function me(){return q<ae?ee[q++]():null}function ke(_){_!=null&&N.push(_);const le=me();return le?le.then(ke):Promise.resolve(N)}return Promise.resolve(null).then(ke)}e.sequence=E;function i(ee,N=ae=>!!ae,q=null){let ae=0;const me=ee.length,ke=()=>{if(ae>=me)return Promise.resolve(q);const _=ee[ae++];return Promise.resolve(_()).then(de=>N(de)?Promise.resolve(de):ke())};return ke()}e.first=i;function r(ee,N=ae=>!!ae,q=null){if(ee.length===0)return Promise.resolve(q);let ae=ee.length;const me=()=>{ae=-1;for(const ke of ee)ke.cancel?.()};return new Promise((ke,_)=>{for(const le of ee)le.then(de=>{--ae>=0&&N(de)?(me(),ke(de)):ae===0&&ke(q)}).catch(de=>{--ae>=0&&(me(),_(de))})})}e.firstParallel=r;class m{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new u.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((q,ae)=>{this.f.push({factory:N,c:q,e:ae}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const q=N.factory();q.then(N.c,N.e),q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class g extends m{constructor(){super(1)}}e.Queue=g;class h{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new ie;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,q=P.extUri){const ae=q.getComparisonKey(N);let me=this.a.get(ae);return me||(me=new g,u.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(ae),this.f()}),this.a.set(ae,me)),me}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=h;class O{constructor(N,q){this.a=-1,typeof N=="function"&&typeof q=="number"&&this.setIfNotSet(N,q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},q)}setIfNotSet(N,q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},q))}}e.TimeoutTimer=O;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,q){this.cancel(),this.a=setInterval(()=>{N()},q)}}e.IntervalTimer=$;class x{constructor(N,q){this.b=-1,this.a=N,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=x;class Y{constructor(N,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=N,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Y;class G extends x{constructor(N,q){super(N,q),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=G;class M extends R.Disposable{constructor(N,q){super(),this.g=N,this.h=q,this.a=[],this.b=this.D(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of N)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ee=>{(0,k.setTimeout0)(()=>{if(N)return;const q=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(ee,N)=>{const q=requestIdleCallback(ee,typeof N=="number"?{timeout:N}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,cancelIdleCallback(q))}}}}();class B{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(q){this.g=q}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=B;async function U(ee,N,q){let ae;for(let me=0;me<q;me++)try{return await ee()}catch(ke){ae=ke,await a(N)}throw ae}e.retry=U;class j{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,q,ae){return this.a={taskId:N,cancel:()=>ae?.(),promise:q},q.then(()=>this.d(N),()=>this.d(N)),q}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let q,ae;const me=new Promise((ke,_)=>{q=ke,ae=_});this.b={run:N,promise:me,promiseResolve:q,promiseReject:ae}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class he{constructor(N,q=()=>Date.now()){this.d=N,this.f=q,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=he;class ie{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,q)=>{this.a=N,this.b=q})}complete(N){return new Promise(q=>{this.a(N),this.f=!0,q()})}error(N){return new Promise(q=>{this.b(N),this.d=!0,q()})}cancel(){new Promise(N=>{this.b(new A.CancellationError),this.d=!0,N()})}}e.DeferredPromise=ie;var V;(function(ee){async function N(ae){let me;const ke=await Promise.all(ae.map(_=>_.then(le=>le,le=>{me||(me=le)})));if(typeof me<"u")throw me;return ke}ee.settled=N;function q(ae){return new Promise(async(me,ke)=>{try{await ae(me,ke)}catch(_){ke(_)}})}ee.withAsyncBody=q})(V=e.Promises||(e.Promises={}));var J;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(J||(J={}));class ne{static fromArray(N){return new ne(q=>{q.emitMany(N)})}static fromPromise(N){return new ne(async q=>{q.emitMany(await N)})}static fromPromises(N){return new ne(async q=>{await Promise.all(N.map(async ae=>q.emitOne(await ae)))})}static merge(N){return new ne(async q=>{await Promise.all(N.map(async ae=>{for await(const me of ae)q.emitOne(me)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new u.Emitter,queueMicrotask(async()=>{const q={emitOne:ae=>this.g(ae),emitMany:ae=>this.h(ae),reject:ae=>this.k(ae)};try{await Promise.resolve(N(q)),this.j()}catch(ae){this.k(ae)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await u.Event.toPromise(this.f.event)}while(!0)}}}static map(N,q){return new ne(async ae=>{for await(const me of N)ae.emitOne(q(me))})}map(N){return ne.map(this,N)}static filter(N,q){return new ne(async ae=>{for await(const me of N)q(me)&&ae.emitOne(me)})}filter(N){return ne.filter(this,N)}static coalesce(N){return ne.filter(N,q=>!!q)}coalesce(){return ne.coalesce(this)}static async toPromise(N){const q=[];for await(const ae of N)q.push(ae);return q}toPromise(){return ne.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}ne.EMPTY=ne.fromArray([]),e.AsyncIterableObject=ne;class ve extends ne{constructor(N,q){super(q),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ve;function ue(ee){const N=new c.CancellationTokenSource,q=ee(N.token);return new ve(N,async ae=>{const me=N.token.onCancellationRequested(()=>{me.dispose(),N.dispose(),ae.reject(new A.CancellationError)});try{for await(const ke of q){if(N.token.isCancellationRequested)return;ae.emitOne(ke)}me.dispose(),N.dispose()}catch(ke){me.dispose(),N.dispose(),ae.reject(ke)}})}e.createCancelableAsyncIterable=ue}),define(De[38],Ce([1,0,17,19,33,28,12,11,8]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",T="[^/\\\\]",S=/\//g;function I(he,ie){switch(he){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}${ie?`|${L}${T}+`:""})*?`}}function C(he,ie){if(!he)return[];const V=[];let J=!1,ne=!1,ve="";for(const ue of he){switch(ue){case ie:if(!J&&!ne){V.push(ve),ve="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ve+=ue}return ve&&V.push(ve),V}e.splitGlobAware=C;function w(he){if(!he)return"";let ie="";const V=C(he,e.GLOB_SPLIT);if(V.every(J=>J===e.GLOBSTAR))ie=".*";else{let J=!1;V.forEach((ne,ve)=>{if(ne===e.GLOBSTAR){if(J)return;ie+=I(2,ve===V.length-1)}else{let ue=!1,ee="",N=!1,q="";for(const ae of ne){if(ae!=="}"&&ue){ee+=ae;continue}if(N&&(ae!=="]"||!q)){let me;ae==="-"?me=ae:(ae==="^"||ae==="!")&&!q?me="^":ae===e.GLOB_SPLIT?me="":me=(0,y.escapeRegExpCharacters)(ae),q+=me;continue}switch(ae){case"{":ue=!0;continue;case"[":N=!0;continue;case"}":{ie+=`(?:${C(ee,",").map(_=>w(_)).join("|")})`,ue=!1,ee="";break}case"]":{ie+="["+q+"]",N=!1,q="";break}case"?":ie+=T;continue;case"*":ie+=I(1);continue;default:ie+=(0,y.escapeRegExpCharacters)(ae)}}ve<V.length-1&&(V[ve+1]!==e.GLOBSTAR||ve+2<V.length)&&(ie+=L)}J=ne===e.GLOBSTAR})}return ie}const n=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),o=function(){return!1},s=function(){return null};function a(he,ie){if(!he)return s;let V;typeof he!="string"?V=he.pattern:V=he,V=V.trim();const J=`${V}_${!!ie.trimForExclusions}`;let ne=t.get(J);if(ne)return l(ne,he);let ve;return n.test(V)?ne=i(V.substr(4),V):(ve=d.exec(E(V,ie)))?ne=r(ve[1],V):(ie.trimForExclusions?v:f).test(V)?ne=m(V,ie):(ve=D.exec(E(V,ie)))?ne=g(ve[1].substr(1),V,!0):(ve=b.exec(E(V,ie)))?ne=g(ve[1],V,!1):ne=h(V),t.set(J,ne),l(ne,he)}function l(he,ie){if(typeof ie=="string")return he;const V=function(J,ne){return(0,u.isEqualOrParent)(J,ie.base,!k.isLinux)?he((0,y.ltrim)(J.substr(ie.base.length),P.sep),ne):null};return V.allBasenames=he.allBasenames,V.allPaths=he.allPaths,V.basenames=he.basenames,V.patterns=he.patterns,V}function E(he,ie){return ie.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function i(he,ie){return function(V,J){return typeof V=="string"&&V.endsWith(he)?ie:null}}function r(he,ie){const V=`/${he}`,J=`\\${he}`,ne=function(ue,ee){return typeof ue!="string"?null:ee?ee===he?ie:null:ue===he||ue.endsWith(V)||ue.endsWith(J)?ie:null},ve=[he];return ne.basenames=ve,ne.patterns=[ie],ne.allBasenames=ve,ne}function m(he,ie){const V=U(he.slice(1,-1).split(",").map(ee=>a(ee,ie)).filter(ee=>ee!==s),he),J=V.length;if(!J)return s;if(J===1)return V[0];const ne=function(ee,N){for(let q=0,ae=V.length;q<ae;q++)if(V[q](ee,N))return he;return null},ve=V.find(ee=>!!ee.allBasenames);ve&&(ne.allBasenames=ve.allBasenames);const ue=V.reduce((ee,N)=>N.allPaths?ee.concat(N.allPaths):ee,[]);return ue.length&&(ne.allPaths=ue),ne}function g(he,ie,V){const J=P.sep===P.posix.sep,ne=J?he:he.replace(S,P.sep),ve=P.sep+ne,ue=P.posix.sep+he;let ee;return V?ee=function(N,q){return typeof N=="string"&&(N===ne||N.endsWith(ve)||!J&&(N===he||N.endsWith(ue)))?ie:null}:ee=function(N,q){return typeof N=="string"&&(N===ne||!J&&N===he)?ie:null},ee.allPaths=[(V?"*/":"./")+he],ee}function h(he){try{const ie=new RegExp(`^${w(he)}$`);return function(V){return ie.lastIndex=0,typeof V=="string"&&ie.test(V)?he:null}}catch{return s}}function O(he,ie,V){return!he||typeof ie!="string"?!1:$(he)(ie,void 0,V)}e.match=O;function $(he,ie={}){if(!he)return o;if(typeof he=="string"||x(he)){const V=a(he,ie);if(V===s)return o;const J=function(ne,ve){return!!V(ne,ve)};return V.allBasenames&&(J.allBasenames=V.allBasenames),V.allPaths&&(J.allPaths=V.allPaths),J}return M(he,ie)}e.parse=$;function x(he){const ie=he;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=x;function Y(he){return he.allBasenames||[]}e.getBasenameTerms=Y;function G(he){return he.allPaths||[]}e.getPathTerms=G;function M(he,ie){const V=U(Object.getOwnPropertyNames(he).map(ee=>B(ee,he[ee],ie)).filter(ee=>ee!==s)),J=V.length;if(!J)return s;if(!V.some(ee=>!!ee.requiresSiblings)){if(J===1)return V[0];const ee=function(ae,me){let ke;for(let _=0,le=V.length;_<le;_++){const de=V[_](ae,me);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(ke||(ke=[]),ke.push(de))}return ke?(async()=>{for(const _ of ke){const le=await _;if(typeof le=="string")return le}return null})():null},N=V.find(ae=>!!ae.allBasenames);N&&(ee.allBasenames=N.allBasenames);const q=V.reduce((ae,me)=>me.allPaths?ae.concat(me.allPaths):ae,[]);return q.length&&(ee.allPaths=q),ee}const ne=function(ee,N,q){let ae,me;for(let ke=0,_=V.length;ke<_;ke++){const le=V[ke];le.requiresSiblings&&q&&(N||(N=(0,P.basename)(ee)),ae||(ae=N.substr(0,N.length-(0,P.extname)(ee).length)));const de=le(ee,N,ae,q);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(me||(me=[]),me.push(de))}return me?(async()=>{for(const ke of me){const _=await ke;if(typeof _=="string")return _}return null})():null},ve=V.find(ee=>!!ee.allBasenames);ve&&(ne.allBasenames=ve.allBasenames);const ue=V.reduce((ee,N)=>N.allPaths?ee.concat(N.allPaths):ee,[]);return ue.length&&(ne.allPaths=ue),ne}function B(he,ie,V){if(ie===!1)return s;const J=a(he,V);if(J===s)return s;if(typeof ie=="boolean")return J;if(ie){const ne=ie.when;if(typeof ne=="string"){const ve=(ue,ee,N,q)=>{if(!q||!J(ue,ee))return null;const ae=ne.replace("$(basename)",()=>N),me=q(ae);return(0,A.isThenable)(me)?me.then(ke=>ke?he:null):me?he:null};return ve.requiresSiblings=!0,ve}}return J}function U(he,ie){const V=he.filter(ee=>!!ee.basenames);if(V.length<2)return he;const J=V.reduce((ee,N)=>{const q=N.basenames;return q?ee.concat(q):ee},[]);let ne;if(ie){ne=[];for(let ee=0,N=J.length;ee<N;ee++)ne.push(ie)}else ne=V.reduce((ee,N)=>{const q=N.patterns;return q?ee.concat(q):ee},[]);const ve=function(ee,N){if(typeof ee!="string")return null;if(!N){let ae;for(ae=ee.length;ae>0;ae--){const me=ee.charCodeAt(ae-1);if(me===47||me===92)break}N=ee.substr(ae)}const q=J.indexOf(N);return q!==-1?ne[q]:null};ve.basenames=J,ve.patterns=ne,ve.allBasenames=J;const ue=he.filter(ee=>!ee.basenames);return ue.push(ve),ue}function j(he,ie){return(0,c.equals)(he,ie,(V,J)=>typeof V=="string"&&typeof J=="string"?V===J:typeof V!="string"&&typeof J!="string"?V.base===J.base&&V.pattern===J.pattern:!1)}e.patternsEquals=j}),define(De[113],Ce([1,0,9,165,24,8,2]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",f=!1){if(this.value=d,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(d,f=0){return this.value+=S(this.supportThemeIcons?(0,A.escapeIcons)(d):d).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,f){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}appendLink(d,f,v){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(d),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(d,f){const v=new RegExp((0,R.escapeRegExpCharacters)(f),"g");return d.replace(v,(D,b)=>d.charAt(b-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=y;function p(n){return L(n)?!n.value:Array.isArray(n)?n.every(p):!0}e.isEmptyMarkdownString=p;function L(n){return n instanceof y?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function T(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons&&n.supportHtml===d.supportHtml&&(n.baseUri===d.baseUri||!!n.baseUri&&!!d.baseUri&&(0,u.isEqual)(P.URI.from(n.baseUri),P.URI.from(d.baseUri)))}e.markdownStringEqual=T;function S(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function I(n){return n.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function C(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function w(n){const d=[],f=n.split("|").map(D=>D.trim());n=f[0];const v=f[1];if(v){const D=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),t=D?D[1]:"",o=b?b[1]:"",s=isFinite(parseInt(o)),a=isFinite(parseInt(t));s&&d.push(`width="${o}"`),a&&d.push(`height="${t}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=w}),define(De[114],Ce([1,0,17,33,12,11,24,8]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(s,a){const{os:l,tildify:E,relative:i}=a;if(i){const g=p(s,i,l);if(typeof g=="string")return g}let r=s.fsPath;if(l===1&&!R.isWindows?r=r.replace(/\//g,"\\"):l!==1&&R.isWindows&&(r=r.replace(/\\/g,"/")),l!==1&&E?.userHome){const g=E.userHome.fsPath;let h;s.scheme!==E.userHome.scheme&&s.path.startsWith(u.posix.sep)?h=E.userHome.with({path:s.path}).fsPath:h=s.fsPath,r=S(h,g,l)}return(l===1?u.win32:u.posix).normalize(L(r,l===1))}e.getPathLabel=y;function p(s,a,l){const E=l===1?u.win32:u.posix,i=l===3?P.extUri:P.extUriIgnorePathCase,r=a.getWorkspace(),m=(0,c.firstOrDefault)(r.folders);if(!m)return;s.scheme!==m.uri.scheme&&s.path.startsWith(u.posix.sep)&&(s=m.uri.with({path:s.path}));const g=a.getWorkspaceFolder(s);if(!g)return;let h;if(i.isEqual(g.uri,s)?h="":h=i.relativePath(g.uri,s)??"",h&&(h=E.normalize(h)),r.folders.length>1&&!a.noPrefix){const O=g.name?g.name:i.basenameOrAuthority(g.uri);h=h?`${O} \u2022 ${h}`:O}return h}function L(s,a=R.isWindows){return(0,A.hasDriveLetter)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let T=Object.create(null);function S(s,a,l=R.OS){if(l===1||!s||!a)return s;let E=T.original===a?T.normalized:void 0;E||(E=a,R.isWindows&&(E=(0,A.toSlashes)(E)),E=`${(0,k.rtrim)(E,u.posix.sep)}${u.posix.sep}`,T={original:a,normalized:E});let i=s;return R.isWindows&&(i=(0,A.toSlashes)(i)),(l===3?i.startsWith(E):(0,k.startsWithIgnoreCase)(i,E))?`~/${i.substr(E.length)}`:s}e.tildify=S;function I(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=I;const C="\u2026",w="\\\\",n="~";function d(s,a=u.sep){const l=new Array(s.length);let E=!1;for(let i=0;i<s.length;i++){const r=s[i];if(r===""){l[i]=`.${a}`;continue}if(!r){l[i]=r;continue}E=!0;let m="",g=r;g.indexOf(w)===0?(m=g.substr(0,g.indexOf(w)+w.length),g=g.substr(g.indexOf(w)+w.length)):g.indexOf(a)===0?(m=g.substr(0,g.indexOf(a)+a.length),g=g.substr(g.indexOf(a)+a.length)):g.indexOf(n)===0&&(m=g.substr(0,g.indexOf(n)+n.length),g=g.substr(g.indexOf(n)+n.length));const h=g.split(a);for(let O=1;E&&O<=h.length;O++)for(let $=h.length-O;E&&$>=0;$--){E=!1;let x=h.slice($,$+O).join(a);for(let Y=0;!E&&Y<s.length;Y++)if(Y!==i&&s[Y]&&s[Y].indexOf(x)>-1){const G=$+O===h.length,M=$>0&&s[Y].indexOf(a)>-1?a+x:x,B=s[Y].endsWith(M);E=!G||B}if(!E){let Y="";(h[0].endsWith(":")||m!=="")&&($===1&&($=0,O++,x=h[0]+a+x),$>0&&(Y=h[0]+a),Y=m+Y),$>0&&(Y=Y+C+a),Y=Y+x,$+O<h.length&&(Y=Y+a+C),l[i]=Y}}E&&(l[i]=r)}return l}e.shorten=d;var f;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function v(s,a=Object.create(null)){const l=[];let E=!1,i="";for(const r of s)if(r==="$"||E&&r==="{")i&&l.push({value:i,type:f.TEXT}),i="",E=!0;else if(r==="}"&&E){const m=a[i];if(typeof m=="string")m.length&&l.push({value:m,type:f.VARIABLE});else if(m){const g=l[l.length-1];(!g||g.type!==f.SEPARATOR)&&l.push({value:m.label,type:f.SEPARATOR})}i="",E=!1}else i+=r;return i&&!E&&l.push({value:i,type:f.TEXT}),l.filter((r,m)=>{if(r.type===f.SEPARATOR){const g=l[m-1],h=l[m+1];return[g,h].every(O=>O&&(O.type===f.VARIABLE||O.type===f.TEXT)&&O.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=v;function D(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function b(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function t(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(s){const a=s.indexOf("/")!==-1?u.posix:u.win32,l=a.basename(s),E=a.dirname(s);return l.length?{name:l,parentPath:E}:{name:E,parentPath:""}}e.splitName=o}),define(De[115],Ce([1,0,22,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(T){return T.toJSON()}class R{constructor(S){this.a=S}transformIncoming(S){const I=this.a.transformIncoming(S);return I===S?S:u(A.URI.from(I))}transformOutgoing(S){const I=this.a.transformOutgoing(S);return I===S?S:u(A.URI.from(I))}transformOutgoingURI(S){const I=this.a.transformOutgoing(S);return I===S?S:A.URI.from(I)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,S,I){if(!T||I>200)return null;if(typeof T=="object"){if(T instanceof A.URI)return S.transformOutgoing(T);for(const C in T)if(Object.hasOwnProperty.call(T,C)){const w=P(T[C],S,I+1);w!==null&&(T[C]=w)}}return null}function k(T,S){const I=P(T,S,0);return I===null?T:I}e.transformOutgoingURIs=k;function y(T,S,I,C){if(!T||C>200)return null;if(typeof T=="object"){if(T.$mid===1)return I?A.URI.revive(S.transformIncoming(T)):S.transformIncoming(T);if(T instanceof c.VSBuffer)return null;for(const w in T)if(Object.hasOwnProperty.call(T,w)){const n=y(T[w],S,I,C+1);n!==null&&(T[w]=n)}}return null}function p(T,S){const I=y(T,S,!1,0);return I===null?T:I}e.transformIncomingURIs=p;function L(T,S){const I=y(T,S,!0,0);return I===null?T:I}e.transformAndReviveIncomingURIs=L}),define(De[29],Ce([1,0,71,72,324,19,33,88,12,11,24,2]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function I(M,B=S.UNLINK){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===S.UNLINK?w(M):C(M)}async function C(M){try{const B=(0,P.randomPath)((0,A.tmpdir)());try{await c.promises.rename(M,B)}catch(U){return U.code==="ENOENT"?void 0:w(M)}w(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function w(M){return(0,u.promisify)(c.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function n(M){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function d(M,B){return D(await(B?f(M):(0,u.promisify)(c.readdir)(M)))}async function f(M){try{return await(0,u.promisify)(c.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const B=[],U=await d(M);for(const j of U){let he=!1,ie=!1,V=!1;try{const J=await e.Promises.lstat((0,y.join)(M,j));he=J.isFile(),ie=J.isDirectory(),V=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}B.push({name:j,isFile:()=>he,isDirectory:()=>ie,isSymbolicLink:()=>V})}return B}function v(M){return D(c.readdirSync(M))}e.readdirSync=v;function D(M){return M.map(B=>typeof B=="string"?p.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=p.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function b(M){const B=await d(M),U=[];for(const j of B)await o.existsDirectory((0,y.join)(M,j))&&U.push(j);return U}function t(M,B=1e3){return new Promise(U=>{let j=!1;const he=setInterval(()=>{j||(j=!0,c.access(M,ie=>{j=!1,ie&&(clearInterval(he),U(void 0))}))},B)})}e.whenDeleted=t;var o;(function(M){async function B(he){let ie;try{if(ie=await e.Promises.lstat(he),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(he),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(p.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(he)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw J}throw V}}M.stat=B;async function U(he){try{const{stat:ie,symbolicLink:V}=await M.stat(he);return ie.isFile()&&V?.dangling!==!0}catch{}return!1}M.existsFile=U;async function j(he){try{const{stat:ie,symbolicLink:V}=await M.stat(he);return ie.isDirectory()&&V?.dangling!==!0}catch{}return!1}M.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function a(M,B,U){return s.queueFor(T.URI.file(M),L.extUriBiasedIgnorePathCase).queue(()=>{const j=m(U);return new Promise((he,ie)=>i(M,B,j,V=>V?ie(V):he()))})}let l=!0;function E(M){l=M}e.configureFlushOnWrite=E;function i(M,B,U,j){if(!l)return c.writeFile(M,B,{mode:U.mode,flag:U.flag},j);c.open(M,U.flag,U.mode,(he,ie)=>{if(he)return j(he);c.writeFile(ie,B,V=>{if(V)return c.close(ie,()=>j(V));c.fdatasync(ie,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),E(!1)),c.close(ie,ne=>j(ne))))})})}function r(M,B,U){const j=m(U);if(!l)return c.writeFileSync(M,B,{mode:j.mode,flag:j.flag});const he=c.openSync(M,j.flag,j.mode);try{c.writeFileSync(he,B);try{c.fdatasyncSync(he)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),E(!1)}}finally{c.closeSync(he)}}e.writeFileSync=r;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function g(M,B){if(M!==B)try{await e.Promises.rename(M,B)}catch(U){if(M.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await h(M,B,{preserveSymlinks:!1}),await I(M,S.MOVE);else throw U}}async function h(M,B,U){return $(M,B,{root:{source:M,target:B},options:U,handledSourcePaths:new Set})}const O=511;async function $(M,B,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:j,symbolicLink:he}=await o.stat(M);if(he){if(U.options.preserveSymlinks)try{return await G(M,B,U)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(he.dangling)return}return j.isDirectory()?x(M,B,j.mode&O,U):Y(M,B,j.mode&O)}async function x(M,B,U,j){await e.Promises.mkdir(B,{recursive:!0,mode:U});const he=await d(M);for(const ie of he)await $((0,y.join)(M,ie),(0,y.join)(B,ie),j)}async function Y(M,B,U){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,U)}async function G(M,B,U){let j=await e.Promises.readlink(M);(0,P.isEqualOrParent)(j,U.root.source,!p.isLinux)&&(j=(0,y.join)(U.root.target,j.substr(U.root.source.length+1))),await e.Promises.symlink(j,B)}e.Promises=new class{get access(){return(0,u.promisify)(c.access)}get stat(){return(0,u.promisify)(c.stat)}get lstat(){return(0,u.promisify)(c.lstat)}get utimes(){return(0,u.promisify)(c.utimes)}get read(){return(M,B,U,j,he)=>new Promise((ie,V)=>{c.read(M,B,U,j,he,(J,ne,ve)=>J?V(J):ie({bytesRead:ne,buffer:ve}))})}get readFile(){return(0,u.promisify)(c.readFile)}get write(){return(M,B,U,j,he)=>new Promise((ie,V)=>{c.write(M,B,U,j,he,(J,ne,ve)=>J?V(J):ie({bytesWritten:ne,buffer:ve}))})}get appendFile(){return(0,u.promisify)(c.appendFile)}get fdatasync(){return(0,u.promisify)(c.fdatasync)}get truncate(){return(0,u.promisify)(c.truncate)}get rename(){return(0,u.promisify)(c.rename)}get copyFile(){return(0,u.promisify)(c.copyFile)}get open(){return(0,u.promisify)(c.open)}get close(){return(0,u.promisify)(c.close)}get symlink(){return(0,u.promisify)(c.symlink)}get readlink(){return(0,u.promisify)(c.readlink)}get chmod(){return(0,u.promisify)(c.chmod)}get mkdir(){return(0,u.promisify)(c.mkdir)}get unlink(){return(0,u.promisify)(c.unlink)}get rmdir(){return(0,u.promisify)(c.rmdir)}get realpath(){return(0,u.promisify)(c.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return b}get writeFile(){return a}get rm(){return I}get move(){return g}get copy(){return h}}}),define(De[116],Ce([1,0,71,12,11,8,29]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(S){if(u.isLinux)return S;const I=(0,A.dirname)(S);if(S===I)return S;const C=((0,A.basename)(S)||S).toLowerCase();try{const n=(0,P.readdirSync)(I).filter(d=>d.toLowerCase()===C);if(n.length===1){const d=k(I);if(d)return(0,A.join)(d,n[0])}else if(n.length>1){const d=n.indexOf(C);if(d>=0){const f=k(I);if(f)return(0,A.join)(f,n[d])}}}catch{}return null}e.realcaseSync=k;async function y(S){if(u.isLinux)return S;const I=(0,A.dirname)(S);if(S===I)return S;const C=((0,A.basename)(S)||S).toLowerCase();try{const n=(await P.Promises.readdir(I)).filter(d=>d.toLowerCase()===C);if(n.length===1){const d=await y(I);if(d)return(0,A.join)(d,n[0])}else if(n.length>1){const d=n.indexOf(C);if(d>=0){const f=await y(I);if(f)return(0,A.join)(f,n[d])}}}catch{}return null}e.realcase=y;async function p(S){try{return await P.Promises.realpath(S)}catch{const C=T(S);return await P.Promises.access(C,c.constants.R_OK),C}}e.realpath=p;function L(S){try{return c.realpathSync(S)}catch{const C=T(S);return c.accessSync(C,c.constants.R_OK),C}}e.realpathSync=L;function T(S){return(0,R.rtrim)((0,A.normalize)(S),A.sep)}}),define(De[117],Ce([1,0,12,11,36,110,10,29]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(T=u.env){return T.comspec||"cmd.exe"}e.getWindowsShell=y;function p(T){let S=[],I=!1;const C=function(w){if(I){S.push(w);return}(!T.send(w,d=>{if(d&&console.error(d),I=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(v=>C(v))}})||A.isWindows)&&(I=!0)};return{send:C}}e.createQueuedSender=p;var L;(function(T){async function S(I,C,w){if(c.isAbsolute(I))return I;if(C===void 0&&(C=u.cwd()),c.dirname(I)!=="."||(w===void 0&&P.isString(u.env.PATH)&&(w=u.env.PATH.split(c.delimiter)),w===void 0||w.length===0))return c.join(C,I);async function d(f){if(await k.Promises.exists(f)){let v;try{v=await k.Promises.stat(f)}catch(D){D.message.startsWith("EACCES")&&(v=await k.Promises.lstat(f))}return v?!v.isDirectory():!1}return!1}for(const f of w){let v;if(c.isAbsolute(f)?v=c.join(f,I):v=c.join(C,f,I),await d(v))return v;let D=v+".com";if(await d(D)||(D=v+".exe",await d(D)))return D}return c.join(C,I)}T.findExecutable=S})(L=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(re,e,c,A){var u=arguments.length,R=u<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,c):A,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,c,A);else for(var k=re.length-1;k>=0;k--)(P=re[k])&&(R=(u<3?P(R):u>3?P(e,c,R):P(e,c))||R);return u>3&&R&&Object.defineProperty(e,c,R),R};define(De[118],Ce([1,0,17,19,22,21,62,9,3,6,70,8,10]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(I||(I={}));function C(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(w||(w={}));function n(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(d||(d={}));function f(ie){let V=0;for(let J=0;;J+=7){const ne=ie.read(1);if(V|=(ne.buffer[0]&127)<<J,!(ne.buffer[0]&128))return V}}const v=s(0);function D(ie,V){if(V===0){ie.write(v);return}let J=0;for(let ve=V;ve!==0;ve=ve>>>7)J++;const ne=u.VSBuffer.alloc(J);for(let ve=0;V!==0;ve++)ne.buffer[ve]=V&127,V=V>>>7,V>0&&(ne.buffer[ve]|=128);ie.write(ne)}class b{constructor(V){this.b=V,this.a=0}read(V){const J=this.b.slice(this.a,this.a+V);return this.a+=J.byteLength,J}}e.BufferReader=b;class t{constructor(){this.a=[]}get buffer(){return u.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=t;var o;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(o||(o={}));function s(ie){const V=u.VSBuffer.alloc(1);return V.writeUInt8(ie,0),V}const a={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},l=typeof Buffer<"u";function E(ie,V){if(typeof V>"u")ie.write(a.Undefined);else if(typeof V=="string"){const J=u.VSBuffer.fromString(V);ie.write(a.String),D(ie,J.byteLength),ie.write(J)}else if(l&&Buffer.isBuffer(V)){const J=u.VSBuffer.wrap(V);ie.write(a.Buffer),D(ie,J.byteLength),ie.write(J)}else if(V instanceof u.VSBuffer)ie.write(a.VSBuffer),D(ie,V.byteLength),ie.write(V);else if(Array.isArray(V)){ie.write(a.Array),D(ie,V.length);for(const J of V)E(ie,J)}else if(typeof V=="number"&&(V|0)===V)ie.write(a.Uint),D(ie,V);else{const J=u.VSBuffer.fromString(JSON.stringify(V));ie.write(a.Object),D(ie,J.byteLength),ie.write(J)}}e.serialize=E;function i(ie){switch(ie.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return ie.read(f(ie)).toString();case o.Buffer:return ie.read(f(ie)).buffer;case o.VSBuffer:return ie.read(f(ie));case o.Array:{const J=f(ie),ne=[];for(let ve=0;ve<J;ve++)ne.push(i(ie));return ne}case o.Object:return JSON.parse(ie.read(f(ie)).toString());case o.Int:return f(ie)}}e.deserialize=i;class r{constructor(V,J,ne=null,ve=1e3){this.h=V,this.j=J,this.k=ne,this.l=ve,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(V,J){this.b.set(V,J),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const J=this.o([V.type]);this.k?.logOutgoing(J,0,1,n(V.type));return}case 201:case 202:case 204:case 203:{const J=this.o([V.type,V.id],V.data);this.k?.logOutgoing(J,V.id,1,n(V.type),V.data);return}}}o(V,J=void 0){const ne=new t;return E(ne,V),E(ne,J),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const J=new b(V),ne=i(J),ve=i(J),ue=ne[0];switch(ue){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}: ${ne[2]}.${ne[3]}`,ve),this.s({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ve});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}: ${ne[2]}.${ne[3]}`,ve),this.t({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ve});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}`),this.u({type:ue,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}`),this.u({type:ue,id:ne[1]})}}s(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const ne=new R.CancellationTokenSource;let ve;try{ve=J.call(this.j,V.name,V.arg,ne.token)}catch(N){ve=Promise.reject(N)}const ue=V.id;ve.then(N=>{this.m({id:ue,data:N,type:201}),this.d.delete(V.id)},N=>{N instanceof Error?this.m({id:ue,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:ue,data:N,type:203}),this.d.delete(V.id)});const ee=(0,p.toDisposable)(()=>ne.cancel());this.d.set(V.id,ee)}t(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const ne=V.id,ue=J.listen(this.j,V.name,V.arg)(ee=>this.m({id:ne,data:ee,type:204}));this.d.set(V.id,ue)}u(V){const J=this.d.get(V.id);J&&(J.dispose(),this.d.delete(V.id))}v(V){let J=this.g.get(V.channelName);J||(J=[],this.g.set(V.channelName,J));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:V,timeoutTimer:ne})}w(V){const J=this.g.get(V);if(J){for(const ne of J)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=r;var m;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(V,J=null){this.l=V,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=J}getChannel(V){const J=this;return{call(ne,ve,ue){return J.a?Promise.reject(new k.CancellationError):J.m(V,ne,ve,ue)},listen(ne,ve){return J.a?y.Event.None:J.o(V,ne,ve)}}}m(V,J,ne,ve=R.CancellationToken.None){const ue=this.g++,N={id:ue,type:100,channelName:V,name:J,arg:ne};if(ve.isCancellationRequested)return Promise.reject(new k.CancellationError);let q;return new Promise((me,ke)=>{if(ve.isCancellationRequested)return ke(new k.CancellationError);const _=()=>{const ce=oe=>{switch(oe.type){case 201:this.f.delete(ue),me(oe.data);break;case 202:{this.f.delete(ue);const F=new Error(oe.data.message);F.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,F.name=oe.data.name,ke(F);break}case 203:this.f.delete(ue),ke(oe.data);break}};this.f.set(ue,ce),this.p(N)};let le=null;this.b===d.Idle?_():(le=(0,A.createCancelablePromise)(ce=>this.u()),le.then(()=>{le=null,_()}));const de=()=>{le?(le.cancel(),le=null):this.p({id:ue,type:101}),ke(new k.CancellationError)},te=ve.onCancellationRequested(de);q=(0,p.combinedDisposable)((0,p.toDisposable)(de),te),this.d.add(q)}).finally(()=>{this.d.delete(q)})}o(V,J,ne){const ve=this.g++,ee={id:ve,type:102,channelName:V,name:J,arg:ne};let N=null;const q=new y.Emitter({onWillAddFirstListener:()=>{N=(0,A.createCancelablePromise)(me=>this.u()),N.then(()=>{N=null,this.d.add(q),this.p(ee)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(q),this.p({id:ve,type:103}))}}),ae=me=>q.fire(me.data);return this.f.set(ve,ae),q.event}p(V){switch(V.type){case 100:case 102:{const J=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(J,V.id,0,`${C(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const J=this.q([V.type,V.id]);this.j?.logOutgoing(J,V.id,0,C(V.type));return}}}q(V,J=void 0){const ne=new t;return E(ne,V),E(ne,J),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const J=new b(V),ne=i(J),ve=i(J),ue=ne[0];switch(ue){case 200:return this.j?.logIncoming(V.byteLength,0,0,n(ue)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,n(ue),ve),this.t({type:ne[0],id:ne[1],data:ve})}}t(V){if(V.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.dispose)(this.d.values()),this.d.clear()}}Ve([P.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class h{get connections(){const V=[];return this.f.forEach(J=>V.push(J)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:J,onDidClientDisconnect:ne})=>{y.Event.once(J.onMessage)(ue=>{const ee=new b(ue),N=i(ee),q=new r(J,N),ae=new g(J);this.a.forEach((ke,_)=>q.registerChannel(_,ke));const me={channelServer:q,channelClient:ae,ctx:N};this.f.add(me),this.g.fire(me),ne(()=>{q.dispose(),ae.dispose(),this.f.delete(me),this.h.fire(me)})})})}getChannel(V,J){const ne=this;return{call(ve,ue,ee){let N;if((0,S.isFunction)(J)){const ae=(0,c.getRandomElement)(ne.connections.filter(J));N=ae?Promise.resolve(ae):y.Event.toPromise(y.Event.filter(ne.onDidAddConnection,J))}else N=J.routeCall(ne,ve,ue);const q=N.then(ae=>ae.channelClient.getChannel(V));return $(q).call(ve,ue,ee)},listen(ve,ue){if((0,S.isFunction)(J))return ne.j(V,J,ve,ue);const ee=J.routeEvent(ne,ve,ue).then(N=>N.channelClient.getChannel(V));return $(ee).listen(ve,ue)}}}j(V,J,ne,ve){const ue=this;let ee=new p.DisposableStore;const N=new y.Emitter({onWillAddFirstListener:()=>{ee=new p.DisposableStore;const q=new y.EventMultiplexer,ae=new Map,me=_=>{const de=_.channelClient.getChannel(V).listen(ne,ve),te=q.add(de);ae.set(_,te)},ke=_=>{const le=ae.get(_);!le||(le.dispose(),ae.delete(_))};ue.connections.filter(J).forEach(me),y.Event.filter(ue.onDidAddConnection,J)(me,void 0,ee),ue.onDidRemoveConnection(ke,void 0,ee),q.event(N.fire,N,ee),ee.add(q)},onDidRemoveLastListener:()=>{ee.dispose()}});return N.event}registerChannel(V,J){this.a.set(V,J),this.f.forEach(ne=>{ne.channelServer.registerChannel(V,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=h;class O{constructor(V,J,ne=null){const ve=new t;E(ve,J),V.send(ve.buffer),this.a=new g(V,ne),this.d=new r(V,J,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,J){this.d.registerChannel(V,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function $(ie){return{call(V,J,ne){return ie.then(ve=>ve.call(V,J,ne))},listen(V,J){const ne=new y.Relay;return ie.then(ve=>ne.input=ve.listen(V,J)),ne.event}}}e.getDelayedChannel=$;function x(ie){let V=!1;return{call(J,ne,ve){return V?ie.call(J,ne,ve):(0,A.timeout)(0).then(()=>V=!0).then(()=>ie.call(J,ne,ve))},listen(J,ne){if(V)return ie.listen(J,ne);const ve=new y.Relay;return(0,A.timeout)(0).then(()=>V=!0).then(()=>ve.input=ie.listen(J,ne)),ve.event}}}e.getNextTickChannel=x;class Y{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const J of V.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=Y;var G;(function(ie){function V(ue,ee){const N=ue,q=ee&&ee.disableMarshalling,ae=new Map;for(const me in N)ne(me)&&ae.set(me,y.Event.buffer(N[me],!0));return new class{listen(me,ke,_){const le=ae.get(ke);if(le)return le;if(ve(ke)){const de=N[ke];if(typeof de=="function")return de.call(N,_)}throw new Error(`Event not found: ${ke}`)}call(me,ke,_){const le=N[ke];if(typeof le=="function"){if(!q&&Array.isArray(_))for(let de=0;de<_.length;de++)_[de]=(0,L.revive)(_[de]);return le.apply(N,_)}throw new Error(`Method not found: ${ke}`)}}}ie.fromService=V;function J(ue,ee){const N=ee&&ee.disableMarshalling;return new Proxy({},{get(q,ae){if(typeof ae=="string")return ee?.properties?.has(ae)?ee.properties.get(ae):ve(ae)?function(me){return ue.listen(ae,me)}:ne(ae)?ue.listen(ae):async function(...me){let ke;ee&&!(0,S.isUndefinedOrNull)(ee.context)?ke=[ee.context,...me]:ke=me;const _=await ue.call(ae,ke);return N?_:(0,L.revive)(_)};throw new Error(`Property not found: ${String(ae)}`)}})}ie.toService=J;function ne(ue){return ue[0]==="o"&&ue[1]==="n"&&T.isUpperAsciiLetter(ue.charCodeAt(2))}function ve(ue){return/^onDynamic/.test(ue)&&T.isUpperAsciiLetter(ue.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const V=ie.toString();if(V!=="[object Object]")return V}return ie}function U(ie){return Array.isArray(ie)?ie.map(B):B(ie)}function j(ie,V,J,ne,ve,ue,ee){ee=U(ee);const N=M[ve],q=N[ne%N.length];let ae=[`%c[${ie}]%c[${String(V).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ue)?(ae=ae.concat(ee),ae.push(")")):ae.push(ee),console.log.apply(console,ae)}class he{constructor(V,J){this.d=V,this.f=J,this.a=0,this.b=0}logOutgoing(V,J,ne,ve,ue){this.b+=V,j(this.d,this.b,V,J,ne,ve,ue)}logIncoming(V,J,ne,ve,ue){this.a+=V,j(this.f,this.a,V,J,ne,ve,ue)}}e.IPCLogger=he}),define(De[119],Ce([1,0,19,22,3,6,118]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(g){g.Created="created",g.Read="read",g.Write="write",g.Open="open",g.Error="error",g.Close="close",g.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",g.NodeEndReceived="nodeEndReceived",g.NodeEndSent="nodeEndSent",g.NodeDrainBegin="nodeDrainBegin",g.NodeDrainEnd="nodeDrainEnd",g.zlibInflateError="zlibInflateError",g.zlibInflateData="zlibInflateData",g.zlibInflateInitialWrite="zlibInflateInitialWrite",g.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",g.zlibInflateWrite="zlibInflateWrite",g.zlibInflateFlushFired="zlibInflateFlushFired",g.zlibDeflateError="zlibDeflateError",g.zlibDeflateData="zlibDeflateData",g.zlibDeflateWrite="zlibDeflateWrite",g.zlibDeflateFlushFired="zlibDeflateFlushFired",g.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",g.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",g.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",g.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",g.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",g.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",g.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",g.ProtocolHeaderRead="protocolHeaderRead",g.ProtocolMessageRead="protocolMessageRead",g.ProtocolHeaderWrite="protocolHeaderWrite",g.ProtocolMessageWrite="protocolMessageWrite",g.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(g){g.enableDiagnostics=!1,g.records=[];const h=new WeakMap;let O=0;function $(Y,G){if(!h.has(Y)){const M=String(++O);h.set(Y,M)}return h.get(Y)}function x(Y,G,M,B){if(!g.enableDiagnostics)return;const U=$(Y,G);if(B instanceof A.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const j=A.VSBuffer.alloc(B.byteLength);j.set(B),g.records.push({timestamp:Date.now(),id:U,label:G,type:M,buff:j})}else g.records.push({timestamp:Date.now(),id:U,label:G,type:M,data:B})}g.traceSocketEvent=x})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(g){g[g.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",g[g.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function T(){return L||(L=A.VSBuffer.alloc(0)),L}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(h){this.a.push(h),this.b+=h.byteLength}read(h){return this.c(h,!0)}peek(h){return this.c(h,!1)}c(h,O){if(h===0)return T();if(h>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===h){const G=this.a[0];return O&&(this.a.shift(),this.b-=h),G}if(this.a[0].byteLength>h){const G=this.a[0].slice(0,h);return O&&(this.a[0]=this.a[0].slice(h),this.b-=h),G}const $=A.VSBuffer.alloc(h);let x=0,Y=0;for(;h>0;){const G=this.a[Y];if(G.byteLength>h){const M=G.slice(0,h);$.set(M,x),x+=h,O&&(this.a[Y]=G.slice(h),this.b-=h),h-=h}else $.set(G,x),x+=G.byteLength,O?(this.a.shift(),this.b-=G.byteLength):Y++,h-=G.byteLength}return $}}e.ChunkStream=S;var I;(function(g){g[g.None=0]="None",g[g.Regular=1]="Regular",g[g.Control=2]="Control",g[g.Ack=3]="Ack",g[g.Disconnect=5]="Disconnect",g[g.ReplayRequest=6]="ReplayRequest",g[g.Pause=7]="Pause",g[g.Resume=8]="Resume",g[g.KeepAlive=9]="KeepAlive",g[g.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",g[g.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(I||(I={}));function C(g){switch(g){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(g){g[g.HeaderLength=13]="HeaderLength",g[g.AcknowledgeTime=2e3]="AcknowledgeTime",g[g.TimeoutTime=2e4]="TimeoutTime",g[g.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",g[g.KeepAliveSendTime=5e3]="KeepAliveSendTime",g[g.LatencySampleTime=6e4]="LatencySampleTime",g[g.LatencySampleCount=5]="LatencySampleCount",g[g.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",g[g.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class n{constructor(h,O,$,x){this.type=h,this.id=O,this.ack=$,this.data=x,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends R.Disposable{constructor(h){super(),this.f=this.D(new u.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=h,this.b=!1,this.c=new S,this.D(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(h){if(!(!h||h.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(h);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,x=this.g.id,Y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new n($,x,Y,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(h){this.k=null,this.a=!1,this.b=!1,this.c=h,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(h){if(this.a)return;h.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=A.VSBuffer.alloc(13);O.writeUInt8(h.type,0),O.writeUInt32BE(h.id,1),O.writeUInt32BE(h.ack,5),O.writeUInt32BE(h.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(h.type),id:h.id,ack:h.ack,messageSize:h.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",h.data),this.j(O,h.data)}g(h,O){const $=this.f===0;return this.d.push(h,O),this.f+=h.byteLength+O.byteLength,$}h(){const h=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,h}j(h,O){this.g(h,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const h=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:h.byteLength}),this.c.write(h)}}class v extends R.Disposable{constructor(h){super(),this.f=new u.Emitter,this.onMessage=this.f.event,this.g=new u.Emitter,this.onDidDispose=this.g.event,this.a=h,this.b=this.D(new f(this.a)),this.c=this.D(new d(this.a)),this.D(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(h){this.b.write(new n(1,0,0,h))}}e.Protocol=v;class D extends P.IPCClient{static fromSocket(h,O){return new D(new v(h),O)}get onDidDispose(){return this.b.onDidDispose}constructor(h,O,$=null){super(h,O,$),this.b=h}dispose(){super.dispose();const h=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),h.end()}}e.Client=D;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(h){this.b?this.d.length>0?this.d.push(h):this.a.fire(h):this.d.push(h)}flushBuffer(){this.d=[]}}e.BufferedEmitter=b;class t{constructor(h){this.data=h,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let h=0,O=this.a;for(;O;)O=O.next,h++;return h}peek(){return this.a?this.a.data:null}toArray(){const h=[];let O=0,$=this.a;for(;$;)h[O++]=$.data,$=$.next;return h}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(h){const O=new t(h);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const h=Date.now();for(let O=0;O<s.a;O++)this.c[O]=h-1e3*O;setInterval(()=>{for(let O=s.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const h=Date.now(),O=(1+s.a)*1e3;let $=0;for(let x=0;x<s.a;x++)h-this.c[x]<=O&&$++;return 1-$/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var a;(function(g){g[g.Good=0]="Good",g[g.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function l(g){switch(g){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class E{constructor(h){this.connectionHealth=h}}e.ConnectionHealthChangedEvent=E;class i{constructor(h,O){this.roundTripTime=h,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=i;class r{get unacknowledgedCount(){return this.c-this.d}constructor(h){this.x=new b,this.onControlMessage=this.x.event,this.y=new b,this.onMessage=this.y.event,this.z=new b,this.onDidDispose=this.z.event,this.A=new b,this.onSocketClose=this.A.event,this.B=new b,this.onSocketTimeout=this.B.event,this.C=new b,this.onHighRoundTripTime=this.C.event,this.D=new b,this.onDidChangeConnectionHealth=this.D.event,this.u=h.loadEstimator??s.getInstance(),this.v=h.measureRoundTripTime??!1,this.w=h.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=h.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),h.initialChunk&&this.q.acceptChunk(h.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const h=new n(5,0,0,T());this.p.write(h),this.p.flush()}sendPause(){const h=new n(7,0,0,T());this.p.write(h)}sendResume(){const h=new n(8,0,0,T());this.p.write(h)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(h,O){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=h,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const h=new n(3,0,this.h,T());this.p.write(h);const O=this.b.toArray();for(let $=0,x=O.length;$<x;$++)this.p.write(O[$]);this.G()}acceptDisconnect(){this.z.fire()}E(h){if(h.ack>this.d){this.d=h.ack;do{const O=this.b.peek();if(O&&O.id<=h.ack)this.b.pop();else break}while(!0)}switch(h.type){case 0:break;case 1:{if(h.id>this.g)if(h.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new n(6,0,0,T())))}else this.g=h.id,this.j=Date.now(),this.F(),this.y.fire(h.data);break}case 2:{this.x.fire(h.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let $=0,x=O.length;$<x;$++)this.p.write(O[$]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(h.data);break}case 11:{this.r.handleResponse(h.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(h){const O=++this.c;this.h=this.g;const $=new n(1,O,this.h,h);this.b.push($),this.a||(this.p.write($),this.G())}sendControl(h){const O=new n(2,0,0,h);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const h=Date.now()-this.j;if(h>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-h+5)}G(){if(this.c<=this.d||this.f||this.a)return;const h=this.b.peek(),O=Date.now()-h.writtenTime,$=Date.now()-this.q.lastReadTime,x=Date.now()-this.n;if(O>=2e4&&$>=2e4&&x>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:$});return}const Y=Math.max(2e4-O,2e4-$,2e4-x,500);this.f=setTimeout(()=>{this.f=null,this.G()},Y)}H(){if(this.g<=this.h)return;this.h=this.g;const h=new n(3,0,this.h,T());this.p.write(h)}I(){this.h=this.g;const h=new n(9,0,this.h,T());this.p.write(h)}J(h){this.h=this.g;const O=new n(10,0,this.h,h);this.p.write(O)}K(h){this.h=this.g;const O=new n(11,0,this.h,h);this.p.write(O)}}e.PersistentProtocol=r;class m extends R.Disposable{constructor(){super(),this.a=this.D(new u.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new u.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new u.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},h=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const h=++this.h,O=A.VSBuffer.alloc(4);O.writeUInt32BE(h,0),this.a.fire(O)},6e4)}handleResponse(h){if(h.byteLength!==4)return;const O=h.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const $=Date.now()-this.g,x=this.k++;this.j[x%this.j.length]=$;const Y=this.l,G=this.j.filter(M=>M>=1e3).length;this.l=G>=3?1:0,$>1e3&&this.b.fire(new i($,G)),Y!==this.l&&this.c.fire(this.l)}}}),define(De[166],Ce([1,0,38,12]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(R,P,k,y,p,L){if(Array.isArray(R)){let T=0;for(const S of R){const I=u(S,P,k,y,p,L);if(I===10)return I;I>T&&(T=I)}return T}else{if(typeof R=="string")return y?R==="*"?5:R===k?10:0:0;if(R){const{language:T,pattern:S,scheme:I,hasAccessToAllModels:C,notebookType:w}=R;if(!y&&!C)return 0;w&&p&&(P=p);let n=0;if(I)if(I===P.scheme)n=10;else if(I==="*")n=5;else return 0;if(T)if(T===k)n=10;else if(T==="*")n=Math.max(n,5);else return 0;if(w)if(w===L)n=10;else if(w==="*"&&L!==void 0)n=Math.max(n,5);else return 0;if(S){let d;if(typeof S=="string"?d=S:d={...S,base:(0,A.normalize)(S.base)},d===P.fsPath||(0,c.match)(d,P.fsPath))n=10;else return 0}return n}else return 0}}e.score=u}),define(De[167],Ce([1,0,8,53,157]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(k,y,p,L){this.c=k,this.d=y,this.f=p,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(k){k.eol&&k.eol!==this.f&&(this.f=k.eol,this.h=null);const y=k.changes;for(const p of y)this.n(p.range),this.o(new A.Position(p.range.startLineNumber,p.range.startColumn),p.text);this.g=k.versionId,this.j=null}k(){if(!this.h){const k=this.f.length,y=this.d.length,p=new Uint32Array(y);for(let L=0;L<y;L++)p[L]=this.d[L].length+k;this.h=new u.PrefixSumComputer(p)}}l(k,y){this.d[k]=y,this.h&&this.h.setValue(k,this.d[k].length+this.f.length)}n(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this.l(k.startLineNumber-1,this.d[k.startLineNumber-1].substring(0,k.startColumn-1)+this.d[k.startLineNumber-1].substring(k.endColumn-1));return}this.l(k.startLineNumber-1,this.d[k.startLineNumber-1].substring(0,k.startColumn-1)+this.d[k.endLineNumber-1].substring(k.endColumn-1)),this.d.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this.h&&this.h.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}o(k,y){if(y.length===0)return;const p=(0,c.splitLines)(y);if(p.length===1){this.l(k.lineNumber-1,this.d[k.lineNumber-1].substring(0,k.column-1)+p[0]+this.d[k.lineNumber-1].substring(k.column-1));return}p[p.length-1]+=this.d[k.lineNumber-1].substring(k.column-1),this.l(k.lineNumber-1,this.d[k.lineNumber-1].substring(0,k.column-1)+p[0]);const L=new Uint32Array(p.length-1);for(let T=1;T<p.length;T++)this.d.splice(k.lineNumber+T-1,0,p[T]),L[T-1]=p[T].length+this.f.length;this.h&&this.h.insertValues(k.lineNumber,L)}}e.MirrorTextModel=R}),define(De[168],Ce([1,0,8,154,53,32,108]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(f,v,D,b){this.searchString=f,this.isRegex=v,this.matchCase=D,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=p(this.searchString):f=this.searchString.indexOf(`
`)>=0;let v=null;try{v=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!v)return null;let D=!this.isRegex&&!f;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new P.SearchData(v,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=y;function p(d){if(!d||d.length===0)return!1;for(let f=0,v=d.length;f<v;f++){const D=d.charCodeAt(f);if(D===10)return!0;if(D===92){if(f++,f>=v)break;const b=d.charCodeAt(f);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=p;function L(d,f,v){if(!v)return new P.FindMatch(d,null);const D=[];for(let b=0,t=f.length;b<t;b++)D[b]=f[b];return new P.FindMatch(d,D)}e.createFindMatch=L;class T{constructor(f){const v=[];let D=0;for(let b=0,t=f.length;b<t;b++)f.charCodeAt(b)===10&&(v[D++]=b);this.a=v}findLineFeedCountBeforeOffset(f){const v=this.a;let D=0,b=v.length-1;if(b===-1||f<=v[0])return 0;for(;D<b;){const t=D+((b-D)/2>>0);v[t]>=f?b=t-1:v[t+1]>=f?(D=t,b=t):D=t+1}return D+1}}class S{static findMatches(f,v,D,b,t){const o=v.parseSearchRequest();return o?o.regex.multiline?this.b(f,D,new n(o.wordSeparators,o.regex),b,t):this.c(f,D,o,b,t):[]}static a(f,v,D,b,t,o){let s,a=0;b?(a=b.findLineFeedCountBeforeOffset(t),s=v+t+a):s=v+t;let l;if(b){const m=b.findLineFeedCountBeforeOffset(t+o.length)-a;l=s+o.length+m}else l=s+o.length;const E=f.getPositionAt(s),i=f.getPositionAt(l);return new R.Range(E.lineNumber,E.column,i.lineNumber,i.column)}static b(f,v,D,b,t){const o=f.getOffsetAt(v.getStartPosition()),s=f.getValueInRange(v,1),a=f.getEOL()===`\r
`?new T(s):null,l=[];let E=0,i;for(D.reset(0);i=D.next(s);)if(l[E++]=L(this.a(f,o,s,a,i.index,i[0]),i,b),E>=t)return l;return l}static c(f,v,D,b,t){const o=[];let s=0;if(v.startLineNumber===v.endLineNumber){const l=f.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return s=this.d(D,l,v.startLineNumber,v.startColumn-1,s,o,b,t),o}const a=f.getLineContent(v.startLineNumber).substring(v.startColumn-1);s=this.d(D,a,v.startLineNumber,v.startColumn-1,s,o,b,t);for(let l=v.startLineNumber+1;l<v.endLineNumber&&s<t;l++)s=this.d(D,f.getLineContent(l),l,0,s,o,b,t);if(s<t){const l=f.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);s=this.d(D,l,v.endLineNumber,0,s,o,b,t)}return o}static d(f,v,D,b,t,o,s,a){const l=f.wordSeparators;if(!s&&f.simpleSearch){const r=f.simpleSearch,m=r.length,g=v.length;let h=-m;for(;(h=v.indexOf(r,h+m))!==-1;)if((!l||w(l,v,g,h,m))&&(o[t++]=new P.FindMatch(new R.Range(D,h+1+b,D,h+1+m+b),null),t>=a))return t;return t}const E=new n(f.wordSeparators,f.regex);let i;E.reset(0);do if(i=E.next(v),i&&(o[t++]=L(new R.Range(D,i.index+1+b,D,i.index+1+i[0].length+b),i,s),t>=a))return t;while(i);return t}static findNextMatch(f,v,D,b){const t=v.parseSearchRequest();if(!t)return null;const o=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.e(f,D,o,b):this.f(f,D,o,b)}static e(f,v,D,b){const t=new u.Position(v.lineNumber,1),o=f.getOffsetAt(t),s=f.getLineCount(),a=f.getValueInRange(new R.Range(t.lineNumber,t.column,s,f.getLineMaxColumn(s)),1),l=f.getEOL()===`\r
`?new T(a):null;D.reset(v.column-1);const E=D.next(a);return E?L(this.a(f,o,a,l,E.index,E[0]),E,b):v.lineNumber!==1||v.column!==1?this.e(f,new u.Position(1,1),D,b):null}static f(f,v,D,b){const t=f.getLineCount(),o=v.lineNumber,s=f.getLineContent(o),a=this.g(D,s,o,v.column,b);if(a)return a;for(let l=1;l<=t;l++){const E=(o+l-1)%t,i=f.getLineContent(E+1),r=this.g(D,i,E+1,1,b);if(r)return r}return null}static g(f,v,D,b,t){f.reset(b-1);const o=f.next(v);return o?L(new R.Range(D,o.index+1,D,o.index+1+o[0].length),o,t):null}static findPreviousMatch(f,v,D,b){const t=v.parseSearchRequest();if(!t)return null;const o=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.h(f,D,o,b):this.j(f,D,o,b)}static h(f,v,D,b){const t=this.b(f,new R.Range(1,1,v.lineNumber,v.column),D,b,10*k);if(t.length>0)return t[t.length-1];const o=f.getLineCount();return v.lineNumber!==o||v.column!==f.getLineMaxColumn(o)?this.h(f,new u.Position(o,f.getLineMaxColumn(o)),D,b):null}static j(f,v,D,b){const t=f.getLineCount(),o=v.lineNumber,s=f.getLineContent(o).substring(0,v.column-1),a=this.k(D,s,o,b);if(a)return a;for(let l=1;l<=t;l++){const E=(t+o-l-1)%t,i=f.getLineContent(E+1),r=this.k(D,i,E+1,b);if(r)return r}return null}static k(f,v,D,b){let t=null,o;for(f.reset(0);o=f.next(v);)t=L(new R.Range(D,o.index+1,D,o.index+1+o[0].length),o,b);return t}}e.TextModelSearch=S;function I(d,f,v,D,b){if(D===0)return!0;const t=f.charCodeAt(D-1);if(d.get(t)!==0||t===13||t===10)return!0;if(b>0){const o=f.charCodeAt(D);if(d.get(o)!==0)return!0}return!1}function C(d,f,v,D,b){if(D+b===v)return!0;const t=f.charCodeAt(D+b);if(d.get(t)!==0||t===13||t===10)return!0;if(b>0){const o=f.charCodeAt(D+b-1);if(d.get(o)!==0)return!0}return!1}function w(d,f,v,D,b){return I(d,f,v,D,b)&&C(d,f,v,D,b)}e.isValidMatch=w;class n{constructor(f,v){this._wordSeparators=f,this.a=v,this.b=-1,this.c=0}reset(f){this.a.lastIndex=f,this.b=-1,this.c=0}next(f){const v=f.length;let D;do{if(this.b+this.c===v||(D=this.a.exec(f),!D))return null;const b=D.index,t=D[0].length;if(b===this.b&&t===this.c){if(t===0){c.getNextCodePoint(f,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=t,!this._wordSeparators||w(this._wordSeparators,f,v,b,t))return D}while(D);return null}}e.Searcher=n}),define(De[120],Ce([1,0,22,11]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(u||(u={}));function R(T){for(let S=0,I=T.length;S<I;S+=4){const C=T[S+0],w=T[S+1],n=T[S+2],d=T[S+3];T[S+0]=d,T[S+1]=n,T[S+2]=w,T[S+3]=C}}function P(T){const S=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return A.isLittleEndian()||R(S),c.VSBuffer.wrap(S)}function k(T){const S=T.buffer;if(A.isLittleEndian()||R(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const I=new Uint8Array(S.byteLength);return I.set(S),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function y(T){const S=new Uint32Array(p(T));let I=0;if(S[I++]=T.id,T.type==="full")S[I++]=1,S[I++]=T.data.length,S.set(T.data,I),I+=T.data.length;else{S[I++]=2,S[I++]=T.deltas.length;for(const C of T.deltas)S[I++]=C.start,S[I++]=C.deleteCount,C.data?(S[I++]=C.data.length,S.set(C.data,I),I+=C.data.length):S[I++]=0}return P(S)}e.encodeSemanticTokensDto=y;function p(T){let S=0;if(S+=1+1,T.type==="full")S+=1+T.data.length;else{S+=1,S+=(1+1+1)*T.deltas.length;for(const I of T.deltas)I.data&&(S+=I.data.length)}return S}function L(T){const S=k(T);let I=0;const C=S[I++];if(S[I++]===1){const f=S[I++],v=S.subarray(I,I+f);return I+=f,{id:C,type:"full",data:v}}const n=S[I++],d=[];for(let f=0;f<n;f++){const v=S[I++],D=S[I++],b=S[I++];let t;b>0&&(t=S.subarray(I,I+b),I+=b),d[f]={start:v,deleteCount:D,data:t}}return{id:C,type:"delta",deltas:d}}e.decodeSemanticTokensDto=L}),define(De[169],Ce([1,0,3,6]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(k){this.c.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this.a.set(k,y),this.fire([k]),(0,A.toDisposable)(()=>{this.a.get(k)===y&&(this.a.delete(k),this.fire([k]))})}registerFactory(k,y){this.b.get(k)?.dispose();const p=new R(this,k,y);return this.b.set(k,p),(0,A.toDisposable)(()=>{const L=this.b.get(k);!L||L!==p||(this.b.delete(k),L.dispose())})}async getOrCreate(k){const y=this.get(k);if(y)return y;const p=this.b.get(k);return!p||p.isResolved?null:(await p.resolve(),this.get(k))}get(k){return this.a.get(k)||null}isResolved(k){if(this.get(k))return!0;const p=this.b.get(k);return!!(!p||p.isResolved)}setColorMap(k){this.d=k,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=u;class R extends A.Disposable{get isResolved(){return this.c}constructor(k,y,p){super(),this.f=k,this.g=y,this.h=p,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const k=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,k&&!this.a&&this.D(this.f.register(this.g,k))}}}),define(De[73],Ce([1,0,67,2,32,169]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class P{constructor(m,g,h){this.offset=m,this.type=g,this.language=h,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=P;class k{constructor(m,g){this.tokens=m,this.endState=g,this._tokenizationResultBrand=void 0}}e.TokenizationResult=k;class y{constructor(m,g){this.tokens=m,this.endState=g,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var p;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(r){const m=new Map;m.set(0,c.Codicon.symbolMethod),m.set(1,c.Codicon.symbolFunction),m.set(2,c.Codicon.symbolConstructor),m.set(3,c.Codicon.symbolField),m.set(4,c.Codicon.symbolVariable),m.set(5,c.Codicon.symbolClass),m.set(6,c.Codicon.symbolStruct),m.set(7,c.Codicon.symbolInterface),m.set(8,c.Codicon.symbolModule),m.set(9,c.Codicon.symbolProperty),m.set(10,c.Codicon.symbolEvent),m.set(11,c.Codicon.symbolOperator),m.set(12,c.Codicon.symbolUnit),m.set(13,c.Codicon.symbolValue),m.set(15,c.Codicon.symbolEnum),m.set(14,c.Codicon.symbolConstant),m.set(15,c.Codicon.symbolEnum),m.set(16,c.Codicon.symbolEnumMember),m.set(17,c.Codicon.symbolKeyword),m.set(27,c.Codicon.symbolSnippet),m.set(18,c.Codicon.symbolText),m.set(19,c.Codicon.symbolColor),m.set(20,c.Codicon.symbolFile),m.set(21,c.Codicon.symbolReference),m.set(22,c.Codicon.symbolCustomColor),m.set(23,c.Codicon.symbolFolder),m.set(24,c.Codicon.symbolTypeParameter),m.set(25,c.Codicon.account),m.set(26,c.Codicon.issues);function g($){let x=m.get($);return x||(console.info("No codicon found for CompletionItemKind "+$),x=c.Codicon.symbolProperty),x}r.toIcon=g;const h=new Map;h.set("method",0),h.set("function",1),h.set("constructor",2),h.set("field",3),h.set("variable",4),h.set("class",5),h.set("struct",6),h.set("interface",7),h.set("module",8),h.set("property",9),h.set("event",10),h.set("operator",11),h.set("unit",12),h.set("value",13),h.set("constant",14),h.set("enum",15),h.set("enum-member",16),h.set("enumMember",16),h.set("keyword",17),h.set("snippet",27),h.set("text",18),h.set("color",19),h.set("file",20),h.set("reference",21),h.set("customcolor",22),h.set("folder",23),h.set("type-parameter",24),h.set("typeParameter",24),h.set("account",25),h.set("issue",26);function O($,x){let Y=h.get($);return typeof Y>"u"&&!x&&(Y=9),Y}r.fromString=O})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(r){r[r.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(r){return r&&A.URI.isUri(r.uri)&&u.Range.isIRange(r.range)&&(u.Range.isIRange(r.originSelectionRange)||u.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=f;var v;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var D;(function(r){r[r.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var b;(function(r){const m=new Map;m.set(0,c.Codicon.symbolFile),m.set(1,c.Codicon.symbolModule),m.set(2,c.Codicon.symbolNamespace),m.set(3,c.Codicon.symbolPackage),m.set(4,c.Codicon.symbolClass),m.set(5,c.Codicon.symbolMethod),m.set(6,c.Codicon.symbolProperty),m.set(7,c.Codicon.symbolField),m.set(8,c.Codicon.symbolConstructor),m.set(9,c.Codicon.symbolEnum),m.set(10,c.Codicon.symbolInterface),m.set(11,c.Codicon.symbolFunction),m.set(12,c.Codicon.symbolVariable),m.set(13,c.Codicon.symbolConstant),m.set(14,c.Codicon.symbolString),m.set(15,c.Codicon.symbolNumber),m.set(16,c.Codicon.symbolBoolean),m.set(17,c.Codicon.symbolArray),m.set(18,c.Codicon.symbolObject),m.set(19,c.Codicon.symbolKey),m.set(20,c.Codicon.symbolNull),m.set(21,c.Codicon.symbolEnumMember),m.set(22,c.Codicon.symbolStruct),m.set(23,c.Codicon.symbolEvent),m.set(24,c.Codicon.symbolOperator),m.set(25,c.Codicon.symbolTypeParameter);function g(h){let O=m.get(h);return O||(console.info("No codicon found for SymbolKind "+h),O=c.Codicon.symbolProperty),O}r.toIcon=g})(b=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(m){switch(m){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(m)}constructor(m){this.value=m}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var o;(function(r){function m(g){return!g||typeof g!="object"?!1:typeof g.id=="string"&&typeof g.title=="string"}r.is=m})(o=e.Command||(e.Command={}));var s;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var E;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var i;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[170],Ce([14,15]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(De[121],Ce([1,0,170,11,107,17,23,153]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=p;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(Q,ge,Le,Ne){this.id=Q,this.name=ge,this.defaultValue=Le,this.schema=Ne}applyUpdate(Q,ge){return I(Q,ge)}compute(Q,ge,Le){return Le}}class S{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=S;function I(W,Q){if(typeof W!="object"||typeof Q!="object"||!W||!Q)return new S(Q,W!==Q);if(Array.isArray(W)||Array.isArray(Q)){const Le=Array.isArray(W)&&Array.isArray(Q)&&R.equals(W,Q);return new S(Q,!Le)}let ge=!1;for(const Le in Q)if(Q.hasOwnProperty(Le)){const Ne=I(W[Le],Q[Le]);Ne.didChange&&(W[Le]=Ne.newValue,ge=!0)}return new S(W,ge)}class C{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return I(Q,ge)}validate(Q){return this.defaultValue}}class w{constructor(Q,ge,Le,Ne){this.id=Q,this.name=ge,this.defaultValue=Le,this.schema=Ne}applyUpdate(Q,ge){return I(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Le){return Le}}function n(W,Q){return typeof W>"u"?Q:W==="false"?!1:Boolean(W)}e.boolean=n;class d extends w{constructor(Q,ge,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(Q,ge,Le,Ne)}validate(Q){return n(Q,this.defaultValue)}}function f(W,Q,ge,Le){if(typeof W>"u")return Q;let Ne=parseInt(W,10);return isNaN(Ne)?Q:(Ne=Math.max(ge,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=f;class v extends w{static clampedInt(Q,ge,Le,Ne){return f(Q,ge,Le,Ne)}constructor(Q,ge,Le,Ne,je,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Le,Ye.minimum=Ne,Ye.maximum=je),super(Q,ge,Le,Ye),this.minimum=Ne,this.maximum=je}validate(Q){return v.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class D extends w{static clamp(Q,ge,Le){return Q<ge?ge:Q>Le?Le:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Le=parseFloat(Q);return isNaN(Le)?ge:Le}constructor(Q,ge,Le,Ne,je){typeof je<"u"&&(je.type="number",je.default=Le),super(Q,ge,Le,je),this.validationFn=Ne}validate(Q){return this.validationFn(D.float(Q,this.defaultValue))}}class b extends w{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(Q,ge,Le,Ne)}validate(Q){return b.string(Q,this.defaultValue)}}function t(W,Q,ge){return typeof W!="string"||ge.indexOf(W)===-1?Q:W}e.stringSet=t;class o extends w{constructor(Q,ge,Le,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Ne,je.default=Le),super(Q,ge,Le,je),this.c=Ne}validate(Q){return t(Q,this.defaultValue,this.c)}}class s extends T{constructor(Q,ge,Le,Ne,je,Ye,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=Ne),super(Q,ge,Le,Xe),this.c=je,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function a(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Le){return Le===0?Q.accessibilitySupport:Le}}class E extends T{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:c.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:n(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function g(W){switch(W){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function h(W){switch(W){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class O extends C{constructor(){super(135)}compute(Q,ge,Le){const Ne=["monaco-editor"];return ge.get(36)&&Ne.push(ge.get(36)),Q.extraEditorClassName&&Ne.push(Q.extraEditorClassName),ge.get(70)==="default"?Ne.push("mouse-default"):ge.get(70)==="copy"&&Ne.push("mouse-copy"),ge.get(105)&&Ne.push("showUnused"),ge.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class $ extends d{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(Q,ge,Le){return Le&&Q.emptySelectionClipboard}}class x extends T{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:c.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:c.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:n(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(ge.loop,this.defaultValue.loop)}}}class Y extends T{constructor(){super(48,"fontLigatures",Y.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?Y.OFF:Q==="true"?Y.ON:Q:Boolean(Q)?Y.ON:Y.OFF}}Y.OFF='"liga" off, "calt" off',Y.ON='"liga" on, "calt" on',e.EditorFontLigatures=Y;class G extends T{constructor(){super(51,"fontVariations",G.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?G.OFF:Q==="true"?G.TRANSLATE:Q:Boolean(Q)?G.TRANSLATE:G.OFF}compute(Q,ge,Le){return Q.fontInfo.fontVariationSettings}}G.OFF="normal",G.TRANSLATE="translate",e.EditorFontVariations=G;class M extends C{constructor(){super(47)}compute(Q,ge,Le){return Q.fontInfo}}class B extends w{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(Q){const ge=D.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(ge,6,100)}compute(Q,ge,Le){return Q.fontInfo.fontSize}}class U extends T{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(v.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class j extends T{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:c.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:t(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??t(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??t(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??t(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??t(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??t(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends T{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:c.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:n(ge.enabled,this.defaultValue.enabled),delay:v.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:n(ge.sticky,this.defaultValue.sticky),above:n(ge.above,this.defaultValue.above)}}}var ie;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class V extends C{constructor(){super(138)}compute(Q,ge,Le){return V.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Le=Math.floor(Q.paddingTop/Q.lineHeight);let Ne=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Ne=Math.max(Ne,ge-1));const je=(Le+Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:Ye}}static c(Q,ge){const Le=Q.outerWidth,Ne=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Ye=ge.stableMinimapLayoutInput,Xe=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,nt=Q.lineHeight,ot=Q.typicalHalfwidthCharacterWidth,pt=Q.scrollBeyondLastLine,bt=Q.minimap.renderCharacters;let St=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Pt=Q.minimap.maxColumn,zt=Q.minimap.size,Xt=Q.minimap.side,ft=Q.verticalScrollbarWidth,vt=Q.viewLineCount,Ot=Q.remainingWidth,Ut=Q.isViewportWrapping,Nt=bt?2:3;let wt=Math.floor(je*Ne);const kt=wt/je;let At=!1,Bt=!1,Ke=Nt*St,Wt=St/je,Re=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:mt,desiredRatio:gt,minimapLineCount:dt}=V.computeContainedMinimapLineCount({viewLineCount:vt,scrollBeyondLastLine:pt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Ne,lineHeight:nt,pixelRatio:je});if(vt/dt>1)At=!0,Bt=!0,St=1,Ke=1,Wt=St/je;else{let yt=!1,Tt=St+1;if(zt==="fit"){const Ht=Math.ceil((ct+vt+mt)*Ke);Ut&&Xe&&Ot<=ge.stableFitRemainingWidth?(yt=!0,Tt=ge.stableFitMaxMinimapScale):yt=Ht>wt}if(zt==="fill"||yt){At=!0;const Ht=St;Ke=Math.min(nt*je,Math.max(1,Math.floor(1/gt))),Ut&&Xe&&Ot<=ge.stableFitRemainingWidth&&(Tt=ge.stableFitMaxMinimapScale),St=Math.min(Tt,Math.max(1,Math.floor(Ke/Nt))),St>Ht&&(Re=Math.min(2,St/Ht)),Wt=St/je/Re,wt=Math.ceil(Math.max(Ge,ct+vt+mt)*Ke),Ut?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=Ot,ge.stableFitMaxMinimapScale=St):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Fe=Math.floor(Pt*Wt),Se=Math.min(Fe,Math.max(0,Math.floor((Ot-ft-2)*Wt/(ot+Wt)))+e.MINIMAP_GUTTER_WIDTH);let se=Math.floor(je*Se);const Oe=se/je;se=Math.floor(se*Re);const He=bt?1:2,Ze=Xt==="left"?0:Le-Se-ft;return{renderMinimap:He,minimapLeft:Ze,minimapWidth:Se,minimapHeightIsEditorHeight:At,minimapIsSampling:Bt,minimapScale:St,minimapLineHeight:Ke,minimapCanvasInnerWidth:se,minimapCanvasInnerHeight:wt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:kt}}static computeLayout(Q,ge){const Le=ge.outerWidth|0,Ne=ge.outerHeight|0,je=ge.lineHeight|0,Ye=ge.lineNumbersDigitCount|0,Xe=ge.typicalHalfwidthCharacterWidth,nt=ge.maxDigitWidth,ot=ge.pixelRatio,pt=ge.viewLineCount,bt=Q.get(130),St=bt==="inherit"?Q.get(129):bt,Pt=St==="inherit"?Q.get(125):St,zt=Q.get(128),Xt=ge.isDominatedByLongLines,ft=Q.get(54),vt=Q.get(64).renderType!==0,Ot=Q.get(65),Ut=Q.get(99),Nt=Q.get(80),wt=Q.get(69),kt=Q.get(97),At=kt.verticalScrollbarSize,Bt=kt.verticalHasArrows,Ke=kt.arrowSize,Wt=kt.horizontalScrollbarSize,Re=Q.get(40),Fe=Q.get(104)!=="never";let Se=Q.get(62);Re&&Fe&&(Se+=16);let se=0;if(vt){const ai=Math.max(Ye,Ot);se=Math.round(ai*nt)}let Oe=0;ft&&(Oe=je);let He=0,Ze=He+Oe,Ge=Ze+se,ct=Ge+Se;const mt=Le-Oe-se-Se;let gt=!1,dt=!1,lt=-1;St==="inherit"&&Xt?(gt=!0,dt=!0):Pt==="on"||Pt==="bounded"?dt=!0:Pt==="wordWrapColumn"&&(lt=zt);const yt=V.c({outerWidth:Le,outerHeight:Ne,lineHeight:je,typicalHalfwidthCharacterWidth:Xe,pixelRatio:ot,scrollBeyondLastLine:Ut,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:wt,verticalScrollbarWidth:At,viewLineCount:pt,remainingWidth:mt,isViewportWrapping:dt},ge.memory||new L);yt.renderMinimap!==0&&yt.minimapLeft===0&&(He+=yt.minimapWidth,Ze+=yt.minimapWidth,Ge+=yt.minimapWidth,ct+=yt.minimapWidth);const Tt=mt-yt.minimapWidth,Ht=Math.max(1,Math.floor((Tt-At-2)/Xe)),Ft=Bt?Ke:0;return dt&&(lt=Math.max(1,Ht),Pt==="bounded"&&(lt=Math.min(lt,zt))),{width:Le,height:Ne,glyphMarginLeft:He,glyphMarginWidth:Oe,lineNumbersLeft:Ze,lineNumbersWidth:se,decorationsLeft:Ge,decorationsWidth:Se,contentLeft:ct,contentWidth:Tt,minimap:yt,viewportColumn:Ht,isWordWrapMinified:gt,isViewportWrapping:dt,wrappingColumn:lt,verticalScrollbarWidth:At,horizontalScrollbarHeight:Wt,overviewRuler:{top:Ft,width:At,height:Ne-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=V;class J extends T{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate(Q){return t(Q,"simple",["simple","advanced"])}compute(Q,ge,Le){return ge.get(2)===2?"advanced":Le}}class ne extends T{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:c.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:n(Q.enabled,this.defaultValue.enabled)}}}class ve extends T{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:n(ge.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ue extends T{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:c.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:t(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ge.fontFamily,this.defaultValue.fontFamily),padding:n(ge.padding,this.defaultValue.padding)}}}class ee extends T{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):v.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Le){return Le<0?v.clampedInt(-Le*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class N extends D{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>D.clamp(Q,0,150),{markdownDescription:c.localize(60,null)})}compute(Q,ge,Le){return Q.fontInfo.lineHeight}}class q extends T{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:Q.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:c.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:n(ge.enabled,this.defaultValue.enabled),autohide:n(ge.autohide,this.defaultValue.autohide),size:t(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ge.side,this.defaultValue.side,["right","left"]),showSlider:t(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(ge.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(ge.scale,1,1,3),maxColumn:v.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ae(W){return W==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends T{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:v.clampedInt(ge.top,0,0,1e3),bottom:v.clampedInt(ge.bottom,0,0,1e3)}}}class ke extends T{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:c.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:n(ge.enabled,this.defaultValue.enabled),cycle:n(ge.cycle,this.defaultValue.cycle)}}}class _ extends C{constructor(){super(136)}compute(Q,ge,Le){return Q.pixelRatio}}class le extends T{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:c.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:c.localize(80,null)},other:{anyOf:ge,default:Q.other,description:c.localize(81,null)}},default:Q,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ot=Q?"on":"off";return{comments:ot,strings:ot,other:ot}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Le,strings:Ne}=Q,je=["on","inline","off"];let Ye,Xe,nt;return typeof ge=="boolean"?Ye=ge?"on":"off":Ye=t(ge,this.defaultValue.other,je),typeof Le=="boolean"?Xe=Le?"on":"off":Xe=t(Le,this.defaultValue.comments,je),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=t(Ne,this.defaultValue.strings,je),{other:Ye,comments:Xe,strings:nt}}}var de;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class te extends T{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Le=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Le}}}function ce(W){const Q=W.get(92);return Q==="editable"?W.get(86):Q!=="on"}e.filterValidationDecorations=ce;class oe extends T{constructor(){const Q=[],ge={type:"number",description:c.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:Q,description:c.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Le of Q)if(typeof Le=="number")ge.push({column:v.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;ge.push({column:v.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ge.sort((Le,Ne)=>Le.column-Ne.column),ge}return this.defaultValue}}function F(W,Q){if(typeof W!="string")return Q;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends T{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:c.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Le=v.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=v.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:F(ge.vertical,this.defaultValue.vertical),horizontal:F(ge.horizontal,this.defaultValue.horizontal),useShadows:n(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:v.clampedInt(ge.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:v.clampedInt(ge.verticalSliderSize,Ne,0,1e3),scrollByPage:n(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends T{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:c.localize(108,null)}})}applyUpdate(Q,ge){let Le=!1;ge.allowedCharacters&&Q&&(P.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Le=!0)),ge.allowedLocales&&Q&&(P.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Le=!0));const Ne=super.applyUpdate(Q,ge);return Le?new S(Ne.newValue,!0):Ne}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:Ae(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Le={};for(const[Ne,je]of Object.entries(Q))je===!0&&(Le[Ne]=!0);return Le}}class Z extends T{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:c.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(110,null),c.localize(111,null)],description:c.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:n(ge.enabled,this.defaultValue.enabled),mode:t(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class fe extends T{constructor(){const Q={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:c.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:c.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:n(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ee extends T{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(115,null),c.localize(116,null),c.localize(117,null)],default:Q.bracketPairs,description:c.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:Q.bracketPairsHorizontal,description:c.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:c.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:c.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(125,null),c.localize(126,null),c.localize(127,null)],default:Q.highlightActiveIndentation,description:c.localize(128,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:Ae(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(W,Q,ge){const Le=ge.indexOf(W);return Le===-1?Q:ge[Le]}class we extends T{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(129,null),c.localize(130,null)],default:Q.insertMode,description:c.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:c.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:c.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:c.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(135,null),c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:Q.selectionMode,markdownDescription:c.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:c.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:c.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:c.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:c.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:c.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:t(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(ge.showIcons,this.defaultValue.showIcons),showStatusBar:n(ge.showStatusBar,this.defaultValue.showStatusBar),preview:n(ge.preview,this.defaultValue.preview),previewMode:t(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(ge.showMethods,this.defaultValue.showMethods),showFunctions:n(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:n(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(ge.showFields,this.defaultValue.showFields),showVariables:n(ge.showVariables,this.defaultValue.showVariables),showClasses:n(ge.showClasses,this.defaultValue.showClasses),showStructs:n(ge.showStructs,this.defaultValue.showStructs),showInterfaces:n(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:n(ge.showModules,this.defaultValue.showModules),showProperties:n(ge.showProperties,this.defaultValue.showProperties),showEvents:n(ge.showEvents,this.defaultValue.showEvents),showOperators:n(ge.showOperators,this.defaultValue.showOperators),showUnits:n(ge.showUnits,this.defaultValue.showUnits),showValues:n(ge.showValues,this.defaultValue.showValues),showConstants:n(ge.showConstants,this.defaultValue.showConstants),showEnums:n(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:n(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(ge.showKeywords,this.defaultValue.showKeywords),showWords:n(ge.showWords,this.defaultValue.showWords),showColors:n(ge.showColors,this.defaultValue.showColors),showFiles:n(ge.showFiles,this.defaultValue.showFiles),showReferences:n(ge.showReferences,this.defaultValue.showReferences),showFolders:n(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:n(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(ge.showSnippets,this.defaultValue.showSnippets),showUsers:n(ge.showUsers,this.defaultValue.showUsers),showIssues:n(ge.showIssues,this.defaultValue.showIssues)}}}class Pe extends T{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(177,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ie;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(Ie=e.WrappingIndent||(e.WrappingIndent={}));class $e extends T{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(178,null),c.localize(179,null),c.localize(180,null),c.localize(181,null)],description:c.localize(182,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Le){return ge.get(2)===2?0:Le}}class xe extends C{constructor(){super(139)}compute(Q,ge,Le){const Ne=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class tt extends T{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:c.localize(183,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:n(Q.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?it:A.isLinux?rt:Qe,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(W){return e.editorOptionsRegistry[W.id]=W,W}var et;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.autoClosingDelete=6]="autoClosingDelete",W[W.autoClosingOvertype=7]="autoClosingOvertype",W[W.autoClosingQuotes=8]="autoClosingQuotes",W[W.autoIndent=9]="autoIndent",W[W.automaticLayout=10]="automaticLayout",W[W.autoSurround=11]="autoSurround",W[W.bracketPairColorization=12]="bracketPairColorization",W[W.guides=13]="guides",W[W.codeLens=14]="codeLens",W[W.codeLensFontFamily=15]="codeLensFontFamily",W[W.codeLensFontSize=16]="codeLensFontSize",W[W.colorDecorators=17]="colorDecorators",W[W.colorDecoratorsLimit=18]="colorDecoratorsLimit",W[W.columnSelection=19]="columnSelection",W[W.comments=20]="comments",W[W.contextmenu=21]="contextmenu",W[W.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",W[W.cursorBlinking=23]="cursorBlinking",W[W.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",W[W.cursorStyle=25]="cursorStyle",W[W.cursorSurroundingLines=26]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",W[W.cursorWidth=28]="cursorWidth",W[W.disableLayerHinting=29]="disableLayerHinting",W[W.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",W[W.domReadOnly=31]="domReadOnly",W[W.dragAndDrop=32]="dragAndDrop",W[W.dropIntoEditor=33]="dropIntoEditor",W[W.emptySelectionClipboard=34]="emptySelectionClipboard",W[W.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",W[W.extraEditorClassName=36]="extraEditorClassName",W[W.fastScrollSensitivity=37]="fastScrollSensitivity",W[W.find=38]="find",W[W.fixedOverflowWidgets=39]="fixedOverflowWidgets",W[W.folding=40]="folding",W[W.foldingStrategy=41]="foldingStrategy",W[W.foldingHighlight=42]="foldingHighlight",W[W.foldingImportsByDefault=43]="foldingImportsByDefault",W[W.foldingMaximumRegions=44]="foldingMaximumRegions",W[W.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=46]="fontFamily",W[W.fontInfo=47]="fontInfo",W[W.fontLigatures=48]="fontLigatures",W[W.fontSize=49]="fontSize",W[W.fontWeight=50]="fontWeight",W[W.fontVariations=51]="fontVariations",W[W.formatOnPaste=52]="formatOnPaste",W[W.formatOnType=53]="formatOnType",W[W.glyphMargin=54]="glyphMargin",W[W.gotoLocation=55]="gotoLocation",W[W.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",W[W.hover=57]="hover",W[W.inDiffEditor=58]="inDiffEditor",W[W.inlineSuggest=59]="inlineSuggest",W[W.letterSpacing=60]="letterSpacing",W[W.lightbulb=61]="lightbulb",W[W.lineDecorationsWidth=62]="lineDecorationsWidth",W[W.lineHeight=63]="lineHeight",W[W.lineNumbers=64]="lineNumbers",W[W.lineNumbersMinChars=65]="lineNumbersMinChars",W[W.linkedEditing=66]="linkedEditing",W[W.links=67]="links",W[W.matchBrackets=68]="matchBrackets",W[W.minimap=69]="minimap",W[W.mouseStyle=70]="mouseStyle",W[W.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=72]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",W[W.multiCursorModifier=74]="multiCursorModifier",W[W.multiCursorPaste=75]="multiCursorPaste",W[W.multiCursorLimit=76]="multiCursorLimit",W[W.occurrencesHighlight=77]="occurrencesHighlight",W[W.overviewRulerBorder=78]="overviewRulerBorder",W[W.overviewRulerLanes=79]="overviewRulerLanes",W[W.padding=80]="padding",W[W.parameterHints=81]="parameterHints",W[W.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",W[W.quickSuggestions=84]="quickSuggestions",W[W.quickSuggestionsDelay=85]="quickSuggestionsDelay",W[W.readOnly=86]="readOnly",W[W.renameOnType=87]="renameOnType",W[W.renderControlCharacters=88]="renderControlCharacters",W[W.renderFinalNewline=89]="renderFinalNewline",W[W.renderLineHighlight=90]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=92]="renderValidationDecorations",W[W.renderWhitespace=93]="renderWhitespace",W[W.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",W[W.roundedSelection=95]="roundedSelection",W[W.rulers=96]="rulers",W[W.scrollbar=97]="scrollbar",W[W.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=99]="scrollBeyondLastLine",W[W.scrollPredominantAxis=100]="scrollPredominantAxis",W[W.selectionClipboard=101]="selectionClipboard",W[W.selectionHighlight=102]="selectionHighlight",W[W.selectOnLineNumbers=103]="selectOnLineNumbers",W[W.showFoldingControls=104]="showFoldingControls",W[W.showUnused=105]="showUnused",W[W.snippetSuggestions=106]="snippetSuggestions",W[W.smartSelect=107]="smartSelect",W[W.smoothScrolling=108]="smoothScrolling",W[W.stickyScroll=109]="stickyScroll",W[W.stickyTabStops=110]="stickyTabStops",W[W.stopRenderingLineAfter=111]="stopRenderingLineAfter",W[W.suggest=112]="suggest",W[W.suggestFontSize=113]="suggestFontSize",W[W.suggestLineHeight=114]="suggestLineHeight",W[W.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",W[W.suggestSelection=116]="suggestSelection",W[W.tabCompletion=117]="tabCompletion",W[W.tabIndex=118]="tabIndex",W[W.unicodeHighlighting=119]="unicodeHighlighting",W[W.unusualLineTerminators=120]="unusualLineTerminators",W[W.useShadowDOM=121]="useShadowDOM",W[W.useTabStops=122]="useTabStops",W[W.wordBreak=123]="wordBreak",W[W.wordSeparators=124]="wordSeparators",W[W.wordWrap=125]="wordWrap",W[W.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=128]="wordWrapColumn",W[W.wordWrapOverride1=129]="wordWrapOverride1",W[W.wordWrapOverride2=130]="wordWrapOverride2",W[W.wrappingIndent=131]="wrappingIndent",W[W.wrappingStrategy=132]="wrappingStrategy",W[W.showDeprecated=133]="showDeprecated",W[W.inlayHints=134]="inlayHints",W[W.editorClassName=135]="editorClassName",W[W.pixelRatio=136]="pixelRatio",W[W.tabFocusMode=137]="tabFocusMode",W[W.layoutInfo=138]="layoutInfo",W[W.wrappingInfo=139]="wrappingInfo"})(et=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(184,null)})),acceptSuggestionOnEnter:Be(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(185,null),""],markdownDescription:c.localize(186,null)})),accessibilitySupport:Be(new l),accessibilityPageSize:Be(new v(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new b(4,"ariaLabel",c.localize(188,null))),autoClosingBrackets:Be(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(189,null),c.localize(190,null),""],description:c.localize(191,null)})),autoClosingDelete:Be(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(192,null),""],description:c.localize(193,null)})),autoClosingOvertype:Be(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(194,null),""],description:c.localize(195,null)})),autoClosingQuotes:Be(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(196,null),c.localize(197,null),""],description:c.localize(198,null)})),autoIndent:Be(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[c.localize(199,null),c.localize(200,null),c.localize(201,null),c.localize(202,null),c.localize(203,null)],description:c.localize(204,null)})),automaticLayout:Be(new d(10,"automaticLayout",!1)),autoSurround:Be(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(205,null),c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),bracketPairColorization:Be(new fe),bracketPairGuides:Be(new Ee),stickyTabStops:Be(new d(110,"stickyTabStops",!1,{description:c.localize(209,null)})),codeLens:Be(new d(14,"codeLens",!0,{description:c.localize(210,null)})),codeLensFontFamily:Be(new b(15,"codeLensFontFamily","",{description:c.localize(211,null)})),codeLensFontSize:Be(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(212,null)})),colorDecorators:Be(new d(17,"colorDecorators",!0,{description:c.localize(213,null)})),colorDecoratorsLimit:Be(new v(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(214,null)})),columnSelection:Be(new d(19,"columnSelection",!1,{description:c.localize(215,null)})),comments:Be(new E),contextmenu:Be(new d(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new d(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(216,null)})),cursorBlinking:Be(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:c.localize(217,null)})),cursorSmoothCaretAnimation:Be(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(218,null),c.localize(219,null),c.localize(220,null)],description:c.localize(221,null)})),cursorStyle:Be(new s(25,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:c.localize(222,null)})),cursorSurroundingLines:Be(new v(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(223,null)})),cursorSurroundingLinesStyle:Be(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(224,null),c.localize(225,null)],description:c.localize(226,null)})),cursorWidth:Be(new v(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(227,null)})),disableLayerHinting:Be(new d(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new d(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new d(31,"domReadOnly",!1)),dragAndDrop:Be(new d(32,"dragAndDrop",!0,{description:c.localize(228,null)})),emptySelectionClipboard:Be(new $),dropIntoEditor:Be(new tt),stickyScroll:Be(new ve),experimentalWhitespaceRendering:Be(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(229,null),c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),extraEditorClassName:Be(new b(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new D(37,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:c.localize(233,null)})),find:Be(new x),fixedOverflowWidgets:Be(new d(39,"fixedOverflowWidgets",!1)),folding:Be(new d(40,"folding",!0,{description:c.localize(234,null)})),foldingStrategy:Be(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(235,null),c.localize(236,null)],description:c.localize(237,null)})),foldingHighlight:Be(new d(42,"foldingHighlight",!0,{description:c.localize(238,null)})),foldingImportsByDefault:Be(new d(43,"foldingImportsByDefault",!1,{description:c.localize(239,null)})),foldingMaximumRegions:Be(new v(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new d(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(241,null)})),fontFamily:Be(new b(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(242,null)})),fontInfo:Be(new M),fontLigatures2:Be(new Y),fontSize:Be(new B),fontWeight:Be(new U),fontVariations:Be(new G),formatOnPaste:Be(new d(52,"formatOnPaste",!1,{description:c.localize(243,null)})),formatOnType:Be(new d(53,"formatOnType",!1,{description:c.localize(244,null)})),glyphMargin:Be(new d(54,"glyphMargin",!0,{description:c.localize(245,null)})),gotoLocation:Be(new j),hideCursorInOverviewRuler:Be(new d(56,"hideCursorInOverviewRuler",!1,{description:c.localize(246,null)})),hover:Be(new he),inDiffEditor:Be(new d(58,"inDiffEditor",!1)),letterSpacing:Be(new D(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>D.clamp(W,-5,20),{description:c.localize(247,null)})),lightbulb:Be(new ne),lineDecorationsWidth:Be(new ee),lineHeight:Be(new N),lineNumbers:Be(new te),lineNumbersMinChars:Be(new v(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new d(66,"linkedEditing",!1,{description:c.localize(248,null)})),links:Be(new d(67,"links",!0,{description:c.localize(249,null)})),matchBrackets:Be(new o(68,"matchBrackets","always",["always","near","never"],{description:c.localize(250,null)})),minimap:Be(new q),mouseStyle:Be(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new D(71,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:c.localize(251,null)})),mouseWheelZoom:Be(new d(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(252,null)})),multiCursorMergeOverlapping:Be(new d(73,"multiCursorMergeOverlapping",!0,{description:c.localize(253,null)})),multiCursorModifier:Be(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ae,{markdownEnumDescriptions:[c.localize(254,null),c.localize(255,null)],markdownDescription:c.localize(256,null)})),multiCursorPaste:Be(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(257,null),c.localize(258,null)],markdownDescription:c.localize(259,null)})),multiCursorLimit:Be(new v(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(260,null)})),occurrencesHighlight:Be(new d(77,"occurrencesHighlight",!0,{description:c.localize(261,null)})),overviewRulerBorder:Be(new d(78,"overviewRulerBorder",!0,{description:c.localize(262,null)})),overviewRulerLanes:Be(new v(79,"overviewRulerLanes",3,0,3)),padding:Be(new me),parameterHints:Be(new ke),peekWidgetDefaultFocus:Be(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],description:c.localize(265,null)})),definitionLinkOpensInPeek:Be(new d(83,"definitionLinkOpensInPeek",!1,{description:c.localize(266,null)})),quickSuggestions:Be(new le),quickSuggestionsDelay:Be(new v(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(267,null)})),readOnly:Be(new d(86,"readOnly",!1)),renameOnType:Be(new d(87,"renameOnType",!1,{description:c.localize(268,null),markdownDeprecationMessage:c.localize(269,null)})),renderControlCharacters:Be(new d(88,"renderControlCharacters",!0,{description:c.localize(270,null),restricted:!0})),renderFinalNewline:Be(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(271,null)})),renderLineHighlight:Be(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(272,null)],description:c.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new d(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(274,null)})),renderValidationDecorations:Be(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(275,null),c.localize(276,null),c.localize(277,null),""],description:c.localize(278,null)})),revealHorizontalRightPadding:Be(new v(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new d(95,"roundedSelection",!0,{description:c.localize(279,null)})),rulers:Be(new oe),scrollbar:Be(new z),scrollBeyondLastColumn:Be(new v(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(280,null)})),scrollBeyondLastLine:Be(new d(99,"scrollBeyondLastLine",!0,{description:c.localize(281,null)})),scrollPredominantAxis:Be(new d(100,"scrollPredominantAxis",!0,{description:c.localize(282,null)})),selectionClipboard:Be(new d(101,"selectionClipboard",!0,{description:c.localize(283,null),included:A.isLinux})),selectionHighlight:Be(new d(102,"selectionHighlight",!0,{description:c.localize(284,null)})),selectOnLineNumbers:Be(new d(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(285,null),c.localize(286,null),c.localize(287,null)],description:c.localize(288,null)})),showUnused:Be(new d(105,"showUnused",!0,{description:c.localize(289,null)})),showDeprecated:Be(new d(133,"showDeprecated",!0,{description:c.localize(290,null)})),inlayHints:Be(new ue),snippetSuggestions:Be(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(291,null),c.localize(292,null),c.localize(293,null),c.localize(294,null)],description:c.localize(295,null)})),smartSelect:Be(new Pe),smoothScrolling:Be(new d(108,"smoothScrolling",!1,{description:c.localize(296,null)})),stopRenderingLineAfter:Be(new v(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new we),inlineSuggest:Be(new Z),suggestFontSize:Be(new v(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new v(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new d(115,"suggestOnTriggerCharacters",!0,{description:c.localize(299,null)})),suggestSelection:Be(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(300,null),c.localize(301,null),c.localize(302,null)],description:c.localize(303,null)})),tabCompletion:Be(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(304,null),c.localize(305,null),c.localize(306,null)],description:c.localize(307,null)})),tabIndex:Be(new v(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new K),unusualLineTerminators:Be(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(308,null),c.localize(309,null),c.localize(310,null)],description:c.localize(311,null)})),useShadowDOM:Be(new d(121,"useShadowDOM",!0)),useTabStops:Be(new d(122,"useTabStops",!0,{description:c.localize(312,null)})),wordBreak:Be(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(313,null),c.localize(314,null)],description:c.localize(315,null)})),wordSeparators:Be(new b(124,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:c.localize(316,null)})),wordWrap:Be(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(317,null),c.localize(318,null),c.localize(319,null),c.localize(320,null)],description:c.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new b(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new b(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new v(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(322,null)})),wordWrapOverride1:Be(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new O),pixelRatio:Be(new _),tabFocusMode:Be(new d(137,"tabFocusMode",!1,{markdownDescription:c.localize(323,null)})),layoutInfo:Be(new V),wrappingInfo:Be(new xe),wrappingIndent:Be(new $e),wrappingStrategy:Be(new J)}}),define(De[171],Ce([14,15]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[172],Ce([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(De[173],Ce([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(De[174],Ce([14,15]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[175],Ce([14,15]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[176],Ce([14,15]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[177],Ce([14,15]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(De[178],Ce([14,15]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(De[179],Ce([14,15]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(De[180],Ce([14,15]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(De[181],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[182],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[183],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(De[184],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(De[185],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[186],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[187],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[188],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[189],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[190],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[191],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[192],Ce([14,15]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(De[193],Ce([14,15]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(De[194],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[195],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[196],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[197],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[198],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[199],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[200],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[201],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[202],Ce([1,0,9,173]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var u;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(u=e.TokenType||(e.TokenType={}));function R(...p){switch(p.length){case 1:return(0,A.localize)(0,null,p[0]);case 2:return(0,A.localize)(1,null,p[0],p[1]);case 3:return(0,A.localize)(2,null,p[0],p[1],p[2]);default:return}}const P=(0,A.localize)(3,null),k=(0,A.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,c.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const T=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:T})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const T=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:T})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const T=this.d,S=this.c.substring(this.d,this.e),I={type:19,offset:this.d,lexeme:S};this.g.push({offset:T,lexeme:S,additionalInfo:L}),this.f.push(I)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const T=this.c.substring(this.d,this.e),S=y.b.get(T);S?this.k(S):this.f.push({type:17,lexeme:T,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,T=!1,S=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(k);return}const C=this.c.charCodeAt(L);if(T)T=!1;else if(C===47&&!S){L++;break}else C===91?S=!0:C===92?T=!0:C===93&&(S=!1);L++}for(;L<this.c.length&&y.a.has(this.c.charCodeAt(L));)L++;this.e=L;const I=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:I,offset:this.d})}r(){return this.e>=this.c.length}}y.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0))),y.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=y}),define(De[203],Ce([1,0,24,37,175,325]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||P.test(d)}e.isValidVersionStr=y;function p(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(P);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=p;function L(d){if(!d)return null;const f=d.majorBase,v=d.majorMustEqual,D=d.minorBase;let b=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(f===0||(b=!1),o=!1);let s=0;if(d.preRelease){const a=k.exec(d.preRelease);if(a){const[,l,E,i]=a;s=Date.UTC(Number(l),Number(E)-1,Number(i))}}return{majorBase:f,majorMustEqual:v,minorBase:D,minorMustEqual:b,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function T(d,f,v){let D;typeof d=="string"?D=L(p(d)):D=d;let b;f instanceof Date?b=f.getTime():typeof f=="string"&&(b=new Date(f).getTime());let t;if(typeof v=="string"?t=L(p(v)):t=v,!D||!t)return!1;const o=D.majorBase,s=D.minorBase,a=D.patchBase;let l=t.majorBase,E=t.minorBase,i=t.patchBase;const r=t.notBefore;let m=t.majorMustEqual,g=t.minorMustEqual,h=t.patchMustEqual;return t.isMinimum?o>l?!0:o<l?!1:s>E?!0:s<E||b&&b<r?!1:a>=i:(o===1&&l===0&&(!m||!g||!h)&&(l=1,E=0,i=0,m=!0,g=!1,h=!1),o<l?!1:o>l?!m:s<E?!1:s>E?!g:a<i?!1:a>i?!h:!(b&&b<r))}e.isValidVersion=T;function S(d,f,v,D,b){const t=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return t.push([A.default.Error,u.localize(0,null)]),t;if(typeof D.name!="string")return t.push([A.default.Error,u.localize(1,null,"name")]),t;if(typeof D.version!="string")return t.push([A.default.Error,u.localize(2,null,"version")]),t;if(!D.engines)return t.push([A.default.Error,u.localize(3,null,"engines")]),t;if(typeof D.engines.vscode!="string")return t.push([A.default.Error,u.localize(4,null,"engines.vscode")]),t;if(typeof D.extensionDependencies<"u"&&!n(D.extensionDependencies))return t.push([A.default.Error,u.localize(5,null,"extensionDependencies")]),t;if(typeof D.activationEvents<"u"){if(!n(D.activationEvents))return t.push([A.default.Error,u.localize(6,null,"activationEvents")]),t;if(typeof D.main>"u"&&typeof D.browser>"u")return t.push([A.default.Error,u.localize(7,null,"activationEvents","main")]),t}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&t.push([A.default.Warning,u.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return t.push([A.default.Error,u.localize(9,null,"main")]),t;{const a=(0,c.joinPath)(v,D.main);(0,c.isEqualOrParent)(a,v)||t.push([A.default.Warning,u.localize(10,null,a.path,v.path)])}if(typeof D.activationEvents>"u")return t.push([A.default.Error,u.localize(11,null,"activationEvents","main")]),t}if(typeof D.browser<"u"){if(typeof D.browser!="string")return t.push([A.default.Error,u.localize(12,null,"browser")]),t;{const a=(0,c.joinPath)(v,D.browser);(0,c.isEqualOrParent)(a,v)||t.push([A.default.Warning,u.localize(13,null,a.path,v.path)])}if(typeof D.activationEvents>"u")return t.push([A.default.Error,u.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(D.version))return t.push([A.default.Error,u.localize(15,null)]),t;const o=[];if(!I(d,f,D,b,o))for(const a of o)t.push([A.default.Error,a]);return t}e.validateExtensionManifest=S;function I(d,f,v,D,b){return D||typeof v.main>"u"&&typeof v.browser>"u"?!0:w(d,f,v.engines.vscode,b)}e.isValidExtensionVersion=I;function C(d,f,v){return d==="*"||w(f,v,d)}e.isEngineValid=C;function w(d,f,v,D=[]){const b=L(p(v));if(!b)return D.push(u.localize(16,null,v)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return D.push(u.localize(17,null,v)),!1}else if(!b.majorMustEqual)return D.push(u.localize(18,null,v)),!1;return T(d,f,b)?!0:(D.push(u.localize(19,null,d,v)),!1)}function n(d){if(!Array.isArray(d))return!1;for(let f=0,v=d.length;f<v;f++)if(typeof d[f]!="string")return!1;return!0}}),define(De[90],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(u,R=[],P=!1){this.ctor=u,this.staticArguments=R,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=c}),define(De[91],Ce([1,0,90]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var u;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(u=e.InstantiationType||(e.InstantiationType={}));function R(k,y,p){y instanceof c.SyncDescriptor||(y=new c.SyncDescriptor(y,[],Boolean(p))),A.push([k,y])}e.registerSingleton=R;function P(){return A}e.getSingletonServiceDescriptors=P}),define(De[204],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R,P){this.key=R,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const P of this.a.values())P.outgoing.size===0&&R.push(P);return R}insertEdge(R,P){const k=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(P);k.outgoing.set(y.key,y),y.incoming.set(k.key,k)}removeNode(R){const P=this.b(R);this.a.delete(P);for(const k of this.a.values())k.outgoing.delete(P),k.incoming.delete(P)}lookupOrInsertNode(R){const P=this.b(R);let k=this.a.get(P);return k||(k=new c(P,R),this.a.set(P,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[P,k]of this.a)R.push(`${P}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,P]of this.a){const k=new Set([R]),y=this.c(P,k);if(y)return y}}c(R,P){for(const[k,y]of R.outgoing){if(P.has(k))return[...P,k].join(" -> ");P.add(k);const p=this.c(y,P);if(p)return p;P.delete(k)}}}e.Graph=A}),define(De[4],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function k(y){return y[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=k})(c=e._util||(e._util={})),e.IInstantiationService=u("instantiationService");function A(P,k,y){k[c.DI_TARGET]===k?k[c.DI_DEPENDENCIES].push({id:P,index:y}):(k[c.DI_DEPENDENCIES]=[{id:P,index:y}],k[c.DI_TARGET]=k)}function u(P){if(c.serviceIds.has(P))return c.serviceIds.get(P);const k=function(y,p,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(k,y,L)};return k.toString=()=>P,c.serviceIds.set(P,k),k}e.createDecorator=u;function R(P){return P}e.refineServiceDecorator=R}),define(De[54],Ce([1,0,10,2,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function R(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=R;function P(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=P;var k;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function p(n,d){const f=Object.create(null);for(const v in n)L(f,v,n[v],d);return f}e.toValuesTree=p;function L(n,d,f,v){const D=d.split("."),b=D.pop();let t=n;for(let o=0;o<D.length;o++){const s=D[o];let a=t[s];switch(typeof a){case"undefined":a=t[s]=Object.create(null);break;case"object":break;default:v(`Ignoring ${d} as ${D.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[b]=f}catch{v(`Ignoring ${d} as ${D.join(".")} is ${JSON.stringify(t)}`)}else v(`Ignoring ${d} as ${D.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=L;function T(n,d){const f=d.split(".");S(n,f)}e.removeFromValueTree=T;function S(n,d){const f=d.shift();if(d.length===0){delete n[f];return}if(Object.keys(n).indexOf(f)!==-1){const v=n[f];typeof v=="object"&&!Array.isArray(v)&&(S(v,d),Object.keys(v).length===0&&delete n[f])}}function I(n,d,f){function v(t,o){let s=t;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const D=d.split("."),b=v(n,D);return typeof b>"u"?f:b}e.getConfigurationValue=I;function C(n,d,f){Object.keys(d).forEach(v=>{v!=="__proto__"&&(v in n?c.isObject(n[v])&&c.isObject(d[v])?C(n[v],d[v],f):f&&(n[v]=d[v]):n[v]=d[v])})}e.merge=C;function w(n){return n.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(De[44],Ce([1,0,11,8,202,4,172]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",c.isMacintosh),k.set("isLinux",c.isLinux),k.set("isWindows",c.isWindows),k.set("isWeb",c.isWeb),k.set("isMacNative",c.isMacintosh&&!c.isWeb),k.set("isEdge",c.isEdge),k.set("isFirefox",c.isFirefox),k.set("isChrome",c.isChrome),k.set("isSafari",c.isSafari);const y=Object.prototype.hasOwnProperty;var p;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class L{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(N){return E.create(N)}static equals(N,q){return i.create(N,q)}static notEquals(N,q){return g.create(N,q)}static regex(N,q){return M.create(N,q)}static in(N,q){return r.create(N,q)}static notIn(N,q){return m.create(N,q)}static not(N){return h.create(N)}static and(...N){return j.create(N,null,!0)}static or(...N){return he.create(N,null,!0)}static greater(N,q){return $.create(N,q)}static greaterEquals(N,q){return x.create(N,q)}static smaller(N,q){return Y.create(N,q)}static smallerEquals(N,q){return G.create(N,q)}static deserialize(N){if(!!N)return this.c(N)}static c(N){const q=N.split("||");return he.create(q.map(ae=>this.d(ae)),null,!0)}static d(N){const q=N.split("&&");return j.create(q.map(ae=>this.f(ae)),null,!0)}static f(N){if(N=N.trim(),N.indexOf("!=")>=0){const q=N.split("!=");return g.create(q[0].trim(),this.g(q[1]))}if(N.indexOf("==")>=0){const q=N.split("==");return i.create(q[0].trim(),this.g(q[1]))}if(N.indexOf("=~")>=0){const q=N.split("=~");return M.create(q[0].trim(),this.h(q[1]))}if(N.indexOf(" not in ")>=0){const q=N.split(" not in ");return m.create(q[0].trim(),this.g(q[1]))}if(N.indexOf(" in ")>=0){const q=N.split(" in ");return r.create(q[0].trim(),this.g(q[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const q=N.split(">=");return x.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const q=N.split(">");return $.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const q=N.split("<=");return G.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const q=N.split("<");return Y.create(q[0].trim(),q[1].trim())}return/^\!\s*/.test(N)?h.create(N.substr(1).trim()):E.create(N)}static g(N){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const q=/^'([^']*)'$/.exec(N);return q?q[1].trim():N}static h(N){if((0,A.isFalsyOrWhitespace)(N))return null;const q=N.indexOf("/"),ae=N.lastIndexOf("/");if(q===ae||q<0)return null;const me=N.slice(q+1,ae),ke=N[ae+1]==="i"?"i":"";try{return new RegExp(me,ke)}catch{return null}}}e.ContextKeyExpr=L;const T={regexParsingWithErrorRecovery:!0};class S extends Error{}const I=(0,P.localize)(0,null),C=(0,P.localize)(1,null),w=(0,P.localize)(2,null),n=(0,P.localize)(3,null),d=(0,P.localize)(4,null),f=(0,P.localize)(5,null),v=(0,P.localize)(6,null),D=(0,P.localize)(7,null);class b{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(N=T){this.h=N,this.c=new u.Scanner,this.d=[],this.f=0,this.g=[]}parse(N){if(N===""){this.g.push({message:I,offset:0,lexeme:"",additionalInfo:C});return}this.d=this.c.reset(N).scan(),this.f=0,this.g=[];try{const q=this.k();if(!this.C()){const ae=this.B(),me=ae.type===17?f:void 0;throw this.g.push({message:d,offset:ae.offset,lexeme:u.Scanner.getLexeme(ae),additionalInfo:me}),new S}return q}catch(q){if(!(q instanceof S))throw q;return}}k(){return this.l()}l(){const N=[this.o()];for(;this.w(16);){const q=this.o();N.push(q)}return N.length===1?N[0]:L.or(...N)}o(){const N=[this.s()];for(;this.w(15);){const q=this.s();N.push(q)}return N.length===1?N[0]:L.and(...N)}s(){if(this.w(2)){const N=this.B();switch(N.type){case 11:return this.x(),a.INSTANCE;case 12:return this.x(),l.INSTANCE;case 0:{this.x();const q=this.k();return this.y(1,n),q?.negate()}case 17:return this.x(),h.create(N.lexeme);default:throw this.z("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.B();switch(N.type){case 11:return this.x(),L.true();case 12:return this.x(),L.false();case 0:{this.x();const q=this.k();return this.y(1,n),q}case 17:{const q=N.lexeme;if(this.x(),this.w(9)){const me=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),me.type!==10)throw this.z("REGEX",me);const ke=me.lexeme,_=ke.lastIndexOf("/"),le=_===ke.length-1?void 0:ke.substring(_+1);let de;try{de=new RegExp(ke.substring(1,_),le)}catch{throw this.z("REGEX",me)}return M.create(q,de)}switch(me.type){case 10:case 19:{const ke=[me.lexeme];this.x();let _=this.B(),le=0;for(let F=0;F<me.lexeme.length;F++)me.lexeme.charCodeAt(F)===40?le++:me.lexeme.charCodeAt(F)===41&&le--;for(;!this.C()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let F=0;F<_.lexeme.length;F++)_.lexeme.charCodeAt(F)===40?le++:me.lexeme.charCodeAt(F)===41&&le--}if(le<0)break;ke.push(u.Scanner.getLexeme(_)),this.x(),_=this.B()}const de=ke.join(""),te=de.lastIndexOf("/"),ce=te===de.length-1?void 0:de.substring(te+1);let oe;try{oe=new RegExp(de.substring(1,te),ce)}catch{throw this.z("REGEX",me)}return L.regex(q,oe)}case 18:{const ke=me.lexeme;this.x();let _=null;if(!(0,A.isFalsyOrWhitespace)(ke)){const le=ke.indexOf("/"),de=ke.lastIndexOf("/");if(le!==de&&le>=0){const te=ke.slice(le+1,de),ce=ke[de+1]==="i"?"i":"";try{_=new RegExp(te,ce)}catch{throw this.z("REGEX",me)}}}if(_===null)throw this.z("REGEX",me);return M.create(q,_)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,w);const me=this.u();return L.notIn(q,me)}switch(this.B().type){case 3:{this.x();const me=this.u();if(this.v().type===18)return L.equals(q,me);switch(me){case"true":return L.has(q);case"false":return L.not(q);default:return L.equals(q,me)}}case 4:{this.x();const me=this.u();if(this.v().type===18)return L.notEquals(q,me);switch(me){case"true":return L.not(q);case"false":return L.has(q);default:return L.notEquals(q,me)}}case 5:return this.x(),Y.create(q,this.u());case 6:return this.x(),G.create(q,this.u());case 7:return this.x(),$.create(q,this.u());case 8:return this.x(),x.create(q,this.u());case 13:return this.x(),L.in(q,this.u());default:return L.has(q)}}case 20:throw this.g.push({message:v,offset:N.offset,lexeme:"",additionalInfo:D}),new S;default:throw this.z(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const N=this.B();switch(N.type){case 17:case 18:return this.x(),N.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(N){return this.A(N)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(N,q){if(this.A(N))return this.x();throw this.z(q,this.B())}z(N,q,ae){const me=(0,P.localize)(8,null,N,u.Scanner.getLexeme(q)),ke=q.offset,_=u.Scanner.getLexeme(q);return this.g.push({message:me,offset:ke,lexeme:_,additionalInfo:ae}),new S}A(N){return this.B().type===N}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=b;function t(ee){const N=new b({regexParsingWithErrorRecovery:!1});return ee.map(q=>(N.parse(q),N.lexingErrors.length>0?N.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,P.localize)(9,null,ae.additionalInfo):(0,P.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}e.validateWhenClauses=t;function o(ee,N){const q=ee?ee.substituteConstants():void 0,ae=N?N.substituteConstants():void 0;return!q&&!ae?!0:!q||!ae?!1:q.equals(ae)}e.expressionsAreEqualWithConstantSubstitution=o;function s(ee,N){return ee.cmp(N)}class a{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return l.INSTANCE}}a.INSTANCE=new a,e.ContextKeyFalseExpr=a;class l{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return a.INSTANCE}}l.INSTANCE=new l,e.ContextKeyTrueExpr=l;class E{static create(N,q=null){const ae=k.get(N);return typeof ae=="boolean"?ae?l.INSTANCE:a.INSTANCE:new E(N,q)}constructor(N,q){this.key=N,this.c=q,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:V(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=k.get(this.key);return typeof N=="boolean"?N?l.INSTANCE:a.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=h.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=E;class i{static create(N,q,ae=null){if(typeof q=="boolean")return q?E.create(N,ae):h.create(N,ae);const me=k.get(N);return typeof me=="boolean"?q===(me?"true":"false")?l.INSTANCE:a.INSTANCE:new i(N,q,ae)}constructor(N,q,ae){this.c=N,this.d=q,this.f=ae,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=k.get(this.c);if(typeof N=="boolean"){const q=N?"true":"false";return this.d===q?l.INSTANCE:a.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=i;class r{static create(N,q){return new r(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:J(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.f),ae=N.getValue(this.d);return Array.isArray(q)?q.includes(ae):typeof ae=="string"&&typeof q=="object"&&q!==null?y.call(q,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=r;class m{static create(N,q){return new m(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=11,this.c=r.create(N,q)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=m;class g{static create(N,q,ae=null){if(typeof q=="boolean")return q?h.create(N,ae):E.create(N,ae);const me=k.get(N);return typeof me=="boolean"?q===(me?"true":"false")?a.INSTANCE:l.INSTANCE:new g(N,q,ae)}constructor(N,q,ae){this.c=N,this.d=q,this.f=ae,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=k.get(this.c);if(typeof N=="boolean"){const q=N?"true":"false";return this.d===q?a.INSTANCE:l.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=g;class h{static create(N,q=null){const ae=k.get(N);return typeof ae=="boolean"?ae?a.INSTANCE:l.INSTANCE:new h(N,q)}constructor(N,q){this.c=N,this.d=q,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:V(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=k.get(this.c);return typeof N=="boolean"?N?a.INSTANCE:l.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.ContextKeyNotExpr=h;function O(ee,N){if(typeof ee=="string"){const q=parseFloat(ee);isNaN(q)||(ee=q)}return typeof ee=="string"||typeof ee=="number"?N(ee):a.INSTANCE}class ${static create(N,q,ae=null){return O(q,me=>new $(N,me,ae))}constructor(N,q,ae){this.c=N,this.d=q,this.f=ae,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=$;class x{static create(N,q,ae=null){return O(q,me=>new x(N,me,ae))}constructor(N,q,ae){this.c=N,this.d=q,this.f=ae,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=x;class Y{static create(N,q,ae=null){return O(q,me=>new Y(N,me,ae))}constructor(N,q,ae){this.c=N,this.d=q,this.f=ae,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=Y;class G{static create(N,q,ae=null){return O(q,me=>new G(N,me,ae))}constructor(N,q,ae){this.c=N,this.d=q,this.f=ae,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=G;class M{static create(N,q){return new M(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const q=this.f?this.f.source:"",ae=N.f?N.f.source:"";return q<ae?-1:q>ae?1:0}equals(N){if(N.type===this.type){const q=this.f?this.f.source:"",ae=N.f?N.f.source:"";return this.d===N.d&&q===ae}return!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.ContextKeyRegexExpr=M;class B{static create(N){return new B(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new B(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=B;function U(ee){let N=null;for(let q=0,ae=ee.length;q<ae;q++){const me=ee[q].substituteConstants();if(ee[q]!==me&&N===null){N=[];for(let ke=0;ke<q;ke++)N[ke]=ee[ke]}N!==null&&(N[q]=me)}return N===null?ee:N}class j{static create(N,q,ae){return j.d(N,q,ae)}constructor(N,q){this.expr=N,this.c=q,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,ae=this.expr.length;q<ae;q++){const me=s(this.expr[q],N.expr[q]);if(me!==0)return me}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,ae=this.expr.length;q<ae;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=U(this.expr);return N===this.expr?this:j.create(N,this.c,!1)}evaluate(N){for(let q=0,ae=this.expr.length;q<ae;q++)if(!this.expr[q].evaluate(N))return!1;return!0}static d(N,q,ae){const me=[];let ke=!1;for(const _ of N)if(!!_){if(_.type===1){ke=!0;continue}if(_.type===0)return a.INSTANCE;if(_.type===6){me.push(..._.expr);continue}me.push(_)}if(me.length===0&&ke)return l.INSTANCE;if(me.length!==0){if(me.length===1)return me[0];me.sort(s);for(let _=1;_<me.length;_++)me[_-1].equals(me[_])&&(me.splice(_,1),_--);if(me.length===1)return me[0];for(;me.length>1;){const _=me[me.length-1];if(_.type!==9)break;me.pop();const le=me.pop(),de=me.length===0,te=he.create(_.expr.map(ce=>j.create([ce,le],null,ae)),null,de);te&&(me.push(te),me.sort(s))}if(me.length===1)return me[0];if(ae){for(let _=0;_<me.length;_++)for(let le=_+1;le<me.length;le++)if(me[_].negate().equals(me[le]))return a.INSTANCE;if(me.length===1)return me[0]}return new j(me,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new j(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.c){const N=[];for(const q of this.expr)N.push(q.negate());this.c=he.create(N,this,!0)}return this.c}}class he{static create(N,q,ae){return he.d(N,q,ae)}constructor(N,q){this.expr=N,this.c=q,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,ae=this.expr.length;q<ae;q++){const me=s(this.expr[q],N.expr[q]);if(me!==0)return me}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,ae=this.expr.length;q<ae;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=U(this.expr);return N===this.expr?this:he.create(N,this.c,!1)}evaluate(N){for(let q=0,ae=this.expr.length;q<ae;q++)if(this.expr[q].evaluate(N))return!0;return!1}static d(N,q,ae){let me=[],ke=!1;if(N){for(let _=0,le=N.length;_<le;_++){const de=N[_];if(!!de){if(de.type===0){ke=!0;continue}if(de.type===1)return l.INSTANCE;if(de.type===9){me=me.concat(de.expr);continue}me.push(de)}}if(me.length===0&&ke)return a.INSTANCE;me.sort(s)}if(me.length!==0){if(me.length===1)return me[0];for(let _=1;_<me.length;_++)me[_-1].equals(me[_])&&(me.splice(_,1),_--);if(me.length===1)return me[0];if(ae){for(let _=0;_<me.length;_++)for(let le=_+1;le<me.length;le++)if(me[_].negate().equals(me[le]))return l.INSTANCE;if(me.length===1)return me[0]}return new he(me,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new he(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.c){const N=[];for(const q of this.expr)N.push(q.negate());for(;N.length>1;){const q=N.shift(),ae=N.shift(),me=[];for(const ke of ue(q))for(const _ of ue(ae))me.push(j.create([ke,_],null,!1));N.unshift(he.create(me,null,!1))}this.c=he.create(N,this,!0)}return this.c}}class ie extends E{static all(){return ie.d.values()}constructor(N,q,ae){super(N,null),this.f=q,typeof ae=="object"?ie.d.push({...ae,key:N}):ae!==!0&&ie.d.push({key:N,description:ae,type:q!=null?typeof q:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return i.create(this.key,N)}notEqualsTo(N){return g.create(this.key,N)}}ie.d=[],e.RawContextKey=ie,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function V(ee,N){return ee<N?-1:ee>N?1:0}function J(ee,N,q,ae){return ee<q?-1:ee>q?1:N<ae?-1:N>ae?1:0}function ne(ee,N){if(ee.type===0||N.type===1)return!0;if(ee.type===9)return N.type===9?ve(ee.expr,N.expr):!1;if(N.type===9){for(const q of N.expr)if(ne(ee,q))return!0;return!1}if(ee.type===6){if(N.type===6)return ve(N.expr,ee.expr);for(const q of ee.expr)if(ne(q,N))return!0;return!1}return ee.equals(N)}e.implies=ne;function ve(ee,N){let q=0,ae=0;for(;q<ee.length&&ae<N.length;){const me=ee[q].cmp(N[ae]);if(me<0)return!1;me===0&&q++,ae++}return q===ee.length}function ue(ee){return ee.type===9?ee.expr:[ee]}}),define(De[205],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(De[122],Ce([1,0,174,4]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function u(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function R(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function P(d,f){switch(d){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P;function k(d,f){return f==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function y(d,f,v){return k(f,v)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===v?!0:p(v).includes(d)}e.isTargetPlatformCompatible=y;function p(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L;var T;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var I;(function(d){d.Install="install",d.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var C;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var w;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class n extends Error{constructor(f,v){super(f),this.code=v,this.name=v}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,c.localize)(1,null),original:"Preferences"}}),define(De[206],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(De[207],Ce([1,0,47,18,12,11,110,29,117,176,206]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=p.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends S{openTerminal(D,b){return this.spawnTerminal(c,D,y.getWindowsShell(),b)}spawnTerminal(D,b,t,o){const s=b.windowsExec||I.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=u.basename(s,".exe").toLowerCase();if(a==="cmder")return D.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),a==="wt"&&l.push("-d ."),new Promise((E,i)=>{const r=n(process),m=D.spawn(t,l,{cwd:o,env:r});m.on("error",i),m.on("exit",()=>E())})}runInTerminal(D,b,t,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:I.getDefaultTerminalWindows();return new Promise((l,E)=>{const i=`"${b} - ${T}"`,r=`""${t.join('" "')}" & pause"`,m=Object.assign({},n(process),o);Object.keys(m).filter(x=>m[x]===null).forEach(x=>delete m[x]);const g={cwd:b,env:m,windowsVerbatimArguments:!0};let h,O;u.basename(a,".exe")==="wt"?(h=a,O=["-d",".",I.b,"/c",r]):(h=I.b,O=["/c","start",i,"/wait",a,"/c",r]),c.spawn(h,O,g).on("error",x=>{E(d(x))}),l(void 0)})}static getDefaultTerminalWindows(){if(!I.d){const D=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${D?"Sysnative":"System32"}\\cmd.exe`}return I.d}}I.b="cmd.exe",e.WindowsExternalTerminalService=I;class C extends S{openTerminal(D,b){return this.spawnTerminal(c,D,b)}runInTerminal(D,b,t,o,s){const a=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((l,E)=>{if(a===L.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const i=a===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",D||T,"-w",b];for(const O of t)m.push("-a"),m.push(O);if(o){const O=Object.assign({},n(process),o);for(const $ in O){const x=O[$];x===null?(m.push("-u"),m.push($)):(m.push("-e"),m.push(`${$}=${x}`))}}let g="";const h=c.spawn(C.b,m);h.on("error",O=>{E(d(O))}),h.stderr.on("data",O=>{g+=O.toString()}),h.on("exit",O=>{if(O===0)l(void 0);else if(g){const $=g.split(`
`,1);E(new Error($[0]))}else E(new Error(p.localize(1,null,i,O)))})}else E(new Error(p.localize(2,null,a)))})}spawnTerminal(D,b,t){const o=b.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const l=["-a",o];t&&l.push(t);const E=n(process),i=D.spawn("/usr/bin/open",l,{cwd:t,env:E});i.on("error",a),i.on("exit",()=>s())})}}C.b="/usr/bin/osascript",e.MacExternalTerminalService=C;class w extends S{openTerminal(D,b){return this.spawnTerminal(c,D,b)}runInTerminal(D,b,t,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,E)=>{const i=[];a.then(r=>{r.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const m=`${f(t)}; echo; read -p "${w.b}" -n1;`;i.push(`''${m}''`);const g=Object.assign({},n(process),o);Object.keys(g).filter(x=>g[x]===null).forEach(x=>delete g[x]);const h={cwd:b,env:g};let O="";const $=c.spawn(r,i,h);$.on("error",x=>{E(d(x))}),$.stderr.on("data",x=>{O+=x.toString()}),$.on("exit",x=>{if(x===0)l(void 0);else if(O){const Y=O.split(`
`,1);E(new Error(Y[0]))}else E(new Error(p.localize(4,null,r,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!R.isLinux)w.d=Promise.resolve("xterm");else{const D=await k.Promises.exists("/etc/debian_version");w.d=new Promise(b=>{D?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return w.d}spawnTerminal(D,b,t){const o=b.linuxExec?Promise.resolve(b.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const E=n(process),i=D.spawn(l,[],{cwd:t,env:E});i.on("error",a),i.on("exit",()=>s())})})}}w.b=p.localize(3,null),e.LinuxExternalTerminalService=w;function n(v){const D={...v.env};return(0,P.sanitizeProcessEnvironment)(D),D}function d(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(p.localize(5,null,v.path)):v}function f(v){let D="";for(const b of v)b.indexOf(" ")>=0?D+='"'+b+'"':D+=b,D+=" ";return D}}),define(De[45],Ce([1,0,69,12,8,10,2,177,4,11,18]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(V){return V.create===!0}e.isFileOpenForWriteOptions=T;var S;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var I;(function(V){V[V.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=w;function n(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=n;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function f(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function v(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=v;function D(V){return w(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var b;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(J,ne){const ve=new t(J.toString(),ne);return a(ve,ne),ve}constructor(J,ne){super(J),this.code=ne}}e.FileSystemProviderError=t;function o(V,J){return t.create(V,J)}e.createFileSystemProviderError=o;function s(V){return V||o((0,k.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function a(V,J){return V.name=J?`${J} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=a;function l(V){if(!V)return b.Unknown;if(V instanceof t)return V.code;const J=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!J)return b.Unknown;switch(J[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=l;function E(V){if(V instanceof O)return V.fileOperationResult;switch(l(V)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=E;var i;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(J,ne,ve){this.resource=J,this.operation=ne,this.target=ve}isOperation(J){return this.operation===J}}e.FileOperationEvent=r;var m;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class g{constructor(J,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ve=new Map;for(const ue of J){const ee=ve.get(ue.type);switch(ee?ee.push([ue.resource,ue]):ve.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,ee]of ve)switch(ue){case 1:this.a=c.TernarySearchTree.forUris(()=>ne),this.a.fill(ee);break;case 0:this.b=c.TernarySearchTree.forUris(()=>ne),this.b.fill(ee);break;case 2:this.c=c.TernarySearchTree.forUris(()=>ne),this.c.fill(ee);break}}contains(J,...ne){return this.d(J,{includeChildren:!1},...ne)}affects(J,...ne){return this.d(J,{includeChildren:!0},...ne)}d(J,ne,...ve){if(!J)return!1;const ue=ve.length>0;return!!((!ue||ve.includes(1))&&(this.a?.get(J)||ne.includeChildren&&this.a?.findSuperstr(J))||(!ue||ve.includes(0))&&(this.b?.get(J)||ne.includeChildren&&this.b?.findSuperstr(J))||(!ue||ve.includes(2))&&(this.c?.findSubstr(J)||ne.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function h(V,J,ne){return!V||!J||V===J||J.length>V.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),ne?(0,u.startsWithIgnoreCase)(V,J):V.indexOf(J)===0)}e.isParent=h;class O extends Error{constructor(J,ne,ve){super(J),this.fileOperationResult=ne,this.options=ve}}e.FileOperationError=O;class $ extends O{constructor(J,ne,ve,ue){super(J,ne,ue),this.fileOperationResult=ne,this.size=ve}}e.TooLargeFileOperationError=$;class x extends O{constructor(J,ne,ve){super(J,2,ve),this.stat=ne}}e.NotModifiedSinceFileOperationError=x;var Y;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=M;async function B(V,J){if(!J.hasProvider(P.URI.from({scheme:V.scheme})))return new Promise(ne=>{const ve=J.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===V.scheme&&ue.added&&(ve.dispose(),ne())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<U.KB?(0,k.localize)(1,null,J.toFixed(0)):J<U.MB?(0,k.localize)(2,null,(J/U.KB).toFixed(2)):J<U.GB?(0,k.localize)(3,null,(J/U.MB).toFixed(2)):J<U.TB?(0,k.localize)(4,null,(J/U.GB).toFixed(2)):(0,k.localize)(5,null,(J/U.TB).toFixed(2))}}U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB,e.ByteSize=U;var j;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=he;function ie(V){const J=typeof V=="string"||V?.scheme===L.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===L.Schemas.file?1024*U.MB:J?10*U.MB:p.isWeb?50*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=ie}),define(De[92],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...u){this.a=new Map;for(const[R,P]of u)this.set(R,P)}set(u,R){const P=this.a.get(u);return this.a.set(u,R),P}has(u){return this.a.has(u)}get(u){return this.a.get(u)}}e.ServiceCollection=c}),define(De[208],Ce([1,0,19,9,6,90,204,4,92,66]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class T extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class S{constructor(n=new y.ServiceCollection,d=!1,f,v=L){this.f=n,this.g=d,this.h=f,this.i=v,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=v?f?._globalGraph??new P.Graph(D=>D):void 0}createChild(n){return new S(n,this.g,this,this.i)}invokeFunction(n,...d){const f=C.traceInvocation(this.i,n);let v=!1;try{return n({get:b=>{if(v)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(b,f);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...d)}finally{v=!0,f.stop()}}createInstance(n,...d){let f,v;return n instanceof R.SyncDescriptor?(f=C.traceCreation(this.i,n.ctor),v=this.j(n.ctor,n.staticArguments.concat(d),f)):(f=C.traceCreation(this.i,n),v=this.j(n,d,f)),f.stop(),v}j(n,d=[],f){const v=k._util.getServiceDependencies(n).sort((t,o)=>t.index-o.index),D=[];for(const t of v){const o=this.m(t.id,f);o||this.u(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),D.push(o)}const b=v.length>0?v[0].index:d.length;if(d.length!==b){console.trace(`[createInstance] First service dependency of ${n.name} at position ${b+1} conflicts with ${d.length} static arguments`);const t=b-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,b)}return Reflect.construct(n,d.concat(D))}k(n,d){if(this.f.get(n)instanceof R.SyncDescriptor)this.f.set(n,d);else if(this.h)this.h.k(n,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(n){const d=this.f.get(n);return!d&&this.h?this.h.l(n):d}m(n,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(n));const f=this.l(n);return f instanceof R.SyncDescriptor?this.q(n,f,d.branch(n,!0)):(d.branch(n,!1),f)}q(n,d,f){if(this.o.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this.o.add(n);try{return this.r(n,d,f)}finally{this.o.delete(n)}}r(n,d,f){const v=new P.Graph(t=>t.id.toString());let D=0;const b=[{id:n,desc:d,_trace:f}];for(;b.length;){const t=b.pop();if(v.lookupOrInsertNode(t),D++>1e3)throw new T(v);for(const o of k._util.getServiceDependencies(t.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${n} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof R.SyncDescriptor){const a={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};v.insertEdge(t,a),b.push(a)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new T(v);break}for(const{data:o}of t){if(this.l(o.id)instanceof R.SyncDescriptor){const a=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,a)}v.removeNode(o)}}return this.l(n)}s(n,d,f=[],v,D){if(this.f.get(n)instanceof R.SyncDescriptor)return this.t(n,d,f,v,D);if(this.h)return this.h.s(n,d,f,v,D);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(n,d,f=[],v,D){if(v){const b=new S(void 0,this.g,this,this.i);b.c=String(n);const t=new Map,o=new c.IdleValue(()=>{const s=b.j(d,f,D);for(const[a,l]of t){const E=s[a];if(typeof E=="function")for(const i of l)E.apply(s,i)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let i=t.get(a);return i||(i=new p.LinkedList,t.set(a,i)),(m,g,h)=>{const O=i.push([m,g,h]);return(0,u.toDisposable)(O)}}if(a in s)return s[a];const l=o.value;let E=l[a];return typeof E!="function"||(E=E.bind(l),s[a]=E),E},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return d.prototype}})}else return this.j(d,f,D)}u(n,d){if(d&&console.warn(n),this.g)throw new Error(n)}}e.InstantiationService=S;var I;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(I||(I={}));class C{static traceInvocation(n,d){return n?new C(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(n,d){return n?new C(1,d.name):C.c}constructor(n,d){this.type=n,this.name=d,this.g=Date.now(),this.h=[]}branch(n,d){const f=new C(3,n.toString());return this.h.push([n,d,f]),f}stop(){const n=Date.now()-this.g;C.f+=n;let d=!1;function f(D,b){const t=[],o=new Array(D+1).join("	");for(const[s,a,l]of b.h)if(a&&l){d=!0,t.push(`${o}CREATES -> ${s}`);const E=f(D+1,l);E&&t.push(E)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(n>2||d)&&C.all.add(v.join(`
`))}}C.all=new Set,C.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C.f=0,e.Trace=C}),define(De[16],Ce([1,0,46,3,68,6,28,11,24,10,2,44,4]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function I(){return new Date().toISOString()}function C(m){return(0,p.isNumber)(m)}e.isLogLevel=C;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function n(m,g,h){switch(g){case w.Trace:m.trace(h);break;case w.Debug:m.debug(h);break;case w.Info:m.info(h);break;case w.Warning:m.warn(h);break;case w.Error:m.error(h);break;case w.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=n;function d(m,g=!1){let h="";for(let O=0;O<m.length;O++){let $=m[O];if($ instanceof Error&&($=(0,c.toErrorMessage)($,g)),typeof $=="object")try{$=JSON.stringify($)}catch{}h+=(O>0?" ":"")+$}return h}class f extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==w.Off&&this.b<=g}}e.AbstractLogger=f;class v extends f{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...h){this.f(w.Trace)&&this.g(w.Trace,d([g,...h],!0))}debug(g,...h){this.f(w.Debug)&&this.g(w.Debug,d([g,...h]))}info(g,...h){this.f(w.Info)&&this.g(w.Info,d([g,...h]))}warn(g,...h){this.f(w.Warning)&&this.g(w.Warning,d([g,...h]))}error(g,...h){if(this.f(w.Error))if(g instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=g.stack,this.g(w.Error,d(O))}else this.g(w.Error,d([g,...h]))}flush(){}}e.AbstractMessageLogger=v;class D extends f{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g),this.g=!k.isWindows}trace(g,...h){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,g,...h):console.log(`[main ${I()}]`,g,...h))}debug(g,...h){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,g,...h):console.log(`[main ${I()}]`,g,...h))}info(g,...h){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,g,...h):console.log(`[main ${I()}]`,g,...h))}warn(g,...h){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,g,...h):console.warn(`[main ${I()}]`,g,...h))}error(g,...h){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,g,...h):console.error(`[main ${I()}]`,g,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=D;class b extends f{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g)}trace(g,...h){this.f(w.Trace)&&console.log("%cTRACE","color: #888",g,...h)}debug(g,...h){this.f(w.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",g,...h)}info(g,...h){this.f(w.Info)&&console.log("%c INFO","color: #33f",g,...h)}warn(g,...h){this.f(w.Warning)&&console.log("%c WARN","color: #993",g,...h)}error(g,...h){this.f(w.Error)&&console.log("%c  ERR","color: #f33",g,...h)}dispose(){}flush(){}}e.ConsoleLogger=b;class t extends f{constructor(g,h=e.DEFAULT_LOG_LEVEL){super(),this.g=g,this.setLevel(h)}trace(g,...h){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(g),...h])}debug(g,...h){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(g),...h])}info(g,...h){this.f(w.Info)&&this.g.log(w.Info,[this.h(g),...h])}warn(g,...h){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(g),...h])}error(g,...h){this.f(w.Error)&&this.g.log(w.Error,[this.h(g),...h])}h(g){return typeof g=="string"?g:(0,c.toErrorMessage)(g,this.f(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends f{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const h of this.g)h.setLevel(g);super.setLevel(g)}trace(g,...h){for(const O of this.g)O.trace(g,...h)}debug(g,...h){for(const O of this.g)O.debug(g,...h)}info(g,...h){for(const O of this.g)O.info(g,...h)}warn(g,...h){for(const O of this.g)O.warn(g,...h)}error(g,...h){for(const O of this.g)O.error(g,...h)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.MultiplexLogger=o;class s extends R.Disposable{constructor(g,h,O){if(super(),this.h=g,this.j=h,this.b=new P.ResourceMap,this.c=this.D(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new A.Emitter),this.onDidChangeVisibility=this.g.event,O)for(const $ of O)this.b.set($.resource,{logger:void 0,info:$})}k(g){return(0,p.isString)(g)?[...this.b.values()].find(h=>h.info.id===g):this.b.get(g)}getLogger(g){return this.k(g)?.logger}createLogger(g,h){const O=this.l(g),$=(0,p.isString)(g)?g:h?.id??(0,u.hash)(O.toString()).toString(16);let x=this.b.get(O)?.logger;const Y=h?.logLevel==="always"?w.Trace:h?.logLevel;x||(x=this.m(O,Y??this.getLogLevel(O)??this.h,{...h,id:$}));const G={logger:x,info:{resource:O,id:$,logLevel:Y,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(G.info),this.b.set(O,G),x}l(g){return(0,p.isString)(g)?(0,y.joinPath)(this.j,`${g}.log`):g}setLogLevel(g,h){if(L.URI.isUri(g)){const O=g,$=h,x=this.b.get(O);x&&$!==x.info.logLevel&&(x.info.logLevel=$===this.h?void 0:$,x.logger?.setLevel($),this.b.set(x.info.resource,x),this.f.fire([O,$]))}else{this.h=g;for(const[O,$]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&$.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,h){const O=this.k(g);O&&h!==!O.info.hidden&&(O.info.hidden=!h,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,h]))}getLogLevel(g){let h;return g&&(h=this.b.get(g)?.info.logLevel),h??this.h}registerLogger(g){const h=this.b.get(g.resource);h?h.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const h=this.b.get(g);h&&(h.logger&&h.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class a{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(g){}getLevel(){return w.Info}trace(g,...h){}debug(g,...h){}info(g,...h){}warn(g,...h){}error(g,...h){}critical(g,...h){}dispose(){}flush(){}}e.NullLogger=a;class l extends a{}e.NullLogService=l;function E(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const g=r(m.logLevel.toLowerCase());if(g!==void 0)return g}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function i(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=i;function r(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=r,e.CONTEXT_LOG_LEVEL=new T.RawContextKey("logLevel",i(w.Info))}),define(De[209],Ce([1,0,6,16]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends c.Disposable{constructor(P,k=[]){super(),this.a=new A.MultiplexLogger([P,...k]),this.D(P.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...k){this.a.trace(P,...k)}debug(P,...k){this.a.debug(P,...k)}info(P,...k){this.a.info(P,...k)}warn(P,...k){this.a.warn(P,...k)}error(P,...k){this.a.error(P,...k)}flush(){this.a.flush()}}e.LogService=u}),define(De[210],Ce([1,0,45,16]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(u||(u={}));async function R(p,L,T,S,I){try{const C=await new Promise((n,d)=>{re(["spdlog"],n,d)});C.setFlushOn(u.Trace);const w=await C.createAsyncRotatingLogger(p,L,T,S);return I?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(C){console.error(C)}return null}function P(p,L,T){switch(L){case A.LogLevel.Trace:p.trace(T);break;case A.LogLevel.Debug:p.debug(T);break;case A.LogLevel.Info:p.info(T);break;case A.LogLevel.Warning:p.warn(T);break;case A.LogLevel.Error:p.error(T);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function k(p,L){switch(L){case A.LogLevel.Trace:p.setLevel(u.Trace);break;case A.LogLevel.Debug:p.setLevel(u.Debug);break;case A.LogLevel.Info:p.setLevel(u.Info);break;case A.LogLevel.Warning:p.setLevel(u.Warning);break;case A.LogLevel.Error:p.setLevel(u.Error);break;case A.LogLevel.Off:p.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends A.AbstractMessageLogger{constructor(L,T,S,I,C){super(),this.k=[],this.setLevel(C),this.l=this.n(L,T,S,I),this.D(this.onDidChangeLogLevel(w=>{this.m&&k(this.m,w)}))}async n(L,T,S,I){const C=S?6:1,w=30/C*c.ByteSize.MB,n=await R(L,T,w,C,I);if(n){this.m=n,k(this.m,this.getLevel());for(const{level:d,message:f}of this.k)P(this.m,d,f);this.k=[]}}g(L,T){this.m?P(this.m,L,T):this.getLevel()<=L&&this.k.push({level:L,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(De[123],Ce([1,0,37,178,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var P;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function p(C,w){return w-C}y.compare=p;const L=Object.create(null);L[y.Error]=(0,A.localize)(0,null),L[y.Warning]=(0,A.localize)(1,null),L[y.Info]=(0,A.localize)(2,null);function T(C){return L[C]||""}y.toString=T;function S(C){switch(C){case c.default.Error:return y.Error;case c.default.Warning:return y.Warning;case c.default.Info:return y.Info;case c.default.Ignore:return y.Hint}}y.fromSeverity=S;function I(C){switch(C){case y.Error:return c.default.Error;case y.Warning:return c.default.Warning;case y.Info:return c.default.Info;case y.Hint:return c.default.Ignore}}y.toSeverity=I}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const p="";function L(S){return T(S,!0)}y.makeKey=L;function T(S,I){const C=[p];return S.source?C.push(S.source.replace("\xA6","\\\xA6")):C.push(p),S.code?typeof S.code=="string"?C.push(S.code.replace("\xA6","\\\xA6")):C.push(S.code.value.replace("\xA6","\\\xA6")):C.push(p),S.severity!==void 0&&S.severity!==null?C.push(P.toString(S.severity)):C.push(p),S.message&&I?C.push(S.message.replace("\xA6","\\\xA6")):C.push(p),S.startLineNumber!==void 0&&S.startLineNumber!==null?C.push(S.startLineNumber.toString()):C.push(p),S.startColumn!==void 0&&S.startColumn!==null?C.push(S.startColumn.toString()):C.push(p),S.endLineNumber!==void 0&&S.endLineNumber!==null?C.push(S.endLineNumber.toString()):C.push(p),S.endColumn!==void 0&&S.endColumn!==null?C.push(S.endColumn.toString()):C.push(p),C.push(p),C.join("\xA6")}y.makeKeyOptionalMessage=T})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(De[211],Ce([1,0,3,37,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,u.createDecorator)("notificationService");var R;(function(p){p[p.WORKSPACE=0]="WORKSPACE",p[p.PROFILE=1]="PROFILE",p[p.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(p){p[p.OFF=0]="OFF",p[p.SILENT=1]="SILENT",p[p.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(De[124],Ce([1,0,8,2,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function R(p,L){return A.URI.isUri(p)?(0,c.equalsIgnoreCase)(p.scheme,L):(0,c.startsWithIgnoreCase)(p,L+":")}e.matchesScheme=R;function P(p,...L){return L.some(T=>R(p,T))}e.matchesSomeScheme=P;function k(p,L){return p.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=k;function y(p){let L;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(p.fragment);return T&&(L={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},p=p.with({fragment:""})),{selection:L,uri:p}}e.extractSelection=y}),define(De[212],Ce([1,0,11,36]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const R=c.globals.vscode.context.configuration();if(R)u=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:R.version})}}else u={},Object.keys(u).length===0&&Object.assign(u,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(De[213],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(re,e){return function(c,A){e(c,A,re)}};define(De[125],Ce([1,0,19,21,6,4]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}k.None=Object.freeze({report(){}}),e.Progress=k;let y=class extends u.Disposable{constructor(T,S){super(),this.a=new c.DeferredPromise,S.withProgress(T,I=>(this.b=I,this.c&&I.report(this.c),this.a.p)),this.D((0,u.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};y=Ve([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class p extends u.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.D(new u.DisposableStore)}start(T){this.stop();const S=++this.a,I=new A.CancellationTokenSource;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,u.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,u.toDisposable)(()=>I.cancel())),this.b.add((0,u.toDisposable)(()=>this.c?this.c.done():void 0)),{id:S,token:I.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=p,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(De[39],Ce([1,0,51,10]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.a=new Map}add(P,k){c.ok(A.isString(P)),c.ok(A.isObject(k)),c.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,k)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.Registry=new u}),define(De[93],Ce([1,0,3,39]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,p){this.a[u(y)]=p,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const P=new R;A.Registry.add(e.Extensions.JSONContribution,P)}),define(De[126],Ce([1,0,17,3,10,171,54,93,39]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(p=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=y.Registry.as(k.Extensions.JSONContribution);class S{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.n(t,o,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.o(t,o),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.o(o,s),this.n(t,!1,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const s=[];for(const{overrides:a,source:l}of t)for(const E in a)if(o.add(E),e.OVERRIDE_PROPERTY_REGEX.test(E)){const i=this.a.get(E),r=i?.valuesSources??new Map;if(l)for(const O of Object.keys(a[E]))r.set(O,l);const m={...i?.value||{},...a[E]};this.a.set(E,{source:l,value:m,valuesSources:r});const g=(0,P.getLanguageTagSettingPlainKey)(E),h={type:"object",default:m,description:R.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:u.isString(l)?void 0:l,defaultValueSource:l};s.push(...w(E)),this.d[E]=h,this.b.properties[E]=h}else{this.a.set(E,{value:a[E],source:l});const i=this.d[E];i&&(this.w(E,i),this.r(E,i))}this.m(s)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:s,source:a}of t)for(const l in s){const E=this.a.get(l),i=u.isString(a)?a:a?.id,r=u.isString(E?.source)?E?.source:E?.source?.id;if(i===r)if(o.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const m=this.d[l];m&&(this.w(l,m),this.r(l,m))}}this.u()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,s){t.forEach(a=>{this.p(a,o,a.extensionInfo,a.restrictedProperties,void 0,s),this.c.push(a),this.q(a)})}o(t,o){const s=a=>{if(a.properties)for(const l in a.properties){o.add(l);const E=this.d[l];E?.policy?.name&&this.e.delete(E.policy.name),delete this.d[l],this.s(l,a.properties[l])}a.allOf?.forEach(l=>s(l))};for(const a of t){s(a);const l=this.c.indexOf(a);l!==-1&&this.c.splice(l,1)}}p(t,o=!0,s,a,l=3,E){l=u.isUndefinedOrNull(t.scope)?l:t.scope;const i=t.properties;if(i)for(const m in i){const g=i[m];if(o&&v(m,g)){delete i[m];continue}if(g.source=s,g.defaultDefaultValue=i[m].default,this.w(m,g),e.OVERRIDE_PROPERTY_REGEX.test(m)?g.scope=void 0:(g.scope=u.isUndefinedOrNull(g.scope)?l:g.scope,g.restricted=u.isUndefinedOrNull(g.restricted)?!!a?.includes(m):g.restricted),i[m].hasOwnProperty("included")&&!i[m].included){this.f[m]=i[m],delete i[m];continue}else this.d[m]=i[m],i[m].policy?.name&&this.e.set(i[m].policy.name,m);!i[m].deprecationMessage&&i[m].markdownDeprecationMessage&&(i[m].deprecationMessage=i[m].markdownDeprecationMessage),E.add(m)}const r=t.allOf;if(r)for(const m of r)this.p(m,o,s,a,l,E)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=s=>{const a=s.properties;if(a)for(const E in a)this.r(E,a[E]);s.allOf?.forEach(o)};o(t)}r(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,o){const s=this.a.get(t);let a=s?.value,l=s?.source;u.isUndefined(a)&&(a=o.defaultDefaultValue,l=void 0),u.isUndefined(a)&&(a=d(o.type)),o.default=a,o.defaultValueSource=l}}const I="\\[([^\\]]+)\\]",C=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let o=C.exec(b);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=C.exec(b)}}return(0,c.distinct)(t)}e.overrideIdentifiersFromKey=w;function n(b){return b.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=n;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new S;y.Registry.add(e.Extensions.Configuration,f);function v(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?R.localize(7,null,b):f.getConfigurationProperties()[b]!==void 0?R.localize(8,null,b):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,b,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=v;function D(){const b=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))b.push([o,t[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=D}),define(De[214],Ce([1,0,17,3,148,6,28,23,10,2,54,126,39]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(o){return Object.isFrozen(o)?o:k.deepFreeze(o)}class C{constructor(s={},a=[],l=[],E){this.b=s,this.c=a,this.d=l,this.raw=E,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof C)return a;const l=new w("");return l.parseRaw(a),l.configurationModel});this.f=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const l=this.rawConfiguration.getValue(s),E=a?this.rawConfiguration.getOverrideValue(s,a):void 0,i=a?this.rawConfiguration.override(a).getValue(s):l;return{value:l,override:E,merged:i}}getOverrideValue(s,a){const l=this.i(a);return l?s?(0,L.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return c.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return c.distinct(s)}override(s){let a=this.a.get(s);return a||(a=this.g(s),this.a.set(s,a)),a}merge(...s){const a=k.deepClone(this.contents),l=k.deepClone(this.overrides),E=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const r of s)if(i.push(...r.raw?.length?r.raw:[r]),!r.isEmpty()){this.h(a,r.contents);for(const m of r.overrides){const[g]=l.filter(h=>c.equals(h.identifiers,m.identifiers));g?(this.h(g.contents,m.contents),g.keys.push(...m.keys),g.keys=c.distinct(g.keys)):l.push(k.deepClone(m))}for(const m of r.keys)E.indexOf(m)===-1&&E.push(m)}return new C(a,E,l,i.every(r=>r instanceof C)?void 0:i)}g(s){const a=this.i(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const E of c.distinct([...Object.keys(this.contents),...Object.keys(a)])){let i=this.contents[E];const r=a[E];r&&(typeof i=="object"&&typeof r=="object"?(i=k.deepClone(i),this.h(i,r)):i=r),l[E]=i}return new C(l,this.keys,this.overrides)}h(s,a){for(const l of Object.keys(a)){if(l in s&&y.isObject(s[l])&&y.isObject(a[l])){this.h(s[l],a[l]);continue}s[l]=k.deepClone(a[l])}}i(s){let a=null,l=null;const E=i=>{i&&(l?this.h(l,i):l=k.deepClone(i))};for(const i of this.overrides)c.equals(i.identifiers,[s])?a=i.contents:i.identifiers.includes(s)&&E(i.contents);return E(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.j(s,a,!0)}setValue(s,a){this.j(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,L.removeFromValueTree)(this.contents,s),T.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>c.equals(l.identifiers,(0,T.overrideIdentifiersFromKey)(s))),1))}j(s,a,l){(0,L.addToValueTree)(this.contents,s,a,E=>console.error(E)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),T.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,T.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],E=>console.error(E))})}}e.ConfigurationModel=C;class w{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!y.isUndefinedOrNull(s)){const l=this.g(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:E,overrides:i,restricted:r,hasExcludedProperties:m}=this.h(s,a);this.b=new C(l,E,i,m?[s]:void 0),this.c=r||[]}g(s){let a={},l=null,E=[];const i=[],r=[];function m(h){Array.isArray(E)?E.push(h):l!==null&&(E[l]=h)}const g={onObjectBegin:()=>{const h={};m(h),i.push(E),E=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{E=i.pop()},onArrayBegin:()=>{const h=[];m(h),i.push(E),E=h,l=null},onArrayEnd:()=>{E=i.pop()},onLiteralValue:m,onError:(h,O,$)=>{r.push({error:h,offset:O,length:$})}};if(s)try{u.visit(s,g),a=E[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return a}h(s,a){const l=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),E=this.i(s,l,!0,a);s=E.raw;const i=(0,L.toValuesTree)(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),r=Object.keys(s),m=this.j(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:i,keys:r,overrides:m,restricted:E.restricted,hasExcludedProperties:E.hasExcludedProperties}}i(s,a,l,E){let i=!1;if(!E?.scopes&&!E?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:i};const r={},m=[];for(const g in s)if(T.OVERRIDE_PROPERTY_REGEX.test(g)&&l){const h=this.i(s[g],a,!1,E);r[g]=h.raw,i=i||h.hasExcludedProperties,m.push(...h.restricted)}else{const h=a[g],O=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&m.push(g),(O===void 0||E.scopes===void 0||E.scopes.includes(O))&&!(E.skipRestricted&&h?.restricted)?r[g]=s[g]:i=!0}return{raw:r,restricted:m,hasExcludedProperties:i}}j(s,a){const l=[];for(const E of Object.keys(s))if(T.OVERRIDE_PROPERTY_REGEX.test(E)){const i={};for(const r in s[E])i[r]=s[E][r];l.push({identifiers:(0,T.overrideIdentifiersFromKey)(E),keys:Object.keys(i),contents:(0,L.toValuesTree)(i,a)})}return l}}e.ConfigurationModelParser=w;class n extends R.Disposable{constructor(s,a,l,E){super(),this.f=s,this.g=a,this.h=E,this.c=this.D(new A.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(l.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(A.Event.any(A.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&l.isEqual(i.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=n;class d{constructor(s,a,l,E,i,r,m,g,h,O,$,x,Y){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=E,this.d=i,this.f=r,this.g=m,this.h=g,this.i=h,this.j=O,this.k=$,this.l=x,this.m=Y}get value(){return I(this.c)}n(s,a,l){const E=s.inspect(a,l);return{get value(){return I(E.value)},get override(){return I(E.override)},get merged(){return I(E.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(s,a,l,E,i=new C,r=new C,m=new P.ResourceMap,g=new C,h=new P.ResourceMap){this.c=s,this.d=a,this.f=l,this.g=E,this.h=i,this.i=r,this.j=m,this.l=g,this.m=h,this.a=null,this.b=new P.ResourceMap,this.n=null}getValue(s,a,l){return this.q(s,a,l).getValue(s)}updateValue(s,a,l={}){let E;l.resource?(E=this.m.get(l.resource),E||(E=new C,this.m.set(l.resource,E))):E=this.l,a===void 0?E.removeValue(s):E.setValue(s,a),l.resource||(this.a=null)}inspect(s,a,l){const E=this.q(s,a,l),i=this.u(a.resource,l),r=a.resource?this.m.get(a.resource)||this.l:this.l,m=new Set;for(const g of E.overrides)for(const h of g.identifiers)E.getOverrideValue(s,h)!==void 0&&m.add(h);return new d(s,a,E.getValue(s),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,i||void 0,r)}keys(s){const a=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.j.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:E,updated:i,removed:r}=b(this.c,s);a=[...E,...i,...r]}for(const E of a)for(const i of(0,T.overrideIdentifiersFromKey)(E)){const r=this.c.getKeysForOverrideIdentifier(i),m=s.getKeysForOverrideIdentifier(i),g=[...m.filter(h=>r.indexOf(h)===-1),...r.filter(h=>m.indexOf(h)===-1),...r.filter(h=>!k.equals(this.c.override(i).getValue(h),s.override(i).getValue(h)))];l.push([i,g])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:E}=b(this.d,s),i=[...a,...l,...E];return i.length&&this.updatePolicyConfiguration(s),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:E,overrides:i}=b(this.applicationConfiguration,s),r=[...a,...l,...E];return r.length&&this.updateApplicationConfiguration(s),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:E,overrides:i}=b(this.localUserConfiguration,s),r=[...a,...l,...E];return r.length&&this.updateLocalUserConfiguration(s),{keys:r,overrides:i}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:E,overrides:i}=b(this.remoteUserConfiguration,s),r=[...a,...l,...E];return r.length&&this.updateRemoteUserConfiguration(s),{keys:r,overrides:i}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:E,overrides:i}=b(this.workspaceConfiguration,s),r=[...a,...l,...E];return r.length&&this.updateWorkspaceConfiguration(s),{keys:r,overrides:i}}compareAndUpdateFolderConfiguration(s,a){const l=this.p.get(s),{added:E,updated:i,removed:r,overrides:m}=b(l,a),g=[...E,...i,...r];return(g.length||!l)&&this.updateFolderConfiguration(s,a),{keys:g,overrides:m}}compareAndDeleteFolderConfiguration(s){const a=this.p.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:E,removed:i,overrides:r}=b(a,void 0);return{keys:[...l,...E,...i],overrides:r}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,a,l){let E=this.r(a,l);return a.overrideIdentifier&&(E=E.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(E=E.merge(this.d)),E}r({resource:s},a){let l=this.s();if(a&&s){const E=a.getFolder(s);E&&(l=this.t(E.uri)||l);const i=this.m.get(s);i&&(l=l.merge(i))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let a=this.b.get(s);if(!a){const l=this.s(),E=this.j.get(s);E?(a=l.merge(E),this.b.set(s,a)):a=l}return a}u(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,a)=>{const{contents:l,overrides:E,keys:i}=this.j.get(a);return s.push([a,{contents:l,overrides:E,keys:i}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.i.keys.forEach(a=>s.add(a)),this.j.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}w(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.i.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(E=>a.add(E))),[...a.values()]}static parse(s){const a=this.x(s.defaults),l=this.x(s.policy),E=this.x(s.application),i=this.x(s.user),r=this.x(s.workspace),m=s.folders.reduce((g,h)=>(g.set(p.URI.revive(h[0]),this.x(h[1])),g),new P.ResourceMap);return new f(a,l,E,i,new C,r,m,new C,new P.ResourceMap)}static x(s){return new C(s.contents,s.keys,s.overrides)}}e.Configuration=f;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const E of o)E.keys.forEach(i=>s.add(i)),E.overrides.forEach(([i,r])=>{const m=(0,P.getOrSet)(a,i,new Set);r.forEach(g=>m.add(g))});const l=[];return a.forEach((E,i)=>l.push([i,[...E.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=v;class D{constructor(s,a,l,E){this.change=s,this.f=a,this.g=l,this.h=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of s.keys)this.affectedKeys.add(i);for(const[,i]of s.overrides)for(const r of i)this.affectedKeys.add(r);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,a){const l=this.a+s,E=this.d.indexOf(l);if(E<0)return!1;const i=E+l.length;if(i>=this.d.length)return!1;const r=this.d.charCodeAt(i);if(r!==this.b&&r!==this.c)return!1;if(a){const m=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,g=this.g.getValue(s,a,this.h);return!k.equals(m,g)}return!0}}e.ConfigurationChangeEvent=D;function b(o,s){const{added:a,removed:l,updated:E}=t(s?.rawConfiguration,o?.rawConfiguration),i=[],r=o?.getAllOverrideIdentifiers()||[],m=s?.getAllOverrideIdentifiers()||[];if(s){const g=m.filter(h=>!r.includes(h));for(const h of g)i.push([h,s.getKeysForOverrideIdentifier(h)])}if(o){const g=r.filter(h=>!m.includes(h));for(const h of g)i.push([h,o.getKeysForOverrideIdentifier(h)])}if(s&&o){for(const g of r)if(m.includes(g)){const h=t({contents:o.getOverrideValue(void 0,g)||{},keys:o.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});i.push([g,[...h.added,...h.removed,...h.updated]])}}return{added:a,removed:l,updated:E,overrides:i}}function t(o,s){const a=o?s?o.keys.filter(i=>s.keys.indexOf(i)===-1):[...o.keys]:[],l=s?o?s.keys.filter(i=>o.keys.indexOf(i)===-1):[...s.keys]:[],E=[];if(o&&s){for(const i of s.keys)if(o.keys.indexOf(i)!==-1){const r=(0,L.getConfigurationValue)(s.contents,i),m=(0,L.getConfigurationValue)(o.contents,i);k.equals(r,m)||E.push(i)}}return{added:a,removed:l,updated:E}}}),define(De[127],Ce([1,0,9,4]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var u;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(u=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends c.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===u.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===u.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===u.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,p=u.Unknown,L){super(y),this._message=y,this._code=p,this._detail=L,this.isHandled=p===u.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function P(k){const y=k.indexOf("+");return y===-1?k:k.substring(0,y)}e.getRemoteAuthorityPrefix=P}),define(De[74],Ce([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(p){return p.scheme===c.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=A;function u(p){if(!p)return;const L=p.indexOf("+");return L<0?p:p.substr(0,L)}e.getRemoteName=u;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=R;function P(p){const{host:L,port:T}=y(p);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:T}}e.parseAuthorityWithPort=P;function k(p,L){let{host:T,port:S}=y(p);return typeof S>"u"&&(S=L),{host:T,port:S}}e.parseAuthorityWithOptionalPort=k;function y(p){const L=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const T=p.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const S=p.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:p,port:void 0}}}),define(De[25],Ce([1,0,8,4,74]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var k;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(n){this.value=n,this.c=n.toLowerCase()}static equals(n,d){if(typeof n>"u"||n===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof n=="string"||typeof d=="string"){const f=typeof n=="string"?n:n.value,v=typeof d=="string"?d:d.value;return c.equalsIgnoreCase(f,v)}return n.c===d.c}static toKey(n){return typeof n=="string"?n.toLowerCase():n.c}}e.ExtensionIdentifier=y;class p{get size(){return this.c.size}constructor(n){if(this.c=new Set,n)for(const d of n)this.add(d)}add(n){this.c.add(y.toKey(n))}delete(n){return this.c.delete(y.toKey(n))}has(n){return this.c.has(y.toKey(n))}}e.ExtensionIdentifierSet=p;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(n){this.c.delete(y.toKey(n))}get(n){return this.c.get(y.toKey(n))}has(n){return this.c.has(y.toKey(n))}set(n,d){this.c.set(y.toKey(n),d)}values(){return this.c.values()}forEach(n){this.c.forEach(n)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function T(w){return S(w)}e.isApplicationScopedExtension=T;function S(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function I(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(w,n){if(n){const d=`onResolveRemoteAuthority:${(0,u.getRemoteName)(n)}`;return!!w.activationEvents?.includes(d)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[128],Ce([1,0,9,25]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class u{constructor(){this.a=new Map,this.b=new WeakMap}register(P,k){this.a.set(P,k)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const k=Object.create(null);for(const y of P){const p=this.readActivationEvents(y);p.length>0&&(k[A.ExtensionIdentifier.toKey(y.identifier)]=p)}return k}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const k=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return k;for(const y in P.contributes){const p=this.a.get(y);if(!p)continue;const L=P.contributes[y],T=Array.isArray(L)?L:[L];try{p(T,k)}catch(S){(0,c.onUnexpectedError)(S)}}return k}}e.ImplicitActivationEventsImpl=u,e.ImplicitActivationEvents=new u}),define(De[215],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((u,R)=>re(["vsda"],u,R))}async createNewMessage(u){try{const R=await this.c(),P=new R.validator;if(P){const k=String(c.a++);return this.b.set(k,P),{id:k,data:P.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,R){if(!u.id)return!0;const P=this.b.get(u.id);if(!P)return!1;this.b.delete(u.id);try{return P.validate(R)==="ok"}catch{return!1}}async sign(u){try{const R=await this.c(),P=new R.signer;if(P)return P.sign(u)}catch{}return u}}c.a=1,e.SignService=c}),define(De[216],Ce([1,0,11,36,2,30]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(p){if(c.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function k(p,L,T,S,I,C,w,n,d,f){const v=Object.create(null);v["common.machineId"]=w,v.sessionID=(0,R.generateUuid)()+Date.now(),v.commitHash=I,v.version=C,v["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,c.PlatformToString)(c.platform),v["common.nodePlatform"]=A.platform,v["common.nodeArch"]=S,v["common.product"]=f||"desktop",n&&(v["common.msftInternal"]=n);let D=0;const b=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),c.isLinuxSnap&&(v["common.snap"]="true");const t=P(T);t&&(v["common.platformDetail"]=t);try{const o=await p.readFile(u.URI.file(d));v["common.source"]=o.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=k;function y(p){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const T=L.toLowerCase();return p.some(S=>T===S)}e.verifyMicrosoftInternalDomain=y}),define(De[217],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var u;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(u=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[75],Ce([1,0,23,10,3,54,74,216,217]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class p{constructor(l){this.value=l}}e.TelemetryTrustedValue=p;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,E){return Promise.resolve(void 0)}publicLog2(l,E){return this.publicLog(l,E)}publicLogError(l,E){return Promise.resolve(void 0)}publicLogError2(l,E){return this.publicLogError(l,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class T{async publicLog(l,E,i){}async publicLogError(l,E,i){}}e.NullEndpointTelemetryService=T,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(a,l){return u.Event.debounce(l.onDidChangeConfiguration,(i,r)=>{const m=i?new Set([...i.affectedKeys,...r.affectedKeys]):r.affectedKeys;return{...r,affectedKeys:m}},1e3,!0)(i=>{i.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=S;function I(a,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!a.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=I;function C(a,l){return!(l.isBuilt||l.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=C;function w(a){const l=a.getValue(y.TELEMETRY_SETTING_ID),E=a.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function n(a){const l={},E={},i={};v(a,i);for(let r in i){r=r.length>150?r.substr(r.length-149):r;const m=i[r];typeof m=="number"?E[r]=m:typeof m=="boolean"?E[r]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${m.length}`),l[r]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(l[r]=m)}return{properties:l,measurements:E}}e.validateTelemetryData=n;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(a){if(!a)return"none";const l=(0,P.getRemoteName)(a);return d.has(l)?l:"other"}e.cleanRemoteAuthority=f;function v(a,l,E=0,i){if(!!a)for(const r of Object.getOwnPropertyNames(a)){const m=a[r],g=i?i+r:r;Array.isArray(m)?l[g]=(0,c.safeStringify)(m):m instanceof Date?l[g]=m.toISOString():(0,A.isObject)(m)?E<2?v(m,l,E+1,g+"."):l[g]=(0,c.safeStringify)(m):l[g]=m}}function D(a,l){const E=a.msftInternalDomains||[],i=l.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(E)||i}e.isInternalTelemetry=D;function b(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=b;function t(a,l){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let E=a;const i=[];for(const h of l)for(;;){const O=h.exec(a);if(!O)break;i.push([O.index,h.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(E="";;){const h=m.exec(a);if(!h)break;const O=i.some(([$,x])=>h.index<x&&$<m.lastIndex);!r.test(h[0])&&!O&&(E+=a.substring(g,h.index)+"<REDACTED: user-file-path>",g=m.lastIndex)}return g<a.length&&(E+=a.substr(g)),E}function o(a){if(!a)return a;const l=a.toLowerCase(),E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of E)if(i.regex.test(l))return`<REDACTED: ${i.label}>`;return a}function s(a,l){return(0,c.cloneAndChange)(a,E=>{if(E instanceof p)return E.value;if(typeof E=="string"){let i=E.replaceAll("%20"," ");i=t(i,l);for(const r of l)i=i.replace(r,"");return i=o(i),i}})}e.cleanData=s}),define(De[218],Ce([1,0,8,122,25,11,2,9,36,75]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,a){return s.uuid&&a.uuid?s.uuid===a.uuid:s.id===a.id?!0:(0,c.compareIgnoreCase)(s.id,a.id)===0}e.areSameExtensions=L;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(a){const l=a.manifest?a.manifest.version:a.version,E=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new S(a.identifier,l,E)}static parse(a){const l=T.exec(a);return l&&l[1]&&l[2]?new S({id:l[1]},l[2],l[4]||void 0):null}constructor(a,l,E="undefined"){this.version=l,this.targetPlatform=E,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof S?L(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=S;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(s){const a=I.exec(s);return a&&a[1]?[n(a[1]),a[2]]:[n(s),void 0]}e.getIdAndVersion=C;function w(s,a){return`${s}.${a}`}e.getExtensionId=w;function n(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function d(s,a){return n(w(s??u.UNDEFINED_PUBLISHER,a))}e.getGalleryExtensionId=d;function f(s,a){const l=[],E=i=>{for(const r of l)if(r.some(m=>L(a(m),a(i))))return r;return null};for(const i of s){const r=E(i);r?r.push(i):l.push([i])}return l}e.groupByExtension=f;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function D(s){return{id:new p.TelemetryTrustedValue(s.identifier.id),name:new p.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function b(s,a){const l=[],E=a.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const i=E.shift();if(i&&l.every(r=>!L(r.identifier,{id:i}))){const r=s.filter(m=>L(m.identifier,{id:i}));r.length===1&&(l.push(r[0]),E.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=b;async function t(s,a){if(!R.isLinux)return!1;let l;try{l=(await s.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){a.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(i))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,a){const l=await t(s,a),E=(0,A.getTargetPlatform)(l?"alpine":R.platform,y.arch);return a.debug("ComputeTargetPlatform:",E),E}e.computeTargetPlatform=o}),define(De[219],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=c;function A(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=A;function u(P){return Array.from(P.entries()).map(k=>[k[0],c(k[1].map)])}e.serializeEnvironmentVariableCollections=u;function R(P){return new Map(P.map(k=>[k[0],{map:A(k[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(De[220],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(u){this.b=u,this.a=new Map}dispose(){for(const u of this.a.values())u.dispose()}startBuffering(u,R,P=5){const k=R(y=>{const p=typeof y=="string"?y:y.data;let L=this.a.get(u);if(L){L.data.push(p);return}const T=setTimeout(()=>this.flushBuffer(u),P);L={data:[p],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(u),k.dispose()}},this.a.set(u,L)});return k}stopBuffering(u){this.a.get(u)?.dispose()}flushBuffer(u){const R=this.a.get(u);R&&(this.a.delete(u),this.b(u,R.data.join("")))}}e.TerminalDataBufferer=c}),define(De[221],Ce([1,0,19,67,52,3,10,2,179,93,39]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var T;(function(D){function b(t,o){let s=t.defaults;for(;u.ThemeIcon.isThemeIcon(s);){const a=C.getIcon(s.id);if(!a)return;s=a.defaults}return s}D.getDefinition=b})(T=e.IconContribution||(e.IconContribution={}));var S;(function(D){function b(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}D.toJSONObject=b;function t(o){const s=a=>(0,P.isString)(a)?a:void 0;if(o&&Array.isArray(o.src)&&o.src.every(a=>(0,P.isString)(a.format)&&(0,P.isString)(a.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(a=>({format:a.format,location:k.URI.parse(a.location)}))}}D.fromJSONObject=t})(S=e.IconFontDefinition||(e.IconFontDefinition={}));class I{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,t,o,s){const a=this.b[b];if(a){if(o&&!a.description){a.description=o,this.d.properties[b].markdownDescription=`${o} $(${b})`;const i=this.e.enum.indexOf(b);i!==-1&&(this.e.enumDescriptions[i]=o),this.a.fire()}return a}const l={id:b,description:o,defaults:t,deprecationMessage:s};this.b[b]=l;const E={$ref:"#/definitions/icons"};return s&&(E.deprecationMessage=s),o&&(E.markdownDescription=`${o}: $(${b})`),this.d.properties[b]=E,this.e.enum.push(b),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const t=this.e.enum.indexOf(b);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,t){const o=this.f[b];return o||(this.f[b]=t,this.a.fire(),t)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(a,l)=>a.id.localeCompare(l.id),t=a=>{for(;u.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(a=>this.b[a]);for(const a of s.filter(l=>!!l.description).sort(b))o.push(`|<i class="${t(a)}"></i>|${a.id}|${u.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const a of s.filter(l=>!u.ThemeIcon.isThemeIcon(l.defaults)).sort(b))o.push(`|<i class="${t(a)}"></i>|${a.id}|`);return o.join(`
`)}}const C=new I;L.Registry.add(e.Extensions.IconContribution,C);function w(D,b,t,o){return C.registerIcon(D,b,t,o)}e.registerIcon=w;function n(){return C}e.getIconRegistry=n;function d(){const D=(0,A.getCodiconFontCharacters)();for(const b in D){const t="\\"+D[b].toString(16);C.registerIcon(b,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const f=L.Registry.as(p.Extensions.JSONContribution);f.registerSchema(e.iconsSchemaId,C.getIconSchema());const v=new c.RunOnceScheduler(()=>f.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=w("widget-close",A.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=w("goto-previous-location",A.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=w("goto-next-location",A.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=u.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(De[129],Ce([1,0,3,54,4,16]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var P;(function(w){w.Http="http",w.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=T;function S(w,n,d,f){if(d===1)return!1;if(d===2&&T(n)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(v?.length===4&&parseInt(v[1])>=18)return!1}return w<1024}e.isPortPrivileged=S;class I{constructor(n,d,f){this.remoteAddress=n,this.localAddress=d,this.b=f,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=I;let C=class{constructor(n,d){this.i=n,this.j=d,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const n=this.j.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.e=n,n?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.f=n.elevation,this.g=n.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const n=[],d=Array.from(this.d.values());for(const f of d){const v=Array.from(f.values());for(const D of v){const b=await D.value;b&&n.push(b)}}return n}async dispose(){for(const n of this.d.values()){for(const{value:d}of n.values())await d.then(f=>f?.dispose());n.clear()}this.d.clear()}setEnvironmentTunnel(n,d,f,v,D){this.o(n,d,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:d,localAddress:f,privacy:v,protocol:D,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,d){(T(n)||L(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const f=this.q(n,d);if(f)return++f.refcount,f.value}openTunnel(n,d,f,v,D,b=!1,t,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${D}.`),!n)return;if(d||(d="localhost"),v||(v=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(n,d,f,v,D,b,t,o);return s?s.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const d=this.d.get(n.tunnelRemoteHost);if(d){const f=d.get(n.tunnelRemotePort);f&&(f.refcount--,await this.n(n.tunnelRemoteHost,n.tunnelRemotePort,f))}}}}async n(n,d,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${d}.`);const v=f.value.then(async D=>{D&&(await D.dispose(!0),this.b.fire({host:D.tunnelRemoteHost,port:D.tunnelRemotePort}))});return this.d.has(n)&&this.d.get(n).delete(d),v}}async closeTunnel(n,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${d} `);const f=this.d.get(n);if(f&&f.has(d)){const v=f.get(d);v.refcount=0,await this.n(n,d,v)}}o(n,d,f){this.d.has(n)||this.d.set(n,new Map),this.d.get(n).set(d,{refcount:1,value:f})}async p(n,d){const f=this.d.get(n);f&&(await f.get(d)||f.delete(d),f.size===0&&this.d.delete(n))}q(n,d){const f=[n];L(n)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):T(n)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const v=f.map(D=>this.d.get(D));for(const D of v){const b=D?.get(d);if(b)return b}}canTunnel(n){return!!p(n)}s(n,d,f,v,D,b,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${v}.`);const o=f;this.h.add(o);const s=v===void 0?f:v,a={elevationRequired:D?this.isPortPrivileged(s):!1},l={remoteAddress:{host:d,port:f},localAddressPort:v,privacy:b,public:b?b!==k.Private:void 0,protocol:t},E=n.forwardPort(l,a);return E?(this.o(d,f,E),E.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),E}};C=Ve([We(0,R.ILogService),We(1,A.IConfigurationService)],C),e.AbstractTunnelService=C}),define(De[222],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var A;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[223],Ce([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(y){return y.scheme!==c.Schemas.file&&y.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function u(y){if(y.folders.length)return y.folders.every(p=>A(p.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=u;function R(y){return u(y)?.scheme}e.getVirtualWorkspaceScheme=R;function P(y){return u(y)?.authority}e.getVirtualWorkspaceAuthority=P;function k(y){return u(y)!==void 0}e.isVirtualWorkspace=k}),define(De[48],Ce([1,0,180,12,69,24,2,4,18]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function p(a){const l=a;return typeof l?.id=="string"&&P.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=p;function L(a){return typeof a?.id=="string"&&!p(a)&&!S(a)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function T(a,l){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,A.basename)(a)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const E=a;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}e.toWorkspaceIdentifier=T;function S(a){const l=a;return typeof l?.id=="string"&&P.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=S;function I(a){const l=a;if(l?.uri)return{id:l.id,uri:P.URI.revive(l.uri)};const E=a;if(E?.configPath)return{id:E.id,configPath:P.URI.revive(E.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=I;var C;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function w(a){const l=a;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=w;function n(a){const l=a;return!!(l&&typeof l=="object"&&P.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=n;class d{constructor(l,E,i,r,m){this.h=l,this.j=i,this.k=r,this.l=m,this.c=u.TernarySearchTree.forUris(this.l,()=>!0),this.folders=E}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=u.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class f{constructor(l,E){this.raw=E,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(a){return new f({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(a,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,l.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function b(a){let l;return P.URI.isUri(a)?l=a:l=a.configuration,l?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=b,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(a,l){return!D(a,l)&&!b(a)}e.isSavedWorkspace=o;function s(a){return(typeof a=="string"?(0,A.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[76],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(u){this.d=u,this.b=new Map,this.c=1}add(u){const R=this.c++;return this.b.set(R,u),this.e(),R}get(u,R){return this.b.has(u)?this.b.get(u)[R]:void 0}delete(u){this.b.delete(u),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}c.a=!1,e.Cache=c}),define(De[49],Ce([1,0,18,24,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(k=>{const y=this.b.get(k.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(k,y){y===null?this.b.delete(k.scheme):this.b.set(k.scheme,y)}isFreeScheme(k){return!this.b.has(k)&&!this.a.has(k)}getCapabilities(k){return this.b.get(k)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(De[224],Ce([1,0,183,16,209,26]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(y,p,L){const T=L.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",S=L.remote.isRemote?(0,c.localize)(0,null):y?(0,c.localize)(1,null):(0,c.localize)(2,null);super(p.createLogger(T,{name:S}))}};P=Ve([We(1,A.ILoggerService),We(2,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(De[225],Ce([1,0,19]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(P,k,y){this.h=new Map,this.a=P,this.b=k,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(p=>(this.f=p,this)),this.g=this.c.onDidChangeStorage(p=>{p.shared===this.b&&p.key===this.a&&(this.f=p.value)}),this.i=new c.RunOnceScheduler(()=>{const p=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of p.values())L.complete()}catch(L){for(const T of p.values())T.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,k){let y=this.f[P];return typeof y>"u"&&(y=k),y}update(P,k){this.f[P]=k;const y=this.h.get(P);if(y!==void 0)return y.p;const p=new c.DeferredPromise;return this.h.set(P,p),this.i.isScheduled()||this.i.schedule(),p.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class u extends A{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,k){super(P.identifier.value,!0,k),this.j=P}}e.ExtensionGlobalMemento=u}),define(De[226],Ce([1,0,3,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(P){this.c=P,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,k,y,p){const T=this.c.getNotebookDocument(A.URI.revive(P)).acceptModelChanged(k.value,y,p);this.b.fire(T)}$acceptDirtyStateChanged(P,k){this.c.getNotebookDocument(A.URI.revive(P)).acceptDirty(k)}$acceptModelSaved(P){const k=this.c.getNotebookDocument(A.URI.revive(P));this.a.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(De[20],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[227],Ce([1,0,25,3]),function(re,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(k,y){u.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(k.identifier),_e(this,u,y,"f"),Me(this,u,"f").onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(k){return Me(this,u,"f").get(this.a,k)}store(k,y){return Me(this,u,"f").store(this.a,k,y)}delete(k){return Me(this,u,"f").delete(this.a,k)}}e.ExtensionSecrets=R,u=new WeakMap}),define(De[55],Ce([1,0,4,129,3,20]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var P;(function(y){function p(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:T.protocol}}y.fromApiTunnel=p;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==A.TunnelPrivacyId.ConstantPrivate&&T.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}y.fromServiceTunnel=L})(P=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let k=class{constructor(p){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(p){return p}async openTunnel(p,L){}async getTunnels(){return[]}async setTunnelFactory(p){return{dispose:()=>{}}}registerPortsAttributesProvider(p,L){return{dispose:()=>{}}}async $providePortAttributes(p,L,T,S,I){return[]}async $forwardPort(p,L){}async $closeTunnel(p){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([We(0,R.IExtHostRpcService)],k),e.ExtHostTunnelService=k}),define(De[56],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=A}),define(De[228],Ce([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(y){let p=this.buffers.indexOf(y);return p<0&&(p=this.buffers.length,this.buffers.push(y)),p}}function u(k,y){if(y.serializeBuffersForPostMessage){const p=new A,L=(I,C)=>{if(C instanceof ArrayBuffer){const w=p.add(C);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(C)){const w=R(C);if(w){const n=p.add(C.buffer);return{$$vscode_array_buffer_reference$$:!0,index:n,view:{type:w,byteLength:C.byteLength,byteOffset:C.byteOffset}}}}return C},T=JSON.stringify(k,L),S=p.buffers.map(I=>{const C=new Uint8Array(I);return c.VSBuffer.wrap(C)});return{message:T,buffers:S}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=u;function R(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(k,y){const p=y.map(S=>{const I=new ArrayBuffer(S.byteLength);return new Uint8Array(I).set(S.buffer),I}),L=y.length?(S,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const C=I,{index:w}=C,n=p[w];if(C.view)switch(C.view.type){case 1:return new Int8Array(n,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return I}:void 0;return{message:JSON.parse(k,L),arrayBuffers:p}}e.deserializeWebviewMessage=P}),define(De[229],Ce([1,0,115]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:R,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function u(R){return new c.URITransformer(A(R))}e.createURITransformer=u}),define(De[130],Ce([1,0,192,10,2,6,4,39,45,18,46,163,37]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function w(ue){const ee=ue;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=w;function n(ue,ee,N){for(const q of N.visibleEditorPanes)if(q.group.id===ee&&ue.matches(q.input))return q.getViewState()}e.findViewStateForEditor=n;function d(ue){if(r(ue))return!1;const ee=ue;return u.URI.isUri(ee?.resource)}e.isResourceEditorInput=d;function f(ue){if(r(ue))return!1;const ee=ue;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=f;function v(ue){if(r(ue)||f(ue))return!1;const ee=ue;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function D(ue){if(r(ue))return!1;const ee=ue;return ee?ee.resource===void 0||ee.resource.scheme===p.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const b=/Untitled-\d+/;function t(ue){return ue.scheme===p.Schemas.untitled&&ue.path.length>1&&!b.test(ue.path)}e.isUntitledWithAssociatedResource=t;function o(ue){if(r(ue))return!1;const ee=ue;return u.URI.isUri(ee?.base?.resource)&&u.URI.isUri(ee?.input1?.resource)&&u.URI.isUri(ee?.input2?.resource)&&u.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var a;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(ee,N){let q=this.a.get(ee);return q||(q={source:ee,label:N},this.a.set(ee,q)),q.source}getSourceLabel(ee){return this.a.get(ee)?.label??ee}}e.SaveSourceRegistry=new l;var E;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function r(ue){return ue instanceof i}e.isEditorInput=r;function m(ue){const ee=ue;return u.URI.isUri(ee?.preferredResource)}function g(ue){const ee=ue;return r(ee?.primary)&&r(ee?.secondary)}e.isSideBySideEditorInput=g;function h(ue){const ee=ue;return r(ee?.modified)&&r(ee?.original)}e.isDiffEditorInput=h;function O(ue,ee,N,q,ae){return ve(q,[(0,T.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const me={...N,limits:{size:Number.MAX_VALUE}};ue.openEditor(ee,me)}}),(0,T.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:S.default.Warning})}e.createTooLargeFileError=O;function $(ue){return r(ue?.editor)}e.isEditorInputWithOptions=$;function x(ue){const ee=ue;return $(ue)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function Y(ue){const ee=ue;return typeof ee?.groupId=="number"&&r(ee.editor)}e.isEditorIdentifier=Y;var G;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(G=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class U{getOriginalUri(ee,N){if(!ee)return;if(o(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,N);if(N?.supportSideBySide){const{primary:ae,secondary:me}=this.a(ee);if(ae&&me){if(N?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===B.ANY)return this.getOriginalUri(ae,{filterByScheme:N.filterByScheme})??this.getOriginalUri(me,{filterByScheme:N.filterByScheme});ee=N.supportSideBySide===B.PRIMARY?ae:me}}if(f(ee)||v(ee)||o(ee))return;const q=m(ee)?ee.preferredResource:ee.resource;return!q||!N||!N.filterByScheme?q:this.b(q,N.filterByScheme)}a(ee){return g(ee)||v(ee)?{primary:ee.primary,secondary:ee.secondary}:h(ee)||f(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,N){if(!ee)return;if(o(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,N);if(N?.supportSideBySide){const{primary:ae,secondary:me}=this.a(ee);if(ae&&me){if(N?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===B.ANY)return this.getCanonicalUri(ae,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:N.filterByScheme});ee=N.supportSideBySide===B.PRIMARY?ae:me}}if(f(ee)||v(ee)||o(ee))return;const q=ee.resource;return!q||!N||!N.filterByScheme?q:this.b(q,N.filterByScheme)}b(ee,N){if(Array.isArray(N)){if(N.some(q=>ee.scheme===q))return ee}else if(N===ee.scheme)return ee}}e.EditorResourceAccessor=new U;var j;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class he{constructor(){this.c=new Map,this.d=new Map}start(ee){const N=this.a=ee.get(P.IInstantiationService);for(const[q,ae]of this.c)this.e(q,ae,N);this.c.clear()}e(ee,N,q){const ae=q.createInstance(N);this.d.set(ee,ae)}registerFileEditorFactory(ee){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ee}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(ee,N){if(this.c.has(ee)||this.d.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.a?this.e(ee,N,this.a):this.c.set(ee,N),(0,R.toDisposable)(()=>{this.c.delete(ee),this.d.delete(ee)})}getEditorSerializer(ee){return this.d.get(typeof ee=="string"?ee:ee.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new he);async function ie(ue,ee,N){return!ue||!ue.length?[]:await Promise.all(ue.map(async q=>{const ae=u.URI.revive(q.fileUri);if(!ae){N.info("Cannot resolve the path because it is not valid.",q);return}if(!await ee.canHandleResource(ae)){N.info("Cannot resolve the path because it cannot be handled",q);return}let ke=q.exists,_=q.type;if(typeof ke!="boolean"||typeof _!="number")try{_=(await ee.stat(ae)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ke=!0}catch(de){N.error(de),ke=!1}if(!ke&&q.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",q);return}if(_===y.FileType.Directory){N.info("Cannot resolve the path because it is a directory",q);return}const le={...q.options,pinned:!0};return ke?{resource:ae,options:le}:{resource:ae,options:le,forceUntitled:!0}}))}e.pathsToEditors=ie;var V;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function J(ue){const ee=ue;if(!ee)return!1;const N=ee;if(N.modified)return J(N.modified);const q=ee;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=J;function ne(ue){return(0,L.isErrorWithActions)(ue)}e.isEditorOpenError=ne;function ve(ue,ee,N){const q=(0,L.createErrorWithActions)(ue,ee);return q.forceMessage=N?.forceMessage,q.forceSeverity=N?.forceSeverity,q.allowDialog=N?.allowDialog,q}e.createEditorOpenError=ve}),define(De[230],Ce([1,0,3,193,4,6,28,39,17,61,23,67,221]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,S.registerIcon)("default-view-icon",T.Codicon.window,(0,A.localize)(0,null));var I;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(I=e.Extensions||(e.Extensions={}));var C;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(C=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function w(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=w;class n extends R.Disposable{constructor(){super(...arguments),this.c=this.D(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.D(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(a,l,E){const i=this.get(a.id);if(i)return i;const r=a;return r.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:r.openCommandActionDescriptor??{id:r.id},(0,P.getOrSet)(this.g,l,[]).push(r),E?.isDefault&&this.h.push(r),this.c.fire({viewContainer:r,viewContainerLocation:l}),r}deregisterViewContainer(a){for(const l of this.g.keys()){const E=this.g.get(l),i=E?.indexOf(a);if(i!==-1){E?.splice(i,1),E.length===0&&this.g.delete(l),this.f.fire({viewContainer:a,viewContainerLocation:l});return}}}get(a){return this.all.filter(l=>l.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(E=>E?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(l=>this.getViewContainerLocation(l)===a)}}k.Registry.add(I.ViewContainersRegistry,new n);var d;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function f(s,a){const l=s.group??d.More,E=a.group??d.More;return l!==E?l.localeCompare(E):(s.order??5)-(a.order??5)}class v extends R.Disposable{constructor(){super(...arguments),this.c=this.D(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.D(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.D(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.D(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new p.SetMap}registerViews(a,l){this.registerViews2([{views:a,viewContainer:l}])}registerViews2(a){a.forEach(({views:l,viewContainer:E})=>this.l(l,E)),this.c.fire(a)}deregisterViews(a,l){const E=this.m(a,l);E.length&&this.f.fire({views:E,viewContainer:l})}moveViews(a,l){for(const E of this.j.keys())if(E!==l){const i=this.m(a,E);i.length&&(this.l(i,l),this.g.fire({views:i,from:E,to:l}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const l of this.i){const E=(this.j.get(l)||[]).filter(i=>i.id===a)[0];if(E)return E}return null}getViewContainer(a){for(const l of this.i)if((this.j.get(l)||[]).filter(i=>i.id===a)[0])return l;return null}registerViewWelcomeContent(a,l){return this.k.add(a,l),this.h.fire(a),(0,R.toDisposable)(()=>{this.k.delete(a,l),this.h.fire(a)})}registerViewWelcomeContent2(a,l){const E=new Map;for(const[i,r]of l)this.k.add(a,r),E.set(i,(0,R.toDisposable)(()=>{this.k.delete(a,r),this.h.fire(a)}));return this.h.fire(a),E}getViewWelcomeContent(a){const l=[];return this.k.forEach(a,E=>l.push(E)),l.sort(f)}l(a,l){let E=this.j.get(l);E||(E=[],this.j.set(l,E),this.i.push(l));for(const i of a){if(this.getView(i.id)!==null)throw new Error((0,A.localize)(1,null,i.id));E.push(i)}}m(a,l){const E=this.j.get(l);if(!E)return[];const i=[],r=[];for(const m of E)a.includes(m)?i.push(m):r.push(m);return i.length&&(r.length?this.j.set(l,r):(this.j.delete(l),this.i.splice(this.i.indexOf(l),1))),i}}k.Registry.add(I.ViewsRegistry,new v),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var D;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(D=e.ViewVisibilityState||(e.ViewVisibilityState={}));var b;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(b=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(a,l){this.c=!1,this.d=!1,(0,L.mixin)(this,a),this.d=!!l,this.resolve=async E=>{if(l&&!this.c){const i=await l(E);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}E.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class o extends Error{constructor(a){super((0,A.localize)(2,null,a))}}e.NoTreeViewError=o}),define(De[131],Ce([1,0,3,19,194]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(k){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=k}onEvent(k){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=k}onRequest(k){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=k}sendResponse(k){k.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.s("response",k)}sendRequest(k,y,p,L){const T={command:k};if(y&&Object.keys(y).length>0&&(T.arguments=y),this.s("request",T),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const I=this.f.get(T.seq);if(I){this.f.delete(T.seq);const C={type:"response",seq:0,request_seq:T.seq,success:!1,command:k,message:(0,u.localize)(0,null,L,k)};I(C)}},L)}return p&&this.f.set(T.seq,p),T.seq}acceptMessage(k){this.j?this.j(k):(this.k.push(k),this.k.length===1&&this.q())}o(k,y){return k.type!=="event"||y.type!=="event"}async q(){let k;for(;this.k.length;){if((!k||this.o(this.k[0],k))&&await(0,A.timeout)(0),k=this.k.shift(),!k)return;switch(k.type){case"event":this.i?.(k);break;case"request":this.g?.(k);break;case"response":{const y=k,p=this.f.get(y.request_seq);p&&(this.f.delete(y.request_seq),p(y));break}}}}s(k,y){y.type=k,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const k=new Map;this.f.forEach((y,p)=>k.set(p,y)),await(0,A.timeout)(500),k.forEach((y,p)=>{y({type:"response",seq:0,request_seq:p,success:!1,command:"canceled",message:"canceled"}),this.f.delete(p)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(De[231],Ce([1,0,195,44,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const R=S=>c.localize(51,null,S);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var P;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(P=e.State||(e.State={}));function k(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var y;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var p;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(p=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,u.createDecorator)("debugService");var T;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[232],Ce([1,0,8,2,12,23,18,32,21,17]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function T(i,r,m){return i.replace(L,function(g,h){return r&&h.length>0&&h[0]!=="_"?g:m&&m.hasOwnProperty(h)?m[h]:g})}e.formatPII=T;function S(i){const r={};for(const m of Object.keys(i))m.startsWith("!")||(r[m]=i[m]);return r}e.filterExceptionsFromTelemetry=S;function I(i){return i.configuration.request==="attach"&&!C(i)&&(!i.parentSession||I(i.parentSession))}e.isSessionAttach=I;function C(i){let r=i.configuration.type;if(!!r)return r==="vslsShare"&&(r=i.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(r,"extensionhost")||(0,c.equalsIgnoreCase)(r,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function w(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=w;function n(i,r,m){let g,h=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let $=null;for(;$=O.exec(i);){const x=$.index+1,Y=x+$[0].length;if(x<=r&&Y>=m){g=$[0],h=x;break}}if(g){const x=/\w+/g;let Y=null;for(;(Y=x.exec(g))&&!(Y.index+1+h+Y[0].length>=m););Y&&(g=g.substring(0,x.lastIndex))}return g?{start:h,end:h+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=n;async function d(i,r,m,g){if(i.evaluatableExpressionProvider.has(r)){const h=i.evaluatableExpressionProvider.ordered(r),O=(0,p.coalesce)(await Promise.all(h.map(async $=>{try{return await $.provideEvaluatableExpression(r,m,g??y.CancellationToken.None)}catch{return}})));if(O.length>0){let $=O[0].expression;const x=O[0].range;return $||($=r.getLineContent(m.lineNumber).substring(x.startColumn-1,x.endColumn-1)),{range:x,matchingExpression:$}}}else{const h=r.getLineContent(m.lineNumber),{start:O,end:$}=n(h,m.column,m.column),x=h.substring(O-1,$);return{matchingExpression:x,range:new k.Range(m.lineNumber,O,m.lineNumber,O+x.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(i){return!!(i&&i.match(f))}e.isUri=v;function D(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(v(i.path))return A.URI.parse(i.path);if((0,u.isAbsolute)(i.path))return A.URI.file(i.path)}return i.path}function b(i){if(typeof i.path=="object"){const r=A.URI.revive(i.path);if(r)return r.scheme===P.Schemas.file?r.fsPath:r.toString()}return i.path}function t(i,r){const m=r?D:b,g=(0,R.deepClone)(i);return s(g,(h,O)=>{h&&O&&(O.path=m(O))}),g}e.convertToDAPaths=t;function o(i,r){const m=r?D:b,g=(0,R.deepClone)(i);return s(g,(h,O)=>{!h&&O&&(O.path=m(O))}),g}e.convertToVSCPaths=o;function s(i,r){switch(i.type){case"event":{const m=i;switch(m.event){case"output":r(!1,m.body.source);break;case"loadedSource":r(!1,m.body.source);break;case"breakpoint":r(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=i;switch(m.command){case"setBreakpoints":r(!0,m.arguments.source);break;case"breakpointLocations":r(!0,m.arguments.source);break;case"source":r(!0,m.arguments.source);break;case"gotoTargets":r(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(g=>r(!1,g));break;default:break}break}case"response":{const m=i;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(g=>r(!1,g.source));break;case"loadedSources":m.body.sources.forEach(g=>r(!1,g));break;case"scopes":m.body.scopes.forEach(g=>r(!1,g.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(g=>r(!1,g.source));break;case"setBreakpoints":m.body.breakpoints.forEach(g=>r(!1,g.source));break;case"disassemble":m.body?.instructions.forEach(h=>r(!1,h.location));break;default:break}break}}}function a(i){return i.filter(r=>!r.presentation?.hidden).sort((r,m)=>r.presentation?m.presentation?r.presentation.group?m.presentation.group?r.presentation.group!==m.presentation.group?r.presentation.group.localeCompare(m.presentation.group):l(r.presentation.order,m.presentation.order):-1:m.presentation.group?1:l(r.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=a;function l(i,r){return typeof i!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:i-r}async function E(i,r){const m=i.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(m!=="none"&&(await r.saveAll(),m==="allEditorsInActiveGroup")){const g=r.activeEditorPane;g&&g.input.resource?.scheme===P.Schemas.untitled&&await r.save({editor:g.input,groupId:g.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(De[233],Ce([1,0,47,132,23,12,11,8,29,196,131]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,f){this.p=f,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",v=>this.w(v))}sendMessage(d){if(this.p){const f=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${T.a}${f}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const f=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(v){this.m.fire(new Error((v.message||v)+`
`+f))}continue}}else{const f=this.r.indexOf(T.a);if(f!==-1){const D=this.r.toString("utf8",0,f).split(T.b);for(const b of D){const t=b.split(T.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(f+T.a.length);continue}}break}}}T.a=`\r
\r
`,T.b=/\r?\n/,T.l=/: */,e.StreamDebugAdapter=T;class S extends T{startSession(){return new Promise((d,f)=>{let v=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),v=!0}),this.x.on("close",()=>{v?this.m.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",D=>{v?this.m.fire(D):f(D)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=S;class I extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=I;class C extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=C;class w extends T{constructor(d,f){super(),this.y=d,this.z=f}async startSession(){const d=this.y.command,f=this.y.args,v=this.y.options||{};try{if(d)if(R.isAbsolute(d)){if(!await y.Promises.exists(d))throw new Error(p.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(p.localize(1,null,this.z));let D=process.env;if(v.env&&Object.keys(v.env).length>0&&(D=u.mixin(u.deepClone(process.env),v.env)),d==="node")if(Array.isArray(f)&&f.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:D,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};v.cwd&&(t.cwd=v.cwd);const o=c.fork(f[0],f.slice(1),t);if(!o.pid)throw new Error(p.localize(2,null,f[0]));this.x=o}else throw new Error(p.localize(3,null));else{const b={env:D};v.cwd&&(b.cwd=v.cwd),this.x=c.spawn(d,f,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,t)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(D){this.m.fire(D)}}async stopSession(){return this.x?(await this.u(),P.isWindows?new Promise((d,f)=>{const v=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(D,b,t){if(D)return f(D)});v.on("exit",d),v.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,f){if(!d)return;const v=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?v.runtime=R.join(f,d.runtime):v.runtime=d.runtime),d.runtimeArgs&&(v.runtimeArgs=d.runtimeArgs),d.program&&(R.isAbsolute(d.program)?v.program=d.program:v.program=R.join(f,d.program)),d.args&&(v.args=d.args);const D=d;return D.win&&(v.win=w.A(D.win,f)),D.winx86&&(v.winx86=w.A(D.winx86,f)),D.windows&&(v.windows=w.A(D.windows,f)),D.osx&&(v.osx=w.A(D.osx,f)),D.linux&&(v.linux=w.A(D.linux,f)),v}static platformAdapterExecutable(d,f){let v=Object.create(null);f=f.toLowerCase();for(const a of d)if(a.contributes){const l=a.contributes.debuggers;l&&l.length>0&&l.filter(E=>typeof E.type=="string"&&k.equalsIgnoreCase(E.type,f)).forEach(E=>{const i=w.A(E,a.extensionLocation.fsPath);v=u.mixin(v,i,a.isBuiltin)})}let D;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?D=v.winx86||v.win||v.windows:P.isWindows?D=v.win||v.windows:P.isMacintosh?D=v.osx:P.isLinux&&(D=v.linux),D=D||v;const b=D.program||v.program,t=D.args||v.args,o=D.runtime||v.runtime,s=D.runtimeArgs||v.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof b=="string"?[b]:[]).concat(t||[])};if(b)return{type:"executable",command:b,args:t||[]}}}e.ExecutableDebugAdapter=w}),define(De[234],Ce([1,0,47,33,11]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(p,L){return new Promise((T,S)=>{let I="";const C=c.spawn(p,L);C.pid&&C.stdout.on("data",w=>{I+=w.toString()}),C.on("error",w=>{S(w)}),C.on("close",w=>{T(I)})})}async function P(p){if(p)if(u.isWindows){const L=await new Promise((T,S)=>{re(["windows-process-tree"],T,S)});return new Promise(T=>{L.getProcessTree(p,S=>{T(!!S&&S.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(p)]).then(L=>{const T=L.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var k;(function(p){p[p.cmd=0]="cmd",p[p.powershell=1]="powershell",p[p.bash=2]="bash"})(k||(k={}));function y(p,L,T,S,I){p=p.trim().toLowerCase();let C;p.indexOf("powershell")>=0||p.indexOf("pwsh")>=0?C=1:p.indexOf("cmd.exe")>=0?C=0:p.indexOf("bash")>=0?C=2:u.isWindows?C=0:C=2;let w,n=" ";switch(C){case 1:if(w=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),S){const d=(0,A.getDriveLetter)(S);d&&(n+=`${d}:; `),n+=`cd ${w(S)}; `}if(I)for(const d in I){const f=I[d];f===null?n+=`Remove-Item env:${d}; `:n+=`\${env:${d}}='${f}'; `}if(L.length>0){const d=L.shift(),f=T?d:w(d);n+=f[0]==="'"?`& ${f} `:`${f} `;for(const v of L)n+=v==="<"||v===">"||T?v:w(v),n+=" "}break;case 0:if(w=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>d.includes(f))||d.length===0?`"${d}"`:d),S){const d=(0,A.getDriveLetter)(S);d&&(n+=`${d}: && `),n+=`cd ${w(S)} && `}if(I){n+='cmd /C "';for(const d in I){let f=I[d];f===null?n+=`set "${d}=" && `:(f=f.replace(/[&^|<>]/g,v=>`^${v}`),n+=`set "${d}=${f}" && `)}}for(const d of L)n+=d==="<"||d===">"||T?d:w(d),n+=" ";I&&(n+='"');break;case 2:{w=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),f.length===0?'""':f);const d=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(S&&(n+=`cd ${w(S)} ; `),I){n+="/usr/bin/env";for(const f in I){const v=I[f];v===null?n+=` -u ${d(f)}`:n+=` ${d(`${f}=${v}`)}`}n+=" "}for(const f of L)n+=f==="<"||f===">"||T?f:w(f),n+=" ";break}}return n}e.prepareCommand=y}),define(De[94],Ce([1,0,22,38,64,89,18,12,11,44]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(C=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var w;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(w=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var f;(function(B){B.scheme=P.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${U.join("")}]+`),he=7;function ie(ee,N){const q=N.toString(he),me=`${q.length<U.length?U[q.length-1]:"z"}${q}s${(0,c.encodeBase64)(c.VSBuffer.fromString(ee.scheme),!0,!0)}`;return ee.with({scheme:B.scheme,fragment:me})}B.generate=ie;function V(ee){if(ee.scheme!==B.scheme)return;const N=ee.fragment.indexOf("s");if(N<0)return;const q=parseInt(ee.fragment.substring(0,N).replace(j,""),he),ae=(0,c.decodeBase64)(ee.fragment.substring(N+1)).toString();if(!isNaN(q))return{handle:q,notebook:ee.with({scheme:ae,fragment:null})}}B.parse=V;function J(ee,N){return ee.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${ee.scheme!==P.Schemas.file?ee.scheme:""}`})}B.generateCellOutputUri=J;function ne(ee){if(ee.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!N)return;const q=N[1]&&N[1]!==""?N[1]:void 0,ae=N[2];return{outputId:q,notebook:ee.with({scheme:ae||P.Schemas.file,fragment:null})}}B.parseCellOutputUri=ne;function ve(ee,N,q){return B.generate(ee,N).with({scheme:q})}B.generateCellPropertyUri=ve;function ue(ee,N){if(ee.scheme===N)return B.parse(ee.with({scheme:B.scheme}))}B.parseCellPropertyUri=ue})(f=e.CellUri||(e.CellUri={}));const v=B=>y.isWindows?B.replace(/\//g,"\\"):B;class D{constructor(U=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(U)].map(he=>({pattern:he,matches:A.parse(v(he))}))}sort(U){const j=new Map(u.Iterable.map(U,ie=>[ie,v(ie)]));let he=[];for(const{matches:ie}of this.d)for(const[V,J]of j)if(ie(J)){he.push(V),j.delete(V);break}return j.size&&(he=he.concat([...j.keys()].sort((ie,V)=>this.e.indexOf(ie)-this.e.indexOf(V)))),he}prioritize(U,j){const he=this.f(U);if(he===-1){this.d.unshift({pattern:U,matches:A.parse(v(U))});return}const ie=new Set(j.map(J=>this.f(J,he)));ie.delete(-1);const V=Array.from(ie).sort();this.d.splice(he+1,0,...V.map(J=>this.d[J]));for(let J=V.length-1;J>=0;J--)this.d.splice(V[J],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,j=this.d.length){const he=v(U);for(let ie=0;ie<j;ie++)if(this.d[ie].matches(he))return ie;return-1}}e.MimeTypeDisplayOrder=D;function b(B,U,j,he=(ie,V)=>ie===V){const ie=[];function V(ve,ue,ee){if(ue===0&&ee.length===0)return;const N=ie[ie.length-1];N&&N.start+N.deleteCount===ve?(N.deleteCount+=ue,N.toInsert.push(...ee)):ie.push({start:ve,deleteCount:ue,toInsert:ee})}let J=0,ne=0;for(;;){if(J===B.length){V(J,0,U.slice(ne));break}if(ne===U.length){V(J,B.length-J,[]);break}const ve=B[J],ue=U[ne];if(he(ve,ue)){J+=1,ne+=1;continue}j(ue)?(V(J,1,[]),J+=1):(V(J,0,[ue]),ne+=1)}return ie}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new p.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(B){B.default="default",B.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(B){const U=B;return!!((typeof U.include=="string"||A.isRelativePattern(U.include))&&(typeof U.exclude=="string"||A.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=o;function s(B,U,j){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const he=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(A.match(he,(0,k.basename)(j.fsPath).toLowerCase()))return!(ie&&A.match(ie,(0,k.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",textOutputLineLimit:"notebook.output.textLineLimit",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var a;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(U){return`${l.d}${U}`}static parse(U){if(U.startsWith(l.d))return U.substring(l.d.length)}}l.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=l;function E(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=E;const i=new TextDecoder;function r(B){const U=[];let j=!1;for(const he of B)(U.length===0||j)&&(U.push(he),j=!0);return O(U),M(c.VSBuffer.concat(U.map(he=>c.VSBuffer.wrap(he))))}e.compressOutputItemStreams=r;const m=`${String.fromCharCode(27)}[A`,g=m.split("").map(B=>B.charCodeAt(0)),h=10;function O(B){B.forEach((U,j)=>{if(j===0||U.length<m.length)return;const he=B[j-1],ie=U.subarray(0,m.length);if(ie[0]===g[0]&&ie[1]===g[1]&&ie[2]===g[2]){const V=he.lastIndexOf(h);if(V===-1)return;B[j-1]=he.subarray(0,V),B[j]=U.subarray(m.length)}})}function $(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function x(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let j=B.match(/\r+(.*)$/m)[1];j=j+U.slice(j.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return B}const Y="\b".charCodeAt(0),G="\r".charCodeAt(0);function M(B){return!B.buffer.includes(Y)&&!B.buffer.includes(G)?B:c.VSBuffer.fromString(x($(i.decode(B.buffer))))}}),define(De[235],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(De[57],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class u{static fromExtHostTestItem(P,k,y=P.parent){if(P._isRoot)return new u([k]);const p=[P.id];for(let L=y;L&&L.id!==k;L=L.parent)p.push(L.id);return p.push(k),new u(p.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const k=P.indexOf("\0");return k===-1?P:P.slice(0,k)}static fromString(P){return new u(P.split("\0"))}static join(P,k){return new u([...P.path,k])}static joinToString(P,k){return P.toString()+"\0"+k}static parentId(P){const k=P.lastIndexOf("\0");return k===-1?void 0:P.slice(0,k)}static localId(P){const k=P.lastIndexOf("\0");return k===-1?P:P.slice(k+1)}static compare(P,k){return P===k?0:k.startsWith(P+"\0")?2:P.startsWith(k+"\0")?3:1}constructor(P,k=P.length){if(this.path=P,this.d=k,P.length===0||k<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new u(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new u(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new u(this.path,P)}compare(P){if(typeof P=="string")return u.compare(this.toString(),P);for(let k=0;k<P.d&&k<this.d;k++)if(P.path[k]!==this.path[k])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.TestId=u}),define(De[77],Ce([1,0,2,32,57]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var P;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const k=i=>"runId"in i;e.isStartControllerTests=k;var y;(function(i){i.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),i.deserialize=r=>({range:A.Range.lift(r.range),uri:c.URI.revive(r.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var p;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(p=e.TestMessageType||(e.TestMessageType={}));var L;(function(i){i.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,location:r.location&&y.serialize(r.location)}),i.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,location:r.location&&y.deserialize(r.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(i,r)=>`${r?"s":"e"}${i}`;e.getMarkId=T;var S;(function(i){i.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&y.serialize(r.location)}),i.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&y.deserialize(r.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var I;(function(i){i.serialize=r=>r.type===0?L.serialize(r):S.serialize(r),i.deserialize=r=>r.type===0?L.deserialize(r):S.deserialize(r)})(I=e.ITestMessage||(e.ITestMessage={}));var C;(function(i){i.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),i.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(I.serialize)}),i.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(I.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",n=(i,r)=>i+w+r;e.namespaceTestTag=n;const d=i=>{const r=i.indexOf(w);return{ctrlId:i.slice(0,r),tagId:i.slice(r+1)}};e.denamespaceTestTag=d;var f;(function(i){i.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),i.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?c.URI.revive(r.uri):void 0,range:r.range?A.Range.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(f=e.ITestItem||(e.ITestItem={}));var v;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(i){i.serialize=r=>({expand:r.expand,item:f.serialize(r.item)}),i.deserialize=r=>({controllerId:u.TestId.root(r.item.extId),expand:r.expand,item:f.deserialize(r.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(i){i.serialize=r=>{let m;return r.item&&(m={},r.item.label!==void 0&&(m.label=r.item.label),r.item.tags!==void 0&&(m.tags=r.item.tags),r.item.busy!==void 0&&(m.busy=r.item.busy),r.item.uri!==void 0&&(m.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(m.range=r.item.range?.toJSON()),r.item.description!==void 0&&(m.description=r.item.description),r.item.error!==void 0&&(m.error=r.item.error),r.item.sortText!==void 0&&(m.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:m}},i.deserialize=r=>{let m;return r.item&&(m={},r.item.label!==void 0&&(m.label=r.item.label),r.item.tags!==void 0&&(m.tags=r.item.tags),r.item.busy!==void 0&&(m.busy=r.item.busy),r.item.range!==void 0&&(m.range=r.item.range?A.Range.lift(r.item.range):null),r.item.description!==void 0&&(m.description=r.item.description),r.item.error!==void 0&&(m.error=r.item.error),r.item.sortText!==void 0&&(m.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:m}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,r)=>{r.expand!==void 0&&(i.expand=r.expand),r.item!==void 0&&(i.item=i.item?Object.assign(i.item,r.item):r.item)};e.applyTestItemUpdate=t;var o;(function(i){i.serializeWithoutMessages=r=>({...D.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(C.serializeWithoutMessages),retired:r.retired}),i.serialize=r=>({...D.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(C.serialize),retired:r.retired}),i.deserialize=r=>({...D.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(C.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(i){i.deserialize=r=>r.op===0?{op:r.op,item:D.deserialize(r.item)}:r.op===1?{op:r.op,item:b.deserialize(r.item)}:r.op===2?{op:r.op,uri:c.URI.revive(r.uri),docv:r.docv}:r,i.serialize=r=>r.op===0?{op:r.op,item:D.serialize(r.item)}:r.op===1?{op:r.op,item:b.serialize(r.item)}:r})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class E{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(r){const m=this.o();for(const g of r)switch(g.op){case 0:this.j(D.deserialize(g.item),m);break;case 1:this.k(b.deserialize(g.item),m);break;case 3:this.l(g.itemId,m);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}m.complete?.()}j(r,m){const g=u.TestId.parentId(r.item.extId)?.toString();let h;if(!g)h=this.p(r),this.f.add(h),this.d.set(r.item.extId,h);else if(this.d.has(g)){const O=this.d.get(g);O.children.add(r.item.extId),h=this.p(r,O),this.d.set(r.item.extId,h)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(r)}`);return}return m.add?.(h),r.expand===2&&this.g++,h}k(r,m){const g=this.d.get(r.extId);if(!!g)return r.expand!==void 0&&(g.expand===2&&this.g--,r.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,r),m.update?.(g),g}l(r,m){const g=this.d.get(r);if(!g)return;const h=u.TestId.parentId(g.item.extId)?.toString();h?this.d.get(h).children.delete(g.item.extId):this.f.delete(g);const O=[[r]];for(;O.length;)for(const $ of O.pop()){const x=this.d.get($);x&&(O.push(x.children),this.d.delete($),m.remove?.(x,x!==g),x.expand===2&&this.g--)}}m(r){}updatePendingRoots(r){this.h+=r}o(){return{}}}e.AbstractIncrementalTestCollection=E}),define(De[95],Ce([1,0,19,3,6,51,77,57]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const p=(f,v)=>f===v,T=Object.entries({range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:p,label:p,description:p,error:p,sortText:p,tags:(f,v)=>!(f.length!==v.length||f.some(D=>!v.includes(D)))}),S=(f,v)=>{let D;for(const[b,t]of T)t(f[b],v[b])||(D?D[b]=v[b]:D={[b]:v[b]});return D};class I extends u.Disposable{get root(){return this.m.root}constructor(v){super(),this.m=v,this.f=this.D(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.D(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.s(this.root,void 0)}set resolveHandler(v){this.h=v;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const v=this.k;return this.k=[],v}pushDiff(v){switch(v.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===v.uri){D.docv=v.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===v.item.extId){(0,P.applyTestItemUpdate)(D.item,v.item);return}if(D.op===0&&D.item.item.extId===v.item.extId){(0,P.applyTestItemUpdate)(D.item,v.item);return}}break}}this.k.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,D){const b=this.tree.get(v);if(!!b){if((b.expandLevels===void 0||D>b.expandLevels)&&(b.expandLevels=D),b.expand===1){const t=this.I(b);return t.isOpen()?this.H(b,D-1):t.wait().then(()=>this.H(b,D-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,D-1)):this.H(b,D-1)}}dispose(){for(const v of this.tree.values())this.m.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(v,D){switch(D.op){case 3:this.L(k.TestId.joinToString(v.fullId,D.id));break;case 0:this.s(D.item,v);break;case 5:for(const b of D.ops)this.p(v,b);break;case 1:this.u(D.new,D.old,v.fullId.toString());break;case 2:this.G(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:D.update}});break;case 6:this.q(v.actual.uri);break;default:(0,R.assertNever)(D)}}q(v){v&&this.pushDiff({op:2,uri:v,docv:this.m.getDocumentVersion(v)})}s(v,D){const b=k.TestId.fromExtHostTestItem(v,this.root.id,D?.actual),t=this.m.getApiFor(v);t.parent&&t.parent!==D?.actual&&this.m.getChildren(t.parent).delete(v.id);let o=this.tree.get(b.toString());if(!o){o={fullId:b,actual:v,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},v.tags.forEach(this.w,this),this.tree.set(o.fullId.toString(),o),this.z(v,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(v)}}),this.F(v,o,D);return}if(o.actual===v){this.C(v,o,D);return}if(o.actual.uri?.toString()!==v.uri?.toString())return this.L(b.toString()),this.s(v,D);const s=this.m.getChildren(o.actual),a=o.actual,l=S(this.m.toITestItem(a),this.m.toITestItem(v));this.m.getApiFor(a).listener=void 0,o.actual=v,o.expand=0,l&&(l.hasOwnProperty("tags")&&(this.u(v.tags,a.tags,b.toString()),delete l.tags),this.p(o,{op:4,update:l})),this.F(v,o,D);for(const[E,i]of s)this.m.getChildren(v).get(i.id)||this.L(k.TestId.joinToString(b,i.id));this.q(o.actual.uri)}u(v,D,b){const t=new Set(D.map(o=>o.id));for(const o of v)t.delete(o.id)||this.w(o);this.pushDiff({op:1,item:{extId:b,item:{tags:v.map(o=>(0,P.namespaceTestTag)(this.m.controllerId,o.id))}}}),t.forEach(this.y,this)}w(v){const D=this.j.get(v.id);D?D.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.namespaceTestTag)(this.m.controllerId,v.id)}}))}y(v){const D=this.j.get(v);D&&!--D.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,P.namespaceTestTag)(this.m.controllerId,v)}))}z(v,D){this.m.getApiFor(v).parent=D&&D.actual!==this.root?D.actual:void 0}C(v,D,b){this.z(v,b);const t=this.m.getApiFor(v);t.parent=b?.actual,t.listener=o=>this.p(D,o),this.G(D)}F(v,D,b){this.C(v,D,b);for(const[t,o]of this.m.getChildren(v))this.s(o,D)}G(v){let D;this.h?v.resolveBarrier?D=v.resolveBarrier.isOpen()?3:2:D=v.actual.canResolveChildren?1:0:D=0,D!==v.expand&&(v.expand=D,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:D}}),D===1&&v.expandLevels!==void 0&&this.I(v))}H(v,D){if(D<0)return;const b=[];for(const[t,o]of this.m.getChildren(v.actual)){const s=this.expand(k.TestId.joinToString(v.fullId,o.id),D);(0,c.isThenable)(s)&&b.push(s)}if(b.length)return Promise.all(b).then(()=>{})}I(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const o=new c.Barrier;return o.open(),o}v.expand=2,this.J(v);const D=v.resolveBarrier=new c.Barrier,b=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let t;try{t=this.h(v.actual===this.root?void 0:v.actual)}catch(o){b(o)}return(0,c.isThenable)(t)?t.catch(b).then(()=>{D.open(),this.G(v)}):(D.open(),this.G(v)),v.resolveBarrier}J(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}L(v){const D=this.tree.get(v);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const b=[D];for(;b.length;){const t=b.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.y(o.id);this.tree.delete(t.fullId.toString());for(const[o,s]of this.m.getChildren(t.actual))b.push(this.tree.get(k.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.TestItemCollection=I;class C extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=C;class w extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class n extends Error{constructor(v,D,b){super(`TestItem with ID "${v}" is from controller "${D}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=n;const d=(f,v,D)=>{let b=new Map;return{get size(){return b.size},forEach(t,o){for(const s of b.values())t.call(o,s,this)},[Symbol.iterator](){return b.entries()},replace(t){const o=new Map,s=new Set(b.keys()),a={op:5,ops:[]};for(const l of t){if(!(l instanceof D))throw new w(l.id);const E=v(l).controllerId;if(E!==f.controllerId)throw new n(l.id,E,f.controllerId);if(o.has(l.id))throw new C(l.id);o.set(l.id,l),s.delete(l.id),a.ops.push({op:0,item:l})}for(const l of s.keys())a.ops.push({op:3,id:l});f.listener?.(a),b=o},add(t){if(!(t instanceof D))throw new w(t.id);b.set(t.id,t),f.listener?.({op:0,item:t})},delete(t){b.delete(t)&&f.listener?.({op:3,id:t})},get(t){return b.get(t)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=d}),define(De[133],Ce([1,0,95]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,u=(P,k)=>{const y={controllerId:k};return A.set(P,y),y};e.createPrivateApiFor=u;const R=P=>{const k=A.get(P);if(!k)throw new c.InvalidTestItemError(P?.id||"<unknown>");return k};e.getPrivateApiFor=R}),define(De[96],Ce([1,0,18,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(k,y){return k.scheme===c.Schemas.http||k.scheme===c.Schemas.https?k:(y&&y.authority&&y.isRemote&&k.scheme===c.Schemas.file&&(k=A.URI.from({scheme:c.Schemas.vscodeRemote,authority:y.authority,path:k.path})),A.URI.from({scheme:c.Schemas.https,authority:`${k.scheme}+${R(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=u;function R(k){return k.replace(/./g,y=>{const p=y.charCodeAt(0);return p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57?y:"-"+p.toString(16).padStart(4,"0")})}function P(k){return k.replace(/-([0-9a-f]{4})/g,(y,p)=>String.fromCharCode(parseInt(p,16)))}e.decodeAuthority=P}),define(De[236],Ce([1,0,3,6,96]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(k,y,p){this.d=k,this.e=y,this.f=p,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const T of this.c.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(k=>k.inset.dispose()),this.b.dispose()}createWebviewEditorInset(k,y,p,L,T){let S;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===k){S=v;break}if(!S)throw new Error("not a visible editor");const I=this,C=this.a++,w=new c.Emitter,n=new c.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,u.asWebviewUri)(v,I.f)}get cspSource(){return u.webviewGenericCspSource}set options(v){this.b=v,I.d.$setOptions(C,v)}get options(){return this.b}set html(v){this.a=v,I.d.$setHtml(C,v)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(v){return I.d.$postMessage(C,v)}},f=new class{constructor(){this.editor=k,this.line=y,this.height=p,this.webview=d,this.onDidDispose=n.event}dispose(){I.c.has(C)&&(I.c.delete(C),I.d.$disposeEditorInset(C),n.fire(),n.dispose(),w.dispose())}};return this.d.$createEditorInset(C,S.id,S.value.document.uri,y+1,p,L||{},T.identifier,T.extensionLocation),this.c.set(C,{editor:k,inset:f,onDidReceiveMessage:w}),f}$onDidDispose(k){const y=this.c.get(k);y&&y.inset.dispose()}$onDidReceiveMessage(k,y){this.c.get(k)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(De[237],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class u extends Error{constructor(P,k){super(k),this.variable=P}}e.VariableError=u}),define(De[238],Ce([1,0,12,36,10,23,11,114,199,237,8]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(I,C,w,n){this.g=new Map,this.a=I,this.b=C,this.d=w,n&&(this.c=n.then(d=>this.h(d)))}h(I){if(P.isWindows){const C=Object.create(null);return Object.keys(I).forEach(w=>{C[w.toLowerCase()]=I[w]}),C}return I}resolveWithEnvironment(I,C,w){return this.j({env:this.h(I),userHome:void 0},C?C.uri:void 0,w)}async resolveAsync(I,C){const w={env:await this.c,userHome:await this.d};return this.j(w,I?I.uri:void 0,C)}async i(I,C,w,n){const d=R.deepClone(C);P.isWindows&&d.windows?Object.keys(d.windows).forEach(v=>d[v]=d.windows[v]):P.isMacintosh&&d.osx?Object.keys(d.osx).forEach(v=>d[v]=d.osx[v]):P.isLinux&&d.linux&&Object.keys(d.linux).forEach(v=>d[v]=d.linux[v]),delete d.windows,delete d.osx,delete d.linux;const f={env:await this.c,userHome:await this.d};return this.j(f,I?I.uri:void 0,d,w,n)}async resolveAnyAsync(I,C,w){return this.i(I,C,w)}async resolveAnyMap(I,C,w){const n=new Map;return{newConfig:await this.i(I,C,w,n),resolvedVariables:n}}resolveWithInteractionReplace(I,C,w,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,C,w,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,C){if(this.g.has(I))throw new Error("Variable "+I+" is contributed twice.");this.g.set(I,C)}async j(I,C,w,n,d){if(u.isString(w))return this.l(I,C,w,n,d);if(Array.isArray(w))return Promise.all(w.map(f=>this.j(I,C,f,n,d)));if(u.isObject(w)){const f=Object.create(null),v=await Promise.all(Object.keys(w).map(async D=>[await this.l(I,C,D,n,d),await this.j(I,C,w[D],n,d)]));for(const[D,b]of v)f[D]=b;return f}return w}l(I,C,w,n,d){return(0,L.replaceAsync)(w,T.VARIABLE_REGEXP,async(f,v)=>{if(v.includes(T.VARIABLE_LHS))return f;let D=await this.n(I,f,v,C,n);return d?.set(v,D),D!==f&&u.isString(D)&&D.match(T.VARIABLE_REGEXP)&&(D=await this.l(I,C,D,n,d)),D})}m(I){return this.b?this.b.getUriLabel(I,{noPrefix:!0}):I.fsPath}async n(I,C,w,n,d){let f;const v=w.split(":");v.length>1&&(w=v[0],f=v[1]);const D=o=>{const s=this.a.getFilePath();if(s)return(0,k.normalizeDriveLetter)(s);throw new p.VariableError(o,(0,y.localize)(0,null,C))},b=o=>{const s=D(o);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,k.normalizeDriveLetter)(a)}throw new p.VariableError(o,(0,y.localize)(1,null,C,c.basename(s)))},t=o=>{if(f){const s=this.a.getFolderUri(f);if(s)return s;throw new p.VariableError(o,(0,y.localize)(2,null,C,f))}if(n)return n;throw this.a.getWorkspaceFolderCount()>1?new p.VariableError(o,(0,y.localize)(3,null,C)):new p.VariableError(o,(0,y.localize)(4,null,C))};switch(w){case"env":if(f){if(I.env){const o=I.env[P.isWindows?f.toLowerCase():f];if(u.isString(o))return o}return""}throw new p.VariableError(p.VariableKind.Env,(0,y.localize)(5,null,C));case"config":if(f){const o=this.a.getConfigurationValue(n,f);if(u.isUndefinedOrNull(o))throw new p.VariableError(p.VariableKind.Config,(0,y.localize)(6,null,C,f));if(u.isObject(o))throw new p.VariableError(p.VariableKind.Config,(0,y.localize)(7,null,C,f));return o}throw new p.VariableError(p.VariableKind.Config,(0,y.localize)(8,null,C));case"command":return this.o(p.VariableKind.Command,C,f,d,"command");case"input":return this.o(p.VariableKind.Input,C,f,d,"input");case"extensionInstallFolder":if(f){const o=await this.a.getExtension(f);if(!o)throw new p.VariableError(p.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,C,f));return this.m(o.extensionLocation)}throw new p.VariableError(p.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,C));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.m(t(p.VariableKind.WorkspaceFolder)));case"cwd":return n||f?(0,k.normalizeDriveLetter)(this.m(t(p.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,k.normalizeDriveLetter)(c.basename(this.m(t(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(I.userHome)return I.userHome;throw new p.VariableError(p.VariableKind.UserHome,(0,y.localize)(11,null,C))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new p.VariableError(p.VariableKind.LineNumber,(0,y.localize)(12,null,C))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new p.VariableError(p.VariableKind.SelectedText,(0,y.localize)(13,null,C))}case"file":return D(p.VariableKind.File);case"fileWorkspaceFolder":return b(p.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||f?c.relative(this.m(t(p.VariableKind.RelativeFile)),D(p.VariableKind.RelativeFile)):D(p.VariableKind.RelativeFile);case"relativeFileDirname":{const o=c.dirname(D(p.VariableKind.RelativeFileDirname));if(n||f){const s=c.relative(this.m(t(p.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return c.dirname(D(p.VariableKind.FileDirname));case"fileExtname":return c.extname(D(p.VariableKind.FileExtname));case"fileBasename":return c.basename(D(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=c.basename(D(p.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-c.extname(o).length)}case"fileDirnameBasename":return c.basename(c.dirname(D(p.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||C}case"execInstallFolder":{const o=this.a.getAppRoot();return o||C}case"pathSeparator":return c.sep;default:try{const o=f?`${w}:${f}`:w;return this.o(p.VariableKind.Unknown,C,o,d,void 0)}catch{return C}}}}o(I,C,w,n,d){if(w&&n){const f=d===void 0?n[w]:n[d+":"+w];if(typeof f=="string")return f;throw new p.VariableError(I,(0,y.localize)(14,null,C))}return C}}T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=T}),define(De[134],Ce([1,0,4,130]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var u;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(u=e.GroupDirection||(e.GroupDirection={}));var R;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var k;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function p(C){const w=C;return(0,A.isEditorInput)(w?.editor)&&(0,A.isEditorInput)(w?.replacement)}e.isEditorReplacement=p;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function S(C){const w=C;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=S;function I(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(De[239],Ce([1,0,4,134]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(R){const P=R;return typeof R=="number"||(0,A.isEditorGroup)(P)}e.isPreferredGroup=u}),define(De[240],Ce([1,0,4,205]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(A.IEnvironmentService)}),define(De[135],Ce([1,0,25,3,12,6]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=P;class k{static isHostExtension(n,d,f){if(d.getExtensionDescription(n))return!1;const v=f.getExtensionDescription(n);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(n,d){this.h=n,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=d,this.j()}j(){this.d.sort(I),this.e=new c.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const n of this.d){if(this.e.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.e.set(n.identifier,n),this.f.push(n);const d=this.h.readActivationEvents(n);if(Array.isArray(d))for(let f of d)f==="onUri"&&(f=`onUri:${c.ExtensionIdentifier.toKey(n.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(n)}}set(n){this.d=n,this.j(),this.c.fire(void 0)}deltaExtensions(n,d){this.d=C(this.d,d),this.d=this.d.concat(n);const f=k.k(this.d);return this.d=C(this.d,f.map(v=>v.identifier)),this.j(),this.c.fire(void 0),new P(f)}static k(n){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this.c.has(t)?this.c.get(t).push(o):this.c.set(t,[o])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,o){const s=d.getArcs(t);for(let a=0;a<s.length;a++)if(!o.has(s[a]))return!1;return!0}getNodes(){return this.e}},f=new c.ExtensionIdentifierMap;for(const t of n)if(f.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)d.addArc(c.ExtensionIdentifier.toKey(t.identifier),c.ExtensionIdentifier.toKey(o));const v=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>v.add(t));const D=d.getNodes().filter(t=>!v.has(t));let b;do{b=!1;for(let t=0;t<D.length;t++){const o=D[t];d.hasOnlyGoodArcs(o,v)&&(D.splice(t,1),t--,v.add(o),b=!0)}}while(b);return D.map(t=>f.get(t))}containsActivationEvent(n){return this.g.has(n)}containsExtension(n){return this.e.has(n)}getExtensionDescriptionsForActivationEvent(n){const d=this.g.get(n);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(n){const d=this.e.get(n);return d||void 0}getExtensionDescriptionByUUID(n){for(const d of this.f)if(d.uuid===n)return d}getExtensionDescriptionByIdOrUUID(n,d){return this.getExtensionDescription(n)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=k,e.basicActivationEventsReader={readActivationEvents:w=>w.activationEvents};class y{constructor(n){this.d=new T,this.c=new k(n,[])}async acquireLock(n){const d=await this.d.acquire(n);return new p(this,d)}deltaExtensions(n,d,f){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,f)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,d){return this.c.getExtensionDescriptionByIdOrUUID(n,d)}}e.LockableExtensionDescriptionRegistry=y;class p extends R.Disposable{constructor(n,d){super(),this.f=n,this.c=!1,this.D(d)}isAcquiredFor(n){return!this.c&&this.f===n}}e.ExtensionDescriptionRegistryLock=p;class L{constructor(n){this.name=n,this.promise=new Promise((d,f)=>{this.c=d})}resolve(n){this.c(n)}}class T{constructor(){this.c=[],this.d=!1}async acquire(n){const d=new L(n);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let d=!0;const f=setTimeout(()=>{d&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),v=()=>{!d||(clearTimeout(f),d=!1,this.d=!1,this.e())};n.resolve((0,R.toDisposable)(v))}}var S;(function(w){w[w.Builtin=0]="Builtin",w[w.User=1]="User",w[w.Dev=2]="Dev"})(S||(S={}));function I(w,n){const d=w.isBuiltin?0:w.isUnderDevelopment?2:1,f=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(d!==f)return d-f;const v=u.posix.basename(w.extensionLocation.path),D=u.posix.basename(n.extensionLocation.path);return v<D?-1:v>D?1:0}function C(w,n){const d=new c.ExtensionIdentifierSet(n);return w.filter(f=>!d.has(f.identifier))}}),define(De[241],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class u{constructor(){this.type=2}serialize(T){T[u.ENV_KEY]="1"}}u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=u;class R{constructor(){this.type=3}serialize(T){T[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function P(L){delete L[A.ENV_KEY],delete L[u.ENV_KEY],delete L[R.ENV_KEY]}function k(L,T){P(T),L.serialize(T)}e.writeExtHostConnection=k;function y(L){if(L[A.ENV_KEY])return p(L,new A(L[A.ENV_KEY]));if(L[u.ENV_KEY])return p(L,new u);if(L[R.ENV_KEY])return p(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function p(L,T){return P(L),T}}),define(De[97],Ce([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var u;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(u=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function P(p){const L=c.VSBuffer.alloc(1);switch(p){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=P;function k(p,L){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=k;var y;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[78],Ce([1,0,4,3,16,26,97,74,75,23,2,6,186]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class extends T.Disposable{constructor(d,f){super(),this.m=d,this.n=f,this.a=this.D(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.D(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=f.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,S.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.D(f.onDidChangeLogLevel(v=>{(0,u.isLogLevel)(v)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,f,v){const D=this.getTelemetryDetails(),b=new C(f,v,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled});return this.l.set(d.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(d,f,v){this.f=d,this.g=f,this.c=v??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const f={};switch(f["common.extname"]=`${d.publisher}.${d.name}`,f["common.extversion"]=d.version,f["common.vscodemachineid"]=this.m.telemetryInfo.machineId,f["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,f["common.vscodeversion"]=this.m.version,f["common.isnewappinstall"]=w(this.m.telemetryInfo.firstSessionDate),f["common.product"]=this.m.environment.appHost,this.m.uiKind){case P.UIKind.Web:f["common.uikind"]="web";break;case P.UIKind.Desktop:f["common.uikind"]="desktop";break;default:f["common.uikind"]="unknown"}return f["common.remotename"]=(0,k.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),f}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const f=this.getTelemetryDetails();this.l.forEach((v,D)=>{v.isDisposed&&this.l.delete(D)}),this.l.forEach(v=>{v.updateTelemetryEnablements(f.isUsageEnabled,f.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,f){const v=this.l.get(d.value);return v&&v.isDisposed?(this.l.delete(d.value),!1):!v||v.ignoreUnhandledExtHostErrors?!1:(v.logError(f),!0)}};I=Ve([We(0,R.IExtHostInitDataService),We(1,u.ILoggerService)],I),e.ExtHostTelemetry=I;class C{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,f,v,D,b,t,o){this.g=v,this.h=D,this.i=b,this.j=t,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=f?.ignoreUnhandledErrors??!1,this.b=f?.ignoreBuiltInCommonProperties??!1,this.c=f?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,f){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:f},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let f=d.properties??d;return f=(0,y.cleanData)(f,[]),this.c&&(f=(0,p.mixin)(f,this.c)),this.b||(f=(0,p.mixin)(f,this.j)),d.properties?d.properties=f:d=f,d}k(d,f){!this.f||(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,f=this.mixInCommonPropsAndCleanData(f||{}),this.i||this.f?.sendEventData(d,f),this.h.trace(d,f))}logUsage(d,f){!this.d.isUsageEnabled||this.k(d,f)}logError(d,f){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,f):this.f.sendErrorData(d,f))}get apiTelemetryLogger(){if(!this.e){const d=this,f={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(f)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=C;function w(n){const d=Date.now()-new Date(n).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=w,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(De[27],Ce([1,0,3,2,218,128,25,4]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class y{constructor(b){this.dependency=b}}e.MissingExtensionDependency=y;var p;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(p=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class L{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(b,t){const o=[],s=[],a=[],l=[],E=T(this.c),i=T(b),r=($,x)=>$.extensionLocation.toString()===x.extensionLocation.toString()||$.isBuiltin===x.isBuiltin||$.isUserBuiltin===x.isUserBuiltin||$.isUnderDevelopment===x.isUnderDevelopment;for(const $ of this.c){const x=i.get($.identifier);if(!x){o.push($.identifier),E.delete($.identifier);continue}if(!r($,x)){o.push($.identifier),E.delete($.identifier);continue}}for(const $ of b){const x=E.get($.identifier);if(!x){s.push($);continue}if(!r(x,$)){o.push(x.identifier),E.delete(x.identifier);continue}}const m=new P.ExtensionIdentifierSet(this.d),g=new P.ExtensionIdentifierSet(t);for(const $ of this.d)g.has($)||a.push($);for(const $ of t)m.has($)||l.push($);const h=R.ImplicitActivationEvents.createActivationEventsMap(s),O={toRemove:o,toAdd:s,addActivationEvents:h,myToRemove:a,myToAdd:l};return this.delta(O),O}delta(b){const{toRemove:t,toAdd:o,myToRemove:s,myToAdd:a}=b,l=new P.ExtensionIdentifierSet(t),E=new P.ExtensionIdentifierSet(s);for(let i=0;i<this.c.length;i++)l.has(this.c[i].identifier)&&(this.c.splice(i,1),i--);for(let i=0;i<this.d.length;i++)E.has(this.d[i])&&(this.d.splice(i,1),i--);for(const i of o)this.c.push(i);for(const i of a)this.d.push(i)}containsExtension(b){for(const t of this.d)if(P.ExtensionIdentifier.equals(t,b))return!0;return!1}}e.ExtensionHostExtensions=L;function T(D){const b=new P.ExtensionIdentifierMap;for(const t of D)b.set(t.identifier,t);return b}function S(D,b){return D.enabledApiProposals?D.enabledApiProposals.includes(b):!1}e.isProposedApiEnabled=S;function I(D,b){if(!S(D,b))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.checkProposedApiEnabled=I;class C{constructor(b,t,o,s){this.codeLoadingTime=b,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=s}}e.ActivationTimes=C;class w{constructor(b,t){this.description=b,this.value=t}}e.ExtensionPointContribution=w;var n;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,u.getGalleryExtensionId)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function f(D,b){return{identifier:new P.ExtensionIdentifier((0,u.getExtensionId)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!b,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform,browserNlsBundleUris:D.browserNlsBundleUris}}e.toExtensionDescription=f;class v{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(b,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=v}),define(De[242],Ce([1,0,9,135,25,27,16,19]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(d,f,v,D){this.startup=d,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=D}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class p{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,f){return d===-1||f===-1?-1:f-d}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=p;class L{constructor(d,f,v,D,b,t){this.activationFailed=d,this.activationFailedError=f,this.activationTimes=v,this.module=D,this.exports=b,this.subscriptions=t}}e.ActivatedExtension=L;class T extends L{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class S extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class I extends L{constructor(d){super(!0,d,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(d,f,v,D){this.g=D,this.a=d,this.b=f,this.c=v,this.d=new u.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[d,f]of this.d)f.dispose()}isActivated(d){const f=this.d.get(d);return Boolean(f&&f.value)}getActivatedExtension(d){const f=this.d.get(d);if(!f||!f.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return f.value}async activateByEvent(d,f){if(this.f[d])return;const v=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(v.map(D=>({id:D.identifier,reason:{startup:f,extensionId:D.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,f){const v=this.a.getExtensionDescription(d);if(!v)throw new Error(`Extension '${d}' is not known`);return this.h([{id:v.identifier,reason:f}])}async h(d){const f=d.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(f.map(v=>v.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const f=this.a.getExtensionDescription(d.id);if(!f){const b=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new I(b));return this.c.onExtensionActivationError(d.id,b,new R.MissingExtensionDependency(d.id.value)),t}const v=[],D=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const b of D){if(this.m(b))continue;const t=this.d.get(b);if(t){v.push(t);continue}if(this.l(b)){v.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:d.reason}));continue}const o=this.a.getExtensionDescription(b);if(o){if(!o.main&&!o.browser)continue;v.push(this.j({id:o.identifier,reason:d.reason}));continue}const s=f.displayName||f.identifier.value,a=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${b}'`),l=this.k(d,f.displayName,[],new I(a));return this.c.onExtensionActivationError(f.identifier,a,new R.MissingExtensionDependency(b)),l}return this.k(d,f.displayName,v,null)}k(d,f,v,D){const b=new w(d.id,f,d.reason,v,D,this.c,this.g);return this.d.set(d.id,b),b}l(d){return A.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const f=this.b.getExtensionDescription(d);return f?!f.main&&!f.browser:!1}};C=Ve([We(3,P.ILogService)],C),e.ExtensionsActivator=C;let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,f,v,D,b,t,o){this.c=d,this.d=f,this.f=v,this.g=D,this.h=b,this.j=t,this.k=o,this.a=new k.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const f=this.g[d];if(f.value&&!f.value.activationFailed){this.g.splice(d,1),d--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this.h=new I(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const f=new Error;if(d&&d.name&&(f.name=d.name),d&&d.message?f.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:f.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(f.stack=d.stack),this.h=new I(f),this.b&&c.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,f,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};w=Ve([We(6,P.ILogService)],w)});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[7],Ce([1,0,17,9,113,28,89,8,10,2,30,45,127,94,27]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C){"use strict";var w,n,d,f,v,D,b,t,o,s,a,l,E,i,r,m,g,h,O,$,x,Y,G,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(X){return Object.assign(X,{apply:function(){const pe=arguments.length===1?[]:arguments[1];return Reflect.construct(X,pe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(X,[]);{const[pe,...Te]=arguments;return Reflect.construct(X,Te,pe.constructor)}}})}var j;(function(X){X[X.Top=0]="Top",X[X.Bottom=1]="Bottom"})(j=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var he;(function(X){X[X.Command=0]="Command",X[X.Opener=1]="Opener"})(he=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let ie=t=class{static from(...H){let pe=H;return new t(function(){if(pe){for(const Te of pe)Te&&typeof Te.dispose=="function"&&Te.dispose();pe=void 0}})}constructor(H){w.set(this,void 0),_e(this,w,H,"f")}dispose(){typeof Me(this,w,"f")=="function"&&(Me(this,w,"f").call(this),_e(this,w,void 0,"f"))}};w=new WeakMap,ie=t=Ve([U],ie),e.Disposable=ie;let V=o=class{static Min(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let Te=1;Te<H.length;Te++){const qe=H[Te];qe.isBefore(pe)&&(pe=qe)}return pe}static Max(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let Te=1;Te<H.length;Te++){const qe=H[Te];qe.isAfter(pe)&&(pe=qe)}return pe}static isPosition(H){if(!H)return!1;if(H instanceof o)return!0;const{line:pe,character:Te}=H;return typeof pe=="number"&&typeof Te=="number"}static of(H){if(H instanceof o)return H;if(this.isPosition(H))return new o(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,pe){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(pe<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=H,this.e=pe}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,pe=0){if(H===null||pe===null)throw(0,A.illegalArgument)();let Te;return typeof H>"u"?Te=0:typeof H=="number"?Te=H:(Te=typeof H.lineDelta=="number"?H.lineDelta:0,pe=typeof H.characterDelta=="number"?H.characterDelta:0),Te===0&&pe===0?this:new o(this.line+Te,this.character+pe)}with(H,pe=this.character){if(H===null||pe===null)throw(0,A.illegalArgument)();let Te;return typeof H>"u"?Te=this.line:typeof H=="number"?Te=H:(Te=typeof H.line=="number"?H.line:this.line,pe=typeof H.character=="number"?H.character:this.character),Te===this.line&&pe===this.character?this:new o(Te,pe)}toJSON(){return{line:this.line,character:this.character}}};V=o=Ve([U],V),e.Position=V;let J=s=class{static isRange(H){return H instanceof s?!0:H?V.isPosition(H.start)&&V.isPosition(H.end):!1}static of(H){if(H instanceof s)return H;if(this.isRange(H))return new s(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,pe,Te,qe){let Je,at;if(typeof H=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof qe=="number"?(Je=new V(H,pe),at=new V(Te,qe)):V.isPosition(H)&&V.isPosition(pe)&&(Je=V.of(H),at=V.of(pe)),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this.c=Je,this.e=at):(this.c=at,this.e=Je)}contains(H){return s.isRange(H)?this.contains(H.start)&&this.contains(H.end):V.isPosition(H)?!(V.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const pe=V.Max(H.start,this.c),Te=V.Min(H.end,this.e);if(!pe.isAfter(Te))return new s(pe,Te)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const pe=V.Min(H.start,this.c),Te=V.Max(H.end,this.end);return new s(pe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,pe=this.end){if(H===null||pe===null)throw(0,A.illegalArgument)();let Te;return H?V.isPosition(H)?Te=H:(Te=H.start||this.start,pe=H.end||this.end):Te=this.start,Te.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Te,pe)}toJSON(){return[this.start,this.end]}};J=s=Ve([U],J),e.Range=J;let ne=a=class extends J{static isSelection(H){return H instanceof a?!0:H?J.isRange(H)&&V.isPosition(H.anchor)&&V.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,pe,Te,qe){let Je,at;if(typeof H=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof qe=="number"?(Je=new V(H,pe),at=new V(Te,qe)):V.isPosition(H)&&V.isPosition(pe)&&(Je=V.of(H),at=V.of(pe)),!Je||!at)throw new Error("Invalid arguments");super(Je,at),this.f=Je,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ne=a=Ve([U],ne),e.Selection=ne;class ve{constructor(H,pe,Te){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,A.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(pe),this.connectionToken=Te}}e.ResolvedAuthority=ve;class ue extends Error{static NotAvailable(H,pe){return new ue(H,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(H){return new ue(H,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Te){super(H),this._message=H,this._code=pe,this._detail=Te,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var ee;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var N;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=l=class{static isTextEdit(H){return H instanceof l?!0:H?J.isRange(H)&&typeof H.newText=="string":!1}static replace(H,pe){return new l(H,pe)}static insert(H,pe){return l.replace(new J(H,H),pe)}static delete(H){return l.replace(H,"")}static setEndOfLine(H){const pe=new l(new J(new V(0,0),new V(0,0)),"");return pe.newEol=H,pe}get range(){return this.c}set range(H){if(H&&!J.isRange(H))throw(0,A.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this.f=H}constructor(H,pe){this.c=H,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};q=l=Ve([U],q),e.TextEdit=q;let ae=E=class{static isNotebookCellEdit(H){return H instanceof E?!0:H?Gt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,pe){return new E(H,pe)}static insertCells(H,pe){return new E(new Gt(H,H),pe)}static deleteCells(H){return new E(H,[])}static updateCellMetadata(H,pe){const Te=new E(new Gt(H,H),[]);return Te.newCellMetadata=pe,Te}static updateNotebookMetadata(H){const pe=new E(new Gt(0,0),[]);return pe.newNotebookMetadata=H,pe}constructor(H,pe){this.range=H,this.newCells=pe}};ae=E=Ve([U],ae),e.NotebookEdit=ae;class me{static isSnippetTextEdit(H){return H instanceof me?!0:H?J.isRange(H.range)&&le.isSnippetString(H.snippet):!1}static replace(H,pe){return new me(H,pe)}static insert(H,pe){return me.replace(new J(H,H),pe)}constructor(H,pe){this.range=H,this.snippet=pe}}e.SnippetTextEdit=me;var ke;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace",X[X.Snippet=6]="Snippet"})(ke=e.FileEditType||(e.FileEditType={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,pe,Te,qe){this.c.push({_type:1,from:H,to:pe,options:Te,metadata:qe})}createFile(H,pe,Te){this.c.push({_type:1,from:void 0,to:H,options:pe,metadata:Te})}deleteFile(H,pe,Te){this.c.push({_type:1,from:H,to:void 0,options:pe,metadata:Te})}e(H,pe,Te){this.c.push({_type:3,metadata:Te,uri:H,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(H,pe,Te,qe){const Je=pe.start,at=pe.end;(Je!==at||Te.length>0)&&this.c.push({_type:5,uri:H,index:Je,count:at-Je,cells:Te,metadata:qe})}g(H,pe,Te,qe){this.c.push({_type:3,metadata:qe,uri:H,edit:{editType:8,index:pe,metadata:Te}})}replace(H,pe,Te,qe){this.c.push({_type:2,uri:H,edit:new q(pe,Te),metadata:qe})}insert(H,pe,Te,qe){this.replace(H,new J(pe,pe),Te,qe)}delete(H,pe,Te){this.replace(H,pe,"",Te)}has(H){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===H.toString())}set(H,pe){if(pe)for(const Te of pe){if(!Te)continue;let qe,Je;Array.isArray(Te)?(qe=Te[0],Je=Te[1]):qe=Te,ae.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(H,qe.range.start,qe.newCellMetadata,Je):qe.newNotebookMetadata?this.e(H,qe.newNotebookMetadata,Je):this.f(H,qe.range,qe.newCells,Je):me.isSnippetTextEdit(qe)?this.c.push({_type:6,uri:H,range:qe.range,edit:qe.snippet,metadata:Je}):this.c.push({_type:2,uri:H,edit:qe,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const qe=this.c[Te];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===H.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(H){const pe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===H.toString()&&pe.push(Te.edit);return pe}entries(){const H=new R.ResourceMap;for(const pe of this.c)if(pe._type===2){let Te=H.get(pe.uri);Te||(Te=[pe.uri,[]],H.set(pe.uri,Te)),Te[1].push(pe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};_=Ve([U],_),e.WorkspaceEdit=_;let le=i=class{static isSnippetString(H){return H instanceof i?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=i.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,pe=this.e++){if(typeof H=="function"){const Te=new i;Te.e=this.e,H(Te),this.e=Te.e,H=Te.value}else H=i.c(H);return this.value+="${",this.value+=pe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,pe=this.e++){const Te=H.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(H,pe){if(typeof pe=="function"){const Te=new i;Te.e=this.e,pe(Te),this.e=Te.e,pe=Te.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};le=i=Ve([U],le),e.SnippetString=le;var de;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(de=e.DiagnosticTag||(e.DiagnosticTag={}));var te;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(te=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ce=r=class{static isLocation(H){return H instanceof r?!0:H?J.isRange(H.range)&&p.URI.isUri(H.uri):!1}constructor(H,pe){if(this.uri=H,pe)if(J.isRange(pe))this.range=J.of(pe);else if(V.isPosition(pe))this.range=new J(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ce=r=Ve([U],ce),e.Location=ce;let oe=class{static is(H){return H?typeof H.message=="string"&&H.location&&J.isRange(H.location.range)&&p.URI.isUri(H.location.uri):!1}constructor(H,pe){this.location=H,this.message=pe}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.location.range.isEqual(pe.location.range)&&H.location.uri.toString()===pe.location.uri.toString()}};oe=Ve([U],oe),e.DiagnosticRelatedInformation=oe;let F=class{constructor(H,pe,Te=te.Error){if(!J.isRange(H))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=H,this.message=pe,this.severity=Te}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.severity===pe.severity&&H.code===pe.code&&H.severity===pe.severity&&H.source===pe.source&&H.range.isEqual(pe.range)&&(0,c.equals)(H.tags,pe.tags)&&(0,c.equals)(H.relatedInformation,pe.relatedInformation,oe.isEqual)}};F=Ve([U],F),e.Diagnostic=F;let z=class{constructor(H,pe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=pe}};z=Ve([U],z),e.Hover=z;var K;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(K=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Z=class{constructor(H,pe=K.Text){this.range=H,this.kind=pe}toJSON(){return{range:this.range,kind:K[this.kind]}}};Z=Ve([U],Z),e.DocumentHighlight=Z;var fe;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(fe=e.SymbolKind||(e.SymbolKind={}));var Ee;(function(X){X[X.Deprecated=1]="Deprecated"})(Ee=e.SymbolTag||(e.SymbolTag={}));let Ae=m=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,pe,Te,qe,Je){this.name=H,this.kind=pe,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),qe instanceof ce?this.location=qe:Te instanceof J&&(this.location=new ce(qe,Te)),m.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};Ae=m=Ve([U],Ae),e.SymbolInformation=Ae;let we=g=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(g.validate)}constructor(H,pe,Te,qe,Je){this.name=H,this.detail=pe,this.kind=Te,this.range=qe,this.selectionRange=Je,this.children=[],g.validate(this)}};we=g=Ve([U],we),e.DocumentSymbol=we;var Pe;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Ie=class{constructor(H,pe){this.title=H,this.kind=pe}};Ie=Ve([U],Ie),e.CodeAction=Ie;let $e=h=class{constructor(H){this.value=H}append(H){return new h(this.value?this.value+h.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+h.c)}};$e.c=".",$e=h=Ve([U],$e),e.CodeActionKind=$e,$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorMove=$e.Refactor.append("move"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let xe=class{constructor(H,pe){if(this.range=H,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};xe=Ve([U],xe),e.SelectionRange=xe;class tt{constructor(H,pe,Te,qe,Je,at){this.kind=H,this.name=pe,this.detail=Te,this.uri=qe,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=tt;class Qe{constructor(H,pe){this.fromRanges=pe,this.from=H}}e.CallHierarchyIncomingCall=Qe;class it{constructor(H,pe){this.fromRanges=pe,this.to=H}}e.CallHierarchyOutgoingCall=it;var rt;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(rt=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Be=class{constructor(H,pe){this.range=H,this.command=pe}get isResolved(){return!!this.command}};Be=Ve([U],Be),e.CodeLens=Be;let et=O=class{static isMarkdownString(H){return H instanceof O?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,pe=!1){n.set(this,void 0),_e(this,n,new u.MarkdownString(H,{supportThemeIcons:pe}),"f")}get value(){return Me(this,n,"f").value}set value(H){Me(this,n,"f").value=H}get isTrusted(){return Me(this,n,"f").isTrusted}set isTrusted(H){Me(this,n,"f").isTrusted=H}get supportThemeIcons(){return Me(this,n,"f").supportThemeIcons}set supportThemeIcons(H){Me(this,n,"f").supportThemeIcons=H}get supportHtml(){return Me(this,n,"f").supportHtml}set supportHtml(H){Me(this,n,"f").supportHtml=H}get baseUri(){return Me(this,n,"f").baseUri}set baseUri(H){Me(this,n,"f").baseUri=H}appendText(H){return Me(this,n,"f").appendText(H),this}appendMarkdown(H){return Me(this,n,"f").appendMarkdown(H),this}appendCodeblock(H,pe){return Me(this,n,"f").appendCodeblock(pe??"",H),this}};n=new WeakMap,et=O=Ve([U],et),e.MarkdownString=et;let W=class{constructor(H,pe){this.label=H,this.documentation=pe}};W=Ve([U],W),e.ParameterInformation=W;let Q=class{constructor(H,pe){this.label=H,this.documentation=pe,this.parameters=[]}};Q=Ve([U],Q),e.SignatureInformation=Q;let ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ge=Ve([U],ge),e.SignatureHelp=ge;var Le;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let je=class{constructor(H){this.value=H}};je=Ve([U],je),e.InlayHintLabelPart=je;let Ye=class{constructor(H,pe,Te){this.position=H,this.label=pe,this.kind=Te}};Ye=Ve([U],Ye),e.InlayHint=Ye;var Xe;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var nt;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(nt=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(X){X[X.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let pt=class{constructor(H,pe){this.label=H,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&nt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pt=Ve([U],pt),e.CompletionItem=pt;let bt=class{constructor(H=[],pe=!1){this.items=H,this.isIncomplete=pe}};bt=Ve([U],bt),e.CompletionList=bt;let St=class{constructor(H,pe,Te){this.insertText=H,this.range=pe,this.command=Te}};St=Ve([U],St),e.InlineSuggestion=St;let Pt=class{constructor(H){this.commands=void 0,this.items=H}};Pt=Ve([U],Pt),e.InlineSuggestionList=Pt;var zt;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})(zt=e.ViewColumn||(e.ViewColumn={}));var Xt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var vt;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(vt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var wt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(wt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function H(pe){switch(pe){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=H}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let kt=class{constructor(H,pe){if(pe&&!p.URI.isUri(pe))throw(0,A.illegalArgument)("target");if(!J.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=pe}};kt=Ve([U],kt),e.DocumentLink=kt;let At=class{constructor(H,pe,Te,qe){this.red=H,this.green=pe,this.blue=Te,this.alpha=qe}};At=Ve([U],At),e.Color=At;let Bt=class{constructor(H,pe){if(pe&&!(pe instanceof At))throw(0,A.illegalArgument)("color");if(!J.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=pe}};Bt=Ve([U],Bt),e.ColorInformation=Bt;let Ke=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};Ke=Ve([U],Ke),e.ColorPresentation=Ke;var Wt;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var Re;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Re=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Fe;(function(X){X[X.Unknown=0]="Unknown",X[X.Shutdown=1]="Shutdown",X[X.Process=2]="Process",X[X.User=3]="User",X[X.Extension=4]="Extension"})(Fe=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(H,pe,Te){if(this.startIndex=H,this.length=pe,this.tooltip=Te,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,A.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Se;class se{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=se;class Oe{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=Oe;var He;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(He=e.TerminalLocation||(e.TerminalLocation={}));class Ze{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Ze;var Ge;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(Ge=e.TaskRevealKind||(e.TaskRevealKind={}));var ct;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(ct=e.TaskPanelKind||(e.TaskPanelKind={}));let mt=$=class{static from(H){switch(H){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(H,pe){if(this.label=pe,typeof H!="string"||typeof pe!="string")throw(0,A.illegalArgument)("name");this.c=H}get id(){return this.c}};mt.Clean=new $("clean","Clean"),mt.Build=new $("build","Build"),mt.Rebuild=new $("rebuild","Rebuild"),mt.Test=new $("test","Test"),mt=$=Ve([U],mt),e.TaskGroup=mt;function gt(X){let H="";for(let pe=0;pe<X.length;pe++)H+=X[pe].replace(/,/g,",,")+",";return H}let dt=class{constructor(H,pe,Te){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=H,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Te):this.f=pe)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)H.push(pe);return gt(H)}};dt=Ve([U],dt),e.ProcessExecution=dt;let lt=class{constructor(H,pe,Te){if(this.f=[],Array.isArray(pe)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H,this.f=pe,this.g=Te}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H,this.g=pe}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)H.push(typeof pe=="string"?pe:pe.value);return gt(H)}};lt=Ve([U],lt),e.ShellExecution=lt;var yt;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var Tt;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(Tt=e.TaskScope||(e.TaskScope={}));class Ht{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=Ht;let Ft=x=class{constructor(H,pe,Te,qe,Je,at){this.j=!1,this.k=this.definition=H;let ut;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Te,this.execution=qe,ut=Je,this.j=!0):pe===Tt.Global||pe===Tt.Workspace?(this.target=pe,this.m=this.name=Te,this.t=this.source=qe,this.execution=Je,ut=at):(this.target=pe,this.m=this.name=Te,this.t=this.source=qe,this.execution=Je,ut=at),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof dt?this.k={type:x.e,id:this.n.computeId()}:this.n instanceof lt?this.k={type:x.f,id:this.n.computeId()}:this.n instanceof Ht?this.k={type:x.c,id:this.n.computeId()}:this.k={type:x.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const pe=this.k.type;(x.g===pe||x.e===pe||x.f===pe||x.c===pe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};Ft.c="customExecution",Ft.e="process",Ft.f="shell",Ft.g="$empty",Ft=x=Ve([U],Ft),e.Task=Ft;var ai;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(ai=e.ProgressLocation||(e.ProgressLocation={}));var Rt;(function(X){function H(pe){const Te=pe;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}X.isViewBadge=H})(Rt=e.ViewBadge||(e.ViewBadge={}));let yi=Y=class{static isTreeItem(H,pe){const Te=H;if(Te.checkboxState!==void 0){(0,C.checkProposedApiEnabled)(pe,"treeItemCheckbox");const qe=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(qe===void 0||qe!==It.Checked&&qe!==It.Unchecked||Je!==void 0&&!(0,y.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(H instanceof Y)return!0;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!p.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const qe=Te.iconPath;if(!qe||!(0,y.isString)(qe.light)&&!p.URI.isUri(qe.light)&&!(0,y.isString)(qe.dark)&&!p.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!p.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<ci.None&&Te.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(H,pe=ci.None){this.collapsibleState=pe,p.URI.isUri(H)?this.resourceUri=H:this.label=H}};yi=Y=Ve([U],yi),e.TreeItem=yi;var ci;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var It;(function(X){X[X.Unchecked=0]="Unchecked",X[X.Checked=1]="Checked"})(It=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let li=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,pe){this.value=H,this.id=pe??(0,L.generateUuid)()}};li=Ve([U],li),e.DataTransferItem=li;let ui=class{constructor(H){d.add(this),f.set(this,new Map);for(const[pe,Te]of H??[]){const qe=Me(this,f,"f").get(Me(this,d,"m",v).call(this,pe));qe?qe.push(Te):Me(this,f,"f").set(Me(this,d,"m",v).call(this,pe),[Te])}}get(H){return Me(this,f,"f").get(Me(this,d,"m",v).call(this,H))?.[0]}set(H,pe){Me(this,f,"f").set(Me(this,d,"m",v).call(this,H),[pe])}forEach(H,pe){for(const[Te,qe]of Me(this,f,"f"))for(const Je of qe)H.call(pe,Je,Te,this)}*[(f=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[H,pe]of Me(this,f,"f"))for(const Te of pe)yield[H,Te]}};v=function(H){return H.toLowerCase()},ui=Ve([U],ui),e.DataTransfer=ui;let Zt=class{constructor(H){this.insertText=H}};Zt=Ve([U],Zt),e.DocumentDropEdit=Zt;let Di=class{constructor(H){this.insertText=H}};Di=Ve([U],Di),e.DocumentPasteEdit=Di;let Dt=class{constructor(H,pe){this.id=H,this.color=pe}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};Dt=Ve([U],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let di=class{constructor(H){this.id=H}};di=Ve([U],di),e.ThemeColor=di;var $i;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})($i=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(H){this.c=H,this.e=p.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,pe){if(typeof H!="string"&&(!H||!p.URI.isUri(H)&&!p.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof pe!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=p.URI.file(H):p.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=Ve([U],ei),e.RelativePattern=ei;const ii=new WeakMap;function ht(X,H){ii.set(X,H)}e.setBreakpointId=ht;let ti=class{constructor(H,pe,Te,qe){this.enabled=typeof H=="boolean"?H:!0,typeof pe=="string"&&(this.condition=pe),typeof Te=="string"&&(this.hitCondition=Te),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this.c||(this.c=ii.get(this)??(0,L.generateUuid)()),this.c}};ti=Ve([U],ti),e.Breakpoint=ti;let Vt=class extends ti{constructor(H,pe,Te,qe,Je){if(super(pe,Te,qe,Je),H===null)throw(0,A.illegalArgument)("location");this.location=H}};Vt=Ve([U],Vt),e.SourceBreakpoint=Vt;let Qt=class extends ti{constructor(H,pe,Te,qe,Je){super(pe,Te,qe,Je),this.functionName=H}};Qt=Ve([U],Qt),e.FunctionBreakpoint=Qt;let hi=class extends ti{constructor(H,pe,Te,qe,Je,at,ut){if(super(qe,Je,at,ut),!pe)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=pe,this.canPersist=Te}};hi=Ve([U],hi),e.DataBreakpoint=hi;let Ci=class{constructor(H,pe,Te){this.command=H,this.args=pe||[],this.options=Te}};Ci=Ve([U],Ci),e.DebugAdapterExecutable=Ci;let Ii=class{constructor(H,pe){this.port=H,this.host=pe}};Ii=Ve([U],Ii),e.DebugAdapterServer=Ii;let fi=class{constructor(H){this.path=H}};fi=Ve([U],fi),e.DebugAdapterNamedPipeServer=fi;let ki=class{constructor(H){this.implementation=H}};ki=Ve([U],ki),e.DebugAdapterInlineImplementation=ki;let mi=class{constructor(H,pe){this.range=H,this.expression=pe}};mi=Ve([U],mi),e.EvaluatableExpression=mi;var gi;(function(X){X[X.Invoke=0]="Invoke",X[X.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ti=class{constructor(H,pe){this.range=H,this.text=pe}};Ti=Ve([U],Ti),e.InlineValueText=Ti;let ni=class{constructor(H,pe,Te=!0){this.range=H,this.variableName=pe,this.caseSensitiveLookup=Te}};ni=Ve([U],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(H,pe){this.range=H,this.expression=pe}};ri=Ve([U],ri),e.InlineValueEvaluatableExpression=ri;let Pi=class{constructor(H,pe){this.frameId=H,this.stoppedLocation=pe}};Pi=Ve([U],Pi),e.InlineValueContext=Pi;var zi;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})(zi=e.FileChangeType||(e.FileChangeType={}));let Yt=G=class extends Error{static FileExists(H){return new G(H,T.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(H){return new G(H,T.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(H){return new G(H,T.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(H){return new G(H,T.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(H){return new G(H,T.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(H){return new G(H,T.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(H,pe=T.FileSystemProviderErrorCode.Unknown,Te){super(p.URI.isUri(H)?H.toString(!0):H),this.code=Te?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Yt=G=Ve([U],Yt),e.FileSystemError=Yt;let Ai=class{constructor(H,pe,Te){this.start=H,this.end=pe,this.kind=Te}};Ai=Ve([U],Ai),e.FoldingRange=Ai;var Wi;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ni;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Ni=e.CommentMode||(e.CommentMode={}));var ji;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(ji=e.CommentThreadState||(e.CommentThreadState={}));class Vi{constructor(H,pe=[]){this.tokenTypes=H,this.tokenModifiers=pe}}e.SemanticTokensLegend=Vi;function xi(X){return typeof X>"u"||(0,y.isStringArray)(X)}class si{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let pe=0,Te=H.tokenTypes.length;pe<Te;pe++)this.j.set(H.tokenTypes[pe],pe);for(let pe=0,Te=H.tokenModifiers.length;pe<Te;pe++)this.k.set(H.tokenModifiers[pe],pe)}}push(H,pe,Te,qe,Je){if(typeof H=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof qe=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(H,pe,Te,qe,Je);if(J.isRange(H)&&typeof pe=="string"&&xi(Te))return this.m(H,pe,Te);throw(0,A.illegalArgument)()}m(H,pe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const qe=H.start.line,Je=H.start.character,at=H.end.character-H.start.character,ut=this.j.get(pe);let Mt=0;if(Te)for(const jt of Te){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(jt);Mt|=1<<xt>>>0}this.n(qe,Je,at,ut,Mt)}n(H,pe,Te,qe,Je){if(this.f&&(H<this.c||H===this.c&&pe<this.e)){this.f=!1;const Mt=this.g.length/5|0;let jt=0,xt=0;for(let Kt=0;Kt<Mt;Kt++){let Jt=this.g[5*Kt],Li=this.g[5*Kt+1];Jt===0?(Jt=jt,Li+=xt):Jt+=jt,this.g[5*Kt]=Jt,this.g[5*Kt+1]=Li,jt=Jt,xt=Li}}let at=H,ut=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(ut-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ut,this.g[this.h++]=Te,this.g[this.h++]=qe,this.g[this.h++]=Je,this.c=H,this.e=pe}static o(H){const pe=[],Te=H.length/5|0;for(let ut=0;ut<Te;ut++)pe[ut]=ut;pe.sort((ut,Mt)=>{const jt=H[5*ut],xt=H[5*Mt];if(jt===xt){const Kt=H[5*ut+1],Jt=H[5*Mt+1];return Kt-Jt}return jt-xt});const qe=new Uint32Array(H.length);let Je=0,at=0;for(let ut=0;ut<Te;ut++){const Mt=5*pe[ut],jt=H[Mt+0],xt=H[Mt+1],Kt=H[Mt+2],Jt=H[Mt+3],Li=H[Mt+4],ln=jt-Je,On=ln===0?xt-at:xt,Oi=5*ut;qe[Oi+0]=ln,qe[Oi+1]=On,qe[Oi+2]=Kt,qe[Oi+3]=Jt,qe[Oi+4]=Li,Je=jt,at=xt}return qe}build(H){return this.f?new pi(new Uint32Array(this.g),H):new pi(si.o(this.g),H)}}e.SemanticTokensBuilder=si;class pi{constructor(H,pe){this.resultId=pe,this.data=H}}e.SemanticTokens=pi;class Fi{constructor(H,pe,Te){this.start=H,this.deleteCount=pe,this.data=Te}}e.SemanticTokensEdit=Fi;class ze{constructor(H,pe){this.resultId=pe,this.edits=H}}e.SemanticTokensEdits=ze;var qt;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let oi=class{constructor(){}};oi.Back={iconPath:new Dt("arrow-left")},oi=Ve([U],oi),e.QuickInputButtons=oi;var Et;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var qi;(function(X){X[X.Info=1]="Info",X[X.Warning=2]="Warning",X[X.Error=3]="Error"})(qi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Gi;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(Gi=e.ExtensionKind||(e.ExtensionKind={}));class Mi{static validate(H){if(typeof H.badge=="string"){let pe=(0,k.nextCharLength)(H.badge,0);if(pe<H.badge.length&&(pe+=(0,k.nextCharLength)(H.badge,pe)),H.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Dt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,pe,Te){this.badge=H,this.tooltip=pe,this.color=Te}}e.FileDecoration=Mi;let Ri=class{constructor(H){this.kind=H}};Ri=Ve([U],Ri),e.ColorTheme=Ri;var bi;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast",X[X.HighContrastLight=4]="HighContrastLight"})(bi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(H){return H instanceof Gt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,pe){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(pe<0)throw(0,A.illegalArgument)("end must be positive");H<=pe?(this.c=H,this.e=pe):(this.c=pe,this.e=H)}with(H){let pe=this.c,Te=this.e;return H.start!==void 0&&(pe=H.start),H.end!==void 0&&(Te=H.end),pe===this.c&&Te===this.e?this:new Gt(pe,Te)}}e.NotebookRange=Gt;class vi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(pe=>vi.isNotebookCellData(pe))}static isNotebookCellData(H){return!0}constructor(H,pe,Te,qe,Je,at,ut){this.kind=H,this.value=pe,this.languageId=Te,this.mime=qe,this.outputs=Je??[],this.metadata=at,this.executionSummary=ut,vi.validate(this)}}e.NotebookCellData=vi;class Ki{constructor(H){this.cells=H}}e.NotebookData=Ki;class $t{static isNotebookCellOutputItem(H){return H instanceof $t?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const pe={name:H.name,message:H.message,stack:H.stack};return $t.json(pe,"application/vnd.code.notebook.error")}static stdout(H){return $t.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return $t.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,pe="application/octet-stream"){return new $t(H,pe)}static text(H,pe=P.Mimes.text){const Te=Me($t,D,"f",b).encode(String(H));return new $t(Te,pe)}static json(H,pe="text/x-json"){const Te=JSON.stringify(H,void 0,"	");return $t.text(Te,pe)}constructor(H,pe){this.data=H,this.mime=pe;const Te=(0,P.normalizeMimeType)(pe,!0);if(!Te)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}D=$t,b={value:new TextEncoder},e.NotebookCellOutputItem=$t;class wi{static isNotebookCellOutput(H){return H instanceof wi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,pe=!1){const Te=new Set,qe=new Set;for(let Je=0;Je<H.length;Je++){const at=H[Je],ut=(0,P.normalizeMimeType)(at.mime);if(!Te.has(ut)||(0,I.isTextStreamMime)(ut)){Te.add(ut);continue}qe.add(Je),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?H:H.filter((Je,at)=>!qe.has(at))}constructor(H,pe,Te){this.items=wi.ensureUniqueMimeTypes(H,!0),typeof pe=="string"?(this.id=pe,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=pe??Te)}}e.NotebookCellOutput=wi;var Xi;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ji;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ji=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class _i{constructor(H,pe){this.text=H,this.alignment=pe}}e.NotebookCellStatusBarItem=_i;var Zi;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(Zi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var be;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred",X[X.Hidden=-1]="Hidden"})(be=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ye{constructor(H,pe=[]){this.uri=H,this.provides=(0,c.asArray)(pe)}}e.NotebookRendererScript=ye;class Ue{constructor(H){this.label=H}}e.NotebookKernelSourceAction=Ue;let st=class{constructor(H,pe){this.label=H,this.timestamp=pe}};st=Ve([U],st),e.TimelineItem=st;var Ct;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(Ct=e.ExtensionMode||(e.ExtensionMode={}));var Lt;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(Lt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(H,pe){this.ranges=H,this.wordPattern=pe}}e.LinkedEditingRanges=gn;class pn{constructor(H,pe){this.c=H,this.e=pe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=pn;var bn;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(bn=e.TestResultState||(e.TestResultState={}));var vn;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(vn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(H=void 0,pe=void 0,Te=void 0){this.include=H,this.exclude=pe,this.profile=Te}};Ui=Ve([U],Ui),e.TestRunRequest=Ui;let en=class extends Ui{constructor(H=void 0,pe=void 0,Te=void 0,qe=!1){super(H,pe,Te),this.continuous=qe}};en=Ve([U],en),e.TestRunRequest2=en;let tn=M=class{static diff(H,pe,Te){const qe=new M(H);return qe.expectedOutput=pe,qe.actualOutput=Te,qe}constructor(H){this.message=H}};tn=M=Ve([U],tn),e.TestMessage=tn;let nn=class{constructor(H){this.id=H}};nn=Ve([U],nn),e.TestTag=nn;let Ei=class{constructor(H,pe){this.covered=H,this.total=pe}};Ei=Ve([U],Ei),e.CoveredCount=Ei;let rn=B=class{static fromDetails(H,pe){const Te=new Ei(0,0),qe=new Ei(0,0),Je=new Ei(0,0);for(const ut of pe)if("branches"in ut){Te.total+=1,Te.covered+=ut.executionCount>0?1:0;for(const Mt of ut.branches)qe.total+=1,qe.covered+=Mt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ut.executionCount>0?1:0;const at=new B(H,Te,qe.total>0?qe:void 0,Je.total>0?Je:void 0);return at.detailedCoverage=pe,at}constructor(H,pe,Te,qe){this.uri=H,this.statementCoverage=pe,this.branchCoverage=Te,this.functionCoverage=qe}};rn=B=Ve([U],rn),e.FileCoverage=rn;let sn=class{constructor(H,pe,Te=[]){this.executionCount=H,this.location=pe,this.branches=Te}};sn=Ve([U],sn),e.StatementCoverage=sn;let on=class{constructor(H,pe){this.executionCount=H,this.location=pe}};on=Ve([U],on),e.BranchCoverage=on;let an=class{constructor(H,pe){this.executionCount=H,this.location=pe}};an=Ve([U],an),e.FunctionCoverage=an;var wn;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var En;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(En=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(H,pe,Te,qe,Je,at){this.kind=H,this.name=pe,this.detail=Te,this.uri=qe,this.range=Je,this.selectionRange=at}}e.TypeHierarchyItem=yn;class Dn{constructor(H){this.uri=H}}e.TextTabInput=Dn;class Cn{constructor(H,pe){this.original=H,this.modified=pe}}e.TextDiffTabInput=Cn;class In{constructor(H,pe,Te,qe){this.base=H,this.input1=pe,this.input2=Te,this.result=qe}}e.TextMergeTabInput=In;class kn{constructor(H,pe){this.uri=H,this.viewType=pe}}e.CustomEditorTabInput=kn;class Tn{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=Tn;class Pn{constructor(H,pe){this.uri=H,this.notebookType=pe}}e.NotebookEditorTabInput=Pn;class An{constructor(H,pe,Te){this.original=H,this.modified=pe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class Ln{constructor(H,pe){this.uri=H,this.inputBoxUri=pe}}e.InteractiveWindowInput=Ln}),define(De[136],Ce([1,0,51,18,8,167,107,7,17]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const p=new Map;function L(C,w){w?p.set(C,w):p.delete(C)}e.setWordDefinitionFor=L;function T(C){return p.get(C)}class S extends R.MirrorTextModel{constructor(w,n,d,f,v,D,b,t){super(n,d,f,v),this.m=w,this.p=D,this.q=b,this.notebook=t,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,y.equals)(this.d,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.c},get fileName(){return w.c.fsPath},get isUntitled(){return w.c.scheme===A.Schemas.untitled},get languageId(){return w.p},get version(){return w.g},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(n){return n?w.s(n):w.getText()},get eol(){return w.f===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w.d.length},lineAt(n){return w.t(n)},offsetAt(n){return w.u(n)},positionAt(n){return w.v(n)},validateRange(n){return w.w(n)},validatePosition(n){return w.x(n)},getWordRangeAtPosition(n,d){return w.y(n,d)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,c.ok)(!this.b),this.p=w}_acceptIsDirty(w){(0,c.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(w){const n=this.w(w);if(n.isEmpty)return"";if(n.isSingleLine)return this.d[n.start.line].substring(n.start.character,n.end.character);const d=this.f,f=n.start.line,v=n.end.line,D=[];D.push(this.d[f].substring(n.start.character));for(let b=f+1;b<v;b++)D.push(this.d[b]);return D.push(this.d[v].substring(0,n.end.character)),D.join(d)}t(w){let n;if(w instanceof k.Position?n=w.line:typeof w=="number"&&(n=w),typeof n!="number"||n<0||n>=this.d.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new I(n,this.d[n],n===this.d.length-1)}u(w){return w=this.x(w),this.k(),this.h.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.k();const n=this.h.getIndexOf(w),d=this.d[n.index].length;return new k.Position(n.index,Math.min(n.remainder,d))}w(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const n=this.x(w.start),d=this.x(w.end);return n===w.start&&d===w.end?w:new k.Range(n.line,n.character,d.line,d.character)}x(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this.d.length===0)return w.with(0,0);let{line:n,character:d}=w,f=!1;if(n<0)n=0,d=0,f=!0;else if(n>=this.d.length)n=this.d.length-1,d=this.d[n].length,f=!0;else{const v=this.d[n].length;d<0?(d=0,f=!0):d>v&&(d=v,f=!0)}return f?new k.Position(n,d):w}y(w,n){const d=this.x(w);if(!n)n=T(this.p);else if((0,u.regExpLeadsToEndlessLoop)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const f=(0,P.getWordAtText)(d.character+1,(0,P.ensureValidWordDefinition)(n),this.d[d.line],0);if(f)return new k.Range(d.line,f.startColumn-1,d.line,f.endColumn-1)}}e.ExtHostDocumentData=S;class I{constructor(w,n,d){this.a=w,this.b=n,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new k.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new k.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=I}),define(De[243],Ce([1,0,7,20,3]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(k){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new u.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(k){let y;switch(k){case"light":y=c.ColorThemeKind.Light;break;case"hcDark":y=c.ColorThemeKind.HighContrast;break;case"hcLight":y=c.ColorThemeKind.HighContrastLight;break;default:y=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(De[13],Ce([1,0,17,22,151,63,113,28,149,70,89,23,10,2,32,73,123,133,130,94,57,77,239,7]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Fe(se){const{selectionStartLineNumber:Oe,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:Ge}=se,ct=new o.Position(Oe-1,He-1),mt=new o.Position(Ze-1,Ge-1);return new o.Selection(ct,mt)}Re.to=Fe;function Se(se){const{anchor:Oe,active:He}=se;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(s=e.Selection||(e.Selection={}));var a;(function(Re){function Fe(se){if(!se)return;const{start:Oe,end:He}=se;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Fe;function Se(se){if(!se)return;const{startLineNumber:Oe,startColumn:He,endLineNumber:Ze,endColumn:Ge}=se;return new o.Range(Oe-1,He-1,Ze-1,Ge-1)}Re.to=Se})(a=e.Range||(e.Range={}));var l;(function(Re){function Fe(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Fe})(l=e.TokenType||(e.TokenType={}));var E;(function(Re){function Fe(se){return new o.Position(se.lineNumber-1,se.column-1)}Re.to=Fe;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Re.from=Se})(E=e.Position||(e.Position={}));var i;(function(Re){function Fe(Oe,He){return(0,c.coalesce)((0,c.asArray)(Oe).map(Ze=>Se(Ze,He)))}Re.from=Fe;function Se(Oe,He){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:se(Oe.scheme,He),pattern:ge.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function se(Oe,He){return He&&typeof Oe=="string"?He.transformOutgoingScheme(Oe):Oe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Re){function Fe(se){switch(se){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function Se(se){switch(se){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Re){function Fe(se){let Oe;return se.code&&((0,S.isString)(se.code)||(0,S.isNumber)(se.code)?Oe=String(se.code):Oe={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Oe,severity:h.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(g.from),tags:Array.isArray(se.tags)?(0,c.coalesce)(se.tags.map(r.from)):void 0}}Re.from=Fe;function Se(se){const Oe=new o.Diagnostic(a.to(se),se.message,h.to(se.severity));return Oe.source=se.source,Oe.code=(0,S.isString)(se.code)?se.code:se.code?.value,Oe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(g.to),Oe.tags=se.tags&&(0,c.coalesce)(se.tags.map(r.to)),Oe}Re.to=Se})(m=e.Diagnostic||(e.Diagnostic={}));var g;(function(Re){function Fe(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Re.from=Fe;function Se(se){return new o.DiagnosticRelatedInformation(new o.Location(se.resource,a.to(se)),se.message)}Re.to=Se})(g=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Re){function Fe(se){switch(se){case o.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Re.from=Fe;function Se(se){switch(se){case n.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=Se})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Re){function Fe(se){return typeof se=="number"&&se>=o.ViewColumn.One?se-1:se===o.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Re.from=Fe;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(O=e.ViewColumn||(e.ViewColumn={}));function $(Re){return typeof Re.range<"u"}function x(Re){return Re.length===0?!0:!!$(Re[0])}e.isDecorationOptionsArr=x;var Y;(function(Re){function Fe(Ge){return Ge.map(Re.from)}Re.fromMany=Fe;function Se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function se(Ge){let ct;if(Se(Ge)){const{language:lt,value:yt}=Ge;ct={value:"```"+lt+`
`+yt+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const mt=Object.create(null);ct.uris=mt;const gt=lt=>{try{let yt=I.URI.parse(lt,!0);yt=yt.with({query:Oe(yt.query,mt)}),mt[lt]=yt}catch{}return""},dt=new y.marked.Renderer;return dt.link=gt,dt.image=lt=>typeof lt=="string"?gt(P.parseHrefAndDimensions(lt).href):"",(0,y.marked)(ct.value,{renderer:dt}),ct}Re.from=se;function Oe(Ge,ct){if(!Ge)return Ge;let mt;try{mt=(0,p.parse)(Ge)}catch{}if(!mt)return Ge;let gt=!1;return mt=(0,T.cloneAndChange)(mt,dt=>{if(I.URI.isUri(dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[lt]=dt,gt=!0,lt}else return}),gt?JSON.stringify(mt):Ge}function He(Ge){const ct=new o.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?I.URI.from(Ge.baseUri):void 0,ct}Re.to=He;function Ze(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Re.from(Ge)}Re.fromStrict=Ze})(Y=e.MarkdownString||(e.MarkdownString={}));function G(Re){return x(Re)?Re.map(Fe=>({range:a.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?Y.fromMany(Fe.hoverMessage):Fe.hoverMessage?Y.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:a.from(Fe)}))}e.fromRangeOrRangeWithMessage=G;function M(Re){return typeof Re>"u"?Re:typeof Re=="string"?I.URI.file(Re):Re}e.pathOrURIToURI=M;var B;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?M(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Fe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?M(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Fe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var he;(function(Re){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?U.from(Se.light):void 0,dark:Se.dark?U.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?M(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Fe})(he=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(Re){function Fe(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Re.from=Fe;function Se(se){const Oe=new o.TextEdit(a.to(se.range),se.text);return Oe.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Oe}Re.to=Se})(ie=e.TextEdit||(e.TextEdit={}));var V;(function(Re){function Fe(se,Oe){const He={edits:[]};if(se instanceof o.WorkspaceEdit){const Ze=new k.ResourceSet;for(const Ge of se._allEntries())Ge._type===1&&I.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of se._allEntries())Ge._type===1?He.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?He.edits.push({resource:Ge.uri,textEdit:ie.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?He.edits.push({resource:Ge.uri,textEdit:{range:a.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?He.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&He.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ot.from)}})}return He}Re.from=Fe;function Se(se){const Oe=new o.WorkspaceEdit;for(const He of se.edits)He.textEdit?Oe.replace(I.URI.revive(He.resource),a.to(He.textEdit.range),He.textEdit.text):Oe.renameFile(I.URI.revive(He.oldResource),I.URI.revive(He.newResource),He.options);return Oe}Re.to=Se})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function Se(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Re.from=Se;function se(Oe){for(const He in Fe)if(Fe[He]===Oe)return Number(He);return o.SymbolKind.Property}Re.to=se})(J=e.SymbolKind||(e.SymbolKind={}));var ne;(function(Re){function Fe(se){switch(se){case o.SymbolTag.Deprecated:return 1}}Re.from=Fe;function Se(se){switch(se){case 1:return o.SymbolTag.Deprecated}}Re.to=Se})(ne=e.SymbolTag||(e.SymbolTag={}));var ve;(function(Re){function Fe(se){return{name:se.name,kind:J.from(se.kind),tags:se.tags&&se.tags.map(ne.from),containerName:se.containerName,location:ae.from(se.location)}}Re.from=Fe;function Se(se){const Oe=new o.SymbolInformation(se.name,J.to(se.kind),se.containerName,ae.to(se.location));return Oe.tags=se.tags&&se.tags.map(ne.to),Oe}Re.to=Se})(ve=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(Re){function Fe(se){const Oe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:J.from(se.kind),tags:se.tags?.map(ne.from)??[]};return se.children&&(Oe.children=se.children.map(Fe)),Oe}Re.from=Fe;function Se(se){const Oe=new o.DocumentSymbol(se.name,se.detail,J.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,c.isNonEmptyArray)(se.tags)&&(Oe.tags=se.tags.map(ne.to)),se.children&&(Oe.children=se.children.map(Se)),Oe}Re.to=Se})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Re){function Fe(se){const Oe=new o.CallHierarchyItem(J.to(se.kind),se.name,se.detail||"",I.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Re.to=Fe;function Se(se,Oe,He){if(Oe=Oe??se._sessionId,He=He??se._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,name:se.name,detail:se.detail,kind:J.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ne.from)}}Re.from=Se})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Re){function Fe(Se){return new o.CallHierarchyIncomingCall(ee.to(Se.from),Se.fromRanges.map(se=>a.to(se)))}Re.to=Fe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(Re){function Fe(Se){return new o.CallHierarchyOutgoingCall(ee.to(Se.to),Se.fromRanges.map(se=>a.to(se)))}Re.to=Fe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ae;(function(Re){function Fe(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Re.from=Fe;function Se(se){return new o.Location(I.URI.revive(se.uri),a.to(se.range))}Re.to=Se})(ae=e.location||(e.location={}));var me;(function(Re){function Fe(se){const Oe=se,He=se;return{originSelectionRange:Oe.originSelectionRange?a.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:He.uri,range:a.from(Oe.targetRange?Oe.targetRange:He.range),targetSelectionRange:Oe.targetSelectionRange?a.from(Oe.targetSelectionRange):void 0}}Re.from=Fe;function Se(se){return{targetUri:I.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Re.to=Se})(me=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Re){function Fe(se){return{range:a.from(se.range),contents:Y.fromMany(se.contents)}}Re.from=Fe;function Se(se){return new o.Hover(se.contents.map(Y.to),a.to(se.range))}Re.to=Se})(ke=e.Hover||(e.Hover={}));var _;(function(Re){function Fe(se){return{range:a.from(se.range),expression:se.expression}}Re.from=Fe;function Se(se){return new o.EvaluatableExpression(a.to(se.range),se.expression)}Re.to=Se})(_=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Re){function Fe(se){if(se instanceof o.InlineValueText)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof o.InlineValueVariableLookup)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function Se(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Re.to=Se})(le=e.InlineValue||(e.InlineValue={}));var de;(function(Re){function Fe(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Re.from=Fe;function Se(se){return new o.InlineValueContext(se.frameId,a.to(se.stoppedLocation))}Re.to=Se})(de=e.InlineValueContext||(e.InlineValueContext={}));var te;(function(Re){function Fe(se){return{range:a.from(se.range),kind:se.kind}}Re.from=Fe;function Se(se){return new o.DocumentHighlight(a.to(se.range),se.kind)}Re.to=Se})(te=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Fe(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Fe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Re){function Fe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Fe})(oe=e.CompletionContext||(e.CompletionContext={}));var F;(function(Re){function Fe(se){switch(se){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function Se(se){switch(se){case 1:return o.CompletionItemTag.Deprecated}}Re.to=Se})(F=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Re){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Fe.get(He)??9}Re.from=Se;const se=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Oe(He){return se.get(He)??o.CompletionItemKind.Property}Re.to=Oe})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Re){function Fe(Se,se){const Oe=new o.CompletionItem(Se.label);return Oe.insertText=Se.insertText,Oe.kind=z.to(Se.kind),Oe.tags=Se.tags?.map(F.to),Oe.detail=Se.detail,Oe.documentation=P.isMarkdownString(Se.documentation)?Y.to(Se.documentation):Se.documentation,Oe.sortText=Se.sortText,Oe.filterText=Se.filterText,Oe.preselect=Se.preselect,Oe.commitCharacters=Se.commitCharacters,C.Range.isIRange(Se.range)?Oe.range=a.to(Se.range):typeof Se.range=="object"&&(Oe.range={inserting:a.to(Se.range.insert),replacing:a.to(Se.range.replace)}),Oe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Oe.insertText=new o.SnippetString(Se.insertText):(Oe.insertText=Se.insertText,Oe.textEdit=Oe.range instanceof o.Range?new o.TextEdit(Oe.range,Oe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Se.additionalTextEdits.map(He=>ie.to(He))),Oe.command=se&&Se.command?se.fromInternal(Se.command):void 0,Oe}Re.to=Fe})(K=e.CompletionItem||(e.CompletionItem={}));var Z;(function(Re){function Fe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:Y.fromStrict(se.documentation)}}Re.from=Fe;function Se(se){return{label:se.label,documentation:P.isMarkdownString(se.documentation)?Y.to(se.documentation):se.documentation}}Re.to=Se})(Z=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(Re){function Fe(se){return{label:se.label,documentation:Y.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Z.from):[],activeParameter:se.activeParameter}}Re.from=Fe;function Se(se){return{label:se.label,documentation:P.isMarkdownString(se.documentation)?Y.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Z.to):[],activeParameter:se.activeParameter}}Re.to=Se})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(Re){function Fe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(fe.from):[]}}Re.from=Fe;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(fe.to):[]}}Re.to=Se})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Fe(Se,se){const Oe=new o.InlayHint(E.to(se.position),typeof se.label=="string"?se.label:se.label.map(we.to.bind(void 0,Se)),se.kind&&Pe.to(se.kind));return Oe.textEdits=se.textEdits&&se.textEdits.map(ie.to),Oe.tooltip=P.isMarkdownString(se.tooltip)?Y.to(se.tooltip):se.tooltip,Oe.paddingLeft=se.paddingLeft,Oe.paddingRight=se.paddingRight,Oe}Re.to=Fe})(Ae=e.InlayHint||(e.InlayHint={}));var we;(function(Re){function Fe(Se,se){const Oe=new o.InlayHintLabelPart(se.label);return Oe.tooltip=P.isMarkdownString(se.tooltip)?Y.to(se.tooltip):se.tooltip,w.Command.is(se.command)&&(Oe.command=Se.fromInternal(se.command)),se.location&&(Oe.location=ae.to(se.location)),Oe}Re.to=Fe})(we=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Pe;(function(Re){function Fe(se){return se}Re.from=Fe;function Se(se){return se}Re.to=Se})(Pe=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(Re){function Fe(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Re.from=Fe;function Se(se){let Oe;if(se.url)try{Oe=typeof se.url=="string"?I.URI.parse(se.url,!0):I.URI.revive(se.url)}catch{}return new o.DocumentLink(a.to(se.range),Oe)}Re.to=Se})(Ie=e.DocumentLink||(e.DocumentLink={}));var $e;(function(Re){function Fe(se){const Oe=new o.ColorPresentation(se.label);return se.textEdit&&(Oe.textEdit=ie.to(se.textEdit)),se.additionalTextEdits&&(Oe.additionalTextEdits=se.additionalTextEdits.map(He=>ie.to(He))),Oe}Re.to=Fe;function Se(se){return{label:se.label,textEdit:se.textEdit?ie.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Oe=>ie.from(Oe)):void 0}}Re.from=Se})($e=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(Re){function Fe(se){return new o.Color(se[0],se[1],se[2],se[3])}Re.to=Fe;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Re.from=Se})(xe=e.Color||(e.Color={}));var tt;(function(Re){function Fe(se){return{range:a.from(se.range)}}Re.from=Fe;function Se(se){return new o.SelectionRange(a.to(se.range))}Re.to=Se})(tt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Fe(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(Re){function Fe(se){switch(se){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function Se(se){switch(se){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=Se})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Re){function Fe(se){if(se===o.EndOfLine.CRLF)return 1;if(se===o.EndOfLine.LF)return 0}Re.from=Fe;function Se(se){if(se===1)return o.EndOfLine.CRLF;if(se===0)return o.EndOfLine.LF}Re.to=Se})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Re){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var et;(function(Re){function Fe(se){const Oe={start:se.start+1,end:se.end+1};return se.kind&&(Oe.kind=W.from(se.kind)),Oe}Re.from=Fe;function Se(se){const Oe={start:se.start-1,end:se.end-1};return se.kind&&(Oe.kind=W.to(se.kind)),Oe}Re.to=Se})(et=e.FoldingRange||(e.FoldingRange={}));var W;(function(Re){function Fe(se){if(se)switch(se){case o.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Re.from=Fe;function Se(se){if(se)switch(se.value){case w.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Re.to=Se})(W=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(Re){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?a.from(Se.selection):void 0,override:typeof Se.override=="boolean"?f.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Fe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ge;(function(Re){function Fe(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||se(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Fe;function Se(He){const Ze=He;return Ze?I.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function se(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(He){return typeof He=="string"?He:new o.RelativePattern(I.URI.revive(He.baseUri),He.pattern)}Re.to=Oe})(ge=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Re){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:ge.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Re.from=Fe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Re){function Fe(se){return{start:se.start,end:se.end}}Re.from=Fe;function Se(se){return new o.NotebookRange(se.start,se.end)}Re.to=Se})(Ne=e.NotebookRange||(e.NotebookRange={}));var je;(function(Re){function Fe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Re.to=Fe;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Re.from=Se})(je=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(Re){function Fe(Se){if(Se===v.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===v.NotebookCellExecutionState.Pending)return;if(Se===v.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Fe})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Fe(se){switch(se){case o.NotebookCellKind.Markup:return v.CellKind.Markup;case o.NotebookCellKind.Code:default:return v.CellKind.Code}}Re.from=Fe;function Se(se){switch(se){case v.CellKind.Markup:return o.NotebookCellKind.Markup;case v.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=Se})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Re){function Fe(se){const Oe={metadata:se.metadata??Object.create(null),cells:[]};for(const He of se.cells)o.NotebookCellData.validate(He),Oe.cells.push(ot.from(He));return Oe}Re.from=Fe;function Se(se){const Oe=new o.NotebookData(se.cells.map(ot.to));return(0,S.isEmptyObject)(se.metadata)||(Oe.metadata=se.metadata),Oe}Re.to=Se})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(Re){function Fe(se){return{cellKind:Xe.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:je.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(bt.from):[]}}Re.from=Fe;function Se(se){return new o.NotebookCellData(Xe.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(bt.to):void 0,se.metadata,se.internalMetadata?je.to(se.internalMetadata):void 0)}Re.to=Se})(ot=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(Re){function Fe(se){return{mime:se.mime,valueBytes:A.VSBuffer.wrap(se.data)}}Re.from=Fe;function Se(se){return new o.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Re.to=Se})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var bt;(function(Re){function Fe(se){return{outputId:se.id,items:se.items.map(pt.from),metadata:se.metadata}}Re.from=Fe;function Se(se){const Oe=se.items.map(pt.to);return new o.NotebookCellOutput(Oe,se.outputId,se.metadata)}Re.to=Se})(bt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var St;(function(Re){function Fe(Oe){return se(Oe)?{include:(0,S.withNullAsUndefined)(ge.from(Oe.include)),exclude:(0,S.withNullAsUndefined)(ge.from(Oe.exclude))}:(0,S.withNullAsUndefined)(ge.from(Oe))}Re.from=Fe;function Se(Oe){return se(Oe)?{include:ge.to(Oe.include),exclude:ge.to(Oe.exclude)}:ge.to(Oe)}Re.to=Se;function se(Oe){const He=Oe;return He?!(0,S.isUndefinedOrNull)(He.include)&&!(0,S.isUndefinedOrNull)(He.exclude):!1}})(St=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pt;(function(Re){function Fe(Se,se,Oe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(He,Oe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Fe})(Pt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var zt;(function(Re){function Fe(Se,se,Oe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(He,Oe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Fe})(zt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Xt;(function(Re){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Fe})(Xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ft;(function(Re){function Fe(se){return{uri:se.uri,provides:se.provides}}Re.from=Fe;function Se(se){return new o.NotebookRendererScript(I.URI.revive(se.uri),se.provides)}Re.to=Se})(ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var vt;(function(Re){function Fe(se){return{message:Y.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Re.from=Fe;function Se(se){const Oe=new o.TestMessage(typeof se.message=="string"?se.message:Y.to(se.message));return Oe.actualOutput=se.actual,Oe.expectedOutput=se.expected,Oe.location=se.location?ae.to(se.location):void 0,Oe}Re.to=Se})(vt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Re){Re.namespace=b.namespaceTestTag,Re.denamespace=b.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Ut;(function(Re){function Fe(se){const Oe=(0,d.getPrivateApiFor)(se).controllerId;return{extId:D.TestId.fromExtHostTestItem(se,Oe).toString(),label:se.label,uri:I.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(He=>Ot.namespace(Oe,He.id)),range:C.Range.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&Y.fromStrict(se.error)||null}}Re.from=Fe;function Se(se){return{parent:void 0,error:void 0,id:D.TestId.fromString(se.extId).localId,label:se.label,uri:I.URI.revive(se.uri),tags:(se.tags||[]).map(Oe=>{const{tagId:He}=Ot.denamespace(Oe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Re.toPlain=Se})(Ut=e.TestItem||(e.TestItem={})),function(Re){function Fe(se){return{id:se.id}}Re.from=Fe;function Se(se){return new o.TestTag(se.id)}Re.to=Se}(Ot=e.TestTag||(e.TestTag={}));var Nt;(function(Re){const Fe=(se,Oe)=>{const He=[];for(const[Ge,ct]of Oe)D.TestId.compare(ct.item.extId,Ge)===2&&(Oe.delete(Ge),He.push(ct));const Ze={...Ut.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===0).map(vt.to)})),children:He.map(Ge=>Fe(Ge,Oe))};for(const Ge of Ze.children)Ge.parent=Ze;return Ze};function Se(se){const Oe=[],He=new Map;for(const Ze of se.items){He.set(Ze.item.extId,Ze);const Ge=D.TestId.root(Ze.item.extId);se.request.targets.some(ct=>ct.controllerId===Ge&&ct.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:se.completedAt,results:Oe.map(Ze=>Fe(Ze,He))}}Re.to=Se})(Nt=e.TestResults||(e.TestResults={}));var wt;(function(Re){function Fe(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?E.from(He):a.from(He)}function se(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&Se(Ze.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=se;function Oe(He){return{uri:He.uri,statement:Fe(He.statementCoverage),branch:He.branchCoverage&&Fe(He.branchCoverage),function:He.functionCoverage&&Fe(He.functionCoverage),details:He.detailedCoverage?.map(se)}}Re.fromFile=Oe})(wt=e.TestCoverage||(e.TestCoverage={}));var kt;(function(Re){function Fe(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Fe})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(Re){function Fe(se){const Oe=new o.TypeHierarchyItem(J.to(se.kind),se.name,se.detail||"",I.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Re.to=Fe;function Se(se,Oe,He){if(Oe=Oe??se._sessionId,He=He??se._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,kind:J.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ne.from)}}Re.from=Se})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Fe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Fe})(Bt=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Re){function Fe(He,Ze,Ge){const ct=Ze.fileData;return ct?new class extends o.DataTransferItem{asFile(){return{name:ct.name,uri:I.URI.revive(ct.uri),data:(0,R.once)(()=>Ge())}}}("",Ze.id):He===L.Mimes.uriList&&Ze.uriListData?new o.DataTransferItem(Oe(Ze.uriListData)):new o.DataTransferItem(Ze.asString)}Re.to=Fe;async function Se(He,Ze){const Ge=await Ze.asString();if(He===L.Mimes.uriList)return{id:Ze.id,asString:Ge,fileData:void 0,uriListData:se(Ge)};const ct=Ze.asFile();return{id:Ze.id,asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}}Re.from=Se;function se(He){return u.UriList.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return I.URI.parse(Ze)}catch{}return Ze})}function Oe(He){return u.UriList.create(He.map(Ze=>typeof Ze=="string"?Ze:I.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Wt;(function(Re){function Fe(se,Oe){const He=se.items.map(([Ze,Ge])=>[Ze,Ke.to(Ze,Ge,()=>Oe(Ge.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Fe;async function Se(se){const Oe={items:[]},He=[];return se.forEach((Ze,Ge)=>{He.push((async()=>{Oe.items.push([Ge,await Ke.from(Ge,Ze)])})())}),await Promise.all(He),Oe}Re.toDataTransferDTO=Se})(Wt=e.DataTransfer||(e.DataTransfer={}))}),define(De[244],Ce([1,0,2,9,7,13,66]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(p,L,T,S={timeout:1500,errors:3}){this.c=p,this.d=L,this.f=T,this.g=S,this.a=new P.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(p){return(L,T,S)=>{const C={dispose:this.a.push([L,T,p])};return Array.isArray(S)&&S.push(C),C}}async $participateInSave(p,L){const T=c.URI.revive(p);let S=!1;const I=setTimeout(()=>S=!0,this.g.timeout),C=[];try{for(const w of[...this.a]){if(S)break;const n=this.d.getDocument(T),d=await this.h(w,{document:n,reason:R.TextDocumentSaveReason.to(L)});C.push(d)}}finally{clearTimeout(I)}return C}h([p,L,T],S){const I=this.b.get(p);return typeof I=="number"&&I>this.g.errors?Promise.resolve(!1):this.i(T,p,L,S).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const w=this.b.get(p);this.b.set(p,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(p,L,T,S){const I=[],C=Date.now(),{document:w,reason:n}=S,{version:d}=w,f=Object.freeze({document:w,reason:n,waitUntil(v){if(Object.isFrozen(I))throw(0,A.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(v))}});try{L.apply(T,[f])}catch(v){return Promise.reject(v)}return Object.freeze(I),new Promise((v,D)=>{const b=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(I).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(b),v(t)}).catch(t=>{clearTimeout(b),D(t)})}).then(v=>{const D={edits:[]};for(const b of v)if(Array.isArray(b)&&b.every(t=>t instanceof u.TextEdit))for(const{newText:t,newEol:o,range:s}of b)D.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:t,eol:o&&R.EndOfLine.from(o)}});if(D.edits.length!==0)return d===w.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(De[245],Ce([1,0,18,2,13,7,94]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(T,S,I,C){this.start=T,this.deletedCount=S,this.deletedItems=I,this.items=C}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(T,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,S,I){this.notebook=T,this.h=S,this.j=I,this.handle=I.handle,this.uri=A.URI.revive(I.uri),this.cellKind=I.cellKind,this.a=I.outputs.map(u.NotebookCellOutput.to),this.e=I.internalMetadata??{},this.b=Object.freeze(I.metadata??{}),this.d=Object.freeze(u.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,S=this.h.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:u.NotebookCellKind.to(this.j.cellKind),document:S.document,get mime(){return T.g},set mime(C){T.g=C},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(I)}return this.f}setOutputs(T){this.a=T.map(u.NotebookCellOutput.to)}setOutputItems(T,S,I){const C=I.map(u.NotebookCellOutputItem.to),w=this.a.find(n=>n.id===T);if(w&&(S||(w.items.length=0),w.items.push(...C),w.items.length>1&&w.items.every(n=>P.isTextStreamMime(n.mime)))){const n=new Map,d=[];w.items.forEach(f=>{let v;n.has(f.mime)?v=n.get(f.mime):(v=[],n.set(f.mime,v),d.push(f.mime)),v.push(f.data)}),w.items.length=0,d.forEach(f=>{const v=P.compressOutputItemStreams(n.get(f));w.items.push({mime:f,data:v.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(u.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=y;class p{constructor(T,S,I,C,w){this.k=T,this.l=S,this.m=I,this.uri=C,this.handle=p.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,S={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===c.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(I){return I=T.n(I),T.b[I].apiCell},getCells(I){return(I?T.p(I):T.b).map(w=>w.apiCell)},save(){return T.q()}};this.e=Object.freeze(S)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,S,I){this.g=T.versionId,this.h=S,this.acceptDocumentPropertiesChanged({metadata:I});const C={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},w=[];for(const d of T.rawEvents)d.kind===P.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,C.contentChanges):d.kind===P.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,C.contentChanges):d.kind===P.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),w.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),w.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),w.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===P.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),w.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),w.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const n=new Map;for(let d=0;d<w.length;d++){const f=w[d],v=n.get(f.cell);if(v===void 0){const D=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});n.set(f.cell,D-1)}else C.cellChanges[v]={...C.cellChanges[v],...f}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let S=T.start|0,I=T.end|0;return S<0&&(S=0),I>this.b.length&&(I=this.b.length),T.with({start:S,end:I})}p(T){T=this.o(T);const S=[];for(let I=T.start;I<T.end;I++)S.push(this.b[I]);return S}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,S,I){if(this.j)return;const C=[],w=[],n=[];if(T.reverse().forEach(d=>{const v=d[2].map(t=>{const o=new y(this,this.l,t);return S||w.push(y.asModelAddData(this.apiNotebook,t)),o}),D=new k(d[0],d[1],[],v),b=this.b.splice(d[0],d[1],...v);for(const t of b)n.push(t.uri),D.deletedItems.push(t.apiCell);C.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:n}),I)for(const d of C)I.push(d.asApiEvent())}s(T,S,I,C){const w=this.b.splice(T,S);this.b.splice(I,0,...w);const n=[new k(T,S,w.map(d=>d.apiCell),[]),new k(I,0,[],w)];for(const d of n)C.push(d.asApiEvent())}t(T,S){this.b[T].setOutputs(S)}u(T,S,I,C){this.b[T].setOutputItems(S,I,C)}v(T,S){const I=this.b[T];I.apiCell.document.languageId!==S&&this.m.$acceptModelLanguageChanged(I.uri,S)}w(T,S){const I=this.b[T];I.apiCell.mime=S}x(T,S){this.b[T].setMetadata(S)}y(T,S){this.b[T].setInternalMetadata(S)}getCellFromApiCell(T){return this.b.find(S=>S.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(S=>S.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}p.a=0,e.ExtHostNotebookDocument=p}),define(De[137],Ce([1,0,9,13,7]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(k,y,p,L,T,S){this.id=k,this.f=y,this.notebookData=p,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=L,this.c=S}get apiEditor(){if(!this.e){const k=this;this.e={get notebook(){return k.notebookData.apiNotebook},get selection(){return k.a[0]},set selection(y){this.selections=[y]},get selections(){return k.a},set selections(y){if(!Array.isArray(y)||!y.every(u.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");k.a=y,k.g(y)},get visibleRanges(){return k.b},revealRange(y,p){k.f.$tryRevealRange(k.id,A.NotebookRange.from(y),p??u.NotebookEditorRevealType.Default)},get viewColumn(){return k.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(k){this.d=k}_acceptVisibleRanges(k){this.b=k}_acceptSelections(k){this.a=k}g(k){this.f.$trySetSelections(this.id,k.map(A.NotebookRange.from))}_acceptViewColumn(k){this.c=k}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(De[246],Ce([1,0,9,3,16,13]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(y,p){this.c=y,this.d=p,this.a=new A.Emitter({onListenerError:c.onUnexpectedExternalError}),this.b=new A.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(y,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,p);const L=this.d.getEditorById(y);p.visibleRanges&&L._acceptVisibleRanges(p.visibleRanges.ranges.map(R.NotebookRange.to)),p.selections&&L._acceptSelections(p.selections.selections.map(R.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const p in y)this.d.getEditorById(p)._acceptViewColumn(R.ViewColumn.to(y[p]))}};P=Ve([We(0,u.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[247],Ce([1,0,13,125,184,21,62,9]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,I,C){const w=this.b++,{title:n,location:d,cancellable:f}=I,v={label:(0,u.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this.a.$startProgress(w,{location:c.ProgressLocation.from(d),title:n,source:v,cancellable:f},S.isUnderDevelopment?void 0:S.identifier.value).catch(k.onUnexpectedExternalError),this.d(w,C,!!f)}d(S,I,C){let w;C&&(w=new R.CancellationTokenSource,this.c.set(S,w));const n=f=>{this.a.$progressEnd(f),this.c.delete(f),w?.dispose()};let d;try{d=I(new L(this.a,S),C&&w?w.token:R.CancellationToken.None)}catch(f){throw n(S),f}return d.then(f=>n(S),f=>n(S)),d}$acceptProgressCanceled(S){const I=this.c.get(S);I&&(I.cancel(),this.c.delete(S))}}e.ExtHostProgress=y;function p(T,S){return T.message=S.message,typeof S.increment=="number"&&(typeof T.increment=="number"?T.increment+=S.increment:T.increment=S.increment),T}class L extends A.Progress{constructor(S,I){super(C=>this.throttledReport(C)),this.c=S,this.d=I}throttledReport(S){this.c.$progressReport(this.d,S)}}Ve([(0,P.throttle)(100,(T,S)=>p(T,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[138],Ce([1,0,32,133,57,95,77,13,2]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const p=(v,D,b,t)=>{let o=D;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!b(o,s)){const a=o;o=s,v.listener?.(t(s,a))}}}},L=(v,D)=>v===D,T={range:(v,D)=>v===D?!0:!v||!D?!1:v.isEqual(D),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(v,D)=>!(v.length!==D.length||v.some(b=>!D.find(t=>b.id===t.id)))},S=v=>D=>({op:4,update:v(D)}),I=(v,D)=>({range:(()=>{let b;const t=S(o=>({range:c.Range.lift(k.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return b},set(o){v.listener?.({op:6}),T.range(b,o)||(b=o,v.listener?.(t(o)))}}})(),label:p(v,D,T.label,S(b=>({label:b}))),description:p(v,void 0,T.description,S(b=>({description:b}))),sortText:p(v,void 0,T.sortText,S(b=>({sortText:b}))),canResolveChildren:p(v,!1,T.canResolveChildren,b=>({op:2,state:b})),busy:p(v,!1,T.busy,S(b=>({busy:b}))),error:p(v,void 0,T.error,S(b=>({error:k.MarkdownString.fromStrict(b)||null}))),tags:p(v,[],T.tags,(b,t)=>({op:1,new:b.map(k.TestTag.from),old:t.map(k.TestTag.from)}))}),C=v=>{const D=u.TestId.fromString(v.extId),b=new n(D.controllerId,D.localId,v.label,y.URI.revive(v.uri)||void 0);return b.range=k.Range.to(v.range||void 0),b.description=v.description||void 0,b.sortText=v.sortText||void 0,b.tags=v.tags.map(t=>k.TestTag.to({id:(0,P.denamespaceTestTag)(t).tagId})),b},w=v=>{let D;for(const b of v.tests){const t=C(b.item);(0,A.getPrivateApiFor)(t).parent=D,D=t}return D};e.toItemFromContext=w;class n{constructor(D,b,t,o){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const s=(0,A.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof d?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,A.getPrivateApiFor,n),enumerable:!0,writable:!1},...I(s,t)})}}e.TestItemImpl=n;class d extends n{constructor(D,b){super(D,D,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class f extends R.TestItemCollection{constructor(D,b,t){super({controllerId:D,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new d(D,b),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=f}),define(De[139],Ce([1,0,51,9,102,13,7]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class k{constructor(S,I,C){const w=k.c.nextId();S.$registerTextEditorDecorationType(I.identifier,w,R.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:w,dispose(){S.$removeTextEditorDecorationType(w)}})}}k.c=new u.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=k;class y{constructor(S,I){this.g=[],this.h=void 0,this.j=!1,this.c=S,this.d=S.version,this.e=I.undoStopBefore,this.f=I.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(S,I){this.k();let C=null;if(S instanceof P.Position)C=new P.Range(S,S);else if(S instanceof P.Range)C=S;else throw new Error("Unrecognized location");this.l(C,I,!1)}insert(S,I){this.k(),this.l(new P.Range(S,S),I,!0)}delete(S){this.k();let I=null;if(S instanceof P.Range)I=S;else throw new Error("Unrecognized location");this.l(I,null,!0)}l(S,I,C){const w=this.c.validateRange(S);this.g.push({range:w,text:I,forceMoveMarkers:C})}setEndOfLine(S){if(this.k(),S!==P.EndOfLine.LF&&S!==P.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=S}}class p{constructor(S,I,C,w){this.c=S,this.d=I,this._accept(C),this.e=w;const n=this;this.value={get tabSize(){return n.f},set tabSize(d){n.m(d)},get indentSize(){return n.g},set indentSize(d){n.o(d)},get insertSpaces(){return n.h},set insertSpaces(d){n.q(d)},get cursorStyle(){return n.j},set cursorStyle(d){n.s(d)},get lineNumbers(){return n.k},set lineNumbers(d){n.t(d)}}}_accept(S){this.f=S.tabSize,this.g=S.indentSize,this.h=S.insertSpaces,this.j=S.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(S.lineNumbers)}l(S){if(S==="auto")return"auto";if(typeof S=="number"){const I=Math.floor(S);return I>0?I:null}if(typeof S=="string"){const I=parseInt(S,10);return isNaN(I)?null:I>0?I:null}return null}m(S){const I=this.l(S);if(I!==null){if(typeof I=="number"){if(this.f===I)return;this.f=I}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:I}))}}n(S){if(S==="tabSize")return"tabSize";if(typeof S=="number"){const I=Math.floor(S);return I>0?I:null}if(typeof S=="string"){const I=parseInt(S,10);return isNaN(I)?null:I>0?I:null}return null}o(S){const I=this.n(S);if(I!==null){if(typeof I=="number"){if(this.g===I)return;this.g=I}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:I}))}}p(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}q(S){const I=this.p(S);if(typeof I=="boolean"){if(this.h===I)return;this.h=I}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:I}))}s(S){this.j!==S&&(this.j=S,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:S})))}t(S){this.k!==S&&(this.k=S,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(S)})))}assign(S){const I={};let C=!1;if(typeof S.tabSize<"u"){const w=this.l(S.tabSize);w==="auto"?(C=!0,I.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,C=!0,I.tabSize=w)}if(typeof S.indentSize<"u"){const w=this.n(S.indentSize);w==="tabSize"?(C=!0,I.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,C=!0,I.indentSize=w)}if(typeof S.insertSpaces<"u"){const w=this.p(S.insertSpaces);w==="auto"?(C=!0,I.insertSpaces=w):this.h!==w&&(this.h=w,C=!0,I.insertSpaces=w)}typeof S.cursorStyle<"u"&&this.j!==S.cursorStyle&&(this.j=S.cursorStyle,C=!0,I.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this.k!==S.lineNumbers&&(this.k=S.lineNumbers,C=!0,I.lineNumbers=R.TextEditorLineNumbersStyle.from(S.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,I))}u(S,I){I.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this.e.warn(C)})}}e.ExtHostTextEditorOptions=p;class L{constructor(S,I,C,w,n,d,f,v){this.id=S,this.j=I,this.k=C,this.g=!1,this.h=new Set,this.c=n,this.d=new p(this.j,this.id,d,C),this.e=f,this.f=v;const D=this;this.value=Object.freeze({get document(){return w.value},set document(b){throw(0,A.readonly)("document")},get selection(){return D.c&&D.c[0]},set selection(b){if(!(b instanceof P.Selection))throw(0,A.illegalArgument)("selection");D.c=[b],D.l()},get selections(){return D.c},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof P.Selection)))throw(0,A.illegalArgument)("selections");D.c=b,D.l()},get visibleRanges(){return D.e},set visibleRanges(b){throw(0,A.readonly)("visibleRanges")},get options(){return D.d.value},set options(b){D.g||D.d.assign(b)},get viewColumn(){return D.f},set viewColumn(b){throw(0,A.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new y(w.value,t);return b(o),D.m(o)},insertSnippet(b,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=D.c.map(a=>R.Range.from(a));else if(t instanceof P.Position){const{lineNumber:a,column:l}=R.Position.from(t);s=[{startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l}]}else if(t instanceof P.Range)s=[R.Range.from(t)];else{s=[];for(const a of t)if(a instanceof P.Range)s.push(R.Range.from(a));else{const{lineNumber:l,column:E}=R.Position.from(a);s.push({startLineNumber:l,startColumn:E,endLineNumber:l,endColumn:E})}}return I.$tryInsertSnippet(S,w.value.version,b.value,s,o)},setDecorations(b,t){const o=t.length===0;o&&!D.h.has(b.key)||(o?D.h.delete(b.key):D.h.add(b.key),D.n(()=>{if(R.isDecorationOptionsArr(t))return I.$trySetDecorations(S,b.key,R.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let a=0,l=t.length;a<l;a++){const E=t[a];s[4*a]=E.start.line+1,s[4*a+1]=E.start.character+1,s[4*a+2]=E.end.line+1,s[4*a+3]=E.end.character+1}return I.$trySetDecorationsFast(S,b.key,s)}}))},revealRange(b,t){D.n(()=>I.$tryRevealRange(S,R.Range.from(b),t||P.TextEditorRevealType.Default))},show(b){I.$tryShowEditor(S,R.ViewColumn.from(b))},hide(){I.$tryHideEditor(S)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(S){(0,c.ok)(!this.g),this.d._accept(S)}_acceptVisibleRanges(S){(0,c.ok)(!this.g),this.e=S}_acceptViewColumn(S){(0,c.ok)(!this.g),this.f=S}_acceptSelections(S){(0,c.ok)(!this.g),this.c=S}async l(){const S=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,S)),this.value}m(S){const I=S.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const C=I.edits.map(n=>n.range);C.sort((n,d)=>n.end.line===d.end.line?n.end.character===d.end.character?n.start.line===d.start.line?n.start.character-d.start.character:n.start.line-d.start.line:n.end.character-d.end.character:n.end.line-d.end.line);for(let n=0,d=C.length-1;n<d;n++){const f=C[n].end;if(C[n+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=I.edits.map(n=>({range:R.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,I.documentVersionId,w,{setEndOfLine:typeof I.setEndOfLine=="number"?R.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}n(S){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this.k.warn(I),null))}}e.ExtHostTextEditor=L}),define(De[248],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[249],Ce([1,0,200,9,37,122,93,39,25,248,213,128]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=k.Registry.as(P.Extensions.JSONContribution);class I{constructor(b,t,o){this.a=b,this.b=t,this.c=o}d(b,t){this.a({type:b,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(u.default.Error,b)}warn(b){this.d(u.default.Warning,b)}info(b){this.d(u.default.Info,b)}}e.ExtensionMessageCollector=I;class C{static a(b){const t=new y.ExtensionIdentifierSet;for(let o=0,s=b.length;o<s;o++)t.add(b[o].description.identifier);return t}static compute(b,t){if(!b||!b.length)return new C(t,[]);if(!t||!t.length)return new C([],b);const o=this.a(b),s=this.a(t),a=t.filter(E=>!o.has(E.description.identifier)),l=b.filter(E=>!s.has(E.description.identifier));return new C(a,l)}constructor(b,t){this.added=b,this.removed=t}}e.ExtensionPointUserDelta=C;class w{constructor(b,t){this.name=b,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=C.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,A.onUnexpectedError)(b)}}}e.ExtensionPoint=w;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class f{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const t=new w(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,t),b.activationEventsGenerator&&T.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,S.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};k.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=k.Registry.as(v.ExtensionsRegistry),S.registerSchema(d,e.schema),S.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}}]}}}})}),define(De[250],Ce([1,0,197,10,23,249,44,3]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var p;(function(S){function I(C,w,n){if(!C)return;const d=A.isString(C.type)?C.type:void 0;if(!d||d.length===0){n.error(c.localize(3,null));return}const f=[];if(Array.isArray(C.required))for(const v of C.required)A.isString(v)&&f.push(v);return{extensionId:w.value,taskType:d,required:f,properties:C.properties?u.deepClone(C.properties):{},when:C.when?P.ContextKeyExpr.deserialize(C.when):void 0}}S.from=I})(p||(p={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(S,I)=>{for(const C of S)C.type&&I.push(`onTaskType:${C.type}`)},jsonSchema:{description:c.localize(4,null),type:"array",items:y}});class T{constructor(){this.d=new k.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((I,C)=>{L.setHandler((w,n)=>{this.c=void 0;try{for(const d of n.removed){const f=d.value;for(const v of f)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const d of n.added){const f=d.value;for(const v of f){const D=p.from(v,d.description.identifier,d.collector);D&&(this.a[D.taskType]=D)}}(n.removed.length>0||n.added.length>0)&&this.d.fire()}catch{}I(void 0)})})}onReady(){return this.b}get(I){return this.a[I]}all(){return Object.keys(this.a).map(I=>this.a[I])}getJsonSchema(){if(this.c===void 0){const I=[];for(const C of this.all()){const w={type:"object",additionalProperties:!1};C.required.length>0&&(w.required=C.required.slice(0)),C.properties!==void 0?w.properties=u.deepClone(C.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[C.taskType]},I.push(w)}this.c={oneOf:I}}return this.c}}e.TaskDefinitionRegistry=new T}),define(De[251],Ce([1,0,198,10,24,23,44,250]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new P.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var y;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(M){function B(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=B}(y=e.ShellQuoting||(e.ShellQuoting={}));var p;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(p=e.CommandOptions||(e.CommandOptions={}));var L;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(M){function B(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=B}(L=e.RevealKind||(e.RevealKind={}));var T;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(M){function B(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=B}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(M){function B(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=B}(S=e.PanelKind||(e.PanelKind={}));var I;(function(M){M.defaults={echo:!0,reveal:L.Always,revealProblems:T.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var C;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(C=e.RuntimeType||(e.RuntimeType={})),function(M){function B(j){switch(j.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=B;function U(j){switch(j){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(C=e.RuntimeType||(e.RuntimeType={}));var w;(function(M){function B(U){return A.isString(U)?U:U.value}M.value=B})(w=e.CommandString||(e.CommandString={}));var n;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function B(j){return j===M.Clean._id||j===M.Build._id||j===M.Rebuild._id||j===M.Test._id}M.is=B;function U(j){if(j!==void 0)return A.isString(j)?B(j)?{_id:j,isDefault:!1}:void 0:j}M.from=U})(n=e.TaskGroup||(e.TaskGroup={}));var d;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var f;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function B(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=B})(f=e.TaskSourceKind||(e.TaskSourceKind={}));var v;(function(M){M.parallel="parallel",M.sequence="sequence"})(v=e.DependsOrder||(e.DependsOrder={}));var D;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(D=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class t{constructor(B,U,j,he,ie,V){this._label="",this._id=B,U&&(this._label=U),j&&(this.type=j),this.runOptions=he,this.configurationProperties=ie,this._source=V}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,U=!1){if(B===void 0)return!1;if(A.isString(B))return B===this._label||B===this.configurationProperties.identifier||U&&B===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class o extends t{constructor(B,U,j,he,ie,V,J,ne){super(B,j,void 0,J,ne,U),this.command={},this._source=U,this.hasDefinedMatchers=V,ie&&(this.command=ie)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case C.Shell:U="shell";break;case C.Process:U="process";break;case C.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(B){return B instanceof o}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new o(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=o;class s extends t{constructor(B,U,j,he,ie,V,J){super(B,j,he,V,J,U),this._source=U,this.configures=ie}static is(B){return B instanceof s}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(j)}}e.ConfiguringTask=s;class a extends t{constructor(B,U,j,he,ie,V,J,ne,ve){super(B,j,he,ne,ve,U),this.defines=ie,this.hasDefinedMatchers=J,this.command=V,this.icon=ve.icon,this.hide=ve.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof a}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new a(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=a;class l extends t{constructor(B,U,j,he,ie,V){super(B,j,he,ie,V,U),this._source=U}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new l(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=l;var E;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(E=e.ExecutionEngine||(e.ExecutionEngine={})),function(M){M._default=M.Terminal}(E=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(B){this.c=new Map;for(let U=0;U<B.length;U++)this.c.set(B[U].uri.toString(),U)}compare(B,U){const j=B.getWorkspaceFolder(),he=U.getWorkspaceFolder();if(j&&he){let ie=this.c.get(j.uri.toString());ie=ie===void 0?0:ie+1;let V=this.c.get(he.uri.toString());return V=V===void 0?0:V+1,ie===V?B._label.localeCompare(U._label):ie-V}else return!j&&he?-1:j&&!he?1:0}}e.TaskSorter=r;var m;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var g;(function(M){M.SingleRun="singleRun",M.Background="background"})(g=e.TaskRunType||(e.TaskRunType={}));var h;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(h=e.TaskRunSource||(e.TaskRunSource={}));var O;(function(M){function B(U,j,he,ie){if(j){const V={kind:U,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:j};return U==="start"?V.resolvedVariables=ie:U==="processStarted"?V.processId=ie:U==="processEnded"&&(V.exitCode=ie),Object.freeze(V)}else return Object.freeze({kind:"changed"})}M.create=B})(O=e.TaskEvent||(e.TaskEvent={}));var $;(function(M){function B(j){const he=Object.keys(j).sort();let ie="";for(const V of he){let J=j[V];J instanceof Object?J=B(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ie+=V+","+J+","}return ie}function U(j){const ie={_key:B(j),type:j.taskType};return Object.assign(ie,j),ie}M.create=U})($=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var Y;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(Y=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var G;(function(M){function B(U,j){const he=k.TaskDefinitionRegistry.get(U.type);if(he===void 0){const ne=R.deepClone(U);return delete ne._key,$.create(ne)}const ie=Object.create(null);ie.type=he.taskType;const V=new Set;he.required.forEach(ne=>V.add(ne));const J=he.properties;for(const ne of Object.keys(J)){const ve=U[ne];if(ve!=null)ie[ne]=ve;else if(V.has(ne)){const ue=J[ne];if(ue.default!==void 0)ie[ne]=R.deepClone(ue.default);else switch(ue.type){case"boolean":ie[ne]=!1;break;case"number":case"integer":ie[ne]=0;break;case"string":ie[ne]="";break;default:j.error(c.localize(2,null,JSON.stringify(U,void 0,0),ne));return}}}return $.create(ie)}M.createTaskIdentifier=B})(G=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[252],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,k)=>{this.b=P,this.d=k,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,c.onUnexpectedError)(P))}then(P,k){return this.j().then(P,k)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.LazyPromise=A;class u extends A{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=u}),define(De[58],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++c.count}}c.count=0,e.ProxyIdentifier=c;const A=[];function u(k){const y=new c(k);return A[y.nid]=y,y}e.createProxyIdentifier=u;function R(k){return A[k].sid}e.getStringIdentifierForProxy=R;class P{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=P}),define(De[5],Ce([1,0,58]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var u;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(u=e.TabInputKind||(e.TabInputKind={}));var R;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var p;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(p=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(n){return n._id=T.a++,n}}T.a=0,e.IdObject=T;var S;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var C;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,c.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,c.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,c.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,c.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(De[79],Ce([1,0,4,16,5,20]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(y,p){this.c=p,this.a=new Set,this.b=y.getProxy(u.MainContext.MainThreadTelemetry)}report(y,p,L){const T=this.d(y,p);this.a.has(T)||(this.a.add(T),p.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:p.identifier.value,apiId:y}))}d(y,p){return`${y}-${p.identifier.value}`}};P=Ve([We(0,R.IExtHostRpcService),We(1,A.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,p){}})}),define(De[253],Ce([1,0,3,5,7,25]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(y){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,p,L,T={}){const S=R.ExtensionIdentifier.toKey(y.identifier),I=this.f.get(S)||[],C=[...L].sort().join(" ");let w=I.find(n=>n.providerId===p&&n.scopes===C);if(w)return w.result;{const n=this.g(y,S,p,L,T);w={providerId:p,scopes:C,result:n},I.push(w),this.f.set(S,I);try{await n}finally{const d=I.findIndex(f=>f.providerId===p&&f.scopes===C);d>-1&&(I.splice(d),this.f.set(S,I))}return n}}async g(y,p,L,T,S={}){await this.a.$ensureProvider(L);const I=y.displayName||y.name;return this.a.$getSession(L,T,p,I,S)}async removeSession(y,p){const L=this.b.get(y);return L?L.provider.removeSession(p):this.a.$removeSession(y,p)}registerAuthenticationProvider(y,p,L,T){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:p,provider:L,options:T??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===y)||this.c.push({id:y,label:p});const S=L.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(y,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(y,p,T?.supportsMultipleAccounts??!1),new u.Disposable(()=>{S.dispose(),this.b.delete(y);const I=this.c.findIndex(C=>C.id===y);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,p){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(p));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,p){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(p));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,p){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(p));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,p){return this.d.fire({provider:{id:y,label:p}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(De[254],Ce([1,0,5,20,13]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(k,y){this.a=k.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:p=>y.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k,y,p){const L=u.WorkspaceEdit.from(k,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,p?.isRefactoring??!1)}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(De[255],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const P=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(k){return P.$writeText(k)}})}}e.ExtHostClipboard=A});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[40],Ce([1,0,10,7,13,23,5,17,16,70,32,53,2,6,4,20,138,22,58,46,43,75,78]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t){"use strict";var o,s,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(h,O,$){o.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),a.set(this,void 0),_e(this,o,h.getProxy(P.MainContext.MainThreadCommands),"f"),this.d=O,_e(this,a,$,"f"),_e(this,s,h.getProxy(P.MainContext.MainThreadTelemetry),"f"),this.converter=new E(this,x=>{const Y=this.c.get(x);return Y?.result===r.Void?Y:void 0},O),this.f=[{processArgument(x){return(0,p.revive)(x)}},{processArgument(x){return(0,R.cloneAndChange)(x,function(Y){if(L.Range.isIRange(Y))return u.Range.to(Y);if(T.Position.isIPosition(Y))return u.Position.to(Y);if(L.Range.isIRange(Y.range)&&S.URI.isUri(Y.uri))return u.location.to(Y);if(Y instanceof d.VSBuffer)return Y.buffer.buffer;if(!Array.isArray(Y))return Y})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const O=this.registerCommand(!1,h.id,async(...$)=>{const x=h.args.map((G,M)=>{if(!G.validate($[M]))throw new Error(`Invalid argument '${G.name}' when running '${h.id}', received: ${$[M]}`);return G.convert($[M])}),Y=await this.executeCommand(h.internalId,...x);return h.result.convert(Y,$,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new A.Disposable(()=>{O.dispose(),this.c.delete(h.id)})}registerCommand(h,O,$,x,Y,G){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:$,thisArg:x,description:Y,extension:G}),h&&Me(this,o,"f").$registerCommand(O),new A.Disposable(()=>{this.b.delete(O)&&h&&Me(this,o,"f").$unregisterCommand(O)})}executeCommand(h,...O){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,O,!0)}async g(h,O,$){if(this.b.has(h))return Me(this,o,"f").$fireCommandActivationEvent(h),this.h(h,O,!1);{let x=!1;const Y=(0,R.cloneAndChange)(O,function(G){if(G instanceof A.Position)return u.Position.from(G);if(G instanceof A.Range)return u.Range.from(G);if(G instanceof A.Location)return u.location.from(G);if(A.NotebookRange.isNotebookRange(G))return u.NotebookRange.from(G);if(G instanceof ArrayBuffer)return x=!0,d.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return x=!0,d.VSBuffer.wrap(G);if(G instanceof d.VSBuffer)return x=!0,G;if(!Array.isArray(G))return G});try{const G=await Me(this,o,"f").$executeCommand(h,x?new f.SerializableObjectWithBuffers(Y):Y,$);return(0,p.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(h,O,!1);throw G}}}async h(h,O,$){const x=this.b.get(h);if(!x)throw new Error("Unknown command");const{callback:Y,thisArg:G,description:M}=x;if(M)for(let U=0;U<M.args.length;U++)try{(0,c.validateConstraint)(O[U],M.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${M.args[U].name}' - ${M.args[U].description}`)}const B=D.StopWatch.create();try{return await Y.apply(G,O)}catch(U){if(h===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...O);j&&(h=j.command)}if(this.d.error(U,h,x.extension?.identifier),!$)throw U;if(x.extension?.identifier){const j=Me(this,a,"f").onExtensionError(x.extension.identifier,U);this.d.trace("forwarded error to extension?",j,x.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.toErrorMessage)(U)),this.id=h,this.source=x.extension?.displayName??x.extension?.name}}}finally{this.j(x,h,B.elapsed())}}j(h,O,$){!h.extension||Me(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new b.TelemetryTrustedValue(O),duration:$})}$executeContributedCommand(h,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const $=this.b.get(h);return $?(O=O.map(x=>this.f.reduce((Y,G)=>G.processArgument(Y,$.extension?.identifier),x)),this.h(h,O,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),Me(this,o,"f").$getCommands().then(O=>(h&&(O=O.filter($=>$[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(const[O,$]of this.b){const{description:x}=$;x&&(h[O]=x)}return Promise.resolve(h)}};o=new WeakMap,s=new WeakMap,a=new WeakMap,l=Ve([We(0,w.IExtHostRpcService),We(1,y.ILogService),We(2,t.IExtHostTelemetry)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class E{constructor(h,O,$){this.d=h,this.f=O,this.g=$,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,O){if(!h)return;const $={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return $;const x=this.f(h.command);if(x)$.id=x.internalId,$.arguments=x.args.map((Y,G)=>Y.convert(h.arguments&&h.arguments[G]));else if((0,k.isNonEmptyArray)(h.arguments)){const Y=`${h.command}/${++this.c}`;this.b.set(Y,h),O.add((0,I.toDisposable)(()=>{this.b.delete(Y),this.g.trace("CommandsConverter#DISPOSE",Y)})),$.$ident=Y,$.id=this.delegatingCommandId,$.arguments=[Y],this.g.trace("CommandsConverter#CREATE",h.command,Y)}return $}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const O=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.CommandsConverter=E;class i{constructor(h,O,$,x){this.name=h,this.description=O,this.validate=$,this.convert=x}optional(){return new i(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,O){return new i(h??this.name,O??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",g=>S.URI.isUri(g),g=>g),i.Position=new i("position","A position in a text document",g=>A.Position.isPosition(g),u.Position.from),i.Range=new i("range","A range in a text document",g=>A.Range.isRange(g),u.Range.from),i.Selection=new i("selection","A selection in a text document",g=>A.Selection.isSelection(g),u.Selection.from),i.Number=new i("number","",g=>typeof g=="number",g=>g),i.String=new i("string","",g=>typeof g=="string",g=>g),i.CallHierarchyItem=new i("item","A call hierarchy item",g=>g instanceof A.CallHierarchyItem,u.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",g=>g instanceof A.TypeHierarchyItem,u.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",g=>g instanceof n.TestItemImpl,u.TestItem.from),e.ApiCommandArgument=i;class r{constructor(h,O){this.description=h,this.convert=O}}r.Void=new r("no result",g=>g),e.ApiCommandResult=r;class m{constructor(h,O,$,x,Y){this.id=h,this.internalId=O,this.description=$,this.args=x,this.result=Y}}e.ApiCommand=m}),define(De[256],Ce([1,0,17,18,2,73,120,44,124,40,13,7]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(L.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,c.isFalsyOrEmpty)(n))return;class f extends T.SymbolInformation{static to(D){const b=new f(D.name,L.SymbolKind.to(D.kind),D.containerName||"",new T.Location(d[0],L.Range.to(D.range)));return b.detail=D.detail,b.range=b.location.range,b.selectionRange=L.Range.to(D.selectionRange),b.children=D.children?D.children.map(f.to):[],b}}return n.map(f.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new p.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(L.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(L.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>T.Position.isPosition(d)),n=>n.map(L.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let f;for(const v of d.reverse())f=new T.SelectionRange(L.Range.to(v),f);return f}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(L.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(L.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(L.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(L.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:L.Range.to(n.range),placeholder:n.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return L.WorkspaceEdit.to(n)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(L.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new T.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,P.decodeSemanticTokensDto)(n);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new T.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,P.decodeSemanticTokensDto)(n);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,f)=>{if(!n)return new T.CompletionList([]);const v=n.suggestions.map(D=>L.CompletionItem.to(D,f));return new T.CompletionList(v,n.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return L.SignatureHelp.to(n)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,f)=>C(v=>new T.CodeLens(L.Range.to(v.range),v.command&&f.fromInternal(v.command)))(n))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>T.Range.isRange(n),n=>T.Selection.isSelection(n)?L.Selection.from(n):L.Range.from(n)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,f)=>C(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const D=new T.CodeAction(v.title,v.kind?new T.CodeActionKind(v.kind):void 0);return v.edit&&(D.edit=L.WorkspaceEdit.to(v.edit)),v.command&&(D.command=f.fromInternal(v.command)),D.isPreferred=v.isPreferred,D}})(n))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new T.ColorInformation(L.Range.to(d.range),L.Color.to(d.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",n=>n instanceof T.Color,L.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:L.Range.from(n.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(L.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,d,f)=>n.map(L.InlayHint.to.bind(void 0,f)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,d)=>{if(n)return n.map(L.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>L.NotebookExclusiveDocumentPattern.to(d))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(L.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>u.URI.isUri(n)||typeof n=="string"&&(0,y.matchesSomeScheme)(n,A.Schemas.http,A.Schemas.https),n=>n),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[L.ViewColumn.from(n),void 0]:[L.ViewColumn.from(n.viewColumn),L.TextEditorOpenOptions.from(n)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[L.ViewColumn.from(n),void 0]:[L.ViewColumn.from(n.viewColumn),L.TextEditorOpenOptions.from(n)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[L.ViewColumn.from(n.viewColumn),L.TextEditorOpenOptions.from(n)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(L.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(L.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(L.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],p.ApiCommandResult.Void)];class I{static register(d){S.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",k.validateWhenClauses)}}e.ExtHostApiCommands=I;function C(n){return d=>{if(Array.isArray(d))return d.map(n)}}function w(n){if(!Array.isArray(n))return;const d=[];for(const f of n)R.isLocationLink(f)?d.push(L.DefinitionLink.to(f)):d.push(L.location.to(f));return d}}),define(De[257],Ce([1,0,19,62,3,6,2,73,25,13,7,5]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(I,C,w){const n=I.getProxy(T.MainContext.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new y.ExtensionIdentifierMap,C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const E=this.b.get(l.handle);return E?E.value:l}else if(l&&l.$mid===7){const E=this.b.get(l.commentControlHandle);if(!E)return l;const i=E.getCommentThread(l.commentThreadHandle);return i?i.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const E=this.b.get(l.thread.commentControlHandle);if(!E)return l;const i=E.getCommentThread(l.thread.commentThreadHandle);return i?l.$mid===8?i.value:{thread:i.value,text:l.text}:l}else if(l&&l.$mid===10){const E=this.b.get(l.thread.commentControlHandle);if(!E)return l;const i=E.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const r=l.commentUniqueId,m=i.getCommentByUniqueId(r);return m||l}else if(l&&l.$mid===11){const E=this.b.get(l.thread.commentControlHandle);if(!E)return l;const i=E.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const r=l.text,m=l.commentUniqueId,g=i.getCommentByUniqueId(m);return g?(typeof g.body=="string"?g.body=r:g.body=new L.MarkdownString(r),g):l}return l}})}createCommentController(l,E,i){const r=d.a++,m=new v(l,r,E,i);this.b.set(m.handle,m);const g=this.c.get(l.identifier)||[];return g.push(m),this.c.set(l.identifier,g),m.value}$createCommentThreadTemplate(l,E,i){const r=this.b.get(l);!r||r.$createCommentThreadTemplate(E,i)}async $updateCommentThreadTemplate(l,E,i){const r=this.b.get(l);!r||r.$updateCommentThreadTemplate(E,i)}$deleteCommentThread(l,E){this.b.get(l)?.$deleteCommentThread(E)}$provideCommentingRanges(l,E,i){const r=this.b.get(l);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(P.URI.revive(E));return(0,c.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(m,i)).then(g=>g?g.map(h=>p.Range.from(h)):void 0)}$toggleReaction(l,E,i,r,m){const g=this.b.get(l);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const h=g.getCommentThread(E);if(h){const O=h.getCommentByUniqueId(r.uniqueIdInThread);if(g!==void 0&&O&&g.reactionHandler)return g.reactionHandler(O,t(m))}return Promise.resolve(void 0)})}dispose(){}}d.a=0;class f{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,E,i,r,m,g,h,O){this.m=E,this.n=i,this.o=r,this.p=m,this.q=g,this.extensionDescription=h,this.r=O,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new u.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),n.$createCommentThread(E,this.handle,this.n,this.o,p.Range.from(this.p),h.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this.i.push({dispose:()=>{n.$deleteCommentThread(E,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(x){$.range=x},get comments(){return $.comments},set comments(x){$.comments=x},get collapsibleState(){return $.collapsibleState},set collapsibleState(x){$.collapsibleState=x},get canReply(){return $.canReply},set canReply(x){$.canReply=x},get contextValue(){return $.contextValue},set contextValue(x){$.contextValue=x},get label(){return $.label},set label(x){$.label=x},get state(){return $.state},set state(x){$.state=x},dispose:()=>{$.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const l=i=>Object.prototype.hasOwnProperty.call(this.b,i),E={};l("range")&&(E.range=p.Range.from(this.p)),l("label")&&(E.label=this.label),l("contextValue")&&(E.contextValue=this.contextValue??null),l("comments")&&(E.comments=this.q.map(i=>D(this,i,this.k))),l("collapsibleState")&&(E.collapseState=o(this.g)),l("canReply")&&(E.canReply=this.canReply),l("state")&&(E.state=s(this.h)),l("isTemplate")&&(E.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(l){for(const E of this.k){const i=E[0],r=E[1];if(l===r)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}f.a=0,Ve([(0,A.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,n.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,E,i,r){this.f=l,this.g=E,this.h=i,this.i=r,this.a=new Map,n.$registerCommentController(this.handle,i,r);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(g){m.options=g},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(g){m.commentingRangeProvider=g},get reactionHandler(){return m.reactionHandler},set reactionHandler(g){m.reactionHandler=g},createCommentThread(g,h,O){return m.createCommentThread(g,h,O).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread(l,E,i,r){if(typeof l=="string"){const m=new f(this.id,this.handle,l,E,i,r,this.f,!1);return this.a.set(m.handle,m),m}else{const m=new f(this.id,this.handle,void 0,l,E,i,this.f,!1);return this.a.set(m.handle,m),m}}$createCommentThreadTemplate(l,E){const i=new f(this.id,this.handle,void 0,P.URI.revive(l),p.Range.to(E),[],this.f,!0);return i.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(l,E){const i=this.a.get(l);i&&(i.range=p.Range.to(E))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function D(a,l,E){let i=E.get(l);i||(i=++a.commentHandle,E.set(l,i));const r=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:typeof l.body=="string"?l.body:p.MarkdownString.from(l.body),userName:l.author.name,userIconPath:r,label:l.label,commentReactions:l.reactions?l.reactions.map(m=>b(m)):void 0,timestamp:l.timestamp?.toJSON()}}function b(a){return{label:a.label,iconPath:a.iconPath?p.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function t(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?P.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function s(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new d}e.createExtHostComments=S}),define(De[258],Ce([1,0,23,5,26,20]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let P=class{constructor(L,T){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,T){const S=this,I=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){S.e(L,T,I,arguments)}})}e(L,T,S,I){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:y(I,this.b)}),this.c&&this.f(L,S,I)}};P=Ve([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],P),e.AbstractExtHostConsoleForwarder=P;const k=1e5;function y(p,L){const T=[];if(p.length)for(let S=0;S<p.length;S++){let I=p[S];if(typeof I>"u")I="undefined";else if(I instanceof Error){const C=I;C.stack?I=C.stack:I=C.toString()}T.push(I)}if(L){const S=new Error().stack;S&&T.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,c.safeStringify)(T);return S.length>k?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[140],Ce([1,0,2,5,7,4,20,16,17,8,12,27]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class Bi{constructor(C,w){this.h=w,this.f=new Map,this.g=C.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,w){const n=Bi.c++;this.f.set(n,{provider:C,extensionDescription:w}),this.g.$registerDecorationProvider(n,w.identifier.value);const d=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(f=>{if(!f){this.g.$onDidChange(n,null);return}const v=(0,y.asArray)(f);if(v.length<=Bi.d){this.g.$onDidChange(n,v);return}this.h.warn("[Decorations] CAPPING events from decorations provider",w.identifier.value,v.length);const D=v.map(o=>({uri:o,rank:(0,p.count)(o.path,"/")})),b=(0,y.groupBy)(D,(o,s)=>o.rank-s.rank||(0,p.compare)(o.uri.path,s.uri.path)),t=[];e:for(const o of b){let s;for(const a of o){const l=(0,L.dirname)(a.uri.path);if(s!==l&&(s=l,t.push(a.uri)>=Bi.d))break e}}this.g.$onDidChange(n,t)});return new u.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(C,w,n){if(!this.f.has(C))return Object.create(null);const d=Object.create(null),{provider:f,extensionDescription:v}=this.f.get(C);return await Promise.all(w.map(async D=>{try{const{uri:b,id:t}=D,o=await Promise.resolve(f.provideFileDecoration(c.URI.revive(b),n));if(!o)return;try{u.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,T.checkProposedApiEnabled)(v,"codiconDecoration"),d[t]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${v}': ${s}`)}}catch(b){this.h.error(b)}})),d}};S.c=0,S.d=250,S=Ve([We(0,P.IExtHostRpcService),We(1,k.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[259],Ce([1,0,181,123,2,5,7,13,3,16,28,49]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";var S,I,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(f,v,D,b,t,o,s){this.d=f,this.e=v,this.f=D,this.g=b,S.set(this,void 0),I.set(this,void 0),C.set(this,void 0),this.c=!1,_e(this,C,new L.ResourceMap(a=>t.getComparisonKey(a)),"f"),_e(this,S,o,"f"),_e(this,I,s,"f")}dispose(){this.c||(Me(this,I,"f").fire([...Me(this,C,"f").keys()]),Me(this,S,"f")?.$clear(this.e),Me(this,C,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(f,v){if(!f){this.clear();return}this.h();let D=[];if(u.URI.isUri(f)){if(!v){this.delete(f);return}Me(this,C,"f").set(f,v.slice()),D=[f]}else if(Array.isArray(f)){D=[];let t;f=[...f].sort(w.j);for(const o of f){const[s,a]=o;if((!t||s.toString()!==t.toString())&&(t&&Me(this,C,"f").get(t).length===0&&Me(this,C,"f").delete(t),t=s,D.push(s),Me(this,C,"f").set(s,[])),a)Me(this,C,"f").get(s)?.push(...a);else{const l=Me(this,C,"f").get(s);l&&(l.length=0)}}}if(Me(this,I,"f").fire(D),!Me(this,S,"f"))return;const b=[];for(const t of D){let o=[];const s=Me(this,C,"f").get(t);if(s)if(s.length>this.f){o=[];const a=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const E of s)if(E.severity===a[l]&&o.push({...k.Diagnostic.from(E),modelVersionId:this.g(t)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(a=>({...k.Diagnostic.from(a),modelVersionId:this.g(t)}));b.push([t,o])}Me(this,S,"f").$changeMany(this.e,b)}delete(f){this.h(),Me(this,I,"f").fire([f]),Me(this,C,"f").delete(f),Me(this,S,"f")?.$changeMany(this.e,[[f,void 0]])}clear(){this.h(),Me(this,I,"f").fire([...Me(this,C,"f").keys()]),Me(this,C,"f").clear(),Me(this,S,"f")?.$clear(this.e)}forEach(f,v){this.h();for(const[D,b]of this)f.call(v,D,b,this)}*[(S=new WeakMap,I=new WeakMap,C=new WeakMap,Symbol.iterator)](){this.h();for(const f of Me(this,C,"f").keys())yield[f,this.get(f)]}get(f){this.h();const v=Me(this,C,"f").get(f);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(f){return this.h(),Array.isArray(Me(this,C,"f").get(f))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(f,v){return f[0].toString()<v[0].toString()?-1:f[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=w;let n=class Si{static _mapper(f){const v=new L.ResourceMap;for(const D of f)v.set(D,D);return{uris:Object.freeze(Array.from(v.values()))}}constructor(f,v,D,b){this.h=v,this.j=D,this.k=b,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,Si._mapper),this.e=f.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,v){const{f:D,e:b,g:t,h:o,j:s,k:a}=this,l=new class{$changeMany(r,m){b.$changeMany(r,m),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,r,m.length===0?"CLEARING":m)}$clear(r){b.$clear(r),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,r)}dispose(){b.dispose()}};let E;if(!v)v="_generated_diagnostic_collection_name_#"+Si.c++,E=v;else if(!D.has(v))E=v;else{this.h.warn(`DiagnosticCollection with name '${v}' does already exist.`);do E=v+Si.c++;while(D.has(E))}return new class extends w{constructor(){super(v,E,Si.d,r=>a.getDocument(r)?.version,s.extUri,l,t),D.set(E,this)}dispose(){super.dispose(),D.delete(E)}}}getDiagnostics(f){if(f)return this.l(f);{const v=new Map,D=[];for(const b of this.f.values())b.forEach((t,o)=>{let s=v.get(t.toString());typeof s>"u"&&(s=D.length,v.set(t.toString(),s),D.push([t,[]])),D[s][1]=D[s][1].concat(...o)});return D}}l(f){let v=[];for(const D of this.f.values())D.has(f)&&(v=v.concat(D.get(f)));return v}$acceptMarkersChange(f){if(!this.m){const v="_generated_mirror",D=new w(v,v,Si.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(v,D),this.m=D}for(const[v,D]of f)this.m.set(u.URI.revive(v),D.map(k.Diagnostic.to))}};n.c=0,n.d=1e3,n=Ve([We(1,p.ILogService),We(2,T.IExtHostFileSystemInfo)],n),e.ExtHostDiagnostics=n}),define(De[260],Ce([1,0,2,5,27]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(k){this.a=k.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(k,y){return y?.allowUIResources&&(0,u.checkProposedApiEnabled)(k,"showLocal"),this.a.$showOpenDialog(y).then(p=>p?p.map(L=>c.URI.revive(L)):void 0)}showSaveDialog(k){return this.a.$showSaveDialog(k).then(y=>y?c.URI.revive(y):void 0)}}e.ExtHostDialogs=R}),define(De[261],Ce([1,0,9,2,7,5,18,21,8]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class p{constructor(T,S,I){this.d=S,this.e=I,this.b=new Map,this.c=T.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,S){if(Object.keys(P.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const I=p.a++;this.b.set(I,S),this.c.$registerTextContentProvider(I,T);let C;return typeof S.onDidChange=="function"&&(C=S.onDidChange(w=>{if(w.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(I,w).then(n=>{if(!n&&typeof n!="string")return;const d=this.d.getDocument(w);if(!d)return;const f=(0,y.splitLines)(n);if(!d.equalLines(f))return this.c.$onVirtualDocumentChange(w,n)},c.onUnexpectedError)})),new u.Disposable(()=>{this.b.delete(I)&&this.c.$unregisterTextContentProvider(I),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(T,S){const I=this.b.get(T);return I?Promise.resolve(I.provideTextDocumentContent(A.URI.revive(S),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}p.a=0,e.ExtHostDocumentContentProvider=p}),define(De[262],Ce([1,0,3,6,2,5,136,13,10,23,7]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(I,C){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=I.getProxy(R.MainContext.MainThreadDocuments),this.g=C,this.g.onDidRemoveDocuments(w=>{for(const n of w)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(w=>{for(const n of w)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(I){if(!I)return;const C=this.g.getDocument(I);if(C)return C}getDocument(I){const C=this.getDocumentData(I);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return C.document}ensureDocumentData(I){const C=this.g.getDocument(I);if(C)return Promise.resolve(C);let w=this.h.get(I.toString());return w||(w=this.f.$tryOpenDocument(I).then(n=>{this.h.delete(I.toString());const d=u.URI.revive(n);return(0,y.assertIsDefined)(this.g.getDocument(d))},n=>(this.h.delete(I.toString()),Promise.reject(n))),this.h.set(I.toString(),w)),w}createDocumentData(I){return this.f.$tryCreateDocument(I).then(C=>u.URI.revive(C))}$acceptModelLanguageChanged(I,C){const w=u.URI.revive(I),n=this.g.getDocument(w);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(C),this.a.fire(n.document)}$acceptModelSaved(I){const C=u.URI.revive(I),w=this.g.getDocument(C);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this.d.fire(w.document)}$acceptDirtyStateChanged(I,C){const w=u.URI.revive(I),n=this.g.getDocument(w);if(!n)throw new Error("unknown document");n._acceptIsDirty(C),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,C,w){const n=u.URI.revive(I),d=this.g.getDocument(n);if(!d)throw new Error("unknown document");d._acceptIsDirty(w),d.onEvents(C);let f;C.isUndoing?f=L.TextDocumentChangeReason.Undo:C.isRedoing&&(f=L.TextDocumentChangeReason.Redo),this.c.fire((0,p.deepFreeze)({document:d.document,contentChanges:C.changes.map(v=>({range:k.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text})),reason:f}))}setWordDefinitionFor(I,C){(0,P.setWordDefinitionFor)(I,C)}}e.ExtHostDocuments=T}),define(De[59],Ce([1,0,51,3,6,2,4,5,136,20,139,13,16,28,18,64,65]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(D,b){this.h=D,this.i=b,this.a=null,this.b=new Map,this.c=new I.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const b=[],t=[],o=[];if(D.removedDocuments)for(const s of D.removedDocuments){const a=R.URI.revive(s),l=this.c.get(a);l?.unref()&&(this.c.delete(a),b.push(l.value))}if(D.addedDocuments)for(const s of D.addedDocuments){const a=R.URI.revive(s.uri);let l=this.c.get(a);if(l&&a.scheme!==C.Schemas.vscodeNotebookCell&&a.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);l||(l=new d(new y.ExtHostDocumentData(this.h.getProxy(k.MainContext.MainThreadDocuments),a,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(a,l),t.push(l.value)),l.ref()}if(D.removedEditors)for(const s of D.removedEditors){const a=this.b.get(s);this.b.delete(s),a&&o.push(a)}if(D.addedEditors)for(const s of D.addedEditors){const a=R.URI.revive(s.documentUri);c.ok(this.c.has(a),`document '${a}' does not exist`),c.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const l=this.c.get(a).value,E=new L.ExtHostTextEditor(s.id,this.h.getProxy(k.MainContext.MainThreadTextEditors),this.i,new n.Lazy(()=>l.document),s.selections.map(T.Selection.to),s.options,s.visibleRanges.map(i=>T.Range.to(i)),typeof s.editorPosition=="number"?T.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,E)}D.newActiveEditor!==void 0&&(c.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,u.dispose)(b),(0,u.dispose)(o),D.removedDocuments&&this.e.fire(b),D.addedDocuments&&this.d.fire(t),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return w.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const b=this.b.get(this.a);return D?b:b?.value}allEditors(){return[...this.b.values()]}};f=Ve([We(0,p.IExtHostRpcService),We(1,S.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[60],Ce([1,0,13,5,2,3,4,7,20,10,61]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");class T{constructor(n,d,f){this.e=f,this.d=d,this.acceptDtoUpdate(n)}get apiObject(){if(!this.a){const n=this,d={get isActive(){return n.b.id===n.e()},get label(){return n.b.label},get input(){return n.c},get isDirty(){return n.b.isDirty},get isPinned(){return n.b.isPinned},get isPreview(){return n.b.isPreview},get group(){return n.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(n){this.b=n,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new k.TextTabInput(u.URI.revive(this.b.input.uri));case 2:return new k.TextDiffTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified));case 3:return new k.TextMergeTabInput(u.URI.revive(this.b.input.base),u.URI.revive(this.b.input.input1),u.URI.revive(this.b.input.input2),u.URI.revive(this.b.input.result));case 6:return new k.CustomEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new k.WebviewEditorTabInput(this.b.input.viewType);case 4:return new k.NotebookEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new k.NotebookDiffEditorTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new k.TerminalEditorTabInput;case 9:return new k.InteractiveWindowInput(u.URI.revive(this.b.input.uri),u.URI.revive(this.b.input.inputBoxUri));default:return}}}class S{constructor(n,d){this.c=[],this.d="",this.b=n,this.e=d;for(const f of n.tabs)f.isActive&&(this.d=f.id),this.c.push(new T(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const n=this,d={get isActive(){return n.b.groupId===n.e()},get viewColumn(){return c.ViewColumn.to(n.b.viewColumn)},get activeTab(){return n.c.find(f=>f.tabId===n.d)?.apiObject},get tabs(){return Object.freeze(n.c.map(f=>f.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(n){this.b=n}acceptTabOperation(n){if(n.kind===0){const f=new T(n.tabDto,this,()=>this.activeTabId());return this.c.splice(n.index,0,f),n.tabDto.isActive&&(this.d=f.tabId),f}else if(n.kind===1){const f=this.c.splice(n.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(n.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this.c.splice(n.index,0,f),f}const d=this.c.find(f=>f.tabId===n.tabDto.id);if(!d)throw new Error("INVALID tab");return n.tabDto.isActive?this.d=n.tabDto.id:this.d===n.tabDto.id&&!n.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(n.tabDto),d}activeTabId(){return this.d}}let I=class{constructor(n){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=n.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const n=this,d={onDidChangeTabGroups:n.c.event,onDidChangeTabs:n.b.event,get all(){return Object.freeze(n.e.map(f=>f.apiObject))},get activeTabGroup(){const f=n.d;return(0,p.assertIsDefined)(n.e.find(D=>D.groupId===f)?.apiObject)},close:async(f,v)=>{const D=Array.isArray(f)?f:[f];return D.length?C(D[0])?this.j(D,v):this.i(D,v):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(n){const d=new Set(this.e.map(s=>s.groupId)),f=new Set(n.map(s=>s.groupId)),v=(0,L.diffSets)(d,f),D=this.e.filter(s=>v.removed.includes(s.groupId)).map(s=>s.apiObject),b=[],t=[];this.e=n.map(s=>{const a=new S(s,()=>this.d);return v.added.includes(a.groupId)?b.push(a.apiObject):t.push(a.apiObject),a});const o=(0,p.assertIsDefined)(n.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:b,closed:D,changed:t}))}$acceptTabGroupUpdate(n){const d=this.e.find(f=>f.groupId===n.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(n),n.isActive&&(this.d=n.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const d=this.e.find(v=>v.groupId===n.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const f=d.acceptTabOperation(n);switch(n.kind){case 0:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(n){for(const d of this.e)for(const f of d.tabs)if(f.apiObject===n)return f}h(n){return this.e.find(d=>d.apiObject===n)}async i(n,d){const f=[];for(const v of n){const D=this.g(v);if(!D)throw new Error("Tab close: Invalid tab not found!");f.push(D.tabId)}return this.a.$closeTab(f,d)}async j(n,d){const f=[];for(const v of n){const D=this.h(v);if(!D)throw new Error("Group close: Invalid group not found!");f.push(D.groupId)}return this.a.$closeGroup(f,d)}};I=Ve([We(0,y.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function C(w){return w.tabs!==void 0}}),define(De[263],Ce([1,0,2,5,6,7,13,156,8,22,27]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(C){this.b=void 0,this.a.push(C)}delete(C){const w=this.a.indexOf(C);w>=0&&(this.a.splice(w,1),this.b=void 0)}c(){if(!this.b){const C=this.a.sort(),w=[];let n,d,f=14,v=14;for(const D of C){let b=n?(0,y.commonPrefixLength)(n,D):0;for(b===0?d=1:d=v;b<D.length;b++)b+1===D.length?(f=v,v=9):v+=1,w.push([d,D.toUpperCase().charCodeAt(b),v]),w.push([d,D.toLowerCase().charCodeAt(b),v]),d=v;n=D,v=f}w.push([9,58,10]),w.push([10,47,12]),this.b=new k.StateMachine(w)}}provideDocumentLinks(C){this.c();const w=[],n=k.LinkComputer.computeLinks({getLineContent(d){return C.lineAt(d-1).text},getLineCount(){return C.lineCount}},this.b);for(const d of n){const f=P.DocumentLink.to(d);f.target&&w.push(f)}return w}}class S{constructor(C,w){this.i=w,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=C.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(C,w,n,d={}){if(S.j(n),this.d.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(C,"*",this.b));const f=this.h++;this.b.add(w),this.d.add(w),this.c.set(f,n);let v=2;d.isCaseSensitive&&(v+=1024),d.isReadonly&&(v+=2048),typeof n.copy=="function"&&(v+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,L.checkProposedApiEnabled)(C,"fsChunks"),v+=4),this.a.$registerFileSystemProvider(f,w,v).catch(b=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${w}`),console.error(b)});const D=n.onDidChangeFile(b=>{const t=[];for(const o of b){const{uri:s,type:a}=o;if(s.scheme!==w)continue;let l;switch(a){case R.FileChangeType.Changed:l=0;break;case R.FileChangeType.Created:l=1;break;case R.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:l})}this.a.$onFileSystemChange(f,t)});return(0,u.toDisposable)(()=>{D.dispose(),this.b.delete(w),this.d.delete(w),this.c.delete(f),this.a.$unregisterProvider(f)})}static j(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static k(C){const{type:w,ctime:n,mtime:d,size:f,permissions:v}=C;return{type:w,ctime:n,mtime:d,size:f,permissions:v}}$stat(C,w){return Promise.resolve(this.l(C).stat(c.URI.revive(w))).then(n=>S.k(n))}$readdir(C,w){return Promise.resolve(this.l(C).readDirectory(c.URI.revive(w)))}$readFile(C,w){return Promise.resolve(this.l(C).readFile(c.URI.revive(w))).then(n=>p.VSBuffer.wrap(n))}$writeFile(C,w,n,d){return Promise.resolve(this.l(C).writeFile(c.URI.revive(w),n.buffer,d))}$delete(C,w,n){return Promise.resolve(this.l(C).delete(c.URI.revive(w),n))}$rename(C,w,n,d){return Promise.resolve(this.l(C).rename(c.URI.revive(w),c.URI.revive(n),d))}$copy(C,w,n,d){const f=this.l(C);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(c.URI.revive(w),c.URI.revive(n),d))}$mkdir(C,w){return Promise.resolve(this.l(C).createDirectory(c.URI.revive(w)))}$watch(C,w,n,d){const f=this.l(C).watch(c.URI.revive(n),d);this.f.set(w,f)}$unwatch(C,w){const n=this.f.get(w);n&&(n.dispose(),this.f.delete(w))}$open(C,w,n){const d=this.l(C);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(c.URI.revive(w),n))}$close(C,w){const n=this.l(C);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(w))}$read(C,w,n,d){const f=this.l(C);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const v=p.VSBuffer.alloc(d);return Promise.resolve(f.read(w,n,v.buffer,0,d)).then(D=>v.slice(0,D))}$write(C,w,n,d){const f=this.l(C);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(w,n,d.buffer,0,d.byteLength))}l(C){const w=this.c.get(C);if(!w){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return w}}e.ExtHostFileSystem=S}),define(De[80],Ce([1,0,5,45,7,22,4,20,49,6]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class _t{constructor(S,I){this.b=new Map,this.a=S.getProxy(c.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(w){try{const n=C.b.get(w.scheme);if(!n)return await C.a.$stat(w);await C.a.$ensureActivation(w.scheme);const d=await n.stat(w);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(n){_t.c(n)}},async readDirectory(w){try{const n=C.b.get(w.scheme);return n?(await C.a.$ensureActivation(w.scheme),(await n.readDirectory(w)).slice()):await C.a.$readdir(w)}catch(n){return _t.c(n)}},async createDirectory(w){try{return await C.a.$mkdir(w)}catch(n){return _t.c(n)}},async readFile(w){try{const n=C.b.get(w.scheme);return n?(await C.a.$ensureActivation(w.scheme),(await n.readFile(w)).slice()):(await C.a.$readFile(w)).buffer}catch(n){return _t.c(n)}},async writeFile(w,n){try{return await C.a.$writeFile(w,R.VSBuffer.wrap(n))}catch(d){return _t.c(d)}},async delete(w,n){try{const d=C.b.get(w.scheme);return d?(await C.a.$ensureActivation(w.scheme),await d.delete(w,{recursive:!1,...n})):await C.a.$delete(w,{recursive:!1,useTrash:!1,...n})}catch(d){return _t.c(d)}},async rename(w,n,d){try{return await C.a.$rename(w,n,{overwrite:!1,...d})}catch(f){return _t.c(f)}},async copy(w,n,d){try{return await C.a.$copy(w,n,{overwrite:!1,...d})}catch(f){return _t.c(f)}},isWritableFileSystem(w){const n=I.getCapabilities(w);if(typeof n=="number")return!(n&2048)}})}static c(S){if(S instanceof u.FileSystemError)throw S;if(!(S instanceof Error))throw new u.FileSystemError(String(S));if(S.name==="ENOPRO"||S.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(S.message);switch(S.name){case A.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(S.message);case A.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(S.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(S.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(S.message);case A.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(S.message);case A.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(S.message);default:throw new u.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,I){return this.b.set(S,I),(0,p.toDisposable)(()=>this.b.delete(S))}};L=Ve([We(0,k.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(De[264],Ce([1,0,3,38,2,5,13,7]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,S,I,C,w,n,d,f){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const v=this.h(T,I,w);this.g=0,n&&(this.g+=1),d&&(this.g+=2),f&&(this.g+=4);const D=(0,A.parse)(w),b=typeof w=="string",t=C(o=>{if(!n)for(const s of o.created){const a=u.URI.revive(s);D(a.fsPath)&&(!b||S.getWorkspaceFolder(a))&&this.a.fire(a)}if(!d)for(const s of o.changed){const a=u.URI.revive(s);D(a.fsPath)&&(!b||S.getWorkspaceFolder(a))&&this.b.fire(a)}if(!f)for(const s of o.deleted){const a=u.URI.revive(s);D(a.fsPath)&&(!b||S.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=k.Disposable.from(v,this.a,this.b,this.c,t)}h(T,S,I){const C=k.Disposable.from();if(typeof I=="string")return C;const w=T.getProxy(R.MainContext.MainThreadFileSystem);let n=!1;(I.pattern.includes(A.GLOBSTAR)||I.pattern.includes(A.GLOB_SPLIT))&&(n=!0);const d=Math.random();return w.$watch(S.identifier.value,d,I.baseUri,{recursive:n,excludes:[]}),k.Disposable.from({dispose:()=>w.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class p{constructor(T,S,I){this.j=T,this.k=S,this.l=I,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,S,I,C,w,n){return new y(this.j,T,S,this.a.event,P.GlobPattern.from(I),C,w,n)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,S){switch(T){case 2:this.b.fire(Object.freeze({files:S.map(I=>({oldUri:u.URI.revive(I.source),newUri:u.URI.revive(I.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(I=>u.URI.revive(I.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(I=>u.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,S){return(I,C,w)=>{const n=function(f){I.call(C,f)};return n.extension=T,S.event(n,void 0,w)}}async $onWillRunFileOperation(T,S,I,C){switch(T){case 2:return await this.n(this.g,{files:S.map(w=>({oldUri:u.URI.revive(w.source),newUri:u.URI.revive(w.target)}))},I,C);case 1:return await this.n(this.i,{files:S.map(w=>u.URI.revive(w.target))},I,C);case 0:case 3:return await this.n(this.h,{files:S.map(w=>u.URI.revive(w.target))},I,C)}}async n(T,S,I,C){const w=new Set,n=[];if(await T.fireAsync(S,C,async(f,v)=>{const D=Date.now(),b=await Promise.resolve(f);b instanceof k.WorkspaceEdit&&(n.push([v.extension,b]),w.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-D>I&&this.k.warn("SLOW file-participant",v.extension.identifier)}),C.isCancellationRequested||n.length===0)return;const d={edits:[]};for(const[,f]of n){const{edits:v}=P.WorkspaceEdit.from(f,{getTextDocumentVersion:D=>this.l.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(v)}return{edit:d,extensionNames:Array.from(w)}}}e.ExtHostFileSystemEventService=p}),define(De[265],Ce([1,0,2,40]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(P,k,y,p,L){this.a=k,this.b=y,this.c=p;const T=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new A.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new A.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new A.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new A.ApiCommandResult("Notebook and input URI",S=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const I=this.a.getEditorById(S.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:c.URI.revive(S.notebookUri),inputUri:c.URI.revive(S.inputUri),notebookEditor:I.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:c.URI.revive(S.notebookUri),inputUri:c.URI.revive(S.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(P,k,y,p){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:y,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(p))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,k){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=u}),define(De[266],Ce([1,0,6,2,5,13]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(p,L){this.extension=p,this.provider=L,this.handle=P.a++}}P.a=0;class k{constructor(p,L,T){this.e=L,this.f=T,this.b=new Map,this.c=new Map,this.d=p.getProxy(u.MainContext.MainThreadInteractiveEditor)}registerProvider(p,L){const T=new P(p,L);return this.b.set(T.handle,T),this.d.$registerInteractiveEditorProvider(T.handle,p.identifier.value),(0,c.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(T.handle),this.b.delete(T.handle)})}async $prepareInteractiveSession(p,L,T,S){const I=this.b.get(p);if(!I){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const C=this.e.getDocument(A.URI.revive(L)),w=await I.provider.prepareInteractiveEditorSession({document:C,selection:R.Selection.to(T)},S);if(!w)return;const n=k.a++;return this.c.set(n,w),{id:n,placeholder:w.placeholder}}async $provideResponse(p,L,T,S){const I=this.b.get(p);if(!I)return;const C=this.c.get(L.id);if(!C)return;const w=await I.provider.provideInteractiveEditorResponse({session:C,prompt:T.prompt,selection:R.Selection.to(T.selection),wholeRange:R.Range.to(T.wholeRange)},S);if(!!w)return{edits:w.edits.map(R.TextEdit.from),placeholder:w.placeholder}}$releaseSession(p,L){const T=this.c.get(L),S=this.b.get(p);T&&S&&S.provider.releaseInteractiveEditorSession?.(T),this.c.delete(L)}}k.a=0,e.ExtHostInteractiveEditor=k}),define(De[267],Ce([1,0,6,10,5]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class R{constructor(y,p){this.extension=y,this.provider=p,this.handle=R.a++}}R.a=0;class P{constructor(y,p){this.b=new Map,this.c=new Map,this.d=y.getProxy(u.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(y,p,L){const T=new R(y,L);return this.b.set(T.handle,T),this.d.$registerInteractiveSessionProvider(T.handle,p),(0,c.toDisposable)(()=>{this.d.$unregisterInteractiveSessionProvider(T.handle),this.b.delete(T.handle)})}addInteractiveSessionRequest(y){this.d.$addInteractiveSessionRequest(y)}async $prepareInteractiveSession(y,p,L){const T=this.b.get(y);if(!T)return;const S=await T.provider.prepareSession(p,L);if(!S)return;const I=P.a++;return this.c.set(I,S),{id:I}}async $resolveInteractiveRequest(y,p,L,T){const S=this.b.get(y);if(!S)return;const I=this.c.get(p);if(!I||!S.provider.resolveRequest)return;const C=await S.provider.resolveRequest(I,L,T);if(C)return{message:C.message}}async $provideInitialSuggestions(y,p){const L=this.b.get(y);if(!!L&&!!L.provider.provideInitialSuggestions)return(0,A.withNullAsUndefined)(await L.provider.provideInitialSuggestions(p))}async $provideInteractiveReply(y,p,L,T){const S=this.b.get(y);if(!S)return;const I=this.c.get(p);if(!I)return;const C={session:I,message:L.message};if(S.provider.provideResponse){const w=await S.provider.provideResponse(C,T);if(I.saveState){const n=I.saveState();this.d.$acceptInteractiveSessionState(p,n)}return w?(this.d.$acceptInteractiveResponseProgress(y,p,{responsePart:w.content}),{followups:w.followups}):void 0}else if(S.provider.provideResponseWithProgress){const w={report:d=>this.d.$acceptInteractiveResponseProgress(y,p,{responsePart:d.content})},n=await S.provider.provideResponseWithProgress(C,w,T);if(I.saveState){const d=I.saveState();this.d.$acceptInteractiveSessionState(p,d)}return n?{followups:n.followups}:void 0}throw new Error("provider must implement either provideResponse or provideResponseWithProgress")}$releaseSession(y){this.c.delete(y)}}P.a=0,e.ExtHostInteractiveSession=P}),define(De[268],Ce([1,0,6,5]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(P){this.b=0,this.a=P.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const k=this.b++;return this.a.$registerResourceLabelFormatter(k,P),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=u}),define(De[269],Ce([1,0,2,23,13,7,73,5,8,32,17,10,152,21,6,120,102,76,43,9,19,27]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(F,z){this.d=F,this.e=z}async provideDocumentSymbols(F,z){const K=this.d.getDocument(F),Z=await this.e.provideDocumentSymbols(K,z);if(!(0,L.isFalsyOrEmpty)(Z))return Z[0]instanceof R.DocumentSymbol?Z.map(u.DocumentSymbol.from):t.f(Z)}static f(F){F=F.slice(0).sort((Z,fe)=>{let Ee=Z.location.range.start.compareTo(fe.location.range.start);return Ee===0&&(Ee=fe.location.range.end.compareTo(Z.location.range.end)),Ee});const z=[],K=[];for(const Z of F){const fe={name:Z.name||"!!MISSING: name!!",kind:u.SymbolKind.from(Z.kind),tags:Z.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:u.Range.from(Z.location.range),selectionRange:u.Range.from(Z.location.range),children:[]};for(;;){if(K.length===0){K.push(fe),z.push(fe);break}const Ee=K[K.length-1];if(p.Range.containsRange(Ee.range,fe.range)&&!p.Range.equalsRange(Ee.range,fe.range)){Ee.children?.push(fe),K.push(fe);break}K.pop()}}return z}}class o{constructor(F,z,K){this.g=F,this.h=z,this.j=K,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(F,z){const K=this.g.getDocument(F),Z=await this.j.provideCodeLenses(K,z);if(!Z||z.isCancellationRequested)return;const fe=this.e.add(Z),Ee=new C.DisposableStore;this.f.set(fe,Ee);const Ae={cacheId:fe,lenses:[]};for(let we=0;we<Z.length;we++)Ae.lenses.push({cacheId:[fe,we],range:u.Range.from(Z[we].range),command:this.h.toInternal(Z[we].command,Ee)});return Ae}async resolveCodeLens(F,z){const K=F.cacheId&&this.e.get(...F.cacheId);if(!K)return;let Z;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?Z=K:Z=await this.j.resolveCodeLens(K,z),Z||(Z=K),z.isCancellationRequested)return;const fe=F.cacheId&&this.f.get(F.cacheId[0]);if(!!fe)return F.command=this.h.toInternal(Z.command??o.d,fe),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(oe){return Array.isArray(oe)?oe.map(u.DefinitionLink.from):oe?[u.DefinitionLink.from(oe)]:[]}class a{constructor(F,z){this.d=F,this.e=z}async provideDefinition(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideDefinition(Z,fe,K);return s(Ee)}}class l{constructor(F,z){this.d=F,this.e=z}async provideDeclaration(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideDeclaration(Z,fe,K);return s(Ee)}}class E{constructor(F,z){this.d=F,this.e=z}async provideImplementation(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideImplementation(Z,fe,K);return s(Ee)}}class i{constructor(F,z){this.d=F,this.e=z}async provideTypeDefinition(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideTypeDefinition(Z,fe,K);return s(Ee)}}class r{constructor(F,z){this.d=F,this.e=z}async provideHover(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideHover(Z,fe,K);if(!(!Ee||(0,L.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=Z.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new R.Range(fe,fe)),u.Hover.from(Ee)}}class m{constructor(F,z){this.d=F,this.e=z}async provideEvaluatableExpression(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideEvaluatableExpression(Z,fe,K);if(Ee)return u.EvaluatableExpression.from(Ee)}}class g{constructor(F,z){this.d=F,this.e=z}async provideInlineValues(F,z,K,Z){const fe=this.d.getDocument(F),Ee=await this.e.provideInlineValues(fe,u.Range.to(z),u.InlineValueContext.to(K),Z);if(Array.isArray(Ee))return Ee.map(Ae=>u.InlineValue.from(Ae))}}class h{constructor(F,z){this.d=F,this.e=z}async provideDocumentHighlights(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideDocumentHighlights(Z,fe,K);if(Array.isArray(Ee))return Ee.map(u.DocumentHighlight.from)}}class O{constructor(F,z){this.d=F,this.e=z}async provideLinkedEditingRanges(F,z,K){const Z=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideLinkedEditingRanges(Z,fe,K);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,L.coalesce)(Ee.ranges.map(u.Range.from)),wordPattern:Ee.wordPattern}}}class ${constructor(F,z){this.d=F,this.e=z}async provideReferences(F,z,K,Z){const fe=this.d.getDocument(F),Ee=u.Position.to(z),Ae=await this.e.provideReferences(fe,Ee,K,Z);if(Array.isArray(Ae))return Ae.map(u.location.from)}}class x{constructor(F,z,K,Z,fe,Ee,Ae){this.g=F,this.h=z,this.j=K,this.k=Z,this.l=fe,this.m=Ee,this.n=Ae,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(F,z,K,Z){const fe=this.g.getDocument(F),Ee=S.Selection.isISelection(z)?u.Selection.to(z):u.Range.to(z),Ae=[];for(const tt of this.j.getDiagnostics(F))if(Ee.intersection(tt.range)&&Ae.push(tt)>x.d)break;const we={diagnostics:Ae,only:K.only?new R.CodeActionKind(K.only):void 0,triggerKind:u.CodeActionTriggerKind.to(K.trigger)},Pe=await this.k.provideCodeActions(fe,Ee,we,Z);if(!(0,L.isNonEmptyArray)(Pe)||Z.isCancellationRequested)return;const Ie=this.e.add(Pe),$e=new C.DisposableStore;this.f.set(Ie,$e);const xe=[];for(let tt=0;tt<Pe.length;tt++){const Qe=Pe[tt];!Qe||(x.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,$e)})):(we.only&&(Qe.kind?we.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Ie,tt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,$e),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(u.Diagnostic.from),edit:Qe.edit&&u.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Ie,actions:xe}}async resolveCodeAction(F,z){const[K,Z]=F,fe=this.e.get(K,Z);if(!fe||x.o(fe)||!this.k.resolveCodeAction)return;const Ee=await this.k.resolveCodeAction(fe,z)??fe;return Ee?.edit?u.WorkspaceEdit.from(Ee.edit,void 0):void 0}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}x.d=1e3;class Y{constructor(F,z,K,Z){this.d=F,this.e=z,this.f=K,this.g=Z}async prepareDocumentPaste(F,z,K,Z){if(!this.f.prepareDocumentPaste)return;const fe=this.e.getDocument(F),Ee=z.map(we=>u.Range.to(we)),Ae=u.DataTransfer.toDataTransfer(K,()=>{throw new v.NotImplementedError});return await this.f.prepareDocumentPaste(fe,Ee,Ae,Z),u.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(F,z,K,Z,fe){const Ee=this.e.getDocument(z),Ae=K.map(Ie=>u.Range.to(Ie)),we=u.DataTransfer.toDataTransfer(Z,async Ie=>(await this.d.$resolvePasteFileData(this.g,F,Ie)).buffer),Pe=await this.f.provideDocumentPasteEdits(Ee,Ae,we,fe);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?u.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class G{constructor(F,z){this.d=F,this.e=z}async provideDocumentFormattingEdits(F,z,K){const Z=this.d.getDocument(F),fe=await this.e.provideDocumentFormattingEdits(Z,z,K);if(Array.isArray(fe))return fe.map(u.TextEdit.from)}}class M{constructor(F,z){this.d=F,this.e=z}async provideDocumentRangeFormattingEdits(F,z,K,Z){const fe=this.d.getDocument(F),Ee=u.Range.to(z),Ae=await this.e.provideDocumentRangeFormattingEdits(fe,Ee,K,Z);if(Array.isArray(Ae))return Ae.map(u.TextEdit.from)}}class B{constructor(F,z){this.d=F,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,z,K,Z,fe){const Ee=this.d.getDocument(F),Ae=u.Position.to(z),we=await this.e.provideOnTypeFormattingEdits(Ee,Ae,K,Z,fe);if(Array.isArray(we))return we.map(u.TextEdit.from)}}class U{constructor(F,z){this.e=F,this.f=z,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,z){const K=await this.e.provideWorkspaceSymbols(F,z);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const Z=this.d.add(K),fe={cacheId:Z,symbols:[]};for(let Ee=0;Ee<K.length;Ee++){const Ae=K[Ee];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}fe.symbols.push({...u.WorkspaceSymbol.from(Ae),cacheId:[Z,Ee]})}return fe}async resolveWorkspaceSymbol(F,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const Z=await this.e.resolveWorkspaceSymbol(K,z);return Z&&(0,A.mixin)(F,u.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class j{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,z,K){this.d=F,this.e=z,this.f=K}async provideRenameEdits(F,z,K,Z){const fe=this.d.getDocument(F),Ee=u.Position.to(z);try{const Ae=await this.e.provideRenameEdits(fe,Ee,K,Z);return Ae?u.WorkspaceEdit.from(Ae):void 0}catch(Ae){const we=j.g(Ae);return we?{rejectReason:we,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(F,z,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(F),fe=u.Position.to(z);try{const Ee=await this.e.prepareRename(Z,fe,K);let Ae,we;if(R.Range.isRange(Ee)?(Ae=Ee,we=Z.getText(Ee)):(0,T.isObject)(Ee)&&(Ae=Ee.range,we=Ee.placeholder),!Ae||!we)return;if(Ae.start.line>fe.line||Ae.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(Ae),text:we}}catch(Ee){const Ae=j.g(Ee);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(Ee)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class he{constructor(F,z){this.resultId=F,this.tokens=z}}class ie{constructor(F,z){this.f=F,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,z,K){const Z=this.f.getDocument(F),fe=z!==0?this.d.get(z):null;let Ee=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,fe.resultId,K):await this.g.provideDocumentSemanticTokens(Z,K);return fe&&this.d.delete(z),Ee?(Ee=ie.h(Ee),this.o(ie.n(fe,Ee),Ee)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ie.j(F)?ie.k(F)?F:new R.SemanticTokens(new Uint32Array(F.data),F.resultId):ie.l(F)?ie.m(F)?F:new R.SemanticTokensEdits(F.edits.map(z=>new R.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const z of F.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(F,z){if(!ie.j(z)||!F||!F.tokens)return z;const K=F.tokens,Z=K.length,fe=z.data,Ee=fe.length;let Ae=0;const we=Math.min(Z,Ee);for(;Ae<we&&K[Ae]===fe[Ae];)Ae++;if(Ae===Z&&Ae===Ee)return new R.SemanticTokensEdits([],z.resultId);let Pe=0;const Ie=we-Ae;for(;Pe<Ie&&K[Z-Pe-1]===fe[Ee-Pe-1];)Pe++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Z-Ae-Pe,data:fe.subarray(Ae,Ee-Pe)}],z.resultId)}o(F,z){if(ie.j(F)){const K=this.e++;return this.d.set(K,new he(F.resultId,F.data)),(0,w.encodeSemanticTokensDto)({id:K,type:"full",data:F.data})}if(ie.l(F)){const K=this.e++;return ie.j(z)?this.d.set(K,new he(z.resultId,z.data)):this.d.set(K,new he(F.resultId)),(0,w.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(F.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class V{constructor(F,z){this.d=F,this.e=z}async provideDocumentRangeSemanticTokens(F,z,K){const Z=this.d.getDocument(F),fe=await this.e.provideDocumentRangeSemanticTokens(Z,u.Range.to(z),K);return fe?this.f(fe):null}f(F){return(0,w.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}class J{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,z,K,Z,fe){this.f=F,this.g=z,this.h=K,this.j=Z,this.k=fe,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(F,z,K,Z){const fe=this.f.getDocument(F),Ee=u.Position.to(z),Ae=fe.getWordRangeAtPosition(Ee)||new R.Range(Ee,Ee),we=Ae.with({end:Ee}),Pe=new f.StopWatch(!0),Ie=await this.h.provideCompletionItems(fe,Ee,Z,u.CompletionContext.to(K));if(!Ie||Z.isCancellationRequested)return;const $e=Array.isArray(Ie)?new R.CompletionList(Ie):Ie,xe=J.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),tt=new C.DisposableStore;this.e.set(xe,tt);const Qe=[],it={x:xe,b:Qe,a:{replace:u.Range.from(Ae),insert:u.Range.from(we)},c:$e.isIncomplete||void 0,d:Pe.elapsed()};for(let rt=0;rt<$e.items.length;rt++){const Be=$e.items[rt],et=this.l(Be,[xe,rt],we,Ae);Qe.push(et)}return it}async resolveCompletionItem(F,z){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const Z=await this.h.resolveCompletionItem(K,z);if(!!Z)return this.l(Z,F)}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,z,K,Z){const fe=this.e.get(z[0]);if(!fe)throw Error("DisposableStore is missing...");const Ee=this.g.toInternal(F.command,fe),Ae={x:z,a:F.label,b:F.kind!==void 0?u.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(u.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:u.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(u.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=F.textEdit.newText):typeof F.insertText=="string"?Ae.h=F.insertText:F.insertText instanceof R.SnippetString&&(Ae.h=F.insertText.value,Ae.i|=4);let we;return F.textEdit?we=F.textEdit.range:F.range&&(we=F.range),R.Range.isRange(we)?Ae.j=u.Range.from(we):we&&(!K?.isEqual(we.inserting)||!Z?.isEqual(we.replacing))&&(Ae.j={insert:u.Range.from(we.inserting),replace:u.Range.from(we.replacing)}),Ae}}class ne{async provideInlineCompletions(F,z,K,Z){}disposeCompletions(F){}handleDidShowCompletionItem(F,z){}handlePartialAccept(F,z,K){}}class ve extends ne{constructor(F,z,K,Z){super(),this.f=F,this.g=z,this.h=K,this.j=Z,this.d=new ue,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,z,K,Z){const fe=this.g.getDocument(F),Ee=u.Position.to(z),Ae=await this.h.provideInlineCompletionItems(fe,Ee,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:u.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},Z);if(!Ae||Z.isCancellationRequested)return;const we=Array.isArray(Ae)?Ae:Ae.items,Pe=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Ie;return{pid:this.d.createReferenceId({dispose(){Ie?.dispose()},items:we}),items:we.map((xe,tt)=>{let Qe;xe.command&&(Ie||(Ie=new C.DisposableStore),Qe=this.j.toInternal(xe.command,Ie));const it=xe.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:xe.filterText,range:xe.range?u.Range.from(xe.range):void 0,command:Qe,idx:tt,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:Pe.map(xe=>(Ie||(Ie=new C.DisposableStore),this.j.toInternal(xe,Ie)))}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,z){const K=this.d.get(F)?.items[z];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}handlePartialAccept(F,z,K){const Z=this.d.get(F)?.items[z];Z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Z,K)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const z=this.e++;return this.d.set(z,F),z}disposeReferenceId(F){const z=this.d.get(F);return this.d.delete(F),z}get(F){return this.d.get(F)}}class ee{constructor(F,z){this.e=F,this.f=z,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(F,z,K,Z){const fe=this.e.getDocument(F),Ee=u.Position.to(z),Ae=this.g(K),we=await this.f.provideSignatureHelp(fe,Ee,Z,Ae);if(we){const Pe=this.d.add([we]);return{...u.SignatureHelp.from(we),id:Pe}}}g(F){let z;if(F.activeSignatureHelp){const K=u.SignatureHelp.to(F.activeSignatureHelp),Z=this.d.get(F.activeSignatureHelp.id,0);Z?(z=Z,z.activeSignature=K.activeSignature,z.activeParameter=K.activeParameter):z=K}return{...F,activeSignatureHelp:z}}releaseSignatureHelp(F){this.d.delete(F)}}class N{constructor(F,z,K,Z,fe){this.f=F,this.g=z,this.h=K,this.j=Z,this.k=fe,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(F,z,K){const Z=this.f.getDocument(F),fe=u.Range.to(z),Ee=await this.h.provideInlayHints(Z,fe,K);if(!Array.isArray(Ee)||Ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(Ee);this.e.set(Ae,new C.DisposableStore);const we={hints:[],cacheId:Ae};for(let Pe=0;Pe<Ee.length;Pe++)this.l(Ee[Pe],fe)&&we.hints.push(this.m(Ee[Pe],[Ae,Pe]));return this.j.trace(`[InlayHints] ${we.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),we}async resolveInlayHint(F,z){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const Z=await this.h.resolveInlayHint(K,z);if(!!Z&&!!this.l(Z))return this.m(Z,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,z){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(z&&!z.contains(F.position))}m(F,z){const K=this.e.get(z[0]);if(!K)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:z,tooltip:u.MarkdownString.fromStrict(F.tooltip),position:u.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(u.TextEdit.from),kind:F.kind&&u.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Z.label=F.label:Z.label=F.label.map(fe=>{const Ee={label:fe.value};return Ee.tooltip=u.MarkdownString.fromStrict(fe.tooltip),R.Location.isLocation(fe.location)&&(Ee.location=u.location.from(fe.location)),fe.command&&(Ee.command=this.g.toInternal(fe.command,K)),Ee}),Z}}class q{constructor(F,z){this.e=F,this.f=z,this.d=new d.Cache("DocumentLink")}async provideLinks(F,z){const K=this.e.getDocument(F),Z=await this.f.provideDocumentLinks(K,z);if(!(!Array.isArray(Z)||Z.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(q.g).map(u.DocumentLink.from)};{const fe=this.d.add(Z),Ee={links:[],cacheId:fe};for(let Ae=0;Ae<Z.length;Ae++){if(!q.g(Z[Ae]))continue;const we=u.DocumentLink.from(Z[Ae]);we.cacheId=[fe,Ae],Ee.links.push(we)}return Ee}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,z){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const Z=await this.f.resolveDocumentLink(K,z);if(!(!Z||!q.g(Z)))return u.DocumentLink.from(Z)}releaseLinks(F){this.d.delete(F)}}class ae{constructor(F,z){this.d=F,this.e=z}async provideColors(F,z){const K=this.d.getDocument(F),Z=await this.e.provideDocumentColors(K,z);return Array.isArray(Z)?Z.map(Ee=>({color:u.Color.from(Ee.color),range:u.Range.from(Ee.range)})):[]}async provideColorPresentations(F,z,K){const Z=this.d.getDocument(F),fe=u.Range.to(z.range),Ee=u.Color.to(z.color),Ae=await this.e.provideColorPresentations(Ee,{document:Z,range:fe},K);if(!!Array.isArray(Ae))return Ae.map(u.ColorPresentation.from)}}class me{constructor(F,z){this.d=F,this.e=z}async provideFoldingRanges(F,z,K){const Z=this.d.getDocument(F),fe=await this.e.provideFoldingRanges(Z,z,K);if(!!Array.isArray(fe))return fe.map(u.FoldingRange.from)}}class ke{constructor(F,z,K){this.d=F,this.e=z,this.f=K}async provideSelectionRanges(F,z,K){const Z=this.d.getDocument(F),fe=z.map(u.Position.to),Ee=await this.e.provideSelectionRanges(Z,fe,K);if(!(0,L.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let we=0;we<fe.length;we++){const Pe=[];Ae.push(Pe);let Ie=fe[we],$e=Ee[we];for(;;){if(!$e.range.contains(Ie))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(u.SelectionRange.from($e)),!$e.parent)break;Ie=$e.range,$e=$e.parent}}return Ae}}class _{constructor(F,z){this.f=F,this.g=z,this.d=new n.IdGenerator(""),this.e=new Map}async prepareSession(F,z,K){const Z=this.f.getDocument(F),fe=u.Position.to(z),Ee=await this.g.prepareCallHierarchy(Z,fe,K);if(!Ee)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(Ee)?Ee.map(we=>this.h(Ae,we)):[this.h(Ae,Ee)]}async provideCallsTo(F,z,K){const Z=this.j(F,z);if(!Z)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(Z,K);if(!!fe)return fe.map(Ee=>({from:this.h(F,Ee.from),fromRanges:Ee.fromRanges.map(Ae=>u.Range.from(Ae))}))}async provideCallsFrom(F,z,K){const Z=this.j(F,z);if(!Z)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(Z,K);if(!!fe)return fe.map(Ee=>({to:this.h(F,Ee.to),fromRanges:Ee.fromRanges.map(Ae=>u.Range.from(Ae))}))}releaseSession(F){this.e.delete(F)}h(F,z){const K=this.e.get(F),Z=u.CallHierarchyItem.from(z,F,K.size.toString(36));return K.set(Z._itemId,z),Z}j(F,z){return this.e.get(F)?.get(z)}}class le{constructor(F,z){this.f=F,this.g=z,this.d=new n.IdGenerator(""),this.e=new Map}async prepareSession(F,z,K){const Z=this.f.getDocument(F),fe=u.Position.to(z),Ee=await this.g.prepareTypeHierarchy(Z,fe,K);if(!Ee)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(Ee)?Ee.map(we=>this.h(Ae,we)):[this.h(Ae,Ee)]}async provideSupertypes(F,z,K){const Z=this.j(F,z);if(!Z)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(Z,K);if(!!fe)return fe.map(Ee=>this.h(F,Ee))}async provideSubtypes(F,z,K){const Z=this.j(F,z);if(!Z)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(Z,K);if(!!fe)return fe.map(Ee=>this.h(F,Ee))}releaseSession(F){this.e.delete(F)}h(F,z){const K=this.e.get(F),Z=u.TypeHierarchyItem.from(z,F,K.size.toString(36));return K.set(Z._itemId,z),Z}j(F,z){return this.e.get(F)?.get(z)}}class de{constructor(F,z,K,Z){this.d=F,this.e=z,this.f=K,this.g=Z}async provideDocumentOnDropEdits(F,z,K,Z,fe){const Ee=this.e.getDocument(z),Ae=u.Position.to(K),we=u.DataTransfer.toDataTransfer(Z,async Ie=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ie)).buffer),Pe=await this.f.provideDocumentDropEdits(Ee,Ae,we,fe);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?u.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class te{constructor(F,z){this.adapter=F,this.extension=z}}class ce{constructor(F,z,K,Z,fe,Ee,Ae,we){this.g=z,this.h=K,this.j=Z,this.k=fe,this.l=Ee,this.m=Ae,this.n=we,this.f=new Map,this.e=F.getProxy(k.MainContext.MainThreadLanguageFeatures)}o(F){return u.DocumentSelector.from(F,this.g)}p(F){return new R.Disposable(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ce.d++}async s(F,z,K,Z,fe,Ee=!1){const Ae=this.f.get(F);if(!Ae||!(Ae.adapter instanceof z))return Z;const we=Date.now();Ee||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Pe=K(Ae.adapter,Ae.extension);return Promise.resolve(Pe).catch(Ie=>{(0,v.isCancellationError)(Ie)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Ie),this.n.onExtensionError(Ae.extension.identifier,Ie))}).finally(()=>{Ee||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-we}ms`)}),I.CancellationToken.isCancellationToken(fe)?(0,D.raceCancellationError)(Pe,fe):Pe}t(F,z){const K=this.q();return this.f.set(K,new te(F,z)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,z,K,Z){const fe=this.t(new t(this.h,K),F),Ee=Z&&Z.label||ce.u(F);return this.e.$registerDocumentSymbolProvider(fe,this.o(z),Ee),this.p(fe)}$provideDocumentSymbols(F,z,K){return this.s(F,t,Z=>Z.provideDocumentSymbols(c.URI.revive(z),K),void 0,K)}registerCodeLensProvider(F,z,K){const Z=this.q(),fe=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new te(new o(this.h,this.j.converter,K),F)),this.e.$registerCodeLensSupport(Z,this.o(z),fe);let Ee=this.p(Z);if(fe!==void 0){const Ae=K.onDidChangeCodeLenses(we=>this.e.$emitCodeLensEvent(fe));Ee=R.Disposable.from(Ee,Ae)}return Ee}$provideCodeLenses(F,z,K){return this.s(F,o,Z=>Z.provideCodeLenses(c.URI.revive(z),K),void 0,K)}$resolveCodeLens(F,z,K){return this.s(F,o,Z=>Z.resolveCodeLens(z,K),void 0,void 0)}$releaseCodeLenses(F,z){this.s(F,o,K=>Promise.resolve(K.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(F,z,K){const Z=this.t(new a(this.h,K),F);return this.e.$registerDefinitionSupport(Z,this.o(z)),this.p(Z)}$provideDefinition(F,z,K,Z){return this.s(F,a,fe=>fe.provideDefinition(c.URI.revive(z),K,Z),[],Z)}registerDeclarationProvider(F,z,K){const Z=this.t(new l(this.h,K),F);return this.e.$registerDeclarationSupport(Z,this.o(z)),this.p(Z)}$provideDeclaration(F,z,K,Z){return this.s(F,l,fe=>fe.provideDeclaration(c.URI.revive(z),K,Z),[],Z)}registerImplementationProvider(F,z,K){const Z=this.t(new E(this.h,K),F);return this.e.$registerImplementationSupport(Z,this.o(z)),this.p(Z)}$provideImplementation(F,z,K,Z){return this.s(F,E,fe=>fe.provideImplementation(c.URI.revive(z),K,Z),[],Z)}registerTypeDefinitionProvider(F,z,K){const Z=this.t(new i(this.h,K),F);return this.e.$registerTypeDefinitionSupport(Z,this.o(z)),this.p(Z)}$provideTypeDefinition(F,z,K,Z){return this.s(F,i,fe=>fe.provideTypeDefinition(c.URI.revive(z),K,Z),[],Z)}registerHoverProvider(F,z,K,Z){const fe=this.t(new r(this.h,K),F);return this.e.$registerHoverProvider(fe,this.o(z)),this.p(fe)}$provideHover(F,z,K,Z){return this.s(F,r,fe=>fe.provideHover(c.URI.revive(z),K,Z),void 0,Z)}registerEvaluatableExpressionProvider(F,z,K,Z){const fe=this.t(new m(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(z)),this.p(fe)}$provideEvaluatableExpression(F,z,K,Z){return this.s(F,m,fe=>fe.provideEvaluatableExpression(c.URI.revive(z),K,Z),void 0,Z)}registerInlineValuesProvider(F,z,K,Z){const fe=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,Ee=this.t(new g(this.h,K),F);this.e.$registerInlineValuesProvider(Ee,this.o(z),fe);let Ae=this.p(Ee);if(fe!==void 0){const we=K.onDidChangeInlineValues(Pe=>this.e.$emitInlineValuesEvent(fe));Ae=R.Disposable.from(Ae,we)}return Ae}$provideInlineValues(F,z,K,Z,fe){return this.s(F,g,Ee=>Ee.provideInlineValues(c.URI.revive(z),K,Z,fe),void 0,fe)}registerDocumentHighlightProvider(F,z,K){const Z=this.t(new h(this.h,K),F);return this.e.$registerDocumentHighlightProvider(Z,this.o(z)),this.p(Z)}$provideDocumentHighlights(F,z,K,Z){return this.s(F,h,fe=>fe.provideDocumentHighlights(c.URI.revive(z),K,Z),void 0,Z)}registerLinkedEditingRangeProvider(F,z,K){const Z=this.t(new O(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(z)),this.p(Z)}$provideLinkedEditingRanges(F,z,K,Z){return this.s(F,O,async fe=>{const Ee=await fe.provideLinkedEditingRanges(c.URI.revive(z),K,Z);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?ce.w(Ee.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(F,z,K){const Z=this.t(new $(this.h,K),F);return this.e.$registerReferenceSupport(Z,this.o(z)),this.p(Z)}$provideReferences(F,z,K,Z,fe){return this.s(F,$,Ee=>Ee.provideReferences(c.URI.revive(z),K,Z,fe),void 0,fe)}registerCodeActionProvider(F,z,K,Z){const fe=new C.DisposableStore,Ee=this.t(new x(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(Ee,this.o(z),{providedKinds:Z?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Z?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,fe)}))},ce.u(F),Boolean(K.resolveCodeAction)),fe.add(this.p(Ee)),fe}$provideCodeActions(F,z,K,Z,fe){return this.s(F,x,Ee=>Ee.provideCodeActions(c.URI.revive(z),K,Z,fe),void 0,fe)}$resolveCodeAction(F,z,K){return this.s(F,x,Z=>Z.resolveCodeAction(z,K),void 0,void 0)}$releaseCodeActions(F,z){this.s(F,x,K=>Promise.resolve(K.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(F,z,K){const Z=this.t(new G(this.h,K),F);return this.e.$registerDocumentFormattingSupport(Z,this.o(z),F.identifier,F.displayName||F.name),this.p(Z)}$provideDocumentFormattingEdits(F,z,K,Z){return this.s(F,G,fe=>fe.provideDocumentFormattingEdits(c.URI.revive(z),K,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(F,z,K){const Z=this.t(new M(this.h,K),F);return this.e.$registerRangeFormattingSupport(Z,this.o(z),F.identifier,F.displayName||F.name),this.p(Z)}$provideDocumentRangeFormattingEdits(F,z,K,Z,fe){return this.s(F,M,Ee=>Ee.provideDocumentRangeFormattingEdits(c.URI.revive(z),K,Z,fe),void 0,fe)}registerOnTypeFormattingEditProvider(F,z,K,Z){const fe=this.t(new B(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(fe,this.o(z),Z,F.identifier),this.p(fe)}$provideOnTypeFormattingEdits(F,z,K,Z,fe,Ee){return this.s(F,B,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(z),K,Z,fe,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(F,z){const K=this.t(new U(z,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof z.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,z,K){return this.s(F,U,Z=>Z.provideWorkspaceSymbols(z,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,z,K){return this.s(F,U,Z=>Z.resolveWorkspaceSymbol(z,K),void 0,void 0)}$releaseWorkspaceSymbols(F,z){this.s(F,U,K=>K.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(F,z,K){const Z=this.t(new j(this.h,K,this.l),F);return this.e.$registerRenameSupport(Z,this.o(z),j.supportsResolving(K)),this.p(Z)}$provideRenameEdits(F,z,K,Z,fe){return this.s(F,j,Ee=>Ee.provideRenameEdits(c.URI.revive(z),K,Z,fe),void 0,fe)}$resolveRenameLocation(F,z,K,Z){return this.s(F,j,fe=>fe.resolveRenameLocation(c.URI.revive(z),K,Z),void 0,Z)}registerDocumentSemanticTokensProvider(F,z,K,Z){const fe=this.t(new ie(this.h,K),F),Ee=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(z),Z,Ee);let Ae=this.p(fe);if(Ee){const we=K.onDidChangeSemanticTokens(Pe=>this.e.$emitDocumentSemanticTokensEvent(Ee));Ae=R.Disposable.from(Ae,we)}return Ae}$provideDocumentSemanticTokens(F,z,K,Z){return this.s(F,ie,fe=>fe.provideDocumentSemanticTokens(c.URI.revive(z),K,Z),null,Z)}$releaseDocumentSemanticTokens(F,z){this.s(F,ie,K=>K.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,z,K,Z){const fe=this.t(new V(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(z),Z),this.p(fe)}$provideDocumentRangeSemanticTokens(F,z,K,Z){return this.s(F,V,fe=>fe.provideDocumentRangeSemanticTokens(c.URI.revive(z),K,Z),null,Z)}registerCompletionItemProvider(F,z,K,Z){const fe=this.t(new J(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(fe,this.o(z),Z,J.supportsResolving(K),`${F.identifier.value}(${Z.join("")})`),this.p(fe)}$provideCompletionItems(F,z,K,Z,fe){return this.s(F,J,Ee=>Ee.provideCompletionItems(c.URI.revive(z),K,Z,fe),void 0,fe)}$resolveCompletionItem(F,z,K){return this.s(F,J,Z=>Z.resolveCompletionItem(z,K),void 0,K)}$releaseCompletionItems(F,z){this.s(F,J,K=>K.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(F,z,K){const Z=new ve(F,this.h,K,this.j.converter),fe=this.t(Z,F);return this.e.$registerInlineCompletionsSupport(fe,this.o(z),Z.supportsHandleEvents),this.p(fe)}$provideInlineCompletions(F,z,K,Z,fe){return this.s(F,ne,Ee=>Ee.provideInlineCompletions(c.URI.revive(z),K,Z,fe),void 0,fe)}$handleInlineCompletionDidShow(F,z,K){this.s(F,ne,async Z=>{Z.handleDidShowCompletionItem(z,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,z,K,Z){this.s(F,ne,async fe=>{fe.handlePartialAccept(z,K,Z)},void 0,void 0)}$freeInlineCompletionsList(F,z){this.s(F,ne,async K=>{K.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(F,z,K,Z){const fe=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,Ee=this.t(new ee(this.h,K),F);return this.e.$registerSignatureHelpProvider(Ee,this.o(z),fe),this.p(Ee)}$provideSignatureHelp(F,z,K,Z,fe){return this.s(F,ee,Ee=>Ee.provideSignatureHelp(c.URI.revive(z),K,Z,fe),void 0,fe)}$releaseSignatureHelp(F,z){this.s(F,ee,K=>K.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(F,z,K){const Z=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new N(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(fe,this.o(z),typeof K.resolveInlayHint=="function",Z,ce.u(F));let Ee=this.p(fe);if(Z!==void 0){const Ae=K.onDidChangeInlayHints(we=>this.e.$emitInlayHintsEvent(Z));Ee=R.Disposable.from(Ee,Ae)}return Ee}$provideInlayHints(F,z,K,Z){return this.s(F,N,fe=>fe.provideInlayHints(c.URI.revive(z),K,Z),void 0,Z)}$resolveInlayHint(F,z,K){return this.s(F,N,Z=>Z.resolveInlayHint(z,K),void 0,K)}$releaseInlayHints(F,z){this.s(F,N,K=>K.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(F,z,K){const Z=this.t(new q(this.h,K),F);return this.e.$registerDocumentLinkProvider(Z,this.o(z),typeof K.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(F,z,K){return this.s(F,q,Z=>Z.provideLinks(c.URI.revive(z),K),void 0,K,z.scheme==="output")}$resolveDocumentLink(F,z,K){return this.s(F,q,Z=>Z.resolveLink(z,K),void 0,void 0,!0)}$releaseDocumentLinks(F,z){this.s(F,q,K=>K.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(F,z,K){const Z=this.t(new ae(this.h,K),F);return this.e.$registerDocumentColorProvider(Z,this.o(z)),this.p(Z)}$provideDocumentColors(F,z,K){return this.s(F,ae,Z=>Z.provideColors(c.URI.revive(z),K),[],K)}$provideColorPresentations(F,z,K,Z){return this.s(F,ae,fe=>fe.provideColorPresentations(c.URI.revive(z),K,Z),void 0,Z)}registerFoldingRangeProvider(F,z,K){const Z=this.q(),fe=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new te(new me(this.h,K),F)),this.e.$registerFoldingRangeProvider(Z,this.o(z),F.identifier,fe);let Ee=this.p(Z);if(fe!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));Ee=R.Disposable.from(Ee,Ae)}return Ee}$provideFoldingRanges(F,z,K,Z){return this.s(F,me,fe=>fe.provideFoldingRanges(c.URI.revive(z),K,Z),void 0,Z)}registerSelectionRangeProvider(F,z,K){const Z=this.t(new ke(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(Z,this.o(z)),this.p(Z)}$provideSelectionRanges(F,z,K,Z){return this.s(F,ke,fe=>fe.provideSelectionRanges(c.URI.revive(z),K,Z),[],Z)}registerCallHierarchyProvider(F,z,K){const Z=this.t(new _(this.h,K),F);return this.e.$registerCallHierarchyProvider(Z,this.o(z)),this.p(Z)}$prepareCallHierarchy(F,z,K,Z){return this.s(F,_,fe=>Promise.resolve(fe.prepareSession(c.URI.revive(z),K,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(F,z,K,Z){return this.s(F,_,fe=>fe.provideCallsTo(z,K,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(F,z,K,Z){return this.s(F,_,fe=>fe.provideCallsFrom(z,K,Z),void 0,Z)}$releaseCallHierarchy(F,z){this.s(F,_,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(F,z,K){const Z=this.t(new le(this.h,K),F);return this.e.$registerTypeHierarchyProvider(Z,this.o(z)),this.p(Z)}$prepareTypeHierarchy(F,z,K,Z){return this.s(F,le,fe=>Promise.resolve(fe.prepareSession(c.URI.revive(z),K,Z)),void 0,Z)}$provideTypeHierarchySupertypes(F,z,K,Z){return this.s(F,le,fe=>fe.provideSupertypes(z,K,Z),void 0,Z)}$provideTypeHierarchySubtypes(F,z,K,Z){return this.s(F,le,fe=>fe.provideSubtypes(z,K,Z),void 0,Z)}$releaseTypeHierarchy(F,z){this.s(F,le,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(F,z,K){const Z=this.q();return this.f.set(Z,new te(new de(this.e,this.h,K,Z),F)),this.e.$registerDocumentOnDropEditProvider(Z,this.o(z)),this.p(Z)}$provideDocumentOnDropEdits(F,z,K,Z,fe,Ee){return this.s(F,de,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(z,c.URI.revive(K),Z,fe,Ee)),void 0,void 0)}registerDocumentPasteEditProvider(F,z,K,Z){const fe=this.q();return this.f.set(fe,new te(new Y(this.e,this.h,K,fe),F)),this.e.$registerPasteEditProvider(fe,this.o(z),!!K.prepareDocumentPaste,Z.pasteMimeTypes),this.p(fe)}$prepareDocumentPaste(F,z,K,Z,fe){return this.s(F,Y,Ee=>Ee.prepareDocumentPaste(c.URI.revive(z),K,Z,fe),void 0,fe)}$providePasteEdits(F,z,K,Z,fe,Ee){return this.s(F,Y,Ae=>Ae.providePasteEdits(z,c.URI.revive(K),Z,fe,Ee),void 0,Ee)}static w(F){return{pattern:F.source,flags:(0,y.regExpFlags)(F)}}static y(F){return{decreaseIndentPattern:ce.w(F.decreaseIndentPattern),increaseIndentPattern:ce.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ce.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ce.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ce.w(F.beforeText),afterText:F.afterText?ce.w(F.afterText):void 0,previousLineText:F.previousLineText?ce.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ce.z)}setLanguageConfiguration(F,z,K){const{wordPattern:Z}=K;if(Z&&(0,y.regExpLeadsToEndlessLoop)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(z,Z):this.h.setWordDefinitionFor(z,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const fe=this.q(),Ee={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ce.w(K.wordPattern):void 0,indentationRules:K.indentationRules?ce.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ce.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(fe,z,Ee),this.p(fe)}$setWordDefinitions(F){for(const z of F)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(De[270],Ce([1,0,5,13,7,37,19,6]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,T,S,I){this.c=T,this.d=S,this.e=I,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,T){await this.a.$changeLanguage(L,T);const S=this.c.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,T){const S=L.version,I=A.Position.from(T),C=await this.a.$tokensAtPosition(L.uri,I),w={type:u.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new u.Range(T.line,T.character,T.line,T.character)};if(!C)return w;const n={range:A.Range.to(C.range),type:A.TokenType.to(C.type)};return!n.range.contains(T)||S!==L.version?w:n}createLanguageStatusItem(L,T,S){const I=this.f++,C=this.a,w=this.g,n=`${L.identifier.value}/${T}`;if(w.has(n))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);w.add(n);const d={selector:S,id:T,name:L.displayName??L.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let f;const v=new k.DisposableStore,D=()=>{f?.dispose(),f=(0,P.disposableTimeout)(()=>{v.clear(),this.a.$setLanguageStatus(I,{id:n,name:d.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===u.LanguageStatusSeverity.Error?R.default.Error:d.severity===u.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:d.command&&this.d.toInternal(d.command,v),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},b={dispose(){v.dispose(),f?.dispose(),C.$removeLanguageStatus(I),w.delete(n)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,D()},get selector(){return d.selector},set selector(t){d.selector=t,D()},get text(){return d.text},set text(t){d.text=t,D()},get detail(){return d.detail},set detail(t){d.detail=t,D()},get severity(){return d.severity},set severity(t){d.severity=t,D()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,D()},get command(){return d.command},set command(t){d.command=t,D()},get busy(){return d.busy},set busy(t){d.busy=t,D()}};return D(),b}}e.ExtHostLanguages=y}),define(De[98],Ce([1,0,11,8,2,4,16,5,26,20]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(S,I,C){this.f=C,this.d=new Map,this.a=I.getProxy(k.MainContext.MainThreadLocalization),this.b=S.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(S,I){const{message:C,args:w,comment:n}=I;if(this.c)return(0,A.format2)(C,w??{});let d=C;n&&n.length>0&&(d+=`/${Array.isArray(n)?n.join(""):n}`);const f=this.d.get(S)?.contents[d];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,A.format2)(f??C,w??{})}getBundle(S){return this.d.get(S)?.contents}getBundleUri(S){return this.d.get(S)?.uri}async initializeLocalizedMessages(S){if(this.c||!S.l10n&&!S.isBuiltin||this.d.has(S.identifier.value))return;let I;const C=await this.g(S);if(!C){this.f.error(`No bundle location found for extension ${S.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(C),n=JSON.parse(w);I=S.isBuiltin?n.contents?.bundle:n}catch(w){this.f.error(`Failed to load translations for ${S.identifier.value} from ${C}: ${w.message}`);return}I&&this.d.set(S.identifier.value,{contents:I,uri:C})}async g(S){if(S.isBuiltin){const I=await this.a.$fetchBuiltInBundleUri(S.identifier.value,this.b);return u.URI.revive(I)}return S.l10n?u.URI.joinPath(S.extensionLocation,S.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=Ve([We(0,y.IExtHostInitDataService),We(1,p.IExtHostRpcService),We(2,P.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(De[141],Ce([1,0,16,5,26,20,2,70]),function(re,e,c,A,u,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends c.AbstractLoggerService{constructor(T,S){super(S.logLevel,S.logsLocation,S.loggers.map(I=>(0,k.revive)(I))),this.n=T.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(T,S){S?this.setLogLevel(P.URI.revive(S),T):this.setLogLevel(T)}setVisibility(T,S){super.setVisibility(T,S),this.n.$setVisibility(T,S)}m(T,S,I){return new p(this.n,T,S,I)}};y=Ve([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class p extends c.AbstractMessageLogger{constructor(T,S,I,C){super(C?.logLevel==="always"),this.m=T,this.n=S,this.k=!1,this.l=[],this.setLevel(I),this.m.$createLogger(S,C).then(()=>{this.q(this.l),this.k=!0})}g(T,S){const I=[[T,S]];this.k?this.q(I):this.l.push(...I)}q(T){this.m.$log(this.n,T)}}}),define(De[271],Ce([1,0,5,16,27]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(k){return k&&k.title}let P=class{constructor(y,p){this.b=p,this.a=y.getProxy(c.MainContext.MainThreadMessageService)}showMessage(y,p,L,T,S){const I={source:{identifier:y.identifier,label:y.displayName||y.name}};let C;typeof T=="string"||R(T)?C=[T,...S]:(I.modal=T?.modal,I.useCustom=T?.useCustom,I.detail=T?.detail,C=S),I.useCustom&&(0,u.checkProposedApiEnabled)(y,"resolvers");const w=[];for(let n=0;n<C.length;n++){const d=C[n];if(typeof d=="string")w.push({title:d,handle:n,isCloseAffordance:!1});else if(typeof d=="object"){const{title:f,isCloseAffordance:v}=d;w.push({title:f,isCloseAffordance:!!v,handle:n})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(p,L,I,w).then(n=>{if(typeof n=="number")return C[n]})}};P=Ve([We(1,A.ILogService)],P),e.ExtHostMessageService=P}),define(De[272],Ce([1,0,22,3,6,28,8,10,2,76,5,40,13,7,58,245,137,9]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,b,t,o){this.q=t,this.r=o,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new p.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=D.getProxy(L.MainContext.MainThreadNotebook),this.c=D.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=D.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const a=s.notebookEditor?.notebookUri,l=s.cell.handle,i=this.g.get(a)?.getCell(l);if(i)return i.apiCell}if(s&&s.$mid===14){const a=s.uri,l=this.g.get(a);if(l)return l.apiNotebook}return s}}),f.x(b)}getEditorById(D){const b=this.h.get(D);if(!b)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(D){for(const[b,t]of this.h)if(t.apiEditor===D)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,b){const t=this.g.get(D);if(!t&&!b)throw new Error(`NO notebook document for '${D}'`);return t}static s(D,b){if(!b)return;const t=b.filenamePattern.map(o=>S.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(b.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:b.displayName,filenamePattern:t,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,b,t){const o=f.a++,s=typeof t.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(o,t),this.b.$registerNotebookCellStatusBarItemProvider(o,s,b);let a;return s!==void 0&&(a=t.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(s))),new I.Disposable(()=>{this.f.delete(o),this.b.$unregisterNotebookCellStatusBarItemProvider(o,s),a?.dispose()})}async createNotebookDocument(D){const b=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&S.NotebookData.from(D.content)});return y.URI.revive(b)}async openNotebookDocument(D){const b=this.g.get(D);if(b)return b.apiNotebook;const t=await this.c.$tryOpenNotebook(D),o=this.g.get(y.URI.revive(t));return(0,k.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(D,b){y.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let t;typeof b=="object"?t={position:S.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(S.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:t={preserveFocus:!1};const o=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,t),s=o&&this.h.get(o)?.apiEditor;if(s)return s;throw o?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,b,t,o){const s=this.f.get(D),a=y.URI.revive(b),l=this.g.get(a);if(!l||!s)return;const E=l.getCellFromIndex(t);if(!E)return;const i=await s.provideCellStatusBarItems(E.apiCell,o);if(!i)return;const r=new u.DisposableStore,m=this.p.add([r]),h=(Array.isArray(i)?i:[i]).map(O=>S.NotebookStatusBarItem.from(O,this.i,r));return{cacheId:m,items:h}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,b,t,o,s){if((0,P.isFalsyOrWhitespace)(b))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,t),this.b.$registerNotebookSerializer(a,{id:D.identifier,location:D.extensionLocation},b,S.NotebookDocumentContentOptions.from(o),f.s(D,s)),(0,u.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(D,b,t){const o=this.u.get(D);if(!o)throw new Error("NO serializer found");const s=await o.deserializeNotebook(b.buffer,t);return new C.SerializableObjectWithBuffers(S.NotebookData.from(s))}async $notebookToData(D,b,t){const o=this.u.get(D);if(!o)throw new Error("NO serializer found");const s=await o.serializeNotebook(S.NotebookData.to(b.value),t);return c.VSBuffer.wrap(s)}w(D,b,t){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const o=new n.ExtHostNotebookEditor(b,this.d,D,t.visibleRanges.map(S.NotebookRange.to),t.selections.map(S.NotebookRange.to),typeof t.viewColumn=="number"?S.ViewColumn.to(t.viewColumn):void 0);this.h.set(b,o)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const t of D.value.removedDocuments){const o=y.URI.revive(t),s=this.g.get(o);s&&(s.dispose(),this.g.delete(o),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(s.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===o.toString()&&this.h.delete(a.id)}if(D.value.addedDocuments){const t=[];for(const o of D.value.addedDocuments){const s=y.URI.revive(o.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new w.ExtHostNotebookDocument(this.c,this.q,this.r,s,o);t.push(...o.cells.map(l=>w.ExtHostCell.asModelAddData(a.apiNotebook,l))),this.g.get(s)?.dispose(),this.g.set(s,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this.m.fire(a.apiNotebook)}}if(D.value.addedEditors)for(const t of D.value.addedEditors){if(this.h.has(t.id))return;const o=y.URI.revive(t.documentUri),s=this.g.get(o);s&&this.w(s,t.id,t)}const b=[];if(D.value.removedEditors)for(const t of D.value.removedEditors){const o=this.h.get(t);o&&(this.h.delete(t),this.k?.id===o.id&&(this.k=void 0),b.push(o))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(o=>this.h.get(o)).filter(o=>!!o);const t=new Set;this.l.forEach(o=>t.add(o.id));for(const o of this.h.values()){const s=t.has(o.id);o._acceptVisibility(s)}this.l=[...this.h.values()].map(o=>o).filter(o=>o.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(D){const b=T.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new T.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>c.VSBuffer.wrap(s))],new T.ApiCommandResult("Notebook Data",s=>S.NotebookData.to(s.value))),o=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new C.SerializableObjectWithBuffers(S.NotebookData.from(s)))],new T.ApiCommandResult("Bytes",s=>s.buffer));D.registerApiCommand(t),D.registerApiCommand(o)}}f.a=0,e.ExtHostNotebookController=f}),define(De[273],Ce([1,0,17,19,21,3,6,28,2,25,16,76,5,40,13,7,96,235,27,58]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(l,E,i,r,m){this.k=E,this.l=i,this.m=r,this.n=m,this.b=new k.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=l.getProxy(S.MainContext.MainThreadNotebookKernels);const g=new I.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new I.ApiCommandArgument("options","Select kernel options",h=>!0,h=>{if(h&&"notebookEditor"in h&&"id"in h){const O=this.l.getIdByEditor(h.notebookEditor);return{id:h.id,extension:h.extension,notebookEditorId:O}}else if(h&&"notebookEditor"in h){const O=this.l.getIdByEditor(h.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${h.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return h})],I.ApiCommandResult.Void);this.m.registerApiCommand(g)}createNotebookController(l,E,i,r,m,g){for(const ne of this.h.values())if(ne.controller.id===E&&p.ExtensionIdentifier.equals(l.identifier,ne.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const h=this.i++,O=this;this.n.trace(`NotebookController[${h}], CREATED by ${l.identifier.value}, ${E}`);const $=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${l.identifier}'`);let x=!1;const Y=new P.DisposableStore,G=new R.Emitter,M=new R.Emitter,B={id:s(l.identifier,E),notebookType:i,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:r||l.identifier.value,preloads:g?g.map(C.NotebookRendererScript.from):[]};let U=m??$,j;this.a.$addKernel(h,B).catch(ne=>{console.log(ne),x=!0});let he=0;const ie=()=>{if(x)return;const ne=++he;Promise.resolve().then(()=>{ne===he&&this.a.$updateKernel(h,B)})},V=new k.ResourceMap,J={get id(){return E},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return B.label},set label(ne){B.label=ne??l.displayName??l.name,ie()},get detail(){return B.detail??""},set detail(ne){B.detail=ne,ie()},get description(){return B.description??""},set description(ne){B.description=ne,ie()},get kind(){return(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind??""},set kind(ne){(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind=ne,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ne){B.supportedLanguages=ne,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){B.supportsExecutionOrder=ne,ie()},get rendererScripts(){return B.preloads?B.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(ne){U=ne??$},get interruptHandler(){return j},set interruptHandler(ne){j=ne,B.supportsInterrupt=Boolean(ne),ie()},createNotebookCellExecution(ne){if(x)throw new Error("notebook controller is DISPOSED");if(!V.has(ne.notebook.uri))throw O.n.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return O._createNotebookCellExecution(ne,s(l.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${h}], DISPOSED`),x=!0,this.h.delete(h),Y.dispose(),G.dispose(),M.dispose(),this.a.$removeKernel(h))},updateNotebookAffinity(ne,ve){ve===w.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(h,ne.uri,ve)},onDidReceiveMessage:M.event,postMessage(ne,ve){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),O.a.$postMessage(h,ve&&O.l.getIdByEditor(ve),ne)},asWebviewUri(ne){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),(0,n.asWebviewUri)(ne,O.k.remote)}};return this.h.set(h,{extensionId:l.identifier,controller:J,onDidReceiveMessage:M,onDidChangeSelection:G,associatedNotebooks:V}),J}getIdByController(l){for(const[E,i]of this.h)if(i.controller===l)return s(i.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,E){const i=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(i,E);const m={dispose:()=>{this.c.delete(i),r.a.$removeKernelDetectionTask(i)}};return this.c.set(i,m),m}registerKernelSourceActionProvider(l,E,i){const r=this.f++,m=typeof i.onDidChangeNotebookKernelSourceActions=="function"?r:void 0,g=this;this.e.set(r,i),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(r,r,E);let h;return m!==void 0&&(h=i.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.e.delete(r),g.a.$removeKernelSourceActionProvider(r,r),h?.dispose()}}}async $provideKernelSourceActions(l,E){const i=this.e.get(l);if(i){const r=new P.DisposableStore;return this.g.add([r]),(await i.provideNotebookKernelSourceActions(E)??[]).map(g=>C.NotebookKernelSourceAction.from(g,this.m.converter,r))}return[]}$acceptNotebookAssociation(l,E,i){const r=this.h.get(l);if(r){const m=this.l.getNotebookDocument(y.URI.revive(E));i?r.associatedNotebooks.set(m.uri,!0):r.associatedNotebooks.delete(m.uri),this.n.trace(`NotebookController[${l}] ASSOCIATE notebook`,m.uri.toString(),i),r.onDidChangeSelection.fire({selected:i,notebook:m.apiNotebook})}}async $executeCells(l,E,i){const r=this.h.get(l);if(!r)return;const m=this.l.getNotebookDocument(y.URI.revive(E)),g=[];for(const h of i){const O=m.getCell(h);O&&g.push(O.apiCell)}try{this.n.trace(`NotebookController[${l}] EXECUTE cells`,m.uri.toString(),g.length),await r.controller.executeHandler.call(r.controller,g,m.apiNotebook,r.controller)}catch(h){this.n.error(`NotebookController[${l}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(l,E,i){const r=this.h.get(l);if(!r)return;const m=this.l.getNotebookDocument(y.URI.revive(E));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,m.apiNotebook);else for(const g of i){const h=m.getCell(g);h&&this.b.get(h.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,E,i){const r=this.h.get(l);if(!r)return;const m=this.l.getEditorById(E);r.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:i}))}$cellExecutionChanged(l,E,i){const m=this.l.getNotebookDocument(y.URI.revive(l)).getCell(E);if(m){const g=i?C.NotebookCellExecutionState.to(i):w.NotebookCellExecutionState.Idle;g!==void 0&&this.j.fire({cell:m.apiCell,state:g})}}_createNotebookCellExecution(l,E){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const m=new t(E,r,this.a);this.b.set(r.uri,m);const g=m.onDidChangeState(()=>{m.state===b.Resolved&&(m.dispose(),g.dispose(),this.b.delete(r.uri))});return m.asApiObject()}};D=Ve([We(4,L.ILogService)],D),e.ExtHostNotebookKernels=D;var b;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(b||(b={}));class t extends P.Disposable{get state(){return this.f}constructor(l,E,i){super(),this.j=E,this.k=i,this.b=t.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.D(new u.CancellationTokenSource),this.h=new o(10,r=>this.m(r)),this.i=E.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const E=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new v.SerializableObjectWithBuffers(E))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}q(l){let E=this.j;if(l&&(E=this.j.notebook.getCellFromApiCell(l)),!E)throw new Error("INVALID cell");return E.handle}r(l){return l.map(E=>{const i=w.NotebookCellOutput.ensureUniqueMimeTypes(E.items,!0);return i===E.items?C.NotebookCellOutput.from(E):C.NotebookCellOutput.from({items:i,id:E.id,metadata:E.metadata})})}async s(l,E,i){const r=this.q(E),m=this.r((0,c.asArray)(l));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:r,append:i,outputs:m})}async t(l,E,i){return l=w.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(C.NotebookCellOutputItem.from),outputId:E.id,append:i})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(i){l.i=i,l.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(i){if(l.f===b.Resolved||l.f===b.Started)throw new Error("Cannot call start again");l.f=b.Started,l.c.fire(),l.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,r){if(l.f===b.Resolved)throw new Error("Cannot call resolve twice");l.f=b.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new v.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:i}))},clearOutput(i){return l.n(),l.s([],i,!1)},appendOutput(i,r){return l.n(),l.s(i,r,!0)},replaceOutput(i,r){return l.n(),l.s(i,r,!1)},appendOutputItems(i,r){return l.n(),l.t(i,r,!0)},replaceOutputItems(i,r){return l.n(),l.t(i,r,!1)}})}}t.a=0;class o{constructor(l,E){this.d=l,this.e=E,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const E=this.a;return this.a=[],this.e(E).finally(()=>l.complete())}}function s(a,l){return`${a.value}/${l}`}e.createKernelId=s}),define(De[274],Ce([1,0,3,5,137]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(k,y){this.c=y,this.a=new Map,this.b=k.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,y,p){const L=this.c.getEditorById(k);this.a.get(y)?.fire({editor:L.apiEditor,message:p})}createRendererMessaging(k,y){if(!k.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,T,S)=>this.d(y).event(L,T,S),postMessage:(L,T)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,T]=[T,L]);const S=T&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(S?.id,y,L)}}}d(k){let y=this.a.get(k);return y||(y=new c.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(k)}}),this.a.set(k,y),y)}}e.ExtHostNotebookRenderers=R}),define(De[275],Ce([1,0,6,10,2,27,5]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class k{constructor(p){this.b=new Map,this.a=p.getProxy(P.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(p,L,T){if((0,R.checkProposedApiEnabled)(p,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,T),this.a.$registerProfileContentHandler(L,T.name,T.description,p.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(p,L,T,S){const I=this.b.get(p);if(!I)throw new Error(`Unknown handler with id: ${p}`);return I.saveProfile(L,T,S)}async $readProfile(p,L,T){const S=this.b.get(p);if(!S)throw new Error(`Unknown handler with id: ${p}`);return S.readProfile((0,A.isString)(L)?L:u.URI.revive(L),T)}}e.ExtHostProfileContentHandlers=k}),define(De[276],Ce([1,0,2,5,19,13]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class P{constructor(y,p){this.d=p,this.c=new Map,this.b=y.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,p,L){const T=c.URI.revive(p),S=this.c.get(y);return S?(0,u.asPromise)(()=>S.provideOriginalResource(T,L)).then(I=>I||null):Promise.resolve(null)}registerQuickDiffProvider(y,p,L,T){const S=P.a++;return this.c.set(S,p),this.b.$registerQuickDiffProvider(S,R.DocumentSelector.from(y,this.d),L,T),{dispose:()=>{this.b.$unregisterQuickDiffProvider(S),this.c.delete(S)}}}}P.a=0,e.ExtHostQuickDiff=P}),define(De[277],Ce([1,0,21,3,6,5,2,7,9,17,37,52,27,13]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(w,n,d){const f=w.getProxy(R.MainContext.MainThreadQuickOpen);class v{constructor(i,r){this.e=new Map,this.f=0,this.a=i,this.b=r}showQuickPick(i,r,m,g=c.CancellationToken.None){this.c=void 0;const h=Promise.resolve(r),O=++this.f,$=f.$show(O,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},g),x={},Y=$.then(()=>x);return Promise.race([Y,h]).then(G=>{if(G===x)return;const M=(0,S.isProposedApiEnabled)(i,"quickPickItemTooltip");return h.then(B=>{const U=[];for(let j=0;j<B.length;j++){const he=B[j];typeof he=="string"?U.push({label:he,handle:j}):he.kind===k.QuickPickItemKind.Separator?U.push({type:"separator",label:he.label}):(he.tooltip&&!M&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),U.push({label:he.label,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:M?I.MarkdownString.fromStrict(he.tooltip):void 0,handle:j}))}return m&&typeof m.onDidSelectItem=="function"&&(this.c=j=>{m.onDidSelectItem(B[j])}),f.$setItems(O,U),$.then(j=>{if(typeof j=="number")return B[j];if(Array.isArray(j))return j.map(he=>B[he])})})}).then(void 0,G=>{if(!(0,y.isCancellationError)(G))return f.$setError(O,G),Promise.reject(G)})}$onItemSelected(i){this.c?.(i)}showInput(i,r=c.CancellationToken.None){return this.d=i?.validateInput,f.$input(i,typeof this.d=="function",r).then(void 0,m=>{if(!(0,y.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(i){if(!this.d)return;const r=await this.d(i);if(!r||typeof r=="string")return r;let m;switch(r.severity){case k.InputBoxValidationSeverity.Info:m=L.default.Info;break;case k.InputBoxValidationSeverity.Warning:m=L.default.Warning;break;case k.InputBoxValidationSeverity.Error:m=L.default.Error;break;default:m=r.message?L.default.Error:L.default.Ignore;break}return{content:r.message,severity:m}}async showWorkspaceFolderPick(i,r=c.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!m)return;const g=await this.a.getWorkspaceFolders2();if(!!g)return g.find(h=>h.uri.toString()===m.uri.toString())}createQuickPick(i){const r=new a(i,()=>this.e.delete(r._id));return this.e.set(r._id,r),r}createInputBox(i){const r=new l(i,()=>this.e.delete(r._id));return this.e.set(r._id,r),r}$onDidChangeValue(i,r){this.e.get(i)?._fireDidChangeValue(r)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,r){const m=this.e.get(i);m instanceof a&&m._fireDidChangeActive(r)}$onDidChangeSelection(i,r){const m=this.e.get(i);m instanceof a&&m._fireDidChangeSelection(r)}$onDidTriggerButton(i,r){this.e.get(i)?._fireDidTriggerButton(r)}$onDidTriggerItemButton(i,r,m){const g=this.e.get(i);g instanceof a&&g._fireDidTriggerItemButton(r,m)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class D{constructor(i,r){this.x=i,this.y=r,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((r,m)=>{const g=r===k.QuickInputButtons.Back?-1:m;this.o.set(g,r)}),this.z({buttons:i.map((r,m)=>({...s(r),tooltip:r.tooltip,handle:r===k.QuickInputButtons.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const r=this.o.get(i);r&&this.r.fire(r)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,u.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(i){if(!this.v){for(const r of Object.keys(i)){const m=i[r];this.u[r]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}D.a=1;function b(E){if(E instanceof k.ThemeIcon)return{id:E.id};const i=o(E),r=t(E);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof r=="string"?P.URI.file(r):r}}function t(E){return typeof E=="object"&&"light"in E?E.light:E}function o(E){return typeof E=="object"&&"dark"in E?E.dark:E}function s(E){const i=b(E.iconPath);let r,m;return"id"in i?m=T.ThemeIcon.asClassName(i):r=i,{iconPath:r,iconClass:m}}class a extends D{constructor(i,r){super(i.identifier,r),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((g,h)=>{this.C.set(h,g),this.D.set(g,h)});const r=(0,S.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),m=[];for(let g=0;g<i.length;g++){const h=i[g];h.kind===k.QuickPickItemKind.Separator?m.push({type:"separator",label:h.label}):(h.tooltip&&!r&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),m.push({handle:g,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:r?I.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((O,$)=>({...s(O),tooltip:O.tooltip,handle:$}))}))}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(r=>this.D.has(r)),this.z({activeItems:this.J.map(r=>this.D.get(r))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(r=>this.D.has(r)),this.z({selectedItems:this.L.map(r=>this.D.get(r))})}_fireDidChangeActive(i){const r=(0,p.coalesce)(i.map(m=>this.C.get(m)));this.J=r,this.K.fire(r)}_fireDidChangeSelection(i){const r=(0,p.coalesce)(i.map(m=>this.C.get(m)));this.L=r,this.M.fire(r)}_fireDidTriggerItemButton(i,r){const m=this.C.get(i);if(!m||!m.buttons||!m.buttons.length)return;const g=m.buttons[r];g&&this.N.fire({button:g,item:m})}}class l extends D{constructor(i,r){super(i.identifier,r),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:L.default.Error}):this.z({validationMessage:i.message,severity:i.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new v(n,d)}e.createExtHostQuickOpen=C});var Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(De[278],Ce([1,0,2,3,62,6,19,5,17,109,16,25,52,13,27]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C){"use strict";var w,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(r){if(r)return typeof r.iconPath=="string"?c.URI.file(r.iconPath):c.URI.isUri(r.iconPath)||S.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function f(r,m){if(!r.iconPath&&!m.iconPath)return 0;if(r.iconPath){if(!m.iconPath)return 1}else return-1;const g=typeof r.iconPath=="string"?r.iconPath:c.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,h=typeof m.iconPath=="string"?m.iconPath:c.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,p.comparePaths)(g,h)}function v(r,m){let g=0;if(r.strikeThrough!==m.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==m.faded)return r.faded?1:-1;if(r.tooltip!==m.tooltip)return(r.tooltip||"").localeCompare(m.tooltip||"");if(g=f(r,m),g!==0)return g;if(r.light&&m.light)g=f(r.light,m.light);else{if(r.light)return 1;if(m.light)return-1}if(g!==0)return g;if(r.dark&&m.dark)g=f(r.dark,m.dark);else{if(r.dark)return 1;if(m.dark)return-1}return g}function D(r,m){if(r.command!==m.command)return r.command<m.command?-1:1;if(r.title!==m.title)return r.title<m.title?-1:1;if(r.tooltip!==m.tooltip){if(r.tooltip!==void 0&&m.tooltip!==void 0)return r.tooltip<m.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(r.arguments===m.arguments)return 0;if(r.arguments)if(m.arguments){if(r.arguments.length!==m.arguments.length)return r.arguments.length-m.arguments.length}else return 1;else return-1;for(let g=0;g<r.arguments.length;g++){const h=r.arguments[g],O=m.arguments[g];if(h!==O)return h<O?-1:1}return 0}function b(r,m){let g=(0,p.comparePaths)(r.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(g!==0)return g;if(r.command&&m.command)g=D(r.command,m.command);else{if(r.command)return 1;if(m.command)return-1}if(g!==0)return g;if(r.decorations&&m.decorations)g=v(r.decorations,m.decorations);else{if(r.decorations)return 1;if(m.decorations)return-1}return g}function t(r,m){for(let g=0;g<r.length;g++)if(r[g]!==m[g])return!1;return!0}function o(r,m){return r.command===m.command&&r.title===m.title&&r.tooltip===m.tooltip&&(r.arguments&&m.arguments?t(r.arguments,m.arguments):r.arguments===m.arguments)}function s(r,m){return(0,y.equals)(r,m,o)}class a{get value(){return this.d}set value(m){m=m??"",Me(this,w,"f").$setInputBoxValue(this.l,m),this.m(m)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(m){Me(this,w,"f").$setInputBoxPlaceholder(this.l,m),this.f=m}get validateInput(){return(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(m){if((0,C.checkProposedApiEnabled)(this.k,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=m,Me(this,w,"f").$setValidationProviderIsEnabled(this.l,!!m)}get enabled(){return this.h}set enabled(m){m=!!m,this.h!==m&&(this.h=m,Me(this,w,"f").$setInputBoxEnablement(this.l,m))}get visible(){return this.j}set visible(m){m=!!m,this.j!==m&&(this.j=m,Me(this,w,"f").$setInputBoxVisibility(this.l,m))}constructor(m,g,h){this.k=m,this.l=h,w.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,w,g,"f")}showValidationMessage(m,g){(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),Me(this,w,"f").$showValidationMessage(this.l,m,g)}$onInputBoxValueChange(m){this.m(m)}m(m){this.d=m,this.e.fire(m)}}e.ExtHostSCMInputBox=a,w=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(m){this.v=m,this.q.$updateGroupLabel(this.t,this.handle,m)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(m){this.p=m,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(m){this.f=[...m],this.k.fire()}constructor(m,g,h,O,$){this.q=m,this.s=g,this.t=h,this.u=O,this.v=$,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(m){return this.g.get(m)}$executeResourceCommand(m,g){const h=this.h.get(m);return h?(0,P.asPromise)(()=>this.s.executeCommand(h.command,...h.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this.f].sort(b),h=(0,y.sortedDiff)(this.o,m,b).map(x=>{const Y=x.toInsert.map(G=>{const M=this.e++;this.g.set(M,G);const B=G.resourceUri;let U;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"){const N=new R.DisposableStore;U=this.s.converter.toInternal(G.command,N),this.j.set(M,N)}else this.h.set(M,G.command);const j=d(G.decorations),he=G.decorations&&d(G.decorations.light)||j,ie=G.decorations&&d(G.decorations.dark)||j,V=[he,ie],J=G.decorations&&G.decorations.tooltip||"",ne=G.decorations&&!!G.decorations.strikeThrough,ve=G.decorations&&!!G.decorations.faded,ue=G.contextValue||"";return{rawResource:[M,B,V,J,ne,ve,ue,U],handle:M}});return{start:x.start,deleteCount:x.deleteCount,toInsert:Y}}),O=h.map(({start:x,deleteCount:Y,toInsert:G})=>[x,Y,G.map(M=>M.rawResource)]),$=h.reverse();for(const{start:x,deleteCount:Y,toInsert:G}of $){const M=G.map(U=>U.handle),B=this.n.splice(x,Y,...M);for(const U of B)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=m,O}dispose(){this.l=!0,this.m.fire()}}l.d=0;class E{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(m){this.g!==m&&(this.g=m,Me(this,n,"f").$updateSourceControl(this.t,{count:m}))}get quickDiffProvider(){return this.h}set quickDiffProvider(m){this.h=m,m?.label&&(0,C.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Me(this,n,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!m,quickDiffLabel:m?.label})}get commitTemplate(){return this.j}set commitTemplate(m){m!==this.j&&(this.j=m,Me(this,n,"f").$updateSourceControl(this.t,{commitTemplate:m}))}get acceptInputCommand(){return this.l}set acceptInputCommand(m){this.k.value=new R.DisposableStore,this.l=m;const g=this.v.converter.toInternal(m,this.k.value);Me(this,n,"f").$updateSourceControl(this.t,{acceptInputCommand:g})}get actionButton(){return(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(m){(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=m;const g=m!==void 0?{command:this.v.converter.toInternal(m.command,this.m.value),secondaryCommands:m.secondaryCommands?.map(h=>h.map(O=>this.v.converter.toInternal(O,this.m.value))),description:m.description,enabled:m.enabled}:void 0;Me(this,n,"f").$updateSourceControl(this.t,{actionButton:g??null})}get statusBarCommands(){return this.p}set statusBarCommands(m){if(this.p&&m&&s(this.p,m))return;this.o.value=new R.DisposableStore,this.p=m;const g=(m||[]).map(h=>this.v.converter.toInternal(h,this.o.value));Me(this,n,"f").$updateSourceControl(this.t,{statusBarCommands:g})}get selected(){return this.q}constructor(m,g,h,O,$,x){this.u=m,this.v=h,this.w=O,this.x=$,this.y=x,n.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=E.d++,this.z=new Map,this.A=new Set,_e(this,n,g,"f"),this.f=new a(m,Me(this,n,"f"),this.t),Me(this,n,"f").$registerSourceControl(this.t,O,$,x)}createResourceGroup(m,g){const h=new l(Me(this,n,"f"),this.v,this.t,m,g),O=A.Event.once(h.onDidDispose)(()=>this.z.delete(h));return this.z.set(h,O),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const m=[],g=[];for(const[h,O]of this.z){O.dispose();const $=h.onDidUpdateResourceStates(()=>{this.A.add(h),this.eventuallyUpdateResourceStates()});A.Event.once(h.onDidDispose)(()=>{this.A.delete(h),$.dispose(),this.e.delete(h.handle),Me(this,n,"f").$unregisterGroup(this.t,h.handle)}),m.push([h.handle,h.id,h.label,h.features]);const x=h._takeResourceStateSnapshot();x.length>0&&g.push([h.handle,x]),this.e.set(h.handle,h)}Me(this,n,"f").$registerGroups(this.t,m,g),this.z.clear()}eventuallyUpdateResourceStates(){const m=[];this.A.forEach(g=>{const h=g._takeResourceStateSnapshot();h.length!==0&&m.push([g.handle,h])}),m.length>0&&Me(this,n,"f").$spliceResourceStates(this.t,m),this.A.clear()}getResourceGroup(m){return this.e.get(m)}setSelectionState(m){this.q=m,this.s.fire(m)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(m=>m.dispose()),Me(this,n,"f").$unregisterSourceControl(this.t)}}n=new WeakMap,E.d=0,Ve([(0,u.debounce)(100)],E.prototype,"eventuallyAddResourceGroups",null),Ve([(0,u.debounce)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let i=class un{get onDidChangeActiveProvider(){return this.j.event}constructor(m,g,h){this.l=g,this.m=h,this.g=new Map,this.h=new T.ExtensionIdentifierMap,this.j=new A.Emitter,this.e=m.getProxy(k.MainContext.MainThreadSCM),this.f=m.getProxy(k.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const $=this.g.get(O.sourceControlHandle);if(!$)return O;const x=$.getResourceGroup(O.groupHandle);return x?x.getResourceState(O.handle):O}else if(O&&O.$mid===4){const $=this.g.get(O.sourceControlHandle);return $?$.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const $=this.g.get(O.handle);return $||O}return O}})}createSourceControl(m,g,h,O){this.m.trace("ExtHostSCM#createSourceControl",m.identifier.value,g,h,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const $=un.d++,x=new E(m,this.e,this.l,g,h,O);this.g.set($,x);const Y=this.h.get(m.identifier)||[];return Y.push(x),this.h.set(m.identifier,Y),x}getLastInputBox(m){this.m.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const g=this.h.get(m.identifier),h=g&&g[g.length-1];return h&&h.inputBox}$provideOriginalResource(m,g,h){const O=c.URI.revive(g);this.m.trace("ExtHostSCM#$provideOriginalResource",m,O.toString());const $=this.g.get(m);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(O,h)).then(x=>x||null)}$onInputBoxValueChange(m,g){this.m.trace("ExtHostSCM#$onInputBoxValueChange",m);const h=this.g.get(m);return h&&h.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(m,g,h,O){this.m.trace("ExtHostSCM#$executeResourceCommand",m,g,h);const $=this.g.get(m);if(!$)return Promise.resolve(void 0);const x=$.getResourceGroup(g);return x?x.$executeResourceCommand(h,O):Promise.resolve(void 0)}$validateInput(m,g,h){this.m.trace("ExtHostSCM#$validateInput",m);const O=this.g.get(m);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>O.inputBox.validateInput(g,h)).then($=>{if(!$)return Promise.resolve(void 0);const x=I.MarkdownString.fromStrict($.message);return x?Promise.resolve([x,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this.g.get(m)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=m,Promise.resolve(void 0)}};i.d=0,i=Ve([We(2,L.ILogService)],i),e.ExtHostSCM=i}),define(De[99],Ce([1,0,5,3,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(k){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=k.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this.b.fire(k)}get(k,y){return this.a.$getPassword(k,y)}store(k,y,p){return this.a.$setPassword(k,y,p)}delete(k,y){return this.a.$deletePassword(k,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[279],Ce([1,0,7,5,185,6,13,10]),function(re,e,c,A,u,R,P,k){"use strict";var y,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(C,w,n,d,f=c.StatusBarAlignment.Left,v){y.set(this,void 0),p.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,y,C,"f"),_e(this,p,w,"f"),this.c=L.a++,this.e=n,this.f=d,this.g=f,this.h=this.u(v)}u(C){if(!!(0,k.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(C){this.k=C,this.v()}set name(C){this.m=C,this.v()}set tooltip(C){this.l=C,this.v()}set color(C){this.n=C,this.v()}set backgroundColor(C){C&&!L.b.has(C.id)&&(C=void 0),this.o=C,this.v()}set command(C){this.r?.fromApi!==C&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof C=="string"?this.r={fromApi:C,internal:Me(this,p,"f").toInternal({title:"",command:C},this.p)}:C?this.r={fromApi:C,internal:Me(this,p,"f").toInternal(C,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(C){this.t=C,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Me(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let C;this.e?this.f?C=`${this.e.identifier.value}.${this.f}`:C=this.e.identifier.value:C=this.f;let w;this.m?w=this.m:w=(0,u.localize)(0,null,this.e.displayName||this.e.name);let n=this.n;this.o&&(n=L.b.get(this.o.id));const d=P.MarkdownString.fromStrict(this.l);Me(this,y,"f").$setEntry(this.c,C,w,this.k,d,this.r?.internal,n,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,p=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class T{constructor(C){this.b=[],this.a=C.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,u.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(C){const w={message:C};return this.b.unshift(w),this.c(),new c.Disposable(()=>{const n=this.b.indexOf(w);n>=0&&(this.b.splice(n,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class S{constructor(C,w){this.a=C.getProxy(A.MainContext.MainThreadStatusBar),this.b=w,this.c=new T(this)}createStatusBarEntry(C,w,n,d){return new L(this.a,this.b,C,w,n,d)}setStatusBarMessage(C,w){const n=this.c.setMessage(C);let d;return typeof w=="number"?d=setTimeout(()=>n.dispose(),w):typeof w<"u"&&w.then(()=>n.dispose(),()=>n.dispose()),new c.Disposable(()=>{n.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=S}),define(De[100],Ce([1,0,5,3,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(k,y){this.c=y,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=k.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this.a.$registerExtensionStorageKeysToSync(k,y)}async initializeExtensionStorage(k,y,p){const L=await this.a.$initializeExtensionStorage(k,y);let T;return L&&(T=this.d(k,y,L)),T||p}setValue(k,y,p){return this.a.$setValue(k,y,p)}$acceptValue(k,y,p){const L=this.d(k,y,p);L&&this.b.fire({shared:k,key:y,value:L})}d(k,y,p){try{return JSON.parse(p)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${k}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(De[81],Ce([1,0,4,26,16,80,2]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let k=class{constructor(p,L,T){this.d=L,this.f=T,this.a=p.workspace??void 0,this.b=p.environment,this.whenReady=this.h().then(S=>this.c=S)}async g(p){return P.URI.joinPath(this.b.workspaceStorageHome,p)}async h(){if(!this.a)return Promise.resolve(void 0);const p=this.a.id,L=await this.g(p);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(p){if(this.c)return P.URI.joinPath(this.c,p.identifier.value)}globalValue(p){return P.URI.joinPath(this.b.globalStorageHome,p.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([We(0,A.IExtHostInitDataService),We(1,u.ILogService),We(2,R.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(De[41],Ce([1,0,3,5,4,2,20,6,7,187,9,219,21,30,220,52,10,19,13]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class v{constructor(i,r,m,g){this.k=i,this._id=r,this.l=m,this.m=g,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(O=>this.f=O);const h=this;this.value={get name(){return h.m||""},get processId(){return h.b},get creationOptions(){return h.l},get exitStatus(){return h.h},get state(){return h.j},sendText(O,$=!0){h.o(),h.k.$sendText(h._id,O,$)},show(O){h.o(),h.k.$show(h._id,O)},hide(){h.o(),h.k.$hide(h._id)},dispose(){h.a||(h.a=!0,h.k.$dispose(h._id))},get dimensions(){if(!(h.d===void 0||h.g===void 0))return{columns:h.d,rows:h.g}}}}async create(i,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,n.withNullAsUndefined)(i.shellPath),shellArgs:(0,n.withNullAsUndefined)(i.shellArgs),cwd:(0,n.withNullAsUndefined)(i.cwd),env:(0,n.withNullAsUndefined)(i.env),icon:(0,n.withNullAsUndefined)(a(i.iconPath)),color:w.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,n.withNullAsUndefined)(i.message),strictEnv:(0,n.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,n.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,n.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,n.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(i.location,r?.resolvedExtHostIdentifier),isTransient:(0,n.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,r,m,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(g)?g.id:void 0,location:this.n(i,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,r){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in i?{viewColumn:f.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,r){this.h=Object.freeze({code:i,reason:r})}setDimensions(i,r){return i===this.d&&r===this.g||i===0||r===0?!1:(this.d=i,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(r=>{r!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=v;class D{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,r){this.g.setDimensions?.({columns:i,rows:r})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let b=1,t=class extends k.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new c.Emitter,this.onDidCloseTerminal=this.z.event,this.C=new c.Emitter,this.onDidOpenTerminal=this.C.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(A.MainContext.MainThreadTerminalService),this.q=new C.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.D({dispose:()=>{for(const[m,g]of this.g)g.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,r){const m=new v(this.a,(0,I.generateUuid)(),i,i.name),g=new D(i.pty);return m.createExtensionTerminal(i.location,this.L(i,r).resolvedExtHostIdentifier,a(i.iconPath),l(i.color)).then(h=>{const O=this.M(h,g);this.h[h]=O}),this.f.push(m),m.value}L(i,r){if(r=r||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const m=i.location.parentTerminal;if(m){const g=this.f.find(h=>h.value===m);g&&(r.resolvedExtHostIdentifier=g._id)}}else i.location&&typeof i.location!="object"?r.location=i.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(i,r){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const g=new D(r),h=this.M(i,g);this.h[i]=h}async $acceptActiveTerminalChanged(i){const r=this.b;if(i===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const m=this.O(i);m&&(this.b=m,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,r){const m=this.O(i);m&&this.I.fire({terminal:m.value,data:r})}async $acceptTerminalDimensions(i,r,m){const g=this.O(i);g&&g.setDimensions(r,m)&&this.G.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(i,r,m){this.g.get(i)?.resize(r,m)}async $acceptTerminalTitleChange(i,r){const m=this.O(i);m&&(m.name=r)}async $acceptTerminalClosed(i,r,m){const g=this.Q(this.f,i);if(g!==null){const h=this.f.splice(g,1)[0];h.setExitStatus(r,m),this.z.fire(h.value)}}$acceptTerminalOpened(i,r,m,g){if(r){const $=this.Q(this.f,r);if($!==null){this.f[$]._id=i,this.C.fire(this.terminals[$]),this.f[$].isOpen=!0;return}}const h={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:R.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},O=new v(this.a,i,h,m);this.f.push(O),this.C.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(i,r){this.O(i)?._setProcessId(r)}async $startExtensionTerminal(i,r){const m=this.O(i);if(!m)return{message:(0,p.localize)(0,null,i)};m.isOpen||await new Promise(h=>{const O=this.onDidOpenTerminal(async $=>{$===m.value&&(O.dispose(),h())})});const g=this.g.get(i);g?g.startSendingEvents(r):this.j[i]={initialDimensions:r}}M(i,r){const m=new k.DisposableStore;m.add(r.onProcessReady(h=>this.a.$sendProcessReady(i,h.pid,h.cwd))),m.add(r.onDidChangeProperty(h=>this.a.$sendProcessProperty(i,h))),this.q.startBuffering(i,r.onProcessData),m.add(r.onProcessExit(h=>this.N(i,h))),this.g.set(i,r);const g=this.j[i];return g&&r instanceof D&&(r.startSendingEvents(g.initialDimensions),delete this.j[i]),m}$acceptProcessAckDataEvent(i,r){this.g.get(i)?.acknowledgeDataEvent(r)}$acceptProcessInput(i,r){this.g.get(i)?.input(r)}$acceptTerminalInteraction(i){const r=this.O(i);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(i,r,m){try{this.g.get(i)?.resize(r,m)}catch(g){if(g.code!=="EPIPE"&&g.code!=="ERR_IPC_CHANNEL_CLOSED")throw g}}$acceptProcessShutdown(i,r){this.g.get(i)?.shutdown(r)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(r=>this.a.$sendProcessProperty(i,{type:"cwd",value:r}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.s.add(i),this.s.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.s.delete(i),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,r,m){if(this.u.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.u.set(r,m),this.a.$registerProfileProvider(r,i.identifier.value),new y.Disposable(()=>{this.u.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(i,r,m){if(this.v.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.v.set(i,m),this.a.$registerQuickFixProvider(i,r),new y.Disposable(()=>{this.v.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,r){const m=new S.CancellationTokenSource().token;if(m.isCancellationRequested)return;const g=this.v.get(i);if(!g)return;const h=await g.provideTerminalQuickFixes(r,m);if(h!==null)return h}async $createContributedProfileTerminal(i,r){const m=new S.CancellationTokenSource().token;let g=await this.u.get(i)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(g&&!("options"in g)&&(g={options:g}),!g||!("options"in g))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in g.options){this.createExtensionTerminal(g.options,r);return}this.createTerminalFromOptions(g.options,r)}}async $provideLinks(i,r){const m=this.O(i);if(!m)return[];this.w.delete(i),this.y.get(i)?.dispose(!0);const h=new S.CancellationTokenSource;this.y.set(i,h);const O=[],$={terminal:m.value,line:r},x=[];for(const M of this.s)x.push(d.Promises.withAsyncBody(async B=>{h.token.onCancellationRequested(()=>B({provider:M,links:[]}));const U=await M.provideTerminalLinks($,h.token)||[];h.token.isCancellationRequested||B({provider:M,links:U})}));const Y=await Promise.all(x);if(h.token.isCancellationRequested)return[];const G=new Map;for(const M of Y)M&&M.links.length>0&&O.push(...M.links.map(B=>{const U={id:b++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return G.set(U.id,{provider:M.provider,link:B}),U}));return this.w.set(i,G),O}$activateLink(i,r){const m=this.w.get(i)?.get(r);!m||m.provider.handleTerminalLink(m.link)}N(i,r){this.q.stopBuffering(i),this.g.delete(i),delete this.j[i];const m=this.h[i];m&&(m.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,r)}O(i){return this.P(this.f,i)}P(i,r){const m=this.Q(i,r);return m!==null?i[m]:null}Q(i,r){let m=null;return i.some((g,h)=>g._id===r?(m=h,!0):!1),m}getEnvironmentVariableCollection(i){let r=this.l.get(i.identifier.value);return r||(r=new o,this.S(i.identifier.value,r)),r}R(i,r){const m=(0,T.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(i,r.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(i){i.forEach(r=>{const m=r[0],g=new o(r[1]);this.S(m,g)})}$acceptDefaultProfile(i,r){const m=this.m;this.m=i,this.n=r,m?.path!==i.path&&this.J.fire(i.path)}S(i,r){this.l.set(i,r),r.onDidChangeCollection(()=>{this.R(i,r)})}};t=Ve([We(1,P.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class o{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,r){this.d(i,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(i,r){this.d(i,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(i,r){this.d(i,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}d(i,r){const m=this.map.get(i);(!m||m.value!==r.value||m.type!==r.type)&&(this.map.set(i,r),this.b.fire())}get(i){return this.map.get(i)}forEach(i,r){this.map.forEach((m,g)=>i.call(r,g,m,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends t{constructor(i){super(!1,i)}createTerminal(i,r,m){throw new L.NotSupportedError}createTerminalFromOptions(i,r){throw new L.NotSupportedError}};s=Ve([We(0,P.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function a(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function l(E){return w.ThemeColor.isThemeColor(E)?E:void 0}});var Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(De[280],Ce([1,0,17,19,22,21,3,63,68,6,23,10,30,5,20,138,13,7,57,95,77,27]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(M,B,U){this.j=U,this.c=new P.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(I.MainContext.MainThreadTesting),this.h=new $(this.f),this.g=new i(this.f),B.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const he=j,ie=he.tests[he.tests.length-1].item.extId;return this.d.get(f.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,w.toItemFromContext)(j)}})}createTestController(M,B,U,j){if(this.d.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const he=new p.DisposableStore,ie=he.add(new w.ExtHostTestItemCollection(B,U,this.j));ie.root.label=U;const V=new Map,J=this.f,ne={items:ie.root.children,get label(){return U},set label(ue){U=ue,ie.root.label=ue,J.$updateController(B,{label:U})},get refreshHandler(){return j},set refreshHandler(ue){j=ue,J.$updateController(B,{canRefresh:!!ue})},get id(){return B},createRunProfile:(ue,ee,N,q,ae,me)=>{let ke=(0,y.hash)(ue);for(;V.has(ke);)ke++;return me!==void 0&&(0,b.checkProposedApiEnabled)(M,"testContinuousRun"),new x(this.f,V,B,ke,ue,ee,N,q,ae,me)},createTestItem(ue,ee,N){return new w.TestItemImpl(B,ue,ee,N)},createTestRun:(ue,ee,N=!0)=>this.g.createTestRun(B,ie,ue,ee,N),set resolveHandler(ue){ie.resolveHandler=ue},get resolveHandler(){return ie.resolveHandler},dispose:()=>{he.dispose()}};J.$registerTestController(B,U,!!j),he.add((0,p.toDisposable)(()=>J.$unregisterTestController(B)));const ve={controller:ne,collection:ie,profiles:V};return this.d.set(B,ve),he.add((0,p.toDisposable)(()=>this.d.delete(B))),he.add(ie.onDidGenerateDiff(ue=>J.$publishDiff(B,ue.map(D.TestsDiffOp.serialize)))),ne}createTestObserver(){return this.h.checkout()}async runTests(M,B=R.CancellationToken.None){const U=r(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(U.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(he=>f.TestId.fromExtHostTestItem(he,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:Y[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(he=>he.id)},B)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,B,U){return(0,c.mapFind)(this.g.trackers,he=>he.id===M?he.getCoverage(B):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,B,U,j){return(0,c.mapFind)(this.g.trackers,ie=>ie.id===M?ie.getCoverage(B):void 0)?.resolveFileCoverage(U,j)??Promise.resolve([])}$configureRunProfile(M,B){this.d.get(M)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(M,B){await this.d.get(M)?.controller.refreshHandler?.(B)}$publishTestResults(M){this.results=Object.freeze(M.map(B=>(0,L.deepFreeze)(n.TestResults.to(B))).concat(this.results).sort((B,U)=>U.completedAt-B.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,B){const U=this.d.get(f.TestId.fromString(M).controllerId)?.collection;U&&(await U.expand(M,B<0?1/0:B),U.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(D.TestsDiffOp.deserialize))}async $runControllerTests(M,B){return Promise.all(M.map(U=>this.k(U,!1,B)))}async $startContinuousRun(M,B){const U=new R.CancellationTokenSource(B),j=await Promise.all(M.map(he=>this.k(he,!0,U.token)));return!B.isCancellationRequested&&!j.some(he=>he.error)&&await new Promise(he=>B.onCancellationRequested(he)),U.dispose(!0),j}async k(M,B,U){const j=this.d.get(M.controllerId);if(!j)return{};const{collection:he,profiles:ie}=j,V=ie.get(M.profileId);if(!V)return{};const J=M.testIds.map(ee=>he.tree.get(ee)).filter(T.isDefined),ne=M.excludeExtIds.map(ee=>j.collection.tree.get(ee)).filter(T.isDefined).filter(ee=>J.some(N=>N.fullId.compare(ee.fullId)===2));if(!J.length)return{};const ve=new d.TestRunRequest2(J.some(ee=>ee.actual instanceof w.TestItemRootImpl)?void 0:J.map(ee=>ee.actual),ne.map(ee=>ee.actual),V,B),ue=(0,D.isStartControllerTests)(M)&&this.g.prepareForMainThreadTestRun(ve,m.fromInternal(M,j.collection),U);try{return await V.runHandler(ve,U),{}}catch(ee){return{error:String(ee)}}finally{ue&&(ue.hasRunningTasks&&!U.isCancellationRequested&&await P.Event.toPromise(ue.onEnd),ue.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};s=Ve([We(0,C.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var l;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(l||(l={}));class E extends p.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,B,U){super(),this.k=M,this.l=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.D(new P.Emitter),this.onEnd=this.j.event,this.h=this.D(new R.CancellationTokenSource(U));const j=this.D(new A.RunOnceScheduler(()=>this.m(),a));this.D(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const B=this.k.id,U=this.k.controllerId,j=(0,S.generateUuid)(),he=new g(this.l,B,j),ie=ve=>(ue,...ee)=>{if(J){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ue)||(this.q(ue),ve(ue,...ee))},V=(ve,ue)=>{const ee=ue instanceof Array?ue.map(n.TestMessage.from):[n.TestMessage.from(ue)];if(ve.uri&&ve.range){const N={range:n.Range.from(ve.range),uri:ve.uri};for(const q of ee)q.location=q.location||N}this.l.$appendTestMessagesInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),ee)};let J=!1;const ne={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return he.coverageProvider},set coverageProvider(ve){he.coverageProvider=ve},enqueued:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),1)}),skipped:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),5)}),started:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),2)}),errored:ie((ve,ue,ee)=>{V(ve,ue),this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),6,ee)}),failed:ie((ve,ue,ee)=>{V(ve,ue),this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),4,ee)}),passed:ie((ve,ue)=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,this.k.controllerId).toString(),3,ue)}),appendOutput:(ve,ue,ee)=>{J||(ee&&(this.k.isIncluded(ee)?this.q(ee):ee=void 0),this.l.$appendOutputToRun(B,j,u.VSBuffer.fromString(ve),ue&&n.location.from(ue),ee&&f.TestId.fromExtHostTestItem(ee,U).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(B,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ne,coverage:he}),this.l.$startedTestRunTask(B,{id:j,name:M,running:!0}),ne}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}q(M){if(!(M instanceof w.TestItemImpl))throw new v.InvalidTestItemError(M.id);if(this.g.has(f.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const B=[],U=this.k.colllection.root;for(;;){const j=n.TestItem.from(M);if(B.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),M===U))break;M=M.parent||U}this.l.$addTestsToRun(this.k.controllerId,this.k.id,B)}}class i{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,B,U){return this.f(M,B,U)}cancelRunById(M){for(const B of this.c.values())if(B.id===M){B.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,B,U,j,he){const ie=this.c.get(U);if(ie)return ie.createRun(j);const V=m.fromPublic(M,B,U,he),J=r(U);this.d.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:J&&{group:Y[J.kind],id:J.profileId},exclude:U.exclude?.map(ve=>f.TestId.fromExtHostTestItem(ve,B.root.id).toString())??[],id:V.id,include:U.include?.map(ve=>f.TestId.fromExtHostTestItem(ve,B.root.id).toString())??[B.root.id],persist:he});const ne=this.f(U,V);return ne.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),ne.dispose()}),ne.createRun(j)}f(M,B,U){const j=new E(B,this.d,U);return this.c.set(M,j),j.onEnd(()=>this.c.delete(M)),j}}e.TestRunCoordinator=i;const r=G=>{if(!!G.profile){if(!(G.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class m{static fromPublic(M,B,U,j){return new m(M,(0,S.generateUuid)(),U.include?.map(he=>f.TestId.fromExtHostTestItem(he,M).toString())??[M],U.exclude?.map(he=>f.TestId.fromExtHostTestItem(he,M).toString())??[],j,B)}static fromInternal(M,B){return new m(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,B)}constructor(M,B,U,j,he,ie){this.controllerId=M,this.id=B,this.isPersisted=he,this.colllection=ie,this.c=U.map(V=>V+"\0"),this.d=j.map(V=>V+"\0")}isIncluded(M){const B=f.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.d)if(B===U||B.startsWith(U))return!1;for(const U of this.c)if(B===U||B.startsWith(U))return!0;return!1}}e.TestRunDto=m;class g{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,B,U){this.f=M,this.g=B,this.h=U}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(n.TestCoverage.fromFile)??[]}catch(B){throw this.d=void 0,B}}async resolveFileCoverage(M,B){const U=await this.d;let j=U?.[M];return!this.c||!U||!j?[]:(j.detailedCoverage||(j=U[M]=await this.c.resolveFileCoverage?.(j,B)??j),j.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,n.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const B=f.TestId.parentId(M.item.extId);if(B&&this.g.has(B.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:B,f:U}=this;return{get added(){return[...M].map(j=>j.revived)},get updated(){return[...B].map(j=>j.revived)},get removed(){return[...U].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class O extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new P.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,B){return{...M,revived:n.TestItem.toPlain(M.item),depth:B?B.depth+1:0,children:new Set}}o(){return new h(this.q)}}class ${constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(B=>B.revived)},dispose:(0,k.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new O;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class x{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?n.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,B,U,j,he,ie,V,J=!1,ne=void 0,ve=!1){this.controllerId=U,this.profileId=j,this.d=he,this.kind=ie,this.runHandler=V,this.f=J,this._tag=ne,this.g=ve,t.set(this,void 0),o.set(this,void 0),_e(this,t,M,"f"),_e(this,o,B,"f"),B.set(j,this);const ue=Y[ie];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Me(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:U,tag:ne?n.TestTag.namespace(this.controllerId,ne.id):null,label:he,group:ue,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ve})}dispose(){Me(this,o,"f")?.delete(this.profileId)&&(_e(this,o,void 0,"f"),Me(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,t=new WeakMap,o=new WeakMap;const Y={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(De[281],Ce([1,0,17,9,3,5,139,13,7]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class p{constructor(T,S){this.i=S,this.a=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.b=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.c=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.d=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.f=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.g=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(I=>this.g.fire(I)),this.i.onDidChangeActiveTextEditor(I=>this.f.fire(I))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const S=this.i.allEditors();return T?S:S.map(I=>I.value)}async showTextDocument(T,S,I){let C;typeof S=="number"?C={position:k.ViewColumn.from(S),preserveFocus:I}:typeof S=="object"?C={position:k.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?k.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:C={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(T.uri,C),n=w&&this.i.getEditor(w);if(n)return n.value;throw w?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,S){return new P.TextEditorDecorationType(this.h,T,S).value}$acceptEditorPropertiesChanged(T,S){const I=this.i.getEditor(T);if(!I)throw new Error("unknown text editor");if(S.options&&I._acceptOptions(S.options),S.selections){const C=S.selections.selections.map(k.Selection.to);I._acceptSelections(C)}if(S.visibleRanges){const C=c.coalesce(S.visibleRanges.map(k.Range.to));I._acceptVisibleRanges(C)}if(S.options&&this.b.fire({textEditor:I.value,options:{...S.options,lineNumbers:k.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const C=y.TextEditorSelectionChangeKind.fromValue(S.selections.source),w=S.selections.selections.map(k.Selection.to);this.a.fire({textEditor:I.value,selections:w,kind:C})}if(S.visibleRanges){const C=c.coalesce(S.visibleRanges.map(k.Range.to));this.c.fire({textEditor:I.value,visibleRanges:C})}}$acceptEditorPositionData(T){for(const S in T){const I=this.i.getEditor(S);if(!I)throw new Error("Unknown text editor");const C=k.ViewColumn.to(T[S]);I.value.viewColumn!==C&&(I._acceptViewColumn(C),this.d.fire({textEditor:I.value,viewColumn:C}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.ExtHostEditors=p}),define(De[282],Ce([1,0,2,4,5,6,7,13,25,10]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(I,C){this.b=new Map,this.c=new Map,this.a=I.getProxy(u.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(w,n)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&y.ExtensionIdentifier.equals(n,this.b.get(w.source)?.extension)){const d=w.uri===void 0?void 0:c.URI.revive(w.uri);return this.c.get(w.source)?.get(T(d))?.get(w.handle)}else return;return w}})}async $getTimeline(I,C,w,n){return this.b.get(I)?.provider.provideTimeline(c.URI.revive(C),w,n)}registerTimelineProvider(I,C,w,n){const d=new R.DisposableStore,f=this.d(C.id,n,d).bind(this);let v;C.onDidChange&&(v=C.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:C.id}),this));const D=this.c;return this.f({...C,scheme:I,onDidChange:void 0,async provideTimeline(b,t,o){t?.resetCache&&(d.clear(),D.get(C.id)?.clear());const s=await C.provideTimeline(b,t,o);if(s==null)return;const a=f(b,t);return{...s,source:C.id,items:s.items.map(a)}},dispose(){for(const b of D.values())b.get(C.id)?.clear();v?.dispose(),d.dispose()}},w)}d(I,C,w){return(n,d)=>{let f;if(d?.cacheResults){let v=this.c.get(I);v===void 0&&(v=new Map,this.c.set(I,v));const D=T(n);f=v.get(D),f===void 0&&(f=new Map,v.set(D,f))}return v=>{const{iconPath:D,...b}=v,t=`${I}|${v.id??v.timestamp}`;f?.set(t,v);let o,s,a;v.iconPath&&(D instanceof P.ThemeIcon?a={id:D.id,color:D.color}:c.URI.isUri(D)?(o=D,s=D):{light:o,dark:s}=D);let l;return P.MarkdownString.isMarkdownString(b.tooltip)?l=k.MarkdownString.from(b.tooltip):(0,p.isString)(b.tooltip)?l=b.tooltip:P.MarkdownString.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=k.MarkdownString.from(b.detail)):(0,p.isString)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=b.detail),{...b,id:b.id??void 0,handle:t,source:I,command:v.command?C.toInternal(v.command,w):void 0,icon:o,iconDark:s,themeIcon:a,tooltip:l,accessibilityInformation:v.accessibilityInformation}}}}f(I,C){if(this.b.get(I.id))throw new Error(`Timeline Provider ${I.id} already exists.`);return this.a.$registerTimelineProvider({id:I.id,label:I.label,scheme:I.scheme}),this.b.set(I.id,{provider:I,extension:C}),(0,R.toDisposable)(()=>{for(const n of this.c.values())n.get(I.id)?.clear();this.b.delete(I.id),this.a.$unregisterTimelineProvider(I.id),I.dispose()})}}e.ExtHostTimeline=L;function T(S){return S?.toString()}}),define(De[283],Ce([1,0,6,18,2,5]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,p,L,T){if(this.c.has(p))throw new Error(`Opener with id '${p}' already registered`);const S=T.schemes.find(I=>!P.a.has(I));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this.c.set(p,L),this.b.$registerUriOpener(p,T.schemes,y,T.label),(0,c.toDisposable)(()=>{this.c.delete(p),this.b.$unregisterUriOpener(p)})}async $canOpenUri(y,p,L){const T=this.c.get(y);if(!T)throw new Error(`Unknown opener with id: ${y}`);const S=u.URI.revive(p);return T.canOpenExternalUri(S,L)}async $openUri(y,p,L){const T=this.c.get(y);if(!T)throw new Error(`Unknown opener id: '${y}'`);return T.openExternalUri(u.URI.revive(p.resolvedUri),{sourceUri:u.URI.revive(p.sourceUri)},L)}}P.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=P}),define(De[284],Ce([1,0,5,2,6,9,25]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(p){this.c=new P.ExtensionIdentifierSet,this.d=new Map,this.b=p.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(p,L){if(this.c.has(p))throw new Error(`Protocol handler already registered for extension ${p}`);const T=k.a++;return this.c.add(p),this.d.set(T,L),this.b.$registerUriHandler(T,p),(0,u.toDisposable)(()=>{this.c.delete(p),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(p,L){const T=this.d.get(p);if(!T)return Promise.resolve(void 0);try{T.handleUri(A.URI.revive(L))}catch(S){(0,R.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(p){return A.URI.revive(await this.b.$createAppUri(p))}}k.a=0,e.ExtHostUrls=k});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[82],Ce([1,0,3,18,23,2,203,228,96,5]),function(re,e,c,A,u,R,P,k,y,p){"use strict";var L,T,S,I,C,w,n,d,f,v,D,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(h,O,$,x,Y,G,M){L.set(this,void 0),T.set(this,void 0),S.set(this,void 0),I.set(this,void 0),C.set(this,void 0),w.set(this,void 0),n.set(this,""),d.set(this,void 0),f.set(this,!1),v.set(this,!1),D.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new c.Emitter),this._onDidDispose=Me(this,t,"f").event,_e(this,L,h,"f"),_e(this,T,O,"f"),_e(this,d,$,"f"),_e(this,I,x,"f"),_e(this,C,Y,"f"),_e(this,w,G,"f"),_e(this,D,s(G),"f"),_e(this,b,a(G),"f"),_e(this,S,M,"f")}dispose(){_e(this,f,!0,"f"),Me(this,t,"f").fire(),Me(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return _e(this,v,!0,"f"),(0,y.asWebviewUri)(h,Me(this,I,"f"))}get cspSource(){const h=Me(this,w,"f").extensionLocation;if(h.scheme===A.Schemas.https||h.scheme===A.Schemas.http){let O=h.toString();return O.endsWith("/")||(O+="/"),O+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Me(this,n,"f")}set html(h){this.a(),Me(this,n,"f")!==h&&(_e(this,n,h,"f"),Me(this,b,"f")&&!Me(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(_e(this,v,!0,"f"),Me(this,S,"f").report("Webview vscode-resource: uris",Me(this,w,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,T,"f").$setHtml(Me(this,L,"f"),this.b(h)))}get options(){return this.a(),Me(this,d,"f")}set options(h){this.a(),u.equals(Me(this,d,"f"),h)||Me(this,T,"f").$setOptions(Me(this,L,"f"),i(Me(this,w,"f"),Me(this,C,"f"),h)),_e(this,d,h,"f")}async postMessage(h){if(Me(this,f,"f"))return!1;const O=(0,k.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Me(this,D,"f")});return Me(this,T,"f").$postMessage(Me(this,L,"f"),O.message,...O.buffers)}a(){if(Me(this,f,"f"))throw new Error("Webview is disposed")}b(h){if(!Me(this,b,"f"))return h;const O=Me(this,w,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,$=Me(this,w,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Me(this,w,"f").extensionLocation.authority:void 0;return h.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,Y,G,M,B,U)=>{const j=R.URI.from({scheme:M||"file",path:decodeURIComponent(B)}),he=(0,y.asWebviewUri)(j,{isRemote:O,authority:$}).toString();return`${Y}${he}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,Y,G,M,B,U)=>{const j=R.URI.from({scheme:M||"file",path:decodeURIComponent(B)}),he=(0,y.asWebviewUri)(j,{isRemote:O,authority:$}).toString();return`${Y}${he}${U}`})}}e.ExtHostWebview=o,L=new WeakMap,T=new WeakMap,S=new WeakMap,I=new WeakMap,C=new WeakMap,w=new WeakMap,n=new WeakMap,d=new WeakMap,f=new WeakMap,v=new WeakMap,D=new WeakMap,b=new WeakMap,t=new WeakMap;function s(g){try{const h=(0,P.normalizeVersion)((0,P.parseVersion)(g.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function a(g){try{const h=(0,P.normalizeVersion)((0,P.parseVersion)(g.engines.vscode));return h?h.majorBase<1||h.majorBase===1&&h.minorBase<60:!1}catch{return!1}}class l{constructor(h,O,$,x,Y){this.c=O,this.d=$,this.e=x,this.f=Y,this.b=new Map,this.a=h.getProxy(p.MainContext.MainThreadWebviews)}$onMessage(h,O,$){const x=this.g(h);if(x){const{message:Y}=(0,k.deserializeWebviewMessage)(O,$.value);x._onMessageEmitter.fire(Y)}}$onMissingCsp(h,O){this.e.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,O,$){const x=new o(h,this.a,r(O),this.c,this.d,$,this.f);return this.b.set(h,x),x._onDidDispose(()=>{this.b.delete(h)}),x}deleteWebview(h){this.b.delete(h)}g(h){return this.b.get(h)}}e.ExtHostWebviews=l;function E(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=E;function i(g,h,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||m(g,h)}}e.serializeWebviewOptions=i;function r(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(h=>R.URI.from(h))}}function m(g,h){return[...(h?.getWorkspaceFolders()||[]).map(O=>O.uri),g.extensionLocation]}}),define(De[285],Ce([1,0,21,68,6,18,24,2,13,82,76,5,7]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=b(this.document.uri)+this.a++;return(0,P.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class C{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,a){const l=this.b(o,s.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const E=new I(s,a);return this.a.set(l,E),E}delete(o,s){const a=this.b(o,s.uri);this.a.delete(a)}b(o,s){return`${o}@@@${s}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class n{constructor(){this.a=new Map}addTextProvider(o,s,a){return this.b(0,o,s,a)}addCustomProvider(o,s,a){return this.b(1,o,s,a)}get(o){return this.a.get(o)}b(o,s,a,l){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:a,provider:l}),new S.Disposable(()=>this.a.delete(s))}}class d{constructor(o,s,a,l,E){this.d=s,this.f=a,this.g=l,this.h=E,this.b=new n,this.c=new C,this.a=o.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,a,l){const E=new u.DisposableStore;return v(a)?(E.add(this.b.addTextProvider(s,o,a)),this.a.$registerTextEditorProvider((0,p.toExtensionData)(o),s,l.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,p.shouldSerializeBuffersForPostMessage)(o))):(E.add(this.b.addCustomProvider(s,o,a)),f(a)&&E.add(a.onDidChangeCustomDocument(i=>{const r=this.i(s,i.document.uri);if(D(i)){const m=r.addEdit(i);this.a.$onDidEdit(i.document.uri,s,m,i.label)}else this.a.$onContentChange(i.document.uri,s)})),this.a.$registerCustomEditorProvider((0,p.toExtensionData)(o),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,p.shouldSerializeBuffersForPostMessage)(o))),S.Disposable.from(E,new S.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,a,l,E){const i=this.b.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${s}'`);const r=k.URI.revive(o),m=await i.provider.openCustomDocument(r,{backupId:a,untitledDocumentData:l?.buffer},E);let g;return f(i.provider)&&this.f&&(g=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(s,m,g),{editable:f(i.provider)}}async $disposeCustomDocument(o,s){const a=this.b.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=k.URI.revive(o),{document:E}=this.i(s,l);this.c.delete(s,E),E.dispose()}async $resolveCustomEditor(o,s,a,l,E,i){const r=this.b.get(a);if(!r)throw new Error(`No provider found for '${a}'`);const m=y.ViewColumn.to(E),g=this.g.createNewWebview(s,l.contentOptions,r.extension),h=this.h.createNewWebviewPanel(s,a,l.title,m,l.options,g,!0),O=k.URI.revive(o);switch(r.type){case 1:{const{document:$}=this.i(a,O);return r.provider.resolveCustomEditor($,h,i)}case 0:{const $=this.d.getDocument(O);return r.provider.resolveCustomTextEditor($,h,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,a){this.i(s,o).disposeEdits(a)}async $onMoveCustomEditor(o,s,a){const l=this.b.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const E=this.h.getWebviewPanel(o);if(!E)throw new Error("No webview found");const i=k.URI.revive(s),r=this.d.getDocument(i);await l.provider.moveCustomTextEditor(r,E,c.CancellationToken.None)}async $undo(o,s,a,l){return this.i(s,o).undo(a,l)}async $redo(o,s,a,l){return this.i(s,o).redo(a,l)}async $revert(o,s,a){const l=this.i(s,o);await this.j(s).revertCustomDocument(l.document,a),l.disposeBackup()}async $onSave(o,s,a){const l=this.i(s,o);await this.j(s).saveCustomDocument(l.document,a),l.disposeBackup()}async $onSaveAs(o,s,a,l){const E=this.i(s,o);return this.j(s).saveCustomDocumentAs(E.document,k.URI.revive(a),l)}async $backup(o,s,a){const l=this.i(s,o),i=await this.j(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},a);return l.updateBackup(i),i.id}i(o,s){const a=this.c.get(o,k.URI.revive(s));if(!a)throw new Error("No custom document found");return a}j(o){const a=this.b.get(o)?.provider;if(!a||!f(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=d;function f(t){return!!t.onDidChangeCustomDocument}function v(t){return typeof t.resolveCustomTextEditor=="function"}function D(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function b(t){const o=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,A.hash)(o)+""}});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[286],Ce([1,0,3,6,2,30,13,82,5,7]),function(re,e,c,A,u,R,P,k,y,p){"use strict";var L,T,S,I,C,w,n,d,f,v,D,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(E,i,r,m){super(),L.set(this,void 0),T.set(this,void 0),S.set(this,void 0),I.set(this,void 0),C.set(this,void 0),w.set(this,void 0),n.set(this,void 0),d.set(this,void 0),f.set(this,!0),v.set(this,void 0),D.set(this,!1),b.set(this,this.D(new c.Emitter)),this.onDidDispose=Me(this,b,"f").event,t.set(this,this.D(new c.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,_e(this,L,E,"f"),_e(this,T,i,"f"),_e(this,I,r,"f"),_e(this,S,m.viewType,"f"),_e(this,C,m.panelOptions,"f"),_e(this,d,m.viewColumn,"f"),_e(this,w,m.title,"f"),_e(this,v,m.active,"f")}dispose(){Me(this,D,"f")||(_e(this,D,!0,"f"),Me(this,b,"f").fire(),Me(this,T,"f").$disposeWebview(Me(this,L,"f")),Me(this,I,"f").dispose(),super.dispose())}get webview(){return this.c(),Me(this,I,"f")}get viewType(){return this.c(),Me(this,S,"f")}get title(){return this.c(),Me(this,w,"f")}set title(E){this.c(),Me(this,w,"f")!==E&&(_e(this,w,E,"f"),Me(this,T,"f").$setTitle(Me(this,L,"f"),E))}get iconPath(){return this.c(),Me(this,n,"f")}set iconPath(E){this.c(),Me(this,n,"f")!==E&&(_e(this,n,E,"f"),Me(this,T,"f").$setIconPath(Me(this,L,"f"),u.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return Me(this,C,"f")}get viewColumn(){if(this.c(),!(typeof Me(this,d,"f")=="number"&&Me(this,d,"f")<0))return Me(this,d,"f")}get active(){return this.c(),Me(this,v,"f")}get visible(){return this.c(),Me(this,f,"f")}_updateViewState(E){Me(this,D,"f")||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(_e(this,v,E.active,"f"),_e(this,f,E.visible,"f"),_e(this,d,E.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(E,i){this.c(),Me(this,T,"f").$reveal(Me(this,L,"f"),{viewColumn:typeof E>"u"?void 0:P.ViewColumn.from(E),preserveFocus:!!i})}c(){if(Me(this,D,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,S=new WeakMap,I=new WeakMap,C=new WeakMap,w=new WeakMap,n=new WeakMap,d=new WeakMap,f=new WeakMap,v=new WeakMap,D=new WeakMap,b=new WeakMap,t=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(E,i,r){this.g=i,this.h=r,this.e=new Map,this.f=new Map,this.d=E.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(E,i,r,m,g={}){const h=typeof m=="object"?m.viewColumn:m,O={viewColumn:P.ViewColumn.from(h),preserveFocus:typeof m=="object"&&!!m.preserveFocus},$=(0,k.shouldSerializeBuffersForPostMessage)(E),x=s.c();this.d.$createWebviewPanel((0,k.toExtensionData)(E),x,i,{title:r,panelOptions:a(g),webviewOptions:(0,k.serializeWebviewOptions)(E,this.h,g),serializeBuffersForPostMessage:$},O);const Y=this.g.createNewWebview(x,g,E);return this.createNewWebviewPanel(x,i,r,h,g,Y,!0)}$onDidChangeWebviewPanelViewStates(E){const i=Object.keys(E);i.sort((r,m)=>{const g=E[r],h=E[m];return g.active?1:h.active?-1:+g.visible-+h.visible});for(const r of i){const m=this.getWebviewPanel(r);if(!m)continue;const g=E[r];m._updateViewState({active:g.active,visible:g.visible,viewColumn:P.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this.e.delete(E),this.g.deleteWebview(E)}registerWebviewPanelSerializer(E,i,r){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:r,extension:E}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(E)}),new p.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(E,i,r,m){const g=this.f.get(i);if(!g)throw new Error(`No serializer found for '${i}'`);const{serializer:h,extension:O}=g,$=this.g.createNewWebview(E,r.webviewOptions,O),x=this.createNewWebviewPanel(E,i,r.title,m,r.panelOptions,$,r.active);await h.deserializeWebviewPanel(x,r.state)}createNewWebviewPanel(E,i,r,m,g,h,O){const $=new o(E,this.d,h,{viewType:i,title:r,viewColumn:m,panelOptions:g,active:O});return this.e.set(E,$),$}getWebviewPanel(E){return this.e.get(E)}}e.ExtHostWebviewPanels=s;function a(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[287],Ce([1,0,3,6,82,13,5,7]),function(re,e,c,A,u,R,P,k){"use strict";var y,p,L,T,S,I,C,w,n,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends A.Disposable{constructor(t,o,s,a,l,E){super(),y.set(this,void 0),p.set(this,void 0),L.set(this,void 0),T.set(this,void 0),S.set(this,!1),I.set(this,void 0),C.set(this,void 0),w.set(this,void 0),n.set(this,void 0),d.set(this,this.D(new c.Emitter)),this.onDidChangeVisibility=Me(this,d,"f").event,f.set(this,this.D(new c.Emitter)),this.onDidDispose=Me(this,f,"f").event,_e(this,L,s,"f"),_e(this,C,a,"f"),_e(this,y,t,"f"),_e(this,p,o,"f"),_e(this,T,l,"f"),_e(this,I,E,"f")}dispose(){Me(this,S,"f")||(_e(this,S,!0,"f"),Me(this,f,"f").fire(),Me(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Me(this,C,"f")}set title(t){this.a(),Me(this,C,"f")!==t&&(_e(this,C,t,"f"),Me(this,p,"f").$setWebviewViewTitle(Me(this,y,"f"),t))}get description(){return this.a(),Me(this,w,"f")}set description(t){this.a(),Me(this,w,"f")!==t&&(_e(this,w,t,"f"),Me(this,p,"f").$setWebviewViewDescription(Me(this,y,"f"),t))}get visible(){return Me(this,I,"f")}get webview(){return Me(this,T,"f")}get viewType(){return Me(this,L,"f")}_setVisible(t){t===Me(this,I,"f")||Me(this,S,"f")||(_e(this,I,t,"f"),Me(this,d,"f").fire())}get badge(){return this.a(),Me(this,n,"f")}set badge(t){this.a(),!(t?.value===Me(this,n,"f")?.value&&t?.tooltip===Me(this,n,"f")?.tooltip)&&(_e(this,n,R.ViewBadge.from(t),"f"),Me(this,p,"f").$setWebviewViewBadge(Me(this,y,"f"),t))}show(t){this.a(),Me(this,p,"f").$show(Me(this,y,"f"),!!t)}a(){if(Me(this,S,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,p=new WeakMap,L=new WeakMap,T=new WeakMap,S=new WeakMap,I=new WeakMap,C=new WeakMap,w=new WeakMap,n=new WeakMap,d=new WeakMap,f=new WeakMap;class D{constructor(t,o){this.d=o,this.b=new Map,this.c=new Map,this.a=t.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,o,s,a){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:t}),this.a.$registerWebviewViewProvider((0,u.toExtensionData)(t),o,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(t)}),new k.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(t,o,s,a,l){const E=this.b.get(o);if(!E)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:r}=E,m=this.d.createNewWebview(t,{},r),g=new v(t,this.a,o,s,m,!0);this.c.set(t,g),await i.resolveWebviewView(g,{state:a},l)}async $onDidChangeWebviewViewVisibility(t,o){this.e(t)._setVisible(o)}async $disposeWebviewView(t){const o=this.e(t);this.c.delete(t),o.dispose(),this.d.deleteWebview(t)}e(t){const o=this.c.get(t);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=D}),define(De[142],Ce([1,0,3,5,2,18,8,4,20]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let p=class dn{get state(){return this.d}constructor(T){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=dn.a,this.b=T.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,S){let I;if(typeof T=="string"){I=T;try{T=u.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,P.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,I,S)}async asExternalUri(T,S){if((0,P.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this.b.$asExternalUri(T,S);return u.URI.from(I)}};p.a={focused:!0},p=Ve([We(0,y.IExtHostRpcService)],p),e.ExtHostWindow=p,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(De[288],Ce([1,0,258,26,20]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let P=class extends c.AbstractExtHostConsoleForwarder{constructor(y,p){super(y,p),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,p,L){const T=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,T.write(`
START_NATIVE_LOG
`),p.apply(console,L),T.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,p){const L=process[y],T=L.write;let S="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(I,C,w)=>{if(!this.g){S+=I.toString(C);const n=S.length>R?S.length:S.lastIndexOf(`
`);n!==-1&&(console[p](S.slice(0,n)),S=S.slice(n+1))}T.call(L,I,C,w)}})}};P=Ve([We(0,u.IExtHostRpcService),We(1,A.IExtHostInitDataService)],P),e.ExtHostConsoleForwarder=P}),define(De[289],Ce([1,0,12,72,30,40,6,5,2,20]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(S,I){super();const C=S.getProxy(k.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async w=>{const n=y.URI.file((0,c.join)((0,A.tmpdir)(),(0,u.generateUuid)()));return await C.$download(w,n),n})}};L=Ve([We(0,p.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(De[290],Ce([1,0,141,18,210,30]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends c.ExtHostLoggerService{m(y,p,L){return y.scheme===A.Schemas.file?new u.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,p):super.m(y,p,L)}registerLogger(y){super.registerLogger(y),this.n.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.n.$deregisterLogger(y)}}e.ExtHostLoggerService=P}),define(De[291],Ce([1,0,71,12,2,81,6,18,19,29]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const o=await super.g(t);if(o.scheme!==k.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let a=0;do{let l;a===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${a}`:`${s}-${a}`,await T(l);const E=A.join(l,"vscode.lock"),i=await w(this.d,E,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),u.URI.file(l);a++}while(a<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(b){try{await p.Promises.stat(b);return}catch{}try{await p.Promises.mkdir(b,{recursive:!0})}catch{}}const S=1e3,I=10*60*1e3;class C extends P.Disposable{constructor(t,o){super(),this.b=t,this.c=o,this.a=this.D(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await n(t,o);(!s||s.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await p.Promises.utimes(o,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${o}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await p.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function w(b,t,o){try{const a={pid:process.pid,willReleaseAt:0};await p.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){b.error(a)}const s=await n(b,t);return!s||s.pid!==process.pid?o?(b.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),v(b,t)):(b.info(`Lock '${t}': Lock acquired.`),new C(b,t))}async function n(b,t){let o;try{o=await p.Promises.readFile(t)}catch(s){return b.error(s),null}try{return JSON.parse(String(o))}catch(s){return b.error(s),null}}async function d(b,t){let o;try{o=await p.Promises.stat(t)}catch(s){return b.error(s),0}return o.mtime.getTime()}function f(b){try{return process.kill(b,0),!0}catch{return!1}}async function v(b,t){const o=await n(b,t);if(!o)return b.info(`Lock '${t}': Could not read pid of lock holder.`),D(b,t);if(o.willReleaseAt){let i=o.willReleaseAt-Date.now();if(i<5e3){for(i>0?b.info(`Lock '${t}': The lockfile is scheduled to be released in ${i} ms.`):b.info(`Lock '${t}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,y.timeout)(Math.min(100,i)),await d(b,t)===0)return D(b,t);i=o.willReleaseAt-Date.now()}return D(b,t)}}if(!f(o.pid))return b.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),D(b,t);const s=await d(b,t),a=Date.now()-s;if(a<=I)return b.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;b.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const l=await d(b,t),E=Date.now()-l;return E<=I?(b.info(`Lock '${t}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(b.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),D(b,t))}async function D(b,t){b.info(`Lock '${t}': Deleting a stale lock.`);try{await p.Promises.unlink(t)}catch{}return w(b,t,!0)}}),define(De[292],Ce([1,0,30,20,41]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends u.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,y,p){return this.createTerminalFromOptions({name:k,shellPath:y,shellArgs:p})}createTerminalFromOptions(k,y){const p=new u.ExtHostTerminal(this.a,(0,c.generateUuid)(),k,k.name);return this.f.push(p),p.create(k,this.L(k,y)),p.value}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(De[293],Ce([1,0,5,20,191,6,26,2,47,24,29,7,11,55,3,129,103,16]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class f extends w.DisposableTunnel{}function v(i){const r=i.trim().split(`
`),m=[];return r.forEach(h=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(h);O&&O.length>=3&&m.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),m.reduce((h,O)=>(h[O.socket]=O,h),{})}e.getSockets=v;function D(...i){const r=[].concat(...i.map(t));return[...new Map(r.filter(m=>m.st==="0A").map(m=>{const g=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:b(g[0]),port:parseInt(g[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=D;function b(i){let r="";if(i.length===8)for(let m=i.length-2;m>=0;m-=2)r+=parseInt(i.substr(m,2),16),m!==0&&(r+=".");else for(let m=i.length-4;m>=0;m-=4)r+=parseInt(i.substr(m,4),16).toString(16),m!==0&&(r+=":");return r}function t(i){const r=i.trim().split(`
`),m=r.shift().trim().split(/\s+/).filter(h=>h!=="rx_queue"&&h!=="tm->when");return r.map(h=>h.trim().split(/\s+/).reduce((O,$,x)=>(O[m[x]||x]=$,O),{}))}e.loadConnectionTable=t;function o(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function s(i){const r=i.trim().split(`
`),m=[];return r.forEach(g=>{const h=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(g);h&&h.length>=4&&m.push({pid:parseInt(h[1],10),ppid:parseInt(h[2]),cmd:h[3]})}),m}e.getRootProcesses=s;async function a(i,r,m){const g=m.reduce((O,$)=>(O[$.pid]=$,O),{}),h=[];return i.forEach(({socket:O,ip:$,port:x})=>{const Y=r[O]?r[O].pid:void 0,G=Y?g[Y]?.cmd:void 0;Y&&G&&!o(G)&&h.push({host:$,port:x,detail:G,pid:Y})}),h}e.findPorts=a;function l(i,r,m){const g=new Map,h=s(r);for(const O of i){const $=m.get(O.port);if($){g.set(O.port,$);continue}const x=h.find(Y=>Y.cmd.includes(`${O.port}`));if(x){let Y=x,G;do G=h.find(M=>M.ppid===Y.pid),G&&(Y=G);while(G);g.set(O.port,{host:O.ip,port:O.port,pid:Y.pid,detail:Y.cmd,ppid:Y.ppid})}else g.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return g}e.tryFindRootPorts=l;let E=class extends R.Disposable{constructor(r,m,g){super(),this.n=g,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new C.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=r.getProxy(c.MainContext.MainThreadTunnelService),S.isLinux&&m.remote.isRemote&&m.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(r,m){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const g=await this.a.$openTunnel(m,r.displayName);if(g){const h=new f(g.remoteAddress,g.localAddress,()=>this.a.$closeTunnel(g.remoteAddress));return this.D(h),h}}async getTunnels(){return this.a.$getTunnels()}p(r){return Math.max(r*20,2e3)}q(){return this.k++}registerPortsAttributesProvider(r,m){const g=this.q();return this.l.set(g,{selector:r,provider:m}),this.a.$registerPortsAttributesProvider(r,g),new T.Disposable(()=>{this.l.delete(g),this.a.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(r,m,g,h,O){const $=[];for(const Y of r){const G=this.l.get(Y);if(!G)return[];$.push(...await Promise.all(m.map(async M=>G.provider.providePortAttributes(M,g,h,O))))}const x=$.filter(Y=>!!Y);return x.length>0?x.map(Y=>({autoForwardAction:Y.autoForwardAction,port:Y.port})):[]}async $registerCandidateFinder(r){if(r&&this.h)return;this.h=r;const m=new n.MovingAverage;let g;for(;this.h;){const h=new Date().getTime(),O=(await this.findCandidatePorts()).filter(x=>(0,w.isLocalhost)(x.host)||(0,w.isAllInterfaces)(x.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(x=>x.port).join(", ")}`);const $=new Date().getTime()-h;m.update($),(!g||JSON.stringify(g)!==JSON.stringify(O))&&(g=O,await this.a.$onFoundNewCandidates(g)),await new Promise(x=>setTimeout(()=>x(),this.p(m.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.c=r.showCandidatePort,this.a.$setCandidateFilter()),r.tunnelFactory){this.b=r.tunnelFactory;let m=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const g=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(g)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(r,m){if(this.f.has(r.host)){const g=this.f.get(r.host);g.has(r.port)&&(m&&g.get(r.port).disposeListener.dispose(),await g.get(r.port).tunnel.dispose(),g.delete(r.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(r,m){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this.b(r,m);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const h=await g;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(r.remoteAddress.host)||this.f.set(r.remoteAddress.host,new Map);const O=this.D(h.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(h.remoteAddress))));return this.f.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:h,disposeListener:O}),I.TunnelDtoConverter.fromApiTunnel(h)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const m=await Promise.all(r.map(h=>this.c(h.host,h.port,h.detail??""))),g=r.filter((h,O)=>m[O]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(h=>h.port).join(", ")} to ${g.map(h=>h.port).join(", ")}`),g}async findCandidatePorts(){let r="",m="";try{r=await L.Promises.readFile("/proc/net/tcp","utf8"),m=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const g=D(r,m),h=await new Promise(U=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,he,ie)=>{U(he)})}),O=v(h),$=await L.Promises.readdir("/proc"),x=[];for(const U of $)try{const j=Number(U),he=p.joinPath(k.URI.file("/proc"),U);if((await L.Promises.stat(he.fsPath)).isDirectory()&&!isNaN(j)){const V=await L.Promises.readlink(p.joinPath(he,"cwd").fsPath),J=await L.Promises.readFile(p.joinPath(he,"cmdline").fsPath,"utf8");x.push({pid:j,cwd:V,cmd:J})}}catch{}const Y=[],G=g.filter(U=>{const j=O[U.socket];return j||Y.push(U),j}),M=a(G,O,x);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Y.length}`),Y.length>0){const U=await new Promise(j=>{(0,y.exec)("ps -F -A -l | grep root",(he,ie,V)=>{j(ie)})});this.j=l(Y,U,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(j=>j.port).join(", ")}`)}return M.then(U=>B?U.concat(B):U)}};E=Ve([We(0,A.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,d.ILogService)],E),e.ExtHostTunnelService=E}),define(De[294],Ce([1,0,19,22,21,9,3,6,115,252,58]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(g,h){try{return JSON.stringify(g,h)}catch{return"null"}}const I="$$ref$$",C={[I]:-1};class w{constructor(h,O){this.jsonString=h,this.referencedBuffers=O}}function n(g,h=null,O=!1){const $=[];return{jsonString:(O?S:JSON.stringify)(g,(Y,G)=>{if(typeof G>"u")return C;if(typeof G=="object"){if(G instanceof A.VSBuffer){const M=$.push(G)-1;return{[I]:M}}if(h)return h(Y,G)}return G}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=n;function d(g,h,O){return JSON.parse(g,($,x)=>{if(x){const Y=x[I];if(typeof Y=="number")return h[Y];if(O&&x.$mid===1)return O.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=d;function f(g,h){return JSON.stringify(g,h)}function v(g){return g?(h,O)=>O&&O.$mid===1?g.transformOutgoing(O):O:null}var D;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class a extends k.Disposable{constructor(h,O=null,$=null){super(),this[T]=!0,this.b=this.D(new P.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=h,this.f=O,this.g=$,this.h=v(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,Y=L.ProxyIdentifier.count;x<Y;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.q={},this.s=0,this.t=0,this.u=0,this.v=this.D(new c.RunOnceScheduler(()=>this.z(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.q).forEach(h=>{this.q[h].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}w(h){this.t===0&&(this.u=Date.now()+a.a),this.t++,this.v.isScheduled()||this.v.schedule()}y(h){this.u=Date.now()+a.a,this.t--,this.t===0&&this.v.cancel(),this.C(0)}z(){this.t!==0&&(Date.now()>this.u?this.C(1):this.v.schedule())}C(h){this.s!==h&&(this.s=h,this.b.fire(this.s))}get responsiveState(){return this.s}transformIncomingURIs(h){return this.g?(0,y.transformIncomingURIs)(h,this.g):h}getProxy(h){const{nid:O,sid:$}=h;return this.l[O]||(this.l[O]=this.F(O,$)),this.l[O]}F(h,O){const $={get:(x,Y)=>(typeof Y=="string"&&!x[Y]&&Y.charCodeAt(0)===36&&(x[Y]=(...G)=>this.O(h,Y,G)),Y===s?O:x[Y])};return new Proxy(Object.create(null),$)}set(h,O){return this.k[h.nid]=O,O}assertRegistered(h){for(let O=0,$=h.length;O<$;O++){const x=h[O];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(h){if(this.j)return;const O=h.byteLength,$=l.read(h,0),x=$.readUInt8(),Y=$.readUInt32();switch(x){case 1:case 2:{let{rpcId:G,method:M,args:B}=i.deserializeRequestJSONArgs($);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(O,Y,G,M,B,x===2);break}case 3:case 4:{let{rpcId:G,method:M,args:B}=i.deserializeRequestMixedArgs($);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(O,Y,G,M,B,x===4);break}case 5:{this.f?.logIncoming(O,Y,0,"ack"),this.y(Y);break}case 6:{this.I(O,Y);break}case 7:{this.J(O,Y,void 0);break}case 9:{let G=i.deserializeReplyOKJSON($);this.g&&(G=(0,y.transformIncomingURIs)(G,this.g)),this.J(O,Y,G);break}case 10:{const G=i.deserializeReplyOKJSONWithBuffers($,this.g);this.J(O,Y,G);break}case 8:{const G=i.deserializeReplyOKVSBuffer($);this.J(O,Y,G);break}case 11:{let G=i.deserializeReplyErrError($);this.g&&(G=(0,y.transformIncomingURIs)(G,this.g)),this.L(O,Y,G);break}case 12:{this.L(O,Y,void 0);break}default:console.error("received unexpected message"),console.error(h)}}H(h,O,$,x,Y,G){this.f?.logIncoming(h,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)($)}.${x}(`,Y);const M=String(O);let B,U;if(G){const he=new u.CancellationTokenSource;Y.push(he.token),B=this.M($,x,Y),U=()=>he.cancel()}else B=this.M($,x,Y),U=t;this.p[M]=U;const j=i.serializeAcknowledged(O);this.f?.logOutgoing(j.byteLength,O,1,"ack"),this.c.send(j),B.then(he=>{delete this.p[M];const ie=i.serializeReplyOK(O,he,this.h);this.f?.logOutgoing(ie.byteLength,O,1,"reply:",he),this.c.send(ie)},he=>{delete this.p[M];const ie=i.serializeReplyErr(O,he);this.f?.logOutgoing(ie.byteLength,O,1,"replyErr:",he),this.c.send(ie)})}I(h,O){this.f?.logIncoming(h,O,1,"receiveCancel");const $=String(O);this.p[$]?.()}J(h,O,$){this.f?.logIncoming(h,O,0,"receiveReply:",$);const x=String(O);if(!this.q.hasOwnProperty(x))return;const Y=this.q[x];delete this.q[x],Y.resolveOk($)}L(h,O,$){this.f?.logIncoming(h,O,0,"receiveReplyErr:",$);const x=String(O);if(!this.q.hasOwnProperty(x))return;const Y=this.q[x];delete this.q[x];let G;$&&($.$isError?(G=new Error,G.name=$.name,G.message=$.message,G.stack=$.stack):G=$),Y.resolveErr(G)}M(h,O,$){try{return Promise.resolve(this.N(h,O,$))}catch(x){return Promise.reject(x)}}N(h,O,$){const x=this.k[h];if(!x)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(h));const Y=x[O];if(typeof Y!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(h));return Y.apply(x,$)}O(h,O,$){if(this.j)return new p.CanceledLazyPromise;let x=null;if($.length>0&&u.CancellationToken.isCancellationToken($[$.length-1])&&(x=$.pop()),x&&x.isCancellationRequested)return Promise.reject(R.canceled());const Y=i.serializeRequestArguments($,this.h),G=++this.m,M=String(G),B=new p.LazyPromise;x&&x.onCancellationRequested(()=>{const j=i.serializeCancel(G);this.f?.logOutgoing(j.byteLength,G,0,"cancel"),this.c.send(i.serializeCancel(G))}),this.q[M]=B,this.w(G);const U=i.serializeRequest(G,h,O,Y,!!x);return this.f?.logOutgoing(U.byteLength,G,0,`request: ${(0,L.getStringIdentifierForProxy)(h)}.${O}(`,$),this.c.send(U),B}}T=o,a.a=3*1e3,e.RPCProtocol=a;class l{static alloc(h,O,$){const x=new l(A.VSBuffer.alloc($+1+4),0);return x.writeUInt8(h),x.writeUInt32(O),x}static read(h,O){return new l(h,O)}get buffer(){return this.a}constructor(h,O){this.a=h,this.b=O}static sizeUInt8(){return 1}writeUInt8(h){this.a.writeUInt8(h,this.b),this.b+=1}readUInt8(){const h=this.a.readUInt8(this.b);return this.b+=1,h}writeUInt32(h){this.a.writeUInt32BE(h,this.b),this.b+=4}readUInt32(){const h=this.a.readUInt32BE(this.b);return this.b+=4,h}static sizeShortString(h){return 1+h.byteLength}writeShortString(h){this.a.writeUInt8(h.byteLength,this.b),this.b+=1,this.a.set(h,this.b),this.b+=h.byteLength}readShortString(){const h=this.a.readUInt8(this.b);this.b+=1;const $=this.a.slice(this.b,this.b+h).toString();return this.b+=h,$}static sizeLongString(h){return 4+h.byteLength}writeLongString(h){this.a.writeUInt32BE(h.byteLength,this.b),this.b+=4,this.a.set(h,this.b),this.b+=h.byteLength}readLongString(){const h=this.a.readUInt32BE(this.b);this.b+=4;const $=this.a.slice(this.b,this.b+h).toString();return this.b+=h,$}writeBuffer(h){this.a.writeUInt32BE(h.byteLength,this.b),this.b+=4,this.a.set(h,this.b),this.b+=h.byteLength}static sizeVSBuffer(h){return 4+h.byteLength}writeVSBuffer(h){this.a.writeUInt32BE(h.byteLength,this.b),this.b+=4,this.a.set(h,this.b),this.b+=h.byteLength}readVSBuffer(){const h=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+h);return this.b+=h,O}static sizeMixedArray(h){let O=0;O+=1;for(let $=0,x=h.length;$<x;$++){const Y=h[$];switch(O+=1,Y.type){case 1:O+=this.sizeLongString(Y.value);break;case 2:O+=this.sizeVSBuffer(Y.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(Y.value);for(let G=0;G<Y.buffers.length;++G)O+=this.sizeVSBuffer(Y.buffers[G]);break;case 4:break}}return O}writeMixedArray(h){this.a.writeUInt8(h.length,this.b),this.b+=1;for(let O=0,$=h.length;O<$;O++){const x=h[O];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let Y=0;Y<x.buffers.length;++Y)this.writeBuffer(x.buffers[Y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const h=this.a.readUInt8(this.b);this.b+=1;const O=new Array(h);for(let $=0;$<h;$++)switch(this.readUInt8()){case 1:O[$]=this.readLongString();break;case 2:O[$]=this.readVSBuffer();break;case 3:{const Y=this.readUInt32(),G=this.readLongString(),M=[];for(let B=0;B<Y;++B)M.push(this.readVSBuffer());O[$]=new L.SerializableObjectWithBuffers(d(G,M,null));break}case 4:O[$]=void 0;break}return O}}l.sizeUInt32=4;var E;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(E||(E={}));class i{static a(h){for(let O=0,$=h.length;O<$;O++)if(h[O]instanceof A.VSBuffer||h[O]instanceof L.SerializableObjectWithBuffers||typeof h[O]>"u")return!0;return!1}static serializeRequestArguments(h,O){if(this.a(h)){const $=[];for(let x=0,Y=h.length;x<Y;x++){const G=h[x];if(G instanceof A.VSBuffer)$[x]={type:2,value:G};else if(typeof G>"u")$[x]={type:4};else if(G instanceof L.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=n(G.value,O);$[x]={type:3,value:A.VSBuffer.fromString(M),buffers:B}}else $[x]={type:1,value:A.VSBuffer.fromString(f(G,O))}}return{type:1,args:$}}return{type:0,args:f(h,O)}}static serializeRequest(h,O,$,x,Y){switch(x.type){case 0:return this.b(h,O,$,x.args,Y);case 1:return this.c(h,O,$,x.args,Y)}}static b(h,O,$,x,Y){const G=A.VSBuffer.fromString($),M=A.VSBuffer.fromString(x);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(G),B+=l.sizeLongString(M);const U=l.alloc(Y?2:1,h,B);return U.writeUInt8(O),U.writeShortString(G),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(h){const O=h.readUInt8(),$=h.readShortString(),x=h.readLongString();return{rpcId:O,method:$,args:JSON.parse(x)}}static c(h,O,$,x,Y){const G=A.VSBuffer.fromString($);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString(G),M+=l.sizeMixedArray(x);const B=l.alloc(Y?4:3,h,M);return B.writeUInt8(O),B.writeShortString(G),B.writeMixedArray(x),B.buffer}static deserializeRequestMixedArgs(h){const O=h.readUInt8(),$=h.readShortString(),x=h.readMixedArray(),Y=new Array(x.length);for(let G=0,M=x.length;G<M;G++){const B=x[G];typeof B=="string"?Y[G]=JSON.parse(B):Y[G]=B}return{rpcId:O,method:$,args:Y}}static serializeAcknowledged(h){return l.alloc(5,h,0).buffer}static serializeCancel(h){return l.alloc(6,h,0).buffer}static serializeReplyOK(h,O,$){if(typeof O>"u")return this.d(h);if(O instanceof A.VSBuffer)return this.e(h,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:Y}=n(O.value,$,!0);return this.g(h,x,Y)}else return this.f(h,S(O,$))}static d(h){return l.alloc(7,h,0).buffer}static e(h,O){let $=0;$+=l.sizeVSBuffer(O);const x=l.alloc(8,h,$);return x.writeVSBuffer(O),x.buffer}static deserializeReplyOKVSBuffer(h){return h.readVSBuffer()}static f(h,O){const $=A.VSBuffer.fromString(O);let x=0;x+=l.sizeLongString($);const Y=l.alloc(9,h,x);return Y.writeLongString($),Y.buffer}static g(h,O,$){const x=A.VSBuffer.fromString(O);let Y=0;Y+=l.sizeUInt32,Y+=l.sizeLongString(x);for(const M of $)Y+=l.sizeVSBuffer(M);const G=l.alloc(10,h,Y);G.writeUInt32($.length),G.writeLongString(x);for(const M of $)G.writeBuffer(M);return G.buffer}static deserializeReplyOKJSON(h){const O=h.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(h,O){const $=h.readUInt32(),x=h.readLongString(),Y=[];for(let G=0;G<$;++G)Y.push(h.readVSBuffer());return new L.SerializableObjectWithBuffers(d(x,Y,O))}static serializeReplyErr(h,O){const $=O?S(R.transformErrorForSerialization(O),null):void 0;if(typeof $!="string")return this.h(h);const x=A.VSBuffer.fromString($);let Y=0;Y+=l.sizeLongString(x);const G=l.alloc(11,h,Y);return G.writeLongString(x),G.buffer}static deserializeReplyErrError(h){const O=h.readLongString();return JSON.parse(O)}static h(h){return l.alloc(12,h,0).buffer}}var r;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var m;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(m||(m={}))}),define(De[295],Ce([1,0,3,39,44,4]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var P;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class k{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(p){this.a.has(p.id)||(this.a.set(p.id,p),this.b.fire(p.id))}getChannels(){const p=[];return this.a.forEach(L=>p.push(L)),p}getChannel(p){return this.a.get(p)}removeChannel(p){this.a.delete(p),this.c.fire(p)}}A.Registry.add(e.Extensions.OutputChannels,new k),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(De[143],Ce([1,0,5,4,20,25,16,295,80,26,49,160,22,10,45,3,6]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends P.AbstractMessageLogger{get disposed(){return this.l}constructor(b,t,o,s,a){super(),this.id=b,this.name=t,this.m=o,this.n=s,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.D(o.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,k.OutputChannelUpdateMode.Clear,b)}replace(b){const t=this.k;this.info(b),this.n.$update(this.id,k.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(b,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:t))}hide(){this.n.$close(this.id)}g(b,t){this.k+=S.VSBuffer.fromString(t).byteLength,(0,P.log)(this.m,b,t),this.visible&&(this.m.flush(),this.n.$update(this.id,k.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class f extends d{appendLine(b){this.append(b)}}let v=class{constructor(b,t,o,s,a,l){this.i=t,this.j=o,this.k=s,this.l=a,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[t,o]of this.g)o.visible=t===this.h}createOutputChannel(b,t,o){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,a=(0,I.isString)(t)?t:void 0;if((0,I.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const E=this.i.environment.extensionLogLevel?.find(([r])=>R.ExtensionIdentifier.equals(o.identifier,r))?.[1];E&&(l=(0,P.parseLogLevel)(E));const i=s?this.o(b,l,o):this.n(b,a,o);return i.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),s?this.r(b,l??this.m.getLevel(),i):this.q(b,i)}async n(b,t,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,a=this.k.extUri.joinPath(s,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(b,a,t,o.identifier.value);return new d(E,b,l,this.a,o)}async o(b,t,o){const s=await this.p(o),a=b.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(s,`${a}.log`),E=`${o.identifier.value}.${a}`,i=this.l.createLogger(l,{id:E,name:b,logLevel:t,extensionId:o.identifier.value});return new f(E,b,i,this.a,o)}p(b){let t=this.d.get(b.identifier.value);if(!t){const o=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return t}q(b,t){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return b},append(a){s(),t.then(l=>l.append(a))},appendLine(a){s(),t.then(l=>l.appendLine(a))},clear(){s(),t.then(a=>a.clear())},replace(a){s(),t.then(l=>l.replace(a))},show(a,l){s(),t.then(E=>E.show(a,l))},hide(){s(),t.then(a=>a.hide())},dispose(){o=!0,t.then(a=>a.dispose())}}}r(b,t,o){const s=new n.DisposableStore,a=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new w.Emitter);function E(i){t=i,l.fire(i)}return o.then(i=>{s.add(i),i.logLevel!==t&&E(i.logLevel),s.add(i.onDidChangeLogLevel(r=>E(r)))}),{...this.q(b,o),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(i,...r){a(),o.then(m=>m.trace(i,...r))},debug(i,...r){a(),o.then(m=>m.debug(i,...r))},info(i,...r){a(),o.then(m=>m.info(i,...r))},warn(i,...r){a(),o.then(m=>m.warn(i,...r))},error(i,...r){a(),o.then(m=>m.error(i,...r))},dispose(){s.dispose()}}}};v=Ve([We(0,u.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,P.ILoggerService),We(5,P.ILogService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(De[296],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(De[297],Ce([1,0,33,18,12,11,24,2,4,223,48,240,296]),function(re,e,c,A,u,R,P,k,y,p,L,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let I=class hn{constructor(w,n,d,f){this.d=w,this.e=n,this.f=d,this.g=f,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const v=await this.e.getEnvironment();return this.c=v?.userHome??w})()}hasValidBasename(w,n,d){return typeof n=="string"||typeof n>"u"?this.a.then(f=>this.h(w,f,n)):this.h(w,n,d)}h(w,n,d){return w.scheme===A.Schemas.file||w.scheme===A.Schemas.vscodeRemote?(0,c.isValidBasename)(d??(0,P.basename)(w),n===1):!0}get defaultUriScheme(){return hn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(w,n){if(w.remoteAuthority)return A.Schemas.vscodeRemote;const d=(0,p.getVirtualWorkspaceScheme)(n.getWorkspace());if(d)return d;const f=n.getWorkspace().folders[0];if(f)return f.uri.scheme;const v=n.getWorkspace().configuration;return v?v.scheme:A.Schemas.file}userHome(w){return w?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(w=>w===1?u.win32:u.posix)}async fileURI(w){let n="";if(await this.a===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const f=w.indexOf("/",2);f===-1?(n=w.substring(2),w="/"):(n=w.substring(2,f),w=w.substring(f)||"/")}return k.URI.from({scheme:A.Schemas.file,authority:n,path:w,query:"",fragment:""})}};I=Ve([We(1,S.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(De[83],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(P,k){this.line=P,this.character=k}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,k){return new c(0,0)}with(P){return new c(0,0)}}e.Position=c;class A{constructor(P,k,y,p){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(P,k),this.end=new c(y,p)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new A(0,0,0,0)}with(P){return new A(0,0,0,0)}}e.Range=A;var u;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(u=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[31],Ce([1,0,17,38,23,33,8,4,12,9,83,19]),function(re,e,c,A,u,R,P,k,y,p,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",I=" characters skipped \u27EB",C=(S.length+I.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var n;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(n=e.QueryType||(e.QueryType={}));function d(J){return!!J.preview}e.resultIsMatch=d;function f(J){return!!J.resource}e.isFileMatch=f;function v(J){return!!J.message}e.isProgressMessage=v;var D;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(D=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=b;class t{constructor(ne,ve,ue){this.ranges=ve;const ee=Array.isArray(ve)?ve:[ve];if(ue&&ue.matchLines===1&&o(ee)){ne=(0,P.getNLines)(ne,ue.matchLines);let N="",q=0,ae=0;const me=Math.floor(ue.charsPerLine/5),ke=[];for(const _ of ee){const le=Math.max(_.startColumn-me,0),de=_.startColumn+ue.charsPerLine;if(le>ae+me+C){const te=S+(le-ae)+I;N+=te+ne.slice(le,de),q+=le-(ae+te.length)}else N+=ne.slice(ae,de);ke.push(new a(0,_.startColumn-q,_.endColumn-q)),ae=de}this.preview={text:N,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const N=Array.isArray(ve)?ve[0].startLineNumber:ve.startLineNumber;this.preview={text:ne,matches:(0,c.mapArrayOrNot)(ve,q=>new s(q.startLineNumber-N,q.startColumn,q.endLineNumber-N,q.endColumn))}}}}e.TextSearchMatch=t;function o(J){const ne=J[0].startLineNumber;for(const ve of J)if(ve.startLineNumber!==ne||ve.endLineNumber!==ne)return!1;return!0}class s{constructor(ne,ve,ue,ee){this.startLineNumber=ne,this.startColumn=ve,this.endLineNumber=ue,this.endColumn=ee}}e.SearchRange=s;class a extends s{constructor(ne,ve,ue){super(ne,ve,ne,ue)}}e.OneLineRange=a;var l;(function(J){J.List="list",J.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var E;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(E=e.SearchSortOrder||(e.SearchSortOrder={}));function i(J,ne=!0){const ve=J&&J.files&&J.files.exclude,ue=ne&&J&&J.search&&J.search.exclude;if(!ve&&!ue)return;if(!ve||!ue)return ve||ue;let ee=Object.create(null);return ee=u.mixin(ee,u.deepClone(ve)),ee=u.mixin(ee,u.deepClone(ue),!0),ee}e.getExcludes=i;function r(J,ne){return J.excludePattern&&A.match(J.excludePattern,ne)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,ne)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ve=>{const ue=ve.folder.fsPath;if(R.isEqualOrParent(ne,ue)){const ee=y.relative(ue,ne);return!ve.includePattern||!!A.match(ve.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var m;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(ne,ve){super(ne),this.code=ve}}e.SearchError=g;function h(J){const ne=J.message;if((0,p.isCancellationError)(J))return new g(ne,m.canceled);try{const ve=JSON.parse(ne);return new g(ve.message,ve.code)}catch{return new g(ne,m.other)}}e.deserializeSearchError=h;function O(J){const ne={message:J.message,code:J.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=O;function $(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=$;function x(J){return J.type==="success"}e.isSerializedSearchSuccess=x;function Y(J){return!!J.path}e.isSerializedFileMatch=Y;function G(J,ne){const ve=J.searchPath?J.searchPath:J.relativePath;return(0,P.fuzzyContains)(ve,ne)}e.isFilePatternMatch=G;class M{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function B(J,ne){const ve={...J||{},...ne||{}};return Object.keys(ve).filter(ue=>{const ee=ve[ue];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=B;class U{constructor(ne,ve){this.c=null,this.a={...ne.excludePattern||{},...ve.excludePattern||{}},this.b=A.parse(this.a);let ue=ne.includePattern;ve.includePattern&&(ue?ue={...ue,...ve.includePattern}:ue=ve.includePattern),ue&&(this.c=A.parse(ue))}matchesExcludesSync(ne,ve,ue){return!!(this.b&&this.b(ne,ve,ue))}includedInQuerySync(ne,ve,ue){return!(this.b&&this.b(ne,ve,ue)||this.c&&!this.c(ne,ve,ue))}includedInQuery(ne,ve,ue){const ee=this.b(ne,ve,ue),N=()=>this.c?!!this.c(ne,ve,ue):!0;return(0,T.isThenable)(ee)?ee.then(q=>q?!1:N()):N()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=U;function j(J){for(const ne in J)if(typeof J[ne]!="boolean")return!0;return!1}function he(J){if(!J)return;let ne;return ve=>(ne||(ne=(J()||Promise.resolve([])).then(ue=>ue?V(ue):{})),ne.then(ue=>!!ue[ve]))}e.hasSiblingPromiseFn=he;function ie(J){if(!J)return;let ne;return ve=>{if(!ne){const ue=J();ne=ue?V(ue):{}}return!!ne[ve]}}e.hasSiblingFn=ie;function V(J){const ne={};for(const ve of J)ne[ve]=!0;return ne}}),define(De[34],Ce([1,0,17,19,21,3,6,69,18,103,24,8,10,2,189,4,16,211,48,49,26,20,13,7,56,31,5]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t,o,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function E(x,Y,G){return new L.ExtUri(M=>g(M,G)).isEqual(x,Y)}function i(x,Y,G){return E(x.uri,Y.uri,G)?0:(0,T.compare)(x.uri.toString(),Y.uri.toString())}function r(x,Y,G){return x.index!==Y.index?x.index<Y.index?-1:1:E(x.uri,Y.uri,G)?(0,T.compare)(x.name,Y.name):(0,T.compare)(x.uri.toString(),Y.uri.toString())}function m(x,Y,G,M){const B=x.slice(0).sort((j,he)=>G(j,he,M)),U=Y.slice(0).sort((j,he)=>G(j,he,M));return(0,c.delta)(B,U,(j,he)=>G(j,he,M))}function g(x,Y){const G=Y.getCapabilities(x.scheme);return!(G&&G&1024)}class h extends f.Workspace{static toExtHostWorkspace(Y,G,M,B){if(!Y)return{workspace:null,added:[],removed:[]};const{id:U,name:j,folders:he,configuration:ie,transient:V,isUntitled:J}=Y,ne=[],ve=G;G?he.forEach((q,ae)=>{const me=I.URI.revive(q.uri),ke=h.o(M||G,me,B);ke?(ke.name=q.name,ke.index=q.index,ne.push(ke)):ne.push({uri:me,name:q.name,index:ae})}):ne.push(...he.map(({uri:q,name:ae,index:me})=>({uri:I.URI.revive(q),name:ae,index:me}))),ne.sort((q,ae)=>q.index<ae.index?-1:1);const ue=new h(U,j,ne,!!V,ie?I.URI.revive(ie):null,!!J,q=>g(q,B)),{added:ee,removed:N}=m(ve?ve.workspaceFolders:[],ue.workspaceFolders,i,B);return{workspace:ue,added:ee,removed:N}}static o(Y,G,M){for(let B=0;B<Y.folders.length;B++){const U=Y.workspaceFolders[B];if(E(U.uri,G,M))return U}}constructor(Y,G,M,B,U,j,he){super(Y,M.map(ie=>new f.WorkspaceFolder(ie)),B,U,he),this.t=G,this.u=j,this.q=[],this.s=k.TernarySearchTree.forUris(he),M.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(Y,G){return G&&this.s.get(Y)&&(Y=(0,L.dirname)(Y)),this.s.findSubstr(Y)}resolveWorkspaceFolder(Y){return this.s.get(Y)}}let O=class{constructor(Y,G,M,B,U){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=B,this.s=M,this.t=U,this.j=new p.Counter,this.k=new A.Barrier,this.o=Y.getProxy(l.MainContext.MainThreadWorkspace),this.q=Y.getProxy(l.MainContext.MainThreadMessageService);const j=G.workspace;this.l=j?new h(j.id,j.name,[],!!j.transient,j.configuration?I.URI.revive(j.configuration):null,!!j.isUntitled,he=>g(he,M)):void 0}$initializeWorkspace(Y,G){this.v=G,this.$acceptWorkspaceData(Y),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?I.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(Y,G,M,...B){const U=[];if(Array.isArray(B)&&B.forEach(J=>{I.URI.isUri(J.uri)&&!U.some(ne=>E(ne.uri,J.uri,this.s))&&U.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.n||[G,M].some(J=>typeof J!="number"||J<0)||M===0&&U.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(G+M>j.length)return!1;const he=j.slice(0);he.splice(G,M,...U.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<he.length;J++){const ne=he[J];if(he.some((ve,ue)=>ue!==J&&E(ne.uri,ve.uri,this.s)))return!1}he.forEach((J,ne)=>J.index=ne);const{added:ie,removed:V}=m(j,he,r,this.s);if(ie.length===0&&V.length===0)return!1;if(this.o){const J=Y.displayName||Y.name;this.o.$updateWorkspaceFolders(J,G,M,U).then(void 0,ne=>{this.n=void 0;const ve={source:{identifier:Y.identifier,label:Y.displayName||Y.name}};this.q.$showMessage(d.Severity.Error,(0,C.localize)(0,null,J,ne.toString()),ve,[])})}return this.y(he),!0}getWorkspaceFolder(Y,G){if(!!this.x)return this.x.getWorkspaceFolder(Y,G)}async getWorkspaceFolder2(Y,G){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(Y,G)}async resolveWorkspaceFolder(Y){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(Y)}getPath(){if(!this.x)return;const{folders:Y}=this.x;if(Y.length!==0)return Y[0].uri.fsPath}getRelativePath(Y,G){let M,B="";if(typeof Y=="string"?(M=I.URI.file(Y),B=Y):typeof Y<"u"&&(M=Y,B=Y.fsPath),!M)return B;const U=this.getWorkspaceFolder(M,!0);if(!U)return B;typeof G>"u"&&this.x&&(G=this.x.folders.length>1);let j=(0,L.relativePath)(U.uri,M);return G&&U.name&&(j=`${U.name}/${j}`),j}y(Y){this.x&&(this.n=h.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:Y,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(Y){const{workspace:G,added:M,removed:B}=h.toExtHostWorkspace(Y,this.l,this.n,this.s);this.l=G||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:B}))}findFiles(Y,G,M,B,U=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let j;if(G===null?j=!1:G&&(typeof G=="string"?j=G:j=G.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:ie}=$(t.GlobPattern.from(Y));return this.o.$startFileSearch((0,S.withUndefinedAsNull)(he),(0,S.withUndefinedAsNull)(ie),(0,S.withUndefinedAsNull)(j),(0,S.withUndefinedAsNull)(M),U).then(V=>Array.isArray(V)?V.map(J=>I.URI.revive(J)):[])}async findTextInFiles(Y,G,M,B,U=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),he=typeof G.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:G.previewOptions,{includePattern:ie,folder:V}=$(t.GlobPattern.from(G.include)),J=typeof G.exclude=="string"?G.exclude:G.exclude?G.exclude.pattern:void 0,ne={ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles=="boolean"?!G.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof G.useGlobalIgnoreFiles=="boolean"?!G.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof G.useParentIgnoreFiles=="boolean"?!G.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof G.useDefaultExcludes=="boolean"?!G.useDefaultExcludes:!0,fileEncoding:G.encoding,maxResults:G.maxResults,previewOptions:he,afterContext:G.afterContext,beforeContext:G.beforeContext,includePattern:ie,excludePattern:J},ve=!1;if(this.u[j]=ue=>{if(ve)return;const ee=I.URI.revive(ue.resource);ue.results.forEach(N=>{(0,a.resultIsMatch)(N)?M({uri:ee,preview:{text:N.preview.text,matches:(0,c.mapArrayOrNot)(N.preview.matches,q=>new o.Range(q.startLineNumber,q.startColumn,q.endLineNumber,q.endColumn))},ranges:(0,c.mapArrayOrNot)(N.ranges,q=>new o.Range(q.startLineNumber,q.startColumn,q.endLineNumber,q.endColumn))}):M({uri:ee,text:N.text,lineNumber:N.lineNumber})})},U.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(Y,(0,S.withUndefinedAsNull)(V),ne,j,U);return delete this.u[j],ue||{}}catch(ue){throw delete this.u[j],ue}}$handleTextSearchResult(Y,G){this.u[G]?.(Y)}saveAll(Y){return this.o.$saveAll(Y)}resolveProxy(Y){return this.o.$resolveProxy(Y)}get trusted(){return this.v}requestWorkspaceTrust(Y){return this.o.$requestWorkspaceTrust(Y)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(Y,G){if(this.w.has(Y))throw new Error(`A provider has already been registered for scheme ${Y}`);this.w.set(Y,G);const M=this.t.transformOutgoingScheme(Y),B=this.z++;return this.o.$registerEditSessionIdentityProvider(B,M),(0,P.toDisposable)(()=>{this.w.delete(Y),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(Y,G){this.h.info("Getting edit session identifier for workspaceFolder",Y);const M=await this.resolveWorkspaceFolder(I.URI.revive(Y));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const B=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!B),!B)return;const U=await B.provideEditSessionIdentity(M,G);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(Y,G,M,B){this.h.info("Getting edit session identifier for workspaceFolder",Y);const U=await this.resolveWorkspaceFolder(I.URI.revive(Y));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const j=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!j),!j)return;const he=await j.provideEditSessionIdentityMatch?.(G,M,B);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(Y){return(G,M,B)=>{const U=function(he){G.call(M,he)};return U.extension=Y,this.A.event(U,void 0,B)}}async $onWillCreateEditSessionIdentity(Y,G,M){const B=await this.resolveWorkspaceFolder(I.URI.revive(Y));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:B},G,async(U,j)=>{const he=Date.now();await Promise.resolve(U),Date.now()-he>M&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),G.isCancellationRequested}};O=Ve([We(0,b.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,v.IExtHostFileSystemInfo),We(3,n.ILogService),We(4,s.IURITransformerService)],O),e.ExtHostWorkspace=O,e.IExtHostWorkspace=(0,w.createDecorator)("IExtHostWorkspace");function $(x){let Y,G;return x&&(typeof x=="string"?Y=x:(Y=x.pattern,G=I.URI.revive(x.baseUri))),{includePattern:Y,folder:G}}}),define(De[35],Ce([1,0,23,3,34,5,7,214,126,10,19,4,20,16,2]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(o,s){if(s){const a=s.split(".");let l=o;for(let E=0;l&&E<a.length;E++)l=l[a[E]];return l}}function n(o){return o instanceof C.URI}function d(o){return o&&o.uri instanceof C.URI&&o.languageId&&typeof o.languageId=="string"}function f(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function v(o){return o&&o.uri instanceof C.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function D(o){if(n(o))return{resource:o};if(d(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(f(o))return{overrideIdentifier:o.languageId};if(v(o))return{resource:o.uri};if(o===null)return{resource:null}}let b=class{constructor(s,a,l){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=a,this.b=l,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,a){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,a))}};b=Ve([We(0,S.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,I.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(s,a,l,E){this.a=new A.Emitter,this.b=s,this.f=E,this.c=a,this.e=k.Configuration.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,a){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=k.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(a,l))}getConfiguration(s,a,l){const E=D(a)||{},i=this.g(s?w(this.e.getValue(void 0,E,this.c.workspace),s):this.e.getValue(void 0,E,this.c.workspace));s&&this.h(s,E,l?.identifier);function r(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(g){return typeof w(i,g)<"u"},get:(g,h)=>{this.h(s?`${s}.${g}`:g,E,l?.identifier);let O=w(i,g);if(typeof O>"u")O=h;else{let $;const x=(Y,G)=>{let M;const B=()=>{$=$||(0,c.deepClone)(i),M=M||w($,G)};return(0,p.isObject)(Y)?new Proxy(Y,{get:(U,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return B(),()=>M;if($)return M=M||w($,G),M[j];const he=U[j];return typeof j=="string"?x(he,`${G}.${j}`):he},set:(U,j,he)=>(B(),M&&(M[j]=he),!0),deleteProperty:(U,j)=>(B(),M&&delete M[j],!0),defineProperty:(U,j,he)=>(B(),M&&Object.defineProperty(M,j,he),!0)}):Y};O=x(O,g)}return O},update:(g,h,O,$)=>{g=s?`${s}.${g}`:g;const x=r(O);return h!==void 0?this.b.$updateConfigurationOption(x,g,h,E,$):this.b.$removeConfigurationOption(x,g,E,$)},inspect:g=>{g=s?`${s}.${g}`:g;const h=this.e.inspect(g,E,this.c.workspace);if(h)return{key:g,defaultValue:(0,c.deepClone)(h.policy?.value??h.default?.value),globalValue:(0,c.deepClone)(h.user?.value??h.application?.value),workspaceValue:(0,c.deepClone)(h.workspace?.value),workspaceFolderValue:(0,c.deepClone)(h.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(h.default?.override),globalLanguageValue:(0,c.deepClone)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,c.deepClone)(h.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(h.workspaceFolder?.override),languageIds:(0,c.deepClone)(h.overrideIdentifiers)}}};return typeof i=="object"&&(0,c.mixin)(m,i,!1),Object.freeze(m)}g(s){const a=l=>(0,p.isObject)(l)?new Proxy(l,{get:(E,i)=>a(E[i]),set:(E,i,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(E,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(E,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:E=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return a(s)}h(s,a,l){const E=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),i=l?`[${l.value}] `:"";if(E===4){typeof a?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(E===3){a?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,a){const l=new k.ConfigurationChangeEvent(s,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(E,i)=>l.affectsConfiguration(E,D(i))})}k(s){return s.reduce((a,l)=>(a.set(l[0],l[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[84],Ce([1,0,2,19,3,5,7,34,59,35,21,41,20,26,4,18,11,16,79,251,9]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(Y){function G(B){if(B!=null)return B}Y.from=G;function M(B){if(B!=null)return B}Y.to=M})(t||(t={}));var o;(function(Y){function G(B){if(B!=null)return B}Y.from=G;function M(B){if(B!=null)return B}Y.to=M})(o||(o={}));var s;(function(Y){function G(B){if(B!=null)return B}Y.from=G;function M(B){if(B!=null)return B}Y.to=M})(s||(s={}));var a;(function(Y){function G(U){if(U){const j=U;return j&&!!j.process}else return!1}Y.is=G;function M(U){if(U==null)return;const j={process:U.process,args:U.args};return U.options&&(j.options=s.from(U.options)),j}Y.from=M;function B(U){if(U!=null)return new P.ProcessExecution(U.process,U.args,U.options)}Y.to=B})(a||(a={}));var l;(function(Y){function G(B){if(B!=null)return B}Y.from=G;function M(B){if(B!=null)return B}Y.to=M})(l||(l={}));var E;(function(Y){function G(U){if(U){const j=U;return j&&(!!j.commandLine||!!j.command)}else return!1}Y.is=G;function M(U){if(U==null)return;const j={};return U.commandLine!==void 0?j.commandLine=U.commandLine:(j.command=U.command,j.args=U.args),U.options&&(j.options=l.from(U.options)),j}Y.from=M;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new P.ShellExecution(U.commandLine,U.options):new P.ShellExecution(U.command,U.args?U.args:[],U.options)}Y.to=B})(E||(E={}));var i;(function(Y){function G(U){if(U){const j=U;return j&&j.customExecution==="customExecution"}else return!1}Y.is=G;function M(U){return{customExecution:"customExecution"}}Y.from=M;function B(U,j){return j.get(U)}Y.to=B})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(Y){function G(M,B){let U;return M.scope!==void 0&&typeof M.scope!="number"?U=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===P.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=v.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:U}}Y.from=G})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(Y){function G(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}Y.from=G})(m||(m={}));var g;(function(Y){function G(U,j){if(U==null)return[];const he=[];for(const ie of U){const V=M(ie,j);V&&he.push(V)}return he}Y.fromMany=G;function M(U,j){if(U==null)return;let he;U.execution instanceof P.ProcessExecution?he=a.from(U.execution):U.execution instanceof P.ShellExecution?he=E.from(U.execution):U.execution&&U.execution instanceof P.CustomExecution&&(he=i.from(U.execution));const ie=t.from(U.definition);let V;return U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=P.TaskScope.Workspace,!ie||!V?void 0:{_id:U._id,definition:ie,name:U.name,source:{extensionId:j.identifier.value,label:U.source,scope:V},execution:he,isBackground:U.isBackground,group:m.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}Y.from=M;async function B(U,j,he){if(U==null)return;let ie;a.is(U.execution)?ie=a.to(U.execution):E.is(U.execution)?ie=E.to(U.execution):i.is(U.execution)&&(ie=i.to(U._id,he));const V=t.to(U.definition);let J;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?J=U.source.scope:J=await j.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):J=P.TaskScope.Workspace),!V||!J)return;const ne=new P.Task(V,J,U.name,U.source.label,ie,U.problemMatchers);return U.isBackground!==void 0&&(ne.isBackground=U.isBackground),U.group!==void 0&&(ne.group=P.TaskGroup.from(U.group._id),ne.group&&U.group.isDefault&&(ne.group=new P.TaskGroup(ne.group.id,ne.group.label),U.group.isDefault===!0&&(ne.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ne.presentationOptions=o.to(U.presentationOptions)),U._id&&(ne._id=U._id),U.detail&&(ne.detail=U.detail),ne}Y.to=B})(g=e.TaskDTO||(e.TaskDTO={}));var h;(function(Y){function G(B){return B}Y.from=G;function M(B){if(!!B)return Object.assign(Object.create(null),B)}Y.to=M})(h||(h={}));class O{constructor(G,M,B){this._id=M,this.a=B,b.set(this,void 0),_e(this,b,G,"f")}get task(){return this.a}terminate(){Me(this,b,"f").terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}b=new WeakMap;let $=class{constructor(G,M,B,U,j,he,ie,V){this.q=new u.Emitter,this.r=new u.Emitter,this.s=new u.Emitter,this.t=new u.Emitter,this.a=G.getProxy(R.MainContext.MainThreadTask),this.b=B,this.c=U,this.d=j,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,M,B){if(!B)return new P.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:M,provider:B,extension:G}),this.a.$registerTaskProvider(U,M),new P.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(G,M){this.a.$registerTaskSystem(G,M)}fetchTasks(G){return this.a.$fetchTasks(h.from(G)).then(async M=>{const B=[];for(const U of M){const j=await g.to(U,this.b,this.m);j&&B.push(j)}return B})}get taskExecutions(){const G=[];return this.k.forEach(M=>G.push(M)),G}terminateTask(G){if(!(G instanceof O))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,M,B){const U=this.m.get(G.id);U&&(this.o.set(G.id,U),this.e.attachPtyToTerminal(M,await U.callback(B))),this.p=G.id,this.q.fire({execution:await this.y(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){const M=await this.y(G);this.l.delete(G.id),this.k.delete(G.id),this.A(G),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const M=await this.y(G.id);this.s.fire({execution:M,processId:G.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(G){const M=await this.y(G.id);this.t.fire({execution:M,exitCode:G.exitCode})}$provideTasks(G,M){const B=this.j.get(G);if(!B)return Promise.reject(new Error("no handler found"));const U=[],j=(0,A.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(he=>this.u(M,U,B,he));return new Promise(he=>{j.then(ie=>{Promise.all(U).then(()=>{he(ie)})})})}async $resolveTask(G,M){const B=this.j.get(G);if(!B)return Promise.reject(new Error("no handler found"));if(M.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await g.to(M,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const j=await B.provider.resolveTask(U,L.CancellationToken.None);if(!j)return;this.z(j,B);const he=g.from(j,B.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(he.execution)&&await this.x(he,j,!0),await this.v(he)}w(){return this.h++}async x(G,M,B){const U=await this.a.$createTaskId(G);!B&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,M.execution)),this.m.set(U,M.execution)}async y(G,M){if(typeof G=="string"){const j=this.l.get(G);if(!j)throw new D.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const B=this.l.get(G.id);if(B)return B;const U=new Promise((j,he)=>{function ie(V,J,ne){ne?j(new O(V,J.id,ne)):he("Unexpected: Task does not exist.")}M?ie(this,G,M):g.to(G.task,this.b,this.m).then(V=>ie(this,G,V))});return this.l.set(G.id,U),U.then(j=>(this.k.set(G.id,j),j),j=>Promise.reject(j))}z(G,M){G._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}A(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const B=this.n.values();let U=B.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=B.next()}};$=Ve([We(0,S.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,d.ILogService),We(7,f.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let x=class extends ${constructor(G,M,B,U,j,he,ie,V){super(G,M,B,U,j,he,ie,V),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:n.PlatformToString(0)})}async executeTask(G,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const B=g.from(M,G);if(B===void 0)throw new Error("Task is not valid");if(i.is(B.execution))await this.x(B,M,!1);else throw new D.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(B),M);return this.a.$executeTask(B).catch(j=>{throw new Error(j)}),U}u(G,M,B,U){const j=[];if(U)for(const he of U){this.z(he,B),(!he.definition||!G[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=g.from(he,B.extension);ie&&i.is(ie.execution)?(j.push(ie),M.push(this.x(ie,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:B.extension}}async v(G){if(i.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,M,B){}};x=Ve([We(0,S.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,d.ILogService),We(7,f.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(De[298],Ce([1,0,12,21,46,38,24,43,31]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class p{constructor(S,I,C){this.k=S,this.l=I,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=S.filePattern,this.b=S.includePattern&&R.parse(S.includePattern),this.c=S.maxResults||void 0,this.d=S.exists,this.h=new Set,this.j=S.excludePattern&&R.parse(S.excludePattern)}cancel(){this.g=!0,this.h.forEach(S=>S.cancel()),this.h=new Set}search(S){const I=this.k.folderQueries||[];return new Promise((C,w)=>{const n=d=>{this.f++,S(d)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const f=d.toString(),v=c.basename(f);this.j&&this.j(f,v)||this.v(n,{base:d,basename:v})}),Promise.all(I.map(d=>this.p(d,n))).then(d=>{C({limitHit:this.e,stats:d[0]||void 0})},d=>{w(new Error((0,u.toErrorMessage)(d)))})})}async p(S,I){const C=new A.CancellationTokenSource,w=this.q(S),n=this.r(),d=new y.QueryGlobTester(this.k,S),f=!d.hasSiblingExcludeClauses();let v;try{this.h.add(C),v=k.StopWatch.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,C.token),b=v.elapsed(),t=k.StopWatch.create();return this.g&&!this.e||(D&&D.forEach(o=>{const s=c.posix.relative(S.folder.path,o.path);if(f){const a=c.basename(o.path);this.v(I,{base:S.folder,relativePath:s,basename:a});return}this.s(n,S.folder,s,I)}),this.g&&!this.e)?null:(this.u(n,d,I),{providerTime:b,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(S){const I=(0,y.resolvePatternsForProvider)(this.k.includePattern,S.includePattern),C=(0,y.resolvePatternsForProvider)(this.k.excludePattern,S.excludePattern);return{folder:S.folder,excludes:C,includes:I,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}s({pathToEntries:S},I,C,w){if(C===this.a){const d=c.basename(this.a);this.v(w,{base:I,relativePath:this.a,basename:d})}function n(d){const f=c.basename(d),v=c.dirname(d);let D=S[v];D||(D=S[v]=[],n(v)),D.push({base:I,relativePath:d,basename:f})}n(C)}u({rootEntries:S,pathToEntries:I},C,w){const n=this,d=this.a;function f(v){const D=(0,y.hasSiblingFn)(()=>v.map(b=>b.basename));for(let b=0,t=v.length;b<t;b++){const o=v[b],{relativePath:s,basename:a}=o;if(C.matchesExcludesSync(s,a,d!==a?D:void 0))continue;const l=I[s];if(l)f(l);else{if(s===d)continue;n.v(w,o)}if(n.e)break}}f(S)}v(S,I){(!this.b||I.relativePath&&this.b(I.relativePath,I.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||S(I))}}class L{constructor(){this.b=new Map}fileSearch(S,I,C,w){const n=this.c(S.cacheKey),d=new p(S,I,n&&n.token);let f=0;const v=D=>{f+=D.length,C(D.map(b=>this.d(b)))};return this.e(d,L.a,v,w).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:D.stats}}))}clearCache(S){this.c(S)?.cancel()}c(S){if(!!S)return this.b.has(S)||this.b.set(S,new A.CancellationTokenSource),this.b.get(S)}d(S){return S.relativePath?{resource:P.joinPath(S.base,S.relativePath)}:{resource:S.base}}e(S,I,C,w){w.onCancellationRequested(()=>{S.cancel()});const n=f=>{f&&(d.push(f),I>0&&d.length>=I&&(C(d),d=[]))};let d=[];return S.search(n).then(f=>(d.length&&C(d),f),f=>(d.length&&C(d),Promise.reject(f)))}}L.a=512,e.FileSearchManager=L}),define(De[299],Ce([1,0,17,61,38,114,28,18,12,24,8,10,2,168,201,54,16,48,134,297,31]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(g,h,O,$,x){this.a=g,this.b=h,this.c=O,this.d=$,this.e=x}text(g,h,O={}){g=this.f(g,O);const $=this.a.getValue(),x=h&&h.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(h?.map(d.toWorkspaceFolder),O),type:2,contentPattern:g,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:$.search.usePCRE2||x||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(g,h){const O=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const $={...g,wordSeparators:O.editor.wordSeparators};return this.j(g,h)&&($.isCaseSensitive=!0),this.k(g)&&($.isMultiline=!0),$}file(g,h={}){return{...this.h(g,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(g,h){return g?(g=Array.isArray(g)?g.map(l):l(g),h?this.parseSearchPaths(g):{pattern:o(...Array.isArray(g)?g:[g])}):{}}h(g=[],h={}){const O=this.g(h.includePattern,h.expandPatterns),$=this.g(h.excludePattern,h.expandPatterns),x=g.length>1,Y=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(B=>this.q(B,h,$)):g.map(B=>this.r(B,h,$,x))).filter(B=>!!B),G={_reason:h._reason,folderQueries:Y,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:$.pattern,includePattern:O.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const B=c.coalesce(c.flatten(this.c.groups.map(he=>he.editors.map(ie=>ie.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const U=B.filter(he=>(0,D.pathIncludedInQuery)(G,he.fsPath)),j=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...G,...j}}const M=h.extraFileResources&&h.extraFileResources.filter(B=>(0,D.pathIncludedInQuery)(G,B.fsPath));return G.extraFileResources=M&&M.length?M:void 0,G}i(g){const h=[],O=new P.ResourceMap,$={};let x=!1;return g.forEach(Y=>{if(Y.scheme===k.Schemas.walkThrough)return;if((0,p.isAbsolutePath)(Y)){const M=this.b.getWorkspaceFolder(Y)?.uri??Y.with({path:y.dirname(Y.fsPath)});let B=O.get(M);B||(x=!0,B={folder:M,includePattern:{}},h.push(B),O.set(M,B));const U=y.relative(M.fsPath,Y.fsPath);(0,T.assertIsDefined)(B.includePattern)[U.replace(/\\/g,"/")]=!0}else Y.fsPath&&(x=!0,$[Y.fsPath]=!0)}),{folderQueries:h,includePattern:$,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}j(g,h){if(h.isSmartCase){if(g.isRegExp){if(L.containsUppercaseCharacter(g.pattern,!0))return!0}else if(L.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,I.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const h=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),$=(Array.isArray(g)?g:s(g)).map(j=>{const he=this.e.resolvedUserHome;return he?(0,R.untildify)(j,he.scheme===k.Schemas.file?he.fsPath:he.path):j}),x=A.groupBy($,j=>h(j)?"searchPaths":"exprSegments"),Y=(x.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),a(j))),G={},M=this.m(x.searchPaths||[]);M&&M.length&&(G.searchPaths=M);const B=c.flatten(Y),U=o(...B);return U&&(G.pattern=U),G}l(g,h){return h.disregardExcludeSettings?void 0:(0,D.getExcludes)(g,!h.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const h=g.flatMap($=>{let{pathPortion:x,globPortion:Y}=t($);return Y&&(Y=E(Y)),this.n(x).flatMap(M=>this.o(M,Y))}),O=new Map;return h.forEach($=>{const x=$.searchPath.toString(),Y=O.get(x);Y?$.pattern&&(Y.pattern=Y.pattern||{},Y.pattern[$.pattern]=!0):O.set(x,{searchPath:$.searchPath,pattern:$.pattern?o($.pattern):void 0})}),Array.from(O.values())}n(g){if(y.isAbsolute(g)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==k.Schemas.file?[{searchPath:h[0].uri.with({path:g})}]:[{searchPath:S.URI.file(y.normalize(g))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(g=l(g),g.startsWith("../")||g===".."){const $=y.posix.resolve(h.path,g);return[{searchPath:h.with({path:$})}]}const O=E(g);return[{searchPath:h,pattern:O}]}else{if(g==="./"||g===".\\")return[];{const h=g.replace(/^\.[\/\\]/,""),$=this.b.getWorkspace().folders.map(x=>{const Y=h.match(new RegExp(`^${L.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return Y?{match:Y,folder:x}:null}).filter(T.isDefined);if($.length)return $.map(x=>{const Y=x.match[1];return{searchPath:x.folder.uri,pattern:Y&&E(Y)}});{const x=g.match(/\.[\/\\](.+)[\/\\]?/),Y=x?x[1]:g,G=C.localize(0,null,Y);throw new Error(G)}}}}o(g,h){const O=g.pattern&&h?`${g.pattern}/${h}`:g.pattern||h,$=[{searchPath:g.searchPath,pattern:O}];return O&&!O.endsWith("**")&&$.push({searchPath:g.searchPath,pattern:O+"/**"}),$}q(g,h,O){const $=this.r((0,d.toWorkspaceFolder)(g.searchPath),h,O,!1);return $?{...$,includePattern:g.pattern}:null}r(g,h,O,$){let x;const Y=S.URI.isUri(g)?g:g.uri;if(O.searchPaths){const j=O.searchPaths.filter(he=>(0,p.isEqual)(he.searchPath,Y))[0];if(j&&!j.pattern)return null;j&&(x=j.pattern)}const G=this.a.getValue({resource:Y}),B={...this.l(G,h)||{},...x||{}},U=S.URI.isUri(g)?(0,p.basename)(g):g.name;return{folder:Y,folderName:$?U:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!G.search.followSymlinks}}};b=Ve([We(0,w.IConfigurationService),We(1,d.IWorkspaceContextService),We(2,f.IEditorGroupsService),We(3,n.ILogService),We(4,v.IPathService)],b),e.QueryBuilder=b;function t(m){const g=m.match(/[\*\{\}\(\)\[\]\?]/);if(g){const h=g.index,O=m.substr(0,h).match(/[/|\\][^/\\]*$/);if(O){let $=m.substr(0,O.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:m.substr((O.index||0)+1)}}}return{pathPortion:m}}function o(...m){return m.length?m.reduce((g,h)=>(g[h]=!0,g),Object.create(null)):void 0}function s(m){return u.splitGlobAware(m,",").map(g=>g.trim()).filter(g=>!!g.length)}function a(m){return[`**/${m}/**`,`**/${m}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function l(m){return m.replace(/\\/g,"/")}function E(m){return l(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(m){return m.replace(/([?*[\]])/g,"[$1]")}function r(m,g){m=c.distinct(m,$=>$.toString());const h=[],O=g.getWorkspace();return m&&m.forEach($=>{let x;if(g.getWorkbenchState()===2)x=(0,p.relativePath)(O.folders[0].uri,$),x&&x!=="."&&(x="./"+x);else{const Y=g.getWorkspaceFolder($);if(Y){const G=Y.name;if(O.folders.filter(B=>B.name===G).length===1){const B=(0,p.relativePath)(Y.uri,$);B===""?x=`./${Y.name}`:x=`./${Y.name}/${B}`}else x=$.fsPath}}x&&h.push(i(x))}),h}e.resolveResourcesForSearchIncludes=r}),define(De[300],Ce([1,0,24,2,21,9,4,299,31,48]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(w,n){const d=n.activationEvents;if(!d)return Promise.resolve(void 0);const f=[],v=[];for(const a of d)if(/^workspaceContains:/.test(a)){const l=a.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?v.push(l):f.push(l)}if(f.length===0&&v.length===0)return Promise.resolve(void 0);let D;const b=new Promise((a,l)=>{D=a}),t=a=>D({activationEvent:a}),o=Promise.all(f.map(a=>S(w,a,t))).then(()=>{}),s=I(w,n.identifier,v,t);return Promise.all([o,s]).then(()=>{D(void 0)}),b}e.checkActivateWorkspaceContainsExtension=T;async function S(w,n,d){for(const f of w.folders)if(await w.exists(c.joinPath(A.URI.revive(f),n))){d(`workspaceContains:${n}`);return}}async function I(w,n,d,f){if(d.length===0)return Promise.resolve(void 0);const v=new u.CancellationTokenSource,D=w.checkExists(w.folders,d,v.token),b=setTimeout(async()=>{v.cancel(),w.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},L);let t=!1;try{t=await D}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}v.dispose(),clearTimeout(b),t&&f(`workspaceContains:${d.join(",")}`)}function C(w,n,d,f){const v=w.get(P.IInstantiationService),D=w.get(y.ISearchService),t=v.createInstance(k.QueryBuilder).file(n.map(o=>(0,p.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:d,exists:!0});return D.fileSearch(t,f).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=C});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[42],Ce([1,0,182,12,85,24,19,6,69,2,16,5,35,242,100,34,27,135,9,25,22,225,7,127,4,26,81,20,92,55,41,3,300,99,227,18,98,43,11]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t,o,s,a,l,E,i,r,m,g,h,O,$,x,Y,G,M){"use strict";var B,U,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let he=class fn extends k.Disposable{constructor(N,q,ae,me,ke,_,le,de,te,ce,oe){super(),this.a=this.D(new g.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=q,this.g=ae,this.f=le,this.j=me,this.k=ke,this.l=_,this.m=te,this.p=ce,this.q=oe,this.s=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.t=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.u=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.v=new P.Barrier,this.w=new P.Barrier,this.y=new P.Barrier,this.z=new P.Barrier,this.C=new ue(this.f.activationEvents),this.G=new d.ExtensionDescriptionRegistry(this.C,this.f.allExtensions);const F=new v.ExtensionIdentifierSet(this.f.myExtensions);this.F=new d.ExtensionDescriptionRegistry(this.C,ne(this.G,F)),this.H=new C.ExtHostStorage(this.g,this.l),this.I=new O.ExtHostSecretState(this.g),this.J=de,this.h=N.createChild(new i.ServiceCollection([C.IExtHostStorage,this.H],[O.IExtHostSecretState,this.I])),this.L=this.D(new I.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(z,K,Z)=>{this.u.$onExtensionActivationError(z,f.transformErrorForSerialization(K),Z)},actualActivateExtension:async(z,K)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(z,this.F,this.G))return await this.u.$activateExtension(z,K),new I.HostExtension;const Z=this.F.getExtensionDescription(z);return this.Z(Z,K)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.v.open(),await this.j.waitForInitializeCall(),u.mark("code/extHost/ready"),this.w.open(),this.f.autoStart&&this.nb()}catch(N){f.onUnexpectedError(N)}}async R(){this.J.onWillDeactivateAll();let N=[];try{N=this.F.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.Y(ke))}catch{}await Promise.all(N)}terminate(N,q=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${N}`),this.l.flush(),this.p.dispose(),this.L.dispose(),f.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const ae=this.R();Promise.race([(0,P.timeout)(5e3),ae]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.l.info(`Extension host exiting with code ${q}`),this.l.flush(),this.l.dispose(),this.c.exit(q)})}isActivated(N){return this.y.isOpen()?this.L.isActivated(N):!1}async getExtension(N){const q=await this.u.$getExtension(N);let ae;if(q?.browserNlsBundleUris){ae={};for(const me of Object.keys(q.browserNlsBundleUris))ae[me]=p.URI.revive(q.browserNlsBundleUris[me])}return q&&{...q,identifier:new v.ExtensionIdentifier(q.identifier.value),extensionLocation:p.URI.revive(q.extensionLocation),browserNlsBundleUris:ae}}S(N,q){return this.L.activateByEvent(N,q)}U(N,q){return this.L.activateById(N,q)}activateByIdWithErrors(N,q){return this.U(N,q).then(()=>{const ae=this.L.getActivatedExtension(N);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this.y.wait().then(N=>this.F)}getExtensionExports(N){return this.y.isOpen()?this.L.getActivatedExtension(N).exports:null}async W(N){if(N.scheme!==x.Schemas.file)return N;const q=await this.c.realpath(N.fsPath);return p.URI.file(q)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(N=>new ve(N))),this.M}async X(N){const q=y.TernarySearchTree.forUris(ae=>R.extUriBiasedIgnorePathCase.ignorePathCasing(ae));return await Promise.all(N.map(async ae=>{if(this.qb(ae)){const me=await this.W(ae.extensionLocation);q.set(me,ae)}})),q}Y(N){let q=Promise.resolve(void 0);if(!this.y.isOpen()||!this.L.isActivated(N))return q;const ae=this.L.getActivatedExtension(N);if(!ae)return q;try{typeof ae.module.deactivate=="function"&&(q=Promise.resolve(ae.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${N.value}':`),this.l.error(me)}try{(0,k.dispose)(ae.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${N.value}':`),this.l.error(me)}return q}async Z(N,q){return this.f.remote.isRemote?this.u.$onWillActivateExtension(N.identifier):await this.u.$onWillActivateExtension(N.identifier),this.bb(N,q).then(ae=>{const me=ae.activationTimes;return this.u.$onDidActivateExtension(N.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,q),this.ab(N,q,"success",me),ae},ae=>{throw this.ab(N,q,"failure"),ae})}ab(N,q,ae,me){const ke=V(N,q);this.t.$publicLog2("extensionActivationTimes",{...ke,...me||{},outcome:ae})}bb(N,q){const ae=V(N,q);this.t.$publicLog2("activatePlugin",ae);const me=this.qb(N);if(!me)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${N.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${N.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.l.flush();const ke=new I.ExtensionActivationTimesBuilder(q.startup);return Promise.all([this.rb(N,(0,R.joinPath)(N.extensionLocation,me),ke),this.cb(N)]).then(_=>(u.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),fn.db(this.l,N.identifier,_[0],_[1],ke))).then(_=>(u.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),_))}cb(N){const q=new b.ExtensionGlobalMemento(N,this.H),ae=new b.ExtensionMemento(N.identifier.value,!1,this.H),me=new $.ExtensionSecrets(N,this.I),ke=N.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,_=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([q.whenReady,ae.whenReady,this.J.whenReady]).then(()=>{const le=this;let de,te;const ce=(0,n.isProposedApiEnabled)(N,"ipc")?this.f.messagePorts?.get(v.ExtensionIdentifier.toKey(N.identifier)):void 0;return Object.freeze({globalState:q,workspaceState:ae,secrets:me,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(oe){return A.join(N.extensionLocation.fsPath,oe)},get storagePath(){return le.J.workspaceValue(N)?.fsPath},get globalStoragePath(){return le.J.globalValue(N).fsPath},get logPath(){return A.join(le.f.logsLocation.fsPath,N.identifier.value)},get logUri(){return p.URI.joinPath(le.f.logsLocation,N.identifier.value)},get storageUri(){return le.J.workspaceValue(N)},get globalStorageUri(){return le.J.globalValue(N)},get extensionMode(){return ke},get extension(){return de===void 0&&(de=new J(le,N.identifier,N,_,!1)),de},get extensionRuntime(){return(0,n.checkProposedApiEnabled)(N,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.p.getEnvironmentVariableCollection(N)},get messagePassingProtocol(){if(!te){if(!ce)return;const oe=g.Event.buffer(g.Event.fromDOMEventEmitter(ce,"message",F=>F.data));ce.start(),te={onDidReceiveMessage:oe,postMessage:ce.postMessage.bind(ce)}}return te}})})}static db(N,q,ae,me,ke){return ae=ae||{activate:void 0,deactivate:void 0},this.eb(N,q,ae,me,ke).then(_=>new I.ActivatedExtension(!1,null,ke.build(),ae,_,me.subscriptions))}static eb(N,q,ae,me,ke){if(typeof ae.activate=="function")try{ke.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${q.value}`);const _=typeof global=="object"?global:self,le=ae.activate.apply(_,[me]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(le).then(de=>(ke.activateResolveStop(),de))}catch(_){return Promise.reject(_)}else return Promise.resolve(ae)}fb(N,q){this.U(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:q}).then(void 0,ae=>{this.l.error(ae)})}gb(N,q=0){const me=Date.now();(0,M.setTimeout0)(()=>{for(let ke=q;ke<N.length;ke+=1){const _=N[ke];for(const le of _.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-me>50){this.gb(N,ke);break}else this.fb(_,le)}})}hb(){this.u.$setPerformanceMarks(u.getMarks()),this.k.getConfigProvider().then(N=>{const q=N.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ae=this.F.getAllExtensionDescriptions();if(q)this.gb(ae);else for(const me of ae)if(me.activationEvents)for(const ke of me.activationEvents)ke==="onStartupFinished"&&this.fb(me,ke)})}ib(){const N=this.S("*",!0).then(void 0,_=>{this.l.error(_)});this.D(this.j.onDidChangeWorkspace(_=>this.jb(_.added)));const q=this.j.workspace?this.j.workspace.folders:[],ae=this.jb(q),me=this.lb(),ke=Promise.all([me,N,ae]).then(()=>{});return Promise.race([ke,(0,P.timeout)(1e4)]).then(()=>{this.hb()}),ke}jb(N){return N.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(q=>this.kb(N,q))).then(()=>{})}async kb(N,q){if(this.isActivated(q.identifier))return;const ae=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:N.map(_=>_.uri),forceUsingSearch:ae,exists:_=>this.c.exists(_.fsPath),checkExists:(_,le,de)=>this.s.$checkExists(_,le,de)},ke=await(0,h.checkActivateWorkspaceContainsExtension)(me,q);if(!!ke)return this.U(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ke.activationEvent}).then(void 0,_=>this.l.error(_))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.z.wait();try{return await this.mb()}catch(N){throw console.error(N),N}}async mb(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:q}=this.f.environment;if(!N||!q)throw new Error(c.localize(0,null));const ae=await this.rb(null,q,new I.ExtensionActivationTimesBuilder(!1));if(!ae||typeof ae.run!="function")throw new Error(c.localize(1,null,q.toString()));return new Promise((me,ke)=>{const _=(te,ce)=>{te?ke(te):me(typeof ce=="number"&&ce>0?1:0)},le=(0,R.originalFSPath)(q),de=ae.run(le,_);de&&de.then&&de.then(()=>{me(0)}).catch(te=>{ke(te instanceof Error&&te.stack?te.stack:String(te))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.w.wait().then(()=>this.y.open()).then(()=>this.ib()).then(()=>{this.z.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(N,q){return this.N[N]=q,(0,k.toDisposable)(()=>{delete this.N[N]})}async ob(N){const q=N.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const ae=N.substr(0,q);return await this.v.wait(),await this.S(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this.N[ae]}}async $resolveAuthority(N,q){const ae=G.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(N)},${q})][${ae.elapsed()}ms] `,ke=ce=>this.l.info(`${me()}${ce}`),_=(ce,oe=void 0)=>this.l.error(`${me()}${ce}`,oe);ke("activating resolver...");const{authorityPrefix:le,resolver:de}=await this.ob(N);if(!de)return _("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};const te=new P.IntervalTimer;try{ke("setting tunnel factory..."),this.D(await this.m.setTunnelFactory(de)),te.cancelAndSet(()=>ke("waiting..."),1e3),ke("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${le}`);const ce=await de.resolve(N,{resolveAttempt:q});u.mark(`code/extHost/didResolveAuthorityOK/${le}`),te.dispose(),ke(`returned ${ce.host}:${ce.port}`);const oe={authority:N,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},F={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:oe,options:F,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(u.mark(`code/extHost/didResolveAuthorityError/${le}`),te.dispose(),_("returned an error",ce),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(N,q){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(N)})`);const{resolver:ae}=await this.ob(N);if(!ae)return null;const me=p.URI.revive(q);if(typeof ae.getCanonicalURI>"u")return me;const ke=await(0,P.asPromise)(()=>ae.getCanonicalURI(me));return ke||me}$startExtensionHost(N){N.toAdd.forEach(me=>me.extensionLocation=p.URI.revive(me.extensionLocation));const{globalRegistry:q,myExtensions:ae}=ie(this.C,this.G,this.F,N);return this.G.set(q.getAllExtensionDescriptions()),this.F.set(ae),this.nb()}$activateByEvent(N,q){return q===1?this.S(N,!1):this.y.wait().then(ae=>this.S(N,!1))}async $activate(N,q){return await this.y.wait(),this.F.getExtensionDescription(N)?(await this.U(N,q),!0):!1}async $deltaExtensions(N){N.toAdd.forEach(_=>_.extensionLocation=p.URI.revive(_.extensionLocation));const{globalRegistry:q,myExtensions:ae}=ie(this.C,this.G,this.F,N),me=await this.X(ae);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(q.getAllExtensionDescriptions()),this.F.set(ae),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){const q=D.VSBuffer.alloc(N),ae=Math.random()%256;for(let me=0;me<N;me++)q.writeUInt8(ae,me);return q}async $updateRemoteConnectionData(N){this.Q=N,this.a.fire()}};he=Ve([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,E.IExtHostRpcService),We(3,w.IExtHostWorkspace),We(4,S.IExtHostConfiguration),We(5,L.ILogService),We(6,a.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,r.IExtHostTunnelService),We(9,m.IExtHostTerminalService),We(10,Y.IExtHostLocalizationService)],he),e.AbstractExtHostExtensionService=he;function ie(ee,N,q,ae){ee.addActivationEvents(ae.addActivationEvents);const me=new d.ExtensionDescriptionRegistry(ee,N.getAllExtensionDescriptions());me.deltaExtensions(ae.toAdd,ae.toRemove);const ke=new v.ExtensionIdentifierSet(q.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of ae.myToRemove)ke.delete(le);for(const le of ae.myToAdd)ke.add(le);const _=ne(me,ke);return{globalRegistry:me,myExtensions:_}}function V(ee,N){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class J{constructor(N,q,ae,me,ke){B.set(this,void 0),U.set(this,void 0),j.set(this,void 0),_e(this,B,N,"f"),_e(this,U,q,"f"),_e(this,j,ae.identifier,"f"),this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=me,this.isFromDifferentExtensionHost=ke}get isActive(){return Me(this,B,"f").isActivated(Me(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,j,"f"),{startup:!1,extensionId:Me(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=J,B=new WeakMap,U=new WeakMap,j=new WeakMap;function ne(ee,N){return ee.getAllExtensionDescriptions().filter(q=>N.has(q.identifier))}class ve{constructor(N){this.a=N}setSearchTree(N){this.a=N}findSubstr(N){return this.a.findSubstr(N)}forEach(N){return this.a.forEach(N)}}e.ExtensionPaths=ve;class ue{constructor(N){this.a=new v.ExtensionIdentifierMap,this.addActivationEvents(N)}readActivationEvents(N){return this.a.get(N.identifier)}addActivationEvents(N){for(const q of Object.keys(N))this.a.set(q,N[q])}}}),define(De[301],Ce([1,0,85,2,5,35,27,25,20,26,4,42,36,16,8]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(b,t,o,s,a,l,E){this.c=b,this.d=t,this.e=o,this.f=s,this.g=a,this.h=l,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,b,this.i)),this.register(this.e.createInstance(f,t)),this.register(this.e.createInstance(n)),this.h.remote.isRemote&&this.register(this.e.createInstance(v,t,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const t of b.nodeModuleName)this.a.set(t,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(t=>b.alternativeModuleName(t))}};w=Ve([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,T.IExtHostExtensionService),We(5,p.IExtHostInitDataService),We(6,I.ILogService)],w),e.RequireInterceptor=w;let n=class cn{constructor(b){if(b.environment.appRoot&&cn.a.size){const t=(0,C.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const t=this.b.exec(this.c(b));if(!t)return;const[,o,s,a]=t,l=cn.a.get(s);if(l!==void 0)return console.warn(`${s} as been renamed to ${l}, please update your imports`),o+l+a}c(b){return b.replace(/\\/g,"/")}};n.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),n=Ve([We(0,p.IExtHostInitDataService)],n);class d{constructor(b,t,o,s,a){this.c=b,this.d=t,this.e=o,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new k.ExtensionIdentifierMap}load(b,t){const o=this.d.findSubstr(t);if(o){let s=this.a.get(o.identifier);return s||(s=this.c(o,this.e,this.f),this.a.set(o.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,l)=>s+=`	${l} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${s}`),this.b=this.c(P.nullExtensionDescription,this.e,this.f)}return this.b}}let f=class{constructor(b,t,o){this.d=b,this.nodeModuleName="keytar",this.a=t.getProxy(u.MainContext.MainThreadTelemetry);const{environment:s}=o,a=t.getProxy(u.MainContext.MainThreadKeytar);if(s.appRoot){let l=s.appRoot.fsPath;S.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,E)=>a.$getPassword(l,E),setPassword:(l,E,i)=>a.$setPassword(l,E,i),deletePassword:(l,E)=>a.$deletePassword(l,E),findPassword:l=>a.$findPassword(l),findCredentials(l){return a.$findCredentials(l)}}}load(b,t){const o=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const t=b.length;if(t<=7||!this.b)return;const o=t-7;if((b.charAt(o)==="/"||b.charAt(o)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};f=Ve([We(1,y.IExtHostRpcService),We(2,p.IExtHostInitDataService)],f);let v=class{constructor(b,t,o){this.e=b,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(u.MainContext.MainThreadTelemetry);const s=o.getProxy(u.MainContext.MainThreadWindow);this.c=(a,l)=>{const E=A.URI.parse(a);return l?this.g(a,l):E.scheme==="http"||E.scheme==="https"?s.$openUri(E,a,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?s.$openUri(E,a,{}):this.g(a,l)}}load(b,t,o){const s=this.e.findSubstr(t);return s&&(this.a=s.identifier.value,this.h()),this.b=o(b),this.c}g(b,t){return this.i(),this.b(b,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};v=Ve([We(2,y.IExtHostRpcService)],v)}),define(De[50],Ce([1,0,65,6,12,36,4,59,60,42,7,34,238,35]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,P.createDecorator)("IExtHostVariableResolverProvider");class C extends S.AbstractVariableResolverService{constructor(d,f,v,D,b,t,o){function s(){if(v){const a=v.activeEditor();if(a)return a.document.uri;const l=D.tabGroups.all.find(E=>E.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof L.TextDiffTabInput||l.input instanceof L.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof L.TextTabInput||l.input instanceof L.NotebookEditorTabInput||l.input instanceof L.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:a=>{const l=t.folders.filter(E=>E.name===a);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,l)=>b.getConfiguration(void 0,a).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=s();if(a)return u.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const a=s();if(a){const l=f.getWorkspaceFolder(a);if(l)return u.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(v){const a=v.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(v){const a=v.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>d.getExtension(a)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let w=class extends A.Disposable{constructor(d,f,v,D,b){super(),this.b=d,this.c=f,this.g=v,this.h=D,this.i=b,this.a=new c.Lazy(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.D(this.c.onDidChangeWorkspace(async a=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,s,this.j())})}getResolver(){return this.a.value}j(){}};w=Ve([We(0,p.IExtHostExtensionService),We(1,T.IExtHostWorkspace),We(2,k.IExtHostDocumentsAndEditors),We(3,I.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],w),e.ExtHostVariableResolverProviderService=w}),define(De[86],Ce([1,0,19,3,10,2,4,5,60,42,20,7,34,131,232,35,50]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,P.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,l,E,i,r){this.D=a,this.E=l,this.F=E,this.G=i,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(k.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new v(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(m=>{m.onDidChange(g=>{this.I(m)}),this.I(m)})}asDebugSourceUri(s,a){const l=s;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let E=`debug:${encodeURIComponent(l.path||"")}`,i="?";return a&&(E+=`${i}session=${encodeURIComponent(a.id)}`,i="&"),E+=`${i}ref=${l.sourceReference}`,R.URI.parse(E)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const a=[];for(const l of s.getAllExtensionDescriptions())if(l.contributes){const E=l.contributes.debuggers;if(E&&E.length>0)for(const i of E)(0,C.isDebuggerMainContribution)(i)&&a.push(i.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){this.T();const a=s.filter(i=>{const r=i.id;return this.w.has(r)?!1:(this.w.set(r,i),!0)});this.U(a,[],[]);const l=[],E=new Map;for(const i of a)if(i instanceof T.SourceBreakpoint){let r=E.get(i.location.uri.toString());r||(r={type:"sourceMulti",uri:i.location.uri,lines:[]},E.set(i.location.uri.toString(),r),l.push(r)),r.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof T.FunctionBreakpoint&&l.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(s){this.T();const a=s.filter(r=>this.w.delete(r.id));this.U([],a,[]);const l=a.filter(r=>r instanceof T.SourceBreakpoint).map(r=>r.id),E=a.filter(r=>r instanceof T.FunctionBreakpoint).map(r=>r.id),i=a.filter(r=>r instanceof T.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(l,E,i)}startDebugging(s,a,l){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,l){if(!a)return new T.Disposable(()=>{});const E=this.d++;return this.f.push({type:s,handle:E,provider:a}),this.k.$registerDebugConfigurationProvider(s,l,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,E),new T.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==a),this.k.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,a,l){if(!l)return new T.Disposable(()=>{});if(!this.P(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:a,handle:E,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(a,E),new T.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new T.Disposable(()=>{});const l=this.i++;return this.j.push({type:s,handle:l,factory:a}),new T.Disposable(()=>{this.j=this.j.filter(E=>E.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let l;const E=await this.W(s);return E&&(l={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(l,a)}J(s,a){if(s.type==="implementation")return new b(s.implementation)}K(){}async $startDASession(s,a){const l=this,E=await this.V(a);return this.R(this.M(E.type),E).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const r=this.L(i),m=this.J(r,E);if(!m)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const g=m;return this.A.set(s,g),this.Q(E).then(h=>(h&&this.B.set(s,h),g.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const $=O,x={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const Y=await this.C.sign($.arguments.value);x.body={signature:Y},g.sendResponse(x)}else throw new Error("no signer")}catch(Y){x.success=!1,x.message=Y.message,g.sendResponse(x)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(O),O=(0,C.convertToVSCPaths)(O,!0),l.k.$acceptDAMessage(s,O)}),g.onError(O=>{h&&h.onError&&h.onError(O),this.k.$acceptDAError(s,O.name,O.message,O.stack)}),g.onExit(O=>{h&&h.onExit&&h.onExit((0,u.withNullAsUndefined)(O),void 0),this.k.$acceptDAExit(s,(0,u.withNullAsUndefined)(O),void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),g.startSession()))})}$sendDAMessage(s,a){a=(0,C.convertToDAPaths)(a,!1);const l=this.B.get(s);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(a),this.A.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.B.get(s);this.B.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const l=this.A.get(s);return this.A.delete(s),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],l=[],E=[];if(s.added)for(const i of s.added){const r=i.id;if(r&&!this.w.has(r)){let m;if(i.type==="function")m=new T.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")m=new T.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const g=R.URI.revive(i.uri);m=new T.SourceBreakpoint(new T.Location(g,new T.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,T.setBreakpointId)(m,r),this.w.set(r,m),a.push(m)}}if(s.removed)for(const i of s.removed){const r=this.w.get(i);r&&(this.w.delete(i),l.push(r))}if(s.changed){for(const i of s.changed)if(i.id){const r=this.w.get(i.id);if(r){if(r instanceof T.FunctionBreakpoint&&i.type==="function"){const m=r;m.enabled=i.enabled,m.condition=i.condition,m.hitCondition=i.hitCondition,m.logMessage=i.logMessage,m.functionName=i.functionName}else if(r instanceof T.SourceBreakpoint&&i.type==="source"){const m=r;m.enabled=i.enabled,m.condition=i.condition,m.hitCondition=i.hitCondition,m.logMessage=i.logMessage,m.location=new T.Location(R.URI.revive(i.uri),new T.Position(i.line,i.character))}E.push(r)}}}this.U(a,l,E)}$provideDebugConfigurations(s,a,l){return(0,c.asPromise)(async()=>{const E=this.O(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(a);return E.provideDebugConfigurations(i,l)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,a,l,E){return(0,c.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(a);return i.resolveDebugConfiguration(r,l,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,l,E){return(0,c.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(a);return i.resolveDebugConfigurationWithSubstitutedVariables(r,l,E)})}async $provideDebugAdapter(s,a){const l=this.N(s);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.V(a);return this.R(l,E).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const E={session:await this.V(s),event:a.event,body:a.body};this.u.fire(E)}L(s){if(s instanceof T.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof T.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const a=this.h.filter(l=>l.type===s);if(a.length>0)return a[0].factory}N(s){const a=this.h.filter(l=>l.handle===s);if(a.length>0)return a[0].factory}O(s){const a=this.f.filter(l=>l.handle===s);if(a.length>0)return a[0].provider}P(s,a){if(s.contributes){const l=s.contributes.debuggers;if(l&&l.length>0){for(const E of l)if(E.label&&E.type&&E.type===a)return!0}}return!1}Q(s){const l=s.configuration.type,E=this.j.filter(i=>i.type===l||i.type==="*").map(i=>(0,c.asPromise)(()=>i.factory.createDebugAdapterTracker(s)).then(r=>r,r=>null));return Promise.race([Promise.all(E).then(i=>{const r=i.filter(m=>!!m);if(r.length>0)return new D(r)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(s,a){const l=a.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new T.DebugAdapterServer(l));if(s){const i=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>s.createDebugAdapterDescriptor(a,this.S(a,i))).then(r=>{if(r)return r})}const E=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,E))}S(s,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,a,l){(s.length>0||a.length>0||l.length>0)&&this.z.fire(Object.freeze({added:s,removed:a,changed:l}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const l=await this.W(s.folderUri),E=s.parent?this.l.get(s.parent):void 0;a=new f(this.k,s.id,s.type,s.name,l,s.configuration,E),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=R.URI.revive(s);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};d=Ve([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,w.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,n.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class f{constructor(s,a,l,E,i,r,m){this.d=s,this.f=a,this.g=l,this.h=E,this.i=i,this.j=r,this.k=m}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=f;class v{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=v;class D{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(l=>l.onExit?l.onExit(s,a):void 0)}}class b extends I.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(s,a,l,E,i,r){super(s,a,l,E,i,r)}};t=Ve([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,w.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,n.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(De[302],Ce([1,0,9,85,2,5,294,16,91,92,26,208,20,56,42,78]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class n{static async installEarlyHandler(v){const D=v.get(k.ILogService),t=v.get(S.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(o=>{D.error(o);const s=c.transformErrorForSerialization(o);t.$onUnexpectedError(s)})}static async installFullHandler(v){const D=v.get(k.ILogService),b=v.get(S.IExtHostRpcService),t=v.get(C.IExtHostExtensionService),o=v.get(w.IExtHostTelemetry),s=b.getProxy(R.MainContext.MainThreadExtensionService),a=b.getProxy(R.MainContext.MainThreadErrors),l=await t.getExtensionPathIndex(),E=new WeakMap;function i(m,g){let h="",O,$;for(const x of g)h+=`
	at ${x.toString()}`,$=x.getFileName(),!O&&$&&(O=l.findSubstr(u.URI.file($)));return E.set(m,O?.identifier),`${m.name||"Error"}: ${m.message||""}${h}`}let r=i;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return r},set(m){r=function(g,h){return i(g,h),m.call(Error,g,h)}}}),c.setUnexpectedErrorHandler(m=>{D.error(m);const g=c.transformErrorForSerialization(m),h=E.get(m);if(!h){a.$onUnexpectedError(g);return}s.$onExtensionRuntimeError(h,g);const O=o.onExtensionError(h,m);D.trace("forwarded error to extension?",O,h)})}}Error.stackTraceLimit=100;class d{constructor(v,D,b,t,o){this.a=b,this.b=new P.RPCProtocol(v,null,t),D=d.e(D,this.b);const s=new p.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:o}),s.set(S.IExtHostRpcService,new S.ExtHostRpcService(this.b)),s.set(I.IURITransformerService,new I.URITransformerService(t)),s.set(C.IHostUtils,b);const a=new T.InstantiationService(s,!0);a.invokeFunction(n.installEarlyHandler),this.d=a.invokeFunction(l=>l.get(k.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=a.invokeFunction(l=>l.get(C.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(n.installFullHandler)}async asBrowserUri(v){const D=this.b.getProxy(R.MainContext.MainThreadExtensionService);return u.URI.revive(await D.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,D){v.allExtensions.forEach(t=>{t.extensionLocation=u.URI.revive(D.transformIncomingURIs(t.extensionLocation));const o={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(s=>o[s]=u.URI.revive(D.transformIncomingURIs(t.browserNlsBundleUris[s]))),t.browserNlsBundleUris=o)}),v.environment.appRoot=u.URI.revive(D.transformIncomingURIs(v.environment.appRoot));const b=v.environment.extensionDevelopmentLocationURI;return b&&(v.environment.extensionDevelopmentLocationURI=b.map(t=>u.URI.revive(D.transformIncomingURIs(t)))),v.environment.extensionTestsLocationURI=u.URI.revive(D.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=u.URI.revive(D.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=u.URI.revive(D.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=u.URI.revive(D.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=u.URI.revive(D.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=u.URI.revive(D.transformIncomingURIs(v.logsLocation)),v.workspace=D.transformIncomingURIs(v.workspace),v}}e.ExtensionHostMain=d}),define(De[303],Ce([1,0,19,11,190,207,215,86,60,42,20,41,7,50,34,233,234,35]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let f=class extends k.ExtHostDebugServiceBase{constructor(o,s,a,l,E,i,r){super(o,s,a,l,i,r),this.Z=E,this.X=new b}J(o,s){switch(o.type){case"server":return new w.SocketDebugAdapter(o);case"pipeServer":return new w.NamedPipeDebugAdapter(o);case"executable":return new w.ExecutableDebugAdapter(o,s.type)}return super.J(o,s)}S(o,s){const a=w.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(a)return new S.DebugAdapterExecutable(a.command,a.args,a.options)}K(){return new P.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(Y=>{this.X.onTerminalClosed(Y)}));const a=await this.F.getConfigProvider(),l=this.Z.getDefaultShell(!0),E=this.Z.getDefaultShellArgs(!0),i=o.title||u.localize(0,null),r=JSON.stringify({shell:l,shellArgs:E});let m=await this.X.checkout(r,i),g,h=!1;if(m)g=o.cwd;else{const Y={shellPath:l,shellArgs:E,cwd:o.cwd,name:i,iconPath:new S.ThemeIcon("debug")};h=!0,m=this.Z.createTerminalFromOptions(Y,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(m,r)}m.show(!0);const O=await m.processId;h?await new Promise(Y=>setTimeout(Y,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?m.sendText("cls"):l.indexOf("bash")>=0?m.sendText("clear"):A.isWindows?m.sendText("cls"):m.sendText("clear"));const $=(0,n.prepareCommand)(l,o.args,!!o.argsCanBeInterpretedByShell,g,o.env);m.sendText($);const x=this.onDidTerminateDebugSession(Y=>{Y.id===s&&(this.X.free(m),x.dispose())});return O}else if(o.kind==="external")return D(o,await this.F.getConfigProvider());return super.$runInTerminal(o,s)}};f=Ve([We(0,L.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,T.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,I.IExtHostVariableResolverProvider)],f),e.ExtHostDebugService=f;let v;function D(t,o){if(!v)if(A.isWindows)v=new R.WindowsExternalTerminalService;else if(A.isMacintosh)v=new R.MacExternalTerminalService;else if(A.isLinux)v=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return v.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class b{constructor(){this.b=new Map}async checkout(o,s){const l=[...this.b.entries()].map(([E,i])=>(0,c.createCancelablePromise)(async r=>{if(E.name!==s||i.lastUsedAt!==-1&&await(0,n.hasChildProcesses)(await E.processId))return null;const m=Date.now();return i.lastUsedAt+b.a>m||r.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=m,E)}));return await(0,c.firstParallel)(l,E=>!!E)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}b.a=1e3}),define(De[304],Ce([1,0,12,2,117,34,59,35,48,41,20,26,84,18,16,79,24,72,50]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends S.ExtHostTaskBase{constructor(b,t,o,s,a,l,E,i,r){super(b,t,o,s,a,l,E,i),this.B=o,this.C=r,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=S.TaskHandleDTO.from(o,this.B),a=await this.a.$getTaskExecution(s);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(a,t);return this.a.$executeTask(s).catch(()=>{}),l}else{const s=S.TaskDTO.from(t,b);if(s===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(s.execution)&&await this.x(s,t,!1);const a=await this.y(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),a}}u(b,t,o,s){const a=[];if(s)for(const l of s){this.z(l,o),(!l.definition||!b[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const E=S.TaskDTO.from(l,o.extension);E&&(a.push(E),S.CustomExecutionDTO.is(E.execution)&&t.push(this.x(E,l,!0)))}return{tasks:a,extension:o.extension}}async v(b){return b}async F(b){let t=b&&b.length>0?b[0]:void 0;if(!t){const o=A.URI.file((0,d.homedir)());t=new y.WorkspaceFolder({uri:o,name:n.basename(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,t){const o=A.URI.revive(b),s={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(o),l=await this.b.getWorkspaceFolders2()??[],E=await this.C.getResolver(),i=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const r of t.variables)s.variables[r]=await E.resolveAsync(i,r);if(t.process!==void 0){let r;if(t.process.path!==void 0){r=t.process.path.split(c.delimiter);for(let m=0;m<r.length;m++)r[m]=await E.resolveAsync(i,r[m])}s.process=await u.win32.findExecutable(await E.resolveAsync(i,t.process.name),t.process.cwd!==void 0?await E.resolveAsync(i,t.process.cwd):void 0,r)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(b,t,o){return u.win32.findExecutable(b,t,o)}};v=Ve([We(0,L.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,P.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,p.IExtHostTerminalService),We(6,C.ILogService),We(7,w.IExtHostApiDeprecationService),We(8,f.IExtHostVariableResolverProvider)],v),e.ExtHostTask=v}),define(De[305],Ce([1,0,72,50]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends A.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(De[144],Ce([1,0,17,19,21,46,18,12,24,2,31]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(f,v,D,b){this.d=f,this.e=v,this.f=D,this.g=b,this.a=null,this.b=!1,this.c=0}search(f,v){const D=this.d.folderQueries||[],b=new u.CancellationTokenSource;return v.onCancellationRequested(()=>b.cancel()),new Promise((t,o)=>{this.a=new I(f);let s=!1;const a=(l,E)=>{if(!s&&!this.b){const i=this.h(l);w(l)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,s=!0,b.cancel(),l=this.j(l,this.d.maxResults-this.c));const r=this.h(l);this.c+=r,(r>0||!w(l))&&this.a.add(l,E)}};Promise.all(D.map((l,E)=>this.k(l,i=>a(i,E),b.token))).then(l=>{b.dispose(),this.a.flush();const E=l.some(i=>!!i&&!!i.limitHit);t({limitHit:this.b||E,messages:(0,c.flatten)(l.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},l=>{b.dispose();const E=(0,R.toErrorMessage)(l);o(new Error(E))})})}h(f){return w(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,v){const D=Array.isArray(f.ranges)?f.ranges:[f.ranges],b=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:D.slice(0,v),preview:{matches:b.slice(0,v),text:f.preview.text},uri:f.uri}}async k(f,v,D){const b=new L.QueryGlobTester(this.d,f),t=[],o={report:l=>{if(!this.l(l))return;const E=f.folder.scheme===P.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(l.uri))):void 0,i=y.relativePath(f.folder,l.uri);if(i){const r=b.includedInQuery(i,k.basename(i),E);(0,A.isThenable)(r)?t.push(r.then(m=>{m&&v(l)})):r&&v(l)}}},s=this.n(f),a=await this.e.provideTextSearchResults(S(this.d.contentPattern),s,o,D);return t.length&&await Promise.all(t),a}l(f){if(w(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const v=(0,L.resolvePatternsForProvider)(this.d.includePattern,f.includePattern),D=(0,L.resolvePatternsForProvider)(this.d.excludePattern,f.excludePattern),b={folder:p.URI.from(f.folder),excludes:D,includes:v,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.f.toCanonicalName(f.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=T;function S(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class I{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new n(512,v=>this.g(v))}add(f,v){this.d&&(this.b!==v||!y.isEqual(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:f.uri,results:[]}),this.d.results.push(C(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.TextSearchResultsCollector=I;function C(d){return w(d)?{preview:{matches:(0,c.mapArrayOrNot)(d.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:d.preview.text},ranges:(0,c.mapArrayOrNot)(d.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function w(d){return!!d.preview}e.extensionResultIsMatch=w;class n{constructor(f,v){this.g=f,this.h=v,this.c=0,this.d=[],this.e=0}addItem(f,v){!f||this.j(f,v)}addItems(f,v){!f||this.k(f,v)}j(f,v){this.d.push(f),this.e+=v,this.l()}k(f,v){this.d=this.d.concat(f),this.e+=v,this.l()}l(){this.c<n.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},n.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}n.a=4e3,n.b=50,e.BatchedCollector=n}),define(De[87],Ce([1,0,6,5,4,298,20,56,16,2,144]),function(re,e,c,A,u,R,P,k,y,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let T=class{constructor(w,n,d){this.k=w,this.l=n,this.n=d,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,n){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const d=this.d++;return this.e.set(d,n),this.c.$registerTextSearchProvider(d,this.o(w)),(0,c.toDisposable)(()=>{this.g.delete(w),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(w,n){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const d=this.d++;return this.h.set(d,n),this.c.$registerFileSearchProvider(d,this.o(w)),(0,c.toDisposable)(()=>{this.i.delete(w),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(w,n,d,f){const v=S(d),D=this.h.get(w);if(D)return this.j.fileSearch(v,D,b=>{this.c.$handleFileMatch(w,n,b.map(t=>t.resource))},f);throw new Error("unknown provider: "+w)}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,n,d,f){const v=this.e.get(w);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const D=S(d);return this.q(D,v).search(t=>this.c.$handleTextMatch(w,n,t),f)}$enableExtensionHostSearch(){}q(w,n){return new L.TextSearchManager(w,n,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};T=Ve([We(0,P.IExtHostRpcService),We(1,k.IURITransformerService),We(2,y.ILogService)],T),e.ExtHostSearch=T;function S(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(I),extraFileResources:C.extraFileResources&&C.extraFileResources.map(w=>p.URI.revive(w))}}e.reviveQuery=S;function I(C){return{...C,folder:p.URI.revive(C.folder)}}}),define(De[306],Ce([1,0,91,143,34,140,35,40,59,41,84,86,87,100,55,79,142,80,49,99,78,60,141,16,50,98]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t,o,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,c.registerSingleton)(o.ILoggerService,t.ExtHostLoggerService,1),(0,c.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands,0),(0,c.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration,0),(0,c.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,c.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,c.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,0),(0,c.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(p.IExtHostTerminalService,p.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,c.registerSingleton)(n.IExtHostWindow,n.ExtHostWindow,0),(0,c.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,c.registerSingleton)(v.IExtHostSecretState,v.ExtHostSecretState,0),(0,c.registerSingleton)(D.IExtHostTelemetry,D.ExtHostTelemetry,0),(0,c.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,c.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(De[101],Ce([1,0,17,16,31,83]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=P;function k(T,S,I,C){const w=(0,c.mapArrayOrNot)(I,y),n=new u.TextSearchMatch(S,w,C),d=n.preview.matches;return{ranges:(0,c.mapArrayOrNot)(w,p),uri:T,preview:{text:n.preview.text,matches:(0,c.mapArrayOrNot)(d,p)}}}e.createTextSearchResult=k;function y(T){return new u.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function p(T){return new R.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(S,I){this.a=S,this.b=I}appendLine(S){this.b.debug(`${this.a}#search`,S)}};L=Ve([We(1,A.ILogService)],L),e.OutputChannel=L}),define(De[307],Ce([1,0,47,12,88,33,11,8,101,308]),function(re,e,c,A,u,R,P,k,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(v,D,b,t){const o=S(v,D,b,t),s=D.folder.fsPath;return{cmd:c.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=T;function S(v,D,b,t){const o=["--files","--hidden","--case-sensitive"];C([D],b,!1).forEach(a=>{const l=(0,y.anchorGlob)(a);if(o.push("-g",l),P.isMacintosh){const E=(0,u.normalizeNFD)(l);E!==l&&o.push("-g",E)}});const s=I([D],t,void 0,!1);return s.globArgs.forEach(a=>{const l=`!${(0,y.anchorGlob)(a)}`;if(o.push("-g",l),P.isMacintosh){const E=(0,u.normalizeNFD)(l);E!==l&&o.push("-g",E)}}),D.disregardIgnoreFiles!==!1?o.push("--no-ignore"):D.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),D.ignoreSymlinks||o.push("--follow"),v.exists&&o.push("--quiet"),o.push("--no-config"),D.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function I(v,D,b,t=!0){const o=[];let s={};return v.forEach(a=>{const l=Object.assign({},a.excludePattern||{},D||{}),E=w(l,t?a.folder.fsPath:void 0,b);o.push(...E.globArgs),E.siblingClauses&&(s=Object.assign(s,E.siblingClauses))}),{globArgs:o,siblingClauses:s}}function C(v,D,b=!0){const t=[];return v.forEach(o=>{const s=Object.assign({},D||{},o.includePattern||{}),a=w(s,b?o.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function w(v,D,b){const t=[],o={};return Object.keys(v).forEach(s=>{if(b&&b.has(s)||!s)return;const a=v[s];s=d(D?n(D,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof a=="boolean"&&a?(s.startsWith("\\\\")&&(s+="**"),t.push(f(s))):a&&a.when&&(o[s]=a)}),{globArgs:t,siblingClauses:o}}function n(v,D){return A.isAbsolute(D)?D:A.join(v,D)}e.getAbsoluteGlob=n;function d(v){return v=k.rtrim(v,"\\"),k.rtrim(v,"/")}function f(v){return R.getRoot(v).toLowerCase()==="c:/"?v.replace(/^c:[/\\]/i,"/"):v}e.fixDriveC=f}),define(De[309],Ce([1,0,47,71,12,310,17,46,38,88,33,11,43,8,10,29,31,307,112]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const v=new Set;process.on("exit",()=>{v.forEach(s=>s())});class D{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&y.parse(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,f.prepareQuery)(this.b).normalizedLowercase),this.u=a.excludePattern&&y.parse(a.excludePattern),this.t=new Map,a.folderQueries.forEach(l=>{const E=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),i=l.folder.fsPath;a.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==i).forEach(r=>{(0,L.isEqualOrParent)(r,i)&&(E[u.relative(i,r)]=!0)}),this.t.set(i,new t(E,i))})}cancel(){this.l=!0,v.forEach(a=>a())}walk(a,l,E,i,r){if(this.m=S.StopWatch.create(!1),this.l)return r(null,this.j);l.forEach(m=>{const g=u.basename(m.fsPath);this.u&&this.u(m.fsPath,g)||this.J(E,{relativePath:m.fsPath,searchPath:void 0})}),this.r=S.StopWatch.create(!1),this.w(a,(m,g)=>{this.x(this.y,this,m,E,i,h=>{if(h){const O=(0,k.toErrorMessage)(h);console.error(O),this.q.push(O),g(h,void 0)}else g(null,void 0)})},(m,g)=>{this.m.stop();const h=m?P.coalesce(m)[0]:null;r(h,this.j)})}w(a,l,E){const i=new Array(a.length),r=new Array(a.length);let m=!1,g=0;if(a.length===0)return E(null,[]);a.forEach((h,O)=>{l(h,($,x)=>{if($?(m=!0,i[O]=null,r[O]=$):(i[O]=x,r[O]=null),++g===a.length)return E(m?r:null,i)})})}x(a,l,...E){try{a.apply(l,E)}catch(i){E[E.length-1](i)}}y(a,l,E,i){const r=a.folder.fsPath,m=T.isMacintosh,g=()=>Y&&Y.kill();v.add(g);let h=U=>{v.delete(g),h=()=>{},i(U)},O="";const $=this.D(),x=(0,d.spawnRipgrepCmd)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),Y=x.cmd,G=!Object.keys(x.siblingClauses).length,M=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${x.rgDiskPath} ${M}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),E({message:B}),this.s=0,this.z(Y,"utf8",E,(U,j,he)=>{if(U){h(U);return}if(this.j){h();return}const V=(O+(m?p.normalizeNFC(j||""):j)).split(`
`);if(he){const J=V.length;V[J-1]=V[J-1].trim(),V[J-1]||V.pop()}else O=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){h(new Error("Splitting up files failed"));return}if(this.s+=V.length,G){for(const J of V)if(this.J(l,{base:r,relativePath:J,searchPath:this.N(a,J)}),this.j){g();break}(he||this.j)&&h();return}this.G(a,$,r,V,l),he&&(this.H($,r,l),h())})}spawnFindCmd(a){const l=this.t.get(a.folder.fsPath),E=l.getBasenameTerms(),i=l.getPathTerms(),r=["-L","."];if(E.length||i.length){r.push("-not","(","(");for(const m of E)r.push("-name",m),r.push("-o");for(const m of i)r.push("-path",m),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),c.spawn("find",r,{cwd:a.folder.fsPath})}readStdout(a,l,E){let i="";this.z(a,l,()=>{},(r,m,g)=>{if(r){E(r);return}i+=m,g&&E(null,i)})}z(a,l,E,i){let r=(h,O,$)=>{(h||$)&&(r=()=>{},this.r?.stop()),i(h,O,$)},m=!1;a.stdout?(this.A(a.stdout,l,r),a.stdout.once("data",()=>m=!0)):E({message:"stdout is null"});let g;a.stderr?g=this.B(a.stderr):E({message:"stderr is null"}),a.on("error",h=>{r(h)}),a.on("close",h=>{let O;!m&&(O=this.C(g,l))&&o(O)?r(new Error(`command failed with error code ${h}: ${this.C(g,l)}`)):(this.g&&h===0&&(this.j=!0),r(null,"",!0))})}A(a,l,E){const i=new R.StringDecoder(l);return a.on("data",r=>{E(null,i.write(r))}),i}B(a){const l=[];return a.on("data",E=>{l.push(E)}),l}C(a,l){const E=new R.StringDecoder(l);return a.map(i=>E.write(i)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:l},E,i,r){i.indexOf(this.b)!==-1&&this.J(r,{base:E,relativePath:this.b,searchPath:this.N(a,this.b)});const m=g=>{const h=u.basename(g),O=u.dirname(g);let $=l[O];$||($=l[O]=[],m(O)),$.push({base:E,relativePath:g,basename:h,searchPath:this.N(a,g)})};i.forEach(m)}H({rootEntries:a,pathToEntries:l},E,i){const r=this,m=this.t.get(E),g=this.b;function h(O){r.o++;const $=(0,n.hasSiblingFn)(()=>O.map(x=>x.basename));for(let x=0,Y=O.length;x<Y;x++){const G=O[x],{relativePath:M,basename:B}=G;if(m.test(M,B,g!==B?$:void 0))continue;const U=l[M];if(U)h(U);else{if(r.p++,M===g)continue;r.J(i,G)}if(r.j)break}}h(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,l,E,i,r){const m=a.folder,g=(0,n.hasSiblingFn)(()=>E);this.w(E,(h,O)=>{if(this.l||this.j)return O(null);const $=l?[l,h].join(u.sep):h;if(this.t.get(a.folder.fsPath).test($,h,this.a.filePattern!==h?g:void 0))return O(null);const x=[m.fsPath,$].join(u.sep);A.lstat(x,(Y,G)=>{if(Y||this.l||this.j)return O(null);this.L(x,G,(M,B)=>M||this.l||this.j?O(null):B.isDirectory()?(this.o++,this.M(x,G,(U,j)=>U||this.l||this.j||(j=j||"",this.v[j])?O(null):(this.v[j]=!0,w.Promises.readdir(x).then(he=>{if(this.l||this.j)return O(null);this.I(a,$,he,i,ie=>O(ie||null))},he=>{O(null)})))):(this.p++,$===this.b||this.h&&C.isNumber(B.size)&&B.size>this.h||this.J(i,{base:m.fsPath,relativePath:$,searchPath:this.N(a,$)}),O(null,void 0)))})},h=>{const O=h&&P.coalesce(h);return r(O&&O.length>0?O[0]:void 0)})}J(a,l){this.K(l)&&(!this.d||this.d(l.relativePath,u.basename(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(l))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,n.isFilePatternMatch)(a,this.c)}return!0}L(a,l,E){return l.isSymbolicLink()?A.stat(a,E):E(null,l)}M(a,l,E){return l.isSymbolicLink()?A.realpath(a,(i,r)=>i?E(i):E(null,r)):E(null,a)}N(a,l){return a.folderName?u.join(a.folderName,l):l}}e.FileWalker=D;class b{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new D(a)}search(a,l,E){this.c.walk(this.a,this.b,a,l,(i,r)=>{E(i,{limitHit:r,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class t{constructor(a,l){this.expression=a,this.c=l,this.d(a)}d(a){let l,E;Object.keys(a).filter(i=>a[i]).forEach(i=>{u.isAbsolute(i)?(l=l||y.getEmptyExpression(),l[i]=a[i]):(E=E||y.getEmptyExpression(),E[i]=a[i])}),this.a=l&&y.parse(l,{trimForExclusions:!0}),this.b=E&&y.parse(E,{trimForExclusions:!0})}test(a,l,E){return this.b&&this.b(a,l,E)||this.a&&this.a(u.join(this.c,a),l,E)}getBasenameTerms(){const a=[];return this.a&&a.push(...y.getBasenameTerms(this.a)),this.b&&a.push(...y.getBasenameTerms(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...y.getPathTerms(this.a)),this.b&&a.push(...y.getPathTerms(this.b)),a}}function o(s){const a=s.trim().split(`
`),l=a[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return I.uppercaseFirstLetter(a[a.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(De[311],Ce([1,0,104,22]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===s)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,P=512,k=512*8,y=512*128;var p;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(p=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(a,l){super(a),this.decodeStreamErrorKind=l}}e.DecodeStreamError=L;class T{static async create(a){let l;if(a!==e.UTF8)l=(await new Promise((i,r)=>{re(["@vscode/iconv-lite-umd"],i,r)})).getDecoder(w(a));else{const E=new TextDecoder;l={write(i){return E.decode(i,{stream:!0})},end(){return E.decode()}}}return new T(l)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function S(s,a){const l=a.minBytesRequiredForDetection??a.guessEncoding?k:P;return new Promise((E,i)=>{const r=(0,c.newWriteableStream)(x=>x.join("")),m=[];let g=0,h;const O=async()=>{try{const x=await o({buffer:A.VSBuffer.concat(m),bytesRead:g},a.guessEncoding);if(x.seemsBinary&&a.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);x.encoding=await a.overwriteEncoding(x.encoding),h=await T.create(x.encoding);const Y=h.write(A.VSBuffer.concat(m).buffer);r.write(Y),m.length=0,g=0,E({stream:r,detected:x})}catch(x){$?.dispose(),r.destroy(),i(x)}},$=(0,c.listenStream)(s,{onData:async x=>{h?r.write(h.write(x.buffer)):(m.push(x),g+=x.byteLength,g>=l&&(s.pause(),await O(),setTimeout(()=>s.resume())))},onError:x=>r.error(x),onEnd:async()=>{h||await O(),r.end(h?.end())}})})}e.toDecodeStream=S;async function I(s,a,l){const i=(await new Promise((g,h)=>{re(["@vscode/iconv-lite-umd"],g,h)})).getEncoder(w(a),l);let r=!1,m=!1;return{read(){if(m)return null;const g=s.read();if(typeof g!="string"){if(m=!0,!r&&l?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const h=i.end();return h&&h.length>0?(r=!0,A.VSBuffer.wrap(h)):null}return r=!0,A.VSBuffer.wrap(i.write(g))}}}e.toEncodeReadable=I;async function C(s){return(await new Promise((l,E)=>{re(["@vscode/iconv-lite-umd"],l,E)})).encodingExists(w(s))}e.encodingExists=C;function w(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=w;function n(s,a){if(!s||a<e.UTF16be_BOM.length)return null;const l=s.readUInt8(0),E=s.readUInt8(1);if(l===e.UTF16be_BOM[0]&&E===e.UTF16be_BOM[1])return e.UTF16be;if(l===e.UTF16le_BOM[0]&&E===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const i=s.readUInt8(2);return l===e.UTF8_BOM[0]&&E===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=n;const d=["ascii","utf-16","utf-32"];async function f(s){const a=await new Promise((m,g)=>{re(["jschardet"],m,g)}),l=s.slice(0,y),E=b(l.buffer),i=a.detect(E);if(!i||!i.encoding)return null;const r=i.encoding.toLowerCase();return 0<=d.indexOf(r)?null:D(i.encoding)}const v={ibm866:"cp866",big5:"cp950"};function D(s){const a=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[a]||a}function b(s){let a="";for(let l=0;l<s.length;l++)a+=String.fromCharCode(s[l]);return a}function t(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=s.match(/windows(\d+)/);return a?"windows-"+a[1]:s}}}e.toCanonicalName=t;function o({buffer:s,bytesRead:a},l){let E=n(s,a),i=!1;if(E!==e.UTF16be&&E!==e.UTF16le&&s){let r=!0,m=!0,g=!1;for(let h=0;h<a&&h<R;h++){const O=h%2===1,$=s.readUInt8(h)===0;if($&&(g=!0),r&&(O&&!$||!O&&$)&&(r=!1),m&&(O&&$||!O&&!$)&&(m=!1),$&&!r&&!m)break}g&&(r?E=e.UTF16le:m?E=e.UTF16be:i=!0)}return l&&!i&&!E&&s?f(s.slice(0,a)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:i,encoding:E}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[145],Ce([1,0,311,29,144]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends u.TextSearchManager{constructor(k,y,p=A,L="searchProcess"){super(k,y,{readdir:T=>p.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,c.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=R}),define(De[312],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(u){if(u&&this.a.has(u)){const R=this.a.get(u);return this.a.delete(u),R}}addDragOperationTransfer(u,R){this.a.set(u,R)}getRenderedTreeElement(u){if(this.b.has(u))return this.b.get(u)}addRenderedTreeItemElement(u,R){this.b.set(u,R)}removeRenderedTreeItemElement(u){this.b.has(u)&&this.b.delete(u)}}e.TreeviewsService=c}),define(De[313],Ce([1,0,188,7,24,2,3,6,230,19,7,10,17,13,21,312,27]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(D,b){if((0,T.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let t;return Array.isArray(D.highlights)&&(t=D.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:D.label,highlights:t}}}class f{constructor(b,t,o){this.d=b,this.e=t,this.f=o,this.a=new Map,this.b=new w.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(l=>s(l)?this.i(l):l):a})}registerTreeDataProvider(b,t,o){const s=this.createTreeView(b,{treeDataProvider:t},o);return{dispose:()=>s.dispose()}}createTreeView(b,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,E=!!t.dragAndDropController?.handleDrop,i=this.h(b,t,o),r=this.d.$registerTreeViewDataProvider(b,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:l,hasHandleDrop:E});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,n.checkProposedApiEnabled)(o,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(m){i.message=m},get title(){return i.title},set title(m){i.title=m},get description(){return i.description},set description(m){i.description=m},get badge(){return i.badge},set badge(m){m!==void 0&&L.ViewBadge.isViewBadge(m)?i.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(i.badge=void 0)},reveal:(m,g)=>i.reveal(m,g),dispose:async()=>{await r,this.a.delete(b),i.dispose()}}}$getChildren(b,t){const o=this.a.get(b);return o?o.getChildren(t):Promise.reject(new y.NoTreeViewError(b))}async $handleDrop(b,t,o,s,a,l,E,i){const r=this.a.get(b);if(!r)return Promise.reject(new y.NoTreeViewError(b));const m=I.DataTransfer.toDataTransfer(o,async g=>(await this.d.$resolveDropFileData(b,t,g)).buffer);return E===b&&i&&await this.g(m,r,i,a,l),r.onDrop(m,s,a)}async g(b,t,o,s,a){const l=this.b.removeDragOperationTransfer(a);if(l)(await l)?.forEach((E,i)=>{E&&b.set(i,E)});else if(a&&t.handleDrag){const E=t.handleDrag(o,b,s);this.b.addDragOperationTransfer(a,E),await E}return b}async $handleDrag(b,t,o,s){const a=this.a.get(b);if(!a)return Promise.reject(new y.NoTreeViewError(b));const l=await this.g(new A.DataTransfer,a,t,s,o);if(!!l)return I.DataTransfer.toDataTransferDTO(l)}async $hasResolve(b){const t=this.a.get(b);if(!t)throw new y.NoTreeViewError(b);return t.hasResolve}$resolve(b,t,o){const s=this.a.get(b);if(!s)throw new y.NoTreeViewError(b);return s.resolveTreeItem(t,o)}$setExpanded(b,t,o){const s=this.a.get(b);if(!s)throw new y.NoTreeViewError(b);s.setExpanded(t,o)}$setSelection(b,t){const o=this.a.get(b);if(!o)throw new y.NoTreeViewError(b);o.setSelection(t)}$setFocus(b,t){const o=this.a.get(b);if(!o)throw new y.NoTreeViewError(b);o.setFocus(t)}$setVisible(b,t){const o=this.a.get(b);if(!o)throw new y.NoTreeViewError(b);o.setVisible(t)}$changeCheckboxState(b,t){const o=this.a.get(b);if(!o)throw new y.NoTreeViewError(b);o.setCheckboxState(t)}h(b,t,o){const s=new v(b,t,this.d,this.e.converter,this.f,o);return this.a.set(b,s),s}i(b){const t=this.a.get(b.$treeViewId);return t&&"$treeItemHandle"in b?t.getExtensionElement(b.$treeItemHandle):t&&"$focusedTreeItem"in b&&b.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=f;class v extends k.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(b=>this.getExtensionElement(b)).filter(b=>!(0,T.isUndefinedOrNull)(b))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(b,t,o,s,a,l){if(super(),this.z=b,this.C=o,this.F=s,this.G=a,this.H=l,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.q=this.D(new P.Emitter),this.onDidExpandElement=this.q.event,this.r=this.D(new P.Emitter),this.onDidCollapseElement=this.r.event,this.s=this.D(new P.Emitter),this.onDidChangeSelection=this.s.event,this.t=this.D(new P.Emitter),this.onDidChangeVisibility=this.t.event,this.u=this.D(new P.Emitter),this.onDidChangeCheckboxState=this.u.event,this.v=this.D(new P.Emitter),this.w=Promise.resolve(),this.y=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,l.contributes&&l.contributes.views)for(const r in l.contributes.views)for(const m of l.contributes.views[r])m.id===b&&(this.J=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.D(this.f.onDidChangeTreeData(r=>this.v.fire({message:!1,element:r})));let E,i;this.D(P.Event.debounce(this.v.event,(r,m)=>(r||(r={message:!1,elements:[]}),m.element!==!1&&(E||(E=new Promise(g=>i=g),this.w=this.w.then(()=>E)),Array.isArray(m.element)?r.elements.push(...m.element):r.elements.push(m.element)),m.message&&(r.message=!0),r),200,!0)(({message:r,elements:m})=>{m.length&&(this.y=this.y.then(()=>{const g=i;return E=null,this.U(m).then(()=>g())})),r&&this.C.$setMessage(this.z,this.I)}))}async getChildren(b){const t=b?this.getExtensionElement(b):void 0;if(b&&!t)return this.G.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let o=this.Q(b);return o||(o=await this.R(t)),o?o.map(s=>s.item):void 0}getExtensionElement(b){return this.i.get(b)}reveal(b,t){t=t||{select:!0,focus:!1};const o=(0,T.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,T.isUndefinedOrNull)(t.focus)?!1:t.focus,a=(0,T.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.w.then(()=>this.N(b)).then(l=>this.P(b,l[l.length-1]).then(E=>this.C.$reveal(this.z,{item:E.item,parentChain:l.map(i=>i.item)},{select:o,focus:s,expand:a})),l=>this.G.error(l)):this.C.$reveal(this.z,void 0,{select:o,focus:s,expand:a})}get message(){return this.I}set message(b){this.I=b,this.v.fire({message:!0,element:!1})}get title(){return this.J}set title(b){this.J=b,this.C.$setTitle(this.z,b,this.L)}get description(){return this.L}set description(b){this.L=b,this.C.$setTitle(this.z,this.J,b)}get badge(){return this.M}set badge(b){this.M?.value===b?.value&&this.M?.tooltip===b?.tooltip||(this.M=I.ViewBadge.from(b),this.C.$setBadge(this.z,b))}setExpanded(b,t){const o=this.getExtensionElement(b);o&&(t?this.q.fire(Object.freeze({element:o})):this.r.fire(Object.freeze({element:o})))}setSelection(b){(0,S.equals)(this.l,b)||(this.l=b,this.s.fire(Object.freeze({selection:this.selectedElements})))}setFocus(b){this.m=b}setVisible(b){b!==this.k&&(this.k=b,this.t.fire(Object.freeze({visible:this.k})))}async setCheckboxState(b){const t=(await Promise.all(b.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.u.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(b,t,o){const s=[];for(const a of b){const l=this.getExtensionElement(a);l&&s.push(l)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,o),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,t,o){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,p.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,b,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,t){if(!this.f.resolveTreeItem)return;const o=this.i.get(b);if(o){const s=this.j.get(o);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,o,t)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(b){return this.O(b).then(t=>t?this.N(t).then(o=>this.P(t,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}O(b){const t=this.j.get(b);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,p.asPromise)(()=>this.f.getParent(b))}P(b,t){const o=this.j.get(b);return o?Promise.resolve(o):(0,p.asPromise)(()=>this.f.getTreeItem(b)).then(s=>this.gb(b,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const l=this.j.get(a);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(b){if(b){let t;if(typeof b=="string"){const o=this.getExtensionElement(b);t=o?this.j.get(o):void 0}else t=b;return t&&t.children||void 0}return this.h}async R(b){this.nb(b);const t=new C.CancellationTokenSource(this.S.token);try{const o=b?this.j.get(b):void 0,s=await this.f.getChildren(b);if(t.token.isCancellationRequested)return;const a=await Promise.all((0,S.coalesce)(s||[]).map(async l=>{const E=await this.f.getTreeItem(l);return E&&!t.token.isCancellationRequested?this.Z(l,E,o):null}));return t.token.isCancellationRequested?void 0:(0,S.coalesce)(a)}finally{t.dispose()}}U(b){if(b.some(o=>!o))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.C.$refresh(this.z);{const o=this.W(b);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(b){const t=new Set,o=b.map(a=>this.j.get(a));for(const a of o)if(a&&!t.has(a.item.handle)){let l=a;for(;l&&l.parent&&o.findIndex(E=>l&&l.parent&&E&&E.item.handle===l.parent.item.handle)===-1;){const E=this.i.get(l.parent.item.handle);l=E?this.j.get(E):void 0}l&&!l.parent&&t.add(a.item.handle)}const s=[];return t.forEach(a=>{const l=this.i.get(a);if(l){const E=this.j.get(l);E&&(!E.parent||!t.has(E.parent.item.handle))&&s.push(a)}}),s}X(b){const t={};return Promise.all(b.map(o=>this.Y(o).then(s=>{s&&(t[o]=s.item)}))).then(()=>Object.keys(t).length?this.C.$refresh(this.z,t):void 0)}Y(b){const t=this.getExtensionElement(b);if(t){const o=this.j.get(t);if(o)return this.nb(t),(0,p.asPromise)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const a=this.eb(t,s,o.parent);return this.lb(t,a,o,o.parent),o.dispose(),a}return null})}return Promise.resolve(null)}Z(b,t,o){const s=this.eb(b,t,o);if(t.id&&this.i.has(s.item.handle))throw new Error((0,c.localize)(0,null,t.id));return this.kb(b,s),this.mb(s,o),s}ab(b){return L.MarkdownString.isMarkdownString(b)?I.MarkdownString.from(b):b}bb(b,t){return t?{...this.F.toInternal(t,b),originalId:t.command}:void 0}cb(b){if(!b.checkboxState)return;let t,o;return typeof b.checkboxState=="number"?t=b.checkboxState:(t=b.checkboxState.state,o=b.checkboxState.tooltip),{isChecked:t===L.TreeItemCheckboxState.Checked,tooltip:o}}db(b){if(!L.TreeItem.isTreeItem(b,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(b,t,o){this.db(t);const s=new k.DisposableStore,a=this.gb(b,t,o),l=this.hb(t);return{item:{handle:a,parentHandle:o?o.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.ib(t)||l,themeIcon:this.fb(t),collapsibleState:(0,T.isUndefinedOrNull)(t.collapsibleState)?L.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(b){return b.iconPath instanceof L.ThemeIcon?b.iconPath:void 0}gb(b,{id:t,label:o,resourceUri:s},a,l){if(t)return`${v.b}/${t}`;const E=d(o,this.H),i=a?a.item.handle:v.a;let r=E?E.label:s?(0,u.basename)(s):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const m=this.j.has(b)?this.j.get(b).item.handle:void 0,g=this.Q(a)||[];let h,O=0;do{if(h=`${i}/${O}:${r}`,l||!this.i.has(h)||m===h)break;O++}while(O<=g.length);return h}hb(b){if(b.iconPath&&!(b.iconPath instanceof L.ThemeIcon))return typeof b.iconPath=="string"||R.URI.isUri(b.iconPath)?this.jb(b.iconPath):this.jb(b.iconPath.light)}ib(b){if(b.iconPath&&!(b.iconPath instanceof L.ThemeIcon)&&b.iconPath.dark)return this.jb(b.iconPath.dark)}jb(b){return R.URI.isUri(b)?b:R.URI.file(b)}kb(b,t){this.i.set(t.item.handle,b),this.j.set(b,t)}lb(b,t,o,s){this.i.delete(t.item.handle),this.j.delete(b),t.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(b,t);const a=this.Q(s)||[],l=a.filter(E=>E.item.handle===o.item.handle)[0];l&&a.splice(a.indexOf(l),1,t)}mb(b,t){t?(t.children||(t.children=[]),t.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}nb(b){if(b){const t=this.j.get(b);if(t){if(t.children)for(const o of t.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}t.children=void 0}}else this.pb()}ob(b){const t=this.j.get(b);if(t){if(t.children)for(const o of t.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}this.j.delete(b),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(b=>b.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.C.$disposeTree(this.z)}}v.a="0",v.b="1"}),define(De[314],Ce([1,0,21,9,3,37,2,121,108,155,166,45,5,97,256,255,40,257,35,259,260,261,244,262,59,42,263,264,269,270,271,143,247,277,278,279,100,41,281,313,13,7,75,284,82,142,34,25,236,268,74,140,84,86,87,16,56,20,26,272,243,55,79,253,282,81,80,287,285,286,254,49,280,283,99,60,78,273,83,274,18,124,246,226,265,6,27,231,98,222,275,276,267,266]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t,o,s,a,l,E,i,r,m,g,h,O,$,x,Y,G,M,B,U,j,he,ie,V,J,ne,ve,ue,ee,N,q,ae,me,ke,_,le,de,te,ce,oe,F,z,K,Z,fe,Ee,Ae,we,Pe,Ie,$e,xe,tt,Qe,it,rt,Be,et,W,Q,ge,Le,Ne,je,Ye,Xe,nt,ot,pt,bt,St,Pt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xt(ft){const vt=ft.get(te.IExtHostInitDataService),Ot=ft.get($e.IExtHostFileSystemInfo),Ut=ft.get(Ee.IExtHostConsumerFileSystem),Nt=ft.get(a.IExtHostExtensionService),wt=ft.get(ne.IExtHostWorkspace),kt=ft.get(rt.IExtHostTelemetry),At=ft.get(f.IExtHostConfiguration),Bt=ft.get(le.IURITransformerService),Ke=ft.get(de.IExtHostRpcService),Wt=ft.get(Y.IExtHostStorage),Re=ft.get(fe.IExtensionStoragePaths),Fe=ft.get(_.ILoggerService),Se=ft.get(_.ILogService),se=ft.get(F.IExtHostTunnelService),Oe=ft.get(z.IExtHostApiDeprecationService),He=ft.get(J.IExtHostWindow),Ze=ft.get(Qe.IExtHostSecretState),Ge=ft.get(it.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Fe),Ke.set(S.ExtHostContext.ExtHostWorkspace,wt),Ke.set(S.ExtHostContext.ExtHostConfiguration,At),Ke.set(S.ExtHostContext.ExtHostExtensionService,Nt),Ke.set(S.ExtHostContext.ExtHostStorage,Wt),Ke.set(S.ExtHostContext.ExtHostTunnelService,se),Ke.set(S.ExtHostContext.ExtHostWindow,He),Ke.set(S.ExtHostContext.ExtHostSecretState,Ze),Ke.set(S.ExtHostContext.ExtHostTelemetry,kt),Ke.set(S.ExtHostContext.ExtHostEditorTabs,Ge);const ct=Ke.set(S.ExtHostContext.ExtHostDecorations,ft.get(q.IExtHostDecorations)),mt=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(s.IExtHostDocumentsAndEditors)),gt=Ke.set(S.ExtHostContext.ExtHostCommands,ft.get(n.IExtHostCommands)),dt=Ke.set(S.ExtHostContext.ExtHostTerminalService,ft.get(G.IExtHostTerminalService)),lt=Ke.set(S.ExtHostContext.ExtHostDebugService,ft.get(me.IExtHostDebugService)),yt=Ke.set(S.ExtHostContext.ExtHostSearch,ft.get(ke.IExtHostSearch)),Tt=Ke.set(S.ExtHostContext.ExtHostTask,ft.get(ae.IExtHostTask)),Ht=Ke.set(S.ExtHostContext.ExtHostOutputService,ft.get(g.IExtHostOutputService)),Ft=Ke.set(S.ExtHostContext.ExtHostLocalization,ft.get(ot.IExtHostLocalizationService)),ai=Ke.set(S.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ke)),Rt=Ke.set(S.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ke,mt)),yi=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Ke,mt,Se)),ci=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Se,Rt,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),It=Ke.set(S.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,gt,mt,Rt)),li=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(It)),ui=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new Le.ExtHostNotebookEditors(Se,It)),Zt=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new Be.ExtHostNotebookKernels(Ke,vt,It,gt,Se)),Di=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new W.ExtHostNotebookRenderers(Ke,It)),Dt=Ke.set(S.ExtHostContext.ExtHostEditors,new M.ExtHostEditors(Ke,mt)),di=Ke.set(S.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),gt,Se)),$i=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),Dt,vt.remote)),ei=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Ke,Se,Ot,mt)),ii=Ke.set(S.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Ke,Rt,gt.converter,Bt)),ht=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ke,Bt,Rt,gt,ei,Se,Oe,kt)),ti=Ke.set(S.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ke,ht)),Vt=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new E.ExtHostFileSystemEventService(Ke,Se,mt)),Qt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,wt,gt)),hi=Ke.set(S.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(Ke,gt,Se)),Ci=Ke.set(S.ExtHostContext.ExtHostQuickDiff,new St.ExtHostQuickDiff(Ke,Bt)),Ii=Ke.set(S.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ke,gt,Rt)),fi=Ke.set(S.ExtHostContext.ExtHostProgress,new h.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),ki=Ke.set(S.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(Ke)),mi=Ke.set(S.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Ke)),gi=Ke.set(S.ExtHostContext.ExtHostAuthentication,new K.ExtHostAuthentication(Ke)),Ti=Ke.set(S.ExtHostContext.ExtHostTimeline,new Z.ExtHostTimeline(Ke,gt)),ni=Ke.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,vt.remote,wt,Se,Oe)),ri=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new Pe.ExtHostWebviewPanels(Ke,ni,wt)),Pi=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ke,Rt,Re,ni,ri)),zi=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Ke,ni)),Yt=Ke.set(S.ExtHostContext.ExtHostTesting,new xe.ExtHostTesting(Ke,gt,mt)),Ai=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ke)),Wi=Ke.set(S.ExtHostContext.ExtHostProfileContentHandlers,new bt.ExtHostProfileContentHandlers(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ke,It,mt,gt,Se));const Hi=Ke.set(S.ExtHostContext.ExtHostInteractiveEditor,new zt.ExtHostInteractiveEditor(Ke,Rt,Se)),Ni=Ke.set(S.ExtHostContext.ExtHostInteractiveSession,new Pt.ExtHostInteractiveSession(Ke,Se)),ji=Object.values(S.ExtHostContext);Ke.assertRegistered(ji);const Vi=new Ie.ExtHostBulkEdits(Ke,mt),xi=new w.ExtHostClipboard(Ke),si=new m.ExtHostMessageService(Ke,Se),pi=new D.ExtHostDialogs(Ke),Fi=new x.ExtHostStatusBar(Ke,gt.converter);return C.ExtHostApiCommands.register(gt),function(ze,qt,oi){const Et=function(){let be=!ze.isUnderDevelopment;function ye(){be||(Se.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(st){if(Array.isArray(st))st.forEach(Ue);else if(typeof st=="string")ye();else{const Ct=st;typeof Ct.scheme>"u"&&ye(),typeof Ct.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return st}}(),qi={getSession(be,ye,Ue){return gi.getSession(ze,be,ye,Ue)},async hasSession(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"authSession"),!!await gi.getSession(ze,be,ye,{silent:!0})},get onDidChangeSessions(){return gi.onDidChangeSessions},registerAuthenticationProvider(be,ye,Ue,st){return gi.registerAuthenticationProvider(be,ye,Ue,st)}},Gi={registerCommand(be,ye,Ue){return gt.registerCommand(!0,be,ye,Ue,void 0,ze)},registerTextEditorCommand(be,ye,Ue){return gt.registerCommand(!0,be,(...st)=>{const Ct=Dt.getActiveTextEditor();if(!Ct){Se.warn("Cannot execute "+be+" because there is no active text editor.");return}return Ct.edit(Lt=>{ye.apply(Ue,[Ct,Lt,...st])}).then(Lt=>{Lt||Se.warn("Edits from command "+be+" were not applied.")},Lt=>{Se.warn("An error occurred while running command "+be,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(be,ye,Ue)=>((0,Xe.checkProposedApiEnabled)(ze,"diffCommand"),gt.registerCommand(!0,be,async(...st)=>{const Ct=mt.activeEditor(!0);if(!Ct){Se.warn("Cannot execute "+be+" because there is no active text editor.");return}const Lt=await Dt.getDiffInformation(Ct.id);ye.apply(Ue,[Lt,...st])},void 0,void 0,ze)),executeCommand(be,...ye){return gt.executeCommand(be,...ye)},getCommands(be=!1){return gt.getCommands(be)}},Mi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return xi.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Xe.checkProposedApiEnabled)(ze,"envShellEvent"),dt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(ze,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(ze,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be){return rt.ExtHostTelemetryLogger.validateSender(be),kt.instantiateLogger(ze,be)},openExternal(be,ye){return He.openUri(be,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===vt.environment.appUriScheme)return ai.createAppUri(be);try{return await He.asExternalUri(be,{allowTunneling:!!vt.remote.authority})}catch(ye){if((0,ge.matchesScheme)(be,Q.Schemas.http)||(0,ge.matchesScheme)(be,Q.Schemas.https))return be;throw ye}},get remoteName(){return(0,N.getRemoteName)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(ze,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel}};vt.environment.extensionTestsLocationURI||Object.freeze(Mi);const Ri={createTestController(be,ye,Ue){return Yt.createTestController(ze,be,ye,Ue)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Yt.createTestObserver()},runTests(be){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Yt.runTests(be)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Yt.results}},bi=vt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Gt={getExtension(be,ye){(0,Xe.isProposedApiEnabled)(ze,"extensionsAny")||(ye=!1);const Ue=qt.mine.getExtensionDescription(be);if(Ue)return new a.Extension(Nt,ze.identifier,Ue,bi,!1);if(ye){const st=qt.all.getExtensionDescription(be);if(st)return new a.Extension(Nt,ze.identifier,st,bi,!0)}},get all(){const be=[];for(const ye of qt.mine.getAllExtensionDescriptions())be.push(new a.Extension(Nt,ze.identifier,ye,bi,!1));return be},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(ze,"extensionsAny");const be=new ve.ExtensionIdentifierSet(qt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of qt.all.getAllExtensionDescriptions()){const st=!be.has(Ue.identifier);ye.push(new a.Extension(Nt,ze.identifier,Ue,bi,st))}return ye},get onDidChange(){return(0,Xe.isProposedApiEnabled)(ze,"extensionsAny")?u.Event.any(qt.mine.onDidChange,qt.all.onDidChange):qt.mine.onDidChange}},vi={createDiagnosticCollection(be){return ei.createDiagnosticCollection(ze.identifier,be)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:be=>ei.getDiagnostics(be),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(be,ye){return ii.changeLanguage(be.uri,ye)},match(be,ye){const Ue=Rt.getDocumentData(ye.uri)?.notebook;return(0,L.score)(U.LanguageSelector.from(be),ye.uri,ye.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,ye,Ue){return ht.registerCodeActionProvider(ze,Et(be),ye,Ue)},registerDocumentPasteEditProvider(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,Et(be),ye,Ue)},registerCodeLensProvider(be,ye){return ht.registerCodeLensProvider(ze,Et(be),ye)},registerDefinitionProvider(be,ye){return ht.registerDefinitionProvider(ze,Et(be),ye)},registerDeclarationProvider(be,ye){return ht.registerDeclarationProvider(ze,Et(be),ye)},registerImplementationProvider(be,ye){return ht.registerImplementationProvider(ze,Et(be),ye)},registerTypeDefinitionProvider(be,ye){return ht.registerTypeDefinitionProvider(ze,Et(be),ye)},registerHoverProvider(be,ye){return ht.registerHoverProvider(ze,Et(be),ye,ze.identifier)},registerEvaluatableExpressionProvider(be,ye){return ht.registerEvaluatableExpressionProvider(ze,Et(be),ye,ze.identifier)},registerInlineValuesProvider(be,ye){return ht.registerInlineValuesProvider(ze,Et(be),ye,ze.identifier)},registerDocumentHighlightProvider(be,ye){return ht.registerDocumentHighlightProvider(ze,Et(be),ye)},registerLinkedEditingRangeProvider(be,ye){return ht.registerLinkedEditingRangeProvider(ze,Et(be),ye)},registerReferenceProvider(be,ye){return ht.registerReferenceProvider(ze,Et(be),ye)},registerRenameProvider(be,ye){return ht.registerRenameProvider(ze,Et(be),ye)},registerDocumentSymbolProvider(be,ye,Ue){return ht.registerDocumentSymbolProvider(ze,Et(be),ye,Ue)},registerWorkspaceSymbolProvider(be){return ht.registerWorkspaceSymbolProvider(ze,be)},registerDocumentFormattingEditProvider(be,ye){return ht.registerDocumentFormattingEditProvider(ze,Et(be),ye)},registerDocumentRangeFormattingEditProvider(be,ye){return ht.registerDocumentRangeFormattingEditProvider(ze,Et(be),ye)},registerOnTypeFormattingEditProvider(be,ye,Ue,...st){return ht.registerOnTypeFormattingEditProvider(ze,Et(be),ye,[Ue].concat(st))},registerDocumentSemanticTokensProvider(be,ye,Ue){return ht.registerDocumentSemanticTokensProvider(ze,Et(be),ye,Ue)},registerDocumentRangeSemanticTokensProvider(be,ye,Ue){return ht.registerDocumentRangeSemanticTokensProvider(ze,Et(be),ye,Ue)},registerSignatureHelpProvider(be,ye,Ue,...st){return typeof Ue=="object"?ht.registerSignatureHelpProvider(ze,Et(be),ye,Ue):ht.registerSignatureHelpProvider(ze,Et(be),ye,typeof Ue>"u"?[]:[Ue,...st])},registerCompletionItemProvider(be,ye,...Ue){return ht.registerCompletionItemProvider(ze,Et(be),ye,Ue)},registerInlineCompletionItemProvider(be,ye){return ye.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,Et(be),ye)},registerDocumentLinkProvider(be,ye){return ht.registerDocumentLinkProvider(ze,Et(be),ye)},registerColorProvider(be,ye){return ht.registerColorProvider(ze,Et(be),ye)},registerFoldingRangeProvider(be,ye){return ht.registerFoldingRangeProvider(ze,Et(be),ye)},registerSelectionRangeProvider(be,ye){return ht.registerSelectionRangeProvider(ze,be,ye)},registerCallHierarchyProvider(be,ye){return ht.registerCallHierarchyProvider(ze,be,ye)},registerTypeHierarchyProvider(be,ye){return ht.registerTypeHierarchyProvider(ze,be,ye)},setLanguageConfiguration:(be,ye)=>ht.setLanguageConfiguration(ze,be,ye),getTokenInformationAtPosition(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"tokenInformation"),ii.tokenAtPosition(be,ye)},registerInlayHintsProvider(be,ye){return ht.registerInlayHintsProvider(ze,be,ye)},createLanguageStatusItem(be,ye){return ii.createLanguageStatusItem(ze,be,ye)},registerDocumentDropEditProvider(be,ye){return ht.registerDocumentOnDropEditProvider(ze,be,ye)}},Ki={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(be,ye,Ue){const st=await(P.URI.isUri(be)?Promise.resolve($t.openTextDocument(be)):Promise.resolve(be));return Dt.showTextDocument(st,ye,Ue)},createTextEditorDecorationType(be){return Dt.createTextEditorDecorationType(ze,be)},onDidChangeActiveTextEditor(be,ye,Ue){return Dt.onDidChangeActiveTextEditor(be,ye,Ue)},onDidChangeVisibleTextEditors(be,ye,Ue){return Dt.onDidChangeVisibleTextEditors(be,ye,Ue)},onDidChangeTextEditorSelection(be,ye,Ue){return Dt.onDidChangeTextEditorSelection(be,ye,Ue)},onDidChangeTextEditorOptions(be,ye,Ue){return Dt.onDidChangeTextEditorOptions(be,ye,Ue)},onDidChangeTextEditorVisibleRanges(be,ye,Ue){return Dt.onDidChangeTextEditorVisibleRanges(be,ye,Ue)},onDidChangeTextEditorViewColumn(be,ye,Ue){return Dt.onDidChangeTextEditorViewColumn(be,ye,Ue)},onDidCloseTerminal(be,ye,Ue){return dt.onDidCloseTerminal(be,ye,Ue)},onDidOpenTerminal(be,ye,Ue){return dt.onDidOpenTerminal(be,ye,Ue)},onDidChangeActiveTerminal(be,ye,Ue){return dt.onDidChangeActiveTerminal(be,ye,Ue)},onDidChangeTerminalDimensions(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)(ze,"terminalDimensions"),dt.onDidChangeTerminalDimensions(be,ye,Ue)},onDidChangeTerminalState(be,ye,Ue){return dt.onDidChangeTerminalState(be,ye,Ue)},onDidWriteTerminalData(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(be,ye,Ue)},get state(){return He.state},onDidChangeWindowState(be,ye,Ue){return He.onDidChangeWindowState(be,ye,Ue)},showInformationMessage(be,...ye){return si.showMessage(ze,R.default.Info,be,ye[0],ye.slice(1))},showWarningMessage(be,...ye){return si.showMessage(ze,R.default.Warning,be,ye[0],ye.slice(1))},showErrorMessage(be,...ye){return si.showMessage(ze,R.default.Error,be,ye[0],ye.slice(1))},showQuickPick(be,ye,Ue){return Qt.showQuickPick(ze,be,ye,Ue)},showWorkspaceFolderPick(be){return Qt.showWorkspaceFolderPick(be)},showInputBox(be,ye){return Qt.showInput(be,ye)},showOpenDialog(be){return pi.showOpenDialog(ze,be)},showSaveDialog(be){return pi.showSaveDialog(be)},createStatusBarItem(be,ye,Ue){let st,Ct,Lt;return typeof be=="string"?(st=be,Ct=ye,Lt=Ue):(Ct=be,Lt=ye),Fi.createStatusBarEntry(ze,st,Ct,Lt)},setStatusBarMessage(be,ye){return Fi.setStatusBarMessage(be,ye)},withScmProgress(be){return Oe.report("window.withScmProgress",ze,"Use 'withProgress' instead."),fi.withProgress(ze,{location:j.ProgressLocation.SourceControl},(ye,Ue)=>be({report(st){}}))},withProgress(be,ye){return fi.withProgress(ze,be,ye)},createOutputChannel(be,ye){return Ht.createOutputChannel(be,ye,ze)},createWebviewPanel(be,ye,Ue,st){return ri.createWebviewPanel(ze,be,ye,Ue,st)},createWebviewTextEditorInset(be,ye,Ue,st){return(0,Xe.checkProposedApiEnabled)(ze,"editorInsets"),$i.createWebviewEditorInset(be,ye,Ue,st,ze)},createTerminal(be,ye,Ue){return typeof be=="object"?"pty"in be?dt.createExtensionTerminal(be):dt.createTerminalFromOptions(be):dt.createTerminal(be,ye,Ue)},registerTerminalLinkProvider(be){return dt.registerLinkProvider(be)},registerTerminalProfileProvider(be,ye){return dt.registerProfileProvider(ze,be,ye)},registerTerminalQuickFixProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(be,ze.identifier.value,ye)},registerTreeDataProvider(be,ye){return di.registerTreeDataProvider(be,ye,ze)},createTreeView(be,ye){return di.createTreeView(be,ye,ze)},registerWebviewPanelSerializer:(be,ye)=>ri.registerWebviewPanelSerializer(ze,be,ye),registerCustomEditorProvider:(be,ye,Ue={})=>Pi.registerCustomEditorProvider(ze,be,ye,Ue),registerFileDecorationProvider(be){return ct.registerFileDecorationProvider(be,ze)},registerUriHandler(be){return ai.registerUriHandler(ze.identifier,be)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(be,ye,Ue){return mi.onDidChangeActiveColorTheme(be,ye,Ue)},registerWebviewViewProvider(be,ye,Ue){return zi.registerWebviewViewProvider(ze,be,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ye,Ue){return It.onDidChangeActiveNotebookEditor(be,ye,Ue)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,ye,Ue){return ui.onDidChangeNotebookEditorSelection(be,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(be,ye,Ue){return ui.onDidChangeNotebookEditorVisibleRanges(be,ye,Ue)},showNotebookDocument(be,ye){return It.showNotebookDocument(be,ye)},registerExternalUriOpener(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)(ze,"externalUriOpener"),Ai.registerExternalUriOpener(ze.identifier,be,ye,Ue)},registerProfileContentHandler(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"profileContentHandlers"),Wi.registrProfileContentHandler(ze,be,ye)},registerQuickDiffProvider(be,ye,Ue,st){return(0,Xe.checkProposedApiEnabled)(ze,"quickDiffProvider"),Ci.registerQuickDiffProvider(Et(be),ye,Ue,st)},get tabGroups(){return Ge.tabGroups}},$t={get rootPath(){return Oe.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(be){throw A.readonly()},getWorkspaceFolder(be){return wt.getWorkspaceFolder(be)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(be){throw A.readonly()},get workspaceFile(){return wt.workspaceFile},set workspaceFile(be){throw A.readonly()},updateWorkspaceFolders:(be,ye,...Ue)=>wt.updateWorkspaceFolders(ze,be,ye||0,...Ue),onDidChangeWorkspaceFolders:function(be,ye,Ue){return wt.onDidChangeWorkspace(be,ye,Ue)},asRelativePath:(be,ye)=>wt.getRelativePath(be,ye),findFiles:(be,ye,Ue,st)=>wt.findFiles(be,ye,Ue,ze.identifier,st),findTextInFiles:(be,ye,Ue,st)=>{(0,Xe.checkProposedApiEnabled)(ze,"findTextInFiles");let Ct,Lt;return typeof ye=="object"?(Ct=ye,Lt=Ue):(Ct={},Lt=ye,st=Ue),wt.findTextInFiles(be,Ct||{},Lt,ze.identifier,st)},saveAll:be=>wt.saveAll(be),applyEdit(be,ye){return Vi.applyWorkspaceEdit(be,ze,ye)},createFileSystemWatcher:(be,ye,Ue,st)=>Vt.createFileSystemWatcher(wt,ze,be,ye,Ue,st),get textDocuments(){return Rt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw A.readonly()},openTextDocument(be){let ye;const Ue=be;if(typeof be=="string")ye=Promise.resolve(P.URI.file(be));else if(P.URI.isUri(be))ye=Promise.resolve(be);else if(!Ue||typeof Ue=="object")ye=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(st=>Rt.ensureDocumentData(st).then(Ct=>Ct.document))},onDidOpenTextDocument:(be,ye,Ue)=>Rt.onDidAddDocument(be,ye,Ue),onDidCloseTextDocument:(be,ye,Ue)=>Rt.onDidRemoveDocument(be,ye,Ue),onDidChangeTextDocument:(be,ye,Ue)=>Rt.onDidChangeDocument(be,ye,Ue),onDidSaveTextDocument:(be,ye,Ue)=>Rt.onDidSaveDocument(be,ye,Ue),onWillSaveTextDocument:(be,ye,Ue)=>ci.getOnWillSaveTextDocumentEvent(ze)(be,ye,Ue),get notebookDocuments(){return It.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ye){let Ue;if(P.URI.isUri(be))Ue=be,await It.openNotebookDocument(be);else if(typeof be=="string")Ue=P.URI.revive(await It.createNotebookDocument({viewType:be,content:ye}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,ye,Ue){return li.onDidSaveNotebookDocument(be,ye,Ue)},onDidChangeNotebookDocument(be,ye,Ue){return li.onDidChangeNotebookDocument(be,ye,Ue)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(be,ye,Ue,st){return It.registerNotebookSerializer(ze,be,ye,Ue,(0,Xe.isProposedApiEnabled)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(be,ye,Ue)=>oi.onDidChangeConfiguration(be,ye,Ue),getConfiguration(be,ye){return ye=arguments.length===1?void 0:ye,oi.getConfiguration(be,ye,ze)},registerTextDocumentContentProvider(be,ye){return yi.registerTextDocumentContentProvider(be,ye)},registerTaskProvider:(be,ye)=>(Oe.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider(ze,be,ye)),registerFileSystemProvider(be,ye,Ue){return(0,Ye.combinedDisposable)(ti.registerFileSystemProvider(ze,be,ye,Ue),Ut.addFileSystemProvider(be,ye))},get fs(){return Ut.value},registerFileSearchProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"fileSearchProvider"),yt.registerFileSearchProvider(be,ye)),registerTextSearchProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"textSearchProvider"),yt.registerTextSearchProvider(be,ye)),registerRemoteAuthorityResolver:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),Nt.registerRemoteAuthorityResolver(be,ye)),registerResourceLabelFormatter:be=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),ki.$registerResourceLabelFormatter(be)),onDidCreateFiles:(be,ye,Ue)=>Vt.onDidCreateFile(be,ye,Ue),onDidDeleteFiles:(be,ye,Ue)=>Vt.onDidDeleteFile(be,ye,Ue),onDidRenameFiles:(be,ye,Ue)=>Vt.onDidRenameFile(be,ye,Ue),onWillCreateFiles:(be,ye,Ue)=>Vt.getOnWillCreateFileEvent(ze)(be,ye,Ue),onWillDeleteFiles:(be,ye,Ue)=>Vt.getOnWillDeleteFileEvent(ze)(be,ye,Ue),onWillRenameFiles:(be,ye,Ue)=>Vt.getOnWillRenameFileEvent(ze)(be,ye,Ue),openTunnel:be=>((0,Xe.checkProposedApiEnabled)(ze,"tunnels"),se.openTunnel(ze,be).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(ze,"tunnels"),se.getTunnels()},onDidChangeTunnels:(be,ye,Ue)=>((0,Xe.checkProposedApiEnabled)(ze,"tunnels"),se.onDidChangeTunnels(be,ye,Ue)),registerPortAttributesProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"portsAttributes"),se.registerPortsAttributesProvider(be,ye)),registerTimelineProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"timeline"),Ti.registerTimelineProvider(be,ye,ze.identifier,gt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:be=>((0,Xe.checkProposedApiEnabled)(ze,"workspaceTrust"),wt.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ye,Ue)=>wt.onDidGrantWorkspaceTrust(be,ye,Ue),registerEditSessionIdentityProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(be,ye)),onWillCreateEditSessionIdentity:(be,ye,Ue)=>((0,Xe.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),wt.getOnWillCreateEditSessionIdentityEvent(ze)(be,ye,Ue))},wi={get inputBox(){return Oe.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(ze)},createSourceControl(be,ye,Ue){return hi.createSourceControl(ze,be,ye,Ue)}},Xi={createCommentController(be,ye){return Ii.createCommentController(ze,be,ye)}},Qi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(be,ye,Ue){return lt.onDidStartDebugSession(be,ye,Ue)},onDidTerminateDebugSession(be,ye,Ue){return lt.onDidTerminateDebugSession(be,ye,Ue)},onDidChangeActiveDebugSession(be,ye,Ue){return lt.onDidChangeActiveDebugSession(be,ye,Ue)},onDidReceiveDebugSessionCustomEvent(be,ye,Ue){return lt.onDidReceiveDebugSessionCustomEvent(be,ye,Ue)},onDidChangeBreakpoints(be,ye,Ue){return lt.onDidChangeBreakpoints(be,ye,Ue)},registerDebugConfigurationProvider(be,ye,Ue){return lt.registerDebugConfigurationProvider(be,ye,Ue||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ye){return lt.registerDebugAdapterDescriptorFactory(ze,be,ye)},registerDebugAdapterTrackerFactory(be,ye){return lt.registerDebugAdapterTrackerFactory(be,ye)},startDebugging(be,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?lt.startDebugging(be,ye,{parentSession:Ue}):lt.startDebugging(be,ye,Ue||{})},stopDebugging(be){return lt.stopDebugging(be)},addBreakpoints(be){return lt.addBreakpoints(be)},removeBreakpoints(be){return lt.removeBreakpoints(be)},asDebugSourceUri(be,ye){return lt.asDebugSourceUri(be,ye)}},Yi={registerTaskProvider:(be,ye)=>Tt.registerTaskProvider(ze,be,ye),fetchTasks:be=>Tt.fetchTasks(be),executeTask:be=>Tt.executeTask(ze,be),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(be,ye,Ue)=>Tt.onDidStartTask(be,ye,Ue),onDidEndTask:(be,ye,Ue)=>Tt.onDidEndTask(be,ye,Ue),onDidStartTaskProcess:(be,ye,Ue)=>Tt.onDidStartTaskProcess(be,ye,Ue),onDidEndTaskProcess:(be,ye,Ue)=>Tt.onDidEndTaskProcess(be,ye,Ue)},Ji={createNotebookController(be,ye,Ue,st,Ct){return Zt.createNotebookController(ze,be,ye,Ue,st,(0,Xe.isProposedApiEnabled)(ze,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(be,ye)=>It.registerNotebookCellStatusBarItemProvider(ze,be,ye),createRendererMessaging(be){return Di.createRendererMessaging(ze,be)},createNotebookControllerDetectionTask(be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,be)},registerKernelSourceActionProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,be,ye)},onDidChangeNotebookCellExecutionState(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(be,ye,Ue)}},_i={t(...be){if(typeof be[0]=="string"){const ye=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return Ft.getMessage(ze.identifier.value,{message:ye,args:Ue})}return Ft.getMessage(ze.identifier.value,be[0])},get bundle(){return Ft.getBundle(ze.identifier.value)},get uri(){return Ft.getBundleUri(ze.identifier.value)}},Zi={_version:1,registerInteractiveEditorSessionProvider(be){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),Hi.registerProvider(ze,be)},registerInteractiveSessionProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),Ni.registerInteractiveSessionProvider(ze,be,ye)},addInteractiveRequest(be){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),Ni.addInteractiveSessionRequest(be)}};return{version:vt.version,authentication:qi,commands:Gi,comments:Xi,debug:Qi,env:Mi,extensions:Gt,interactive:Zi,l10n:_i,languages:vi,notebooks:Ji,scm:wi,tasks:Yi,tests:Ri,window:Ki,workspace:$t,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:p.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:I.UIKind,Uri:P.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:he.TelemetryTrustedValue,LogLevel:_.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Xt}),define(De[315],Ce([1,0,316,326,327,2,328]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(T,S,I,C,w,n){const d=n.environment.useHostProxy,f=typeof d=="boolean"?d:!n.remote.isRemote,v=(0,P.createProxyResolver)({resolveProxy:b=>T.resolveProxy(b),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(b,t,...o)=>{switch(b){case P.LogLevel.Trace:C.trace(t,...o);break;case P.LogLevel.Debug:C.debug(t,...o);break;case P.LogLevel.Info:C.info(t,...o);break;case P.LogLevel.Warning:C.warn(t,...o);break;case P.LogLevel.Error:C.error(t,...o);break;case P.LogLevel.Critical:C.error(t,...o);break;case P.LogLevel.Off:break;default:s(b,t,o);break}function s(a,l,...E){C.error("Unknown log level",a),C.error(l,...E)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:f,env:process.env}),D=y(S,v);return L(I,D)}e.connectProxyResolver=k;function y(T,S){const I={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(w=>{I.config=T.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(w=>{C.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,P.createHttpPatch)(c,S,{config:"off"},C,!0)),on:Object.assign({},c,(0,P.createHttpPatch)(c,S,{config:"on"},C,!0)),override:Object.assign({},c,(0,P.createHttpPatch)(c,S,{config:"override"},C,!0)),onRequest:Object.assign({},c,(0,P.createHttpPatch)(c,S,I,C,!0)),default:Object.assign(c,(0,P.createHttpPatch)(c,S,I,C,!1))},https:{off:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"off"},C,!0)),on:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"on"},C,!0)),override:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"override"},C,!0)),onRequest:Object.assign({},A,(0,P.createHttpPatch)(A,S,I,C,!0)),default:Object.assign(A,(0,P.createHttpPatch)(A,S,I,C,!1))},tls:Object.assign(u,(0,P.createTlsPatch)(u))}}const p=new Map;function L(T,S){return T.getExtensionPathIndex().then(I=>{const C=globalThis._VSCODE_NODE_MODULES.module,w=C._load;C._load=function(d,f,v){if(d==="tls")return S.tls;if(d!=="http"&&d!=="https")return w.apply(this,arguments);const D=S[d],b=I.findSubstr(R.URI.file(f.filename));let t=p.get(b);if(t||p.set(b,t={}),!t[d]){const o=D.default;t[d]={...o}}return t[d]}})}}),define(De[146],Ce([1,0,47,329,310,17,61,38,12,8,2,31,83,330,308,101]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const n=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(h){this.a=h}provideTextSearchResults(h,O,$,x){return this.a.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...O,folder:O.folder.toString()})}`),new Promise((Y,G)=>{x.onCancellationRequested(()=>J());const M=o(h,O),B=O.folder.fsPath,U=M.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");this.a.appendLine(`${n} ${U}
 - cwd: ${B}`);let j=c.spawn(n,M,{cwd:B});j.on("error",N=>{console.error(N),this.a.appendLine("Error: "+(N&&N.message)),G((0,T.serializeSearchError)(new T.SearchError(N&&N.message,T.SearchErrorCode.rgProcessError)))});let he=!1;const ie=new D(O.maxResults,B,O.previewOptions);ie.on("result",N=>{he=!0,ve="",$.report(N)});let V=!1;const J=()=>{V=!0,j?.kill(),ie?.cancel()};let ne=!1;ie.on("hitLimit",()=>{ne=!0,J()});let ve="";j.stdout.on("data",N=>{ie.handleData(N),he||(ve+=N)});let ue=!1;j.stdout.once("data",()=>ue=!0);let ee="";j.stderr.on("data",N=>{const q=N.toString();this.a.appendLine(q),ee.length+q.length<1e6&&(ee+=q)}),j.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(he?"Got result from parser":"No result from parser"),ve&&this.a.appendLine(`Got data without result: ${ve}`),this.a.appendLine(""),V)Y({limitHit:ne});else{ie.flush(),j=null;let N;ee&&!ue&&(N=f(ee))?G((0,T.serializeSearchError)(new T.SearchError(N.message,N.code))):Y({limitHit:ne})}})})}}e.RipgrepTextSearchEngine=d;function f(g){const h=g.split(`
`),O=h[0].trim();if(h.some(x=>x.startsWith("regex parse error")))return new T.SearchError(v(h),T.SearchErrorCode.regexParseError);const $=O.match(/grep config error: unknown encoding: (.*)/);if($)return new T.SearchError(`Unknown encoding: ${$[1]}`,T.SearchErrorCode.unknownEncoding);if(O.startsWith("error parsing glob"))return new T.SearchError(O.charAt(0).toUpperCase()+O.substr(1),T.SearchErrorCode.globParseError);if(O.startsWith("the literal"))return new T.SearchError(O.charAt(0).toUpperCase()+O.substr(1),T.SearchErrorCode.invalidLiteral);if(O.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(O,T.SearchErrorCode.regexParseError)}function v(g){const h=["Regex parse error"],O=g.filter($=>$.startsWith("PCRE2:"));if(O.length>=1){const $=O[0].replace("PCRE2:","");if($.indexOf(":")!==-1&&$.split(":").length>=2){const x=$.split(":")[1];h.push(":"+x)}}return h.join("")}class D extends A.EventEmitter{constructor(h,O,$){super(),this.g=h,this.h=O,this.j=$,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new u.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(h,O){return super.on(h,O),this}handleData(h){if(this.b)return;const O=typeof h=="string"?h:this.d.write(h);this.k(O)}k(h){let O=h.indexOf(`
`);const $=this.a+h;if(O>=0)O+=this.a.length;else{this.a=$;return}let x=0;for(;O>=0;)this.m($.substring(x,O).trim()),x=O+1,O=$.indexOf(`
`,x);this.a=$.substring(x)}m(h){if(this.b||!h)return;let O;try{O=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(O.type==="match"){const $=b(O.data.path),x=L.URI.file(y.join(this.h,$)),Y=this.n(O.data,x);this.p(Y),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(O.type==="context"){const $=b(O.data.path),x=L.URI.file(y.join(this.h,$));this.o(O.data,x).forEach(G=>this.p(G))}}n(h,O){const $=h.line_number-1,x=b(h.lines),Y=Buffer.from(x);let G=0,M=0,B=$;h.submatches.length===0&&h.submatches.push(x.length?{start:0,end:1,match:{text:x[0]}}:{start:0,end:0,match:{text:""}});const U=(0,R.coalesce)(h.submatches.map((j,he)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=b(j.match),V=Y.slice(G,j.start).toString(),J=t(V),ne=J.numLines>0?J.lastLineLength:J.lastLineLength+M,ve=t(ie),ue=J.numLines+B,ee=ve.numLines+ue,N=ve.numLines>0?ve.lastLineLength:ve.lastLineLength+ne;return G=j.end,M=N,B=ee,new S.Range(ue,ne,ee,N)}));return(0,w.createTextSearchResult)(O,x,U,this.j)}o(h,O){const $=b(h.lines),x=h.line_number;return $.replace(/\r?\n$/,"").split(`
`).map((Y,G)=>({text:Y,uri:O,lineNumber:x+G}))}p(h){this.emit("result",h)}}e.RipgrepParser=D;function b(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function t(g){const h=/\n/g;let O=0,$=-1,x;for(;x=h.exec(g);)O++,$=x.index;const Y=$>=0?g.length-$-1:g.length;return{numLines:O,lastLineLength:Y}}function o(g,h){const O=["--hidden"];O.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:$,otherIncludes:x}=(0,P.groupBy)(h.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(x&&x.length){const G=new Set;x.forEach(M=>{G.add(M)}),O.push("-g","!*"),G.forEach(M=>{s(M).map(w.anchorGlob).forEach(B=>{O.push("-g",B)})})}$&&$.length&&$.forEach(G=>{O.push("-g",G)}),h.excludes.map(w.anchorGlob).forEach(G=>O.push("-g",`!${G}`)),h.maxFileSize&&O.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||O.push("--no-ignore-parent"):O.push("--no-ignore"),h.followSymlinks&&O.push("--follow"),h.encoding&&h.encoding!=="utf8"&&O.push("--encoding",h.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,p.escapeRegExpCharacters)(g.pattern),g.isRegExp=!0),h.usePCRE2&&O.push("--pcre2"),O.push("--crlf"),g.isRegExp&&(g.pattern=a(g.pattern),O.push("--engine","auto"));let Y;if(g.isWordMatch){const M=(0,p.createRegExp)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");O.push("--regexp",M)}else if(g.isRegExp){let G=E(g.pattern);G=i(G),O.push("--regexp",G)}else Y=g.pattern,O.push("--fixed-strings");return O.push("--no-config"),h.useGlobalIgnoreFiles||O.push("--no-ignore-global"),O.push("--json"),g.isMultiline&&O.push("--multiline"),h.beforeContext&&O.push("--before-context",h.beforeContext+""),h.afterContext&&O.push("--after-context",h.afterContext+""),O.push("--"),Y&&O.push(Y),O.push("."),O}e.getRgArgs=o;function s(g){return m(g).flatMap(O=>{const $=(0,k.splitGlobAware)(O,"/");return $.map((x,Y)=>$.slice(0,Y+1).join("/"))})}function a(g){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(h);)g=g.replace(h,"$1\\x{$2}");const O=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(O);)g=g.replace(O,"$1\\x{$2}");return g}e.unicodeEscapesToPCRE2=a;const l=g=>g.type==="Assertion"&&g.kind==="lookbehind";function E(g){let h;try{h=new I.RegExpParser().parsePattern(g)}catch{return g}let O="",$=0;const x=(M,B,U)=>{O+=g.slice($,M)+U,$=B},Y=[];return new I.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=Y[0];if(!B)x(M.start,M.end,"\\r?\\n");else if(!Y.some(l))if(B.type==="CharacterClass")if(B.negate){const U=g.slice(B.start+2,M.start)+g.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?x(B.start,B.end,U?`[^${U}]`:"."):x(B.start,B.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=g.slice(B.start+1,M.start)+g.slice(M.end,B.end-1);x(B.start,B.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else B.type==="Quantifier"&&x(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){Y.unshift(M)},onQuantifierLeave(){Y.shift()},onCharacterClassRangeEnter(M){Y.unshift(M)},onCharacterClassRangeLeave(){Y.shift()},onCharacterClassEnter(M){Y.unshift(M)},onCharacterClassLeave(){Y.shift()},onAssertionEnter(M){l(M)&&Y.push(M)},onAssertionLeave(M){Y[0]===M&&Y.shift()}}).visit(h),O+=g.slice($),O}e.fixRegexNewline=E;function i(g){return g.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function r(g){let h=!1,O=!1,$="",x="";for(let Y=0;Y<g.length;Y++){const G=g[Y];switch(G){case"\\":O?(h?x+="\\"+G:$+="\\"+G,O=!1):O=!0;break;case"{":if(O)h?x+=G:$+=G,O=!1;else{if(h)return{strInBraces:$+"{"+x+"{"+g.substring(Y+1)};h=!0}break;case"}":if(O)h?x+=G:$+=G,O=!1;else{if(h)return{fixedStart:$,strInBraces:x,fixedEnd:g.substring(Y+1)};$+=G}break;default:h?x+=(O?"\\":"")+G:$+=(O?"\\":"")+G,O=!1;break}}return{strInBraces:$+(h?"{"+x:"")}}function m(g){const{fixedStart:h,strInBraces:O,fixedEnd:$}=r(g);if(h===void 0||$===void 0)return[O];let x=(0,k.splitGlobAware)(O,",");x.length||(x=[""]);const Y=m($);return x.flatMap(G=>{const M=h+G;return Y.map(B=>M+B)})}e.performBraceExpansionForRipgrep=m}),define(De[317],Ce([1,0,21,146,125,18]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(p){this.b=p,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(p,L,T,S){const I=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:R.Schemas.file})},w=new u.Progress(n=>T.report({...n,uri:n.uri.with({scheme:L.folder.scheme})}));return this.c(S,n=>I.provideTextSearchResults(p,C,w,n))}else return this.c(S,C=>I.provideTextSearchResults(p,L,T,C))}async c(p,L){const T=k(p);this.a.add(T);const S=await L(T.token);return this.a.delete(T),S}d(){this.a.forEach(p=>p.cancel())}}e.RipgrepSearchProvider=P;function k(y){const p=new c.CancellationTokenSource;return y.onCancellationRequested(()=>p.cancel()),p}}),define(De[318],Ce([1,0,29,146,145]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,p,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(I){L({message:I})}},S=new u.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(T),c);return new Promise((I,C)=>S.search(w=>{p(w.map(P))},y).then(w=>I({limitHit:w.limitHit,type:"success",stats:w.stats}),C))}}e.TextSearchEngineAdapter=R;function P(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,p)=>{if(p.ranges){const L=p;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(De[319],Ce([1,0,17,19,9,3,112,12,43,2,45,31,309,318]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(D="searchProcess"){this.d=D,this.b=Object.create(null)}fileSearch(D){let b;const t=d(D),o=new R.Emitter({onDidAddFirstListener:()=>{b=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(S.Engine,t,a=>o.fire(a),s)),b.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return o.event}textSearch(D){let b;const t=d(D),o=new R.Emitter({onDidAddFirstListener:()=>{b=(0,A.createCancelablePromise)(s=>this.f(t,a=>o.fire(a),s)),b.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return o.event}f(D,b,t){return D.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(D).search(t,b,b)}doFileSearch(D,b,t){return this.doFileSearchWithEngine(S.Engine,D,b,t)}doFileSearchWithEngine(D,b,t,o,s=C.a){let a=0;const l=i=>{Array.isArray(i)?(a+=i.length,t(i.map(r=>this.g(r)))):i.relativePath?(a++,t(this.g(i))):t(i)};if(b.sortByScore){let i=this.k(b,l,o);if(!i){const r=b.maxResults?Object.assign({},b,{maxResults:null}):b,m=new D(r);i=this.h(m,b,t,l,o)}return new Promise((r,m)=>{i.then(([g,h])=>{const O=h.map($=>this.g($));this.n(O,t,s),r(g)},m)})}const E=new D(b);return this.q(E,l,s,o).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}g(D){return{path:D.base?(0,k.join)(D.base,D.relativePath):D.relativePath}}h(D,b,t,o,s){const a=new R.Emitter;let l=(0,A.createCancelablePromise)(i=>{let r=[];const m=g=>{Array.isArray(g)?r=g:(o(g),a.fire(g))};return this.q(D,m,-1,i).then(g=>[g,r])}),E;if(b.cacheKey){E=this.j(b.cacheKey);const i={promise:l,event:a.event,resolved:!1};E.resultsToSearchCache[b.filePattern||""]=i,l.then(()=>{i.resolved=!0},r=>{delete E.resultsToSearchCache[b.filePattern||""]}),l=this.r(l)}return l.then(([i,r])=>{const m=E?E.scorerCache:Object.create(null),g=(typeof b.maxResults!="number"||b.maxResults>0)&&y.StopWatch.create(!1);return this.l(b,r,m,s).then(h=>{const O=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:O,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:h.length},messages:i.messages,limitHit:i.limitHit||typeof b.maxResults=="number"&&r.length>b.maxResults},h]})})}j(D){const b=this.b[D];return b||(this.b[D]=new w)}k(D,b,t){const o=D.cacheKey&&this.b[D.cacheKey];if(!o)return;const s=this.o(o,D.filePattern||"",b,t);if(s)return s.then(([a,l,E])=>{const i=y.StopWatch.create(!1);return this.l(D,l,o.scorerCache,t).then(r=>{const m=i.elapsed(),g={fromCache:!0,detailStats:E,type:this.d,resultCount:l.length,sortingTime:m};return[{type:"success",limitHit:a.limitHit||typeof D.maxResults=="number"&&l.length>D.maxResults,stats:g},r]})})}l(D,b,t,o){const s=(0,P.prepareQuery)(D.filePattern||""),a=(E,i)=>(0,P.compareItemsByFuzzyScore)(E,i,s,!0,n,t),l=typeof D.maxResults=="number"?D.maxResults:Number.MAX_VALUE;return c.topAsync(b,a,l,1e4,o)}n(D,b,t){if(t&&t>0)for(let o=0;o<D.length;o+=t)b(D.slice(o,o+t));else b(D)}o(D,b,t,o){const s=y.StopWatch.create(!1),a=b.indexOf(k.sep)>=0;let l;for(const m in D.resultsToSearchCache)if(b.startsWith(m)){if(a&&m.indexOf(k.sep)<0&&m!=="")continue;const g=D.resultsToSearchCache[m];l={promise:this.r(g.promise),event:g.event,resolved:g.resolved};break}if(!l)return null;const E=s.elapsed(),i=y.StopWatch.create(!1),r=l.event(t);return o&&o.onCancellationRequested(()=>{r.dispose()}),l.promise.then(([m,g])=>{if(o&&o.isCancellationRequested)throw(0,u.canceled)();const h=[],O=(0,P.prepareQuery)(b).normalizedLowercase;for(const $ of g)!(0,T.isFilePatternMatch)($,O)||h.push($);return[m,h,{cacheWasResolved:l.resolved,cacheLookupTime:E,cacheFilterTime:i.elapsed(),cacheEntryCount:g.length}]})}q(D,b,t,o){return new Promise((s,a)=>{let l=[];o?.onCancellationRequested(()=>D.cancel()),D.search(E=>{E&&(t?(l.push(E),t>0&&l.length>=t&&(b(l),l=[])):b(E))},E=>{b(E)},(E,i)=>{l.length&&b(l),E?a(E):s(i)})})}clearCache(D){return delete this.b[D],Promise.resolve(void 0)}r(D){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,t){return D.then(b,t)}catch(b){return this.then(void 0,b)}finally(b){return D.finally(b)}}}}C.a=512,e.SearchService=C;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(v){return(0,k.basename)(v.relativePath)}getItemDescription(v){return(0,k.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function d(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(f),extraFileResources:v.extraFileResources&&v.extraFileResources.map(D=>p.URI.revive(D))}}function f(v){return{...v,folder:p.URI.revive(v.folder)}}}),define(De[320],Ce([1,0,6,18,2,29,16,26,20,87,56,31,319,317,101,145]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let n=class extends p.ExtHostSearch{constructor(f,v,D,b){super(f,D,b),this.s=R,this.t=-1,this.v=null,this.w=!1;const t=new C.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new I.RipgrepSearchProvider(t)),v.remote.isRemote&&v.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const f=new C.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new I.RipgrepSearchProvider(f)),this.y(A.Schemas.file,new S.SearchService("fileSearchProvider"))}y(f,v){const D=this.d++;return this.v=v,this.t=D,this.c.$registerFileSearchProvider(D,this.o(f)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(D)})}$provideFileSearchResults(f,v,D,b){const t=(0,p.reviveQuery)(D);return f===this.t?this.z(f,v,t,b):super.$provideFileSearchResults(f,v,D,b)}z(f,v,D,b){const t=o=>{if((0,T.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(f,v,o.map(s=>u.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(D,t,b)}$clearCache(f){return this.v?.clearCache(f),super.$clearCache(f)}q(f,v){return new w.NativeTextSearchManager(f,v,void 0,"textSearchProvider")}};n=Ve([We(0,y.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,P.ILogService)],n),e.NativeExtHostSearch=n}),define(De[147],Ce([1,0,331,132,72,332,22,9,3,6,12,11,30,118,119]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(g,h){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,h)}constructor(g,h=""){this.f=!0,this.debugLabel=h,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}},this.socket.on("error",this.a),this.b=O=>{this.traceSocketEvent("close",{hadError:O}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const h=O=>{this.traceSocketEvent("read",O),g(P.VSBuffer.wrap(O))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(g){const h=O=>{g({type:0,hadError:O,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(g){const h=()=>{g()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,k.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,k.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=w;var n;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(n||(n={}));var d;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(d||(d={}));class f extends p.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,h){this.socket.traceSocketEvent(g,h)}constructor(g,h,O,$){super(),this.f=this.D(new y.Emitter),this.g=this.D(new y.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:O?.byteLength||0,recordInflateBytes:$}),this.a=this.D(new v(this,h,O,$,this.f,(x,Y)=>this.k(x,Y))),this.D(this.a.onError(x=>{console.error(x),(0,k.onUnexpectedError)(x),this.g.fire({type:0,hadError:!0,error:x})})),this.b=new C.ChunkStream,this.D(this.socket.onData(x=>this.l(x))),this.D(this.socket.onClose(async x=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(x)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let h=0;for(;h<g.byteLength;)this.a.writeMessage(g.slice(h,Math.min(h+262144,g.byteLength))),h+=262144}k(g,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let O=2;g.byteLength<126?O+=0:g.byteLength<2**16?O+=2:O+=8;const $=P.VSBuffer.alloc(O);if(h?$.writeUInt8(194,0):$.writeUInt8(130,0),g.byteLength<126)$.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){$.writeUInt8(126,1);let x=1;$.writeUInt8(g.byteLength>>>8&255,++x),$.writeUInt8(g.byteLength>>>0&255,++x)}else{$.writeUInt8(127,1);let x=1;$.writeUInt8(0,++x),$.writeUInt8(0,++x),$.writeUInt8(0,++x),$.writeUInt8(0,++x),$.writeUInt8(g.byteLength>>>24&255,++x),$.writeUInt8(g.byteLength>>>16&255,++x),$.writeUInt8(g.byteLength>>>8&255,++x),$.writeUInt8(g.byteLength>>>0&255,++x)}this.socket.write(P.VSBuffer.concat([$,g]))}end(){this.h=!0,this.socket.end()}l(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),O=h.readUInt8(0),$=(O&128)>>>7,x=(O&64)>>>6,Y=h.readUInt8(1),G=(Y&128)>>>7,M=Y&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=$,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(x)),this.j.firstFrameOfMessage=Boolean($),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),O=h.readUInt8(1),$=(O&128)>>>7;let x=O&127,Y=1;x===126?x=h.readUInt8(++Y)*2**8+h.readUInt8(++Y):x===127&&(x=h.readUInt8(++Y)*0+h.readUInt8(++Y)*0+h.readUInt8(++Y)*0+h.readUInt8(++Y)*0+h.readUInt8(++Y)*2**24+h.readUInt8(++Y)*2**16+h.readUInt8(++Y)*2**8+h.readUInt8(++Y));let G=0;$&&(G=h.readUInt8(++Y)*2**24+h.readUInt8(++Y)*2**16+h.readUInt8(++Y)*2**8+h.readUInt8(++Y)),this.j.state=3,this.j.readLen=x,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),t(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class v extends p.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.VSBuffer.alloc(0)}constructor(g,h,O,$,x,Y){super(),this.l=g,this.m=x,this.n=Y,this.a=this.D(new y.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new y.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new y.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,h?(this.b=this.D(new D(this.l,$,O,{windowBits:15})),this.f=this.D(new b(this.l,{windowBits:15})),this.D(this.b.onError(G=>this.a.fire(G))),this.D(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(g){this.g.push(g),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const g=this.g.shift();if(this.f){const h=await this.r(this.f,g);this.n(h,!0)}else this.n(g,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(g,h){return new Promise((O,$)=>{g.write(h),g.flush(x=>O(x))})}acceptFrame(g,h,O){this.h.push({data:g,isCompressed:h,isLastFrameOfMessage:O}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const h=await this.u(this.b,g.data,g.isLastFrameOfMessage);this.m.fire(h)}else this.m.fire(g.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(g,h,O){return new Promise(($,x)=>{g.write(h),O&&g.write(P.VSBuffer.fromByteArray([0,0,255,255])),g.flush(Y=>$(Y))})}}class D extends p.Disposable{get recordedInflateBytes(){return this.j?P.VSBuffer.concat(this.f):P.VSBuffer.alloc(0)}constructor(g,h,O,$){super(),this.h=g,this.j=h,this.a=this.D(new y.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)($),this.b.on("error",x=>{this.h.traceSocketEvent("zlibInflateError",{message:x?.message,code:x?.code}),this.a.fire(x)}),this.b.on("data",x=>{this.h.traceSocketEvent("zlibInflateData",x),this.g.push(P.VSBuffer.wrap(x))}),O&&(this.h.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this.b.write(O.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=P.VSBuffer.concat(this.g);this.g.length=0,g(h)})}}class b extends p.Disposable{constructor(g,h){super(),this.g=g,this.a=this.D(new y.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",O=>{this.g.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.g.traceSocketEvent("zlibDeflateData",O),this.f.push(P.VSBuffer.wrap(O))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=P.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),g(h)})}}function t(m,g){if(g===0)return;const h=m.byteLength>>>2;for(let M=0;M<h;M++){const B=m.readUInt32BE(M*4);m.writeUInt32BE(B^g,M*4)}const O=h*4,$=m.byteLength-O,x=g>>>24&255,Y=g>>>16&255,G=g>>>8&255;$>=1&&m.writeUInt8(m.readUInt8(O)^x,O),$>=2&&m.writeUInt8(m.readUInt8(O+1)^Y,O+1),$>=3&&m.writeUInt8(m.readUInt8(O+2)^G,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const g=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,u.tmpdir)(),h=(0,L.join)(g,`vscode-ipc-${m}.sock`);return l(h),h}e.createRandomIPCHandle=s;function a(m,g,h){const O=(0,c.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${h}-${g}-sock`;const $=h.substr(0,4),x=g.substr(0,6),Y=O.substr(0,8);let G;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?G=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${Y}-${$}-${x}.sock`):G=(0,L.join)(m,`${$}-${x}.sock`),l(G),G}e.createStaticIPCHandle=a;function l(m){const g=o[T.platform];typeof g=="number"&&m.length>=g&&console.warn(`WARNING: IPC handle "${m}" is longer than ${g} chars, try a shorter --user-data-dir`)}class E extends I.IPCServer{static b(g){const h=y.Event.fromNodeEventEmitter(g,"connection");return y.Event.map(h,O=>({protocol:new C.Protocol(new w(O,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(O,"close"))}))}constructor(g){super(E.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=E;function i(m){return new Promise((g,h)=>{const O=(0,A.createServer)();O.on("error",h),O.listen(m,()=>{O.removeListener("error",h),g(new E(O))})})}e.serve=i;function r(m,g){return new Promise((h,O)=>{const $=(0,A.createConnection)(m,()=>{$.removeListener("error",O),h(C.Client.fromSocket(new w($,`ipc-client${g}`),g))});$.once("error",O)})}e.connect=r}),define(De[321],Ce([1,0,147,316,71,40,2,16,48]),function(re,e,c,A,u,R,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class p{constructor(S,I,C){this.b=S,this.c=I,this.f=C,this.a=A.createServer((w,n)=>this.h(w,n)),this.g().catch(w=>(I.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",S=>this.c.error(S))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(S,I){const C=(n,d)=>{I.writeHead(n,{"content-type":"application/json"}),I.end(JSON.stringify(d||null),f=>f&&this.c.error(f))},w=[];S.setEncoding("utf8"),S.on("data",n=>w.push(n)),S.on("end",async()=>{try{const n=JSON.parse(w.join(""));let d;switch(n.type){case"open":d=await this.i(n);break;case"openExternal":d=await this.j(n);break;case"status":d=await this.l(n);break;case"extensionManagement":d=await this.k(n);break;default:C(404,`Unknown message type: ${n.type}`);break}C(200,d)}catch(n){const d=n instanceof Error?n.message:JSON.stringify(n);C(500,d),this.c.error("Error while processing pipe request",n)}})}async i(S){const{fileURIs:I,folderURIs:C,forceNewWindow:w,diffMode:n,mergeMode:d,addMode:f,forceReuseWindow:v,gotoLineMode:D,waitMarkerFilePath:b,remoteAuthority:t}=S,o=[];if(Array.isArray(C))for(const E of C)try{o.push({folderUri:P.URI.parse(E)})}catch{}if(Array.isArray(I))for(const E of I)try{(0,y.hasWorkspaceFileExtension)(E)?o.push({workspaceUri:P.URI.parse(E)}):o.push({fileUri:P.URI.parse(E)})}catch{}const s=b?P.URI.file(b):void 0,l={forceNewWindow:w,diffMode:n,mergeMode:d,addMode:f,gotoLineMode:D,forceReuseWindow:v,preferNewWindow:!v&&!s&&!f,waitMarkerFileURI:s,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",o,l),""}async j(S){for(const I of S.uris){const C=P.URI.parse(I),w=C.scheme==="file"?C:I;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k(S){const I=w=>w?.map(n=>/\.vsix$/i.test(n)?P.URI.parse(n):n),C={list:S.list,install:I(S.install),uninstall:I(S.uninstall),force:S.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(S){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&u.existsSync(this.f)&&u.unlinkSync(this.f)}}e.CLIServerBase=p;let L=class extends p{constructor(S,I){super(S,I,(0,c.createRandomIPCHandle)())}};L=Ve([We(0,R.IExtHostCommands),We(1,k.ILogService)],L),e.CLIServer=L}),define(De[322],Ce([1,0,85,314,301,315,42,289,2,18,7,321,116,288]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends u.RequireInterceptor{j(){const d=this,f=globalThis._VSCODE_NODE_MODULES.module,v=f._load;f._load=function(o,s,a){return o=b(o),d.a.has(o)?d.a.get(o).load(o,y.URI.file((0,S.realpathSync)(s.filename)),l=>v.apply(this,[l,s,a])):v.apply(this,arguments)};const D=f._resolveLookupPaths;f._resolveLookupPaths=(t,o)=>D.call(this,b(t),o);const b=t=>{for(const o of d.b){const s=o(t);if(s){t=s;break}}return t}}}class w extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async pb(){this.h.createInstance(I.ExtHostConsoleForwarder);const d=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(k.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const D=this.h.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=D.ipcHandlePath}await this.h.createInstance(C,d,{mine:this.F,all:this.G}).install(),c.mark("code/extHost/didInitAPI");const v=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,v,this,this.l,this.t,this.f),c.mark("code/extHost/didInitProxyResolver")}qb(d){return d.main}async rb(d,f,v){if(f.scheme!==p.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let D=null;v.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this.l.flush();const b=d?.identifier.value;d&&await this.q.initializeLocalizedMessages(d);try{b&&c.mark(`code/extHost/willLoadExtensionCode/${b}`),D=re.__$__nodeRequire(f.fsPath)}finally{b&&c.mark(`code/extHost/didLoadExtensionCode/${b}`),v.codeLoadingStop()}return D}async $setRemoteEnvironment(d){if(!!this.f.remote.isRemote)for(const f in d){const v=d[f];v===null?delete process.env[f]:process.env[f]=v}}}e.ExtHostExtensionService=w}),define(De[323],Ce([1,0,91,292,304,303,320,322,293,86,42,87,84,41,55,81,291,290,16,305,50,224,90]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d,f,v,D,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,k.ExtHostExtensionService,0),(0,c.registerSingleton)(f.ILoggerService,d.ExtHostLoggerService,1),(0,c.registerSingleton)(f.ILogService,new t.SyncDescriptor(b.ExtHostLogService,[!1],!0)),(0,c.registerSingleton)(w.IExtensionStoragePaths,n.ExtensionStoragePaths,0),(0,c.registerSingleton)(p.IExtHostDebugService,R.ExtHostDebugService,0),(0,c.registerSingleton)(T.IExtHostSearch,P.NativeExtHostSearch,0),(0,c.registerSingleton)(S.IExtHostTask,u.ExtHostTask,0),(0,c.registerSingleton)(I.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,c.registerSingleton)(C.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,c.registerSingleton)(D.IExtHostVariableResolverProvider,v.NodeExtHostVariableResolverProviderService,0)}),define(De[333],Ce([1,0,132,334,85,9,119,147,212,97,302,22,29,116,19,121,229,241,306,323]),function(re,e,c,A,u,R,P,k,y,p,L,T,S,I,C,w,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let E=0;E<process.execArgv.length;E++)process.execArgv[E]==="--inspect-port=0"&&(process.execArgv.splice(E,1),E--)}();const f=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,E=l._load;l._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return E.apply(this,arguments)}})();const v=process.exit.bind(process);function D(l){process.exit=function(E){if(l)v(E);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const E=new Error("An extension called process.crash() and this was prevented.");console.warn(E.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(l){v()};function t(){const l=(0,d.readExtHostConnection)(process.env);if(l.type===3)return new Promise((E,i)=>{const r=m=>{const g=m[0],h=new P.BufferedEmitter;g.on("message",O=>h.fire(T.VSBuffer.wrap(O.data))),g.on("close",()=>{b("renderer closed the MessagePort")}),g.start(),E({onMessage:h.event,send:O=>g.postMessage(O.buffer)})};process.parentPort.on("message",m=>r(m.ports))});if(l.type===2)return new Promise((E,i)=>{let r=null;const m=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),g=108e5,h=3e5,O=new C.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),g),$=new C.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),h);process.on("message",(Y,G)=>{if(Y&&Y.type==="VSCODE_EXTHOST_IPC_SOCKET"){G.setNoDelay(!0);const M=T.VSBuffer.wrap(Buffer.from(Y.initialDataChunk,"base64"));let B;if(Y.skipWebSocketFrames)B=new k.NodeSocket(G,"extHost-socket");else{const U=T.VSBuffer.wrap(Buffer.from(Y.inflateBytes,"base64"));B=new k.WebSocketNodeSocket(new k.NodeSocket(G,"extHost-socket"),Y.permessageDeflate,U,!1)}r?(O.cancel(),$.cancel(),r.beginAcceptReconnection(B,M),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(m),r=new P.PersistentProtocol({socket:B,initialChunk:M}),r.sendResume(),r.onDidDispose(()=>b("renderer disconnected")),E(r),r.onSocketClose(()=>{O.schedule()}))}if(Y&&Y.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if($.isScheduled())return;O.isScheduled()&&$.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const E=l.pipeName;return new Promise((i,r)=>{const m=c.createConnection(E,()=>{m.removeListener("error",r);const g=new P.PersistentProtocol({socket:new k.NodeSocket(m,"extHost-renderer")});g.sendResume(),i(g)});m.once("error",r),m.on("close",()=>{b("renderer closed the socket")})})}}async function o(){const l=await t();return new class{constructor(){this.a=new P.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,l.onMessage(E=>{(0,p.isMessageOfType)(E,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(E)})}send(E){this.b||l.send(E)}async drain(){if(l.drain)return l.drain()}}}function s(l){return new Promise(E=>{const i=l.onMessage(r=>{i.dispose();const m=JSON.parse(r.toString()),g=m.commit,h=y.default.commit;if(g&&h&&g!==h&&v(55),m.parentPid){let O=0;setInterval(function(){try{process.kill(m.parentPid,0),O=0}catch(x){x&&x.code==="EPERM"?(O++,O>=3&&b(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):b(`parent process ${m.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let $;try{$=globalThis._VSCODE_NODE_MODULES["native-watchdog"],$.start(m.parentPid)}catch(x){(0,R.onUnexpectedError)(x)}}l.send((0,p.createMessageOfType)(0)),E({protocol:l,initData:m})});l.send((0,p.createMessageOfType)(1))})}async function a(){const l=[];process.on("unhandledRejection",(O,$)=>{l.push($),setTimeout(()=>{const x=l.indexOf($);x>=0&&$.catch(Y=>{l.splice(x,1),(0,R.isCancellationError)(Y)||(console.warn(`rejected promise not handled within 1 second: ${Y}`),Y&&Y.stack&&console.warn(`stack trace: ${Y.stack}`),O&&(0,R.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const $=l.indexOf(O);$>=0&&l.splice($,1)}),process.on("uncaughtException",function(O){(0,R.isSigPipeError)(O)||(0,R.onUnexpectedError)(O)}),u.mark("code/extHost/willConnectToRenderer");const E=await o();u.mark("code/extHost/didConnectToRenderer");const i=await s(E);u.mark("code/extHost/didWaitForInitData");const{initData:r}=i;D(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,w.boolean)(f.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit($){v($)}exists($){return S.Promises.exists($)}realpath($){return(0,I.realpath)($)}};let g=null;r.remote.authority&&f.transformURIs&&(g=(0,n.createURITransformer)(r.remote.authority));const h=new L.ExtensionHostMain(i.protocol,r,m,g);b=O=>h.terminate(O)}a().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3a168b2d1ec767eea02b46d6ed38c755805b43a7/core/vs/workbench/api/node/extensionHostProcess.js.map
